<?php
ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.settings.inc');
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.ccurl.inc');

if($argv[1]=="--install"){install();exit;}
if($argv[1]=="--uninstall"){uninstall();exit;}
if($argv[1]=="--connect"){connect();exit;}
if($argv[1]=="--disconnect"){disconnect();exit;}
if($argv[1]=="--monit"){install_monit();exit;}
function install(){
	
	
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CicapEnabled", 1);
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableeCapClamav", 0);
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	build_progress_install("{install_service} 1/5",10);
	install_cicap();
	
	build_progress_install("{install_service} 2/5",15);
	cicap_daemon_tail();
	build_progress_install("{install_service} 3/5",20);
	cicap_access_tail();
	build_progress_install("{install_service} 4/5",25);

    system("$php /usr/share/artica-postfix/exec.clamd.php --install");

	clamav_daemon();
	build_progress_install("{install_service} 5/5",30);
	clamav_freshclam();
	install_monit();
	
	build_progress_install("{configuring} 1/2",40);
	$q=new lib_sqlite("/home/artica/SQLITE/proxy.db");
	
	$q->QUERY_SQL("UPDATE c_icap_services SET enabled=1,zOrder=1 WHERE ID=1");
	$q->QUERY_SQL("UPDATE c_icap_services SET enabled=1,zOrder=2 WHERE ID=2");
	
	build_progress_install("{restart_service} 1/6",45);
	system("/etc/init.d/c-icap restart");
	build_progress_install("{restart_service} 2/6",50);
	system("/etc/init.d/c-icap-watchdog restart");
	build_progress_install("{restart_service} 3/6",55);
	system("/etc/init.d/c-icap-access restart");
	build_progress_install("{restart_service} 4/6",60);
	system("/etc/init.d/clamav-daemon restart");
	build_progress_install("{restart_service} 5/6",65);
	system("/etc/init.d/clamav-freshclam restart");
	build_progress_install("{restart_service} 6/6",65);
	system("/etc/init.d/monit restart");
	build_progress_install("{configuring} 2/2",70);
	system("$php /usr/share/artica-postfix/exec.squid.global.access.php");
	build_progress_install("{done}",100);
	cluster_mode();
}

function uninstall_monit(){
	$RELOAD=false;
	if(is_file("/etc/monit/conf.d/APP_CICAP.monitrc")){
		@unlink("/etc/monit/conf.d/APP_CICAP.monitrc");
		$RELOAD=true;
	}
	
	if(is_file("/etc/monit/conf.d/APP_CLAMAV.monitrc")){
		@unlink("/etc/monit/conf.d/APP_CLAMAV.monitrc");
		$RELOAD=true;
	}
	
	if($RELOAD){shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload");}
}

function install_monit(){
	
	
	@unlink("/etc/monit/conf.d/APP_C_ICAP.monitrc");
	$f[]="check process APP_C_ICAP with pidfile /var/run/c-icap/c-icap.pid";
	$f[]="\tstart program = \"/etc/init.d/c-icap start\"";
	$f[]="\tstop program = \"/etc/init.d/c-icap stop\"";
    $f[]="\trestart program = \"/etc/init.d/c-icap restart\"";
	$f[]="\tif 5 restarts within 5 cycles then timeout";
    $f[]="\tif failed host 127.0.0.1 port 1345 then restart";
	$f[]="";
	@file_put_contents("/etc/monit/conf.d/APP_CICAP.monitrc", @implode("\n", $f));
	
	$f=array();
	$f[]="check process APP_CLAMAV";
	$f[]="with pidfile /var/run/clamav/clamd.pid";
	$f[]="start program = \"/etc/init.d/clamav-daemon start --monit\"";
	$f[]="stop program =  \"/etc/init.d/clamav-daemon stop --monit\"";
	$f[]="if 5 restarts within 5 cycles then timeout";
	$f[]="if failed unixsocket /var/run/clamav/clamav.sock then restart";
	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring Clamd service...\n";}
	@file_put_contents("/etc/monit/conf.d/APP_CLAMAV.monitrc", @implode("\n", $f));
	
	
	
	shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload");
}

function connect(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	build_progress_install("{configuring} 1/2",40);
	$q=new lib_sqlite("/home/artica/SQLITE/proxy.db");
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CicapClusterConnect", 1);
	
	$q->QUERY_SQL("UPDATE c_icap_services SET enabled=1,zOrder=1 WHERE ID=1");
	if(!$q->ok){
		echo $q->mysql_error;
		build_progress_install("{failed2}",110);
		return;
	}
	
	$ligneSQL=$q->mysqli_fetch_array("SELECT `enabled` FROM c_icap_services WHERE ID=1");
	if($ligneSQL["enabled"]==0){
		echo "Enabled == 0 for ID = 1 ???\n";
		build_progress_install("{failed2}",110);
		return;
	}
	echo "Enabled == 1 for ID = 1 [OK]\n";
	
	$q->QUERY_SQL("UPDATE c_icap_services SET enabled=1,zOrder=2 WHERE ID=2");
	build_progress_install("{configuring} 2/2",80);
	system("$php /usr/share/artica-postfix/exec.squid.global.access.php");
	build_progress_install("{done}",100);
	cluster_mode();
}

function disconnect(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	build_progress_install("{configuring} 1/2",40);
	$q=new lib_sqlite("/home/artica/SQLITE/proxy.db");
	
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CicapClusterConnect", 0);
	$q->QUERY_SQL("UPDATE c_icap_services SET enabled=0 WHERE ID=1");
	if(!$q->ok){
		echo $q->mysql_error;
		build_progress_install("{failed2}",110);
		return;
	}
	
	$ligneSQL=mysqli_fetch_array($q->QUERY_SQL("SELECT `enabled` FROM c_icap_services WHERE ID=1"));
	if($ligneSQL["enabled"]==1){
		echo "Enabled == 0 for ID = 1 ???\n";
		build_progress_install("{failed2}",110);
		return;
	}
	echo "Enabled == 0 for ID = 1 [OK]\n";
	
	$q->QUERY_SQL("UPDATE c_icap_services SET enabled=0 WHERE ID=2");
	build_progress_install("{configuring} 2/2",80);
	system("$php /usr/share/artica-postfix/exec.squid.global.access.php");
	build_progress_install("{done}",100);	
	cluster_mode();
	
}





function uninstall(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	build_progress_install("{configuring} 1/2",5);
	$q=new lib_sqlite("/home/artica/SQLITE/proxy.db");
	
	$q->QUERY_SQL("UPDATE c_icap_services SET enabled=0,zOrder=1 WHERE ID=1");
	$q->QUERY_SQL("UPDATE c_icap_services SET enabled=0,zOrder=2 WHERE ID=2");
	
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CicapEnabled", 0);
	
	build_progress_install("{remove_service} 1/5",10);
	remove_service("/etc/init.d/c-icap");
	uninstall_monit();
	build_progress_install("{remove_service} 2/5",20);
	remove_service("/etc/init.d/c-icap-watchdog");
	build_progress_install("{remove_service} 3/5",30);
	remove_service("/etc/init.d/c-icap-access");
	build_progress_install("{remove_service} 4/5",40);
	remove_service("/etc/init.d/clamav-daemon");
	build_progress_install("{remove_service} 5/5",50);
	remove_service("/etc/init.d/clamav-freshclam");
	
	build_progress_install("{configuring} 2/2",70);
	system("$php /usr/share/artica-postfix/exec.squid.php --build --force");
	build_progress_install("{done}",100);
	cluster_mode();
}

function build_progress_install($text,$pourc){
	$filename="/usr/share/artica-postfix/ressources/logs/web/cicap.install.progress";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	echo "[$pourc]: $text\n";
	@file_put_contents($filename, serialize($array));
	@chmod($filename,0777);

}


function remove_service($INITD_PATH){
	if(!is_file($INITD_PATH)){return;}
	system("$INITD_PATH stop");
	if(is_file('/usr/sbin/update-rc.d')){shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");}
	if(is_file('/sbin/chkconfig')){shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");}
	if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}

function install_cicap(){
	$unix=new unix();
	$binpath=$unix->find_program("c-icap");
	$INITD_PATH="/etc/init.d/c-icap";

	if(!is_file($binpath)){
		if(is_file($INITD_PATH)){
			if(is_file('/usr/sbin/update-rc.d')){
				shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");
			}
				
			if(is_file('/sbin/chkconfig')){
				shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
				shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." off >/dev/null 2>&1");
			}
			@unlink($INITD_PATH);
		}

	}


	$php=$unix->LOCATE_PHP5_BIN();

	$INITD_PATH="/etc/init.d/c-icap";
	$php5script="exec.c-icap.php";
	$daemonbinLog="C-ICAP For Artica";
	$daemon_path=$unix->find_program("nginx");


	$f[]="#!/bin/sh";
	$f[]="### BEGIN INIT INFO";
	$f[]="# Provides:         artica-cicap";
	$f[]="# Required-Start:    \$local_fs \$syslog";
	$f[]="# Required-Stop:     \$local_fs \$syslog";
	$f[]="# Should-Start:";
	$f[]="# Should-Stop:";
	$f[]="# Default-Start:     3 4 5";
	$f[]="# Default-Stop:      0 1 6";
	$f[]="# Short-Description: $daemonbinLog";
	$f[]="# chkconfig: - 80 75";
	$f[]="# description: $daemonbinLog";
	$f[]="### END INIT INFO";

	$f[]="case \"\$1\" in";
	$f[]=" start)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  stop)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" restart)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
	$f[]="    ;;";
	$f[]=" reload)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --reload \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" reconfigure)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --build \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  *)";
	$f[]="    echo \"Usage: \$0 {start|stop|restart|reconfigure|reload} (+ '--verbose' for more infos)\"";
	$f[]="    exit 1";
	$f[]="    ;;";
	$f[]="esac";
	$f[]="exit 0\n";


	echo "$daemonbinLog: [INFO] Writing $INITD_PATH with new config\n";
	@unlink($INITD_PATH);
	@file_put_contents($INITD_PATH, @implode("\n", $f));
	@chmod($INITD_PATH,0755);

	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
	}

	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
		shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
	}

}


function clamav_daemon(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	$INITD_PATH="/etc/init.d/clamav-daemon";
	$php5script="exec.clamd.php";
	$daemonbinLog="Clam AntiVirus userspace daemon";



	$f[]="#!/bin/sh";
	$f[]="### BEGIN INIT INFO";
	$f[]="# Provides:        clamav-daemon";
	$f[]="# Required-Start:    \$local_fs \$syslog";
	$f[]="# Required-Stop:     \$local_fs \$syslog";
	$f[]="# Should-Start:";
	$f[]="# Should-Stop:";
	$f[]="# Default-Start:     3 4 5";
	$f[]="# Default-Stop:      0 1 6";
	$f[]="# Short-Description: $daemonbinLog";
	$f[]="# chkconfig: - 80 75";
	$f[]="# description: $daemonbinLog";
	$f[]="### END INIT INFO";

	$f[]="case \"\$1\" in";
	$f[]=" start)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  stop)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" restart)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" reconfigure)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --build \$2 \$3";
	$f[]="    ;;";
	$f[]=" build)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --build \$2 \$3";
	$f[]="    ;;";
	$f[]=" force-reload)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --force-reload \$2 \$3";
	$f[]="    ;;";
	$f[]=" reload-database)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --reload-database \$2 \$3";
	$f[]="    ;;";
	$f[]=" reload-log)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --reload-log \$2 \$3";
	$f[]="    ;;";

	$f[]="";
	$f[]="  *)";
	$f[]="    echo \"Usage: $INITD_PATH {start|stop|restart|force-reload|reload-log|reload-database|status} (+ '--verbose' for more infos)\"";
	$f[]="    exit 1";
	$f[]="    ;;";
	$f[]="esac";
	$f[]="exit 0\n";


	echo "$daemonbinLog: [INFO] Writing $INITD_PATH with new config\n";
	@unlink($INITD_PATH);
	@file_put_contents($INITD_PATH, @implode("\n", $f));
	@chmod($INITD_PATH,0755);

	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
	}

	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
		shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
	}

}
function cicap_daemon_tail(){

	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	$INITD_PATH="/etc/init.d/c-icap-watchdog";
	$php5script="exec.init-tail-icap-server.php";
	$daemonbinLog="C-ICAP Tail daemon";
	if(!is_file("/usr/share/artica-postfix/$php5script")){return;}

	$f[]="#!/bin/sh";
	$f[]="### BEGIN INIT INFO";
	$f[]="# Provides:         ".basename($INITD_PATH);
	$f[]="# Required-Start:    \$local_fs \$syslog \$squid";
	$f[]="# Required-Stop:     \$local_fs \$syslog \$squid";
	$f[]="# Should-Start:";
	$f[]="# Should-Stop:";
	$f[]="# Default-Start:     3 4 5";
	$f[]="# Default-Stop:      0 1 6";
	$f[]="# Short-Description: $daemonbinLog";
	$f[]="# chkconfig: - 80 75";
	$f[]="# description: $daemonbinLog";
	$f[]="### END INIT INFO";

	$f[]="case \"\$1\" in";
	$f[]=" start)";
	$f[]=" bash -c \"ulimit -n 65535 -c unlimited\"";
	$f[]=" bash -c \"ulimit -n 65535 -c unlimited\"";
	$f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  stop)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" restart)";
	$f[]=" bash -c \"ulimit -n 65535 -c unlimited\"";
	$f[]=" bash -c \"ulimit -n 65535 -c unlimited\"";
	$f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" reconfigure)";
	$f[]=" bash -c \"ulimit -n 65535 -c unlimited\"";
	$f[]=" bash -c \"ulimit -n 65535 -c unlimited\"";
	$f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" reload)";
	$f[]=" bash -c \"ulimit -n 65535 -c unlimited\"";
	$f[]=" bash -c \"ulimit -n 65535 -c unlimited\"";
	$f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  *)";
	$f[]="    echo \"Usage: \$0 {start|stop|restart|reconfigure|reload} (+ '--verbose' for more infos)\"";
	$f[]="    exit 1";
	$f[]="    ;;";
	$f[]="esac";
	$f[]="exit 0\n";


	echo "$daemonbinLog: [INFO] Writing $INITD_PATH with new config\n";
	@unlink($INITD_PATH);
	@file_put_contents($INITD_PATH, @implode("\n", $f));
	@chmod($INITD_PATH,0755);

	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
	}

	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
		shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
	}
}
function cicap_access_tail(){

	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	$INITD_PATH="/etc/init.d/c-icap-access";
	$php5script="exec.init-tail-icap-access.php";
	$daemonbinLog="C-ICAP Tail access";
	if(!is_file("/usr/share/artica-postfix/$php5script")){return;}

	$f[]="#!/bin/sh";
	$f[]="### BEGIN INIT INFO";
	$f[]="# Provides:         ".basename($INITD_PATH);
	$f[]="# Required-Start:    \$local_fs \$syslog \$squid";
	$f[]="# Required-Stop:     \$local_fs \$syslog \$squid";
	$f[]="# Should-Start:";
	$f[]="# Should-Stop:";
	$f[]="# Default-Start:     3 4 5";
	$f[]="# Default-Stop:      0 1 6";
	$f[]="# Short-Description: $daemonbinLog";
	$f[]="# chkconfig: - 80 75";
	$f[]="# description: $daemonbinLog";
	$f[]="### END INIT INFO";

	$f[]="case \"\$1\" in";
	$f[]=" start)";
	$f[]=" bash -c \"ulimit -n 65535 -c unlimited\"";
	$f[]=" bash -c \"ulimit -n 65535 -c unlimited\"";
	$f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  stop)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" restart)";
	$f[]=" bash -c \"ulimit -n 65535 -c unlimited\"";
	$f[]=" bash -c \"ulimit -n 65535 -c unlimited\"";
	$f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" reconfigure)";
	$f[]=" bash -c \"ulimit -n 65535 -c unlimited\"";
	$f[]=" bash -c \"ulimit -n 65535 -c unlimited\"";
	$f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" reload)";
	$f[]=" bash -c \"ulimit -n 65535 -c unlimited\"";
	$f[]=" bash -c \"ulimit -n 65535 -c unlimited\"";
	$f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  *)";
	$f[]="    echo \"Usage: \$0 {start|stop|restart|reconfigure|reload} (+ '--verbose' for more infos)\"";
	$f[]="    exit 1";
	$f[]="    ;;";
	$f[]="esac";
	$f[]="exit 0\n";


	echo "$daemonbinLog: [INFO] Writing $INITD_PATH with new config\n";
	@unlink($INITD_PATH);
	@file_put_contents($INITD_PATH, @implode("\n", $f));
	@chmod($INITD_PATH,0755);

	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
	}

	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
		shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
	}
}

function clamav_freshclam(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	$INITD_PATH="/etc/init.d/clamav-freshclam";
	$php5script="exec.freshclam.php";
	$daemonbinLog="Clam AntiVirus userspace daemon";
	$Provides="clamav-freshclam";
	$daemonbinLog="Clam AntiVirus virus database updater";



	$f[]="#!/bin/sh";
	$f[]="### BEGIN INIT INFO";
	$f[]="# Provides:        $Provides";
	$f[]="# Required-Start:    \$local_fs \$syslog";
	$f[]="# Required-Stop:     \$local_fs \$syslog";
	$f[]="# Should-Start:";
	$f[]="# Should-Stop:";
	$f[]="# Default-Start:     3 4 5";
	$f[]="# Default-Stop:      0 1 6";
	$f[]="# Short-Description: $daemonbinLog";
	$f[]="# chkconfig: - 80 75";
	$f[]="# description: $daemonbinLog";
	$f[]="### END INIT INFO";

	$f[]="case \"\$1\" in";
	$f[]=" start)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  stop)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
	$f[]="    ;;";
	$f[]="  skip)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
	$f[]="    ;;";
	$f[]="  status)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" restart)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" reconfigure)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --build \$2 \$3";
	$f[]="    ;;";
	$f[]=" build)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --build \$2 \$3";
	$f[]="    ;;";
	$f[]=" force-reload)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --force-reload \$2 \$3";
	$f[]="    ;;";
	$f[]=" reload-database)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --reload-database \$2 \$3";
	$f[]="    ;;";
	$f[]=" reload-log)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --reload-log \$2 \$3";
	$f[]="    ;;";

	$f[]="";
	$f[]="  *)";
	$f[]="    echo \"Usage: $INITD_PATH {no-daemon|start|stop|restart|force-reload|reload-log|skip|status} (+ '--verbose' for more infos)\"";
	$f[]="    exit 1";
	$f[]="    ;;";
	$f[]="esac";
	$f[]="exit 0\n";


	echo "$daemonbinLog: [INFO] Writing $INITD_PATH with new config\n";
	@unlink($INITD_PATH);
	@file_put_contents($INITD_PATH, @implode("\n", $f));
	@chmod($INITD_PATH,0755);

	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
	}

	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
		shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
	}


}