<?php
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;$GLOBALS["OUTPUT"]=true;$GLOBALS["debug"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
$GLOBALS["FORCE"]=false;
$GLOBALS["RECONFIGURE"]=false;
$GLOBALS["SWAPSTATE"]=false;
$GLOBALS["NOSQUIDOUTPUT"]=true;
$GLOBALS["WATCHDOG"]=false;
$GLOBALS["MONIT"]=false;
$GLOBALS["UFDBTAIL"]=false;
$GLOBALS["TITLENAME"]="DNS Load-balancing Daemon";
$GLOBALS["AFTER-FATAL-ERROR"]=false;
$GLOBALS["BYSCHEDULE"]=false;
$GLOBALS["HUMAN"]=false;
$GLOBALS["WIZARD"]=false;
$GLOBALS["OUTPUT"]=true;

include_once("/usr/share/artica-postfix/ressources/class.resolv.conf.inc");
include_once("/usr/share/artica-postfix/ressources/class.sqlite.inc");
include_once(dirname(__FILE__).'/framework/class.unix.inc');
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');


if($argv[1]=="--install"){install();exit();}
if($argv[1]=="--uninstall"){uninstall();exit();}
if($argv[1]=="--build"){build();exit();}
if($argv[1]=="--restart"){restart();exit();}
if($argv[1]=="--start"){start();exit();}
if($argv[1]=="--stop"){stop();exit();}


function PID_NUM(){

    $unix=new unix();
    return $unix->PIDOF_PATTERN("dnsdist -C \/etc\/");
}
function stop($aspid=false){
    $unix=new unix();
    if(!$aspid){
        $pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
        $pid=$unix->get_pid_from_file($pidfile);
        if($unix->process_exists($pid,basename(__FILE__))){
            $time=$unix->PROCCESS_TIME_MIN($pid);
            if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service Already Artica task running PID $pid since {$time}mn\n";}
            return;
        }
        @file_put_contents($pidfile, getmypid());
    }

    $pid=PID_NUM();


    if(!$unix->process_exists($pid)){
        if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service already stopped...\n";}
        return;
    }
    $pid=PID_NUM();

    if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service Shutdown pid $pid...\n";}
    $unix->KILL_PROCESS($pid,9);
    for($i=0;$i<10;$i++){
        $pid=PID_NUM();
        if(!$unix->process_exists($pid)){break;}
        $unix->KILL_PROCESS($pid,9);
        if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service waiting pid:$pid $i/5...\n";}
        sleep(1);
    }

    $pid=PID_NUM();
    if(!$unix->process_exists($pid)){
        if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service success...\n";}
        return;
    }

    if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service shutdown - force - pid $pid...\n";}
    $unix->KILL_PROCESS($pid,9);
    for($i=0;$i<5;$i++){
        $pid=PID_NUM();
        if(!$unix->process_exists($pid)){break;}
        if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service waiting pid:$pid $i/5...\n";}
        $unix->KILL_PROCESS($pid,9);
        sleep(1);
    }

    if($unix->process_exists($pid)){
        if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service failed...\n";}
        return;
    }

}

function start($aspid=false){
    $unix=new unix();
    $Masterbin=$unix->find_program("dnsdist");

    if(!is_file($Masterbin)){
        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]}, not installed\n";}
        return;
    }

    if(!$aspid){
        $pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
        $pid=$unix->get_pid_from_file($pidfile);
        if($unix->process_exists($pid,basename(__FILE__))){
            $time=$unix->PROCCESS_TIME_MIN($pid);
            if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Already Artica task running PID $pid since {$time}mn\n";}
            return true;
        }
        @file_put_contents($pidfile, getmypid());
    }

    $pid=PID_NUM();




    if($unix->process_exists($pid)){
        $timepid=$unix->PROCCESS_TIME_MIN($pid);
        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Service already started $pid since {$timepid}Mn...\n";}
        return true;
    }

    $nohup=$unix->find_program("nohup");
    $cmd="$nohup $Masterbin -C /etc/dnsdist.conf -v --supervised --disable-syslog >/var/log/dnsdist-service.log 2>&1 &";
    if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service\n";}

    shell_exec($cmd);

     for($i=1;$i<5;$i++){
        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} waiting $i/5\n";}
        sleep(1);
        $pid=PID_NUM();
        if($unix->process_exists($pid)){break;}
    }

    $pid=PID_NUM();
    if($unix->process_exists($pid)) {
        if ($GLOBALS["OUTPUT"]) {
            echo "Starting......: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} Success PID $pid\n";
        }
        $ff=explode("\n",@file_get_contents("/var/log/dnsdist-service.log"));
        foreach ($ff as $line){
            $line=trim($line);
            if($line==null){continue;}
            if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: $line\n";}
        }
        return true;
    }

    if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Failed\n";}
    if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} $cmd\n";}
    $ff=explode("\n",@file_get_contents("/var/log/dnsdist-service.log"));
    foreach ($ff as $line){
        $line=trim($line);
        if($line==null){continue;}

        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: $line\n";}
    }


    return false;

}
function build_progress($text,$pourc){
    $GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/web/dnsdist.install";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($GLOBALS["CACHEFILE"], serialize($array));
    @chmod($GLOBALS["CACHEFILE"],0755);

}
function build_progress_restart($text,$pourc){
    $GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/web/dnsdist.restart";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($GLOBALS["CACHEFILE"], serialize($array));
    @chmod($GLOBALS["CACHEFILE"],0755);

}
function restart(){

    build_progress_restart("{stopping} {APP_DNSDIST}",10);
    stop(true);
    build_progress_restart("{configuring} {APP_DNSDIST}",50);
    build();
    build_progress_restart("{starting} {APP_DNSDIST}",70);
    if(!start(true)){
        build_progress_restart("{starting} {APP_DNSDIST} {failed}",110);
        return;
    }
    build_progress_restart("{starting} {APP_DNSDIST} {success}",100);
}


function build(){
    $GLOBALS["DSTDOMAINS"]=array();
    $unix=new unix();
    $CPUNUMBER=$unix->CPU_NUMBER();
    $interfaces=array();
    $PowerDNSListenAddr=explode("\n",trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PowerDNSListenAddr")));
    $ListenOnlyLoopBack=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ListenOnlyLoopBack"));
    $EnableGoogleSafeSearch= intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableGoogleSafeSearch"));
    $EnableDuckduckgoSafeSearch = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableDuckduckgoSafeSearch"));
    $EnableQwantSafeSearch = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableQwantSafeSearch"));
    $EnableBingSafeSearch = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableBingSafeSearch"));
    $EnableYoutubeSafeSearch = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableYoutubeSafeSearch"));
    $EnbaleYoutubeModerate = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnbaleYoutubeModerate"));

    if (!$unix->CORP_LICENSE()) {
        $EnableDuckduckgoSafeSearch = 0;
        $EnableQwantSafeSearch = 0;
        $EnableBingSafeSearch = 0;
        $EnableYoutubeSafeSearch = 0;
        $EnbaleYoutubeModerate = 0;
        $EnableGoogleSafeSearch = 0;
    }


    if(count($PowerDNSListenAddr)>0){
        foreach ($PowerDNSListenAddr as $interface){
            $interface=trim($interface);
            if($interface==null){continue;}
             $IpAddr = $unix->InterfaceToIP($interface);
            $f[] = "-- Listen on interface $interface ($IpAddr)";
            if($IpAddr==null){continue;}
            $interfaces[$interface]=$IpAddr;
        }
    }



    $OutboundInterface=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundOutGoingInterface"));

    for ($i = 0; $i < $CPUNUMBER; $i++) {
        $f[] = "addLocal('127.0.0.1',{reusePort=true,cpus={{$i}}, numberOfShards=16 })";
    }

    if($ListenOnlyLoopBack==0) {
        if (count($interfaces) == 0) {
            for ($i = 0; $i < $CPUNUMBER; $i++) {
                $f[] = "addLocal('0.0.0.0',{reusePort=true,cpus={{$i}}, numberOfShards=16 })";
            }
        } else {
            foreach ($interfaces as $inet => $Ipaddr) {
                for ($i = 0; $i < $CPUNUMBER; $i++) {
                    $f[] = "addLocal('$Ipaddr',{reusePort=true, cpus={{$i}}, numberOfShards=16 })";
                }

            }
        }

    }
    $f[] = "-- ACLS BEGIN -----------------------------------------";
    $f[]=BUILD_ACLS();
    $f[] = "-- ACLS END -----------------------------------------";

    $q = new lib_sqlite("/home/artica/SQLITE/dns.db");
    $ipclass=new IP();
    $Rules=$q->COUNT_ROWS("pdns_restricts");
    $f[] = "-- $Rules Restrictions";
    if($Rules==0){
        $ACLREST[] = "'192.168.0.0/16'";
        $ACLREST[] = "'10.0.0.0/8'";
        $ACLREST[] = "'172.16.0.0/12'";
        $ACLREST[] = "'127.0.0.0/8'";
    }else {
        $sql = "SELECT *  FROM pdns_restricts";
        $results = $q->QUERY_SQL($sql);
        $ACLREST[] = "'127.0.0.0/8'";
        foreach ($results as $index => $ligne) {
            $address=trim($ligne["address"]);
            if($address==null){continue;}
            if (!$ipclass->isIPAddressOrRange($ligne["address"])) {
                continue;
            }
            $ACLREST[] = "'{$ligne["address"]}'";
        }
    }

    foreach ($ACLREST as $mask){
        $mask=str_replace("'","",$mask);
        $ActionsNets[]="addAction(\"$mask\", PoolAction(\"defaults\"))";

    }

    $f[] = "setACL({".@implode(",",$ACLREST)."})";
    $resolv=new resolv_conf();
    @file_put_contents("/etc/resolv.conf",$resolv->build());

if($OutboundInterface<>null){
    $OutboundInterface_text=", source=\"$OutboundInterface\"";
}



$f[]="webserver(\"127.0.0.1:5600\", \"\", \"\")";

    if($resolv->MainArray["DNS1"]<>null){
        if(preg_match("#^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+$#",$resolv->MainArray["DNS1"])){
            $f[]="newServer({address=\"{$resolv->MainArray["DNS1"]}\", useClientSubnet=true, name=\"dns1\"{$OutboundInterface_text}, pool=\"defaults\",qps=10}) ";
        }

    }
    if($resolv->MainArray["DNS2"]<>null){
        if(preg_match("#^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+$#",$resolv->MainArray["DNS2"])){
            $f[]="newServer({address=\"{$resolv->MainArray["DNS2"]}\", useClientSubnet=true, name=\"dns2\"{$OutboundInterface_text}, pool=\"defaults\", qps=10}) ";
        }

    }
    if($resolv->MainArray["DNS3"]<>null){
        if(preg_match("#^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+$#",$resolv->MainArray["DNS3"])){
            $f[]="newServer({address=\"{$resolv->MainArray["DNS3"]}\", useClientSubnet=true, name=\"dns3\"{$OutboundInterface_text}, pool=\"defaults\" qps=10}) ";
        }
    }
    $f[]="local dbr = dynBlockRulesGroup()";
    $f[]="dbr:setQueryRate(30, 10, \"Exceeded query rate\", 3000)";
    $f[]="dbr:setRCodeRate(DNSRCode.NXDOMAIN, 20, 10, \"Exceeded NXD rate\", 3000)";
    $f[]="dbr:setRCodeRate(DNSRCode.SERVFAIL, 20, 10, \"Exceeded ServFail rate\", 300)";
    $f[]="dbr:setQTypeRate(DNSQType.ANY, 5, 10, \"Exceeded ANY rate\", 300)";
    $f[]="dbr:setResponseByteRate(10000, 10, \"Exceeded resp BW rate\", 300)";


    if ($EnableGoogleSafeSearch == 1) {
            $f[]="addAction('google.com', SpoofAction('216.239.38.12'))";
    }

    if ($EnableQwantSafeSearch == 1) {
        $f[]="addAction('api.qwant.com',SpoofAction('194.187.168.114'))";
    }

    if ($EnableDuckduckgoSafeSearch == 1) {
        $f[]="addAction('duckduckgo.com',SpoofAction('54.229.105.151'))";
    }

    if ($EnableBingSafeSearch == 1) {
        $f[]="addAction('www.bing.com', SpoofAction('204.79.197.220'))";
        $f[]="addAction('explicit.bing.net',SpoofAction('127.0.0.1'))";
    }


    $ASYOUTUBE = false;
    if ($EnbaleYoutubeModerate == 1) {
        $ASYOUTUBE = true;
    }
    if ($EnableYoutubeSafeSearch == 1) {
        $ASYOUTUBE = true;
    }


    if ($ASYOUTUBE) {
        if ($EnableYoutubeSafeSearch == 1) {
            $YoutubeCNAME = "restrict.youtube.com";
        }
        if ($EnbaleYoutubeModerate == 1) {
            $YoutubeCNAME = "restrictmoderate.youtube.com";
        }
        $fyz[] = "www.youtube.com";
        $fyz[] = "m.youtube.com";
        $fyz[] = "youtubei.googleapis.com";
        $fyz[] = "youtube.googleapis.com";
        $fyz[] = "www.youtube-nocookie.com";

        foreach ($fyz as $youtube) {
            $f[]="addAction('$youtube',SpoofCNAMEAction('$YoutubeCNAME'))";
       }
        $f[] = "";
    }

    $sql="SELECT * FROM pdns_fwzones";
    $q=new lib_sqlite("/home/artica/SQLITE/dns.db");

    $results=$q->QUERY_SQL($sql);
    foreach ($results as $index=>$ligne){
        $hostname=$ligne["hostname"];
        if(isset($GLOBALS["DSTDOMAINS"][$hostname])){continue;}
        $port=$ligne["port"];
        $zone=$ligne["zone"];
        $id=$ligne["ID"];
        $GLOBALS["DSTDOMAINS"][$hostname]=true;
        $zone=str_replace("%20","",$zone);
        if($zone=="*"){
            $f[]="newServer({address=\"{$hostname}:$port\", useClientSubnet=true, name=\"fwdns$id\"{$OutboundInterface_text}, pool=\"defaults\", qps=10}) ";
            continue;
        }

        $f[]="newServer({address=\"{$hostname}:$port\", useClientSubnet=true, name=\"fwdns$id\"{$OutboundInterface_text}, pool=\"zone$id\" ,qps=10}) ";
        $f[]="addAction({'$zone', '$zone.'}, PoolAction(\"zone$id\"));";


    }


    $DNSDistSetServerPolicy=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DNSDistSetServerPolicy"));
    if($DNSDistSetServerPolicy==null){$DNSDistSetServerPolicy="leastOutstanding";}


    $f[]="setServerPolicy($DNSDistSetServerPolicy)";
    $tt=array();
    if($resolv->MainArray["DOMAINS1"]<>null){$tt[]=$resolv->MainArray["DOMAINS1"];}
    if($resolv->MainArray["DOMAINS2"]<>null){$tt[]=$resolv->MainArray["DOMAINS2"];}
    if($resolv->MainArray["DOMAINS3"]<>null){$tt[]=$resolv->MainArray["DOMAINS3"];}

    foreach ($tt as $domain){
        if(isset($GLOBALS["DSTDOMAINS"][$domain])){continue;}
        $f[]="addAction({'$domain', '$domain.'}, PoolAction(\"defaults\"));";
    }

    $UnBoundCacheSize=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnBoundCacheSize"));
    $UnBoundCacheMinTTL=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnBoundCacheMinTTL"));
    $UnBoundCacheMAXTTL=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnBoundCacheMAXTTL"));
    $UnBoundCacheNEGTTL=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnBoundCacheNEGTTL"));
    $EnableUnboundLogQueries=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableUnboundLogQueries"));

    if($UnBoundCacheMinTTL==0){$UnBoundCacheMinTTL=3600;}
    if($UnBoundCacheMAXTTL==0){$UnBoundCacheMAXTTL=172800;}
    if($UnBoundCacheNEGTTL==0){$UnBoundCacheNEGTTL=3600;}

    if($UnBoundCacheMinTTL==-1){$UnBoundCacheMinTTL=0;}
    if($UnBoundCacheMAXTTL==-1){$UnBoundCacheMAXTTL=0;}
    if($UnBoundCacheNEGTTL==-1){$UnBoundCacheNEGTTL=0;}

    $DnsDistCacheItem=$UnBoundCacheSize*1024;
    $DnsDistCacheItem=$DnsDistCacheItem*1024;
    $DnsDistCacheItem=round($DnsDistCacheItem/512);

    $f[]="setECSOverride(true)";
    $f[]="setECSSourcePrefixV4(32)";
    $f[]="setECSSourcePrefixV6(128)";

    if($EnableUnboundLogQueries==1) {
        $f[] = "addAction(AllRule(), LogAction(\"/var/log/dnsdist.log\", false, true, false))";
    }

    $f[]=@implode("\n",$ActionsNets);
    $f[] = "addAction(PoolAvailableRule(\"\"), PoolAction(\"\"))";
    $f[]="addAction(MaxQPSIPRule(5, 32, 48), DelayAction(100))";
    //$f[]="addAction(AllRule(), PoolAction(\"defaults\"));";

    $f[]="pcdefaults = newPacketCache($DnsDistCacheItem, {maxTTL=$UnBoundCacheMAXTTL, minTTL=$UnBoundCacheMinTTL, temporaryFailureTTL=$UnBoundCacheNEGTTL, staleTTL=60, dontAge=false})";
    $f[]="getPool(\"defaults\"):setCache(pcdefaults)";

    @file_put_contents("/etc/dnsdist.conf",@implode("\n",$f));


}

function BUILD_ACLS(){

    $q=new lib_sqlite("/home/artica/SQLITE/acls.db");

    $results=$q->QUERY_SQL("SELECT * FROM dnsdist_rules WHERE enabled=1 ORDER BY zOrder");

    foreach ($results as $index=>$ligne){
        $ID=$ligne["ID"];
        $ruletype=$ligne["ruletype"];
        $rulevalue=trim($ligne["rulevalue"]);
        $rulename=utf8_encode($ligne["rulename"]);
        $SELECTOR=0;
        $f[] = "-- *****************************************************************";
        $f[] = "-- Rule [ $rulename ] Type: $ruletype";
        $fsrc=array();
        if(BUILD_ACLS_SRC($ID)){
            $fsrc[] = @implode("\n",$GLOBALS["BUILD_ACLS_LB_SERVERS"]);
            $fsrc[] = "-- Selector, src IP addresses";
            $fsrc[] = "SRCIP{$ID} = newNMG()";
            $fsrc[] = @implode("\n",$GLOBALS["LB_IP"]);
            $SELECTOR++;
            $fsrc[]="selector{$ID} = AndRule{ selector{$ID}, NetmaskGroupRule(SRCIP{$ID}) }";
        }else{
            $fsrc[] = @implode("\n",$GLOBALS["BUILD_ACLS_LB_SERVERS"]);

        }

        if(BUILD_ACLS_ALL($ID)) {
            $SELECTOR++;
            $fsrc[] = "selector{$ID} = AndRule{ selector{$ID}, makeRule(\"0.0.0.0/0\") }";
        }

        if(BUILD_ACLS_DSTDOMREGEX($ID)){
            $fsrc[] = @implode("\n",$GLOBALS["BUILD_ACLS_LB_SERVERS"]);
            $SELECTOR++;
            $fsrc[] = "selector{$ID} = AndRule{ selector{$ID}, {$GLOBALS["REGEX_DOM"]} }";
        }


        if(BUILD_ACLS_DSTDOM($ID)){
            $fsrc[] = @implode("\n",$GLOBALS["BUILD_ACLS_LB_SERVERS"]);
            $fsrc[] = "DSTDOM{$ID} = newSuffixMatchNode()";
            $fsrc[] = @implode("\n",$GLOBALS["LB_DOM"]);
            $SELECTOR++;
            $fsrc[] = "selector{$ID} = AndRule{ selector{$ID}, SuffixMatchNodeRule(DSTDOM{$ID}) }";

        }



        if($ruletype==1){
            $GLOBALS["BUILD_ACLS_LB_SERVERS"]=array();
            $GLOBALS["LB_SERVERS"]=array();
            if(!BUILD_ACLS_LB_SERVERS($ID)){
                $f[] =@implode("\n",$GLOBALS["BUILD_ACLS_LB_SERVERS"]);
                $f[] = "-- Seems not server to balance";
                continue;
            }
            if($SELECTOR==0){
                $f[] = "-- Seems no selector to balance";
                continue;
            }
            $f[] = @implode("\n",$fsrc);
            $f[] = @implode("\n",$GLOBALS["BUILD_ACLS_LB_SERVERS"]);
            $f[] = @implode("\n",$GLOBALS["LB_SERVERS"]);
            $f[] = "addAction(selector{$ID},  PoolAction(\"Pool{$ID}\"))";
            continue;
        }

        if($ruletype==2){
            $f[] = @implode("\n",$fsrc);
            $f[] = "addAction(selector{$ID},  RCodeAction( dnsdist.REFUSED) )";
            continue;
        }
        if($ruletype==3){
            if($rulevalue==null){
                $f[] =@implode("\n",$GLOBALS["BUILD_ACLS_LB_SERVERS"]);
                $f[] = "-- No CNAME defined for the answer";
                continue;
            }
            $f[] = @implode("\n",$fsrc);
            $f[] = "addAction(selector{$ID},  SpoofCNAMEAction('$rulevalue') )";
            continue;
        }
        if($ruletype==4){
            if($rulevalue==null){
                $f[] =@implode("\n",$GLOBALS["BUILD_ACLS_LB_SERVERS"]);
                $f[] = "-- No IP defined for the answer";
                continue;
            }
            $f[] = @implode("\n",$fsrc);
            $f[] = "addAction(selector{$ID},  SpoofAction('$rulevalue') )";
            continue;
        }
        if($ruletype==5){
            $f[] = @implode("\n",$fsrc);
            $f[] = "addAction(selector{$ID},  SkipCacheAction() )";
            continue;
        }




    }

    return @implode("\n",$f);

}

function BUILD_ACLS_SRC($ruleid){
    $q=new lib_sqlite("/home/artica/SQLITE/acls.db");
    $sql="SELECT dnsdist_sqacllinks.gpid,dnsdist_sqacllinks.negation,dnsdist_sqacllinks.zOrder,webfilters_sqgroups.* 
		FROM dnsdist_sqacllinks,webfilters_sqgroups 
		WHERE dnsdist_sqacllinks.gpid=webfilters_sqgroups.ID AND webfilters_sqgroups.GroupType='src'
		AND dnsdist_sqacllinks.aclid=$ruleid
		ORDER BY dnsdist_sqacllinks.zOrder";
    $results=$q->QUERY_SQL($sql);
    $GLOBALS["LB_IP"]=array();
    $GLOBALS["BUILD_ACLS_LB_SERVERS"]=array();
    foreach ($results as $index=>$ligne){
        $gpid=$ligne["gpid"];
        $GroupName=utf8_encode($ligne["GroupName"]);
        $GLOBALS["BUILD_ACLS_LB_SERVERS"][]="-- Group $GroupName ($gpid)";
        $results2=$q->QUERY_SQL("SELECT pattern FROM webfilters_sqitems WHERE enabled=1 AND gpid=$gpid");
        if(count($results2)==0){
            $GLOBALS["BUILD_ACLS_LB_SERVERS"][]="-- no items for this group";
            continue;
        }

        foreach ($results2 as $index2=>$ligne2){
            $pattern=$ligne2["pattern"];
            if(!preg_match("#^([0-9]+)\/([0-9]+)#",$pattern)){
                $pattern=$pattern."/32";
            }


            $GLOBALS["LB_IP"][]="SRCIP{$ruleid}:addMask('$pattern')";

        }

    }

    if(count($GLOBALS["LB_IP"])==0){return false;}
    return true;
}

function BUILD_ACLS_ALL($ruleid){
    $q=new lib_sqlite("/home/artica/SQLITE/acls.db");
    $sql="SELECT dnsdist_sqacllinks.gpid,dnsdist_sqacllinks.negation,dnsdist_sqacllinks.zOrder,webfilters_sqgroups.* 
		FROM dnsdist_sqacllinks,webfilters_sqgroups 
		WHERE dnsdist_sqacllinks.gpid=webfilters_sqgroups.ID AND webfilters_sqgroups.GroupType='all'
		AND dnsdist_sqacllinks.aclid=$ruleid
		ORDER BY dnsdist_sqacllinks.zOrder";
        $results=$q->QUERY_SQL($sql);
        if(count($results)>0){return true;}

        return false;

}

function BUILD_ACLS_DSTDOM($ruleid){

    $q=new lib_sqlite("/home/artica/SQLITE/acls.db");
    $sql="SELECT dnsdist_sqacllinks.gpid,dnsdist_sqacllinks.negation,dnsdist_sqacllinks.zOrder,webfilters_sqgroups.* 
		FROM dnsdist_sqacllinks,webfilters_sqgroups 
		WHERE dnsdist_sqacllinks.gpid=webfilters_sqgroups.ID AND webfilters_sqgroups.GroupType='dstdomain'
		AND dnsdist_sqacllinks.aclid=$ruleid
		ORDER BY dnsdist_sqacllinks.zOrder";
    $results=$q->QUERY_SQL($sql);
    $GLOBALS["LB_DOM"]=array();
    $GLOBALS["BUILD_ACLS_LB_SERVERS"]=array();
    foreach ($results as $index=>$ligne){
        $gpid=$ligne["gpid"];
        $GroupName=utf8_encode($ligne["GroupName"]);
        $GLOBALS["BUILD_ACLS_LB_SERVERS"][]="-- Group $GroupName ($gpid)";
        $results2=$q->QUERY_SQL("SELECT pattern FROM webfilters_sqitems WHERE enabled=1 AND gpid=$gpid");
        if(count($results2)==0){
            $GLOBALS["BUILD_ACLS_LB_SERVERS"][]="-- no items for this group";
            continue;
        }

        foreach ($results2 as $index2=>$ligne2){
            $pattern=$ligne2["pattern"];
            $GLOBALS["DSTDOMAINS"][$pattern]=true;
            $GLOBALS["LB_DOM"][]="DSTDOM{$ruleid}:add(newDNSName(\"{$pattern}\"))";
            $GLOBALS["LB_DOM"][]="DSTDOM{$ruleid}:add(newDNSName(\"{$pattern}.\"))";

        }

    }

    if(count($GLOBALS["LB_DOM"])==0){return false;}
    return true;

}
function BUILD_ACLS_DSTDOMREGEX($ruleid){

    $q=new lib_sqlite("/home/artica/SQLITE/acls.db");
    $sql="SELECT dnsdist_sqacllinks.gpid,dnsdist_sqacllinks.negation,dnsdist_sqacllinks.zOrder,webfilters_sqgroups.* 
		FROM dnsdist_sqacllinks,webfilters_sqgroups 
		WHERE dnsdist_sqacllinks.gpid=webfilters_sqgroups.ID AND webfilters_sqgroups.GroupType='dstdomain'
		AND dnsdist_sqacllinks.aclid=$ruleid
		ORDER BY dnsdist_sqacllinks.zOrder";
    $results=$q->QUERY_SQL($sql);
    $GLOBALS["LB_DOM"]=array();
    $GLOBALS["REGEX_DOM"]=null;
    $GLOBALS["BUILD_ACLS_LB_SERVERS"]=array();
    $regx=array();
    foreach ($results as $index=>$ligne){
        $gpid=$ligne["gpid"];
        $GroupName=utf8_encode($ligne["GroupName"]);
        $GLOBALS["BUILD_ACLS_LB_SERVERS"][]="-- Group $GroupName ($gpid)";
        $results2=$q->QUERY_SQL("SELECT pattern FROM webfilters_sqitems WHERE enabled=1 AND gpid=$gpid");
        if(count($results2)==0){
            $GLOBALS["BUILD_ACLS_LB_SERVERS"][]="-- no items for this group";
            continue;
        }

        foreach ($results2 as $index2=>$ligne2){
            $pattern=$ligne2["pattern"];
            $regx[]="RegexRule('$pattern')";



        }

    }

    $GLOBALS["REGEX_DOM"]="OrRule{ ".@implode(", ",$regx)." }";
    if(count($regx)==0){return false;}



    return true;

}



function BUILD_ACLS_LB_SERVERS($ruleid){
    $q=new lib_sqlite("/home/artica/SQLITE/acls.db");
    $sql="SELECT dnsdist_sqacllinks.gpid,dnsdist_sqacllinks.negation,dnsdist_sqacllinks.zOrder,webfilters_sqgroups.* 
		FROM dnsdist_sqacllinks,webfilters_sqgroups 
		WHERE dnsdist_sqacllinks.gpid=webfilters_sqgroups.ID AND webfilters_sqgroups.GroupType='dst'
		AND dnsdist_sqacllinks.aclid=$ruleid
		ORDER BY dnsdist_sqacllinks.zOrder";
    $GLOBALS["LB_SERVERS"]=array();
    $results=$q->QUERY_SQL($sql);

    foreach ($results as $index=>$ligne){
        $gpid=$ligne["gpid"];
        $GroupName=utf8_encode($ligne["GroupName"]);
        $GLOBALS["BUILD_ACLS_LB_SERVERS"][]="-- Group $GroupName ($gpid)";
        $results2=$q->QUERY_SQL("SELECT pattern FROM webfilters_sqitems WHERE enabled=1 AND gpid=$gpid");
        if(count($results2)==0){
            $GLOBALS["BUILD_ACLS_LB_SERVERS"][]="-- no items for this group";
            continue;
        }

        foreach ($results2 as $index2=>$ligne2){
            $pattern=$ligne2["pattern"];
            $ID=$ligne2["ID"];
            $GLOBALS["LB_SERVERS"][]="newServer({address=\"$pattern\", name=\"DNS{$gpid}-$ruleid\", qps=1, pool=\"Pool{$ruleid}\"})";

        }

    }

    if(count($GLOBALS["LB_SERVERS"])==0){return false;}
    return true;

}



function uninstall(){

    build_progress("{uninstall} {APP_DNSDIST}",50);

    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableDNSDist",0);

    if(is_file("/etc/init.d/snmpd")){
        build_progress("{uninstall} {APP_DNSDIST}",60);
        shell_exec("/etc/init.d/snmpd restart");
    }

    remove_service("/etc/init.d/dnsdist");
    build_progress("{uninstall} {APP_DNSDIST} {done}",100);

}
function remove_service($INITD_PATH){
    if(!is_file($INITD_PATH)){return;}
    system("$INITD_PATH stop");

    if(is_file('/usr/sbin/update-rc.d')){
        shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");
    }

    if(is_file('/sbin/chkconfig')){
        shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");

    }

    if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}

function install(){
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();


    if(is_file("/etc/init.d/unbound")){
        build_progress("{APP_UNBOUND} {already_installed}",110);
        die();
    }
    if(is_file("/etc/init.d/dnsfilterd")){
        build_progress("DNS filter service {already_installed}",110);
        die();
    }

    if(is_file("/etc/init.d/pdns-recursor")){
        build_progress("{APP_PDNS_RECURSOR} {already_installed}",110);
        die();
    }

    if(is_file("/etc/init.d/pdns")){
        build_progress("{APP_PDNS} {already_installed}",110);
        die();
    }



    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableDNSDist",1);

    build_progress("{creating_service}",15);
    dnsdist_service();
    $res=new resolv_conf();
    $res->save();

    if(is_file("/etc/init.d/snmpd")){
        build_progress("{install} {APP_DNSDIST}",52);
        shell_exec("/etc/init.d/snmpd restart");
    }

    build_progress("{creating_service}",53);
    build_progress("{starting_service}",55);
    build_progress("{restarting_service}",70);
    system("/etc/init.d/dnsdist restart");
    build_progress("{installing} {succes}",100);


}




function dnsdist_service(){
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    $INITD_PATH="/etc/init.d/dnsdist";
    $php5script=basename(__FILE__);
    $daemonbinLog="DNS Load-balancing Service";


    $f[]="#!/bin/sh";
    $f[]="### BEGIN INIT INFO";
    $f[]="# Provides:         dnsdist";
    $f[]="# Required-Start:    \$local_fs \$syslog";
    $f[]="# Required-Stop:     \$local_fs \$syslog";
    $f[]="# Should-Start:";
    $f[]="# Should-Stop:";
    $f[]="# Default-Start:     4 5";
    $f[]="# Default-Stop:      0 1 6";
    $f[]="# Short-Description: $daemonbinLog";
    $f[]="# chkconfig: - 80 75";
    $f[]="# description: $daemonbinLog";
    $f[]="### END INIT INFO";
    $f[]=". /lib/lsb/init-functions";

    $f[]="case \"\$1\" in";
    $f[]=" start)";

    $f[]="\t$php /usr/share/artica-postfix/$php5script --start \$2 \$3";

    $f[]="    ;;";
    $f[]="";
    $f[]="  stop)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
    $f[]="    ;;";
    $f[]=" reload)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --reload \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" restart)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" rotatelog)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --rotatelog \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]="  *)";
    $f[]="    echo \"Usage: \$0 {start|stop|restart|rotatelog} (+ '--verbose' for more infos)\"";
    $f[]="    exit 1";
    $f[]="    ;;";
    $f[]="esac";
    $f[]="exit 0\n";


    echo "$daemonbinLog: [INFO] Writing $INITD_PATH with new config\n";
    @unlink($INITD_PATH);
    @file_put_contents($INITD_PATH, @implode("\n", $f));


    @chmod($INITD_PATH,0755);

    if(is_file('/usr/sbin/update-rc.d')){
        shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");

    }

    if(is_file('/sbin/chkconfig')){
        shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
        shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
    }


}