#!/usr/bin/php -q
<?php
include_once(dirname(__FILE__).'/framework/class.unix.inc');
include_once(dirname(__FILE__).'/ressources/class.tcpip.inc');
include_once(dirname(__FILE__).'/ressources/class.samba.privileges.inc');
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}

if(isset($argv[1])){
    if($argv[1]=="--notify"){notify_ntlm();exit;}
}


$logFile="/var/log/ntml.status.log";
if(is_file($logFile)){@unlink($logFile);}
if(!netads_info()){
    echo "net ads INFO... [FAILED]\n";
    exit(1);}
echo "net ads INFO... [OK]\n";
if(!netads_status()){
    echo "net ads STATUS..[FAILED]\n";
    exit(1);
}
echo "net ads STATUS..[OK]\n";



if(!wbinfo_check_secret()){
    echo "wbinfo Checks.....[FAILED]\n";
    exit(1);
}
echo "wbinfo Checks.....[OK]\n";


if(!wbinfo_auth()){
    echo "net ads STATUS..[FAILED]\n";
    exit(1);}
echo "wbinfo AUTH.....[OK]\n";
if(!wbinfo_ping_dc()){
    echo "wbinfo PING.....[FAILED]\n";
    exit(1);}
echo "wbinfo PING.....[OK]\n";
if(!wbinfo_ping_winbind()){
    echo "wbinfo WINBIND.....[FAILED]\n";
    exit(1);}
echo "wbinfo WINBIND.....[OK]\n";




echo "--- TESTS SUCCEEDED ---\n";
wbinfo_log("--- TESTS SUCCEEDED ---");
exit(0);

function notify_ntlm(){
    $content=@file_get_contents("/var/log/ntml.status.log");
    squid_admin_mysql(0,"NTLM watchdog report an issue on Active Directory link",$content,__FILE__,__LINE__);

}

function wbinfo_log($text){
    $date=date("Y-m-d H:i:s");
    $logFile="/var/log/ntml.status.log";
    $f = fopen($logFile, 'a');
    fwrite($f, "$date $text\n");
    fclose($f);


}

function wbinfo_ping_dc(){
    $unix=new unix();
    wbinfo_log("------------- ".__FUNCTION__." ------------");
    $wbinfo=$unix->find_program("wbinfo");
    if(!is_file($wbinfo)){return false;}

    exec("$wbinfo --ping-dc 2>&1",$results);
    foreach ($results as $line){
        $line=trim($line);
        if($line==null){continue;}
        wbinfo_log($line);
        if(preg_match("#succeeded#",$line)){return true;}

    }
    return false;

}
function wbinfo_ping_winbind(){
    $unix=new unix();
    wbinfo_log("------------- ".__FUNCTION__." ------------");
    $wbinfo=$unix->find_program("wbinfo");
    if(!is_file($wbinfo)){return false;}

    exec("$wbinfo --ping 2>&1",$results);
    foreach ($results as $line){
        $line=trim($line);
        if($line==null){continue;}
        wbinfo_log($line);
        if(preg_match("#succeeded#",$line)){return true;}

    }
    return false;

}
function wbinfo_auth(){
    $unix=new unix();
    $array=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("KerbAuthInfos")));

    $adminpassword=$array["WINDOWS_SERVER_PASS"];
    $adminpassword=$unix->shellEscapeChars($adminpassword);
    $adminname=$array["WINDOWS_SERVER_ADMIN"];
    $wbinfo=$unix->find_program("wbinfo");
    if(!is_file($wbinfo)){return false;}
    wbinfo_log("------------- ".__FUNCTION__." ------------");
    exec("$wbinfo -a $adminname%$adminpassword 2>&1",$results);

    foreach ($results as $line){
        $line=trim($line);
        if($line==null){continue;}
        wbinfo_log($line);
        if(preg_match("#succeeded#",$line)){return true;}

    }
    return false;

}
function wbinfo_check_secret(){
    $unix=new unix();
    wbinfo_log("------------- ".__FUNCTION__." ------------");
    $wbinfo=$unix->find_program("wbinfo");
    if(!is_file($wbinfo)){return false;}

    exec("$wbinfo --check-secret 2>&1",$results);
    foreach ($results as $line){
        $line=trim($line);
        if($line==null){continue;}
        wbinfo_log($line);
        if(preg_match("#succeeded#",$line)){return true;}

    }
    return false;

}


function netads_info(){
    $unix=new unix();
    $net=$unix->find_program("net");
    if(!is_file($net)){return false;}
    wbinfo_log("------------- ".__FUNCTION__." ------------");
    exec("$net ads testjoin 2>&1",$results);

    foreach ($results as $line){
        $line=trim($line);
        if($line==null){continue;}
        wbinfo_log($line);
        if(preg_match("#Join is OK#i",$line)){return true;}

    }
    return false;

}
function netads_status(){
    $unix=new unix();
    $net=$unix->find_program("net");
    if(!is_file($net)){return false;}
    $array=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("KerbAuthInfos")));

    $adminname=$array["WINDOWS_SERVER_ADMIN"];
    $adminpassword=$array["WINDOWS_SERVER_PASS"];
    $adminpassword=$unix->shellEscapeChars($adminpassword);
    wbinfo_log("------------- ".__FUNCTION__." ------------");

    exec("$net ads status -U $adminname%$adminpassword 2>&1",$results);

    foreach ($results as $line){
        $line=trim($line);
        if($line==null){continue;}
        wbinfo_log($line);
        if(preg_match("#servicePrincipalName:\s+(.+)?#i",$line)){return true;}

    }
    return false;

}


