<?php
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
$GLOBALS["FORCE"]=false;
$GLOBALS["RECONFIGURE"]=false;
$GLOBALS["SWAPSTATE"]=false;
$GLOBALS["NOSQUIDOUTPUT"]=true;
$GLOBALS["TITLENAME"]="Daemon Monitor";
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;$GLOBALS["OUTPUT"]=true;$GLOBALS["debug"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
if(preg_match("#--output#",implode(" ",$argv))){$GLOBALS["OUTPUT"]=true;}
if(preg_match("#schedule-id=([0-9]+)#",implode(" ",$argv),$re)){$GLOBALS["SCHEDULE_ID"]=$re[1];}
if(preg_match("#--force#",implode(" ",$argv),$re)){$GLOBALS["FORCE"]=true;}
if(preg_match("#--reconfigure#",implode(" ",$argv),$re)){$GLOBALS["RECONFIGURE"]=true;}
$GLOBALS["AS_ROOT"]=true;
include_once(dirname(__FILE__).'/ressources/class.ldap.inc');
include_once(dirname(__FILE__).'/ressources/class.squid.inc');
include_once(dirname(__FILE__).'/ressources/class.mysql.inc');

include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.settings.inc');
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.users.menus.inc');
include_once(dirname(__FILE__).'/ressources/class.system.nics.inc');
include_once(dirname(__FILE__).'/ressources/class.monit.inc');


if(system_is_overloaded(basename(__FILE__))){echo "Overloaded system, EXIT";exit();}

$GLOBALS["MONIT_CLASS"]=new monit_unix();

$GLOBALS["ARGVS"]=implode(" ",$argv);
if($argv[1]=="--stop"){$GLOBALS["OUTPUT"]=true;stop();exit();}
if($argv[1]=="--start"){$GLOBALS["OUTPUT"]=true;start();exit();}
if($argv[1]=="--reload"){$GLOBALS["OUTPUT"]=true;reload();exit();}
if($argv[1]=="--restart"){$GLOBALS["OUTPUT"]=true;restart();exit();}
if($argv[1]=="--build"){$GLOBALS["OUTPUT"]=true;build();exit();}
if($argv[1]=="--status"){status();exit();}
if($argv[1]=="--monitor-wait"){monitor_wait();exit();}
if($argv[1]=="--install"){install_service(true);exit();}
if($argv[1]=="--msftncsi"){msftncsi(true);exit;}
if($argv[1]=="--ifailed"){msftncsi_failed($argv[2],$argv[3]);exit;}


function msftncsi_failed($ipaddr,$host){
    squid_admin_mysql(0,"Access to Internet failed from $ipaddr to $host",null,__FILE__,__LINE__);
    die();
}

function status(){
    $GLOBALS["YESCGROUP"]=true;xcgroups();


	$cache_file="/usr/share/artica-postfix/ressources/logs/web/monit.status.all";
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pid=$unix->get_pid_from_file($pidfile);
	if($unix->process_exists($pid,basename(__FILE__))){
		$time=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Already Artica task running PID $pid since {$time}mn\n";}
		return;
	}

	$monit_pid=$GLOBALS["MONIT_CLASS"]->PID_NUM();
	if(!$unix->process_exists($monit_pid)){
		squid_admin_mysql(0, "Daemon monitor is not running, start it", null,__FILE__,__LINE__);
		start(true);
		return;
	}
	
	
	$time=$unix->file_time_min($cache_file);
	if(!$GLOBALS["VERBOSE"]){
		if($time<1){return;}
	}
	$cache_file="/usr/share/artica-postfix/ressources/logs/web/monit.status.all";
	$monit=new monit_unix();
	$array=$monit->all_status();
	if(count($array)<2){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} array returned less than 2 items\n";}
		return;}
	@unlink($cache_file);
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Saving $cache_file\n";}
	@file_put_contents($cache_file, serialize($array));
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MonitStatus.array",serialize($array));
	@chmod($cache_file,0755);
}


function restart() {
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pid=$unix->get_pid_from_file($pidfile);
	if($unix->process_exists($pid,basename(__FILE__))){
		$time=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Already Artica task running PID $pid since {$time}mn\n";}
		return;
	}
	@file_put_contents($pidfile, getmypid());
	build_progress_restart("{stopping_service}",15);
	if(!stop(true)){return;}
	build_progress_restart("{reconfiguring}",21);
	build();
	sleep(1);
	build_progress_restart("{starting_service}",46);
	start(true);
	
}

function monitor_wait(){
	sleep(5);
	$unix=new unix();
	$php5=$unix->LOCATE_PHP5_BIN();
	$sysctl=$unix->find_program("sysctl");
	$echo=$unix->find_program("echo");
	$nohup=$unix->find_program("nohup");
	shell_exec("{$GLOBALS["MONIT_CLASS"]->monitor_all_cmdline} >/dev/null 2>&1");
	
}

function reload(){
    echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Reloading...\n";
    $unix=new unix();
    $monitbin=$unix->find_program("monit");
    $pid=$GLOBALS["MONIT_CLASS"]->PID_NUM();
    if($unix->process_exists($pid)) {
        $time=$unix->PROCCESS_TIME_MIN($pid);
        echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Reloading PID $pid running since {$time}mn\n";
        shell_exec("$monitbin -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload >/dev/null 2>&1");
        return;
    }

    start();

}


function start($aspid=false){
	if(is_file("/etc/artica-postfix/FROM_ISO")){if(!is_file("/etc/artica-postfix/artica-iso-setup-launched")){return;}}
	$unix=new unix();
	$sock=new sockets();
	$Masterbin=$unix->find_program("monit");

	if(!is_file($Masterbin)){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]}, arpd not installed\n";}
		build_progress_restart("{starting_service} {failed}",110);
		return false;
	}

	if(!$aspid){
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=$unix->get_pid_from_file($pidfile);
		if($unix->process_exists($pid,basename(__FILE__))){
			$time=$unix->PROCCESS_TIME_MIN($pid);
			echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Already Artica task running PID $pid since {$time}mn\n";
			build_progress_restart("{starting_service} {failed}",110);
			return false;
		}
		@file_put_contents($pidfile, getmypid());
	}

	$pid=$GLOBALS["MONIT_CLASS"]->PID_NUM();

	if($unix->process_exists($pid)){
		$timepid=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Service already started $pid since {$timepid}Mn...\n";}
		build_progress_restart("{starting_service} {success}",100);
		return true;
	}
	
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableMonit")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableMonit", 1);}
	
	$EnableMonit=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableMonit"));

	if(!is_file("/etc/rsyslog.d/monit.conf")){
        $h[]="if  (\$programname =='monit') then {";
        $h[]="\tif (\$msg contains \"Checking summary\") then {";
        $h[]="\t\tstop";
        $h[]="\t}";
        $h[]="\t-/var/log/monit.log";
       // $h[]="\t& stop";
        $h[]="}";
        $h[]="";
        @file_put_contents("/etc/rsyslog.d/monit.conf",@implode("\n", $h));
        system("/etc/init.d/rsyslog restart");
    }
	
	

	if($EnableMonit==0){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service disabled (see EnableMonit)\n";}
		build_progress_restart("{starting_service} {failed}",110);
		return false;
	}

	$php5=$unix->LOCATE_PHP5_BIN();
	$nohup=$unix->find_program("nohup");
	$rm=$unix->find_program("rm");
	if(!is_dir("/var/run/monit")){@mkdir("/var/run/monit",0755,true);}

    shell_exec("$rm -f /etc/monit/conf-available/* 2>&1");
    shell_exec("$rm -f /etc/monit/conf-enabled/* 2>&1");
	
	
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} apply permissions\n";}
	$GLOBALS["MONIT_CLASS"]->CheckFolders();
	
	$cmd=$GLOBALS["MONIT_CLASS"]->start_cmdline ." 2>&1";
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} configuring service\n";}
	build();
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} starting service\n";}

	if(is_dir("/etc/monit/monitrc")){@rmdir("/etc/monit/monitrc");}
	if(!is_file("/etc/monit/monitrc")){build();}

	shell_exec("$nohup $cmd >/dev/null 2>&1 &");
	
	for($i=1;$i<5;$i++){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} waiting $i/5\n";}
		sleep(1);
		build_progress_restart("{starting_service} {waiting} $i/5",47);
		$pid=$GLOBALS["MONIT_CLASS"]->PID_NUM();
		if($unix->process_exists($pid)){break;}
	}

	$pid=$GLOBALS["MONIT_CLASS"]->PID_NUM();
	if($unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Success PID $pid\n";}
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Force to monitor all daemons..\n";}
		shell_exec("$nohup $php5 --monitor-wait >/dev/null 2>&1 &");
		shell_exec("$nohup /etc/init.d/artica-status reload >/dev/null 2>&1 &");
		build_progress_restart("{starting_service} {success}",100);
		return true;
	}
	build_progress_restart("{starting_service} {failed}",110);
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Failed\n";}
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} $cmd\n";}
	
		
}

function stop($aspid=false){
	$unix=new unix();
	if(!$aspid){
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=$unix->get_pid_from_file($pidfile);
		if($unix->process_exists($pid,basename(__FILE__))){
			$time=$unix->PROCCESS_TIME_MIN($pid);
			if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service Already Artica task running PID $pid since {$time}mn\n";}
			build_progress_restart("{stopping_service} {failed}",110);
			return;
		}
		@file_put_contents($pidfile, getmypid());
	}

	$pid=$GLOBALS["MONIT_CLASS"]->PID_NUM();


	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service already stopped...\n";}
		build_progress_restart("{stopping_service} {success}",20);
		return true;
	}
	$pid=$GLOBALS["MONIT_CLASS"]->PID_NUM();

	
	build_progress_restart("{stopping_service}",16);
	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} unmonitor all processes\n";}
	exec($GLOBALS["MONIT_CLASS"]->stop_cmdline." 2>&1",$results);
	sleep(1);

	build_progress_restart("{stopping_service}",17);
	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service Shutdown pid $pid...\n";}
	unix_system_kill($pid);
	for($i=0;$i<5;$i++){
		$pid=$GLOBALS["MONIT_CLASS"]->PID_NUM();
		if(!$unix->process_exists($pid)){break;}
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service waiting pid:$pid $i/5...\n";}
		sleep(1);
	}

	build_progress_restart("{stopping_service}",18);
	$pid=$GLOBALS["MONIT_CLASS"]->PID_NUM();
	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service success...\n";}
		build_progress_restart("{stopping_service} {success}",20);
		return true;
	}
	
	build_progress_restart("{stopping_service}",19);
	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service shutdown - force - pid $pid...\n";}
	unix_system_kill_force($pid);
	for($i=0;$i<5;$i++){
		$pid=$GLOBALS["MONIT_CLASS"]->PID_NUM();
		if(!$unix->process_exists($pid)){break;}
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service waiting pid:$pid $i/5...\n";}
		sleep(1);
	}
	
	if($unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service failed...\n";}
		build_progress_restart("{stopping_service} {failed}",110);
		return false;
	}
	build_progress_restart("{stopping_service} {success}",20);
	return true;

}
function build_progress_restart($text,$pourc){
	
	if($GLOBALS["OUTPUT"]){echo "Progress......: ".date("H:i:s")." [{$pourc}%]: {$GLOBALS["TITLENAME"]} $text..\n";}
	$GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/exec.monit.progress";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($GLOBALS["CACHEFILE"], serialize($array));
	@chmod($GLOBALS["CACHEFILE"],0755);
	if($GLOBALS["PROGRESS"]){sleep(1);}

}

function msftncsi($reload=false){
    $MAINDIR="/etc/monit/conf.d";

    if (!$handle = opendir($MAINDIR)) {return;}
     while (false !== ($fileZ = readdir($handle))) {
         if ($fileZ == ".") {
             continue;
         }
         if ($fileZ == "..") {
             continue;
         }
         if (!preg_match("#^APP_MSFTNCSI_#", $fileZ)) {
             continue;
         }
         $path = "$MAINDIR/$fileZ";
         @unlink($path);
     }
    $EnableMsftncsi=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableMsftncsi"));
    if($EnableMsftncsi==0){return true;}
    $unix=new unix();

    $MAIN=$unix->NETWORK_ALL_INTERFACES();
    $php=$unix->LOCATE_PHP5_BIN();

    $sites_to_test[]="http://www.msftconnecttest.com/connecttest.txt";
    $sites_to_test[]="http://www.msftncsi.com/ncsi.txt";
    $sites_to_test[]="http://detectportal.firefox.com/success.txt";
    $sites_to_test[]="http://www.appleiphonecell.com/index.html";
    $sites_to_test[]="http://www.itools.info/index.html";
    $sites_to_test[]="http://www.ibook.info/index.html";
    $sites_to_test[]="http://www.airport.us/index.html";
    $sites_to_test[]="http://www.thinkdifferent.us/index.html";

    $c=0;
    foreach ($MAIN as $eth=>$array){
        if(!isset($array["IPADDR"])){continue;}
        echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} msftncsi: $eth `{$array["IPADDR"]}`\n";
        if($eth=="lo"){continue;}
        if(!isset($array["IPADDR"])){
            echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} msftncsi $eth -> NO IP\n";
            continue;
        }
        $ipaddr=trim($array["IPADDR"]);
        if($ipaddr=="0.0.0.0"){continue;}
        if($ipaddr==null){continue;}

        $nic=new system_nic($eth);
        if(!$nic->IsConfigured()){
            echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} msftncsi $eth -> Not configured\n";
            continue;
        }
        if($nic->NoInternetCheck==1){
            echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} msftncsi $eth -> NoInternetCheck == 1, skip\n";
            continue;
        }



        $URL=$sites_to_test[rand(0,count($sites_to_test)-1)];
        $cheks=parse_url($URL);
        $host=$cheks["host"];
        $path = $cheks["path"];
        $CF=array();
        echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} msftncsi $ipaddr - $host \n";
        $CF[]="check host msftncsi.$eth.tld with address $host every 6 cycles";
        $CF[]="\tif failed";
        $CF[]="\t\tport 80";
        $CF[]="\t\ttimeout 3 seconds";
        $CF[]="\t\tretry 3";
        $CF[]="\t\taddress $ipaddr";
        $CF[]="\t\tprotocol http";

        $CF[]="\t\trequest \"$path\"";



        $CF[]="\tthen exec \"$php ".__FILE__." --ifailed $ipaddr $host\"";
        $CF[]="";
        $destfile="/etc/monit/conf.d/APP_MSFTNCSI_".strtoupper($eth).".monitrc";
        @file_put_contents($destfile,@implode("\n",$CF));
        echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} msftncsi $destfile done\n";

    }

    if(is_file("/etc/cron.d/artica-msftncsi")){
        @unlink("/etc/cron.d/artica-msftncsi");
        shell_exec("/etc/init.d/cron reload");
        return;
    }

    if(is_file("/usr/share/artica-postfix/exec.msftncsi.php")){
        @unlink("/usr/share/artica-postfix/exec.msftncsi.php");
    }

    if($reload){reload();}


}

function build(){
	$users=new usersMenus();
	$sock=new sockets();
	$unix=new unix();
	$SquidPerformance=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidPerformance"));
	$EnableIntelCeleron=intval(@file_get_contents("/etc/artica-postfix/settings/Daemons/EnableIntelCeleron"));
    $squidbin=$unix->LOCATE_SQUID_BIN();
    $php=$unix->LOCATE_PHP5_BIN();
    $echo=$unix->find_program("echo");
	$php5=$unix->LOCATE_PHP5_BIN();


	build_progress_restart("{reconfiguring}",10);
	if(!is_file("/etc/cron.d/monit-queue")){
	    $unix->Popuplate_cron_make("monit-queue","*/5 * * * *","exec.monit-queue.php");
	    shell_exec("/etc/init.d/cron restart");
    }
	
	
	$ZarafaDedicateMySQLServer=$sock->GET_INFO("ZarafaDedicateMySQLServer");
	if(!is_numeric($ZarafaDedicateMySQLServer)){$ZarafaDedicateMySQLServer=0;}
	build_progress_restart("{reconfiguring}",22);
	
	$ini=new Bs_IniHandler();
	$ini->loadFile('/etc/artica-postfix/smtpnotif.conf');
	
	if(!is_numeric($ini->_params["SMTP"]["EnableNotifs"])){$ini->_params["SMTP"]["EnableNotifs"]=0;}
	if(!is_numeric($ini->_params["SMTP"]["tls_enabled"])){$ini->_params["SMTP"]["tls_enabled"]=0;}
	
	
	$smtp_server=trim($ini->_params["SMTP"]['smtp_server_name']);
	$smtp_server_port=$ini->_params["SMTP"]['smtp_server_port'];
	$smtp_dest=$ini->_params["SMTP"]['smtp_dest'];
	$smtp_sender=$ini->_params["SMTP"]['smtp_sender'];
	$smtp_auth_user=$ini->_params["SMTP"]['smtp_auth_user'];
	$smtp_auth_passwd=$ini->_params["SMTP"]['smtp_auth_passwd'];
	$tls_enabled=$ini->_params["SMTP"]["tls_enabled"];
	
	$recipientsZ=explode("\n","/etc/artica-postfix/settings/Daemons/SmtpNotificationConfigCC");
	
	$recipients=array();
	foreach ($recipientsZ as $to){
		if(trim($to)==null){continue;}
		$recipients[]=$to;
		
	}
	
	if($smtp_server==null){$ini->_params["SMTP"]["EnableNotifs"]=0;}
	if($smtp_dest==null){
		if(count($recipients)==0){$ini->_params["SMTP"]["EnableNotifs"]=0;}
	}
	if(!is_numeric($smtp_server_port)){$smtp_server_port=25;}
	
	$EnableNotifs=$ini->_params["SMTP"]["EnableNotifs"];
	$monit_not_on='instance,action';
	
	$f[]='set daemon 60 with start delay 5';
	$f[]='set idfile /var/run/monit/monit.id';
	
	
	$cpunum=$unix->CPU_NUMBER();
	$normal=($cpunum*2)+1;
	$normal2=$cpunum*2;
	$busy=$cpunum*4;
	build_progress_restart("{reconfiguring}",23);
	
	$EnableMONITSmtpNotif=$sock->GET_INFO("EnableMONITSmtpNotif");
	if(!is_numeric($EnableMONITSmtpNotif)){$EnableMONITSmtpNotif=1;}

    $MonitSpaceFree=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MonitSpaceFree"));
    $MonitSpaceFreeCycles=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MonitSpaceFreeCycles"));
    if($MonitSpaceFree==0){$MonitSpaceFree=5;}
    if($MonitSpaceFreeCycles==0){$MonitSpaceFreeCycles=30;}
	
	$MonitCPUUsage=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MonitCPUUsage"));
	$MonitCPUUsageCycles=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MonitCPUUsageCycles"));
	
	$MonitMemUsage=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MonitMemUsage"));
	$MonitMemUsageCycles=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MonitMemUsageCycles"));
	
	$MonitReportLoadVG1mn=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MonitReportLoadVG1mn"));
	$MonitReportLoadVG1mnCycles=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MonitReportLoadVG1mnCycles"));
	
	if($MonitReportLoadVG1mnCycles==0){$MonitReportLoadVG1mnCycles=5;}
	
	$MonitReportLoadVG5mn=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MonitReportLoadVG5mn"));
	$MonitReportLoadVG5mnCycles=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MonitReportLoadVG5mnCycles"));
	
	if($MonitReportLoadVG5mnCycles==0){$MonitReportLoadVG5mnCycles=15;}
	
	$MonitReportLoadVG15mn=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MonitReportLoadVG15mn"));
	$MonitReportLoadVG15mnCycles=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MonitReportLoadVG15mnCycles"));
	
	if($MonitReportLoadVG15mnCycles==0){$MonitReportLoadVG15mnCycles=60;}
	$MonitMemPurgeCache=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MonitMemPurgeCache"));
	$MonitMemPurgeCacheCycles=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MonitMemPurgeCacheCycles"));
	if($MonitMemPurgeCache==0){$MonitMemPurgeCache=70;}
	if($MonitMemPurgeCacheCycles==0){$MonitMemPurgeCacheCycles=5;}
	if($MonitMemUsageCycles==0){$MonitMemUsageCycles=5;}

	if($MonitCPUUsageCycles==0){$MonitCPUUsageCycles=15;}
	
	if($MonitCPUUsage>0){
		if($MonitCPUUsage<50){
			$MonitCPUUsage=90;
		}
	}
	
	if($MonitMemUsage>0){
		if($MonitMemUsage<50){
			$MonitMemUsage=90;
		}
	}

	
	build_progress_restart("{reconfiguring}",24);
	

	$SQUIDEnable=intval($sock->GET_INFO("SQUIDEnable"));

	if($SQUIDEnable==1){
        build_progress_restart("{reconfiguring} {APP_SQUID}",25);
        system("$php /usr/share/artica-postfix/exec.squid.disable.php --monit >/dev/null 2>&1");
    }

	
	$f[]='set logfile syslog facility log_daemon';
	
	$f[]='set statefile /var/run/monit/monit.state';
	$f[]='';
	if($EnableNotifs==1){
		if($EnableMONITSmtpNotif==1){
			$f[]="set mailserver $smtp_server PORT $smtp_server_port";
			if(strlen($smtp_auth_user)>0){ $f[]="\tUSERNAME \"$smtp_auth_user\" PASSWORD \"$smtp_auth_passwd\"";}
			if($tls_enabled==1){$f[]="\tusing TLSV1";}
			$f[]="\tset eventqueue";
			$f[]="\tbasedir /var/monit";
			$f[]="\tslots 100";
	
			$f[]="\tset mail-format {";
			$f[]="\t\tfrom: $smtp_sender";
			$f[]="\t\tsubject: Artica service monitor: \$SERVICE \$EVENT";
			$f[]="\t\tmessage: Artica service monitor  \$ACTION  \$SERVICE at  \$DATE on  \$HOST:  \$DESCRIPTION";
			$f[]="\t}";
			$f[]="set alert $smtp_dest but not on {{$monit_not_on}}";
			if($recipients>0){
			    foreach ($recipientsZ as $to){
					$f[]="set alert $to but not on {{$monit_not_on}}";
				}
			}
	
		}
	}
	
	build_progress_restart("{reconfiguring}",25);
	$allips=$unix->NETWORK_ALL_INTERFACES(true);
	
	$f[]="set httpd port 2874 and use address 127.0.0.1";
	$f[]="\tallow 127.0.0.1";
	foreach ($allips as $tcpi=>$to){
		$f[]="\tallow $tcpi";
	}


	
		$TSCR=array();
		
		if($MonitReportLoadVG1mn>0){$TSCR[]="\tif loadavg (1min) > $MonitReportLoadVG1mn for $MonitReportLoadVG1mnCycles cycles then exec \"/bin/artica-system-alert.sh LOAD_1 $MonitReportLoadVG1mn\"";}
		if($MonitReportLoadVG5mn>0){$TSCR[]="\tif loadavg (5min) > $MonitReportLoadVG5mn for $MonitReportLoadVG5mnCycles cycles then exec \"/bin/artica-system-alert.sh LOAD_5 $MonitReportLoadVG5mn\"";}
		if($MonitReportLoadVG15mn>0){$TSCR[]="\tif loadavg (15min) > $MonitReportLoadVG15mn for $MonitReportLoadVG15mnCycles cycles then exec \"/bin/artica-system-alert.sh LOAD_15 $MonitReportLoadVG15mn\"";}
		
		if($MonitCPUUsage>0){
			if($MonitCPUUsage<75){$MonitCPUUsage=75;}
			$TSCR[]="\tif cpu usage(system) > {$MonitCPUUsage}% for $MonitCPUUsageCycles cycles then exec \"/bin/artica-system-alert.sh CPU_SYSTEM $MonitCPUUsage\"";
			$TSCR[]="\tif cpu usage(user) > {$MonitCPUUsage}% for $MonitCPUUsageCycles cycles then exec \"/bin/artica-system-alert.sh CPU_USER $MonitCPUUsage\"";
			$TSCR[]="\tif cpu usage(wait) > {$MonitCPUUsage}% for $MonitCPUUsageCycles cycles then exec \"/bin/artica-system-alert.sh CPU_WAIT $MonitCPUUsage\"";
			
		}
		if($MonitMemUsage>0){
			if($MonitMemUsage<75){$MonitMemUsage=75;}
			$TSCR[]="\tif memory > {$MonitMemUsage}% for $MonitMemUsageCycles cycles then exec \"/bin/artica-system-alert.sh MEM $MonitMemUsage\"";
		}

		if($MonitMemPurgeCache>5){
			@chmod("/usr/share/artica-postfix/exec.kernel.purge.cache.php",0755);
			$TSCR[]="\tif memory > {$MonitMemPurgeCache}% for $MonitMemPurgeCacheCycles cycles then exec \"/usr/share/artica-postfix/exec.kernel.purge.cache.php\"";
		}
		
		if(count($TSCR)>1){
            $f[]="";
			$f[]="check system ".$unix->hostname_g();
			$f[]=@implode("\n", $TSCR);
		}

    $MonitSpaceFree=$MonitSpaceFree+1;
    if($MonitSpaceFree==101){$MonitSpaceFree=100;}
    $f[]="";
    $f[]="check filesystem rootfs with path /";
    $f[]="\tif space free < {$MonitSpaceFree}% for $MonitSpaceFreeCycles cycles then exec \"/bin/artica-system-alert.sh SPACE $MonitSpaceFree\"";




    $TSCR=array();
		$SCRIPT=array();
		$SCRIPT[]="#!/bin/sh";
		$SCRIPT[]="";
		$SCRIPT[]="$php /usr/share/artica-postfix/exec.artica-system-alert.php $1 $2";
		$SCRIPT[]="";
		@file_put_contents("/bin/artica-system-alert.sh", @implode("\n", $SCRIPT));
		@chmod("/bin/artica-system-alert.sh",0755);
		$SCRIPT=array();
		
	$f[]="";
	$f[]="check host loopback with address 127.0.0.1";
	$f[]="\tif failed icmp type echo with timeout 1 seconds then exec \"/bin/loopbackfailed.sh\"";
	$f[]="";
	
	$loopbackfailed[]="#!/bin/sh";
	$loopbackfailed[]="$php5 /usr/share/artica-postfix/exec.virtuals-ip.php --loopback";
	$loopbackfailed[]="";
	@file_put_contents("/bin/loopbackfailed.sh", @implode("\n", $loopbackfailed));
	@chmod("/bin/loopbackfailed.sh",0755);
	$loopbackfailed=array();
	build_progress_restart("{reconfiguring}",25);
	


//********************************************************************************************************************

    $tt[]="/var/log/artica-postfix/squid-logger-start.log";
    $tt[]="/var/log/squid/access.log";
    $tt[]="/var/log/hacluster-connections.log";
    $tt[]="/var/log/hacluster-client.log";

    foreach ($tt as $filepath){
        $path=dirname($filepath);
        if(!is_dir($path)){@mkdir($path,0755,true);}
        if(!is_file($filepath)){@touch($filepath);}
    }

    $scr[]="#!/bin/sh";
    $scr[]="rm -f /var/log/syslog";
    $scr[]="/etc/init.d/rsyslog restart\n";
    $scr[]="/etc/init.d/artica-syslog restart\n";
    $scr[]="exit 0\n";
    @file_put_contents("/bin/clean-phpsyslog.sh",@implode("\n",$scr));
    @chmod("/bin/clean-phpsyslog.sh",0755);


	$f[]="check file php.log with path /var/log/php.log";
	$f[]="\tif size > 100 MB then";
	$f[]="\t\texec \"/bin/clean-phplog.sh\"";
	$f[]="";
	$f[]="check file usrphp.log with path /usr/share/artica-postfix/ressources/logs/php.log";
	$f[]="      if size > 100 MB then";
	$f[]="\t\texec \"/bin/clean-phplog.sh\"";
	$f[]="";
    $f[]="check file syslogev with path /var/log/syslog";
    $f[]="      if size > 1000 MB then";
    $f[]="\t\texec \"/bin/clean-phpsyslog.sh\"";
    $f[]="";


	if(!is_file("/var/log/artica-postfix/squid-logger-start.log")){@touch("/var/log/artica-postfix/squid-logger-start.log");}
	if(is_file($squidbin)){
		$f[]="check file squid-logger-start.log with path /var/log/artica-postfix/squid-logger-start.log";
		$f[]="\tif size > 100 MB then";
		$f[]="\t\texec \"/bin/squid-logger-start.sh\"";
		$f[]="";
	}

	build_progress_restart("{reconfiguring}",26);
	$f[]="include /etc/monit/conf.d/*";
	@file_put_contents("/etc/monit/monitrc", @implode("\n", $f));
	@chmod("/etc/monit/monitrc",0700);


	echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} /etc/monit/monitrc done...\n";
	$AA[]="#!/bin/sh";
	$AA[]="$echo \"#\" >/var/log/artica-postfix/squid-logger-start.log";
	$AA[]="";
	@file_put_contents("/bin/squid-logger-start.sh", @implode("\n", $AA));
	@chmod("/bin/squid-logger-start.sh",0755);
	
	
	
	$AA=array();
	$AA[]="#!/bin/sh";
	$AA[]="$echo \"#\" >/var/log/php.log";
	$AA[]="";
	@file_put_contents("/bin/clean-phplog.sh", @implode("\n", $AA));
	@chmod("/bin/clean-phplog.sh",0755);
	$AA=array();
	
	
	$monit=new monit();
	$monit->save();

	
	build_progress_restart("{reconfiguring}",27);
	@unlink("/etc/monit/conf.d/APP_OPENSSH.monitrc");
	
	
//********************************************************************************************************************	
	$f=array();
	build_progress_restart("{reconfiguring}",28);
	$f[]="check process APP_ARTICA_STATUS with pidfile /etc/artica-postfix/exec.status.php.pid";
	$f[]="\tstart program = \"/etc/init.d/artica-status start --monit\"";
	$f[]="\tstop program = \"/etc/init.d/artica-status stop --monit\"";
	$f[]="\tif 5 restarts within 5 cycles then timeout";
	$f[]="";
	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring Artica Status...\n";}
	@file_put_contents("/etc/monit/conf.d/APP_ARTICASTATUS.monitrc", @implode("\n", $f));	
//********************************************************************************************************************	
	$f=array();
	$EnableInflux=1;
	if($SquidPerformance>2){$EnableInflux=0;}
	$InfluxUseRemote=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("InfluxUseRemote"));
	$EnableInfluxDB=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableInfluxDB"));
	
	if($InfluxUseRemote==1){$EnableInfluxDB=0;}
	if($EnableIntelCeleron==1){$EnableInflux=0;}
	if($EnableInfluxDB==0){$EnableInflux=0;}
	$POSTFIX_INSTALLED=false;
	$postconf=$unix->find_program("postconf");
	if(is_file($postconf)){$POSTFIX_INSTALLED=true;}
	
	if(is_file("/etc/artica-postfix/STATS_APPLIANCE")){$EnableInflux=1;}
	build_progress_restart("{reconfiguring}",29);
	@unlink("/etc/monit/conf.d/APP_INFLUXDB.monitrc");

	
	$f=array();

// ********************************************************************************************************************
// ********************************************************************************************************************
	
	
	
	$f=array();
	build_progress_restart("{reconfiguring} Proftpd",31);
	@unlink("/etc/monit/conf.d/APP_PROFTPD.monitrc");
	$proftpd=$unix->find_program("proftpd");
	
	if(is_file($proftpd)){
		$enabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableProFTPD"));
		if($enabled==1){
			$f[]="check process APP_PROFTPD with pidfile /var/run/proftpd.pid";
			$f[]="\tstart program = \"/etc/init.d/proftpd start --monit\"";
			$f[]="\tstop program = \"/etc/init.d/proftpd stop --monit\"";
			$f[]="\tif 5 restarts within 5 cycles then timeout";
			$f[]="";
			if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring PROFTPD...\n";}
			@file_put_contents("/etc/monit/conf.d/APP_PROFTPD.monitrc", @implode("\n", $f));
		}
	}
	// ********************************************************************************************************************
	$f=array();
	build_progress_restart("{reconfiguring} dbus",31);
	@unlink("/etc/monit/conf.d/APP_DBUS.monitrc");
	$f[]="check process APP_DBUS with pidfile /var/run/dbus/pid";
	$f[]="\tstart program = \"/etc/init.d/dbus start\"";
	$f[]="\tstop program = \"/etc/init.d/dbus stop\"";
	$f[]="\tif 5 restarts within 5 cycles then timeout";
	$f[]="";
	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring DBUS...\n";}
	@file_put_contents("/etc/monit/conf.d/APP_DBUS.monitrc", @implode("\n", $f));
	
	
	
	
	$f=array();
	build_progress_restart("{reconfiguring} Bandwidthd",31);
	@unlink("/etc/monit/conf.d/APP_BANDWIDTHD.monitrc");
	
		if(is_file("/usr/bandwidthd/bandwidthd")){
		$enabled=$sock->Bandwidthd_enabled();
		if($enabled==1){
			$f[]="check process APP_BANDWIDTHD with pidfile /var/run/bandwidthd.pid";
			$f[]="\tstart program = \"/etc/init.d/bandwidthd start --monit\"";
			$f[]="\tstop program = \"/etc/init.d/bandwidthd stop --monit\"";
			$f[]="\tif 5 restarts within 5 cycles then timeout";
			$f[]="";
			if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring DnsMASQ...\n";}
			@file_put_contents("/etc/monit/conf.d/APP_BANDWIDTHD.monitrc", @implode("\n", $f));
		}
		
	}
	// ********************************************************************************************************************	
	$f=array();
	build_progress_restart("{reconfiguring} rsyslog",32);
	$rsyslogd=$unix->find_program("rsyslogd");
	@unlink("/etc/monit/conf.d/APP_RSYSLOG.monitrc");
	if(is_file($rsyslogd)){
		
		$SCRIPT=array();
		$SCRIPT[]="#!/bin/sh";
		$SCRIPT[]="$php5 /usr/share/artica-postfix/exec.watchdog.rsyslogd.php --start";
		$SCRIPT[]="";
		@file_put_contents("/bin/artica-rsyslog-start.sh", @implode("\n", $SCRIPT));
		@chmod("/bin/artica-rsyslog-start.sh",0755);
		$SCRIPT=array();
		$SCRIPT[]="#!/bin/sh";
		$SCRIPT[]="$php5 /usr/share/artica-postfix/exec.watchdog.rsyslogd.php --stop";
		$SCRIPT[]="";
		@file_put_contents("/bin/artica-rsyslog-stop.sh", @implode("\n", $SCRIPT));
		@chmod("/bin/artica-rsyslog-stop.sh",0755);
		$SCRIPT=array();		
		
		
		$f[]="check process APP_RSYSLOG with pidfile /var/run/rsyslogd.pid";
		$f[]="\tstart program = \"/bin/artica-rsyslog-start.sh\"";
		$f[]="\tstop program = \"/bin/artica-rsyslog-stop.sh\"";
		$f[]="\tif 5 restarts within 5 cycles then timeout";
		$f[]="";
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring rsyslogd...\n";}
		@file_put_contents("/etc/monit/conf.d/APP_RSYSLOG.monitrc", @implode("\n", $f));
	}
	
	
	// ********************************************************************************************************************
	

	$f=array();
	build_progress_restart("{reconfiguring} Suricata",32);
	$EnableSuricata=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableSuricata"));
	@unlink("/etc/monit/conf.d/APP_SURICATA.monitrc");
	@unlink("/etc/monit/conf.d/APP_SURICATA_TAIL.monitrc");
	$suricata=$unix->find_program("suricata");
	if(is_file($suricata)){
		if($EnableSuricata==1){
			$f[]="check process APP_SURICATA with pidfile /var/run/suricata/suricata.pid";
			$f[]="\tstart program = \"/etc/init.d/suricata start --monit\"";
			$f[]="\tstop program = \"/etc/init.d/suricata stop --monit\"";
			$f[]="\tif cpu usage > 95% for 5 cycles then restart";
			$f[]="\tif 5 restarts within 5 cycles then timeout";
			$f[]="";
			if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring Suricata...\n";}
			@file_put_contents("/etc/monit/conf.d/APP_SURICATA.monitrc", @implode("\n", $f));
			
			$f=array();
			$f[]="check process APP_SURICATA_TAIL with pidfile /etc/artica-postfix/exec.suricata-tail.php.pid";
			$f[]="\tstart program = \"/etc/init.d/suricata-tail start --monit\"";
			$f[]="\tstop program = \"/etc/init.d/suricata-tail stop --monit\"";
			$f[]="\tif 5 restarts within 5 cycles then timeout";
			$f[]="";
			if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring Suricata tail...\n";}
			@file_put_contents("/etc/monit/conf.d/APP_SURICATA_TAIL.monitrc", @implode("\n", $f));
		}
	}
// ********************************************************************************************************************	
	$f=array();
	build_progress_restart("{reconfiguring}",32);

// ********************************************************************************************************************
	$f=array();

// ********************************************************************************************************************	
	build_progress_restart("{reconfiguring}",34);
	@unlink("/etc/monit/conf.d/APP_SYSLOGDB.monitrc");
//********************************************************************************************************************
	$f=array();
	@unlink("/etc/monit/conf.d/cron.monitrc");
	if(is_file("/etc/monit/templates/rootbin")){
		$f[]="check process crond with pidfile /var/run/crond.pid";
		$f[]="   group system";
		$f[]="   group crond";
		$f[]="   start program = \"/etc/init.d/cron start\"";
		$f[]="   stop  program = \"/etc/init.d/cron stop\"";
		$f[]="   if 5 restarts with 5 cycles then timeout";
		$f[]="   depend cron_bin";
		$f[]="   depend cron_rc";
		$f[]="   depend cron_spool";
		$f[]="";
		$f[]=" check file cron_bin with path /usr/sbin/cron";
		$f[]="   group crond";
		$f[]="   include /etc/monit/templates/rootbin";
		$f[]="";
		$f[]=" check file cron_rc with path \"/etc/init.d/cron\"";
		$f[]="   group crond";
		$f[]="   include /etc/monit/templates/rootbin";
		$f[]="";
		$f[]=" check directory cron_spool with path /var/spool/cron/crontabs";
		$f[]="   group crond";
		$f[]="   if failed permission 1730 then unmonitor";
		$f[]="   if failed uid root        then unmonitor";
		$f[]="   if failed gid crontab     then unmonitor";	
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring cron...\n";}
		@file_put_contents("/etc/monit/conf.d/cron.monitrc", @implode("\n", $f));
		$f=array();
	}
	
	@unlink("/etc/monit/conf.d/APP_ZARAFASERVER.monitrc");
	@unlink("/etc/monit/conf.d/APP_ZARAFAGATEWAY.monitrc");
	@unlink("/etc/monit/conf.d/APP_ZARAFAAPACHE.monitrc");
	@unlink("/etc/monit/conf.d/APP_ZARAFAWEB.monitrc");
	@unlink("/etc/monit/conf.d/APP_ZARAFASPOOLER.monitrc");	
	@unlink("/etc/monit/conf.d/APP_ZARAFADB.monitrc");
	build_progress_restart("{reconfiguring}",35);
	

	if(is_file($unix->find_program("zarafa-server"))){
		$ZarafaApacheEnable=$sock->GET_INFO("ZarafaApacheEnable");
		if(!is_numeric($ZarafaApacheEnable)){$ZarafaApacheEnable=1;}
		$ZarafaApachePort=$sock->GET_INFO("ZarafaApachePort");
		if(!is_numeric($ZarafaApachePort)){$ZarafaApachePort=9010;}
		
		if($ZarafaDedicateMySQLServer==1){
			$f=array();
			$f[]="check process APP_ZARAFA_DB with pidfile /var/run/zarafa-db.pid";
			$f[]="\tstart program = \"/etc/init.d/zarafa-db start --monit\"";
			$f[]="\tstop program = \"/etc/init.d/zarafa-db stop --monit\"";
			$f[]="\tif failed unixsocket /var/run/mysqld/zarafa-db.sock then restart";
			$f[]="\tif 5 restarts within 5 cycles then timeout";
			$f[]="";
			if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring Zarafa Database...\n";}
			@file_put_contents("/etc/monit/conf.d/APP_ZARAFADB.monitrc", @implode("\n", $f));
		}		
		
		
		
		$f=array();
		$f[]="check process APP_ZARAFA_SERVER with pidfile /var/run/zarafa-server.pid";
		$f[]="\tstart program = \"/etc/init.d/zarafa-server start --monit\"";
		$f[]="\tstop program = \"/etc/init.d/zarafa-server stop --monit\"";
		$f[]="\tif failed unixsocket /var/run/zarafa then restart";
		$f[]="\tif 5 restarts within 5 cycles then timeout";
		$f[]="";
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring Zarafa Server...\n";}
		@file_put_contents("/etc/monit/conf.d/APP_ZARAFASERVER.monitrc", @implode("\n", $f));

		$f=array();
		$f[]="check process APP_ZARAFA_SPOOLER with pidfile /var/run/zarafa-spooler.pid";
		$f[]="\tstart program = \"/etc/init.d/zarafa-spooler start --monit\"";
		$f[]="\tstop program = \"/etc/init.d/zarafa-spooler stop --monit\"";
		$f[]="\tif 5 restarts within 5 cycles then timeout";
		$f[]="";
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring Zarafa Spooler...\n";}
		@file_put_contents("/etc/monit/conf.d/APP_ZARAFASPOOLER.monitrc", @implode("\n", $f));		
		
		
		
		
		$f=array();
		$f[]="check process APP_ZARAFA_GATEWAY with pidfile /var/run/zarafa-gateway.pid";
		$f[]="\tstart program = \"/etc/init.d/zarafa-gateway start --monit\"";
		$f[]="\tstop program = \"/etc/init.d/zarafa-gateway stop --monit\"";
		$f[]="\tif 5 restarts within 5 cycles then timeout";
		$f[]="";
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring Zarafa Gateway...\n";}
		@file_put_contents("/etc/monit/conf.d/APP_ZARAFAGATEWAY.monitrc", @implode("\n", $f));		
		
	}

//********************************************************************************************************************
	build_progress_restart("{reconfiguring}",36);
	$EnableClamavDaemon=$sock->GET_INFO("EnableClamavDaemon");
	$EnableClamavDaemonForced=$sock->GET_INFO("EnableClamavDaemonForced");
	$CicapEnabled=$sock->GET_INFO("CicapEnabled");
	$SQUIDEnable=$sock->GET_INFO("SQUIDEnable");
	
	if(!is_numeric($EnableClamavDaemon)){$EnableClamavDaemon=0;}
	if(!is_numeric($EnableClamavDaemonForced)){$EnableClamavDaemonForced=0;}
	if(!is_numeric($SQUIDEnable)){$SQUIDEnable=1;}
	if(!is_numeric($CicapEnabled)){$CicapEnabled=0;}
	if($SQUIDEnable==1){if($CicapEnabled==1){$EnableClamavDaemon=1;}}
	if($EnableClamavDaemonForced==1){$EnableClamavDaemon=1;}
//********************************************************************************************************************

	
	
	
	@unlink("/etc/monit/conf.d/ufdb.monitrc");
	@unlink("/etc/monit/conf.d/ufdbweb.monitrc");
	$ufdbbin=$unix->find_program("ufdbguardd");
	build_progress_restart("{reconfiguring}",38);
	if(is_file($ufdbbin)){
		$EnableUfdbGuard=intval($sock->EnableUfdbGuard());
		
		$UseRemoteUfdbguardService=$sock->GET_INFO('UseRemoteUfdbguardService');
		$EnableSquidGuardHTTPService=$sock->GET_INFO("EnableSquidGuardHTTPService");
		$SquidPerformance=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidPerformance"));
		$EnableWebProxyStatsAppliance=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableWebProxyStatsAppliance"));
		$SquidGuardApachePort=$sock->GET_INFO("SquidGuardApachePort");
		$SquidGuardApacheSSLPort=$sock->GET_INFO("SquidGuardApacheSSLPort");
		if(!is_numeric($UseRemoteUfdbguardService)){$UseRemoteUfdbguardService=0;}
		if(!is_numeric($EnableUfdbGuard)){$EnableUfdbGuard=0;}
		if(!is_numeric($EnableSquidGuardHTTPService)){$EnableSquidGuardHTTPService=1;}
		if(!is_numeric($EnableWebProxyStatsAppliance)){$EnableWebProxyStatsAppliance=0;}
		if($EnableUfdbGuard==0){$EnableSquidGuardHTTPService=0;}
		if($EnableWebProxyStatsAppliance==1){$EnableSquidGuardHTTPService=1;}
		if(!is_numeric($SquidGuardApachePort)){$SquidGuardApachePort="9020";}
		if(!is_numeric($SquidGuardApacheSSLPort)){$SquidGuardApacheSSLPort=9025;}
		if($SquidPerformance>2){$EnableSquidGuardHTTPService=0;}
		
		if($SQUIDEnable==1){	
			
			if($EnableSquidGuardHTTPService==1){
				$f=array();
				if(is_file("/etc/init.d/ufdb-http")){
					$SquidGuardApachePort=intval($GLOBALS["CLASS_SOCKETS"]->SET_INFO("SquidGuardApachePort"));
					if($SquidGuardApachePort == 0){ $SquidGuardApachePort=9020;}
					
					$f[]="check process APP_UFDB_HTTP";
					$f[]="with pidfile /var/run/webfilter-http.pid";
					$f[]="start program = \"/etc/init.d/ufdb-http start --monit\"";
					$f[]="stop program =  \"/etc/init.d/ufdb-http stop --monit\"";
					$f[]="if failed host 127.0.0.1 port $SquidGuardApachePort with timeout 15 seconds then restart";
					$f[]="if 5 restarts within 5 cycles then timeout";
					$f[]="";
					if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring Web filtering HTTP service...\n";}
					@file_put_contents("/etc/monit/conf.d/ufdbweb.monitrc", @implode("\n", $f));
				}
				
			}
			
			
		}
	}
	
//********************************************************************************************************************	

	@unlink("/etc/monit/conf.d/APP_LIGHTTPD.monitrc");
	if(!is_file("/usr/local/ArticaWebConsole/sbin/artica-webconsole")){
		$EnableArticaFrontEndToNGninx=$sock->GET_INFO("EnableArticaFrontEndToNGninx");
		$EnableArticaFrontEndToApache=$sock->GET_INFO("EnableArticaFrontEndToApache");
		if(!is_numeric($EnableArticaFrontEndToNGninx)){$EnableArticaFrontEndToNGninx=0;}
		if(!is_numeric($EnableArticaFrontEndToApache)){$EnableArticaFrontEndToApache=0;}
		$EnableNginx=$sock->GET_INFO("EnableNginx");
		$EnableFreeWeb=$sock->GET_INFO("EnableFreeWeb");
		if(!is_numeric($EnableFreeWeb)){$EnableFreeWeb=0;}
		if(!is_numeric($EnableNginx)){$EnableNginx=1;}
		if($EnableNginx==0){$EnableArticaFrontEndToNGninx=0;}
		$pid=null;
		build_progress_restart("{reconfiguring}",39);
		
		if($EnableArticaFrontEndToNGninx==0){			
			$pid="/var/run/lighttpd/lighttpd.pid";
			if($EnableArticaFrontEndToApache==1){$pid="/var/run/artica-apache/apache.pid";}
			$f=array();
			$f[]="check process APP_ARTICAWEBCONSOLE with pidfile $pid";
			$f[]="\tstart program = \"/etc/init.d/artica-webconsole start --monit\"";
			$f[]="\tstop program = \"/etc/init.d/artica-webconsole stop --monit\"";
			$f[]="\tif 5 restarts within 5 cycles then timeout";
			$f[]="";
			if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring Artica Web Console...\n";}
			@file_put_contents("/etc/monit/conf.d/APP_LIGHTTPD.monitrc", @implode("\n", $f));
		}
		//********************************************************************************************************************	
	}	

		
	
	build_progress_restart("{reconfiguring}",40);
	$f=array();
	if(is_file("/etc/init.d/sysklogd")){
		$f[]="check process APP_SYSLOGD with pidfile /var/run/syslogd.pid";
		$f[]="\tstart program = \"/etc/init.d/sysklogd start --monit\"";
		$f[]="\tstop program = \"/etc/init.d/sysklogd stop --monit\"";
		$f[]="\tif 5 restarts within 5 cycles then timeout";
		$f[]="\tcheck file syslogd_file with path /var/log/syslog";
		$f[]="\tif timestamp > 10 minutes then restart";
		$f[]="";
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring sysklogd...\n";}
		@file_put_contents("/etc/monit/conf.d/APP_SYSKLOGD.monitrc", @implode("\n", $f));
	}
	
//********************************************************************************************************************	

build_progress_restart("{reconfiguring}",42);

//********************************************************************************************************************
build_progress_restart("{reconfiguring}",43);
@unlink("/etc/monit/conf.d/APP_DNSMASQ.monitrc");
$f=array();
$binpath=$unix->find_program("dnsmasq");
if(is_file($binpath)){
	$EnableDNSMASQ=$users->EnableDNSMASQ();
	if($EnableDNSMASQ==1){
		$f[]="check process APP_DNSMASQ with pidfile /var/run/dnsmasq.pid";
		$f[]="\tstart program = \"/etc/init.d/dnsmasq start --monit\"";
		$f[]="\tstop program = \"/etc/init.d/dnsmasq stop --monit\"";
		$f[]="\tif 5 restarts within 5 cycles then timeout";
		$f[]="";
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring DNSMasq Service...\n";}
		@file_put_contents("/etc/monit/conf.d/APP_DNSMASQ.monitrc", @implode("\n", $f));
	}
}
//********************************************************************************************************************
build_progress_restart("{reconfiguring}",43);
@unlink("/etc/monit/conf.d/APP_WIFIDOG.monitrc");
$f=array();
$binpath=$unix->find_program("wifidog");
if(is_file($binpath)){
	if(is_file("/etc/init.d/wifidog")){
		$EnableArticaHotSpot=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableArticaHotSpot"));
		if($EnableArticaHotSpot==1){
			$f[]="check process HOTSPOT_SERVICE with pidfile /var/run/wifidog.pid";
			$f[]="\tstart program = \"/etc/init.d/wifidog start\"";
			$f[]="\tstop program = \"/etc/init.d/wifidog stop\"";
			$f[]="\tif 5 restarts within 5 cycles then timeout";
			$f[]="";
			if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring Wifidog Service...\n";}
			@file_put_contents("/etc/monit/conf.d/APP_WIFIDOG.monitrc", @implode("\n", $f));
		}
	}
}
//********************************************************************************************************************	
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} checking syslog\n";}
	if(is_file("/etc/init.d/syslog")){checkDebSyslog();}
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} configuration done\n";}
	shell_exec($GLOBALS["MONIT_CLASS"]->monitor_all_cmdline." 2>&1");
	build_progress_restart("{reconfiguring}",45);
}
function checkDebSyslog(){
	if(!is_file("/etc/rsyslog.conf")){return;}
	$f=file("/etc/init.d/syslog");
	$RSYSLOGD_PIDFILE=null;
	foreach ($f as $index=>$line){
		if(preg_match("#RSYSLOGD_PIDFILE=(.+)#", $line,$re)){
			$RSYSLOGD_PIDFILE=$re[1];
			break;
		}
	}

	$filesize=filesize("/etc/init.d/syslog");
	if($filesize<50){$RSYSLOGD_PIDFILE="/var/run/rsyslogd.pid";}
	if($RSYSLOGD_PIDFILE==null){if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} pidfile `cannot check pid...`\n";return;}}

if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} rsyslog pidfile `$RSYSLOGD_PIDFILE`\n";}

	$f=file("/etc/rsyslog.conf");
	foreach ($f as $index=>$line){
		if(preg_match("#\*\.\*.*?\s+(.+)#", $line,$re)){
			$syslogpath=$re[1];
			if(substr($syslogpath, 0,1)=='-'){$syslogpath=substr($syslogpath, 1,strlen($syslogpath));}
			break;
		}
		 
	}

	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} syslog path `$syslogpath`\n";}
	if(!is_file($syslogpath)){if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} syslog path `$syslogpath` no such file!\n";return;}}

	$f=array();
	$f[]="check process APP_SYSLOGD with pidfile $RSYSLOGD_PIDFILE";
	$f[]="start program = \"/etc/init.d/syslog start --monit\"";
	$f[]="stop program = \"/etc/init.d/syslog stop --monit\"";
	$f[]="if 5 restarts within 5 cycles then timeout";
	@chmod("/etc/init.d/syslog",0755);
	@file_put_contents("/etc/monit/conf.d/APP_RSYSLOGD.monitrc", @implode("\n", $f));
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} /etc/monit/conf.d/APP_RSYSLOGD.monitrc done\n";}
}



function install_service(){
	function amavis(){
		$unix=new unix();
		$php=$unix->LOCATE_PHP5_BIN();
		$monit=$unix->find_program("monit");
	
		if(!is_file($monit)){return;}
	
		$f[]="#!/bin/sh";
		$f[]="### BEGIN INIT INFO";
		$f[]="# Provides:          monit";
		$f[]="# Required-Start:    \$local_fs \$syslog";
		$f[]="# Required-Stop:     \$local_fs \$syslog";
		$f[]="# Should-Start:";
		$f[]="# Should-Stop:";
		$f[]="# Default-Start:     3 4 5";
		$f[]="# Default-Stop:      0 1 6";
		$f[]="# Short-Description: Monitor daemon";
		$f[]="# chkconfig: 2345 11 89";
		$f[]="# description: Extensible, configurable Monitor daemon";
		$f[]="### END INIT INFO";
		$f[]="case \"\$1\" in";
		$f[]=" start)";
		$f[]="   $php ".__FILE__." --start \$2 \$3";
	
		$f[]="	 exit 0";
		$f[]="    ;;";
		$f[]="";
		$f[]="  stop)";
		$f[]="   $php ".__FILE__." --stop \$2 \$3";
		$f[]="    ;;";
		$f[]="";
		$f[]=" restart)";
	
		$f[]="   $php ".__FILE__." --restart \$2 \$3";
		$f[]="	 exit 0";
		$f[]="    ;;";
		$f[]="";
		$f[]=" reload)";
		$f[]="   $php ".__FILE__." --reload \$2 \$3";
		$f[]="	 exit 0";
		$f[]="    ;;";
		$f[]="";
		$f[]="  *)";
		$f[]="    echo \"Usage: \$0 {start|stop|restart} (+ '--verbose' for more infos)\"";
		$f[]="    exit 1";
		$f[]="    ;;";
		$f[]="esac";
		$f[]="exit 0\n";
	
		$INITD_PATH="/etc/init.d/monit";
		echo "amavis: [INFO] Writing $INITD_PATH with new config\n";
		@unlink($INITD_PATH);
		@file_put_contents($INITD_PATH, @implode("\n", $f));
		@chmod($INITD_PATH,0755);
	
		if(is_file('/usr/sbin/update-rc.d')){
			shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
		}
	
		if(is_file('/sbin/chkconfig')){
			shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
			shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
		}
	
	}
}
?>