<?php
$GLOBALS["EnablePostfixMultiInstance"]=0;
include_once(dirname(__FILE__) . '/ressources/class.ldap.inc');
include_once(dirname(__FILE__) . '/ressources/class.user.inc');
include_once(dirname(__FILE__) . '/ressources/class.mysql.inc');
include_once(dirname(__FILE__) . '/ressources/class.maincf.multi.inc');
include_once(dirname(__FILE__) . '/ressources/class.main_cf.inc');
include_once(dirname(__FILE__) . '/ressources/class.main.hashtables.inc');
include_once(dirname(__FILE__) . '/ressources/class.postfix.externaldbs.inc');
include_once(dirname(__FILE__) . '/ressources/class.tcpip.inc');

include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__)."/framework/frame.class.inc");
$GLOBALS["PROGRESS_FILE"]=null;
$GLOBALS["POURC_START"]=0;
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["DEBUG"]=true;$GLOBALS["VERBOSE"]=true;}
if(preg_match("#--reload#",implode(" ",$argv))){$GLOBALS["RELOAD"]=true;}
if(preg_match("#--pourc=([0-9]+)#",implode(" ",$argv),$re)){$GLOBALS["POURC_START"]=$re[1];}
if(preg_match("#--progress-file=(.+?)\s+#",implode(" ",$argv),$re)){$GLOBALS["PROGRESS_FILE"]=$re[1];}



if($GLOBALS["VERBOSE"]){ini_set('html_errors',0);ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);}
$sock=new sockets();
$unix=new unix();
$GLOBALS["EnablePostfixMultiInstance"]=$sock->GET_INFO("EnablePostfixMultiInstance");
if(!is_numeric($GLOBALS["EnablePostfixMultiInstance"])){$GLOBALS["EnablePostfixMultiInstance"]=0;}
$GLOBALS["EnableBlockUsersTroughInternet"]=$sock->GET_INFO("EnableBlockUsersTroughInternet");
$GLOBALS["postconf"]=$unix->find_program("postconf");
$GLOBALS["postmap"]=$unix->find_program("postmap");
$GLOBALS["newaliases"]=$unix->find_program("newaliases");
$GLOBALS["postalias"]=$unix->find_program("postalias");
$GLOBALS["postfix"]=$unix->find_program("postfix");
$GLOBALS["newaliases"]=$unix->find_program("newaliases");
$GLOBALS["virtual_alias_maps"]=array();
$GLOBALS["alias_maps"]=array();
$GLOBALS["bcc_maps"]=array();
$GLOBALS["smtp_generic_maps"]=array();
$GLOBALS["PHP5_BIN"]=$unix->LOCATE_PHP5_BIN();
$GLOBALS["CLASS_UNIX"]=$unix;
if(!is_file($GLOBALS["postfix"])){exit();}
if($argv[1]=="--relay"){
	
	build_relay_domains();
	exit();
}

if($argv[1]=="--relayhost"){
	internal_pid($argv);
    mailbox_transport_maps();
	perso_settings();
	shell_exec("{$GLOBALS["postfix"]} reload >/dev/null 2>&1");
	exit();
}
if($argv[1]=="--restricted-relais"){
	restrict_relay_domains();
	exit();
}
if($argv[1]=="--mailbox-transport-maps"){
	mailbox_transport_maps();
	echo "Starting......: ".date("H:i:s")." Postfix reloading\n";
	shell_exec("{$GLOBALS["postfix"]} reload >/dev/null 2>&1");
	exit();
}

if($argv[1]=="--smtpd-milter-maps"){
	smtpd_milter_maps(true);
	exit;
}
if($argv[1]=="--transport-maps"){
    build_transport_maps();
    exit;
}

start();

function build_progress($text,$pourc){
	if($GLOBALS["POURC_START"]>0){if($pourc<$GLOBALS["POURC_START"]){$pourc=$GLOBALS["POURC_START"];}}
	if($GLOBALS["POURC_START"]>0){if($pourc>95){$pourc=95;}}
	$cachefile="/usr/share/artica-postfix/ressources/logs/web/postfix.transport.progress";
	if($GLOBALS["PROGRESS_FILE"]<>null){$cachefile=$GLOBALS["PROGRESS_FILE"];}
	echo "{$pourc}% $text\n";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($cachefile, serialize($array));
	@chmod($cachefile,0755);

}




function start(){
	$unix=new unix();
	$php5=$unix->LOCATE_PHP5_BIN();
	build_progress("Loading LDAP config",15);
	LoadLDAPDBs();
	build_progress("Loading Transport data",20);
	

	build_progress("Building build_transport_maps",30);
	build_transport_maps();
	build_progress("Building recipient_bcc_maps",31);
	recipient_bcc_maps();
	build_progress("Building smtp_sasl_password_maps",32);
	smtp_sasl_password_maps();
	build_progress("Building sender_bcc_maps",33);
	sender_bcc_maps();
	build_progress("Building smtpd_milter_maps database",34);
	smtpd_milter_maps();
	build_progress("Building Transport database",35);
	build_relay_domains();
	build_progress("Building restrict_relay_domains",40);
	restrict_relay_domains();
	build_progress("Building build_cyrus_lmtp_auth",50);
	build_cyrus_lmtp_auth();
	build_progress("Building relay_recipient_maps_build",55);
	relay_recipient_maps_build();
//	$hashT=new main_hash_table();
//	$hashT->mydestination();
	build_progress("Building mailbox_transport_maps",60);
	mailbox_transport_maps();
	build_progress("Building perso_settings",80);
	perso_settings();
	build_progress("{tls_title}",85);
	system("$php5 /usr/share/artica-postfix/exec.postfix.tls.php");
	
	
	if($GLOBALS["POURC_START"]==0){
		build_progress("{reloading_smtp_service}",90);
		shell_exec("{$GLOBALS["postfix"]} reload >/dev/null 2>&1");
		build_progress("{done}",100);
	}
	
}
function perso_settings(){
	$main=new main_perso();
	$main->replace_conf("/etc/postfix/main.cf");
}
function mailbox_transport_maps(){
	$f=array();
	$DestinationFile="/etc/postfix/mailbox_transport_maps";
	$sql="SELECT * FROM postfix_transport_mailbox WHERE hostname='master'";
	$q=new mysql();
	$results=$q->QUERY_SQL($sql,"artica_backup");
	while($ligne=mysqli_fetch_array($results,MYSQLI_ASSOC)){
		$xType=$ligne["xType"];
		$pattern="lmtp:{$ligne["lmtp_address"]}";
		if($xType==1){

			while (list ($uid, $none) = each ($hash) ){if(trim($uid)==null){continue;}$f[]="$uid\t$pattern";}
			continue;
		}
		$f[]="{$ligne["uid"]}\t$pattern";
	}

	@file_put_contents($DestinationFile,@implode("\n",$f));
	shell_exec("{$GLOBALS["postmap"]} hash:$DestinationFile >/dev/null 2>&1");
	if(count($f)>0){
		shell_exec("{$GLOBALS["postconf"]} -e \"mailbox_transport_maps=hash:$DestinationFile\" >/dev/null 2>&1");
	}else{
		shell_exec("{$GLOBALS["postconf"]} -X \"mailbox_transport_maps\" >/dev/null 2>&1");
	}

}

function smtp_sasl_password_maps(){

	
	$q=new lib_sqlite("/home/artica/SQLITE/postfix.db");
	$sql='SELECT * FROM transport_maps WHERE enabled=1 AND auth=1';
	$results=$q->QUERY_SQL($sql);
	
	if(!$q->ok){echo $q->mysql_error;}
	
	build_progress("Building SMTP Authentication ".count($results)." rows in transport",32);
	
	
	$f=array();
	foreach ($results as $index=>$ligne){
		$nexthope=$ligne["nexthope"];
		$username=$ligne["username"];
		$password=$ligne["password"];
		$f[]="$nexthope\t$username:$password";
	}
	
	if(count($f)==0){
		echo "Starting......: ".date("H:i:s")." 0 smtp password rule(s)\n";
		shell_exec("{$GLOBALS["postconf"]} -X \"smtp_sasl_password_maps\" >/dev/null 2>&1");
		shell_exec("{$GLOBALS["postconf"]} -e \"smtp_sasl_auth_enable=no\" >/dev/null 2>&1");
		return;
	}
	
	echo "Starting......: ".date("H:i:s")." Postfix ". count($f)." smtp password rule(s)\n";
	@file_put_contents("/etc/postfix/smtp_sasl_password",implode("\n",$f));
	shell_exec("{$GLOBALS["postmap"]} hash:/etc/postfix/smtp_sasl_password >/dev/null 2>&1");
	shell_exec("{$GLOBALS["postconf"]} -e \"smtp_sasl_password_maps=hash:/etc/postfix/smtp_sasl_password\" >/dev/null 2>&1");
	shell_exec("{$GLOBALS["postconf"]} -e \"smtp_sasl_auth_enable=yes\" >/dev/null 2>&1");
	CreateEntry("smtp_sasl_mechanism_filter","!gssapi,!login,static:all");
	shell_exec("{$GLOBALS["postconf"]} -e \"smtp_send_dummy_mail_auth=yes\" >/dev/null 2>&1");
	shell_exec("{$GLOBALS["postconf"]} -e \"smtp_sasl_security_options=\" >/dev/null 2>&1");
}

function CreateEntry($key,$value){
	$FOUND=false;
	$f=explode("\n",@file_get_contents("/etc/postfix/main.cf"));
	foreach ($f as $index=>$line){
		if(preg_match("#^$key#i", $line)){
			$FOUND=true;
			$f[$index]="$key = $value";
		}
	}
	
	if(!$FOUND){
		$f[]="$key = $value";
	}
	
	@file_put_contents("/etc/postfix/main.cf", @implode("\n", $f));
	
}


function smtpd_milter_maps_progress($text,$pourc){
	$cachefile="/usr/share/artica-postfix/ressources/logs/smtpd_milter_maps";
	echo "{$pourc}% $text\n";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($cachefile, serialize($array));
	@chmod($cachefile,0755);

}


function smtpd_milter_maps($reload=false){
	$unix=new unix();
	$q=new lib_sqlite("/home/artica/SQLITE/postfix.db");
	$f=array();
	$results=$q->QUERY_SQL("SELECT * FROM smtpd_milter_maps WHERE enabled=1 ORDER BY pattern");
	$IpClass=new IP();
	$f[]="127.0.0.0/8\tDISABLE";
	smtpd_milter_maps_progress("{configuring}",50);
	foreach ($results as $index=>$ligne){
		if(!$IpClass->isIPAddressOrRange($ligne["pattern"])){continue;}
		$f[]=$ligne["pattern"]."\tDISABLE";
		smtpd_milter_maps_progress("{configuring} {$ligne["pattern"]}",55);
	}
	
	@file_put_contents("/etc/postfix/smtpd_milter_maps.cdir", @implode("\n", $f));
	
	shell_exec("{$GLOBALS["postconf"]} -e \"smtpd_milter_maps=cidr:/etc/postfix/smtpd_milter_maps.cdir\"");
	
	if($reload){
		$postfix=$unix->find_program("postfix");
		smtpd_milter_maps_progress("{reloading}",95);
		system("$postfix reload");
	}
	smtpd_milter_maps_progress("{done}",100);
}


function relay_recipient_maps_build(){
	$relay_recipient_maps=array();
	$ActiveDirectoryConnections=unserialize($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ActiveDirectoryConnections"));
	
	if(count($ActiveDirectoryConnections)>0){
		while (list ($index, $HASH) = each ($ActiveDirectoryConnections) ){
			$x=array();
			$name=$HASH["NAME"];
			$host=$HASH["LDAP_SERVER"];
			$port=$HASH["LDAP_PORT"];
			$suffix=$HASH["LDAP_SUFFIX"];
			$user="{$HASH["LDAP_DN"]}@{$HASH["LDAP_DOMAIN"]}";
			$password=$HASH["LDAP_PASSWORD"];
			$x[]="server_host     = $host";
			$x[]="server_port     = $port";
			$x[]="version         = 3";
			$x[]="bind            = yes";
			$x[]="start_tls       = no";
			$x[]="bind_dn         = $user";
			$x[]="bind_pw         = $password";
			$x[]="search_base     = $suffix";
			$x[]="scope           = sub";
			$x[]="query_filter    = (proxyAddresses=%s)";
			$x[]="result_attribute= mail";
			$x[]="debuglevel      = 0";
			$x[]="";
			$relay_recipient_maps[]="proxy:ldap:/etc/postfix/ActiveDirectory{$index}.cf";
			@file_put_contents("/etc/postfix/relay_recipient_maps_{$index}.cf", @implode("\n", $x));
		}
	
	
	}
	
	if(count($relay_recipient_maps)>0){
		$relay_recipient_maps_text=@implode(",", $relay_recipient_maps);
		shell_exec("{$GLOBALS["postconf"]} -e \"relay_recipient_maps=$relay_recipient_maps_text\" >/dev/null 2>&1");
		
	}
	
	
	shell_exec("{$GLOBALS["postconf"]} -X \"relay_recipient_maps\" >/dev/null 2>&1");
}

function build_cyrus_lmtp_auth(){
	$users=new usersMenus();
	$disable=false;
	if($users->ZABBIX_INSTALLED){$disable=true;}else{
		if(!$users->cyrus_imapd_installed){$disable=true;}
	}

	if($disable){
		shell_exec("{$GLOBALS["postconf"]} -e \"lmtp_sasl_auth_enable=no\" >/dev/null 2>&1");
		shell_exec("{$GLOBALS["postconf"]} -X \"lmtp_sasl_password_maps\" >/dev/null 2>&1");
		shell_exec("{$GLOBALS["postconf"]} -X \"lmtp_sasl_security_options\" >/dev/null 2>&1");
		return;
	}


	$sock=new sockets();
	$page=CurrentPageName();
	$CyrusEnableLMTPUnix=$sock->GET_INFO("CyrusEnableLMTPUnix");
	if($CyrusEnableLMTPUnix==1){
		shell_exec("{$GLOBALS["postconf"]} -e \"lmtp_sasl_auth_enable=no\" >/dev/null 2>&1");
		shell_exec("{$GLOBALS["postconf"]} -X \"lmtp_sasl_password_maps\" >/dev/null 2>&1");
		shell_exec("{$GLOBALS["postconf"]} -X \"lmtp_sasl_security_options\" >/dev/null 2>&1");
	}else{
		$ldap=new clladp();
		$CyrusLMTPListen=trim($sock->GET_INFO("CyrusLMTPListen"));
		$cyruspass=$ldap->CyrusPassword();
		if($CyrusLMTPListen==null){return;}
		@file_put_contents("/etc/postfix/lmtpauth","$CyrusLMTPListen\tcyrus:$cyruspass");
		shell_exec("{$GLOBALS["postmap"]} hash:/etc/postfix/lmtpauth >/dev/null 2>&1");
		shell_exec("{$GLOBALS["postconf"]} -e \"lmtp_sasl_auth_enable=yes\" >/dev/null 2>&1");
		shell_exec("{$GLOBALS["postconf"]} -e \"lmtp_sasl_password_maps=hash:/etc/postfix/lmtpauth\" >/dev/null 2>&1");
		shell_exec("{$GLOBALS["postconf"]} -e \"lmtp_sasl_mechanism_filter=plain,login\" >/dev/null 2>&1");
		shell_exec("{$GLOBALS["postconf"]} -X \"lmtp_sasl_security_options\" >/dev/null 2>&1");
	}

}

function restrict_relay_domains(){
	echo "Starting......: ".date("H:i:s")." ".__FUNCTION__."\n";
	
	$q=new lib_sqlite("/home/artica/SQLITE/postfix.db");
	$f=array();

	$results=$q->QUERY_SQL("SELECT * FROM transport_maps WHERE direction=0 AND enabled=1 ORDER BY addr");
	if(count($results)>0){
	    foreach ($results as $num=>$ligne) {
            $OtherDomains = unserialize(base64_decode($ligne["OtherDomains"]));
            $OtherDomains[$ligne["addr"]] = true;
            foreach ($OtherDomains as $item => $none) {
                if (strpos("  $item", "#") > 0) { continue; }
                $item = trim($item);
                $MDOMAINS[strtolower($item)] = true;
            }
        }

	}
	$results=$q->QUERY_SQL("SELECT domainname FROM relay_domains_restricted");
	if(!$q->ok){echo "Starting......: ".date("H:i:s")." ".__FUNCTION__." ". $q->mysql_error."\n";} 
	echo "Starting......: ".date("H:i:s")." ".__FUNCTION__." ". count($results)." item(s)\n";
	if(count($results)>0){
		foreach ($results as $num=>$ligne){
			$domain=trim(strtolower($ligne["domainname"]));
			if($domain==null){continue;}
			if(preg_match("#^@(.+)#",$domain,$re)){$domain=$re[1];}
			if(!isset($MDOMAINS[$domain])){echo "Starting......: ".date("H:i:s")." ".__FUNCTION__." Not found $domain, aborting\n";continue;}
			$f[]="$domain\tartica_restrict_relay_domains";
			echo "Starting......: ".date("H:i:s")." ".__FUNCTION__." Restricted \"$domain\"\n";
		}
	}
	
	@file_put_contents("/etc/postfix/relay_domains_restricted",implode("\n",$f));
	shell_exec("{$GLOBALS["postmap"]} hash:/etc/postfix/relay_domains_restricted >/dev/null 2>&1");

}


function build_relay_domains(){
	
	$q=new lib_sqlite("/home/artica/SQLITE/postfix.db");
	echo "------------- RELAY DOMAINS -------------\n";
	$results=$q->QUERY_SQL("SELECT * FROM transport_maps WHERE direction=0 AND enabled=1 ORDER BY addr");
	if(!$q->ok){
		echo "*** RELAY DOMAINS: MYSQL ERROR $q->mysql_error ***\n";
	}
    $array=array();
	if(count($results)>0){
		foreach ($results as $num=>$ligne){
            $service=$ligne["service"];
            $OtherDomains = unserialize(base64_decode($ligne["OtherDomains"]));
            $OtherDomains[$ligne["addr"]] = true;
            foreach ($OtherDomains as $item => $none) {
                if (strpos("  $item", "#") > 0) {continue; }
                if (strpos($item, "@") > 0) { continue; }
                echo "RELAY Domain: $item $service\n";
                $array[] = "$item\tOK";
            }
		}
	}
	if(count($array)==0){
		shell_exec("{$GLOBALS["postconf"]} -X \"relay_domains\"");
		return;
	}
	$cmd="{$GLOBALS["postconf"]} -e \"relay_domains=hash:/etc/postfix/relay_domains\" >/dev/null 2>&1";
	echo $cmd."\n";
	shell_exec($cmd);
	@file_put_contents("/etc/postfix/relay_domains",implode("\n",$array));
	shell_exec("{$GLOBALS["postmap"]} hash:/etc/postfix/relay_domains >/dev/null 2>&1");

}




function build_transport_maps(){
	
	$main=new maincf_multi("master","master");
	$main->bann_destination_domains();
	$users=new usersMenus();
	$CountDeMailMan=0;

	$q=new lib_sqlite("/home/artica/SQLITE/postfix.db");

	echo "------------- TRANSPORT MAPS INBOUND-------------\n";
	$results=$q->QUERY_SQL("SELECT * FROM transport_maps WHERE direction=0 AND service='smtp' AND enabled=1 ORDER BY addr");
	if(!$q->ok){
		echo "*** MYSQL ERROR $q->mysql_error ***\n";
	}
	if(count($results)>0){
		foreach ($results as $num=>$ligne){
			$service=$ligne["service"];
			$nexthope=$ligne["nexthope"];
			$nextport=$ligne["nextport"];
            $OtherDomains = unserialize(base64_decode($ligne["OtherDomains"]));
            $OtherDomains[$ligne["addr"]] = true;
            foreach ($OtherDomains as $item => $none) {
                if (strpos("  $item", "#") > 0) { continue; }
                echo "$item -> $service $nexthope:$nextport\n";

                if ($service == "error") {
                    $array[] = "$item\t$service:";
                    continue;
                }
                $array[] = "$item\t$service:$nexthope:$nextport";
            }
		
		}
	}
	
	echo "------------- TRANSPORT MAPS INBOUND -------------\n";
	$results=$q->QUERY_SQL("SELECT * FROM transport_maps WHERE direction=0 AND service='error' AND enabled=1 ORDER BY addr");
	if(count($results)>0){
		foreach ($results as $num=>$ligne){
			$service=$ligne["service"];
            $OtherDomains = unserialize(base64_decode($ligne["OtherDomains"]));
            $OtherDomains[$ligne["addr"]] = true;
            foreach ($OtherDomains as $item => $none) {
                if (strpos("  $item", "#") > 0) {
                    continue;
                }
                $array[] = "$item\t$service:";
            }
		
		}
	}
	
	$EnableMail2SMS=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableMail2SMS"));
	if($EnableMail2SMS==1){
	    $mail2smsRcpt=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("mail2smsRcpt"));
	    if($mail2smsRcpt<>null){
            $mail2smsRcpts=explode(",",$mail2smsRcpt);
            foreach ($mail2smsRcpts as $addr){
                $array[] = "$addr\tmail2sms:";

            }

        }

    }



	echo "Starting......: ".date("H:i:s")." ".__FUNCTION__." ". count($array)." routings rules\n";

	if($users->MAILMAN_INSTALLED){shell_exec("{$GLOBALS["postconf"]} -e \"mailman_destination_recipient_limit = 1\" >/dev/null 2>&1");}
	@file_put_contents("/etc/postfix/transport",implode("\n",$array));
	shell_exec("{$GLOBALS["postmap"]} hash:/etc/postfix/transport >/dev/null 2>&1");
	shell_exec("{$GLOBALS["postconf"]} -e \"transport_maps=hash:/etc/postfix/transport\" >/dev/null 2>&1");
	sender_dependent_relayhost_maps();
}

function sender_dependent_relayhost_maps(){
    $func=__FUNCTION__.": ";
if(!isset($GLOBALS["postconf"])){
    $unix=new unix();
    $GLOBALS["postconf"]=$unix->find_program("postconf");
}
    echo " * * * * $func * * * *\n";
    $ipclass=new IP();
	$q=new lib_sqlite("/home/artica/SQLITE/postfix.db");

	$relayhost=null;
	
	$results=$q->QUERY_SQL("SELECT * FROM transport_maps WHERE direction=1 AND service='smtp' AND enabled=1 ORDER BY addr");
	
	foreach ($results as $num=>$ligne){
		$service=$ligne["service"];
		$nexthope=$ligne["nexthope"];
		$nextport=$ligne["nextport"];
        $OtherDomains = unserialize(base64_decode($ligne["OtherDomains"]));
        $OtherDomains[$ligne["addr"]] = true;
        foreach ($OtherDomains as $item => $none) {
            if (strpos("  $item", "#") > 0) {
                continue;
            }
            if ($item == null) {
                continue;
            }
            if ($item == "*") {
                $relayhost = "$service:$nexthope:$nextport";
                continue;
            }

            if ($service == "error") {
                $GLOBALS["transport_maps_AT"][$item] = "$service:";
                continue;
            }
            $array[] = "$item\t$service:$nexthope:$nextport";
        }
	
	}
	$results=$q->QUERY_SQL("SELECT * FROM transport_maps WHERE direction=1 AND service='error' AND enabled=1 ORDER BY addr");
	
	foreach ($results as $num=>$ligne){
		$service=$ligne["service"];
        $OtherDomains = unserialize(base64_decode($ligne["OtherDomains"]));
        $OtherDomains[$ligne["addr"]] = true;
        foreach ($OtherDomains as $item => $none) {
            if (strpos("  $item", "#") > 0) {
                continue;
            }
            $array[] = "$item\t$service:";
        }
	
	}
    echo "Starting......: ".date("H:i:s")."$func relayhost=$relayhost\n";
	if($relayhost<>null){
        echo "Starting......: ".date("H:i:s")."$func {$GLOBALS["postconf"]} -e \"relayhost=$relayhost\" >/dev/null 2>&1\n";
        shell_exec("{$GLOBALS["postconf"]} -e \"relayhost=$relayhost\" >/dev/null 2>&1");
        shell_exec("{$GLOBALS["postconf"]} -e \"default_transport=$relayhost\" >/dev/null 2>&1");
    }else{
        shell_exec("{$GLOBALS["postconf"]} -X \"relayhost\" >/dev/null 2>&1");
        shell_exec("{$GLOBALS["postconf"]} -e \"default_transport=smtp\" >/dev/null 2>&1");
    }
	
	
	if(!is_array($array)){
		echo "Starting......: ".date("H:i:s")."$func 0 sender dependent relayhost rule(s)\n";
		shell_exec("{$GLOBALS["postconf"]} -X \"sender_dependent_relayhost_maps\" >/dev/null 2>&1");
		return;
	}

	echo "Starting......: ".date("H:i:s")."$func". count($array)." sender dependent relayhost rule(s)\n";
	@file_put_contents("/etc/postfix/sender_dependent_relayhost",implode("\n",$array)."\n");
	shell_exec("{$GLOBALS["postmap"]} hash:/etc/postfix/sender_dependent_relayhost >/dev/null 2>&1");
	shell_exec("{$GLOBALS["postconf"]} -e \"sender_dependent_relayhost_maps=hash:/etc/postfix/sender_dependent_relayhost\" >/dev/null 2>&1");
	
}

function sender_bcc_maps(){
	$q=new lib_sqlite("/home/artica/SQLITE/postfix.db");

	
	$results=$q->QUERY_SQL("SELECT * FROM transport_maps WHERE direction=1 AND service='BCC' AND enabled=1 ORDER BY addr");
	
	foreach ($results as $num=>$ligne){
		$nexthope=$ligne["nexthope"];
        $OtherDomains = unserialize(base64_decode($ligne["OtherDomains"]));
        $OtherDomains[$ligne["addr"]] = true;
        foreach ($OtherDomains as $item => $none) {
            if (strpos("  $item", "#") > 0) {
                continue;
            }
            $array[] = "$item\t$nexthope";
        }
	
	}
	if(count($array)==0){
		system("{$GLOBALS["postconf"]} -X \"sender_bcc_maps\" >/dev/null 2>&1");
		return;
	}
	
	echo "Starting......: ".date("H:i:s")." ".__FUNCTION__." ". count($array)." sender dependent relayhost rule(s)\n";
	@file_put_contents("/etc/postfix/sender_bcc_maps",implode("\n",$array)."\n");
	shell_exec("{$GLOBALS["postmap"]} hash:/etc/postfix/sender_bcc_maps >/dev/null 2>&1");
	shell_exec("{$GLOBALS["postmap"]} hash:/etc/postfix/sender_bcc_maps >/dev/null 2>&1");
	shell_exec("{$GLOBALS["postconf"]} -e \"sender_bcc_maps=hash:/etc/postfix/sender_bcc_maps\" >/dev/null 2>&1");
}


function recipient_bcc_maps(){
	$q=new lib_sqlite("/home/artica/SQLITE/postfix.db");
	
	$results=$q->QUERY_SQL("SELECT * FROM transport_maps WHERE direction=0 AND service='BCC' AND enabled=1 ORDER BY addr");
	
	foreach ($results as $num=>$ligne){
		$nexthope=$ligne["nexthope"];
        $OtherDomains = unserialize(base64_decode($ligne["OtherDomains"]));
        $OtherDomains[$ligne["addr"]] = true;
        foreach ($OtherDomains as $item => $none) {
            if (strpos("  $item", "#") > 0) {
                continue;
            }
            $array[] = "$item\t$nexthope";
        }
	
	}
	if(count($array)==0){
		system("{$GLOBALS["postconf"]} -X \"recipient_bcc_maps\" >/dev/null 2>&1");
		return;
	}
	
	echo "Starting......: ".date("H:i:s")." ".__FUNCTION__." ". count($array)." sender dependent relayhost rule(s)\n";
	@file_put_contents("/etc/postfix/recipient_bcc_maps",implode("\n",$array)."\n");
	shell_exec("{$GLOBALS["postmap"]} hash:/etc/postfix/recipient_bcc_maps >/dev/null 2>&1");
	shell_exec("{$GLOBALS["postconf"]} -e \"recipient_bcc_maps=hash:/etc/postfix/recipient_bcc_maps\" >/dev/null 2>&1");
	
	
}



function LoadLDAPDBs(){
	if(isset($GLOBALS["LoadLDAPDBs_performed"])){return ;}
	$main=new maincf_multi("master","master");
	$databases_list=unserialize(base64_decode($main->GET_BIGDATA("ActiveDirectoryDBS")));
	if(is_array($databases_list)){
		while (list ($dbindex, $array) = each ($databases_list) ){
			if($GLOBALS["DEBUG"]){echo __FUNCTION__."::LDAP:: {$array["database_type"]}; enabled={$array["enabled"]}\n";}
			if($array["enabled"]<>1){
				if($GLOBALS["DEBUG"]){echo __FUNCTION__."::LDAP:: {$array["database_type"]} is not enabled, skipping\n";}
				continue;
			}
			$targeted_file=$main->buidLdapDB("master",$dbindex,$array);
			if(!is_file($targeted_file)){
				if($GLOBALS["DEBUG"]){echo __FUNCTION__."::LDAP:: {$array["database_type"]} \"$targeted_file\" no such file, skipping\n";}
				continue;
			}
				
				
			//$GLOBALS["REMOTE_SMTP_LDAPDB_ROUTING"]

			if($array["resolv_domains"]==1){$domains=$main->buidLdapDBDomains($array);}
				
			$GLOBALS["LDAPDBS"][$array["database_type"]][]="ldap:$targeted_file";
			if($GLOBALS["DEBUG"]){echo __FUNCTION__."::LDAP:: GLOBALS[LDAPDBS][{$array["database_type"]}]=ldap:$targeted_file\n";}
		}
	}
	$GLOBALS["LoadLDAPDBs_performed"]=true;
}