<?php
$GLOBALS["PROXY_PAC_DEBUG"]=0;
//ini_set('display_errors', 1);	ini_set('html_errors',0);ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);
$GLOBALS["KAV4PROXY_NOSESSION"]=true;
$GLOBALS["TITLENAME"]="Dynamic Proxy PAC";
LoadIncludes();


if($argv[1]=="--build"){build();exit;}

proxy_pac();

function LoadIncludes(){
	include_once(dirname(__FILE__)."/ressources/class.user.inc");
	include_once(dirname(__FILE__)."/ressources/class.groups.inc");
	include_once(dirname(__FILE__)."/ressources/class.ldap.inc");
	include_once(dirname(__FILE__)."/ressources/class.system.network.inc");
	include_once(dirname(__FILE__)."/ressources/class.dansguardian.inc");
	include_once(dirname(__FILE__)."/ressources/class.squid.inc");
	include_once(dirname(__FILE__)."/ressources/class.mysql.inc");
	include_once(dirname(__FILE__)."/ressources/class.os.system.inc");
	include_once(dirname(__FILE__)."/ressources/class.tcpip.inc");	
	include_once(dirname(__FILE__)."/ressources/class.familysites.inc");	
	include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
	include_once(dirname(__FILE__).'/framework/frame.class.inc');
	include_once(dirname(__FILE__).'/framework/class.settings.inc');
	include_once(dirname(__FILE__).'/ressources/class.templates.inc'); 
	include_once(dirname(__FILE__)."/ressources/class.os.system.tools.inc");
}


function build(){
	$unix=new unix();
	
	$rm=$unix->find_program("rm");
	if(is_dir("/home/squid/proxy_pac_rules")){
		build_progress("Removing old configuration....",10);
		system("$rm -rf /home/squid/proxy_pac_rules/*");
	}else{
		@mkdir("/home/squid/proxy_pac_rules",0755,true);
	}
	
	
	build_progress("{configuring}",20);
	proxy_pac();
	build_progress("{restarting_service}",50);
	system("/etc/init.d/proxy-pac restart");
	$pid=PID_NUM();
	
	if(!$unix->process_exists($pid)){
		build_progress("{restarting_service} {failed}",110);
		return;
	}
	build_progress("{configuring} {success}",100);
	
}
function build_progress($text="Unknown",$pourc){
	$GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/web/autoconfiguration.apply.progress";
	echo "{$pourc}% $text\n";
	$array=array();
	$cachefile=$GLOBALS["CACHEFILE"];
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($cachefile, serialize($array));
	@chmod($cachefile,0755);

}
function PID_NUM(){

	$unix=new unix();
	$pid=$unix->get_pid_from_file("/var/run/proxy-pac/http-server.pid");
	if($unix->process_exists($pid)){
		return $pid;
	}

	return $unix->PIDOF_PATTERN("/usr/share/artica-postfix/proxy-pac.py");

}


function proxy_pac(){
	LoadIncludes();
	$sock=new sockets();
	$unix=new unix();
	$q=new lib_sqlite("/home/artica/SQLITE/acls.db");

    if(!$q->FIELD_EXISTS("wpad_rules", "NomadeMode")){
        $q->QUERY_SQL("ALTER TABLE `wpad_rules` ADD `NomadeMode`  INTEGER DEFAULT '0'");
    }
    if(!$q->FIELD_EXISTS("wpad_rules", "NomadeResolve")){
        $q->QUERY_SQL("ALTER TABLE `wpad_rules` ADD `NomadeResolve`  TEXT DEFAULT ''");
    }

	$sql="SELECT * FROM wpad_rules WHERE enabled=1 ORDER BY zorder";
	$results = $q->QUERY_SQL($sql);
	if(count($results)==0){exit();}
	$DenyDnsResolve=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DenyDnsResolve"));
	
	if(!is_file("/etc/init.d/proxy-pac")){
		build_progress("{install_service}",20);
		$php=$unix->LOCATE_PHP5_BIN();
		system("$php /usr/share/artica-postfix/exec.squid.autoconfig.php --install-service");
		
	}
    @mkdir("/home/squid/proxy_pac_rules");
    $f=array();
    $f[]="function FindProxyForURL(url, host) {";
    $f[]="return \"DIRECT\";";
    $f[]="}";
    @file_put_contents("/home/squid/proxy_pac_rules/default.pac",@implode("\n",$f));
    $f=array();

	foreach($results as $index=>$ligne) {
		
		$rulename=$ligne["rulename"];
		build_progress("{configuring} $rulename",30);
		echo "[PAC]: Rule: $rulename\n";
		$FinishbyDirect=$ligne["FinishbyDirect"];
		$NomadeMode=intval($ligne["NomadeMode"]);
		$NomadeResolve=trim($ligne["NomadeResolve"]);
		$ID=$ligne["ID"];

		$MAIN_RULES[]="$ID|$rulename";
		@mkdir("/home/squid/proxy_pac_rules/$ID",0755,true);
		client_matches($ID);
        pac_except($ID);
		
		
		
		$f=array();
		$f[]="function FindProxyForURL(url, host) {";
		$f[]="\turl = url.toLowerCase();";
		$f[]="\thost = host.toLowerCase();";

		if($NomadeMode==1){
		    if($NomadeResolve<>null){
                $f[]="\tif( !isResolvable(\"$NomadeResolve\") ){";
                $f[]="\t\treturn \"DIRECT\";";
                $f[]="\t}";
            }
        }

		if($DenyDnsResolve==0){
			$f[]="\tvar hostIP = dnsResolve(host);";
		}else{
			$f[]="\tvar hostIP = host;";
		}
		$f[]="\tvar myip=myIpAddress();";
		$f[]="\tvar DestPort=GetPort(url);";
		$f[]="\tvar PROTO='';";
		
		$f[]="\tif (url.substring(0, 5) == 'http:' ){ PROTO='HTTP'; }";
		$f[]="\tif (url.substring(0, 6) == 'https:' ){ PROTO='HTTPS'; }";
		$f[]="\tif (url.substring(0, 4) == 'ftp:' ){ PROTO='FTP'; }";
        $f[]="";
        $f[]="\tif(ForceProxies(DestPort,hostIP,host)){";
        $f[]="\t\t".build_proxies($ID,0);
        $f[]="\t}";
        $f[]="// Rule: $rulename";
		$f[]=build_whitelist($ID);
		$f[]=build_subrules($ID);
		$f[]=build_proxies($ID,$FinishbyDirect);
		$f[]="}\r\n";
		$f[]=build_forced($ID);
		$f[]="function GetPort(TestURL){";
		$f[]="\tTestURLRegex = /^[^:]*\:\/\/([^\/]*).*/;";
		$f[]="\tTestURLMatch = TestURL.replace(TestURLRegex, \"$1\");";
		$f[]="\tTestURLLower = TestURLMatch.toLowerCase();";
		$f[]="\tTestURLLowerRegex = /^([^\.]*)[^\:]*(.*)/;";
		$f[]="\tNewPort=TestURLLower.replace(TestURLLowerRegex, \"$2\");";
		$f[]="\tif (NewPort === \"\"){";
		$f[]="\t\tNewPort=\":80\";";
		$f[]="\t}";
		$f[]="\treturn NewPort;";
		$f[]="}";
		$f[]="\r\n\r\n";
		
		$script=@implode("\r\n", $f);
		echo "[PAC]: Rule: $ID/proxy.pac ".strlen($script)." Bytes\n";
		@file_put_contents("/home/squid/proxy_pac_rules/$ID/proxy.pac",$script);
		$script=null;
		$f=array();
	}
	
	@file_put_contents("/home/squid/proxy_pac_rules/rules.conf", @implode("\n", $MAIN_RULES));

	
}

function pac_file_time_min($path){
	$last_modified=0;

	if(is_dir($path)){return 10000;}
	if(!is_file($path)){return 100000;}
		
	$data1 = filemtime($path);
	$data2 = time();
	$difference = ($data2 - $data1);
	$results=intval(round($difference/60));
	if($results<0){$results=1;}
	return $results;
}

function build_subrules($ID){
	$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
	$sql="SELECT * FROM wpad_destination_rules WHERE aclid=$ID ORDER BY zorder";
	$results = $q->QUERY_SQL($sql);
	if(!$q->ok){return;}
	$f[]="";
	$f[]="// build_subrules($ID)";
	
	
	foreach($results as $index=>$ligne) {
		$destinations=array();
		$values=array();
		$value=trim($ligne["value"]);
		if($value==null){continue;}
		$xtype=$ligne["xtype"];
		
		$CarriageReturn=strpos($value, "\n");
		$f[]="// Carriage return = $CarriageReturn [".__LINE__."]";
		
		if($CarriageReturn==0){
			$f[]="// Carriage source = $value [".__LINE__."]";
			$values[]=$value;
		}else{
			$explode=explode("\n", $value);
			while (list ($num, $Linz) = each ($explode) ){
				$Linz=trim($Linz);
				if($Linz==null){continue;}
				$values[]=$Linz;
			}
			$f[]="// Carriage sources = ".count($values)." items [".__LINE__."]";
		}
		
		$value=trim($ligne["destinations"]);
		if($value<>null){
			$CarriageReturn=strpos($value, "\n");
			if($CarriageReturn==0){
				$value=trim($value);
				if(!preg_match("#^PROXY#", $value)){$value="PROXY $value";}
				$destinations[]=$value;
				$f[]="// Carriage return Proxy = $value [".__LINE__."]";
			}else{
			
				$explode=explode("\n", $value);
				while (list ($num, $destline) = each ($explode) ){
					$destline=trim($destline);
					if($destline==null){continue;}
					if(!preg_match("#^PROXY#", $destline)){$destline="PROXY $destline";}
					$destinations[]=$destline;
				}
			}
			
			
			
		}
	
		if(count($destinations)==0){$destinations_final="DIRECT";}
		if(count($destinations)>0){$destinations_final=@implode("; ", $destinations);}

		if($xtype=="shExpMatchRegex"){
			foreach ($values as $num=>$pattern){
				$f[]="\tif( url.match( /$pattern/i ) ){ return \"$destinations_final\"; }";
				$f[]="\tif( host.match( /$pattern/i ) ){ return \"$destinations_final\"; }";
			}
			continue;
		}
			
		if($xtype=="shExpMatch"){
			foreach ($values as $num=>$pattern){
				$f[]="\tif( shExpMatch( url,\"$pattern\" ) ){ return \"$destinations_final\"; }";
				$f[]="\tif( shExpMatch( host,\"$pattern\" ) ){ return \"$destinations_final\"; }";
			}
			continue;
		}
		
		if($xtype=="isInNetMyIP"){
			foreach ($values as $num=>$pattern){
				$xt=explode("-",$pattern);
				$xt[0]=trim($xt[0]);
				$xt[1]=trim($xt[1]);
				if($xt[1]==null){$xt[1]="255.255.255.0";}
				$f[]="\tif( isInNet( myip, \"{$xt[0]}\", \"{$xt[1]}\") ){ return \"$destinations_final\"; }";
			}
			continue;
		}	

		if($xtype=="isInNet"){
			foreach ($values as $num=>$pattern){
				$xt=explode("-",$pattern);
				$xt[0]=trim($xt[0]);
				$xt[1]=trim($xt[1]);
				if($xt[1]==null){$xt[1]="255.255.255.0";}
				$f[]="\tif( isInNet( hostIP, \"{$xt[0]}\", \"{$xt[1]}\") ){ return \"$destinations_final\"; }";
			}
			continue;
		}		

	
	}
	
	return @implode("\r\n\r\n", $f);
	
}
function pac_except($ID)
{
    $q = new lib_sqlite("/home/artica/SQLITE/acls.db");
    $f = array();
    $results = $q->QUERY_SQL("SELECT *  FROM pac_except WHERE ruleid=$ID");
    @mkdir("/home/squid/proxy_pac_rules/$ID", 0755, true);

    foreach ($results as $index => $ligne) {
        $pattern = trim($ligne["pattern"]);
        if ($pattern == null) {
            continue;
        }
        $type = $ligne["type"];
        $f[] = "$type yes $pattern";
    }

    @file_put_contents("/home/squid/proxy_pac_rules/$ID/Except.rules", @implode("\n", $f));

}


function client_matches($ID){
	$q      = new lib_sqlite("/home/artica/SQLITE/acls.db");
	$f      = array();
	$sql    = "SELECT wpad_sources_link.gpid,wpad_sources_link.negation,wpad_sources_link.zmd5 as mkey,
	wpad_sources_link.zorder,
	webfilters_sqgroups.*
	FROM wpad_sources_link,webfilters_sqgroups
	WHERE wpad_sources_link.gpid=webfilters_sqgroups.ID
	AND wpad_sources_link.aclid=$ID
	AND webfilters_sqgroups.enabled=1
	ORDER BY wpad_sources_link.zorder";
	
	@mkdir("/home/squid/proxy_pac_rules/$ID",0755,true);
	$results = $q->QUERY_SQL($sql);
	if(!$q->ok){writelogs("$ID $q->mysql_error",__FUNCTION__,__FILE__,__LINE__);return false;}
	if(count($results)==0){return false;}
	
	foreach($results as $index=>$ligne) {
		$gpid=$ligne["gpid"];
		$not="Yes";
		$matches=false;
		$GroupName=$ligne["GroupName"];
		$negation=$ligne["negation"];
		if($negation==1){$not="No";}
		echo "Rule.$ID: {$ligne["GroupType"]} ($GroupName):$negation\n";
		
		
		if($ligne["GroupType"]=="dstdomain"){
			$f[]="dstdomain $not null";
			continue;
		}
		
		
		if($ligne["GroupType"]=="all"){
				$f[]="all $not null";
			continue;
		}


		if($ligne["GroupType"]=="srcproxy") {
            $f=matches_proxysrc($gpid, $not, $f);
            continue;
        }

		
		if($ligne["GroupType"]=="browser"){
			$f=matches_browser($gpid,$not,$f);
			continue;
		}
		if($ligne["GroupType"]=="srcdomain"){
			$f=matches_srcdomain($gpid,$not,$f);
			continue;
		}
		
		if($ligne["GroupType"]=="src"){
			$f=matches_src($gpid,$not,$f);
			continue;
		}	

		if($ligne["GroupType"]=="time"){
			//$f=matches_time($gpid,$negation,$f);
			continue;
			
		}		
	
	
	}	
	
	@file_put_contents("/home/squid/proxy_pac_rules/$ID/Sources.rules", @implode("\n", $f));


	$unix=new unix();
    @file_put_contents("/home/squid/proxy_pac_rules/myhostname",$unix->hostname_g());
    $IPADDRS=$unix->NETWORK_ALL_INTERFACES(true);
    foreach ($IPADDRS as $ipaddr=>$none){
        $tt[]=$ipaddr;

    }
    @file_put_contents("/home/squid/proxy_pac_rules/myips",@implode("\n",$tt));

}


function matches_browser($gpid,$negation,$f){
	$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
	$HTTP_USER_AGENT=$_SERVER["HTTP_USER_AGENT"];
	$sql="SELECT pattern FROM webfilters_sqitems WHERE gpid=$gpid AND enabled=1";
	$results = $q->QUERY_SQL($sql);
	if(!$q->ok){writelogs("$gpid $q->mysql_error",__FUNCTION__,__FILE__,__LINE__);return $f;}
	if(count($results)==0){return $f;}
	
	foreach($results as $index=>$ligne) {
			$f[]="browser $negation {$ligne["pattern"]}";
	}
	
	return $f;
}
function matches_proxysrc($gpid,$negation,$f){
    $q=new lib_sqlite("/home/artica/SQLITE/acls.db");
    $sql="SELECT pattern FROM webfilters_sqitems WHERE gpid=$gpid AND enabled=1";
    $results = $q->QUERY_SQL($sql);
    if(!$q->ok){writelogs("$gpid $q->mysql_error",__FUNCTION__,__FILE__,__LINE__);return $f;}
    if(count($results)==0){return $f;}

    foreach($results as $index=>$ligne) {
        $f[]="srcproxy $negation {$ligne["pattern"]}";
    }

    return $f;
}

function matches_srcdomain($gpid,$negation,$f){
	$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
	$TO_MATCH=$GLOBALS["HOSTNAME"];
	$sql="SELECT pattern FROM webfilters_sqitems WHERE gpid=$gpid AND enabled=1";
	$results = $q->QUERY_SQL($sql);
	if(!$q->ok){writelogs("$gpid $q->mysql_error",__FUNCTION__,__FILE__,__LINE__);return $f;}
	if(count($results)==0){return $f;}
	
	foreach($results as $index=>$ligne) {
		$ligne["pattern"]=str_replace(".", "\.", $ligne["pattern"]);
		$f[]="srcdomain $negation {$ligne["pattern"]}";
	}	
	return $f;
}
function matches_src($gpid,$negation,$f){
	$ip=new IP();
	$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
	//src
	$sql="SELECT pattern FROM webfilters_sqitems WHERE gpid=$gpid AND enabled=1";
	$results = $q->QUERY_SQL($sql);
	$exclam=null;
	if(!$q->ok){writelogs("$gpid $q->mysql_error",__FUNCTION__,__FILE__,__LINE__);return $f;}
	if(count($results)==0){return $f;}

	
	foreach($results as $index=>$ligne) {
		$pattern=trim($ligne["pattern"]);
		if($pattern==null){continue;}
		$f[]="src $negation $pattern";

	}
	return $f;
}

function matches_time($gpid,$negation,$f){
	$ip=new IP();
	$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
	$sql="SELECT pattern,other FROM webfilters_sqitems WHERE gpid=$gpid AND enabled=1";
	$results = $q->QUERY_SQL($sql);
	$exclam=null;
	if(!$q->ok){writelogs("$gpid $q->mysql_error",__FUNCTION__,__FILE__,__LINE__);return $f;}
	if(count($results)==0){return $f;}

	foreach($results as $index=>$ligne) {
		$pattern=trim($ligne["pattern"]);
		if($pattern==null){return;}
		
		$pattern=base64_decode($ligne["other"]);
		$TimeSpace=unserialize(base64_decode($ligne["other"]));
		if(!is_array($TimeSpace)){
			writelogs("Not supported pattern !is_array",__FUNCTION__,__FILE__,__LINE__);
			continue;
		}
		$fromtime=$TimeSpace["H1"];
		$tottime=$TimeSpace["H2"];
		
		if($fromtime=="00:00" && $tottime=="00:00"){
			continue;
		}
		
		
		$timerange1=strtotime(date("Y-m-d $fromtime:00"));
		$timerange2=strtotime(date("Y-m-d $tottime:00"));
		$timerange0=time();
		$days=array("0"=>"1","1"=>"2","2"=>"3","3"=>"4","4"=>"5","5"=>"6","6"=>"7");		
		while (list ($key, $ligne) = each ($TimeSpace) ){if(preg_match("#^day_([0-9]+)#", $key,$re)){$dayT=$re[1];if($ligne<>1){continue;}$dd[$days[$dayT]]=true;}}
		
		$CurrentDay=date('D');
		if($negation==1){
			if(!isset($dd[$CurrentDay])){
				if($timerange0 <= $timerange1){$result=true;}
				
			}
			continue;
		}
		if(isset($dd[$CurrentDay])){
			if($timerange0>=$timerange1){
				if($timerange0<=$timerange2){
					$result=true;
				}
			}
		}
	}
	return $result;
	
}

function build_forced($ID){
    $q=new lib_sqlite("/home/artica/SQLITE/acls.db");

    $sql="SELECT wpad_black_link.gpid,wpad_black_link.negation,wpad_black_link.zmd5 as mkey,
	wpad_black_link.zorder,
	webfilters_sqgroups.*
	FROM wpad_black_link,webfilters_sqgroups
	WHERE wpad_black_link.gpid=webfilters_sqgroups.ID
	AND wpad_black_link.aclid=$ID
	AND webfilters_sqgroups.enabled=1
	ORDER BY wpad_black_link.zorder";


    $f[]="function ForceProxies(DestPort,hostIP,host){";

    $results = $q->QUERY_SQL($sql);

    $CountObjects=count($results);
    if($CountObjects==0){
        $f[]="//\tNo force rules";
        $f[]="\treturn false;";
        $f[]="}";
        return @implode("\n",$f);

    }

    foreach($results as $index=>$ligne) {
        $gpid=$ligne["gpid"];
        $GroupName=$ligne["GroupName"];
        $negation=$ligne["negation"];


        if($ligne["GroupType"]=="all"){
            $f[]="//\tGroupType == all, make no sense but...";
            $f[]="\treturn true;";
            $f[]="}";
            return @implode("\n",$f);
        }

        if($ligne["GroupType"]=="port"){ $f[]=build_whitelist_port($gpid,$negation,false); continue;}
        if($ligne["GroupType"]=="dstdomain"){ $f[]=build_whitelist_dstdomain($gpid,$negation,false); continue;}
        if($ligne["GroupType"]=="src"){ $f[]=build_whitelist_src($gpid,$negation,false); continue;}
        if($ligne["GroupType"]=="dst"){ $f[]=build_whitelist_dst($gpid,$negation,false); continue;}
        if($ligne["GroupType"]=="srcdomain"){ $f[]=build_whitelist_srcdomain($gpid,$negation,false); continue;}
        if($ligne["GroupType"]=="time"){ $f[]=build_whitelist_time($gpid,$negation,false); continue;}
        writelogs("Not supported Group {$ligne["GroupType"]} - $GroupName",__FUNCTION__,__FILE__,__LINE__);


    }

    $f[]="\treturn false;";
    $f[]="}";
    return @implode("\n",$f);
}

function build_whitelist($ID){
	$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
	$ligne=$q->mysqli_fetch_array("SELECT * FROM wpad_rules WHERE ID='$ID'");
	$dntlhstname=$ligne["dntlhstname"];
	$isResolvable=$ligne["isResolvable"];
	$f=array();
	
	if($dntlhstname==1){ $f[]="\tif ( isPlainHostName(host) ) { return \"DIRECT\"; }"; }
	if($isResolvable==1){ $f[]="\tif( isResolvable(host) ) { return \"DIRECT\"; }"; }
	
	
	
	$sql="SELECT wpad_white_link.gpid,wpad_white_link.negation,wpad_white_link.zmd5 as mkey,
	wpad_white_link.zorder,
	webfilters_sqgroups.*
	FROM wpad_white_link,webfilters_sqgroups
	WHERE wpad_white_link.gpid=webfilters_sqgroups.ID
	AND wpad_white_link.aclid=$ID
	AND webfilters_sqgroups.enabled=1
	ORDER BY wpad_white_link.zorder";
	
	$results = $q->QUERY_SQL($sql);
	if(!$q->ok){
		pack_debug("Fatal !! $ID $q->mysql_error",__FILE__,__LINE__);
		@implode("\n", $f);
	}
	
	$CountObjects=count($results);
	if($CountObjects==0){
		pack_debug("Rule:[$ID] No whitelist groups set",__FUNCTION__,__LINE__);
        $f[]="\tif (isInNet(hostIP, \"10.0.0.0\", \"255.0.0.0\") || isInNet(hostIP, \"172.16.0.0\",  \"255.240.0.0\") || isInNet(hostIP, \"192.168.0.0\", \"255.255.0.0\") || isInNet(hostIP, \"127.0.0.0\", \"255.255.255.0\")) {";
        $f[]="\t\treturn \"DIRECT\"; }";
        return @implode("\n", $f);
	}
	
	pack_debug("Rule:[$ID] $CountObjects Object(s)",__FUNCTION__,__LINE__);
	
	foreach($results as $index=>$ligne) {
		$gpid=$ligne["gpid"];
		$not=false;
		$matches=false;
		$GroupName=$ligne["GroupName"];
		$negation=$ligne["negation"];
		if($negation==1){$not=true;}
		
		pack_debug("Rule:[$ID] Whitelisted group {$GroupName}[$gpid] Type:{$ligne["GroupType"]} Negation:$negation",__FUNCTION__,__LINE__);

        if($ligne["GroupType"]=="all"){
            $f[]="\tif (isInNet(hostIP, \"10.0.0.0\", \"255.0.0.0\") || isInNet(hostIP, \"172.16.0.0\",  \"255.240.0.0\") || isInNet(hostIP, \"192.168.0.0\", \"255.255.0.0\") || isInNet(hostIP, \"127.0.0.0\", \"255.255.255.0\")) {";
            $f[]="\t\treturn \"DIRECT\"; }";
        }
		if($ligne["GroupType"]=="port"){ $f[]=build_whitelist_port($gpid,$negation); continue;}
		if($ligne["GroupType"]=="dstdomain"){ $f[]=build_whitelist_dstdomain($gpid,$negation); continue;}
		if($ligne["GroupType"]=="src"){ $f[]=build_whitelist_src($gpid,$negation); continue;}
		if($ligne["GroupType"]=="dst"){ $f[]=build_whitelist_dst($gpid,$negation); continue;}
		if($ligne["GroupType"]=="srcdomain"){ $f[]=build_whitelist_srcdomain($gpid,$negation); continue;}
		if($ligne["GroupType"]=="time"){ $f[]=build_whitelist_time($gpid,$negation); continue;}
		writelogs("Not supported Group {$ligne["GroupType"]} - $GroupName",__FUNCTION__,__FILE__,__LINE__);
	}
	
	return @implode("\n", $f);
}

function build_whitelist_port($gpid,$negation,$return_direct=true){
	$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
	$sql="SELECT pattern FROM webfilters_sqitems WHERE gpid=$gpid AND enabled=1";
	$results = $q->QUERY_SQL($sql);
	$exclam=null;
	if(!$q->ok){writelogs("$gpid $q->mysql_error",__FUNCTION__,__FILE__,__LINE__);return false;}
	if(count($results)==0){return false;}
	if($negation==1){$exclam="!";}
	$f=array();

    if($return_direct) {
        $return = "\"DIRECT\";";
    }else{
        $return="true;";
    }

	foreach($results as $index=>$ligne) {
		$pattern=$ligne["pattern"];
		if(!is_numeric($pattern)){return;}
		$f[]="\tif( DestPort{$exclam}==\":{$ligne["pattern"]}\"){  return $return }";
	}
	return @implode("\n", $f);
}

function build_whitelist_dstdomain($gpid,$negation,$return_direct=true){
	$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
	$fam=new familysite();
	$sql="SELECT pattern FROM webfilters_sqitems WHERE gpid=$gpid AND enabled=1";
	$results = $q->QUERY_SQL($sql);
	$exclam=null;
	if(!$q->ok){writelogs("$gpid $q->mysql_error",__FUNCTION__,__FILE__,__LINE__);return false;}
	if(count($results)==0){return false;}	
	if($negation==1){$exclam="!";}

    if($return_direct) {
        $return = "\"DIRECT\";";
    }else{
        $return="true;";
    }
	$f=array();
	foreach($results as $index=>$ligne) {
		$pattern=trim(strtolower($ligne["pattern"]));
		$Family=$fam->GetFamilySites($pattern);
		pack_debug("Group::[$gpid] Item: \"$pattern\" -> $Family",__FUNCTION__,__LINE__);
		
		
		if(strpos(" $pattern", "*")>0){
			if(preg_match("#^\^(.+)#", $ligne["pattern"],$re)){$pattern=$re[1];}
			$f[]="\tif( shExpMatch(host ,\"$pattern\") ){ return $return;}";
			continue;
		}
		
		if(preg_match("#^\^(.+)#", $ligne["pattern"],$re)){
			$f[]="\tif( {$exclam}dnsDomainIs(host, \"{$re[1]}\") ){  return $return }";
			continue;
		}
		if($Family==$ligne["pattern"]){
			if(!preg_match("#^\.#", $ligne["pattern"])){
				$f[]="\tif( {$exclam}dnsDomainIs(host, \".{$ligne["pattern"]}\") ){  return $return }";
				continue;
			}
		}
		
		$f[]="\tif( {$exclam}dnsDomainIs(host, \"{$ligne["pattern"]}\") ){  return $return }";
	}
	return @implode("\n", $f);
}

function build_whitelist_dst($gpid,$negation,$return_direct=true){
	$ip=new IP();
	$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
	$sql="SELECT pattern FROM webfilters_sqitems WHERE gpid=$gpid AND enabled=1";
	$results = $q->QUERY_SQL($sql);
	$exclam=null;
	if(!$q->ok){
		pack_debug("Group:[$gpid] FATAL !! $q->mysql_error",__FUNCTION__,__LINE__);
		return false;
	}

    if($return_direct) {
        $return = "\"DIRECT\";";
    }else{
        $return="true;";
    }
	
	$CountObjects=count($results);
	if($CountObjects==0){
		pack_debug("Group::[$gpid] No object defined",__FUNCTION__,__LINE__);
		return false;
	}	
	if($negation==1){$exclam="!";}
	$f=array();
	pack_debug("Group::[$gpid] $CountObjects object(s) defined",__FUNCTION__,__LINE__);
	
	foreach($results as $index=>$ligne) {
		$pattern=trim($ligne["pattern"]);
		pack_debug("Group::[$gpid] Item: \"$pattern\"",__FUNCTION__,__LINE__);
		
		if($pattern==null){continue;}
		
		if(preg_match("#^([0-9\.]+)-([0-9\.]+)$#", $pattern,$re)){
			$pattern=GetRange($pattern);
			pack_debug("Group::[$gpid] Item: \"{$ligne["pattern"]}\" -> $pattern",__FUNCTION__,__LINE__);
		}
		
		if(preg_match("#^([0-9\.]+)\/[0-9]+$#", $pattern,$re)){
			$ipaddr=$re[1];
			$netmask=cdirToNetmask($pattern);
			if(!preg_match("#^[0-9\.]+$#", $netmask)){
				pack_debug("ERROR CAN'T PARSE $pattern to netmask",__FILE__,__LINE__);
				continue;
			}
			if($netmask==null){$netmask="255.255.255.0";}
			$f[]="\tif( {$exclam}isInNet(hostIP, \"$ipaddr\", \"$netmask\") ){ return $return}";
			continue;
		}		

		if ($ip->isIPAddress($pattern)){
			$f[]="\tif ( isInNet(hostIP, \"$pattern\",\"255.255.255.0\") ) { return $return}";
			continue;
		}
		

		
		
		writelogs("Not supported pattern $pattern",__FUNCTION__,__FILE__,__LINE__);
	}
	return @implode("\n", $f);
}

function build_whitelist_src($gpid,$negation,$return_direct=true){
	$ip=new IP();
	$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
	$sql="SELECT pattern FROM webfilters_sqitems WHERE gpid=$gpid AND enabled=1";
	$results = $q->QUERY_SQL($sql);
	$exclam=null;
	if(!$q->ok){writelogs("$gpid $q->mysql_error",__FUNCTION__,__FILE__,__LINE__);return false;}
	if(count($results)==0){return false;}
	if($negation==1){$exclam="!";}
	$f=array();

    if($return_direct) {
        $return = "\"DIRECT\";";
    }else{
        $return="true;";
    }

	foreach($results as $index=>$ligne) {
		$pattern=trim($ligne["pattern"]);
		if($pattern==null){return;}
		
		if(preg_match("#^([0-9\.]+)-([0-9\.]+)$#", $pattern,$re)){
			$pattern=GetRange($pattern);
			pack_debug("Group::[$gpid] Item: \"{$ligne["pattern"]}\" -> $pattern",__FUNCTION__,__LINE__);
		}
		
		
		if(preg_match("#^([0-9\.]+)\/[0-9]+$#", $pattern,$re)){
			$ipaddr=$re[1];
			$netmask=cdirToNetmask($pattern);
			
			if($GLOBALS["VERBOSE"]){$f[]="// --- $pattern -> $ipaddr netmask:$netmask [".__LINE__."]";}
			if(!preg_match("#^[0-9\.]+$#", $netmask)){
				pack_debug("ERROR CAN'T PARSE $pattern to netmask",__FILE__,__LINE__);
				continue;
			}
			if($netmask==null){$netmask="255.255.255.0";}
			$f[]="\tif( {$exclam}isInNet(myip, \"$ipaddr\", \"$netmask\") ){ return $return}";
			continue;
		}		


		if ($ip->isIPAddress($pattern)){
			if($GLOBALS["VERBOSE"]){$f[]="// --- $pattern -> isIPAddress(TRUE) [".__LINE__."]";}
			$f[]="\tif( {$exclam}isInNet(myip, \"$pattern\", \"255.255.255.255\") ){ return $return}";
			continue;
		}




		pack_debug("Not supported pattern $pattern",__FILE__,__LINE__);
	}
	return @implode("\n", $f);
}

function build_whitelist_srcdomain($gpid,$negation,$return_direct=true){
	$ip=new IP();
	$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
	$sql="SELECT pattern FROM webfilters_sqitems WHERE gpid=$gpid AND enabled=1";
	$results = $q->QUERY_SQL($sql);
	$exclam=null;
	if(!$q->ok){writelogs("$gpid $q->mysql_error",__FUNCTION__,__FILE__,__LINE__);return false;}
	if(count($results)==0){return false;}
	if($negation==1){$exclam="!";}
	$f=array();

    if($return_direct) {
        $return = "\"DIRECT\";";
    }else{
        $return="true;";
    }
	
	foreach($results as $index=>$ligne) {
		$pattern=trim($ligne["pattern"]);
		if($pattern==null){return;}
	
		if ($ip->isIPAddress($pattern)){
			$f[]="\tif( hostIP {$exclam}== \"$pattern\") { return $return}";
			continue;
		}
		
		if(substr($pattern, 0,1)=='.'){
			if(strpos($pattern, "*")>0){
				$f[]="\tif( shExpMatch(host ,\"$pattern\") ) { return $return}";
				continue;
			}
			
			$f[]="\tif( dnsDomainIs(host ,\"$pattern\") ){ return $return}";
			continue;
			
		}
		
		$f[]="\tif( host {$exclam}== \"$pattern\") { return $return}";

		
	}
	return @implode("\n", $f);	
	
}

function build_whitelist_time($gpid,$negation,$return_direct=true){
	$ip=new IP();
	$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
	$sql="SELECT pattern,other FROM webfilters_sqitems WHERE gpid=$gpid AND enabled=1";
	$results = $q->QUERY_SQL($sql);
	$exclam=null;
	if(!$q->ok){writelogs("$gpid $q->mysql_error",__FUNCTION__,__FILE__,__LINE__);return false;}
	if(count($results)==0){return false;}
	if($negation==1){$exclam="!";}
	foreach($results as $index=>$ligne) {
		$pattern=trim($ligne["pattern"]);
		if($pattern==null){return;}
	
		$pattern=base64_decode($ligne["other"]);
		$TimeSpace=unserialize(base64_decode($ligne["other"]));
		if(!is_array($TimeSpace)){
			writelogs("Not supported pattern !is_array",__FUNCTION__,__FILE__,__LINE__);
			continue;
		}
		$fromtime=$TimeSpace["H1"];
		$tottime=$TimeSpace["H2"];
	
		if($fromtime=="00:00" && $tottime=="00:00"){
			writelogs("From: $fromtime to $tottime not supported...",__FUNCTION__,__FILE__,__LINE__);
			continue;
		}
	
	
		$timerange1=strtotime(date("Y-m-d $fromtime:00"));
		$timerange2=strtotime(date("Y-m-d $tottime:00"));
		$timerange0=time();
		
		
		
		$days=array("0"=>"MON","1"=>"TUE","2"=>"WED","3"=>"THU","4"=>"FRI","5"=>"SAT","6"=>"SUN");
		foreach ($TimeSpace as $key=>$ligne){
			if(preg_match("#^day_([0-9]+)#", $key,$re)){
				$dayT=$re[1];
				if($ligne<>1){continue;}
				$f[]="\tif( {$exclam}weekdayRange(\"{$days[$dayT]}\") ){";
				$f[]="\t\t{$exclam}timeRange(".date("H",$timerange1).",". date("i",$timerange1).", 0,".date("H",$timerange2).",".date("i",$timerange2).", 0) ){";
				if($return_direct) {
                    $f[] = "\t\t\treturn \"DIRECT\";";
                }else{
				    $f[]="\t\t\treturn true;";
                }
				$f[]="\t\t}";
				$f[]="\t}";
				
			}
		}

	}
	return @implode("\n", $f);
	
}

function GetRange($net){
	
	if(preg_match("#(.+?)-(.+)#", $net,$re)){
		$ip=new IP();
		return $ip->ip2cidr($re[1],$re[2]);
    }
	
}

function cdirToNetmask($net){
	$results2=array();
	
	if(preg_match("#(.+?)\/(.+)#", $net,$re)){
		$ip=new ipv4($re[1],$re[2]);
		$netmask=$ip->netmask();
		$ipaddr=$ip->address();

		if(preg_match("#[0-9\.]+#", $netmask)){
			return $netmask;
		}
		
		pack_debug("$net -> $ipaddr - $netmask ",__FILE__,__LINE__);
	}

	exec("/usr/share/artica-postfix/bin/ipcalc $net 2>&1");
	pack_debug("/usr/share/artica-postfix/bin/ipcalc $net 2>&1",__FILE__,__LINE__);
	foreach ($results2 as $index=>$line){
		if(preg_match("#Netmask:\s+([0-9\.]+)#", $line,$re)){return $re[1];break;}
	}

}

function build_proxies($ID,$FinishbyDirect=0){
	$sql="SELECT * FROM `wpad_destination` WHERE aclid=$ID ORDER BY zorder";
	$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
	$results = $q->QUERY_SQL($sql);
	if(!$q->ok){return "\n\treturn \"DIRECT\";";}
	if(count($results)==0){return "\n\treturn \"DIRECT\";";}
	
	foreach($results as $index=>$ligne) {
	    $PREFIX="PROXY";
	    if($ligne["secure"]==1){$PREFIX="HTTPS";}


	    $g[]="$PREFIX {$ligne["proxyserver"]}:{$ligne["proxyport"]};";
	}

	if(count($g)==0){return "\n\treturn \"DIRECT\";";}
	if($FinishbyDirect==1){$g[]="DIRECT";}
	
	return "\n\treturn \"".@implode(" ", $g)."\";";
}

function packsyslog($text,$function=null,$line=0){
	$servername=$_SERVER["SERVER_NAME"];
	
	if(function_exists("debug_backtrace")){
		$trace=debug_backtrace();
		if(isset($trace[1])){
			if($function==null){$function=$trace[1]["function"];}
			if($line==0){$line=$trace[1]["line"];}
		}
			
	}
	
	
	
	$LineToSyslog="[$servername] {$GLOBALS["IPADDR"]}: $text function $function line $line";
	ToSyslog($LineToSyslog);
	
	
}

function pack_debug($text,$function,$line){

	if($GLOBALS["VERBOSE"]){echo "<code style='font-size:14px'>$function:[$line] $text<br>\n";}
	if($GLOBALS["PROXY_PAC_DEBUG"]==0){return;}
	
	$servername=$_SERVER["SERVER_NAME"];
	$LineToSyslog="[$servername] {$GLOBALS["IPADDR"]}: $text function $function line $line";
	ToSyslog($LineToSyslog);
	
	$logFile="/var/log/apache2/proxy.pack.debug";
	
	$from=$_SERVER["REMOTE_ADDR"];
	$lineToSave=date('H:i:s')." [$servername] {$GLOBALS["IPADDR"]}: $text function $function line $line";
	
	if (is_file($logFile)) { $size=@filesize($logFile); if($size>900000){@unlink($logFile);} }
	
	$f = @fopen($logFile, 'a');
	@fwrite($f, "$lineToSave\n");
	@fclose($f);
}
function pack_error($text,$function,$line){
	
	$logFile="/var/log/apache2/proxy.pack.error";
	$servername=$_SERVER["SERVER_NAME"];
	$from=$_SERVER["REMOTE_ADDR"];
	$lineToSave=date('H:i:s')." [$servername] {$GLOBALS["IPADDR"]}: $text function $function line $line";
	$LineToSyslog="[$servername] {$GLOBALS["IPADDR"]}: $text function $function line $line";
	if (is_file($logFile)) { $size=@filesize($logFile); if($size>900000){@unlink($logFile);} }

	$f = @fopen($logFile, 'a');
	if(!$f){ ToSyslog($LineToSyslog); return; }
	@fwrite($f, "$lineToSave\n");
	@fclose($f);
}

function ToSyslog($text){

	$LOG_SEV=LOG_INFO;
	if(function_exists("openlog")){openlog("proxy.pac", LOG_PID , LOG_SYSLOG);}
	if(function_exists("syslog")){ syslog($LOG_SEV, $text);}
	if(function_exists("closelog")){closelog();}
}
///* Don't proxy local hostnames */ if (isPlainHostName(host)) { return 'DIRECT'; }
//  if (dnsDomainLevels(host) > 0) { // if the number of dots in host > 0
//  if (isResolvable(host))
?>