<?php
ini_set('display_errors', 1);	ini_set('html_errors',0);ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);
include_once(dirname(__FILE__).'/framework/class.unix.inc');
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/ressources/class.sockets.inc');
include_once(dirname(__FILE__).'/ressources/class.mount.inc');
include_once(dirname(__FILE__).'/ressources/class.mysql.inc');
include_once(dirname(__FILE__).'/ressources/class.squid.inc');
include_once(dirname(__FILE__).'/ressources/class.squid.acls.inc');
if(!isset($GLOBALS["CLASS_SOCKETS"])){$GLOBALS["CLASS_SOCKETS"]=new sockets();}

if($argv[1]=="--on"){EnableSSLEmergency();exit;}
if($argv[1]=="--off"){DisableSSLEmergency();exit;}
if($argv[1]=="--start"){Create_ssl_config();exit;}
DisableSSLEmergency();

function EnableSSLEmergency(){
    $baspath="/usr/share/artica-postfix";
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    squid_admin_mysql(0,"Activate SSL proxy emergency status",null,__FILE__,__LINE__);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("SquidSSLUrgency", 0);
    $aclGen=new squid_acls();
    $aclGen->Build_Acls(true);
    @file_put_contents("/etc/squid3/acls_center.conf", @implode("\n",$aclGen->acls_array));
    system("$php $baspath/exec.squid.global.access.php --ports --restart --firehol --force");
}

function DisableSSLEmergency(){

    $CountOfSSLPorts=CountOfSSLPorts();
    $baspath="/usr/share/artica-postfix";
    $unix=new unix();
    $squidbin=$unix->LOCATE_SQUID_BIN();
    $php=$unix->LOCATE_PHP5_BIN();
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("SquidSSLUrgency", 0);
    squid_admin_mysql(0,"Remove SSL proxy emergency status",null,__FILE__,__LINE__);
    if($CountOfSSLPorts==0){
        Create_ssl_config();
        return true;
    }
    build_progress("{starting} {compiling_rules}",10);
    if(!Create_ssl_config()){
        build_progress("{starting} {failed}",110);
        return;
    }
    build_progress("{starting} {compiling_rules}",20);
    $aclGen=new squid_acls();
    $aclGen->Build_Acls(true);
    @file_put_contents("/etc/squid3/acls_center.conf", @implode("\n",$aclGen->acls_array));

    build_progress("{starting} {compiling_rules}",30);
    system("$php $baspath/exec.squid.global.access.php --ports --restart --firehol --force");



    build_progress("{starting} {compiling_rules}",40);
    $squid_ssl=new squid_ssl();
    $squid_ssl->build();
    build_progress("{starting} {reloading}",50);
    shell_exec("$squidbin -f /etc/squid3/squid.conf -k reconfigure");
    build_progress("{starting} {done}",100);

}
function build_progress($text,$pourc){
    $echotext=$text;
    $echotext=str_replace("{reconfigure}", "Reconfigure", $echotext);
    echo "Starting......: ".date("H:i:s")." {$pourc}% $echotext\n";
    $cachefile="/usr/share/artica-postfix/ressources/logs/squid.ssl.emergency.progress";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($cachefile, serialize($array));
    @chmod($cachefile,0755);

}

function CountOfSSLPorts(){
    if(isset($GLOBALS["CountOfSSLPorts"])){return $GLOBALS["CountOfSSLPorts"];}
    $q=new lib_sqlite("/home/artica/SQLITE/proxy.db");
    $ligne=$q->mysqli_fetch_array("SELECT count(*) as tcount FROM proxy_ports 
            WHERE UseSSL=1 AND enabled=1");
    if(!$q->ok){echo $q->mysql_error."\n";}
    $CountOfSSLPorts=intval($ligne["tcount"]);
    echo "Starting......: ".date("H:i:s")." $CountOfSSLPorts Standard SSL ports ...\n";

    $ligne=$q->mysqli_fetch_array("SELECT count(*) as tcount FROM transparent_ports WHERE enabled=1 AND TProxy=0 AND LENGTH('sslcertificate') >3");

    if(!$q->ok){echo $q->mysql_error."\n";}
    echo "Starting......: ".date("H:i:s")." $CountOfSSLPorts Transparent SSL ports ...\n";

    $CountOfSSLPorts=$CountOfSSLPorts+intval($ligne["tcount"]);

    $HaClusterClient                = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterClient"));
    if($HaClusterClient==1){
        $HaClusterGBConfig=unserialize($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterGBConfig"));
        if(intval($HaClusterGBConfig["HaClusterDecryptSSL"])==1){
            $CountOfSSLPorts++;
        }
    }
    echo "Starting......: ".date("H:i:s")." $CountOfSSLPorts SSL ports ...\n";
    $GLOBALS["CountOfSSLPorts"]=$CountOfSSLPorts;
    return $CountOfSSLPorts;

}

function Create_ssl_config(){
    $unix=new unix();
    $mount=new mount();
    $rm=$unix->find_program("rm");
    $su=$unix->find_program("su");
    $ssldir="/var/lib/squid/session/ssl";
    $index="$ssldir/ssl_db/index.txt";
    $sslcrtd_program_dbsize=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("sslcrtd_program_dbsize"));
    if($sslcrtd_program_dbsize==0){$sslcrtd_program_dbsize=8;}

    CreateDir();
    if(!isDirPopulated($ssldir)){
        if(is_dir("$ssldir/ssl_db")){
            echo "Starting......: ".date("H:i:s")." Remove $ssldir/ssl_db\n";
            shell_exec("$rm -rf $ssldir/ssl_db");
        }

        echo "Starting......: ".date("H:i:s")." Populate $ssldir\n";
        $cmd="$su -c \"/lib/squid3/security_file_certgen -c -s $ssldir/ssl_db -M {$sslcrtd_program_dbsize}MB\" squid ";

        shell_exec($cmd);
        CreateDir();
    }

    if(!isDirPopulated($ssldir)){
        echo "Starting......: ".date("H:i:s")." Populate $ssldir Failed\n";
        squid_admin_mysql(0,"Unable to initialize $ssldir for {$sslcrtd_program_dbsize}MB",
            null,__FILE__,__LINE__);
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("SquidSSLUrgency", 1);
        return false;
    }
    echo "Starting......: ".date("H:i:s")." Populate $ssldir Success\n";
    CreateDir();
    return true;

}

function isDirPopulated($ssldir){

    if(!is_dir("$ssldir/ssl_db/certs")) {return false;}
    if(!is_file("$ssldir/ssl_db/index.txt")){return false;}
    return true;
}

function CreateDir(){

    $sslv1="/var/lib/squid";
    $sslv2="/var/lib/squid/session";
    $ssldir="$sslv2/ssl";
    if(!is_dir($ssldir)) {
        @mkdir($ssldir, 0755, true);
    }
    @chown($ssldir,"squid");
    @chgrp($ssldir,"squid");

    @chown($sslv1,"squid");
    @chgrp($sslv1,"squid");

    @chown($sslv2,"squid");
    @chgrp($sslv2,"squid");

    if(is_file("$ssldir/ssl_db/index.txt")){
        $unix=new unix();
        $chown=$unix->find_program("chown");
        shell_exec("$chown -R squid:squid $ssldir/ssl_db");
    }

}