<?php
$GLOBALS["YESCGROUP"]=true;
$GLOBALS["DEBUG"]=false;
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.system.network.inc');
include_once(dirname(__FILE__).'/ressources/class.mysql.catz.inc');
include_once(dirname(__FILE__).'/ressources/class.hosts.inc');
include_once(dirname(__FILE__).'/ressources/class.squid.acls.useragents.inc');
include_once(dirname(__FILE__).'/ressources/class.statscom-msmtp.inc');
include_once(dirname(__FILE__).'/ressources/class.html.tools.inc');
include_once(dirname(__FILE__).'/ressources/class.tcpip.inc');
if(isset($argv)){
    if(preg_match("#--verbose#",implode(" ",$argv),$re)){$GLOBALS["DEBUG"]=true;$GLOBALS["VERBOSE"]=false;ini_set('html_errors',0);ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);}
    if($argv[1]=="--main"){build_maintenance();exit;}
    if($argv[1]=="--days"){build_days();exit;}
    if($argv[1]=="--entities"){entities();exit;}
    if($argv[1]=="--catz"){Nocategorized();exit;}
    if($argv[1]=="--users"){build_users_days();exit;}
    if($argv[1]=="--test-smtp"){test_smtp();exit;}
    if($argv[1]=="--set-schedules"){schedules();}
    if($argv[1]=="--block"){build_blocked();exit;}
    if($argv[1]=="--total"){dashboard_stats();exit;}

}
build_accesses();


function build_maintenance(){
    $GLOBALS["VERBOSE"]=true;
    $q=new postgres_sql();
    if(!$q->CREATE_STATSCOM()){
        echo "error:".$q->mysql_error."\n";
    }

}

function schedules(){
    $unix=new unix();
    if (!$handle = opendir("/etc/cron.d")) {return false;}

    build_progress_reports(25,"{removing}..");

    while (false !== ($file = readdir($handle))) {
        if ($file == "." && $file == "..") {continue;}
        if(substr($file, 0,1)=='.'){continue;}
        $fullpath="/etc/cron.d/$file";
        if(is_dir($file)){continue;}

        if(!preg_match("#^pdf-proxy-report-[0-9]+#",$file)){continue;}
        echo "Remove $file\n";
        @unlink($fullpath);
    }
    build_progress_reports(50,"{configuring}..");

    $q=new lib_sqlite("/home/artica/SQLITE/sys_schedules.db");
    $results=$q->QUERY_SQL("SELECT * FROM pdf_reports WHERE enabled=1");
    foreach ($results as $index=>$ligne){
        $ID=$ligne["ID"];
        $TimeText=$ligne["TimeText"];
        $unix->Popuplate_cron_make("pdf-proxy-report-$ID",$TimeText,"exec.pdf.proxy.daily.php --schedule $ID");


    }

    build_progress_reports(75,"{restarting}..");

    shell_exec("/etc/init.d/cron/restart");

    build_progress_reports(100,"{done}..");

}


build_accesses();




function test_smtp(){


    $smtp=new statscom_msmtp();
    $recipient=$smtp->recipient;
    build_progress_smtp(50,"Send to $recipient");
    $smtp->Subject="Subject: Test notification PDF Report engine";
    $body[]="";
    $body[]="";
    $body[]="Here, the message from the robot...";
    $body[]="";
    $body[]="";
    $finalbody=@implode("\r\n", $body);
    $smtp->debug=true;

    if( !$smtp->Send($finalbody)){
        build_progress_smtp(110,$smtp->smtp_error);

        return;
    }
    build_progress_smtp(100,"Send to $recipient {success}");
}
function build_progress_smtp($pourc,$text){
    $echotext=$text;
    echo "Starting......: ".date("H:i:s")." {$pourc}% $echotext\n";
    $cachefile="/usr/share/artica-postfix/ressources/logs/web/statscom.smtp.progress";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($cachefile, serialize($array));
    @chmod($cachefile,0755);
}
function build_progress_reports($pourc,$text){
    $echotext=$text;
    echo "Starting......: ".date("H:i:s")." {$pourc}% $echotext\n";
    $ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/statscom.report.progres";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($ARRAY["PROGRESS_FILE"], serialize($array));
    @chmod($ARRAY["PROGRESS_FILE"],0755);
}
function build_accesses(){
    $GLOBALS["CLASS_SOCKETS"]=new sockets();
    $GLOBALS["COUNT_ENTRIES"]=0;
    $unix=new unix();
    $catz=new mysql_catz();
    $fam=new squid_familysite();
    $q=new postgres_sql();




    $EnableStatsCommunicator=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableStatsCommunicator"));
    if(!$q->CREATE_STATSCOM()){
        if($GLOBALS["DEBUG"]){echo "Error creating statscom tables $q->mysql_error\n";}
        events("Error creating statscom tables",__LINE__);
        squid_admin_mysql(0,"Error creating statscom tables",$q->mysql_error,__FILE__,__FUNCTION__);
        return;
    }

    $q->QUERY_SQL("ALTER TABLE statscom ALTER COLUMN username TYPE varchar(90);");
    $q->QUERY_SQL("ALTER TABLE statscom_husers ALTER COLUMN username TYPE varchar(90);");
    $q->QUERY_SQL("ALTER TABLE statscom_users ALTER COLUMN username TYPE varchar(90);");
    $q->QUERY_SQL("ALTER TABLE statsblocks ALTER COLUMN username TYPE varchar(90);");
    $q->QUERY_SQL("ALTER TABLE statscom_days ALTER COLUMN username TYPE varchar(90);");

    if($GLOBALS["DEBUG"]){echo "EnableStatsCommunicator = $EnableStatsCommunicator\n";}
    if($EnableStatsCommunicator==1){

        if(!is_file("/etc/init.d/statscom")){
            if($GLOBALS["DEBUG"]){echo "/etc/init.d/statscom no such file...\n";}
            squid_admin_mysql(0, "Install Artica Status Communicator by default... [action=install]", null,__FILE__,__LINE__);
            $php=$unix->LOCATE_PHP5_BIN();
            $cmd="$php /usr/share/artica-postfix/exec.statscom.php --install";
            shell_exec2($cmd);
        }
    }


    try {
        $redis = new Redis();
        $redis->connect("127.0.0.1", 4322, 2);
    } catch (Exception $e) {
        events("Error connecting to redis Daemon ".$e->getMessage(),__LINE__);
        shell_exec("/etc/init.d/statsredis restart");
        $unix->ToSyslog("build_accesses(): ".$e->getMessage(),"stats-communicator");
    }
    try {
        $ALL_KEYS = $redis->keys("ACCESS.*");
    } catch( Exception $e ){
        events("Error Gettings ACCESS.* ".$e->getMessage(),__LINE__);
        $unix->ToSyslog("build_accesses(): ".$e->getMessage(),"stats-communicator");
        shell_exec("/etc/init.d/statsredis restart");
        return false;
    }


    events("Scanning ".count($ALL_KEYS)." row(s)",__LINE__);
    $CurrentTimeStamp=CurrentTimeStamp();
    $prefix="INSERT INTO statscom (zdate,username,ipaddr,mac,siteid,hits,size,entityid) VALUES ";
    $KeysToDelete=array();
    $f=array();
    $SKIP=0;
    $REMOVED=0;
    $GLOBALS_SIZE=0;
    $GLOBALS_RQS=0;
    $GLOBALS_SITES=array();
    foreach ($ALL_KEYS as $key){

        if(!preg_match("#^ACCESS\.([0-9]+)\.(.+)#",$key,$re)){
            $REMOVED++;
            $redis->del($key);
            continue;
        }
        $Time=$re[1];
        if($Time==$CurrentTimeStamp){
            $SKIP++;
            echo "Skipping $key\n";
            continue;
        }
        $zdate=date("Y-m-d H:i:s",$Time);
        $records=explode("|",$re[2]);

        $ipaddr=trim($records[0]);
        $mac=trim(strtolower($records[1]));
        $username=trim(strtolower($records[2]));
        $sitename=trim(strtolower($records[3]));
        $category=intval($records[4]);
        $proxname=trim(strtolower($records[5]));
        $uuid=trim(strtolower($records[6]));
        if(strpos($username,":")>0){$username=null;}


        if($sitename=="-"){
            events("Scanning sitename === - in $re[2]",__LINE__);
            continue;}
        if($ipaddr=="-"){
            events("Scanning ipaddr === - in $re[2]",__LINE__);
            continue;}
        if(!preg_match("#^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+$#",$ipaddr)){
            events("Scanning $ipaddr === NOT IP",__LINE__);
            continue;}
        if(strpos("  $sitename","::")>0){
            events("Scanning $sitename === '::' skip",__LINE__);
            continue;}
        if($uuid==null){
            events("Scanning uuid === null in \"$re[2]\" skip",__LINE__);
            $REMOVED++;
            $redis->del($key);
            continue;
        }

        $familysite=$fam->GetFamilySites($sitename);
        if($category==0){$category=$catz->GET_CATEGORIES($sitename);}

        $siteid=get_siteid($sitename,$familysite,$category);
        if($siteid==0){
            $REMOVED++;
            $redis->del($key);
            events("Fatal unable to get siteid from \"$sitename\" \"$re[2]\"",__LINE__);
            continue;
        }
        $entityid=get_entityid($uuid,$proxname);
        if($entityid==0){
            events( "Fatal unable to get entityid from \"$uuid\" \"$re[2]\"",__LINE__);
            squid_admin_mysql("Fatal unable to get entityid from $uuid",null,__FILE__,__LINE__);
            die();
        }


        $metrics=$redis->hgetall($key);
        $size=$metrics["SIZE"];
        $reqs=$metrics["RQS"];
        $KeysToDelete[]=$key;
        $GLOBALS_SIZE=$GLOBALS_SIZE+$size;
        $GLOBALS_RQS=$GLOBALS_RQS+$reqs;
        $GLOBALS_SITES[$siteid]=true;

        $md5_user=md5("$username$ipaddr$mac");
        $USERS[$md5_user]="('$md5_user','$username','$ipaddr','$mac')";
        $linez="('$zdate','$username','$ipaddr','$mac','$siteid','$reqs','$size','$entityid')";
      
        $f[]=$linez;

        if(count($f)>5000){
            $GLOBALS["COUNT_ENTRIES"]=$GLOBALS["COUNT_ENTRIES"]+count($f);
            $q->QUERY_SQL($prefix.@implode(",",$f));
            if(!$q->ok){
                $unix->ToSyslog("build_accesses(): PostGreSQL error $q->mysql_error","stats-communicator");
                events("statscom failed with error $q->mysql_error",__LINE__);
                squid_admin_mysql("statscom failed with error $q->mysql_error",$q->mysql_error,__FILE__,__LINE__);
                return false;
            }
            $f=array();
            echo "Remove ".count($KeysToDelete)." keys from memory\n";
            $redis->del($KeysToDelete);
            $KeysToDelete=array();
            continue;
        }
    }

    if(count($f)>0){
        $GLOBALS["COUNT_ENTRIES"]=$GLOBALS["COUNT_ENTRIES"]+count($f);
        if($GLOBALS["DEBUG"]){echo $prefix.@implode(",",$f)."\n";}
        $q->QUERY_SQL($prefix.@implode(",",$f));
        if(!$q->ok){
            $unix->ToSyslog("build_accesses(): PostGreSQL error $q->mysql_error","stats-communicator");
            events("statscom failed with error $q->mysql_error",__LINE__);
            squid_admin_mysql("statscom failed with error $q->mysql_error",$q->mysql_error,__FILE__,__LINE);
            return false;
        }
        echo "Remove ".count($KeysToDelete)." keys from memory\n";
        $redis->del($KeysToDelete);
    }


    $ligne=$q->mysqli_fetch_array("SELECT COUNT(*) as tcount FROM statscom_websites WHERE category>0");
    $redis->set("DASHBOARD.TOTAL.CATEGORIZED",intval($ligne["tcount"]));


    $redis->close();

    events("Parsing done {$GLOBALS["COUNT_ENTRIES"]} items, skipped:$SKIP removed:$REMOVED",__LINE__);
    events("Parsing {$GLOBALS_SIZE}bytes, {$GLOBALS_RQS} rqs ".count($GLOBALS_SITES)." sites",__LINE__);


    if($GLOBALS["DEBUG"]){echo "Parsing done {$GLOBALS["COUNT_ENTRIES"]} items.\n";}

    $OLD=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("STATSCOM_COUNT_ENTRIES"));

    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("STATSCOM_COUNT_RQS",$GLOBALS_RQS);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("STATSCOM_COUNT_BYTES",$GLOBALS_SIZE);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("STATSCOM_COUNT_SITES",count($GLOBALS_SITES));
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("STATSCOM_COUNT_ENTRIES",intval($GLOBALS["COUNT_ENTRIES"])+$OLD);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("STATSCOM_USERS",count($USERS));


    build_blocked();
    UserAgents();
    SitesSimple();
    ProxySimple();
    UsersSimple();
    dashboard_stats();
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("STATSCOM_LAST_SCAN",time());

}

function dashboard_stats(){

    $currenthour=date("Y-m-d H:00:00");
    $currentDay=date("Y-m-d 00:00:00");
    $currentWeek=date("Y-m-d 00:00:00", strtotime('monday this week'));
    $q=new postgres_sql();

    $ligne=$q->mysqli_fetch_array("SELECT SUM(size) as download FROM statscom");
    $MAIN["TOTAL"]["ALL"]["DOWNLOAD"]=intval($ligne["download"]);

    $ligne=$q->mysqli_fetch_array("SELECT SUM(hits) as download FROM statscom");
    echo "************ HITS {$ligne["download"]}\n";
    $MAIN["TOTAL"]["ALL"]["HITS"]=intval($ligne["download"]);

    $MAIN["TOTAL"]["ALL"]["ROWS"]=$q->COUNT_ROWS("statscom");

    $ligne=$q->mysqli_fetch_array("SELECT zdate FROM statscom ORDER BY zdate LIMIT 1");
    $MAIN["TOTAL"]["ALL"]["FIRST_DATE"]=$ligne["zdate"];
    $ligne=$q->mysqli_fetch_array("SELECT zdate FROM statscom ORDER BY zdate DESC LIMIT 1");
    $MAIN["TOTAL"]["ALL"]["LAST_DATE"]=$ligne["zdate"];
    $reuslts=$q->QUERY_SQL("SELECT familysite FROM statscom_websites GROUP BY familysite");
    $MAIN["TOTAL"]["ALL"]["FAMILYSITES"]=pg_num_rows($reuslts);
    $reuslts=$q->QUERY_SQL("SELECT category FROM statscom_websites GROUP BY category");
    $MAIN["TOTAL"]["ALL"]["CATEGORIES"]=pg_num_rows($reuslts);
    $reuslts=$q->QUERY_SQL("SELECT username FROM statscom_users GROUP BY username");
    $MAIN["TOTAL"]["ALL"]["USERNAMES"]=pg_num_rows($reuslts);
    $reuslts=$q->QUERY_SQL("SELECT mac FROM statscom_users GROUP BY mac");
    $MAIN["TOTAL"]["ALL"]["MACS"]=pg_num_rows($reuslts);
    $reuslts=$q->QUERY_SQL("SELECT ipaddr FROM statscom_users GROUP BY ipaddr");
    $MAIN["TOTAL"]["ALL"]["IPADRS"]=pg_num_rows($reuslts);


    $ligne=$q->mysqli_fetch_array("SELECT SUM(size) as download FROM statscom WHERE zdate>'$currenthour'");

    $hourly_download=$ligne["download"];
    $ligne=$q->mysqli_fetch_array("SELECT SUM(size) as download FROM statscom WHERE zdate>'$currentDay'");

    $daily_download=$ligne["download"];
    $ligne=$q->mysqli_fetch_array("SELECT SUM(size) as download FROM statscom WHERE zdate>'$currentWeek'");

    $week_download=$ligne["download"];
    $MAIN["TOTAL"]["WEEKLY"]["DOWN"]=$week_download;




    $thisMonth=date("Y-m-01 00:00:00");
    $ligne=$q->mysqli_fetch_array("SELECT  SUM(size) as download FROM statscom WHERE date_trunc('month',zdate)='$thisMonth'");
    $MAIN["TOTAL"]["MONTHLY"]["DOWN"]=$ligne["download"];
    $MAIN["TOTAL"]["HOURLY"]["DOWN"]=$hourly_download;
    $MAIN["TOTAL"]["DAILY"]["DOWN"]=$daily_download;


    $array=array();



    $results=$q->QUERY_SQL("SELECT date_trunc('day', zdate) AS tday FROM statscom WHERE zdate>'$currentWeek' GROUP BY tday ORDER BY tday");

    if(!$q->ok){echo $q->mysql_error."\n";}

    while ($ligne = pg_fetch_assoc($results)) {
        $sday=$ligne["tday"];
        $xtime=strtotime($sday);
        $nextday=str_replace("00:00:00","23:59:59",$sday);
        $results2=$q->QUERY_SQL("SELECT zdate,SUM(size) as download FROM statscom WHERE zdate>'$sday' AND zdate<'$nextday' 
                                GROUP BY zdate ORDER BY zdate");

        if(!$q->ok){
            echo $q->mysql_error. " IN LINE ".__LINE__."\n";
        }

        while ($ligne2 = pg_fetch_assoc($results2)) {
            $download=intval($ligne2["download"]);
            $zdate=$ligne2["zdate"];
            $MAIN["RQ"]["WEEKLY"][$xtime][$zdate]=array("DOW"=>$download);
        }




        $results2=$q->QUERY_SQL("SELECT statscom_websites.category,SUM(statscom.size) as download FROM 
        statscom,statscom_websites WHERE statscom_websites.siteid=statscom.siteid AND zdate>'$sday' AND zdate<'$nextday' GROUP BY category ORDER BY download DESC LIMIT 10");

        if(!$q->ok){
            echo $q->mysql_error. " IN LINE ".__LINE__."\n";
        }

        while ($ligne2 = pg_fetch_assoc($results2)) {
            $category=$ligne2["category"];
            $download=intval($ligne2["download"]);

            echo "$sday - $nextday $category: $download\n";
            $array[$category]=array("DOW"=>$download);
            $MAIN["RQ"]["CATEGORY"][$xtime][$category]=array("DOW"=>$download);
        }

        $results2=$q->QUERY_SQL("SELECT ipaddr,SUM(size) as download FROM statscom 
        WHERE zdate>'$sday' AND zdate<'$nextday'  GROUP BY ipaddr ORDER BY download DESC LIMIT 10");

        while ($ligne2 = pg_fetch_assoc($results2)) {
            $category=$ligne2["ipaddr"];
            $download=intval($ligne2["download"]);
            $array[$category]=array("DOW"=>$download);
            $MAIN["RQ"]["SRC"][$xtime][$category]=array("DOW"=>$download);
        }

        $results2=$q->QUERY_SQL("SELECT siteid,SUM(size) as download FROM statscom 
        WHERE zdate>'$sday' AND zdate<'$nextday'  GROUP BY siteid ORDER BY download DESC LIMIT 10");

        while ($ligne2 = pg_fetch_assoc($results2)) {
            $category=get_siteid($ligne2["siteid"]);
            $download=intval($ligne2["download"]);
            echo "$sday - $nextday $category: $download\n";
            $array[$category]=array("DOW"=>$download);
            $MAIN["RQ"]["FAM"][$xtime][$category]=array("DOW"=>$download);
        }
    }

    try {
        $redis = new Redis();
        $redis->connect("127.0.0.1", 4322, 2);
    } catch (Exception $e) {
        $unix=new unix();
        $unix->ToSyslog("dashboard_stats(): ".$e->getMessage(),"stats-communicator");
    }
    $redis->set("DASBOARD.ALLSTATS",base64_encode(serialize($MAIN)));
    $redis->close();
}



function build_blocked(){

    $f=array();
    $q=new postgres_sql();
    if(!$q->CREATE_STATSCOM()){return null;}
    $unix=new unix();
    $squidfamily=new squid_familysite();

    try {
        $redis = new Redis();
        $redis->connect("127.0.0.1", 4322, 2);
    } catch (Exception $e) {
        $unix->ToSyslog("build_blocked(): ".$e->getMessage(),"stats-communicator");
    }

    $ALL_KEYS=$redis->keys("BLOCKED.*");
    $CurrentTimeStamp=CurrentTimeStamp();
    $prefix="INSERT INTO statsblocks (zdate,username,ipaddr,mac,siteid,hits,block) VALUES ";
    $keysToDelete=array();
    foreach ($ALL_KEYS as $key) {

        echo "$key\n";
        if(!preg_match("#^BLOCKED\.([0-9]+)\.[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+\|#",$key)){
            echo "Wrong key $key\n";
            $redis->del($key);
            continue;
        }

        preg_match("#^BLOCKED\.([0-9]+)\.(.+)#",$key,$re);
        $Time=$re[1];
        $records=$re[2];
        if($CurrentTimeStamp==$Time){continue;}
        $zdate=date("Y-m-d H:i:s",$Time);
        echo "$zdate ($records)\n";
        $elements=explode("|",$records);
        $ipaddr=$elements[0];
        $MAC=$elements[1];
        $username=$elements[2];
        $sitename=$elements[3];
        $category=$elements[4];
        $block=$elements[5];
        if(strpos(" $sitename",'::')>0){continue;}
        $hits=$redis->get($key);
        $family=$squidfamily->GetFamilySites($sitename);
        $siteid=get_siteid($sitename,$family,$category);
        if($siteid==0){continue;}
        $line="('$zdate','$username','$ipaddr','$MAC','$siteid','$hits','$block')";

        $f[]=$line;
        $keysToDelete[]=$key;
    }

    if(count($f)>0){
        $q->QUERY_SQL($prefix." ".@implode(",",$f));
        if(!$q->ok){
            squid_admin_mysql(1,"PostgreSQL Error $q->mysql_error",$q->mysql_error,__FILE__,__LINE__);
            return false;
        }
    }

    if(count($keysToDelete)>0){
        echo "build_blocked():: Remove ".count($keysToDelete)." keys from memory\n";
        $redis->del($keysToDelete);
    }

    $ligne=$q->mysqli_fetch_array("SELECT SUM(hits) as hits FROM statsblocks");
    $redis->set("DASHBOARD.TOTAL.BLOCKED",intval($ligne["hits"]));



}
function UsersSimple(){
    $unix=new unix();
    $q=new postgres_sql();
    $q->CREATE_STATSCOM();
    $prefix="INSERT INTO statscom_husers(username,ipaddr,mac,stime, hits,size ) VALUES ";


    try {
        $redis = new Redis();
        $redis->connect("127.0.0.1", 4322, 2);
    } catch (Exception $e) {
        $unix->ToSyslog("SitesSimple(): ".$e->getMessage(),"stats-communicator");
        return;
    }
    $IpClass=new IP();
    $CurrentTimeStamp=CurrentTimeStamp();
    $ALL_KEYS=$redis->keys("USERS.*");
    $KeysToDelete=array();
    echo "UsersSimple() USERS.*:". count($ALL_KEYS)." Keys\n";
    $f=array();
    foreach ($ALL_KEYS as $key) {
        preg_match("#^USERS\.([0-9]+)\.(.+)#", $key, $re);
        $stime=$re[1];
        if($stime==$CurrentTimeStamp){continue;}
        $records=explode("|",$re[2]);

        $ipaddr     = $records[0];
        $MAC        = $records[1];
        $username   = $records[2];
        $data       = $redis->hgetall($key);
        if(!$IpClass->isValid($ipaddr)){
            continue;
        }
        if($MAC<>"00:00:00:00:00:00") {
            if (!$IpClass->IsvalidMAC($MAC)) {
                continue;
            }
        }


        if(!isset($data["RQS"])){$data["RQS"]=1;}
        $size       = intval($data["SIZE"]);
        $rqs        = intval($data["RQS"]);
        $KeysToDelete[]=$key;
        $f[]="('$username','$ipaddr','$MAC','$stime','$rqs','$size')";
    }

    if(count($f)>0) {
        $q->QUERY_SQL($prefix . @implode(",", $f). " ON CONFLICT DO NOTHING");
        if (!$q->ok) {
            echo "UsersSimple() ".$q->mysql_error . "line:".__LINE__."\n";
            $unix->ToSyslog("UsersSimple(): PostGreSQL Error: $q->mysql_error", "stats-communicator");
            return;
        }
        echo "UsersSimple(): " . Count($KeysToDelete) . " Keys to delete\n";
        $redis->del($KeysToDelete);
    }
    $ALL_KEYS=$redis->keys("MEMBER.*");
    foreach ($ALL_KEYS as $key) {
        $redis->del($key);
    }


    $redis->close();
}

function SitesSimple(){
    $unix=new unix();
    $faml=new squid_familysite();
    $q=new postgres_sql();
    $q->CREATE_STATSCOM();
    $prefix="INSERT INTO statscom_hsites(uniqueid,siteid,stime, hits,size ) VALUES ";

    try {
        $redis = new Redis();
        $redis->connect("127.0.0.1", 4322, 2);
    } catch (Exception $e) {
        $unix->ToSyslog("SitesSimple(): ".$e->getMessage(),"stats-communicator");
        return;
    }

    $CurrentTimeStamp=CurrentTimeStamp();
    $ALL_KEYS=$redis->keys("PROXY.*");
    $KeysToDelete=array();
    $f=array();
    echo count($ALL_KEYS)." Internet sites\n";
    foreach ($ALL_KEYS as $key) {
        preg_match("#^PROXY\.([0-9]+)\.(.+)#", $key, $re);
        $stime=$re[1];
        if($stime==$CurrentTimeStamp){continue;}
        echo "$key --> {$re[2]} ".__LINE__."\n";
        $records=explode("|",$re[2]);
       // $sitename|$category|$proxyName|$uniqueid
        $familysite = $faml->GetFamilySites($records[0]);
        $uniqueid   = get_entityid($records[3],$records[2]);
        $siteid     = get_siteid($records[0],$records[1],$familysite);
        if($siteid==0){continue;}
        $data       = $redis->hgetall($key);
        $size       = intval($data["SIZE"]);
        $rqs        = intval($data["RQS"]);
        $KeysToDelete[]=$key;

        if(!isset($GLOBALS["STATSCOM"][$siteid])){
            $GLOBALS["STATSCOM"][$siteid]["SIZE"]=0;
            $GLOBALS["STATSCOM"][$siteid]["RQS"]=0;
        }
        $GLOBALS["STATSCOM"][$siteid]["SIZE"]=$GLOBALS["STATSCOM"][$siteid]["SIZE"]+$size;
        $GLOBALS["STATSCOM"][$siteid]["RQS"]=$GLOBALS["STATSCOM"][$siteid]["RQS"]+$rqs;

        $f[]="('$uniqueid','$siteid','$stime','$rqs','$size')";
    }
    if(count($f)>0) {
        $q->QUERY_SQL($prefix . @implode(",", $f) . " ON CONFLICT DO NOTHING");
        if (!$q->ok) {
            echo $q->mysql_error . "\n";
            $unix->ToSyslog("SitesSimple(): PostGreSQL Error: $q->mysql_error", "stats-communicator");
            return;
        }
    }
    if(count($KeysToDelete)>0) {
        echo "SitesSimple(): " . Count($KeysToDelete) . " Keys to delete\n";
        $redis->del($KeysToDelete);
        $redis->close();
    }

    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("STATSCOM",serialize($GLOBALS["STATSCOM"]));
}

function ProxySimple(){
    $unix=new unix();
    $q=new postgres_sql();
    $q->CREATE_STATSCOM();
    $prefix="INSERT INTO statscom_proxies (uniqueid,stime, hits,size ) VALUES ";

    try {
        $redis = new Redis();
        $redis->connect("127.0.0.1", 4322, 2);
    } catch (Exception $e) {
        $unix->ToSyslog("ProxySimple(): ".$e->getMessage(),"stats-communicator");
        return;
    }

    $CurrentTimeStamp=CurrentTimeStamp();
    $ALL_KEYS=$redis->keys("PROXY.*");
    $KeysToDelete=array();
    echo count($ALL_KEYS)." Proxies\n";
    $f=array();
    foreach ($ALL_KEYS as $key){
        preg_match("#^PROXY\.([0-9]+)\.(.+)#",$key,$re);
        $stime=$re[1];
        $uniqueid=get_entityid(trim($re[2]),null);
        $PROXYS_COUNT[$uniqueid]=true;
        if($stime==$CurrentTimeStamp){
            echo "ProxySimple():: $key --> SKIP\n";
            continue;
        }
        $data=$redis->hgetall($key);
        $size=$data["SIZE"];
        $rqs=$data["RQS"];
        $KeysToDelete[]=$key;
        $f[]="('$uniqueid','$stime','$rqs','$size')";
    }

    if(count($f)>0) {
        $q->QUERY_SQL($prefix . @implode(",", $f) . " ON CONFLICT DO NOTHING");
        if (!$q->ok) {
            echo $q->mysql_error . "\n";
            return;
        }
    }
    if(count($KeysToDelete)>0) {
        echo "ProxySimple():: ".Count($KeysToDelete) . " Keys to delete\n";
        $redis->del($KeysToDelete);
    }

    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("STATSCOM_PROXYNAME",serialize($PROXYS_COUNT));

    $redis->close();


}


function UserAgents(){

    $unix=new unix();
    $useragents=new useragents(false);
    $q=new lib_sqlite("/home/artica/SQLITE/acls.db");
    $sql="CREATE TABLE IF NOT EXISTS UserAgents ( source TEXT PRIMARY KEY, regex TEXT)";
    $q->QUERY_SQL($sql);


    try {
        $redis = new Redis();
        $redis->connect("127.0.0.1", 4322, 2);
    } catch (Exception $e) {
        $unix->ToSyslog("UserAgents(): ".$e->getMessage(),"stats-communicator");
        return;
    }

    $ALL_KEYS=$redis->keys("USERAGENT.*");

    echo count($ALL_KEYS)." UsersAgents\n";
    foreach ($ALL_KEYS as $key){
        $USERAGENT=$redis->get($key);
        $USERAGENT=url_decode_special_tool($USERAGENT);
        $regex=$useragents->PatternToRegex($USERAGENT);
        $USERAGENT=$q->sqlite_escape_string2($USERAGENT);
        $regex=$q->sqlite_escape_string2($regex);
        $sql="INSERT OR IGNORE INTO UserAgents(source,regex) VALUES ('$USERAGENT','$regex')";
        $q->QUERY_SQL($sql);
        $redis->del($key);
        if(!$q->ok){
            echo $q->mysql_error."\n";
            return true;
        }
    }

    $q->QUERY_SQL("DELETE FROM UserAgents WHERE source LIKE '%squid-%):%'");
    $q->QUERY_SQL("DELETE FROM UserAgents WHERE source LIKE '%\%20%' ESCAPE '\'");

}



function import_users($USERS){
    $q=new postgres_sql();
    $fu=array();
    foreach ($USERS as $md5=>$row){
        $fu[]=$row;
        if(count($fu)>500){
            $q->QUERY_SQL("INSERT INTO statscom_users (zmd5,username,ipaddr,mac) VALUES ".@implode(",",$fu). " ON CONFLICT DO NOTHING");
            if(!$q->ok){echo $q->mysql_error."\n";}
            $fu=array();
        }

    }

    if(count($fu)>0){
        $q->QUERY_SQL("INSERT INTO statscom_users (zmd5,username,ipaddr,mac) VALUES ".@implode(",",$fu). " ON CONFLICT DO NOTHING");
        if(!$q->ok){echo $q->mysql_error."\n";}
    }
}

function parse_elements($time,$elements){


    $prefix="INSERT INTO statscom (zdate,username,ipaddr,mac,siteid,hits,size,entityid) VALUES ";
    $q=new postgres_sql();
    $catz=new mysql_catz();
    $fam=new squid_familysite();
    $date=date("Y-m-d H:i:s",$time);

    if($GLOBALS["DEBUG"]){
        echo "parse_elements: $date\n";
    }

    $f=array();
    foreach ($elements as $SiteCat=>$usersArray){
        $tb=explode("|",$SiteCat);
        $sitename=trim(strtolower($tb[0]));
        $category=intval($tb[1]);
        $proxname=trim($tb[2]);
        $uuid=trim($tb[3]);
        if($sitename=="-"){continue;}
        if(strpos("  $sitename","::")>0){continue;}
        if($uuid==null){
            echo "UUID === NULL?\n";
            continue;}

        if($sitename==null){continue;}
        $familysite=$fam->GetFamilySites($sitename);
        if($category==0){$category=$catz->GET_CATEGORIES($sitename);}

        $siteid=get_siteid($sitename,$familysite,$category);
        if($siteid==0){
            echo "Fatal unable to get siteid from $sitename\n";
            squid_admin_mysql("Fatal unable to get siteid from $sitename",null,__FILE__,__LINE__);
            continue;
        }

        $entityid=get_entityid($uuid,$proxname);
        if($entityid==0){
            echo "Fatal unable to get entityid from $uuid\n";
            squid_admin_mysql("Fatal unable to get entityid from $uuid",null,__FILE__,__LINE__);
            die();
        }

        foreach ($usersArray as $usernames=>$metrics){

            $size=$metrics["SIZE"];
            $reqs=$metrics["RQS"];
            if($GLOBALS["DEBUG"]){echo "$sitename: $usernames size=$size, RQS=$reqs\n";}
            $tb=explode("|",$usernames);
            $username=trim($tb[2]);
            $ipaddr=trim($tb[0]);
            if($ipaddr=="-"){continue;}
            if(!preg_match("#^[0-9\.]+$#",$ipaddr)){continue;}
            $mac=trim($tb[1]);

            $md5_user=md5("$username$ipaddr$mac");
            $USERS[$md5_user]="('$md5_user','$username','$ipaddr','$mac')";
            $linez="('$date','$username','$ipaddr','$mac','$siteid','$reqs','$size','$entityid')";
            if($GLOBALS["DEBUG"]){echo "$sitename: $linez\n";}
            $f[]=$linez;



        }
    }

    if(count($f)>0){
        $GLOBALS["COUNT_ENTRIES"]=$GLOBALS["COUNT_ENTRIES"]+count($f);
        $sql=$prefix.@implode(",",$f);
        $q->QUERY_SQL($sql);
        if(!$q->ok){
            if($GLOBALS["DEBUG"]){
                echo "statscom failed with error $q->mysql_error\n";
            }
            squid_admin_mysql("statscom failed with error $q->mysql_error",$q->mysql_error,__FILE__,__LINE__);
            return false;
        }
    }

    import_users($USERS);

    return true;

}

function get_entityid($uuid,$proxname=null){
    if(isset($GLOBALS["get_entityid"][$uuid])){
        return intval($GLOBALS["get_entityid"][$uuid]);
    }

    $q=new postgres_sql();
    $ligne=$q->mysqli_fetch_array("SELECT entityid from statscom_entity WHERE entityname='$uuid'");
    $siteid=intval($ligne["entityid"]);
    if($siteid==0) {
        if($proxname<>null) {
            $q->QUERY_SQL("INSERT INTO statscom_entity(entityname,entitylabel) VALUES ('$uuid','$proxname')");
            $ligne = $q->mysqli_fetch_array("SELECT entityid from statscom_entity WHERE entityname='$uuid'");
            $siteid = intval($ligne["entityid"]);
        }

    }
    if($siteid>0) {
        $GLOBALS["get_entityid"][$uuid] = $siteid;
        return intval($GLOBALS["get_entityid"][$uuid]);
    }
    return 0;
}

function get_siteid($sitename,$familysite=null,$category=0){

    if(trim($sitename)==null){return 0;}
    if(is_numeric($sitename)){return 0;}

    if(isset($GLOBALS["get_siteid"][$sitename])){
        return intval($GLOBALS["get_siteid"][$sitename]);
    }

    $q=new postgres_sql();
    $ligne=$q->mysqli_fetch_array("SELECT siteid from statscom_websites WHERE sitename='$sitename'");
    if(!$q->ok){echo $q->mysql_error."\n";}

    $siteid=intval($ligne["siteid"]);
    if($GLOBALS["DEBUG"]){echo "get_siteid(): statscom_websites $sitename == {$ligne["siteid"]}\n";}
    if($siteid==0) {
        if($familysite==null){return 0;}
        $q->QUERY_SQL("INSERT INTO statscom_websites(sitename,familysite,category) 
                                VALUES ('$sitename','$familysite','$category')");
        if($GLOBALS["DEBUG"]){echo "statscom_websites $sitename,$familysite,$category ==> INSERT\n";}
        if(!$q->ok){echo $q->mysql_error."\n";}
        $ligne=$q->mysqli_fetch_array("SELECT siteid from statscom_websites WHERE sitename='$sitename'");
        $siteid=intval($ligne["siteid"]);

    }

    $GLOBALS["get_siteid"][$sitename]=intval($siteid);
    return intval($GLOBALS["get_siteid"][$sitename]);

}

function build_users_days(){
    $q=new postgres_sql();
    $sql="SELECT username,ipaddr,mac FROM statscom_days GROUP BY username,ipaddr,mac";
    $results=$q->QUERY_SQL($sql);
    if(!$q->ok){echo $q->mysql_error."\n";return;}
    while ($ligne = pg_fetch_assoc($results)) {
        $username=trim($ligne["username"]);
        $ipaddr=trim($ligne["ipaddr"]);
        $mac=trim($ligne["mac"]);
        $md5_user=md5("$username$ipaddr$mac");
        echo "('$md5_user','$username','$ipaddr','$mac')\n";
        $USERS[$md5_user]="('$md5_user','$username','$ipaddr','$mac')";
    }
 import_users($USERS);
}

function build_days(){
    build_maintenance();
    $q=new postgres_sql();

    $sql="SELECT zdate,SUM(size) as size FROM statscom_days GROUP BY zdate ORDER BY zdate";
    $results=$q->QUERY_SQL($sql);
    if(!$q->ok){echo $q->mysql_error."\n";return;}
    while ($ligne = pg_fetch_assoc($results)) {
        $ALREADY[$ligne["zdate"]]=$ligne["size"];
    }

echo count($ALREADY)." days already imported\n";
    $sql="SELECT date(zdate) as xdate, SUM(size) as size FROM statscom GROUP BY xdate ORDER BY xdate";
    $CurrentDay=date("Y-m-d");
    $results=$q->QUERY_SQL($sql);
    if(!$q->ok){echo $q->mysql_error."\n";return;}
    while ($ligne = pg_fetch_assoc($results)) {

        $day=$ligne["xdate"];
        if($CurrentDay==$day){continue;}
        $size=$ligne["size"];

        echo "$day ($size) ";
        if(isset($ALREADY[$day])){
            echo "Done if $size == {$ALREADY[$day]}";
            if($size==$ALREADY[$day]){echo " OK\n";continue;}
            $q->QUERY_SQL("DELETE FROM statscom_days WHERE zdate='$day'");
            echo " Restart...\n";
        }

        if(!transfert_day($day)){
            $q->QUERY_SQL("DELETE FROM statscom_days WHERE zdate='$day'");
            continue;
        }

    }

    $sql="SELECT SUM(size) as size, SUM(hits) as hits, siteid FROM statscom_days GROUP BY siteid";
    $results=$q->QUERY_SQL($sql);
    if(!$q->ok){echo $q->mysql_error."\n";return;}
    while ($ligne = pg_fetch_assoc($results)) {
        $size=$ligne["size"];
        $hits=$ligne["hits"];
        $siteid=$ligne["siteid"];
        $q->QUERY_SQL("UPDATE statscom_websites SET hitsTot=$hits,sizeTot=$size WHERE siteid=$siteid");
        echo "Updating site $siteid\n";
    }

    entities();
    Nocategorized();
    build_users_days();
}



function entities(){
    $q=new postgres_sql();

    $sql="SELECT entityid FROM statscom_entity";
    $results=$q->QUERY_SQL($sql);
    if(!$q->ok){echo $q->mysql_error."\n";return;}
    while ($ligne = pg_fetch_assoc($results)) {
        $entityid=$ligne["entityid"];
        echo "Update entity ID $entityid\n";
        $ligne2=$q->mysqli_fetch_array("SELECT SUM(size) as size, SUM(hits) as hits FROM statscom_days WHERE entityid='$entityid'");
        if(!$q->ok){echo $q->mysql_error."\n";return;}

        $hits=$ligne2["hits"];
        $size=$ligne2["size"];
        $q->QUERY_SQL("UPDATE statscom_entity SET hits=$hits,size=$size WHERE entityid='$entityid'");
        if(!$q->ok){echo $q->mysql_error."\n";return;}
    }
}

function Nocategorized(){
    $q=new postgres_sql();
    $unix=new unix();
    $catz=new mysql_catz();
    $catz->NoNegativeCache=true;
    $c=0;
    $unix->Popuplate_cron_make("statscom-categorize","30 23 * * *","exec.statscom-stats.php --catz");
    $memcache=new lib_memcached();

    $results=$q->QUERY_SQL("SELECT sitename,siteid FROM statscom_websites WHERE category=0");
    while ($ligne = pg_fetch_assoc($results)) {
        $siteid=intval($ligne["siteid"]);
        $sitename=$ligne["sitename"];
        $category=$catz->GET_CATEGORIES($sitename);
        if($category>0){
            $c++;
            $key_not_categorized="notcategorized.".strtolower($sitename);
            $memcache->Delkey($key_not_categorized);
            $text[]="$sitename categorized in ".$catz->CategoryIntToStr($category);
            $q->QUERY_SQL("UPDATE statscom_websites SET category=$category WHERE siteid='$siteid'");
            continue;
        }

        echo "$sitename Unknown...\n";

    }

    if($c>0){
        $smtp=new statscom_msmtp();
        $recipient=$smtp->recipient;
        if($recipient<>null){
            $smtp->Subject="$c unknown websites fixed and categorized";
            $smtp->Send(@implode("\r\n",$text));
        }

        squid_admin_mysql(1,"$c unknown websites fixed and categorized",null,__FILE__,__LINE__);
    }
}


function transfert_day($day){
    $q=new postgres_sql();
    $CurrentDay=date("Y-m-d");
    if($day==$CurrentDay){return false;}

    if(!$q->CREATE_STATSCOM()){
        echo "error:".$q->mysql_error."\n";
        return;
    }


    $sql="SELECT date(zdate) as xdate,username,ipaddr,mac,siteid,entityid,SUM(hits) as hits,SUM(size) as size FROM statscom WHERE date(zdate)='$day' GROUP BY xdate,username,ipaddr,mac,siteid,entityid";
    $f=array();
    $results=$q->QUERY_SQL($sql);

    $prefix="INSERT INTO statscom_days (zdate,username,ipaddr,mac,siteid,entityid,size,hits) VALUES ";


    if(!$q->ok){echo $q->mysql_error."\n";return false;}
    while ($ligne = pg_fetch_assoc($results)) {
        $zdate=$ligne["xdate"];
        $username=trim($ligne["username"]);
        $ipaddr=trim($ligne["ipaddr"]);
        $mac=trim($ligne["mac"]);
        $siteid=intval($ligne["siteid"]);
        $entityid=intval($ligne["entityid"]);
        $size=intval($ligne["size"]);
        $hits=intval($ligne["hits"]);
        $md5_user=md5("$username$ipaddr$mac");
        $USERS[$md5_user]="('$md5_user','$username','$ipaddr','$mac')";

        $line="('$zdate','$username','$ipaddr','$mac','$siteid','$entityid','$size','$hits')";
        $f[]=$line;

        if(count($f)>5000){
            $q->QUERY_SQL($prefix.@implode(",",$f));
            if(!$q->ok){
                echo $q->mysql_error;
                return false;
            }

            $f=array();
        }

    }

    if(count($f)>0){
        $q->QUERY_SQL($prefix.@implode(",",$f));
        if(!$q->ok){
            echo $q->mysql_error;
            return false;
        }
    }

    import_users($USERS);

    return true;

}

function CurrentTimeStamp(){
    $date = new DateTime(date("Y-m-d H:i:s"));
    $date = roundToNearestMinuteInterval($date);
    return $date->getTimestamp();
}

function roundToNearestMinuteInterval(\DateTime $dateTime, $minuteInterval = 10)
{
    return $dateTime->setTime(
        $dateTime->format('H'),
        round($dateTime->format('i') / $minuteInterval) * $minuteInterval,
        0
    );
}

function events($text,$line=0){
    $filename=basename(__FILE__);
    $pid=getmypid();
    $date=date("H:i:s");
    $logFile="/var/log/statscom-stats.log";
    $size=filesize($logFile);
    if($size>1000000){unlink($logFile);}

    $f = @fopen($logFile, 'a');
    @fwrite($f, "$date [$pid]: $text line:$line\n");
    if($GLOBALS["VERBOSE"]){echo "$filename[$pid] $date $text\n";}
    @fclose($f);
}