<?php
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
$GLOBALS["FORCE"]=false;
$GLOBALS["RECONFIGURE"]=false;
$GLOBALS["NO_START"]=false;
$GLOBALS["SWAPSTATE"]=false;
$GLOBALS["NOSQUIDOUTPUT"]=true;
$GLOBALS["TITLENAME"]="Kernel Optimization";
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;$GLOBALS["OUTPUT"]=true;$GLOBALS["debug"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
if(preg_match("#--output#",implode(" ",$argv))){$GLOBALS["OUTPUT"]=true;}
if(preg_match("#schedule-id=([0-9]+)#",implode(" ",$argv),$re)){$GLOBALS["SCHEDULE_ID"]=$re[1];}
if(preg_match("#--force#",implode(" ",$argv),$re)){$GLOBALS["FORCE"]=true;}
if(preg_match("#--reconfigure#",implode(" ",$argv),$re)){$GLOBALS["RECONFIGURE"]=true;}
if(preg_match("#--reboot#",implode(" ",$argv),$re)){$GLOBALS["REBOOT"]=true;}
if(preg_match("#--nostart#",implode(" ",$argv),$re)){$GLOBALS["NO_START"]=true;}
$GLOBALS["AS_ROOT"]=true;
$GLOBALS["REBOOT"]=false;
include_once(dirname(__FILE__).'/ressources/class.ldap.inc');
include_once(dirname(__FILE__).'/ressources/class.squid.inc');
include_once(dirname(__FILE__).'/ressources/class.mysql.inc');

include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.settings.inc');
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.system.nics.inc');
include_once(dirname(__FILE__).'/ressources/class.identity.inc');



$GLOBALS["ARGVS"]=implode(" ",$argv);
if($argv[1]=="--stop"){$GLOBALS["OUTPUT"]=true;stop();exit();}
if($argv[1]=="--start"){$GLOBALS["OUTPUT"]=true;start();exit();}
if($argv[1]=="--restart"){$GLOBALS["OUTPUT"]=true;restart();exit();}
if($argv[1]=="--build"){$GLOBALS["OUTPUT"]=true;build();exit();}
if($argv[1]=="--rand"){randomizekeys();}

function randomizekeys()
{

    $key = exec("/usr/bin/openssl rand -hex 16 2>&1");

    $rand1 = substr($key, 0, 8);
    $rand2 = substr($key, 8, 8);
    $rand3 = substr($key, 16, 8);
    $rand4 = substr($key, 24, 8);

    @file_put_contents("/tmp/rand.tmp", "$rand1-$rand2-$rand3-$rand4");
}




function build_progress($pourc,$text){
	$cachefile="/usr/share/artica-postfix/ressources/logs/sysctl.progress";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($cachefile, serialize($array));
	@chmod($cachefile,0755);
}

function restart() {
	build_progress(10, "{starting}");
	
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pid=$unix->get_pid_from_file($pidfile);
	if($unix->process_exists($pid,basename(__FILE__))){
		$time=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Already Artica task running PID $pid since {$time}mn\n";}
		return;
	}
	@file_put_contents($pidfile, getmypid());
	stop(true);
	build_progress(50, "{configuring}");
	build();
	sleep(1);
	build_progress(99, "{configuring}");
	start(true);
	build_progress(100, "{done}");
}


function start($aspid=false){
	$unix=new unix();
	$sock=new sockets();
	$Masterbin=$unix->find_program("sysctl");

	if(!is_file($Masterbin)){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]}, sysctl not installed\n";}
		return;
	}
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]}..\n";}
	shell_exec("$Masterbin -p >/dev/null;");
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Done.\n";}
}


function build(){
	$unix=new unix();
	
	if($unix->ServerRunSince()<3){return;}
    $sidentity=new sidentity();
    $WizardSavedSettings=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("WizardSavedSettings")));
    $WizardSavedSettings=$sidentity->RepairSidentity($WizardSavedSettings);
	
	$sock=new sockets();
	$Isagetway=false;
	$INSTALL_SERVICE=false;
	$KernelSendRedirects=$sock->GET_INFO("KernelSendRedirects");
	$squidbin=$unix->LOCATE_SQUID_BIN();
	if(!is_numeric($KernelSendRedirects)){$KernelSendRedirects=1;}
	$conntrack=$unix->find_program("conntrack");
	$EnableChilli=$sock->GET_INFO("EnableChilli");
	$EnableArticaAsGateway=$sock->GET_INFO("EnableArticaAsGateway");
	if(!is_numeric($EnableChilli)){$EnableChilli=0;}
	$hasProxyTransparent=$sock->GET_INFO("hasProxyTransparent");
	if(!is_numeric($hasProxyTransparent)){$hasProxyTransparent=0;}

    $hostname=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("myhostname"));

	
	if($EnableChilli==1){$Isagetway=true;}
	if($EnableArticaAsGateway==1){$Isagetway=true;}
	if($hasProxyTransparent==1){$Isagetway=true;}
	if(is_file("/etc/artica-postfix/IPTABLES_BR_BRIDGE")){$Isagetway=true;}
	if(is_file("/etc/artica-postfix/IPTABLES_BRIDGE")){$Isagetway=true;}
	
	$EnableipV6=intval($sock->GET_INFO("EnableipV6"));

	
	$ARRAY=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("kernel_values")));
	
	$swappiness=intval($ARRAY["swappiness"]);
	if($swappiness==0){$swappiness=10;}
	$tcp_max_syn_backlog=$ARRAY["tcp_max_syn_backlog"];
	if(!is_numeric($tcp_max_syn_backlog)){$tcp_max_syn_backlog=1024;}
	$EnableTCPOptimize=$sock->GET_INFO("EnableTCPOptimize");
	$DisableConntrack=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DisableConntrack"));
	if(!is_numeric($EnableTCPOptimize)){$EnableTCPOptimize=1;}
	
	$DisableTCPOptimizations=$sock->GET_INFO("DisableTCPOptimizations");
	if($DisableTCPOptimizations==1){$EnableTCPOptimize=0;}
	
	
	$echo=$unix->find_program("echo");
	$modprobe=$unix->find_program("modprobe");
	$EnableArticaAsGateway=intval(trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableArticaAsGateway")));
	$DisableTCPEn=intval(trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DisableTCPEn")));
	$DisableTCPWindowScaling=intval(trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DisableTCPWindowScaling")));
	$EnableSystemOptimize=intval(trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableSystemOptimize")));
	$EnableConntrack=intval(trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableConntrack")));
	$EnableSystemNetworkOptimize=intval(trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableSystemNetworkOptimize")));
	$AS_SQUID=false;
	if(is_file($squidbin)){
		$SQUIDEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable"));
		if($SQUIDEnable==1){$AS_SQUID=true;}
	}
	
	
	$tcp_ecn=2;
	$tcp_window_scaling=1;
	if($DisableTCPWindowScaling==1){$tcp_window_scaling=0;}
	if($DisableTCPEn==1){$tcp_ecn=0;}
	$sysctl=$unix->find_program("sysctl");

	$memory=$unix->MEM_TOTAL_INSTALLEE()*1024;
	$dirty_ratio=round($memory*0.8);
	if($tcp_max_syn_backlog<1025){$tcp_max_syn_backlog=10240;}
	$wmem_max=trim(intval(@file_get_contents("/proc/sys/net/core/wmem_max")));
	
	$f[]="#";
	$f[]="# /etc/sysctl.conf - Configuration file for setting system variables";
	$f[]="# See /etc/sysctl.d/ for additonal system variables";
	$f[]="# See sysctl.conf (5) for information.";
	$f[]="#";
	$f[]="";
	$f[]="#kernel.domainname = example.com";
	$f[]="";
	$f[]="# Uncomment the following to stop low-level messages on console";
	$f[]="kernel.printk = 3 4 1 3";
	$f[]="";
	$f[] = "##############################################################";
	$f[] = "kernel.hostname=$hostname";
	$f[] = "kernel.domainname=";
    $cat=$unix->find_program("cat");
    $chmod=$unix->find_program("chmod");
	$mkdir=$unix->find_program("mkdir");
	$chown=$unix->find_program("chown");
	$echo =$unix->find_program("echo");
    $php=$unix->LOCATE_PHP5_BIN();
	$CMDLINE[]="";
	$CMDLINE[]="if [ ! -f \"\/etc/sysctl.d/50-tcp_fastopen_key.conf\" ]; then";
	$CMDLINE[]="\t$php ".__FILE__." --rand";
    $CMDLINE[]="\tNEWKEY=`$cat /tmp/rand.tmp`";
	$CMDLINE[]="\t$echo \"TCP Fast open init with \$NEWKEY\"";
	$CMDLINE[]="\t$mkdir -p /etc/sysctl.d || true";
	$CMDLINE[]="\t$echo \"net.ipv4.tcp_fastopen=0x3\" > /etc/sysctl.d/50-tcp_fastopen_key.conf";
	$CMDLINE[]="\t$echo \"net.ipv4.tcp_fastopen_key=\$NEWKEY\" >> /etc/sysctl.d/50-tcp_fastopen_key.conf";
	$CMDLINE[]="\t$chmod 600 /etc/sysctl.d/50-tcp_fastopen_key.conf; $chown root /etc/sysctl.d/50-tcp_fastopen_key.conf";
	$CMDLINE[]="\tunset NEWKEY";
	$CMDLINE[]="fi";
	$CMDLINE[]="\t$sysctl -p /etc/sysctl.d/50-tcp_fastopen_key.conf";
	$CMDLINE[]="";

    $overcommit_memory=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("overcommit_memory"));
    $overcommit_ratio=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("overcommit_ratio"));

	$f[]="############################### VM ############";
	$f[]="vm.swappiness = $swappiness";
    $f[] = "vm.overcommit_memory = $overcommit_memory";

    if($overcommit_memory==2) {
        if ($overcommit_ratio < 50) {
            $f[] = "vm.overcommit_ratio = 95";
        } else {
            $f[] = "vm.overcommit_ratio = $overcommit_ratio";
        }
    }

	$f[]="vm.panic_on_oom = 0";
	$f[]="vm.oom_kill_allocating_task = 0";
	$f[]="vm.oom_dump_tasks = 1";

	$f[]="vm.page-cluster = 3";
	if($EnableSystemOptimize==0){
		$f[]="vm.dirty_background_ratio = 10";
		$f[]="vm.dirty_background_bytes = 0";
		$f[]="vm.dirty_ratio = 20";
		$f[]="vm.dirty_bytes = 0";
		$f[]="vm.vfs_cache_pressure=50";
		$f[]="vm.dirty_ratio=20"; //def 40
		$f[]="vm.dirty_background_ratio=5";     # default is 10
	}
	
	
	if($EnableSystemOptimize==1){
		$f[]="vm.dirty_background_ratio = 4";
		$f[]="vm.dirty_background_bytes = 33554432";
		$f[]="vm.dirty_ratio = 64";
		$f[]="vm.dirty_bytes = 100663296";
		$f[]="vm.vfs_cache_pressure=50";
		$f[]="vm.dirty_ratio=20"; //def 40
		$f[]="vm.dirty_background_ratio=5";     # default is 10		
		
		
	}
	

	$f[]="net.ipv4.tcp_window_scaling = $tcp_window_scaling";
	
	
	$ip_forward=0;
	$send_redirects=1;
	$accept_redirects=1;

	if($EnableArticaAsGateway==1){
		$ip_forward=1;
		$send_redirects=1;
		$accept_redirects=1;
		$Isagetway=true;
	}




    $KernelModulesDisabled=	intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("KernelModulesDisabled"));
    $EnableDHCPRelay=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableDHCPRelay"));
	$INTERFACES=$unix->NETWORK_ALL_INTERFACES();
	reset($INTERFACES);

    $f[]="# The maximum number of \"backlogged sockets\".  Default is 128.";
    $f[]="net.core.somaxconn = 1024";
    $f[]="kernel.sched_autogroup_enabled = 0";
    $f[]="kernel.modules_disabled        =  $KernelModulesDisabled";

	$f[]="# Default settings ---------------------------------------------------------------------------------";
	$f[]="net.ipv4.conf.default.forwarding = 1";
	
	$f[]="net.ipv4.conf.default.accept_redirects = 1";
	$f[]="net.ipv4.conf.default.secure_redirects = 1";
	$f[]="net.ipv4.conf.default.shared_media = 1";
	$f[]="net.ipv4.conf.default.rp_filter = 1";
	$f[]="net.ipv4.conf.default.send_redirects = 1";
	$f[]="net.ipv4.conf.default.accept_source_route = 1";
	$f[]="net.ipv4.conf.default.accept_local = 0";
	$f[]="net.ipv4.conf.default.src_valid_mark = 0";
	$f[]="net.ipv4.conf.default.proxy_arp = 0";
	$f[]="net.ipv4.conf.default.medium_id = 0";
	$f[]="net.ipv4.conf.default.bootp_relay = $EnableDHCPRelay";
	$f[]="net.ipv4.conf.default.log_martians = 0";
	$f[]="net.ipv4.conf.default.tag = 0";
	$f[]="net.ipv4.conf.default.arp_filter = 0";
	$f[]="net.ipv4.conf.default.arp_announce = 0";
	$f[]="net.ipv4.conf.default.arp_ignore = 0";
	$f[]="net.ipv4.conf.default.arp_accept = 0";
	$f[]="net.ipv4.conf.default.arp_notify = 0";
	$f[]="net.ipv4.conf.default.proxy_arp_pvlan = 0";
	$f[]="net.ipv4.conf.default.disable_xfrm = 0";
	$f[]="net.ipv4.conf.default.disable_policy = 0";
	$f[]="net.ipv4.conf.default.force_igmp_version = 0";
	$f[]="net.ipv4.conf.default.promote_secondaries = 0";
	$f[]="";
	$f[]="";
	$f[]="net.ipv4.conf.all.forwarding = 1";
	
	$f[]="net.ipv4.conf.all.accept_redirects = 0";
	$f[]="net.ipv4.conf.all.secure_redirects = 1";
	$f[]="net.ipv4.conf.all.shared_media = 1";
	$f[]="net.ipv4.conf.all.rp_filter = 1";
	$f[]="net.ipv4.conf.all.send_redirects = 1";
	$f[]="net.ipv4.conf.all.accept_source_route = 0";
	$f[]="net.ipv4.conf.all.accept_local = 0";
	$f[]="net.ipv4.conf.all.src_valid_mark = 0";
	$f[]="net.ipv4.conf.all.proxy_arp = 0";
	$f[]="net.ipv4.conf.all.medium_id = 0";
	$f[]="net.ipv4.conf.all.bootp_relay = 0";
	$f[]="net.ipv4.conf.all.log_martians = 0";
	$f[]="net.ipv4.conf.all.tag = 0";
	$f[]="net.ipv4.conf.all.arp_filter = 0";
	$f[]="net.ipv4.conf.all.arp_announce = 0";
	$f[]="net.ipv4.conf.all.arp_ignore = 0";
	$f[]="net.ipv4.conf.all.arp_accept = 0";
	$f[]="net.ipv4.conf.all.arp_notify = 0";
	$f[]="net.ipv4.conf.all.proxy_arp_pvlan = 0";
	$f[]="net.ipv4.conf.all.disable_xfrm = 0";
	$f[]="net.ipv4.conf.all.disable_policy = 0";
	$f[]="net.ipv4.conf.all.force_igmp_version = 0";
	$f[]="net.ipv4.conf.all.promote_secondaries = 0";
	$f[]="";
	$f[]="# Ipv6";
	
	if($EnableipV6==1){
		$f[]="net.ipv6.conf.all.disable_ipv6 = 0";
		$f[]="net.ipv6.conf.default.disable_ipv6 = 0";
		$f[]="net.ipv6.conf.lo.disable_ipv6 = 0";
		$f[]="net.ipv6.conf.all.accept_redirects = $accept_redirects";
		$f[]="net.ipv6.conf.all.accept_source_route = 0";
	}else{
		$f[]="net.ipv6.conf.all.disable_ipv6 = 1";
		$f[]="net.ipv6.conf.default.disable_ipv6 = 1";
		$f[]="net.ipv6.conf.lo.disable_ipv6 = 1";
	}
	
	
	$NOSET=array();
	if($AS_SQUID){
		$q=new lib_sqlite("/home/artica/SQLITE/proxy.db");
		$results=$q->QUERY_SQL("SELECT nic FROM proxy_ports WHERE (TProxy=1) OR (MIKROTIK_PORT=1)");
		if(!$q->ok){echo $q->mysql_error."\n";}
		foreach ($results as $index=>$ligne){
				$Interface=$ligne["nic"];
				if($Interface==null){continue;}
				$NOSET[$Interface]=true;
				$f[]="# Settings TProxy for Interface $Interface";
				$f[]="net.ipv4.conf.$Interface.rp_filter			=	0";
				$f[]="net.ipv4.conf.$Interface.send_redirects		=	0";
				$f[]="net.ipv4.conf.$Interface.accept_redirects		=	0";
				$f[]="";
				$f[]="";
				$Isagetway=true;
			}
		
	
		$results=$q->QUERY_SQL("SELECT ID FROM transparent_ports  WHERE enabled=1");
		foreach ($results as $index=>$ligne){
			$f[]="# Settings Transparent proxy for ID {$ligne["ID"]}";
			$Isagetway=true;
		}


        $qs=new lib_sqlite("/home/artica/SQLITE/firewall.db");
        $results=$qs->QUERY_SQL("SELECT * FROM pnic_bridges WHERE enabled=1");
        foreach ($results as $index=>$ligne){
            $f[]="# Settings gateway for Bridge #{$ligne["ID"]}";
            $Isagetway=true;
        }

	
	}
	
	foreach ($INTERFACES as $Interface=>$value){
		if(preg_match("#-ifb#", $Interface)){continue;}
		if(preg_match("#lo#", $Interface)){continue;}
		if(preg_match("#tun#", $Interface)){continue;}
		if(preg_match("#wccp#", $Interface)){continue;}
		$niClass=new system_nic($Interface);
		$f[]="";
		$f[]="# -----------------------------------------------------------------";
		$f[]="# Settings for Interface $Interface; Enabled=$niClass->SysCtlEnable";
		if($niClass->SysCtlEnable==0){
			$f[]="# SysCtlEnable is disabled for this interface, do nothing\n";
			$f[]="# -----------------------------------------------------------------";
			continue;
		}
		
		if(!isset($NOSET[$Interface])){
			$f[]="net.ipv4.conf.$Interface.rp_filter			=	$niClass->RPFilter";
			$f[]="net.ipv4.conf.$Interface.send_redirects			=	$niClass->SendRedirects";
			$f[]="net.ipv4.conf.$Interface.accept_redirects			=	$niClass->AcceptRedirects";
		}
		$f[]="net.ipv4.conf.$Interface.log_martians			=	$niClass->LogMartians";
		$f[]="net.ipv4.conf.$Interface.accept_source_route			=	$niClass->AcceptSourceRoute";
		$f[]="net.ipv4.conf.$Interface.forwarding			=	$niClass->forwarding";
		$f[]="net.ipv4.conf.$Interface.mc_forwarding			=	$niClass->MCForwarding";
		$f[]="net.ipv4.conf.$Interface.secure_redirects			=	$niClass->SendRedirects";
		
		$f[]="";
		$f[]="# -----------------------------------------------------------------";
		$f[]="";
	}
	
	
	

	
	if($Isagetway){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableArticaAsGateway", 1);
		$ip_forward=1;
	}
	
	$f[]="";
	$f[]="# -----------------------------------------------------------------";
	$f[]="# Forward as router ?";
	$f[]="net.ipv4.ip_forward					=	$ip_forward";

	$f[]="net.ipv4.tcp_max_syn_backlog = 4096";
    $f[]="net.ipv4.tcp_syncookies = 1";
	$f[]="net.ipv4.ip_local_reserved_ports = 9000,80,443,5474";
	$f[]="";
	$f[]="# -----------------------------------------------------------------";
	
	if($Isagetway){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Set as gateway...\n";}
		reset($INTERFACES);
		
	
		if($EnableipV6==1){
			$f[]="net.ipv6.conf.all.send_redirects 		= $send_redirects";
			$f[]="net.ipv6.conf.all.forwarding			= 1";
			$f[]="net.ipv6.conf.all.accept_redirects 	= $accept_redirects";
			$f[]="net.ipv6.conf.all.accept_source_route = 1";

		}
	
	}else{
		
		if($EnableipV6==1){
			$f[]="net.ipv6.conf.all.forwarding			= 0";
			$f[]="net.ipv6.conf.all.accept_redirects 	= $accept_redirects";
		}
		reset($INTERFACES);
	}
	
	$NetCoreRmemMax=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NetCoreRmemMax"));
	$NetIpv4TcpMemLow=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NetIpv4TcpMemLow"));
	$NetIpv4TcpMemPress=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NetIpv4TcpMemPress"));
	$NetIpv4TcpMemPages=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NetIpv4TcpMemPages"));


	if($NetCoreRmemMax==0){$NetCoreRmemMax=16777216;}
	if($NetIpv4TcpMemLow==0){$NetIpv4TcpMemLow=187212;}
	if($NetIpv4TcpMemPress==0){$NetIpv4TcpMemPress=249617;}
	if($NetIpv4TcpMemPages==0){$NetIpv4TcpMemPages=374424;}
	
	$NetIpv4TcpRmemMin=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NetIpv4TcpRmemMin"));
	$NetIpv4TcpRmemDef=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NetIpv4TcpRmemDef"));
	$NetIpv4TcpRmemMax=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NetIpv4TcpRmemMax"));
	if($NetIpv4TcpRmemMin==0){$NetIpv4TcpRmemMin=4096;}
	if($NetIpv4TcpRmemDef==0){$NetIpv4TcpRmemDef=87380;}
	if($NetIpv4TcpRmemMax==0){$NetIpv4TcpRmemMax=6291456;}
	
	$EnableKernelBBR=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableKernelBBR"));
	if($EnableKernelBBR==1){
		if(!is_file("/etc/modprobe.d/bbr.conf")){
			@file_put_contents("/etc/modprobe.d/bbr.conf", "install tcp_bbr\n");
		}
		$CMDLINE[]="$modprobe tcp_bbr >/dev/null 2>&1 || true";		
	}else{
		if(is_file("/etc/modprobe.d/bbr.conf")){@unlink("/etc/modprobe.d/bbr.conf");}
	}
	
	$f[]="";
	$f[]="";
	$f[]=trim(@file_get_contents("/etc/sysctl.d/50-tcp_fastopen_key.conf"));
	$NetIpv4TcpTwReuse=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NetIpv4TcpTwReuse"));
	$NetIpv4TcpTwRecycle=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NetIpv4TcpTwRecycle"));
	$NetIpv4TcpFinTimeOut=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NetIpv4TcpFinTimeOut"));
	if($NetIpv4TcpFinTimeOut==0){$NetIpv4TcpFinTimeOut=60;}

    if($EnableKernelBBR==1) {
        $f[] = "net.core.default_qdisc=fq";
        $f[] = "net.ipv4.tcp_congestion_control=bbr";
    }
	
	
	if($EnableSystemNetworkOptimize==1){
		$f[]="# -----------------------------------------------------------------";
		$f[]="# Optimized settings....";
		$f[]="";
		$f[]="net.core.optmem_max 			= 40960";
		$f[]="net.core.netdev_max_backlog	= 16384";
		$f[]="net.ipv4.tcp_max_syn_backlog  = 16384";
		$f[]="net.ipv4.ip_local_port_range 	= 1024 65535";
		$f[]="net.ipv4.tcp_low_latency 		= 1";
		$f[]="net.ipv4.tcp_no_metrics_save	= 1";
		$f[]="net.ipv4.tcp_max_tw_buckets 	= 360000";
		$f[]="net.ipv4.tcp_reordering 		= 5";
		$f[]="net.ipv4.tcp_keepalive_intvl  = 20";
		$f[]="net.ipv4.tcp_keepalive_probes = 5";
		$f[]="net.ipv4.tcp_keepalive_time 	= 1800";
		$f[]="net.ipv4.tcp_timestamps 		= 0";
		$f[]="net.ipv4.tcp_rfc1337 			= 1";
		$f[]="net.ipv4.tcp_ecn 				= $tcp_ecn";
		$f[]="net.ipv4.tcp_rmem				= $NetIpv4TcpRmemMin $NetIpv4TcpRmemDef $NetCoreRmemMax";
		$f[]="net.ipv4.tcp_wmem				= 10240 87380 $wmem_max";
		$f[]="net.ipv4.tcp_mem 				= $NetIpv4TcpMemLow $NetIpv4TcpMemPress $NetIpv4TcpMemPages";
		$f[]="net.ipv4.tcp_synack_retries 	= 2";
		$f[]="net.ipv4.tcp_syn_retries 		= 3";
		$f[]="net.ipv4.tcp_sack 			= 0";
		$f[]="net.core.rmem_default 		= $NetCoreRmemMax";
		$f[]="net.core.wmem_default 		= $NetCoreRmemMax";
		$f[]="net.core.rmem_max				= $NetCoreRmemMax";
		$f[]="net.core.wmem_max 			= $NetCoreRmemMax";
		
	}else{
		$f[]="# Normal settings....";
		$f[]="";
		$f[]="net.core.wmem_max 			= 212992";
		$f[]="net.core.rmem_max 			= 212992";
		$f[]="net.core.wmem_default 		= 212992";
		$f[]="net.core.rmem_default 		= 212992";
		$f[]="net.core.optmem_max 			= 20480";
		$f[]="net.core.netdev_max_backlog 	= 1000";
		$f[]="net.ipv4.tcp_max_syn_backlog 	= 128";
		$f[]="net.ipv4.ip_local_port_range 	= 1024 65535";
		$f[]="net.ipv4.tcp_low_latency 		= 0 ";
		$f[]="net.ipv4.tcp_no_metrics_save 	= 0";
		$f[]="net.ipv4.tcp_max_tw_buckets 	= 65536";
		$f[]="net.ipv4.tcp_reordering 		= 3";
		$f[]="net.ipv4.tcp_keepalive_time 	= 7200";
		$f[]="net.ipv4.tcp_rfc1337 			= 0";
		$f[]="net.ipv4.tcp_synack_retries 	= 5";
		$f[]="net.ipv4.tcp_ecn 				= 2";
		$f[]="net.ipv4.tcp_mem 				= 14190	18920	28380";
		$f[]="net.ipv4.tcp_wmem 			= 4096	16384	605440";
		$f[]="net.ipv4.tcp_rmem 			= 4096	87380	605440";
		$f[]="net.ipv4.tcp_syn_retries 		= 5";
		
	}
	
	$f[]="net.ipv4.tcp_fin_timeout 		= $NetIpv4TcpFinTimeOut";
	
	if($NetIpv4TcpTwReuse==1){
		$f[]="net.ipv4.tcp_tw_reuse 		= 1";
		
	}else{
		$f[]="net.ipv4.tcp_tw_reuse 		= 0";
	}
	
	if($NetIpv4TcpTwRecycle==1){
		$f[]="net.ipv4.tcp_tw_recycle 		= 1";
	}else{
		$f[]="net.ipv4.tcp_tw_recycle 		= 0";
	}
	
	if($EnableKernelBBR==1){
		$f[]="net.core.default_qdisc = fq";
		$f[]="net.ipv4.tcp_congestion_control = bbr";
	
	}else{
		$f[]="net.core.default_qdisc = pfifo_fast";
		$f[]="net.ipv4.tcp_congestion_control = cubic";
	}
	
	$f[]="# -----------------------------------------------------------------";
	$f[]="";	
	$f[]="";
	$f[]="";
	$dirs=$unix->dirdir("/sys/block");$f[]="";
	foreach ($dirs as $num=>$directory){
		$CMDLINE[]="$echo 1024 > $directory/queue/nr_requests >/dev/null 2>&1 || true";
	}
	
	
	if(is_file($conntrack)){
		if($EnableConntrack==1){
			$CMDLINE[]="$modprobe nf_conntrack >/dev/null 2>&1 || true";
			$CMDLINE[]="$modprobe nf_conntrack_ipv4 >/dev/null 2>&1 || true";
			$nf_conntrack_max=196608;
			$ip_conntrack_tcp_timeout_established=86400;
			
			if(is_file("/proc/sys/net/netfilter/nf_conntrack_acct")){
				$f[]="# nf_conntrack_acct-----------------------------------------------------------------";
				$f[]="net.netfilter.nf_conntrack_acct = 1";
				$f[]="net.netfilter.nf_conntrack_checksum = 0";
				$f[]="net.netfilter.nf_conntrack_max = $nf_conntrack_max";
				$f[]="net.netfilter.nf_conntrack_tcp_timeout_established = $ip_conntrack_tcp_timeout_established";
				$f[]="net.netfilter.nf_conntrack_udp_timeout = 60";
				$f[]="net.netfilter.nf_conntrack_udp_timeout_stream = 180";
				$f[]="net.ipv4.netfilter.ip_conntrack_generic_timeout = 600";
				$f[]="net.ipv4.netfilter.ip_conntrack_tcp_timeout_syn_sent = 120";
				$f[]="net.ipv4.netfilter.ip_conntrack_tcp_timeout_syn_sent2 = 120";
				$f[]="net.ipv4.netfilter.ip_conntrack_tcp_timeout_syn_recv = 60";
				$f[]="net.ipv4.netfilter.ip_conntrack_tcp_timeout_established = $ip_conntrack_tcp_timeout_established";
				$f[]="net.ipv4.netfilter.ip_conntrack_tcp_timeout_fin_wait = 120";
				$f[]="net.ipv4.netfilter.ip_conntrack_tcp_timeout_close_wait = 60";
				$f[]="net.ipv4.netfilter.ip_conntrack_tcp_timeout_last_ack = 30";
				$f[]="net.ipv4.netfilter.ip_conntrack_tcp_timeout_time_wait = 120";
				$f[]="net.ipv4.netfilter.ip_conntrack_tcp_timeout_close = 10";
				$f[]="net.ipv4.netfilter.ip_conntrack_tcp_timeout_max_retrans = 300";
				$f[]="net.ipv4.netfilter.ip_conntrack_tcp_loose = 1";
				$f[]="net.ipv4.netfilter.ip_conntrack_tcp_be_liberal = 0";
				$f[]="net.ipv4.netfilter.ip_conntrack_tcp_max_retrans = 3";
				$f[]="net.ipv4.netfilter.ip_conntrack_udp_timeout = 30";
				$f[]="net.ipv4.netfilter.ip_conntrack_udp_timeout_stream = 180";
				$f[]="net.ipv4.netfilter.ip_conntrack_icmp_timeout = 30";
				$f[]="net.ipv4.netfilter.ip_conntrack_max = $nf_conntrack_max";
				$f[]="net.ipv4.netfilter.ip_conntrack_checksum = 1";
				$f[]="net.ipv4.netfilter.ip_conntrack_log_invalid = 0";
				$f[]="# -----------------------------------------------------------------";
				$CMDLINE[]="$echo ".round($nf_conntrack_max/8)." > /sys/module/nf_conntrack/parameters/hashsize >/dev/null 2>&1 ||true";
				}
		}
	
	}

    $f[]="\n\n";
    $f[]="# --------------------------------AUTOMATICS--------------------------------\n";
    $max_filedesc=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("max_filedesc"));
    if($max_filedesc==0){$max_filedesc=300000;}

    $f[]="";
    $f[]="";
    $f[]="fs.file-max = $max_filedesc";
    $f[]="fs.inotify.max_user_watches=16384";
    $f[]="fs.inotify.max_user_instances=512";

   // $Totalbytes=FullMemorybits();
   // $SHMMAX = round($Totalbytes/2);
   // $SHMALL = $Totalbytes*40;
   // $SHMALL= round($SHMALL/ 100);

   // $f[]="kernel.shmmni  = 4096";
   // $f[]="kernel.shmall  =  $SHMALL";
   // $f[]="kernel.shmmax  =  $SHMMAX";

    $f[]="kernel.shmmni  = 4096";
    $f[]="kernel.shmall  =  18446744073692774399";
    $f[]="kernel.shmmax  =  18446744073692774399";


	
	$f[]="# --------------------------------ENDOF--------------------------------\n";
	

	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} /etc/sysctl.conf writing file with ".count($f)." parameters\n";}
	@file_put_contents("/etc/sysctl.conf", @implode("\n", $f));
	$f=array();
	$SCRIPT[]="#!/bin/sh";
	$SCRIPT[]="### BEGIN INIT INFO";
	$SCRIPT[]="# Provides:         artica-optimize";
	$SCRIPT[]="# Required-Start:    \$local_fs";
	$SCRIPT[]="# Required-Stop:     \$local_fs";
	$SCRIPT[]="# Should-Start:";
	$SCRIPT[]="# Should-Stop:";
	$SCRIPT[]="# Default-Start:     3 4 5";
	$SCRIPT[]="# Default-Stop:      0 1 6";
	$SCRIPT[]="# Short-Description: artica-optimize";
	$SCRIPT[]="# chkconfig: - 80 75";
	$SCRIPT[]="# description: artica-optimize";
	$SCRIPT[]="### END INIT INFO";
	$SCRIPT[]="case \"\$1\" in";
	$SCRIPT[]=" start)";
	$SCRIPT[]="\texport MALLOC_ARENA_MAX=16 || true";
	$SCRIPT[]="\techo \"Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]}\"";
	$echo=$unix->find_program("echo");
	while (list ($index, $line) = each ($CMDLINE)){
		$SCRIPT[]="\t$line";
	}
	$SCRIPT[]="\t$sysctl -p || true";
	$SCRIPT[]="\techo \"Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]}\" done.";
	$SCRIPT[]="\t;;";
	$SCRIPT[]="*)";
    $SCRIPT[]="echo \"Usage: $0 start\"";
    $SCRIPT[]="exit 1";
    $SCRIPT[]=";;";
	$SCRIPT[]="esac";
	$SCRIPT[]="exit 0";
	$SCRIPT[]="";

	if(!is_file("/etc/init.d/artica-optimize")){$INSTALL_SERVICE=true;}
	
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} /etc/init.d/artica-optimize done\n";}
	@file_put_contents("/etc/init.d/artica-optimize",@implode("\n", $SCRIPT));
	@chmod("/etc/init.d/artica-optimize",0755);
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Installing init service\n";}

		
	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f artica-optimize defaults >/dev/null 2>&1");
	}
		
	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --add artica-optimize >/dev/null 2>&1");
		shell_exec("/sbin/chkconfig --level 345 artica-optimize on >/dev/null 2>&1");
	}

	if($GLOBALS["NO_START"]){return;}
		
	shell_exec("/etc/init.d/artica-optimize start");
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} /etc/sysctl.conf done\n";}
	if($GLOBALS["REBOOT"]){$reboot=$unix->find_program("reboot");shell_exec("$reboot");}
	start(true);
}

function FullMemorybits(){
    $TotalKbytes=0;
    $f=explode(@file_get_contents("/proc/meminfo"));
    foreach ($f as $num=>$ligne) {
        if (!preg_match("#MemTotal:\s+([0-9]+)\s+#", $ligne, $re)) {
            continue;
        }
        $TotalKbytes = $re[1];
        return intval($TotalKbytes * 1024);

    }

    return 2097152000;

}



function stop(){}
