<?php
	$GLOBALS["SCHEDULE_ID"]=0;
	$GLOBALS["FORCE"]=false;
	if(preg_match("#schedule-id=([0-9]+)#",implode(" ",$argv),$re)){$GLOBALS["SCHEDULE_ID"]=$re[1];}
	include_once(dirname(__FILE__) . '/ressources/class.templates.inc');
    include_once(dirname(__FILE__) . '/ressources/class.ccurl.inc');
	include_once(dirname(__FILE__) . '/framework/class.unix.inc'); 
	include_once(dirname(__FILE__) . '/framework/frame.class.inc');	
	
	
	if(is_array($argv)){
		if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;}
		if(preg_match("#--force#",implode(" ",$argv))){$GLOBALS["FORCE"]=true;}
		if(preg_match("#--reinstall#",implode(" ",$argv))){$GLOBALS["REINSTALL"]=true;}
		if(preg_match("#--noreload#",implode(" ",$argv))){$GLOBALS["NO_HTTPD_RELOAD"]=true;}
		if($GLOBALS["VERBOSE"]){ini_set('html_errors',0);ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);}
	}
    if($argv[1]=="--install"){install();exit();}
	if($argv[1]=="--instances"){GetInstances();exit();}
    if($argv[1]=="--uninstall"){uninstall();exit();}
    if($argv[1]=="--dashboard"){dashboard_infos();exit();}
	
runProc();


function build_progress_run($text,$pourc){
    $filename="/usr/share/artica-postfix/ressources/logs/web/speedtests.execute.progress";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    echo "[$pourc]: $text\n";
    @file_put_contents($filename, serialize($array));
    @chmod($filename,0777);

}
function build_progress($text,$pourc){
    $filename="/usr/share/artica-postfix/ressources/logs/web/speedtests.progress";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    echo "[$pourc]: $text\n";
    @file_put_contents($filename, serialize($array));
    @chmod($filename,0777);

}

function uninstall(){

    build_progress("{uninstalling}",50);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableBandwithCalculation",0);

    if(is_file("/etc/cron.d/BandwithCalculation")){
        @unlink("/etc/cron.d/BandwithCalculation");
        shell_exec("/etc/init.d/cron reload");


    }

    build_progress("{uninstalling}",80);
    if(is_file("/home/artica/SQLITE/speedtests.db")){
        @unlink("/home/artica/SQLITE/speedtests.db");
    }

    build_progress("{uninstalling}",90);
    if(is_dir("/usr/share/artica-postfix/ressources/logs/speed")){
        $unix=new unix();
        $rm=$unix->find_program("rm");
        shell_exec("$rm -rf /usr/share/artica-postfix/ressources/logs/speed");
    }

    build_progress("{uninstalling} {success}",100);
    squid_admin_mysql(2,"Bandwidth Calculation feature was successfully uninstalled",null,__FILE__,__LINE__);

}

function install(){
    $unix=new unix();
    $cron_restart=false;
    build_progress("{installing}",50);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableBandwithCalculation",1);
    $BandwithCalculationSchedule=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("BandwithCalculationSchedule"));

    if($BandwithCalculationSchedule==0){$BandwithCalculationSchedule=30;}
    if($BandwithCalculationSchedule==30){$task="*/30 * * * *";}
    if($BandwithCalculationSchedule==1){$task="0 * * * *";}
    if($BandwithCalculationSchedule>1){$task="0 */$BandwithCalculationSchedule * * *";}
    build_progress("{installing}",80);

    if(!is_file("/etc/cron.d/BandwithCalculation")){$cron_restart=true;}
    $unix->Popuplate_cron_make("BandwithCalculation",$task,basename(__FILE__));
    if($cron_restart){shell_exec("/etc/init.d/cron restart");}else{shell_exec("/etc/init.d/cron reload");}

    $q=new lib_sqlite("/home/artica/SQLITE/speedtests.db");
    $sql="CREATE TABLE IF NOT EXISTS speeds ( ztime INTEGER PRIMARY KEY,
    public_ip TEXT,isp TEXT,country TEXT,bytes_sent INTEGER ,download INTEGER,
    picture TEXT,ping INTEGER,upload INTEGER,latency INTEGER,ServerName TEXT,ServerCountry TEXT,ServerSponsor TEXT)";

    $q->QUERY_SQL($sql);

    $sql="CREATE TABLE IF NOT EXISTS `dummytable` (
			`ID` INTEGER PRIMARY KEY AUTOINCREMENT,
			`nothing` TEXT NOT NULL)";
    $q->QUERY_SQL($sql);

    if(!$q->ok){
        echo $q->mysql_error;
        build_progress("{installing} {failed}",110);
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableBandwithCalculation",0);
        return false;
    }
    build_progress("{installing} {success}",100);
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    shell_exec("$php ".__FILE__ ." 2>&1 &");

    squid_admin_mysql(2,"Bandwidth Calculation feature was successfully installed",null,__FILE__,__LINE__);

    return true;
}
	
function runProc(){
	$unix=new unix();
	$timeFile="/etc/artica-postfix/pids/".basename(__FILE__).".time";
	$timePID="/etc/artica-postfix/pids/".basename(__FILE__).".pid";
	$EnableBandwithCalculation=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableBandwithCalculation"));

	$GetInstances=GetInstances();
	if($GetInstances>0){
		echo "$GetInstances instance(s) already running.. aborting...\n";
		return ;
	}
	
	if($EnableBandwithCalculation==0){return;}
	
	if(!$GLOBALS["FORCE"]){
		$pid=$unix->get_pid_from_file($timePID);
		if($unix->process_exists($pid,basename(__FILE__))){
			$timexec=$unix->PROCCESS_TIME_MIN($pid);
			if($timexec<30){
				echo "Already instance executed pid $pid since {$timexec}Mn\n";
				return;
			}else{
				unix_system_kill_force($pid);
				echo "Instance pid $pid since {$timexec}Mn was killed\n";
			}
		}
		
		$ExecTimefile=$unix->file_time_min($timeFile);
		if($ExecTimefile<30){
			echo "Must run minimal 30mn ({$ExecTimefile}Mn), aborting\n";
			return;
		}
		
		@unlink($timeFile);
		@file_put_contents($timeFile, time());
		@file_put_contents($timePID, getmypid());
		
	}
	
	
	$python=$unix->find_program("python");
	if(!is_file($python)){
	    squid_admin_mysql(1, "python, no such binary", null, __FILE__, __LINE__);
	    return;
	}
    $BandwithCalculationInterface=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("BandwithCalculationInterface"));
    $BandwithCalculationLocalProxy=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("BandwithCalculationLocalProxy"));
    $srcipToken=null;
    if($BandwithCalculationInterface<>null){
        $srcip=$unix->InterfaceToIPv4($BandwithCalculationInterface);
        if($srcip<>null){
            $srcipToken=" --source $srcip";
        }
    }

    build_progress_run("{starting}",10);
    @chmod("/usr/share/artica-postfix/bin/speedtest-cli");
	@chdir("/usr/share/artica-postfix/bin");
	@chmod("/usr/share/artica-postfix/bin/speedtest-cli",0755);
    build_progress_run("{executing}....",20);
    $ini=new Bs_IniHandler();
    $ArticaProxySettings=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("ArticaProxySettings");
    $ini->loadString($ArticaProxySettings);

    if(!isset($ini->_params["PROXY"]["ArticaProxyServerEnabled"])){
        $ini->_params["PROXY"]["ArticaProxyServerEnabled"]=0;
    }

    $ArticaProxyServerEnabled=strtolower($ini->_params["PROXY"]["ArticaProxyServerEnabled"]);
    if($ArticaProxyServerEnabled==null){$ArticaProxyServerEnabled=0;}
    if($ArticaProxyServerEnabled=="no"){$ArticaProxyServerEnabled=0;}

    if($ArticaProxyServerEnabled==1) {
        $ArticaProxyServerName = $ini->_params["PROXY"]["ArticaProxyServerName"];
        if ($ArticaProxyServerName == null) {
            $ArticaProxyServerEnabled = 0;
        }
        $ArticaProxyServerPort = intval($ini->_params["PROXY"]["ArticaProxyServerPort"]);
        if ($ArticaProxyServerPort == 0) {
            $ArticaProxyServerEnabled = 0;
        }

    }


    $h[]="#!/usr/bin/bash";

    if($BandwithCalculationLocalProxy==1){
        if(is_file("/etc/squid3/listen_ports.conf")) {
            $res = explode("\n", @file_get_contents("/etc/squid3/listen_ports.conf"));
            foreach ($res as $line) {
                if (!preg_match("#^http_port .*?:([0-9]+).*?name=MyManagerPort#", $line, $re)) {
                    continue;
                }
                $h[] = "http_proxy=http://127.0.0.1:{$re[1]}";
                $h[] = "https_proxy=http://127.0.0.1:{$re[1]}";
            }
        }
    }

    if($ArticaProxyServerEnabled==1){
        $h[] = "http_proxy=http://$ArticaProxyServerName:{$ArticaProxyServerPort}";
        $h[] = "https_proxy=http://$ArticaProxyServerName:{$ArticaProxyServerPort}";
    }

    $h[]="/usr/share/artica-postfix/bin/speedtest-cli{$srcipToken} --single --share --json --secure >/var/log/speedtest.json";
    $h[] = "";
    $tmpfile=$unix->FILE_TEMP();
    @file_put_contents($tmpfile,@implode("\n",$h));
    @chmod($tmpfile,0755);
    shell_exec("$tmpfile 2>&1");
    @unlink($tmpfile);
	@chdir("/root");
    build_progress_run("{analyze}",50);
    echo "Open /var/log/speedtest.json\n";
	$data=@file_get_contents("/var/log/speedtest.json");
	$json=json_decode($data);
	@unlink("/var/log/speedtest.json");
	$tt=time();

	if(!property_exists($json,"bytes_sent")){
	    echo "bytes_sent property doesn't exists.\n";
        build_progress_run("{failed} property doesn't exists",110);
        echo $data."\n";
        squid_admin_mysql(1,"Unable to parse json file for speedtests",$data,__FILE__,__LINE__);
        return false;
    }

    build_progress_run("{starting}",80);
	$distance=$unix->distanceOfTimeInWords_text($tt,time());
	squid_admin_mysql(2,"Bandwidth: speed test successfull, operation took ".$distance,null,__FILE__,__LINE__);

	$ztime=time();
	$public_ip=$json->client->ip;
	$isp=$json->client->isp;
    $country=$json->client->country;
    $bytes_sent=$json->bytes_sent;
    $download=round($json->download/1000000);
    $upload=round($json->upload/1000000);
    $curl=new ccurl($json->share);
    $picture=null;
    if($curl->GetFile("/tmp/img.png")){
        $picture=base64_encode(@file_get_contents("/tmp/img.png"));
        @unlink("/tmp/img.png");
    }
    $ping=intval($json->ping);
    $latency=intval($json->server->latency);
    $ServerName=str_replace("'",'`',$json->server->name);
    $ServerCountry=str_replace("'",'`',$json->server->country);
    $ServerSponsor=str_replace("'",'`',$json->server->sponsor);
    echo "{$download}Mibps bandwidth download {$upload}Mibps bandwidth upload\n";
    $unix->ToSyslog("[$public_ip]: {$download}Mibps bandwidth download {$upload}Mibps bandwidth upload");


    $sql="INSERT INTO speeds (ztime,public_ip,isp,country,bytes_sent,download,picture,ping,upload,latency,ServerName,ServerCountry,ServerSponsor) 
    VALUES ($ztime,'$public_ip','$isp','$country','$bytes_sent','$download','$picture','$ping','$upload','$latency','$ServerName','$ServerCountry','$ServerSponsor')";

    $q=new lib_sqlite("/home/artica/SQLITE/speedtests.db");
    $q->QUERY_SQL($sql);
    if(!$q->ok) {
        echo $q->mysql_error."\n";
        build_progress_run("{failed} SQLite Error",110);
        squid_admin_mysql(1,"SQLite Error",$q->mysql_error,__FILE__,__LINE__);
        return;
    }
    build_progress_run("{starting}",95);
    dashboard_infos();
    build_progress_run("{success}",100);
}

function dashboard_infos(){
    $q=new lib_sqlite("/home/artica/SQLITE/speedtests.db");

    $sql="CREATE TABLE IF NOT EXISTS `dummytable` (
			`ID` INTEGER PRIMARY KEY AUTOINCREMENT,
			`nothing` TEXT NOT NULL)";
    $q->QUERY_SQL($sql);

    $sql="SELECT * FROM speeds ORDER BY ztime DESC LIMIT 1";
    $ligne=$q->mysqli_fetch_array($sql);
    if(!is_dir("/usr/share/artica-postfix/ressources/logs/speed")){
        @mkdir("/usr/share/artica-postfix/ressources/logs/speed",0755,true);

    }

    @file_put_contents("/usr/share/artica-postfix/ressources/logs/speed/latest",serialize($ligne));

    $Last30days=strtotime("-30 day");
    $q->QUERY_SQL("DELETE FROM speeds WHERE ztime < $Last30days");

    $results=$q->QUERY_SQL("SELECT ztime,bytes_sent,download,upload FROM speeds ORDER BY ztime");
    @file_put_contents("/usr/share/artica-postfix/ressources/logs/speed/timeline",serialize($results));



}

function GetInstances(){
	$unix=new unix();
	$pidsARR=array();
	$kill=$unix->find_program("kill");
	$pgrep=$unix->find_program("pgrep");
	exec("$pgrep -l -f \"python.*?speedtest-cli\.py\" 2>&1",$results);
	foreach ($results as $index=>$line){
		if(!preg_match("#([0-9]+)\s+(.*?)#", $line,$re)){continue;}
		$pid=$re[1];
		$cmdline=trim($re[2]);
		if(preg_match("#^sh\s+#", $cmdline)){continue;}
		$time=$unix->PROCCESS_TIME_MIN($pid);
		if($time>15){unix_system_kill_force($pid);continue;}
		$pidsARR[$pid]=true;
	}
	if($GLOBALS["VERBOSE"]){echo "-> ".count($pidsARR)." instances..\n";}
	return count($pidsARR);
}