<?php
// SP1 2020 06 02
$GLOBALS["YESCGROUP"]=true;
define("LkdPTEQ",base64_decode("L3Vzci9sb2NhbC9zaGFyZS9hcnRpY2EvLkdPTEQ="));
$GLOBALS["SCRIPT_SUFFIX"]="--script=".basename(__FILE__);
if (!isset($GLOBALS["CLASS_SOCKETS"])) {
    if (!class_exists("sockets")) {
        include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");
    }
    $GLOBALS["CLASS_SOCKETS"]=new sockets();
} if (function_exists("posix_getuid")) {
    if (posix_getuid()<>0) {
        die("Cannot be used in web server mode\n\n");
    }
}
$GLOBALS["BYCRON"]=false;
$GLOBALS["FORCE"]=false;
$GLOBALS["STAMP"]=false;
$GLOBALS["EMAIL"]=false;
$GLOBALS["MIGRATION"] = false;
$GLOBALS["FROM_WIZARD"] = false;
$GLOBALS["REMOTE_OUTPUT"]=false;
if (preg_match("#--email#", implode(" ", $argv))) {
    $GLOBALS["EMAIL"]=true;
}
if (preg_match("#--force#", implode(" ", $argv))) {
    $GLOBALS["FORCE"]=true;
}
if (preg_match("#--verbose#", implode(" ", $argv))) {
    $GLOBALS["VERBOSE"]=true;
    $GLOBALS["VERBOSE"]=true;
    ini_set('html_errors', 0);
    ini_set('display_errors', 1);
    ini_set('error_reporting', E_ALL);
}
//$GLOBALS["VERBOSE"]=true;$GLOBALS["VERBOSE"]=true;$GLOBALS["debug"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);
        
include_once(dirname(__FILE__).'/ressources/class.templates.inc');
include_once(dirname(__FILE__).'/ressources/class.ldap.inc');
include_once(dirname(__FILE__).'/ressources/class.ini.inc');
include_once(dirname(__FILE__).'/ressources/class.mysql.inc');
include_once(dirname(__FILE__).'/ressources/class.ccurl.inc');
include_once(dirname(__FILE__).'/ressources/class.identity.inc');
include_once(dirname(__FILE__).'/framework/class.unix.inc');
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.squidguard.inc');
$GLOBALS["MYPID"]=getmypid();

$unix=new unix();
if (is_file("/etc/artica-postfix/FROM_ISO")) {
    if ($unix->file_time_min("/etc/artica-postfix/FROM_ISO")<1) {
        echo "/etc/artica-postfix/FROM_ISO Time less than 1mn\n";
        exit();
    }
}

$unix=new unix();
$uptime=$unix->ServerRunSince();
echo "Server running since ".$uptime." minutes...\n";
if (!$GLOBALS["FORCE"]) {
    if ($uptime < 5) {
        echo "Server run since " . $uptime . " minutes ( need 5mn, restart later)\n";
        build_progress_influx("Server run since " . $uptime . " minutes ( need 5mn, restart later)", 110);
        build_progress("Server run since " . $uptime . " minutes ( need 5mn, restart later)", 110);
        exit();
    }
}

if (preg_match("#--remote-output#", implode(" ", $argv))) {
    $GLOBALS["REMOTE_OUTPUT"]=true;
}
if (preg_match("#--force#", implode(" ", $argv))) {
    $GLOBALS["FORCE"]=true;
}
if (preg_match("#--bycron#", implode(" ", $argv))) {
    $GLOBALS["BYCRON"]=true;
}
if (preg_match("#--set-stamp#", implode(" ", $argv))) {
    $GLOBALS["STAMP"]=true;
}
if (preg_match("#--migration#", implode(" ", $argv))) {
    $GLOBALS["MIGRATION"] = true;
}
if (preg_match("#--from-wizard#", implode(" ", $argv))) {
    $GLOBALS["FROM_WIZARD"] = true;
}

if ($argv[1]=="--register") {
    register();
    exit();
}
if ($argv[1]=="--uuid") {
    uuid_check();
    exit();
}
if ($argv[1]=="--register-lic") {
    register_lic();
    exit();
}
if ($argv[1]=="--squid-repo") {
    others_update();
    exit();
}
if ($argv[1]=="--whatsnew") {
    others_update();
    exit();
}
if ($argv[1]=="--updates") {
    others_update();
    exit();
}
if ($argv[1]=="--force-updates") {
    $GLOBALS["FORCE"]=true;
    others_update();
    exit();
}
if ($argv[1]=="--install-key") {
    install_key($argv[2]);
    exit();
}
if ($argv[1]=="--ping-cloud") {
    ping_server();
    exit();
}


if ($argv[1]=="--register-kaspersky") {
    register_lic_kaspersky();
    exit();
}




if ($argv[1]=="--uuid") {
    $unix=new unix();
    echo $unix->GetUniqueID()."\n";
    exit();
}
if (!ifMustBeExecuted()) {
    events("ifMustBeExecuted() -> FALSE, DIE()", __FUNCTION__, __FILE__, __LINE__);
    exit();
}
if ($argv[1]=="--patterns") {
    exit();
}
if ($argv[1]=="--sitesinfos") {
    exit();
}
if ($argv[1]=="--groupby") {
    exit();
}
if ($argv[1]=="--export") {
    exit();
}
if ($argv[1]=="--export-deleted") {
    exit();
}
if ($argv[1]=="--export-weighted") {
    exit();
}
if ($argv[1]=="--export-not-categorized") {
    exit();
}
if ($argv[1]=="--remove-grace-period") {
    remove_grace_period();
    exit();
}

if ($argv[1]=="--drop-categorize") {
    drop_categorize(true);
    exit();
}




    $t=time();
    $sock=new sockets();
    $users=new usersMenus();
    $EnableRemoteStatisticsAppliance=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableRemoteStatisticsAppliance");
    if ($EnableRemoteStatisticsAppliance==1) {
        if ($GLOBALS["VERBOSE"]) {
            echo "Use the Web statistics appliance aborting...\n";
        }
        exit();
    }
    $EnableSquidRemoteMySQL=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableSquidRemoteMySQL");
    if (!is_numeric($EnableSquidRemoteMySQL)) {
        $EnableSquidRemoteMySQL=0;
    }
    if ($EnableSquidRemoteMySQL==1) {
        exit();
    }
    
    
    $system_is_overloaded=system_is_overloaded();
    if ($system_is_overloaded) {
        $unix=new unix();
        events("Overloaded system, [{$GLOBALS["SYSTEM_INTERNAL_LOAD"]}] Web filtering maintenance databases tasks aborted (general)", "MAIN", __FILE__, __LINE__);
        exit();
    }
    

    $WebCommunityUpdatePool=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("WebCommunityUpdatePool");
    if (!is_numeric($WebCommunityUpdatePool)) {
        $WebCommunityUpdatePool=120;
        $sock->SET_INFO("WebCommunityUpdatePool", 120);
    }
    
    
    $pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
    $cachetime="/etc/artica-postfix/pids/exec.web-community-filter.php.MAIN.time";
    $unix=new unix();
    $myFile=basename(__FILE__);
    $pid=@file_get_contents($pidfile);
    if ($unix->process_exists($pid, $myFile)) {
        events("Already executed PID:$pid, die()", __FUNCTION__, __FILE__, __LINE__);
        exit();
    }
    
    $filetime=file_time_min($cachetime);

    if($filetime<20){
        echo "Current $filetime minutes, need to wait 20mn\n";
        die();
    }

    @mkdir(dirname($cachetime), 0755, true);
    @unlink($cachetime);
    @file_put_contents($cachetime, time());
    @file_put_contents($pidfile, $GLOBALS["MYPID"]);

    register_lic();

    

        



function whatsnew()
{
    $unix=new unix();
    
    $filetmp=$unix->FILE_TEMP();
    $VERSION=trim(@file_get_contents("/usr/share/artica-postfix/VERSION"));
    $uri="http://articatech.net/v10-whatsnew/$VERSION.txt";
    if (is_file("/usr/share/artica-postfix/ressources/logs/web/$VERSION.txt")) {
        return;
    }
    
    $curl=new ccurl($uri);
    if (!$curl->GetFile($filetmp)) {
        @unlink($filetmp);
        return;
    }
    
    @copy($filetmp, "/usr/share/artica-postfix/ressources/logs/web/$VERSION.txt");
    @unlink($filetmp);
    return;
}
function install_key($filename)
{
    if (file_exists('/etc/artica-postfix/settings/Daemons/NewLicServer')) {
        echo "NEW LIC";
        $WORKDIR = base64_decode("L3Vzci9sb2NhbC9zaGFyZS9hcnRpY2E=");
        $WORKFILE = base64_decode('LmxpYw==');
        $function_ghost = base64_decode("Y2hlY2tsaWNlbnNlLmJpbg==");
        $line_ghost = base64_decode("MTA4NDM=");
        $textGhost = base64_decode("Q29ycG9yYXRlIExpY2Vuc2UgZXhwaXJlZCAtIHJldHVybiBiYWNrIHRvIENvbW11bml0eSBsaWNlbnNl");
        $verifailed = base64_decode("Q29ycG9yYXRlIExpY2Vuc2UgZXhwaXJlZCAtIHJldHVybiBiYWNrIHRvIENvbW11bml0eSBsaWNlbnNl");
        $licexpir = base64_decode("e2xpY2Vuc2VfZXhwaXJlZH0=");
        $fname = base64_decode("L2V0Yy9hcnRpY2EtcG9zdGZpeC9zZXR0aW5ncy9EYWVtb25zL0NPUlBfTElDRU5TRQ==");
        $error1 = base64_decode("e2dlbmVyaWNfaHR0cF9lcnJvcn0=");
        $textGhost = base64_decode("Q29ycG9yYXRlIExpY2Vuc2UgZXhwaXJlZCAtIHJldHVybiBiYWNrIHRvIENvbW11bml0eSBsaWNlbnNl");
    
        $licexpir = base64_decode("e2xpY2Vuc2VfZXhwaXJlZH0=");
        $LicenseInfos = unserialize(base64_decode(@file_get_contents("/etc/artica-postfix/settings/Daemons/LicenseInfos")));
    
        $WORKPATH = "$WORKDIR/$WORKFILE";
        $unix = new unix();
        $uuid = $unix->GetUniqueID();
        $php = $unix->LOCATE_PHP5_BIN();
        include_once dirname(__FILE__) . '/ressources/class.encrypt.v2.inc';
        @mkdir($WORKDIR, 0755, true);
        $keypath = "/usr/share/artica-postfix/ressources/conf/upload/$filename";
        echo "Key File: $keypath\n";
        if (!is_file($keypath)) {
            echo "Key File: $keypath no such file\n";
            build_progress_key("$filename no such file...", 110);
            return;
        }
    
        echo "UUID: $uuid\n";
        $cryptClass = new CI_Encryption();
        $cryptClass->initialize(
            array(
                    'driver'=>'openssl',
                    'cipher' => 'aes-128',
                    'mode' => 'cbc',
                    'key' => $uuid,
            )
    );
        $KEY_CONTENT = @file_get_contents($keypath);
        $decrypted = $cryptClass->decrypt($KEY_CONTENT);
        $array = unserialize(base64_decode($decrypted));
        if (!is_array($array)) {
            echo "Corrupted key file not an array\n";
            build_progress_key("$filename $verifailed", 110);
            return;
        }
    
        $finaltime = intval($array["expire"]);
        if ($finaltime == 0) {
            echo "Corrupted key file finaltime == 0\n";
            build_progress_key("$filename $verifailed", 110);
            return;
    
        }
        $LicenseInfos["FINAL_TIME"] = $finaltime;
        if (isset($array["company"])) {$LicenseInfos["COMPANY"] = $array["register"];}
        if (isset($array["email"])) {$LicenseInfos["mail"] = $array["register"];}
        if (isset($array["employees"])) {$LicenseInfos["employees"] = $array["employees"];}
        if (isset($array["license"])) {$LicenseInfos["UNLOCKLIC"] = $array["license"];}
    
        if ($finaltime < time()) {
            build_progress_key("$licexpir {failed2}", 110);
            $LicenseInfos["license_status"] = $licexpir;
            $LicenseInfos["license_number"] = null;
            $LicenseInfos["UNLOCKLIC"] = null;
            $LicenseInfos["TIME"] = time();
            @unlink($WORKPATH);
            @unlink($GLOBALS["TVF_WORKPATH"]);
            @file_put_contents("/etc/artica-postfix/settings/Daemons/CurrentLIC", 0);
            @file_put_contents("/etc/artica-postfix/settings/Daemons/LicenseInfos", base64_encode(serialize($LicenseInfos)));
            return;
        }
        $LicenseInfos["TIME"] = time();
        $LicenseInfos["license_status"] = "{license_active}";
        echo "**********************************************\n";
        echo "*\n";
        echo "*\n";
        echo "*              Congratulations\n";
        echo "*        Your License is  - Active -\n";
        echo "*\n";
        echo "*\n";
        echo "**********************************************\n";
        @file_put_contents($WORKPATH, "TRUE");
        @file_put_contents($WORKDIR . "/.KEY", $KEY_CONTENT);
        @file_put_contents($GLOBALS["TVF_WORKPATH"], "VFJVRQ==");
        @file_put_contents("/etc/artica-postfix/settings/Daemons/LicenseInfos", base64_encode(serialize($LicenseInfos)));
        @file_put_contents("/etc/artica-postfix/settings/Daemons/CurrentLIC", 1);
        @unlink($keypath);
        build_progress_key("$filename {success}", 100);
        sleep(3);
        system("$php /usr/share/artica-postfix/exec.status.php --process1");


    }
    else {
    $WORKDIR = base64_decode("L3Vzci9sb2NhbC9zaGFyZS9hcnRpY2E=");
    $WORKFILE = base64_decode('LmxpYw==');
    $function_ghost = base64_decode("Y2hlY2tsaWNlbnNlLmJpbg==");
    $line_ghost = base64_decode("MTA4NDM=");
    $textGhost = base64_decode("Q29ycG9yYXRlIExpY2Vuc2UgZXhwaXJlZCAtIHJldHVybiBiYWNrIHRvIENvbW11bml0eSBsaWNlbnNl");
    $verifailed = base64_decode("Q29ycG9yYXRlIExpY2Vuc2UgZXhwaXJlZCAtIHJldHVybiBiYWNrIHRvIENvbW11bml0eSBsaWNlbnNl");
    $licexpir = base64_decode("e2xpY2Vuc2VfZXhwaXJlZH0=");
    $fname = base64_decode("L2V0Yy9hcnRpY2EtcG9zdGZpeC9zZXR0aW5ncy9EYWVtb25zL0NPUlBfTElDRU5TRQ==");
    $error1 = base64_decode("e2dlbmVyaWNfaHR0cF9lcnJvcn0=");
    $textGhost = base64_decode("Q29ycG9yYXRlIExpY2Vuc2UgZXhwaXJlZCAtIHJldHVybiBiYWNrIHRvIENvbW11bml0eSBsaWNlbnNl");

    $licexpir = base64_decode("e2xpY2Vuc2VfZXhwaXJlZH0=");
    $LicenseInfos = unserialize(base64_decode(@file_get_contents("/etc/artica-postfix/settings/Daemons/LicenseInfos")));

    $WORKPATH = "$WORKDIR/$WORKFILE";
    $unix = new unix();
    $uuid = $unix->GetUniqueID();
    $php = $unix->LOCATE_PHP5_BIN();
    include_once dirname(__FILE__) . '/ressources/class.encrypt.inc';
    @mkdir($WORKDIR, 0755, true);
    $keypath = "/usr/share/artica-postfix/ressources/conf/upload/$filename";
    echo "Key File: $keypath\n";
    if (!is_file($keypath)) {
        echo "Key File: $keypath no such file\n";
        build_progress_key("$filename no such file...", 110);
        return;
    }

    echo "UUID: $uuid\n";
    $cryptClass = new McryptCipher($uuid);
    $KEY_CONTENT = @file_get_contents($keypath);
    $decrypted = $cryptClass->decrypt($KEY_CONTENT);
    $array = unserialize(base64_decode($decrypted));
    if (!is_array($array)) {
        echo "Corrupted key file not an array\n";
        build_progress_key("$filename $verifailed", 110);
        return;
    }

    $finaltime = intval($array["finaltime"]);
    if ($finaltime == 0) {
        echo "Corrupted key file finaltime == 0\n";
        build_progress_key("$filename $verifailed", 110);
        return;

    }
    $LicenseInfos["FINAL_TIME"] = $finaltime;
    if (isset($array["company"])) {$LicenseInfos["COMPANY"] = $array["company"];}
    if (isset($array["email"])) {$LicenseInfos["mail"] = $array["email"];}
    if (isset($array["employees"])) {$LicenseInfos["employees"] = $array["employees"];}
    if (isset($array["license"])) {$LicenseInfos["UNLOCKLIC"] = $array["license"];}

    if ($finaltime < time()) {
        build_progress_key("$licexpir {failed2}", 110);
        $LicenseInfos["license_status"] = $licexpir;
        $LicenseInfos["license_number"] = null;
        $LicenseInfos["UNLOCKLIC"] = null;
        $LicenseInfos["TIME"] = time();
        @unlink($WORKPATH);
        @unlink($GLOBALS["TVF_WORKPATH"]);
        @file_put_contents("/etc/artica-postfix/settings/Daemons/CurrentLIC", 0);
        @file_put_contents("/etc/artica-postfix/settings/Daemons/LicenseInfos", base64_encode(serialize($LicenseInfos)));
        return;
    }
    $LicenseInfos["TIME"] = time();
    $LicenseInfos["license_status"] = "{license_active}";
    echo "**********************************************\n";
    echo "*\n";
    echo "*\n";
    echo "*              Congratulations\n";
    echo "*        Your License is  - Active -\n";
    echo "*\n";
    echo "*\n";
    echo "**********************************************\n";
    @file_put_contents($WORKPATH, "TRUE");
    @file_put_contents($WORKDIR . "/.KEY", $KEY_CONTENT);
    @file_put_contents($GLOBALS["TVF_WORKPATH"], "VFJVRQ==");
    @file_put_contents("/etc/artica-postfix/settings/Daemons/LicenseInfos", base64_encode(serialize($LicenseInfos)));
    @file_put_contents("/etc/artica-postfix/settings/Daemons/CurrentLIC", 1);
    @unlink($keypath);
    build_progress_key("$filename {success}", 100);
    sleep(3);
    system("$php /usr/share/artica-postfix/exec.status.php --process1");
}

}

function build_progress_key($text, $pourc)
{
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    echo "{$pourc}% $text\n";
    @file_put_contents("/usr/share/artica-postfix/ressources/logs/artica.keyfile.progress", serialize($array));
    @chmod("/usr/share/artica-postfix/ressources/logs/artica.keyfile.progress", 0755);
}



function build_progress_influx($text, $pourc)
{
    $GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/influxdb.refresh.progress";
    echo "{$pourc}% $text\n";
    $cachefile=$GLOBALS["CACHEFILE"];
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($cachefile, serialize($array));
    @chmod($cachefile, 0755);
}


function others_update()
{
    $unix=new unix();
    
    $pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
    $cachetime="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".time";
    $pid=@file_get_contents($pidfile);
    if ($unix->process_exists($pid)) {
        build_progress_influx("Already executed", 110);
        events("Already executed PID:$pid, die()", __FUNCTION__, __FILE__, __LINE__);
        return;
    }
    
    if (!$GLOBALS["FORCE"]) {
        $TimeCache=$unix->file_time_min($cachetime);
        if ($TimeCache<30) {
            build_progress_influx("Need at least 30Mn ( current {$TimeCache}mn ) ", 110);
            return;
        }
    }
    
    $DEBIAN_VERSION=$unix->DEBIAN_VERSION();
    $TimeFile=$unix->file_time_min("/etc/artica-postfix/settings/Daemons/v4softsRepo");
    $tmpfile=$unix->TEMP_DIR()."/squid.update.db";
    if ($GLOBALS["VERBOSE"]) {
        $TimeFile=10000;
    }
    $php=$unix->LOCATE_PHP5_BIN();
    
    if (!$GLOBALS["FORCE"]) {
        if ($TimeFile<480) {
            ping_server(true);
            whatsnew();
            return;
        }
    }

    
    build_progress_influx("{check_repository} (BigData Engine)", 20);

    $URI="http://articatech.net/v4softs.php";

    echo "Debian Version: $DEBIAN_VERSION\n";

    if ($DEBIAN_VERSION==10) {
        $URI="http://articatech.net/v4softs-debian10.php";
    }

    
    $curl=new ccurl($URI);

    if (!$curl->GetFile($tmpfile)) {
        build_progress_influx("{check_repository} {failed}", 20);
        echo $curl->error."\n";
        if(is_file($tmpfile)){@unlink($tmpfile);}
        $unix->ToSyslog("http://articatech.net/v4softs.php Failed $curl->error",true,"artica-update");
    }
    
    
    $DATA=@file_get_contents($tmpfile);
    $ARRAY=unserialize(base64_decode($DATA));
    if ($GLOBALS["VERBOSE"]) {
        print_r($ARRAY);
    }
    
    if (count($ARRAY)>0) {
        build_progress_influx("{check_repository} (BigData Engine) {success}", 25);
        @unlink("/etc/artica-postfix/settings/Daemons/v4softsRepo");
        @copy("$tmpfile", "/etc/artica-postfix/settings/Daemons/v4softsRepo");
        @chmod("/etc/artica-postfix/settings/Daemons/v4softsRepo", 0755);
            
        if ($GLOBALS["VERBOSE"]) {
            $dd=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("v4softsRepo")));
            print_r($dd);
        }
            
            
        whatsnew();
        ping_server();
        build_progress_influx("{check_repository} {success}", 95);
    } else {
        echo "**** NOT AN ARRAY ****\n";
        build_progress_influx("{check_repository} {failed}", 110);
    }

    if(is_file($tmpfile)){@unlink($tmpfile);}
        
    shell_exec("$php /usr/share/artica-postfix/exec.status.php --process1");
    build_progress_influx("{check_repository} {done}", 100);
}



function getLastLines($string, $n = 1)
{
    $lines = explode("\n", $string);

    $lines = array_slice($lines, -$n);

    return implode("\n", $lines);
}

    
    
function register($force=false){

    if(is_file(LkdPTEQ)){
        if($GLOBALS["CLASS_SOCKETS"]->IsGoldKey(trim(@file_get_contents(LkdPTEQ)))){
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseINGP", 0);
            build_progress("{license_active}: {gold_license}", 100);
            return true;
        }
    }

    if (file_exists('/etc/artica-postfix/settings/Daemons/NewLicServer')) {
        if ($force) {
            $GLOBALS["FORCE"]=true;
        }
        echo "START REGISTER";
        build_progress("{license_migration_title}: {collecting_data}", 10);
        //build_progress("{license_active}: Verify validation...", 90);
        //build_progress("{service_disable} {APP_MOBILEAPP}... {success}",100);
        if ($GLOBALS["VERBOSE"]) {
            echo __FUNCTION__ . "() in line " . __LINE__ . "\n";
        }
        $sock = new sockets();
        $unix = new unix();
        $pidfile = "/etc/artica-postfix/pids/" . basename(__FILE__) . "." . __FUNCTION__ . ".pid";
        $cachetime = "/etc/artica-postfix/pids/" . basename(__FILE__) . "." . __FUNCTION__ . ".time";
        $pid = @file_get_contents($pidfile);

        $sock = new sockets();
        $EnableKerbAuth = @file_get_contents("/etc/artica-postfix/settings/Daemons/EnableKerbAuth");
        if (!is_numeric("$EnableKerbAuth")) {
            $EnableKerbAuth = 0;
        }

        if ($GLOBALS["VERBOSE"]) {
            echo "Loading WizardSavedSettings " . __FUNCTION__ . "() in line " . __LINE__ . "\n";
        }
        $WizardSavedSettings = unserialize(base64_decode(@file_get_contents("/etc/artica-postfix/settings/Daemons/WizardSavedSettings")));

        if ($GLOBALS['MIGRATION']) {
            $WizardSavedSettings = json_decode(json_encode(unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("TokenRequest")))), true);
        }

        $WizardSavedSettingsSend = intval(@file_get_contents("/etc/artica-postfix/settings/Daemons/WizardSavedSettingsSend"));
        $Migration = intval(@file_get_contents("/etc/artica-postfix/settings/Daemons/Migration"));

        if (!$GLOBALS['MIGRATION']) {
            if (count($WizardSavedSettings) < 2) {
                if ($GLOBALS["VERBOSE"]) {
                    echo "WizardSavedSettings array is less than 2" . __FUNCTION__ . "() in line " . __LINE__ . "\n";
                }
                return;
            }

            if (!isset($WizardSavedSettings["key"])) {
                $WizardSavedSettings["key"] = null;
            }
            if ($WizardSavedSettings["key"] == null) {
                return;
            }
        }

        if ($force) {
            $Migration = 0;
        }
        if ($GLOBALS['FROM_WIZARD']) {
            $Migration = 0;
        }
        if ($Migration == 1) {
            echo "1";
            if (!$GLOBALS["FORCE"]) {
                echo "2";
                if ($GLOBALS["VERBOSE"]) {echo "Migration == 1, aborting.. (use --force)" . __FUNCTION__ . "() in line " . __LINE__ . "\n";}
                return false;
            }
        }

        $uuid = $unix->GetUniqueID();
        if ($uuid == null) {
            if ($GLOBALS["VERBOSE"]) {
                echo "No system ID !\n";
            }
            return false;
        }
        $WizardSavedSettings["ACTIVE_DIRECTORY"] = $EnableKerbAuth;

        if ($EnableKerbAuth == 1) {
            include_once dirname(__FILE__) . "/ressources/class.external.ad.inc";
            $ldap = new external_ad_search();
            $NET_RPC_INFOS = $ldap->NET_RPC_INFOS();
            foreach ($NET_RPC_INFOS as $a=>$b){
                $WizardSavedSettings[$a] = $b;
            }
        }
        $LicenseInfos = null;
        if (file_exists("/etc/artica-postfix/settings/Daemons/LicenseInfos")) {
            $LicenseInfos = unserialize(base64_decode(@file_get_contents("/etc/artica-postfix/settings/Daemons/LicenseInfos")));
        }
        $WizardSavedSettings["UUID"] = $uuid;
        $WizardSavedSettings["CPUS_NUMBER"] = $unix->CPU_NUMBER();
        $WizardSavedSettings["LINUX_DISTRI"] = $unix->LINUX_DISTRIBUTION();
        $WizardSavedSettings["ARTICAVERSION"] = @file_get_contents("/usr/share/artica-postfix/VERSION");
        $WizardSavedSettings["STATS_APPLIANCE"] = 0;

        if (is_file("/etc/artica-postfix/STATS_APPLIANCE")) {
            $WizardSavedSettings["APPLIANCE"] = "Artica Stats Appliance";
            $WizardSavedSettings["STATS_APPLIANCE"] = 1;
        }
        if (is_file("/etc/artica-postfix/WEBSECURITY_APPLIANCE")) {
            $WizardSavedSettings["WEBSECURITY_APPLIANCE"] = 1;
        }

        $zarafa_server = $unix->find_program("zarafa-server");
        if (is_file($zarafa_server)) {
            $WizardSavedSettings["ZARAFA APPLIANCE"] = "YES";
        }
        $squid = $unix->find_program("squid");
        if (is_file($squid)) {
            $WizardSavedSettings["PROXY INSTALLED"] = "YES";
        }
        if (is_file("/etc/artica-postfix/FROM_ISO")) {
            $WizardSavedSettings["FROM ISO"] = "YES";
        }
        if (is_file("/etc/artica-postfix/SQUID_APPLIANCE")) {
            $WizardSavedSettings["APPLIANCE"] = "Artica Proxy";
            $WizardSavedSettings["PROXY APPLIANCE"] = "YES";
        }
        if (is_file("/etc/artica-postfix/SAMBA_APPLIANCE")) {
            $WizardSavedSettings["APPLIANCE"] = "Artica NAS";
            $WizardSavedSettings["N.A.S APPLIANCE"] = "YES";
        }

        if (is_file("/etc/artica-postfix/artica-iso-first-reboot")) {
            $zDate = filemtime("/etc/artica-postfix/artica-iso-first-reboot");
            $WizardSavedSettings["INSTALL_DATE"] = date("Y-m-d H:i:s", $zDate);
        } else {
            $zDate = filemtime("/etc/artica-postfix/.");
            $WizardSavedSettings["INSTALL_DATE"] = date("Y-m-d H:i:s", $zDate);
        }
        $WizardSavedSettings["REGISTER"] = 1;
        if (is_file("/etc/artica-postfix/dmidecode.cache.url")) {
            $final_array = unserialize(base64_decode(@file_get_contents("/etc/artica-postfix/dmidecode.cache.url")));
            foreach ($final_array as $a=>$b){
                $WizardSavedSettings[$a] = $b;
            }
        }
        @file_put_contents("/etc/artica-postfix/settings/Daemons/WizardSavedSettings", base64_encode(serialize($WizardSavedSettings)));

        if (file_exists("/etc/artica-postfix/settings/Daemons/LicenseInfos")) {
            $MergedArray = $LicenseInfos;

            foreach ($MergedArray as $num=>$val){
                $val = trim($val);
                if ($val == null) {
                    continue;
                }
                if (isset($WizardSavedSettings[$num])) {
                    continue;
                }
                $WizardSavedSettings[$num] = $val;
            }
        }

        $hostname = $unix->hostname_g();
        $tt = explode(".", $hostname);
        $netbiosname = $tt[0];
        unset($tt[0]);
        $domain = @implode(".", $tt);

        $WizardSavedSettings["netbiosname"] = $netbiosname;
        $WizardSavedSettings["domain"] = $domain;
        $WizardSavedSettings["CPUS_NUMBER"] = $unix->CPU_NUMBER();
        $WizardSavedSettings["MEMORY"] = $unix->TOTAL_MEMORY_MB();
        build_progress("{license_migration_title}: {connecting_to_server}", 50);
        if ($GLOBALS["VERBOSE"]) {
            echo "Send order to api/server/register " . __FUNCTION__ . "() in line " . __LINE__ . "\n";
        }
        $curl = new ccurl("https://licensing.artica.center/api/register/server", false, null);
        $curl->parms["X-API-KEY"] = $WizardSavedSettings["X-API-KEY"];
        $curl->parms["REGISTER"] = base64_encode(serialize($WizardSavedSettings));
        if ($GLOBALS["VERBOSE"]) {
            $curl->parms["VERBOSE"] = true;
        }
        $curl->NoLocalProxy();
        $curl->get();
        if ($GLOBALS["VERBOSE"]) {
			echo $curl->data;
        }
        $response = json_decode(getLastLines($curl->orginal_data));
        if ($response->status) {
            $sock->SET_INFO("WizardSavedSettingsSend", 1);
			$sock->SET_INFO("NewLicServer", 1);
			$sock->SET_INFO('Migration',1);
            if ($GLOBALS['MIGRATION'] || $GLOBALS['FROM_WIZARD'] || $force) {
                build_progress("{license_migration_title}: $response->message", 60);
                register_lic();
            } else {
                build_progress("{license_migration_title}: $response->message", 100);
            }
        } else {
            build_progress("{license_migration_title}: $response->message", 110);
        }
    } else {
        if ($force) {
            $GLOBALS["FORCE"]=true;
        }
        echo "Register the server\n";
        if ($GLOBALS["VERBOSE"]) {
            echo __FUNCTION__."() in line ". __LINE__."\n";
        }
        $sock=new sockets();
        $unix=new unix();

        $URIBASE=$unix->MAIN_URI();
        $URIBASE=str_replace("articatech.net", "artica.fr", $URIBASE);
        $pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
        $cachetime="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".time";
        $pid=@file_get_contents($pidfile);
        if ($unix->process_exists($pid)) {
            events("Already executed PID:$pid, die()", __FUNCTION__, __FILE__, __LINE__);
            exit();
        }
    

        $EnableKerbAuth=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableKerbAuth");
        if (!is_numeric("$EnableKerbAuth")) {
            $EnableKerbAuth=0;
        }
    
        if ($GLOBALS["VERBOSE"]) {
            echo "Loading WizardSavedSettings ".__FUNCTION__."() in line ". __LINE__."\n";
        }
        $WizardSavedSettings=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("WizardSavedSettings")));
        $WizardSavedSettings=RepairSidentity($WizardSavedSettings);

        $LicenseInfos=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LicenseInfos")));

        $WizardSavedSettingsSend=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("WizardSavedSettingsSend"));


        if (count($WizardSavedSettings)<2) {
            if (count($LicenseInfos)>2) {
                $WizardSavedSettings=array();
                $WizardSavedSettings["company_name"]=$LicenseInfos["company_name"];
                $WizardSavedSettings["company_www"]=$LicenseInfos["company_www"];
                $WizardSavedSettings["mail"]=$LicenseInfos["mail"];
                $WizardSavedSettings["employees"]=$LicenseInfos["employees"];
                $WizardSavedSettings["domain"]=$LicenseInfos["company_www"];
            }
        }


    
    
        if (count($WizardSavedSettings)<2) {
            echo "Register: WizardSavedSettings is corrupted...\n";
            if ($GLOBALS["VERBOSE"]) {
                echo "WizardSavedSettings array is less than 2".__FUNCTION__."() in line ". __LINE__."\n";
            }
            return;
        }


        if (!isset($WizardSavedSettings["company_name"])) {
            $WizardSavedSettings["company_name"]=null;
        }

        if ($WizardSavedSettings["company_name"]==null) {
            if (isset($WizardSavedSettings["COMPANY"])) {
                $WizardSavedSettings["company_name"]=$WizardSavedSettings["COMPANY"];
            }
        }


        if ($WizardSavedSettings["company_name"]==null) {
            $LicenseInfos = unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LicenseInfos")));
            if ($LicenseInfos["COMPANY"]<>null) {
                $WizardSavedSettings["company_name"]=$LicenseInfos["COMPANY"];
            }
        }


        if ($WizardSavedSettings["company_name"]==null) {
            echo "Company Name is null!\n";
            return;
        }
    
        if (!is_numeric($WizardSavedSettingsSend)) {
            $WizardSavedSettingsSend=0;
        }
        if ($WizardSavedSettingsSend==1) {
            if (!$GLOBALS["FORCE"]) {
                echo "WizardSavedSettingsSend == 1, aborting.. (use --force)".__FUNCTION__."() in line ". __LINE__."\n";
                return;
            }
        }
    
        $uuid=$unix->GetUniqueID();
        if ($uuid==null) {
            if ($GLOBALS["VERBOSE"]) {
                echo "No system ID !\n";
            }
            return;
        }
        $WizardSavedSettings["ACTIVE_DIRECTORY"]=$EnableKerbAuth;
    
        if ($EnableKerbAuth==1) {
            include_once(dirname(__FILE__)."/ressources/class.external.ad.inc");
            $ldap=new external_ad_search();
            $NET_RPC_INFOS=$ldap->NET_RPC_INFOS();
            foreach ($NET_RPC_INFOS as $a=>$b){
                $WizardSavedSettings[$a]=$b;
            }
        }
        $LicenseInfos=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LicenseInfos")));
        $WizardSavedSettings["UUID"]=$uuid;
        $WizardSavedSettings["CPUS_NUMBER"]=$unix->CPU_NUMBER();
        $WizardSavedSettings["LINUX_DISTRI"]=$unix->LINUX_DISTRIBUTION();
        $WizardSavedSettings["ARTICAVERSION"]=@file_get_contents("/usr/share/artica-postfix/VERSION");
        $WizardSavedSettings["STATS_APPLIANCE"]=0;
    
        if (is_file("/etc/artica-postfix/STATS_APPLIANCE")) {
            $WizardSavedSettings["APPLIANCE"]="Artica Stats Appliance";
            $WizardSavedSettings["STATS_APPLIANCE"]=1;
        }
        if (is_file("/etc/artica-postfix/WEBSECURITY_APPLIANCE")) {
            $WizardSavedSettings["WEBSECURITY_APPLIANCE"]=1;
        }
    
    
        $zarafa_server=$unix->find_program("zarafa-server");
        if (is_file($zarafa_server)) {
            $WizardSavedSettings["ZARAFA APPLIANCE"]="YES";
        }
        $squid=$unix->find_program("squid");
        if (is_file($squid)) {
            $WizardSavedSettings["PROXY INSTALLED"]="YES";
        }
        if (is_file("/etc/artica-postfix/FROM_ISO")) {
            $WizardSavedSettings["FROM ISO"]="YES";
        }
        if (is_file("/etc/artica-postfix/SQUID_APPLIANCE")) {
            $WizardSavedSettings["APPLIANCE"]="Artica Proxy";
            $WizardSavedSettings["PROXY APPLIANCE"]="YES";
        }
        if (is_file("/etc/artica-postfix/SAMBA_APPLIANCE")) {
            $WizardSavedSettings["APPLIANCE"]="Artica NAS";
            $WizardSavedSettings["N.A.S APPLIANCE"]="YES";
        }
    
        if (is_file("/etc/artica-postfix/artica-iso-first-reboot")) {
            $zDate=filemtime("/etc/artica-postfix/artica-iso-first-reboot");
            $WizardSavedSettings["INSTALL_DATE"]=date("Y-m-d H:i:s", $zDate);
        } else {
            $zDate=filemtime("/etc/artica-postfix/.");
            $WizardSavedSettings["INSTALL_DATE"]=date("Y-m-d H:i:s", $zDate);
        }
    
        if (is_file("/etc/artica-postfix/dmidecode.cache.url")) {
            $final_array=unserialize(base64_decode(@file_get_contents("/etc/artica-postfix/dmidecode.cache.url")));
            foreach ($final_array as $a=>$b){
                $WizardSavedSettings[$a]=$b;
            }
        }
    
        $MergedArray=$LicenseInfos;
    

    
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("WizardSavedSettings", base64_encode(serialize($WizardSavedSettings)));
    
        if (is_array($MergedArray)) {
            foreach ($MergedArray as $num=>$val) {
                $val=trim($val);
                if ($val==null) {
                    continue;
                }
                if (isset($WizardSavedSettings[$num])) {
                    continue;
                }
                $WizardSavedSettings[$num]=$val;
            }
        }
    
        $hostname=$unix->hostname_g();
        $tt=explode(".", $hostname);
        $netbiosname=$tt[0];
        unset($tt[0]);
        $domain=@implode(".", $tt);
    
        $WizardSavedSettings["netbiosname"]=$netbiosname;
        $WizardSavedSettings["domain"]=$domain;
        $WizardSavedSettings["CPUS_NUMBER"]=$unix->CPU_NUMBER();
        $WizardSavedSettings["MEMORY"]=$unix->TOTAL_MEMORY_MB();
    
        if ($GLOBALS["VERBOSE"]) {
            echo "Send order to $URIBASE/shalla-orders.php ".__FUNCTION__."() in line ". __LINE__."\n";
        }
        $curl=new ccurl("$URIBASE/shalla-orders.php", false, null);
        $curl->parms["REGISTER"]=base64_encode(serialize($WizardSavedSettings));
        if ($GLOBALS["VERBOSE"]) {
            $curl->parms["VERBOSE"]=true;
        }
        $curl->NoLocalProxy();
        $curl->get();
        if ($GLOBALS["VERBOSE"]) {
            echo $curl->data;
        }
    
        if (preg_match("#GOOD#s", $curl->data)) {
            echo "Register: server answer GOOD\n";
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("WizardSavedSettingsSend", 1);
            $LicenseInfos=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LicenseInfos")));
            $LicenseInfos["REGISTER"]=1;
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseInfos", base64_encode(serialize($LicenseInfos)));
            return true;
        }
    
        echo "Register: -------------------------\n";
        echo $curl->data;
        return false;
    }
}

function XZCPU_NUMBER()
{
    $unix=new unix();
    $cat=$unix->find_program("cat");
    $grep=$unix->find_program("grep");
    $cut=$unix->find_program("cut");
    $wc=$unix->find_program("wc");
    $cmd="$cat /proc/cpuinfo |$grep \"model name\" |$cut -d: -f2|$wc -l 2>&1";
    $CPUNUM=exec($cmd);
    
    return $CPUNUM;
}

function uuid_check()
{
    $unix=new unix();
    $uuid=$unix->GetUniqueID();
    echo $uuid."\n";
}

function  remove_grace_period(){
    $time=strtotime("-7 day");
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseINGP",$time);
    system("clear");
    echo "Grace period, is removed\n";
}

function CheckLic($array1=array(), $array2=array()){

    if(is_file(LkdPTEQ)){
        if($GLOBALS["CLASS_SOCKETS"]->IsGoldKey(trim(@file_get_contents(LkdPTEQ)))){
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseINGP", 0);
            build_progress("{license_active}: {gold_license}", 100);
            return true;
        }
    }


    if (file_exists('/etc/artica-postfix/settings/Daemons/NewLicServer')) {
        $WORKDIR        = base64_decode("L3Vzci9sb2NhbC9zaGFyZS9hcnRpY2E=");
        $WORKFILE       = base64_decode('LmxpYw==');
        $function_ghost = base64_decode("Y2hlY2tsaWNlbnNlLmJpbg==");
        $line_ghost     = base64_decode("MTA4NDM=");
        $textGhost      = base64_decode("Q29ycG9yYXRlIExpY2Vuc2UgZXhwaXJlZCAtIHJldHVybiBiYWNrIHRvIENvbW11bml0eSBsaWNlbnNl");
        $verifailed     = base64_decode("Q29ycG9yYXRlIExpY2Vuc2UgZXhwaXJlZCAtIHJldHVybiBiYWNrIHRvIENvbW11bml0eSBsaWNlbnNl");
        $licexpir       = base64_decode("e2xpY2Vuc2VfZXhwaXJlZH0=");
        $fname          = base64_decode("L2V0Yy9hcnRpY2EtcG9zdGZpeC9zZXR0aW5ncy9EYWVtb25zL0NPUlBfTElDRU5TRQ==");
        $licActi        = base64_decode("e2xpY2Vuc2VfYWN0aXZlfQ==");
        $einGP          = base64_decode("RW50ZXJpbmcgaW4gZ3JhY2UgcGVyaW9k");
        $einGPR         = base64_decode("TGljZW5zZSBpcyBvaywgcmVtb3ZlIGdyYWNlIHBlcmlvZA==");
        $WORKPATH       = "$WORKDIR/$WORKFILE";
        $unix           = new unix();
        $sock           = new sockets();
        $curl           = new ccurl("https://licensing.artica.center/api/check/license", false, null);
        $php            = $unix->LOCATE_PHP5_BIN();
        $squidbin       = $unix->LOCATE_SQUID_BIN();
        $finaltime      = 0;
        $badmail        = 0;
        build_progress("{license_active}: Verify validation...", 90);


        $curl->parms["X-API-KEY"] = $array2["X-API-KEY"];
        $curl->parms["REGISTER-LIC"] = base64_encode(serialize($array1));

        events("Contacting api/check/license", __FUNCTION__, __FILE__, __LINE__);
        $curl->NoLocalProxy();
        $curl->get();
        $response = json_decode(getLastLines($curl->orginal_data));

        if(property_exists($response,"status")){
            build_progress("{license_active}: Status property OK", 91);
        }

        if(!property_exists($response,"status")){
            build_progress("{license_server_error}: status is not a property...", 110);
            events("property_exists(response,status) Failed\n$curl->orginal_data", __FUNCTION__, __FILE__, __LINE__);
            echo "property_exists status => False..\n";
            echo "$curl->orginal_data\n";
            return false;
        }

        build_progress("{license_active}: Checking response ($response->status/$response->message)", 92);


        if (!$response->status) {
            echo "License don't exist on the server\n";
            @unlink($WORKPATH);
            build_progress("{license_invalid}: Verify validation failed...", 110);
            $array1["license_status"] = "{license_invalid}";
            $array1["license_number"] = null;
            $array1["UNLOCKLIC"] = null;
            $array1["FINAL_TIME"] = null;
            $array1["TIME"] = time();
            squid_admin_mysql(0, $textGhost, null, $function_ghost, $line_ghost);
            system("$php /usr/share/artica-postfix/exec.disable.license.php");
            system("$php /usr/share/artica-postfix/exec.status.php --process1");
            @file_put_contents("/etc/artica-postfix/settings/Daemons/CurrentLIC", 0);
            if(is_file($fname)){@unlink($fname);}
            $sock->SaveConfigFile(base64_encode(serialize($array1)), "LicenseInfos");
            if (is_file($squidbin)) {
                shell_exec("$php /usr/share/artica-postfix/exec.squid.php --build");
                shell_exec("/etc/init.d/squid restart {$GLOBALS["SCRIPT_SUFFIX"]}");
            }

            return;
        }
        if ($response->status && $response->message == "1") {
            $finaltime = $response->expire;
            $license_key=$response->license;
            events("Expiration time: " . $finaltime." ".date("Y-m-d H:i:s",$finaltime),__FUNCTION__,__FILE__,__LINE__);
            events("License Key: $license_key",__FUNCTION__,__FILE__,__LINE__);

            if ($finaltime > 0) {
                if (time() > $finaltime) {

                    $LicenseINGP=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LicenseINGP"));
                    events("LicenseINGP === $LicenseINGP",__FUNCTION__,__FILE__,__LINE__);
                    if($LicenseINGP==0){
                        squid_admin_mysql(0, $einGP, null, $function_ghost, $line_ghost);
                        $gptime = strtotime("+7 day");
                        $gptimeF= strtotime("+7 day",$finaltime);

                        if($gptime>$gptimeF) {
                            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseINGP", $gptime);
                            $array1["license_status"] = base64_decode("e2dyYWNlX3BlcmlvZH0=");
                            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseInfos", base64_encode(serialize($array1)));
                            $unix->ToSyslog("License info: " . base64_decode("e2dyYWNlX3BlcmlvZH0=") . " 7 days more.");
                            build_progress(base64_decode("e2dyYWNlX3BlcmlvZH0=")." {refresh}", 99);
                            system("$php /usr/share/artica-postfix/exec.status.php --process1");
                            build_progress("{license_active} {success}", 100);
                            return true;
                        }
                    }

                    if($LicenseINGP>time()){
                        $array1["license_status"]=base64_decode("e2dyYWNlX3BlcmlvZH0=");
                        $unix->ToSyslog("License info: ".base64_decode("e2dyYWNlX3BlcmlvZH0="));
                        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseInfos", base64_encode(serialize($array1)));
                        $unix->ToSyslog("License info: ".base64_decode("e2dyYWNlX3BlcmlvZH0=")." expire in " .($LicenseINGP-time())." seconds");
                        build_progress(base64_decode("e2dyYWNlX3BlcmlvZH0=")." {refresh}", 99);
                        system("$php /usr/share/artica-postfix/exec.status.php --process1");
                        build_progress("{license_active} {success}", 100);
                        return true;
                    }
                    $unix->ToSyslog("FATAL: $licexpir");




                    if (is_file($WORKPATH)) {
                        @unlink($WORKPATH);
                        @unlink($fname);
                        build_progress($verifailed, 110);
                        $array1["license_status"] = $licexpir;
                        $array1["license_number"] = null;
                        $array1["UNLOCKLIC"] = null;
                        $array1["TIME"] = time();
                        if ($finaltime > 0) {
                            $LicenseInfos["FINAL_TIME"] = $finaltime;
                        }
                        squid_admin_mysql(0, $textGhost, null, $function_ghost, $line_ghost);
                        system("$php /usr/share/artica-postfix/exec.status.php --process1");
                        @file_put_contents("/etc/artica-postfix/settings/Daemons/CurrentLIC", 0);
                        system("$php /usr/share/artica-postfix/exec.disable.license.php");
                        $sock->SaveConfigFile(base64_encode(serialize($array1)), "LicenseInfos");
                        if (is_file($squidbin)) {
                            shell_exec("$php /usr/share/artica-postfix/exec.squid.php --build");
                            shell_exec("/etc/init.d/squid restart {$GLOBALS["SCRIPT_SUFFIX"]}");
                        }
                    }
                    return;
                } else {
                    $LicenseINGP=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LicenseINGP"));

                    if($LicenseINGP>0){
                        squid_admin_mysql(0, $einGPR, null, $function_ghost, $line_ghost);
                        $unix->ToSyslog("License info: ".$einGPR);
                        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseINGP",0);
                    }

                    $array1["license_status"] = "{license_active}";
                    $array1["license_number"] = $response->license;
                    $array1["TIME"] = time();
                    $array1["FINAL_TIME"] = $finaltime;
                    $sock->SaveConfigFile(base64_encode(serialize($array1)), "LicenseInfos");
                    build_progress("{license_active} {refresh}", 100);
                    system("$php /usr/share/artica-postfix/exec.status.php --process1");
                    build_progress("{license_active} {success}", 100);
                    return true;
                }
            }
        }
        if ($response->status && $response->message == "5") {
            echo "License don't exist on the server\n";
            @unlink($WORKPATH);
            build_progress("{license_invalid}: License key don't exist on the server, creating a trial license...", 80);
            $array1["license_status"] = "{license_invalid}";
            $array1["license_number"] = null;
            $array1["UNLOCKLIC"] = null;
            $array1["FINAL_TIME"] = null;
            $array1["TIME"] = time();
            if(is_file($fname)){@unlink($fname);}
            squid_admin_mysql(0, $textGhost, null, $function_ghost, $line_ghost);
            system("$php /usr/share/artica-postfix/exec.status.php --process1");
            system("$php /usr/share/artica-postfix/exec.disable.license.php");
            @file_put_contents("/etc/artica-postfix/settings/Daemons/CurrentLIC", 0);
            $sock->SaveConfigFile(base64_encode(serialize($array1)), "LicenseInfos");
            if (is_file($squidbin)) {
                shell_exec("$php /usr/share/artica-postfix/exec.squid.php --build");
                shell_exec("/etc/init.d/squid restart {$GLOBALS["SCRIPT_SUFFIX"]}");
            }

            register_lic(true);
        }
        if ($response->status && $response->message == "2") {
            echo "License don't exist on the server\n";
            @unlink($WORKPATH);
            build_progress("{license_invalid}: Verify validation failed...", 110);
            $array1["license_status"] = "{license_invalid}";
            $array1["license_number"] = null;
            $array1["UNLOCKLIC"] = null;
            $array1["FINAL_TIME"] = null;
            $array1["TIME"] = time();
            if(is_file($fname)){@unlink($fname);}
            squid_admin_mysql(0, $textGhost, null, $function_ghost, $line_ghost);
            system("$php /usr/share/artica-postfix/exec.status.php --process1");
            @file_put_contents("/etc/artica-postfix/settings/Daemons/CurrentLIC", 0);
            system("$php /usr/share/artica-postfix/exec.disable.license.php");
            $sock->SaveConfigFile(base64_encode(serialize($array1)), "LicenseInfos");
            if (is_file($squidbin)) {
                shell_exec("$php /usr/share/artica-postfix/exec.squid.php --build");
                shell_exec("/etc/init.d/squid restart {$GLOBALS["SCRIPT_SUFFIX"]}");
            }

            return;
        }
    } else {
        $WORKDIR        = base64_decode("L3Vzci9sb2NhbC9zaGFyZS9hcnRpY2E=");
        $WORKFILE       = base64_decode('LmxpYw==');
        $function_ghost = base64_decode("Y2hlY2tsaWNlbnNlLmJpbg==");
        $line_ghost     = base64_decode("MTA4NDM=");
        $textGhost      = base64_decode("Q29ycG9yYXRlIExpY2Vuc2UgZXhwaXJlZCAtIHJldHVybiBiYWNrIHRvIENvbW11bml0eSBsaWNlbnNl");
        $verifailed     = base64_decode("Q29ycG9yYXRlIExpY2Vuc2UgZXhwaXJlZCAtIHJldHVybiBiYWNrIHRvIENvbW11bml0eSBsaWNlbnNl");
        $licexpir       = base64_decode("e2xpY2Vuc2VfZXhwaXJlZH0=");
        $fname          = base64_decode("L2V0Yy9hcnRpY2EtcG9zdGZpeC9zZXR0aW5ncy9EYWVtb25zL0NPUlBfTElDRU5TRQ==");
        $WORKPATH       = "$WORKDIR/$WORKFILE";
        $unix           = new unix();
        $URIBASE        = $unix->MAIN_URI();
        $URIBASE        = str_replace("articatech.net", "artica.fr", $URIBASE);
        $sock           = new sockets();
        $curl           = new ccurl("$URIBASE/shalla-orders.php", false, null);
        $finaltime      = 0;
        $badmail        = 0;

        build_progress("{license_active}: Verify validation...", 95);
        $curl->parms["REGISTER-LIC"]=base64_encode(serialize($array1));
        $curl->parms["REGISTER-OLD"]=base64_encode(serialize($array2));
        events("shalla-orders.php", __FUNCTION__, __FILE__, __LINE__);
        $curl->get();
        $unix=new unix();
        $php=$unix->LOCATE_PHP5_BIN();
        $squidbin=$unix->LOCATE_SQUID_BIN();

        if (preg_match("#<FINALTIME>([0-9]+)</FINALTIME>#s", $curl->data, $re)) {
            $finaltime=intval($re[1]);
        }
        if ($finaltime>0) {
            if (time()>$finaltime) {
                if (is_file($WORKPATH)) {
                    @unlink($WORKPATH);
                    @unlink($fname);
                    build_progress($verifailed, 110);
                    $array1["license_status"]=$licexpir;
                    $array1["license_number"]=null;
                    $array1["UNLOCKLIC"]=null;
                    $array1["TIME"]=time();
                    if ($finaltime>0) {
                        $LicenseInfos["FINAL_TIME"]=$finaltime;
                    }
                    if(is_file($fname)){@unlink($fname);}
                    squid_admin_mysql(0, $textGhost, null, $function_ghost, $line_ghost);
                    system("$php /usr/share/artica-postfix/exec.disable.license.php");
                    system("$php /usr/share/artica-postfix/exec.status.php --process1");
                    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("CurrentLIC", 0);
                    if (is_file($squidbin)) {
                        shell_exec("$php /usr/share/artica-postfix/exec.squid.php --build");
                        shell_exec("/etc/init.d/squid restart {$GLOBALS["SCRIPT_SUFFIX"]}");
                    }
                    $sock->SaveConfigFile(base64_encode(serialize($array1)), "LicenseInfos");
                }
                return;
            }
        }
    

        if (preg_match("#REGISTRATION_DELETE_NOW#s", $curl->data, $re)) {
            @unlink($WORKPATH);
            if(is_file($fname)){@unlink($fname);}
            build_progress("{license_invalid}: Verify validation failed...", 110);
            $array1["license_status"]="{license_invalid}";
            $array1["license_number"]=null;
            $array1["UNLOCKLIC"]=null;
            $array1["TIME"]=time();
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("CurrentLIC", 0);
            $sock->SaveConfigFile(base64_encode(serialize($array1)), "LicenseInfos");
            system("$php /usr/share/artica-postfix/exec.disable.license.php");
            return;
        }
    }
}








function register_lic_kaspersky()
{
    $sock=new sockets();
    $unix=new unix();
    $WizardSavedSettings=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("WizardSavedSettings")));
    if ($GLOBALS["VERBOSE"]) {
        echo __FUNCTION__."::".__LINE__."\n";
    }
    $uuid=$unix->GetUniqueID();
    if ($GLOBALS["VERBOSE"]) {
        echo " *************** \n\n UUID : $uuid \n\n ***************\n";
    }
    if ($uuid==null) {
        if ($GLOBALS["VERBOSE"]) {
            echo "No system ID !\n";
        }
        return;
    }
    $WizardSavedSettings["UUID"]=$uuid;
    $unix=new unix();
    $URIBASE=$unix->MAIN_URI();
    $URIBASE=str_replace("articatech.net", "artica.fr", $URIBASE);
    $verbosed=null;
    $php=$unix->LOCATE_PHP5_BIN();
    $nohup=$unix->find_program("nohup");
    $KasperskyAskQuoteResults=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("KasperskyAskQuoteResults");
    if ($KasperskyAskQuoteResults=="KEY_OK") {
        return;
    }
    
    if (is_file("/etc/artica-postfix/artica-iso-first-reboot")) {
        $zDate=filemtime("/etc/artica-postfix/artica-iso-first-reboot");
        $WizardSavedSettings["INSTALL_DATE"]=date("Y-m-d H:i:s", $zDate);
    } else {
        $zDate=filemtime("/etc/artica-postfix/.");
        $WizardSavedSettings["INSTALL_DATE"]=date("Y-m-d H:i:s", $zDate);
    }
    
    
    $curl=new ccurl("$URIBASE/shalla-orders.php$verbosed", false, null);
    $curl->NoLocalProxy();
    if ($GLOBALS["VERBOSE"]) {
        $curl->parms["VERBOSE"]=yes;
    }
    $curl->parms["REGISTER_KAV4PROXY"]=base64_encode(serialize($WizardSavedSettings));
    events("shalla-orders.php", __FUNCTION__, __FILE__, __LINE__);
    $curl->get();
    if ($GLOBALS["VERBOSE"]) {
        echo "***** $curl->data ****\n";
    }
    
    if (preg_match("#INVALID_TEMP_LICENSE#is", $curl->data)) {
        $sock->SET_INFO("KasperskyAskQuoteResults", "INVALID_TEMP_LICENSE");
        return false;
    }
    if (preg_match("#CLOUD_ERROR#is", $curl->data)) {
        $sock->SET_INFO("KasperskyAskQuoteResults", "CLOUD_ERROR");
        return false;
    }
    
    if (preg_match("#TEMP_LICENSE=\[(.+?)\]#is", $curl->data, $re)) {
        $sock->SET_INFO("KasperskyAskQuoteResults", "waiting_order");
        $WizardSavedSettings["license_kav4Proxy_temp"]=$re[1];
        $sock->SaveConfigFile(base64_encode(serialize($WizardSavedSettings)), "WizardSavedSettings");
        return true;
    }
    
    if (preg_match("#<LICENSE_K>(.*?)</LICENSE_K>#is", $curl->data, $re)) {
        $ldata=$re[1];
        @file_put_contents("/tmp/kl", $ldata);
        exec("/opt/kaspersky/kav4proxy/bin/kav4proxy-licensemanager -a /tmp/kl 2>&1", $results);
        @unlink("/tmp/kl");
        foreach ($results as $table=>$none){
            if (!preg_match("#successfully registered#", $none)) {
                if ($GLOBALS["VERBOSE"]) {
                    echo "$none\n";
                }
                continue;
            }
            $sock->SET_INFO("KasperskyAskQuoteResults", "KEY_OK");
            shell_exec("$php /usr/share/artica-postfix/exec.keepup2date.php --update");
            shell_exec("$nohup $php /usr/share/artica-postfix/exec.kav4proxy.php --license --force >/dev/null 2>&1 &");
            break;
        }
    }
}

function build_progress($text, $pourc)
{
	$echotext=$text;
	echo "Starting......: ".date("H:i:s")." {$pourc}% $echotext\n";

    $cachefile="/usr/share/artica-postfix/ressources/logs/web/artica.license.progress";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($cachefile, serialize($array));
    @chmod($cachefile, 0755);
}
function check_key_file(){


    if(is_file(LkdPTEQ)){
        if($GLOBALS["CLASS_SOCKETS"]->IsGoldKey(trim(@file_get_contents(LkdPTEQ)))){
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseINGP", 0);
            return true;
        }
    }


    include_once(dirname(__FILE__).'/ressources/class.encrypt.inc');
    $unix=new unix();
    $WORKDIR=base64_decode("L3Vzci9sb2NhbC9zaGFyZS9hcnRpY2E=");
    $KEYFILE=$WORKDIR."/.KEY";
    $uuid=$unix->GetUniqueID();
    if (!is_file($KEYFILE)) {
        return false;
    }
    echo "UUID: $uuid\n";
    
    $function_ghost=base64_decode("Y2hlY2tsaWNlbnNlLmJpbg==");
    $error1=base64_decode("e2dlbmVyaWNfaHR0cF9lcnJvcn0=");
    $textGhost=base64_decode("Q29ycG9yYXRlIExpY2Vuc2UgZXhwaXJlZCAtIHJldHVybiBiYWNrIHRvIENvbW11bml0eSBsaWNlbnNl");
    $verifailed=base64_decode("Q29ycG9yYXRlIExpY2Vuc2UgZXhwaXJlZCAtIHJldHVybiBiYWNrIHRvIENvbW11bml0eSBsaWNlbnNl");
    $licexpir=base64_decode("e2xpY2Vuc2VfZXhwaXJlZH0=");
    $line_ghost=base64_decode("MTA4NDM=");
    $squidbin=$unix->LOCATE_SQUID_BIN();
    $php=$unix->LOCATE_PHP5_BIN();
    $licexpir=base64_decode("e2xpY2Vuc2VfZXhwaXJlZH0=");
    $licActi=base64_decode("e2xpY2Vuc2VfYWN0aXZlfQ==");
    $einGP=base64_decode("RW50ZXJpbmcgaW4gZ3JhY2UgcGVyaW9k");
    $einGPR=base64_decode("TGljZW5zZSBpcyBvaywgcmVtb3ZlIGdyYWNlIHBlcmlvZA==");
    $LicenseInfos=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LicenseInfos")));



    $cryptClass=new McryptCipher($uuid);
    $KEY_CONTENT=@file_get_contents($KEYFILE);
    $decrypted=$cryptClass->decrypt($KEY_CONTENT);
    $array=unserialize(base64_decode($decrypted));
    
    
    if (!is_array($array)) {
        @unlink($KEYFILE);
        return false;
    }

    
    $finaltime=intval($array["finaltime"]);
    if ($finaltime==0) {
        return true;
    }
    $LicenseInfos["TIME"]=time();

    echo "$licexpir ".date("Y-m-d H:i:s")."\n";
    $LicenseINGP=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LicenseINGP"));
    if ($finaltime<time()) {

        if($LicenseINGP==0){
            squid_admin_mysql(0, $einGP, null, $function_ghost, $line_ghost);
            $gptime = strtotime("+7 day");
            $gptimeF= strtotime("+7 day",$finaltime);

            if($gptime>$gptimeF) {
                $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseINGP", $gptime);
                $LicenseInfos["license_status"] = base64_decode("e2dyYWNlX3BlcmlvZH0=");
                $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseInfos", base64_encode(serialize($LicenseInfos)));
                $unix->ToSyslog("License info: " . base64_decode("e2dyYWNlX3BlcmlvZH0=") . " 7 days more.");
                return true;
            }
        }

        if($LicenseINGP>time()){
            $LicenseInfos["license_status"]=base64_decode("e2dyYWNlX3BlcmlvZH0=");
            $unix->ToSyslog("License info: ".base64_decode("e2dyYWNlX3BlcmlvZH0="));
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseInfos", base64_encode(serialize($LicenseInfos)));
            $unix->ToSyslog("License info: ".base64_decode("e2dyYWNlX3BlcmlvZH0=")." expire in " .($LicenseINGP-time())." seconds");
            return true;
        }
        $unix->ToSyslog("FATAL: $licexpir");
        $LicenseInfos["license_status"]=$licexpir;
        $LicenseInfos["license_number"]=null;
        $LicenseInfos["UNLOCKLIC"]=null;
        @unlink($KEYFILE);
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseInfos", base64_encode(serialize($LicenseInfos)));
        squid_admin_mysql(0, $textGhost, null, $function_ghost, $line_ghost);
        system("$php /usr/share/artica-postfix/exec.status.php --process1");
        if (is_file($squidbin)) {
            shell_exec("$php /usr/share/artica-postfix/exec.squid.php --build");
            shell_exec("$php /usr/share/artica-postfix/exec.kerbauth.php --disconnect");
            shell_exec("/etc/init.d/squid restart {$GLOBALS["SCRIPT_SUFFIX"]}");
        }
        
        return false;
    }

    if($LicenseINGP>0){
        squid_admin_mysql(0, $einGPR, null, $function_ghost, $line_ghost);
        $unix->ToSyslog("License info: ".$einGPR);
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseINGP",0);

    }
    $LicenseInfos["license_status"]=$licActi;
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseInfos", base64_encode(serialize($LicenseInfos)));
    return true;
}

function ping_server($noprgress=false){
    if (file_exists('/etc/artica-postfix/settings/Daemons/NewLicServer')) {
        $unix = new unix();
        $LicenseInfos = unserialize(base64_decode(@file_get_contents("/etc/artica-postfix/settings/Daemons/LicenseInfos")));
        $hostname = $unix->hostname_g();
        $tt = explode(".", $hostname);
        $netbiosname = $tt[0];
        unset($tt[0]);
        $domain = @implode(".", $tt);
        unset($LicenseInfos["administratorpass"]);
        unset($LicenseInfos["SQL1"]);
        unset($LicenseInfos["administrator"]);
        unset($LicenseInfos["ArticaMetaPassword"]);
        unset($LicenseInfos["ArticaMetaUsername"]);
        $uuid = $unix->GetUniqueID();
        $LicenseInfos["netbiosname"] = $netbiosname;
        $LicenseInfos["domain"] = $domain;
        $LicenseInfos["CPUS_NUMBER"] = $unix->CPU_NUMBER();
        $LicenseInfos["MEMORY"] = $unix->TOTAL_MEMORY_MB();
        $LicenseInfos["LINUX_DISTRI"] = $unix->LINUX_DISTRIBUTION();
        $LicenseInfos["UUID"] = $uuid;
        $LicenseInfos["ARTICAVERSION"] = @file_get_contents("/usr/share/artica-postfix/VERSION");
        $LicensePingInfos = @file_get_contents("/etc/artica-postfix/settings/Daemons/LicensePingInfos");

        echo "Checking license on the cloud server\n";
       if(!$noprgress){ build_progress("Ping the cloud server...", 40);}
        echo "[" . __LINE__ . "] Contacting api/ping/server\n";
        if(!isset($LicenseInfos["X-API-KEY"])){$LicenseInfos["X-API-KEY"]=null;}
        $curl = new ccurl("https://licensing.artica.center/api/ping/server", false, null);
        $curl->parms["X-API-KEY"] = $LicenseInfos["X-API-KEY"];
        $curl->parms["PING-LIC"] = base64_encode(serialize($LicenseInfos));
        $curl->NoLocalProxy();
        $curl->get();
        $response = json_decode(getLastLines($curl->orginal_data));
        if (!$response->status) {
            echo "**********************************\n";
            echo "*\n";
            echo "* Failed to contact cloud server..*\n";
            echo "*\n";
            echo "**********************************\n";
            echo $curl->data;
            @unlink("/etc/artica-postfix/settings/Daemons/LicensePingInfos");
            @file_put_contents("/etc/artica-postfix/settings/Daemons/LicensePingInfos", $LicensePingInfos);
        }
    } else {
        $unix=new unix();
        $LicenseInfos=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LicenseInfos")));
        $hostname=$unix->hostname_g();
        $tt=explode(".", $hostname);
        $netbiosname=$tt[0];
        unset($tt[0]);
        $domain=@implode(".", $tt);
        unset($LicenseInfos["administratorpass"]);
        unset($LicenseInfos["SQL1"]);
        unset($LicenseInfos["administrator"]);
        unset($LicenseInfos["ArticaMetaPassword"]);
        unset($LicenseInfos["ArticaMetaUsername"]);
        $uuid=$unix->GetUniqueID();
        $LicenseInfos["netbiosname"]=$netbiosname;
        $LicenseInfos["domain"]=$domain;
        $LicenseInfos["CPUS_NUMBER"]=$unix->CPU_NUMBER();
        $LicenseInfos["MEMORY"]=$unix->TOTAL_MEMORY_MB();
        $LicenseInfos["LINUX_DISTRI"]=$unix->LINUX_DISTRIBUTION();
        $LicenseInfos["UUID"]=$uuid;
        $LicenseInfos["ARTICAVERSION"]=@file_get_contents("/usr/share/artica-postfix/VERSION");
        $URIBASE=$unix->MAIN_URI();
        $URIBASE=str_replace("articatech.net", "artica.fr", $URIBASE);
    
        $verbosed="?VERBOSE=yes&time=".time();
        echo "Checking license on the cloud server\n";
        if(!$noprgress){build_progress("Ping the cloud server...", 40);}
        echo "Contacting $URIBASE\n";
        $curl=new ccurl("$URIBASE/shalla-orders.php", false, null);
        $curl->parms["PING-LIC"]=base64_encode(serialize($LicenseInfos));
    
        if (!$curl->get()) {
            echo "**********************************\n";
            echo "*\n";
            echo "* Failed to contact cloud server..*\n";
            echo "*\n";
            echo "**********************************\n";
            echo $curl->data;
        }
    }
}

function RepairSidentity($savedsettings)
{
    $sidentity=new sidentity();
    return $sidentity->RepairSidentity($savedsettings);
}

function register_lic($force=false){
    $unix                   = new unix();
    $error124               = base64_decode("SW52YWxpZCBHb2xkIGxpY2Vuc2Uga2V5IQ==");
    $verifailed             = base64_decode("Q29ycG9yYXRlIExpY2Vuc2UgZXhwaXJlZCAtIHJldHVybiBiYWNrIHRvIENvbW11bml0eSBsaWNlbnNl");
    $APP_ARTICA_LIC_GOLD    = trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("APP_ARTICA_LIC_GOLD"));
    if(!is_dir(dirname(LkdPTEQ))){@mkdir(dirname(LkdPTEQ),0755,true);}


    if($APP_ARTICA_LIC_GOLD<>null){
        if(!$GLOBALS["CLASS_SOCKETS"]->IsGoldKey($APP_ARTICA_LIC_GOLD)){
            build_progress("$APP_ARTICA_LIC_GOLD $error124", 110);
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_ARTICA_LIC_GOLD"," ");
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseINGP", 0);
            build_progress("{gold_license}", 100);
            die();
        }

        @file_put_contents(LkdPTEQ,$APP_ARTICA_LIC_GOLD);
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("WizardSavedSettingsSend", 1);
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("NewLicServer", 1);
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO('Migration',1);
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_ARTICA_LIC_GOLD"," ");
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("HideCorporateFeatures",0);

        $LicenseInfos=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LicenseInfos")));
        $uuid = $unix->GetUniqueID();
        $LicenseInfos["MIGRATION"] = 1;
        $LicenseInfos["UUID"] = $uuid;
        $LicenseInfos["uuid"] = $uuid;
        $LicenseInfos["ARTICAVERSION"] = @file_get_contents("/usr/share/artica-postfix/VERSION");
	    $LicenseInfos["license_number"]=$APP_ARTICA_LIC_GOLD;

	    $LicenseInfos["TIME"]=strtotime('+50 year', time());
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseInfos", base64_encode(serialize($LicenseInfos)));

        build_progress("{restarting} {APP_ARTICA_STATUS}", 90);
        system("/etc/init.d/artica-status restart");
        build_progress("$APP_ARTICA_LIC_GOLD {success}", 100);
        die();
    }

    if(is_file(LkdPTEQ)){
        $APP_ARTICA_LIC_GOLD=trim(@file_get_contents(LkdPTEQ));
        if($GLOBALS["CLASS_SOCKETS"]->IsGoldKey($APP_ARTICA_LIC_GOLD)){
            $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseINGP", 0);
            build_progress("$APP_ARTICA_LIC_GOLD {success}", 100);
            die();
        }
    }


    if(!file_exists('/etc/artica-postfix/settings/Daemons/NewLicServer')){@touch("/etc/artica-postfix/settings/Daemons/NewLicServer");}

    if (file_exists('/etc/artica-postfix/settings/Daemons/NewLicServer')) {
        echo "register_lic...\n";
        ini_set('html_errors', 0);
        ini_set('display_errors', 1);
        ini_set('error_reporting', E_ALL);
        $sock = new sockets();
        $unix = new unix();
        $ini = new Bs_IniHandler();
        $function_ghost = base64_decode("Y2hlY2tsaWNlbnNlLmJpbg==");
        $error1 = base64_decode("e2dlbmVyaWNfaHR0cF9lcnJvcn0=");
        $textGhost = base64_decode("Q29ycG9yYXRlIExpY2Vuc2UgZXhwaXJlZCAtIHJldHVybiBiYWNrIHRvIENvbW11bml0eSBsaWNlbnNl");

        $licexpir = base64_decode("e2xpY2Vuc2VfZXhwaXJlZH0=");
        $WORKDIR = base64_decode("L3Vzci9sb2NhbC9zaGFyZS9hcnRpY2E=");
        $WORKFILE = base64_decode('LmxpYw==');
        $WORKPATH = "$WORKDIR/$WORKFILE";
        $line_ghost = base64_decode("MTA4NDM=");
        $datas = $GLOBALS["CLASS_SOCKETS"]->GET_INFO("ArticaProxySettings");
        $squidbin = $unix->LOCATE_SQUID_BIN();
        $php = $unix->LOCATE_PHP5_BIN();
        $ArticaProxyServerEnabled = null;

        if ($GLOBALS["STAMP"]) {
            @mkdir("/etc/artica-postfix/pids", 0755, true);
            $filetime = "/etc/artica-postfix/pids/register-license";
            $ztime = $unix->file_time_min($filetime);
            if ($ztime < 120) {
                echo "{$ztime}Mn, require 120Mn... die()\n";
                events("{$ztime}Mn, require 120Mn... die()", __FUNCTION__, __FILE__, __LINE__);
                die();
            }
            @unlink($filetime);
            @file_put_contents($filetime, time());
        }

        if (is_file($WORKDIR . "/.KEY")) {
            echo "Checking KEY file\n";
            if (check_key_file()) {
                echo "Checking KEY OK\n";
                ping_server();
                build_progress("{done}", 100);
                return;
            }
            echo "Checking KEY FALSE\n";
        }

        if (trim($datas) != null) {
            $ini->loadString($datas);
            $ArticaProxyServerEnabled = $ini->_params["PROXY"]["ArticaProxyServerEnabled"];
            if ($ArticaProxyServerEnabled == 1) {
                $ArticaProxyServerEnabled == "yes";
            }
        }

        echo "Use a Proxy server: $ArticaProxyServerEnabled\n";

        $nohup = $unix->find_program("nohup");
        if ($GLOBALS["VERBOSE"]) {
            echo __FUNCTION__ . "::" . __LINE__ . "\n";
        }
        $pidfile = "/etc/artica-postfix/pids/" . basename(__FILE__) . "." . __FUNCTION__ . ".pid";
        //$cachetime = "/etc/artica-postfix/pids/" . basename(__FILE__) . "." . __FUNCTION__ . ".time";
        $pid = @file_get_contents($pidfile);

        if ($unix->process_exists($pid)) {
            build_progress("License information: Already executed PID:$pid, die()", 100);
            die();
        }

        build_progress("Building informations...", 10);

        $EnableRemoteStatisticsAppliance = @file_get_contents("/etc/artica-postfix/settings/Daemons/EnableRemoteStatisticsAppliance");
        if (!is_numeric($EnableRemoteStatisticsAppliance)) {
            $EnableRemoteStatisticsAppliance = 0;
        }
        $cmdADD = null;
        if ($EnableRemoteStatisticsAppliance == 1) {
            $cmdADD = "$nohup " . $unix->LOCATE_PHP5_BIN() . "/usr/share/artica-postfix/exec.netagent.php >/dev/null 2>&1 &";
        }
        $WizardSavedSettings = unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("WizardSavedSettings") ) );

        if ($GLOBALS["VERBOSE"]) {
            echo __FUNCTION__ . "::" . __LINE__ . "\n";
        }
        $LicenseInfos = unserialize( base64_decode( $GLOBALS["CLASS_SOCKETS"]->GET_INFO("LicenseInfos") ) );

        if (!isset($WizardSavedSettings["company_name"])) {
            if(!isset($LicenseInfos["COMPANY"])){$LicenseInfos["COMPANY"] = null;}
        }else{
            $LicenseInfos['COMPANY'] = $WizardSavedSettings["company_name"];
        }
        if (!isset($WizardSavedSettings["request_by"])) {
            if(!isset($LicenseInfos["REQUEST_BY"])){$LicenseInfos["REQUEST_BY"] = null;}
        }else{
            $LicenseInfos['REQUEST_BY'] = $WizardSavedSettings["request_by"];
        }

        if (!isset($WizardSavedSettings["REGISTER"])) {
            $WizardSavedSettings["REGISTER"] = null;
        }
        $LicenseInfos["STATS_APPLIANCE"] = 0;

        if (is_file("/etc/artica-postfix/artica-iso-first-reboot")) {
            $zDate = filemtime("/etc/artica-postfix/artica-iso-first-reboot");
            $LicenseInfos["INSTALL_DATE"] = date("Y-m-d H:i:s", $zDate);
        } else {
            $zDate = filemtime("/etc/artica-postfix/.");
            $LicenseInfos["INSTALL_DATE"] = date("Y-m-d H:i:s", $zDate);
        }

        echo "Registered for {$LicenseInfos["COMPANY"]}\n";
        build_progress("Check information {$LicenseInfos["COMPANY"]}", 20);

        $MergedArray = $WizardSavedSettings;
        foreach ($MergedArray as $num=>$val){
            $val = trim($val);
            if ($val == null) {
                continue;
            }
            if (isset($LicenseInfos[$num])) {
                continue;
            }
            $LicenseInfos[$num] = $val;
        }


        $ARRAY = $unix->NETWORK_ALL_INTERFACES();
        if (isset($LicenseInfos["NIC"])) {

            $LicenseInfos["IPADDR"] = $ARRAY[$LicenseInfos["NIC"]]["IPADDR"];
        } else {
            $LicenseInfos["NIC"] = "eth0";
            $LicenseInfos["IPADDR"] = $ARRAY["eth0"]["IPADDR"];
        }

        $hostname = $unix->hostname_g();
        $tt = explode(".", $hostname);
        $netbiosname = $tt[0];
        unset($tt[0]);
        $domain = @implode(".", $tt);

        $LicenseInfos["netbiosname"] = $netbiosname;
        $LicenseInfos["domain"] = $domain;
        $LicenseInfos["CPUS_NUMBER"] = $unix->CPU_NUMBER();
        $LicenseInfos["MEMORY"] = $unix->TOTAL_MEMORY_MB();
        $LicenseInfos["LINUX_DISTRI"] = $unix->LINUX_DISTRIBUTION();
        $LicenseInfos["MIGRATION"] = $GLOBALS['MIGRATION'] ? 1 : 0;

        if ($GLOBALS["VERBOSE"]) {
            echo __FUNCTION__ . "::" . __LINE__ . "\n";
        }
        $uuid = $unix->GetUniqueID();

        build_progress("Check information $uuid", 30);

        echo " *************** \n\n UUID : $uuid \n\n ***************\n";
        if ($uuid == null) {
            build_progress("No system ID !", 110);
            return;
        }

        if (!is_numeric($WizardSavedSettings["REGISTER"])) {
            echo "License information: server is not registered\n";
        }
        if (intval($WizardSavedSettings["REGISTER"]) == 0) {
            echo "License information: server is not registered, please wait\n";
            register(true);
            build_progress("License information: server is not registered, please wait", 60);

        }

        $LicenseInfos["UUID"] = $uuid;
        $LicenseInfos["uuid"] = $uuid;
        $LicenseInfos["ARTICAVERSION"] = @file_get_contents("/usr/share/artica-postfix/VERSION");
        echo "License information: Artica v{$LicenseInfos["ARTICAVERSION"]}\n";

        if ($GLOBALS["VERBOSE"]) {
            echo __FUNCTION__ . "::" . __LINE__ . "\n";
        }
        if (!isset($LicenseInfos["license_number"])) {
            $LicenseInfos["license_number"] = null;
        }
        if ($LicenseInfos["license_number"] == "--") {
            $LicenseInfos["license_number"] = null;
        }
        if (strpos($LicenseInfos["license_number"], "(") > 0) {
            $LicenseInfos["license_number"] = null;
        }
        echo "License number:{$LicenseInfos["license_number"]}\n";
        if (!$GLOBALS['MIGRATION'] || $force) {
            @mkdir($WORKDIR, 640, true);
            if (isset($LicenseInfos["license_number"])) {
                if (strlen($LicenseInfos["license_number"]) > 4) {
                    @file_put_contents($WORKPATH, "TRUE");
                    echo "License number: License is Active [OK] by the Unlock License\n";
                    $LicenseInfos["license_status"] = "{license_active}";
                    $LicenseInfos["TIME"] = time();
                    $sock->SaveConfigFile(base64_encode(serialize($LicenseInfos)), "LicenseInfos");
                    if ($cmdADD != null) {
                        shell_exec($cmdADD);
                    }
                    build_progress("{license_active}", 80);
                    echo "CheckLic....\n";
                    CheckLic($LicenseInfos, $WizardSavedSettings);
                    build_progress("{done}", 100);
                    return;
                } else {
                    echo "license_number token not set..\n";
                }
            } else {
                echo "license_number token not set..\n";
            }
        }
        $unix = new unix();
        $URIBASE = $unix->MAIN_URI();
        $URIBASE = str_replace("articatech.net", "artica.fr", $URIBASE);

        $verbosed = "?VERBOSE=yes&time=" . time();
        echo "Checking license on the cloud server\n";
        build_progress("Checking license on the cloud server...", 40);
        echo "Contacting api/register/license\n";
        $curl = new ccurl("https://licensing.artica.center/api/register/license", false, null);

        unset($LicenseInfos["administratorpass"]);
        unset($LicenseInfos["SQL1"]);
        unset($LicenseInfos["administrator"]);
        unset($LicenseInfos["ArticaMetaPassword"]);
        unset($LicenseInfos["ArticaMetaUsername"]);

        if ($GLOBALS["REMOTE_OUTPUT"]) {
            echo "DUMP WEBSERVER RESPONSE....\n";
            $curl->parms["VERBOSE"] = "yes";
        }
        if ($GLOBALS["VERBOSE"]) {
            $curl->parms["VERBOSE"] = "yes";
        }
        $curl->parms["X-API-KEY"] = $WizardSavedSettings["X-API-KEY"];
        $curl->parms["REGISTER-LIC"] = base64_encode(serialize($LicenseInfos));
        $curl->NoLocalProxy();
        $curl->get();
        echo "Data received: ".strlen($curl->orginal_data)."Bytes\n";

        if(preg_match("#A PHP Error was encountered#is",$curl->orginal_data)){
            $data=strip_tags($curl->orginal_data);
            $data=str_replace("\n\n","\n",$data);
            $data=str_replace("\n\n","\n",$data);
            $dataTBl=explode("\n",$data);
            foreach ($dataTBl as $line){
                $line=trim($line);
                $line=str_replace("\r","",$line);
                if($line==null){continue;}
                $dataF[]=$line;
            }
            echo "**** Error on the server, please report this issue on your support team.****\n";
            echo @implode("\n",$dataF)."\n";
            echo "*****************************************************************************\n";
            build_progress("{failed} ({see_report})", 110);
            exit;
        }



        $response = json_decode(getLastLines($curl->orginal_data));
        echo "MY RESPONSE IS " . $response->message;
        events("api/register/license", __FUNCTION__, __FILE__, __LINE__);
        echo "Send request... please wait...\n";
        if (!$response->status) {
            echo "**********************************\n";
            echo "*\n";
            echo "* Failed to contact cloud server..*\n";
            echo "*\n";
            echo "**********************************\n";
            build_progress("Failed to contact cloud server", 110);
            echo "HTTP Error returned: " . $curl->error . "\n";
            echo "**********************************\n";
            echo "*\n";
            echo @implode("\n", $curl->errors);
            echo "*\n";
            echo "**********************************\n";
            $LicenseInfos["TIME"] = time();
            $LicenseInfos["license_status"] = "{registration_failed} $curl->error";
            $sock->SaveConfigFile(base64_encode(serialize($LicenseInfos)), "LicenseInfos");


            if (!is_file("/etc/artica-postfix/REGISTRATION_FAILED_TIME")) {
                @file_put_contents("/etc/artica-postfix/REGISTRATION_FAILED_TIME", time());
                $sock->SaveConfigFile(base64_encode(serialize($LicenseInfos)), "LicenseInfos");
                return true;
            }


            return false;
        }
        @file_put_contents("/etc/artica-postfix/REGISTRATION_FAILED_TIME", 0);
        echo "OK the server as been contacted....\n";
        build_progress("{checkiccloud1}", 50);
        if ($GLOBALS["REMOTE_OUTPUT"]) {
            echo "***** $curl->data ****\n";
        }

        $finaltime = 0;
        //if (preg_match("#<FINALTIME>([0-9]+)</FINALTIME>#s", $curl->data, $re)) {$finaltime = $re[1];}
        if ($response->status && $response->message == "1") {
            $finaltime = $response->expire;
        }

        echo "OK the server as been contacted....[" . __LINE__ . "]\n";

        if ($finaltime > 0) {
            echo "Final Time: $finaltime against " . time() . "....[" . __LINE__ . "]\n";
            if (time() > $finaltime) {
                $LicenseInfos["license_status"] = $licexpir;
                $LicenseInfos["license_number"] = null;
                $LicenseInfos["TIME"] = time();
                if ($finaltime > 0) {
                    $LicenseInfos["FINAL_TIME"] = $finaltime;
                }
                $sock->SaveConfigFile(base64_encode(serialize($LicenseInfos)), "LicenseInfos");

                if (is_file($WORKPATH)) {
                    @unlink($WORKPATH);
                    build_progress($licexpir, 110);
                    echo "license_status: $licexpir.... (Expired) [" . __LINE__ . "]\n";
                    squid_admin_mysql(0, $textGhost, null, $function_ghost, $line_ghost);
                    system("$php /usr/share/artica-postfix/exec.status.php --process1");
                    if (is_file($squidbin)) {
                        shell_exec("$php /usr/share/artica-postfix/exec.squid.global.access.php --build");
                        shell_exec("$php /usr/share/artica-postfix/exec.kerbauth.php --disconnect");
                        squid_admin_mysql(2, "Reloading Proxy service (" . __FUNCTION__ . ")", null, __FILE__, __LINE__);
                        shell_exec("$squidbin -f /etc/squid3/squid.conf -k reconfigure");
                    }
                }

                build_progress("$licexpir", 110);
                return false;
            }
            $reste = distanceOfTimeInWords(time(), $finaltime, true);
            echo "license_status: expire in $reste [" . __LINE__ . "]\n";
        }

        echo "OK Analyze answer from the cloud server....[" . __LINE__ . "]\n";

        echo "Data Lenght: " . strlen($curl->data) . " bytes\n";
        if (strlen($curl->data) == 0) {
            build_progress("{error} O Size byte", 110);
            return false;
        }

        if ($response->status && $response->message == "1") {
            echo "**********************************************\n";
            echo "*\n";
            echo "*\n";
            echo "*              Congratulations\n";
            echo "*        Your License is  - Active -\n";
            echo "*\n";
            echo "*\n";
            echo "**********************************************\n";
            echo "OK License is Active....[" . __LINE__ . "]\n";
            @file_put_contents($WORKPATH, "TRUE");
            @file_put_contents($GLOBALS["TVF_WORKPATH"], "VFJVRQ==");
            if ($finaltime > 0) {
                $LicenseInfos["FINAL_TIME"] = $finaltime;
            }
            $LicenseInfos["license_status"] = "{license_active}";
            $LicenseInfos["license_number"] = $response->license;
            $LicenseInfos["TIME"] = time();
            $sock->SaveConfigFile(base64_encode(serialize($LicenseInfos)), "LicenseInfos");
            $sock->SET_INFO('NewLicServer', 1);
            $sock->SET_INFO('Migration', 1);
            if ($cmdADD != null) {
                shell_exec($cmdADD);
            }
            build_progress("{license_active} {refresh}", 100);
            system("$php /usr/share/artica-postfix/exec.status.php --process1");
            build_progress("{license_active} {success}", 100);
            return false;
        }
        if ($response->status && $response->message == "2") {
            echo "***** REGISTRATION_DELETE_NOW ****\n";
            @unlink($WORKPATH);
            @unlink($GLOBALS["TVF_WORKPATH"]);
            $LicenseInfos["license_status"] = "Community Edition - limited";
            $LicenseInfos["license_number"] = null;
            $LicenseInfos["UNLOCKLIC"] = null;
            $LicenseInfos["TIME"] = time();
            if ($finaltime > 0) {
                $LicenseInfos["FINAL_TIME"] = $finaltime;
            }
            $unix->Process1(true);
            $sock->SaveConfigFile(base64_encode(serialize($LicenseInfos)), "LicenseInfos");
            system("$php /usr/share/artica-postfix/exec.status.php --process1");
            build_progress("Community Edition - limited", 110);
            return false;
        }
        if ($response->status && $response->message == "3") {
            echo "License information: server is not registered, please wait\n";
            register(true);
            //build_progress("License information: server is not registered, please wait123", 60);

            die();
        }

        if ($curl->error != null) {
            squid_admin_mysql(2, "License registration failed with error $curl->error", "GetLicense", "license", 0, "license");
            echo "License registration failed with error $curl->error\n";
        }

        build_progress("Unknown registration?", 110);
        echo "***** Registration_failed ****\n";
        echo $curl->data . "\n";
    } else {
        $GLOBALS["CLASS_SOCKETS"]->GET_INFO("WizardSavedSettings");
        echo "register_lic...\n";
        ini_set('html_errors', 0);
        ini_set('display_errors', 1);
        ini_set('error_reporting', E_ALL);
        $sock=new sockets();
        $unix=new unix();
        $ini=new Bs_IniHandler();
        $function_ghost=base64_decode("Y2hlY2tsaWNlbnNlLmJpbg==");
        $error1=base64_decode("e2dlbmVyaWNfaHR0cF9lcnJvcn0=");
        $textGhost=base64_decode("Q29ycG9yYXRlIExpY2Vuc2UgZXhwaXJlZCAtIHJldHVybiBiYWNrIHRvIENvbW11bml0eSBsaWNlbnNl");
        //$verifailed=base64_decode("Q29ycG9yYXRlIExpY2Vuc2UgZXhwaXJlZCAtIHJldHVybiBiYWNrIHRvIENvbW11bml0eSBsaWNlbnNl");
        $licexpir=base64_decode("e2xpY2Vuc2VfZXhwaXJlZH0=");
        $WORKDIR=base64_decode("L3Vzci9sb2NhbC9zaGFyZS9hcnRpY2E=");
        $WORKFILE=base64_decode('LmxpYw==');
        $WORKPATH="$WORKDIR/$WORKFILE";
        $line_ghost=base64_decode("MTA4NDM=");
        $datas=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("ArticaProxySettings");
        $squidbin=$unix->LOCATE_SQUID_BIN();
        $php=$unix->LOCATE_PHP5_BIN();
        $ArticaProxyServerEnabled=null;
    
    
    
        if ($GLOBALS["STAMP"]) {
            @mkdir("/etc/artica-postfix/pids", 0755, true);
            $filetime="/etc/artica-postfix/pids/register-license";
            $ztime=$unix->file_time_min($filetime);
            if ($ztime<120) {
                echo "{$ztime}Mn, require 120Mn... die()\n";
                events("{$ztime}Mn, require 120Mn... die()", __FUNCTION__, __FILE__, __LINE__);
                exit();
            }
            @unlink($filetime);
            @file_put_contents($filetime, time());
        }
    
        if (is_file($WORKDIR."/.KEY")) {
            echo "Checking KEY file\n";
            if (check_key_file()) {
                echo "Checking KEY OK\n";
                ping_server();
                build_progress("{done}", 100);
                return;
            }
            echo "Checking KEY FALSE\n";
        }
    
        $LicenseWasRequested=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LicenseWasRequested"));
        if ($LicenseWasRequested==0) {
            echo "License was not requested....\n";
            build_progress("{failed} License was not requested", 110);
            return false;
        }
    
    
        if (trim($datas)<>null) {
            $ini->loadString($datas);
            $ArticaProxyServerEnabled=$ini->_params["PROXY"]["ArticaProxyServerEnabled"];
            if ($ArticaProxyServerEnabled==1) {
                $ArticaProxyServerEnabled=="yes";
            }
        }
    
        echo "Use a Proxy server: $ArticaProxyServerEnabled\n";
    
    
    

        $nohup=$unix->find_program("nohup");
        if ($GLOBALS["VERBOSE"]) {
            echo __FUNCTION__."::".__LINE__."\n";
        }
        $pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
        $cachetime="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".time";
        $pid=@file_get_contents($pidfile);
    
    
        if ($unix->process_exists($pid)) {
            build_progress("License information: Already executed PID:$pid, die()", 100);
            exit();
        }
    
        build_progress("Building informations...", 10);
    
    
        $EnableRemoteStatisticsAppliance=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableRemoteStatisticsAppliance");
        if (!is_numeric($EnableRemoteStatisticsAppliance)) {
            $EnableRemoteStatisticsAppliance=0;
        }
        $cmdADD=null;
        if ($EnableRemoteStatisticsAppliance==1) {
            $cmdADD="$nohup ".$unix->LOCATE_PHP5_BIN()."/usr/share/artica-postfix/exec.netagent.php >/dev/null 2>&1 &";
        }
    
        $WizardSavedSettings=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("WizardSavedSettings")));
        if (!is_array($WizardSavedSettings)) {
            $WizardSavedSettings=array();
        }
        $WizardSavedSettings=RepairSidentity($WizardSavedSettings);
    
        if ($GLOBALS["VERBOSE"]) {
            echo __FUNCTION__."::".__LINE__."\n";
        }
        $LicenseInfos=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LicenseInfos")));
        if (!isset($LicenseInfos["COMPANY"])) {
            $LicenseInfos["COMPANY"]=null;
        }
        if (!isset($LicenseInfos["GoldKey"])) {
            $LicenseInfos["GoldKey"]=null;
        }
        if (!isset($LicenseInfos["REGISTER"])) {
            $LicenseInfos["REGISTER"]=null;
        }
        if (!isset($LicenseInfos["COMPANY"])) {
            $LicenseInfos["COMPANY"]=null;
        }
        if (!isset($LicenseInfos["EMAIL"])) {
            $LicenseInfos["EMAIL"]=null;
        }
        if (!isset($LicenseInfos["GoldKey"])) {
            $LicenseInfos["GoldKey"]=null;
        }
        if (!isset($WizardSavedSettings["GoldKey"])) {
            $WizardSavedSettings["GoldKey"]=null;
        }
        if ($LicenseInfos["COMPANY"]==null) {
            $LicenseInfos["COMPANY"]=$WizardSavedSettings["company_name"];
        }
        if ($LicenseInfos["EMAIL"]==null) {
            $LicenseInfos["EMAIL"]=$WizardSavedSettings["mail"];
        }

    
        $LicenseInfos["STATS_APPLIANCE"]=0;
    
        if (is_file("/etc/artica-postfix/artica-iso-first-reboot")) {
            $zDate=filemtime("/etc/artica-postfix/artica-iso-first-reboot");
            $LicenseInfos["INSTALL_DATE"]=date("Y-m-d H:i:s", $zDate);
        } else {
            $zDate=filemtime("/etc/artica-postfix/.");
            $LicenseInfos["INSTALL_DATE"]=date("Y-m-d H:i:s", $zDate);
        }
    
    
        $LicenseInfos["COMPANY"]=str_replace("%uFFFD", "é", $LicenseInfos["COMPANY"]);
        if ($WizardSavedSettings["GoldKey"]<>null) {
            if ($sock->IsGoldKey($WizardSavedSettings["GoldKey"])) {
                if ($LicenseInfos["GoldKey"]==null) {
                    echo "Gold Key: {$WizardSavedSettings["GoldKey"]}\n";
                    $LicenseInfos["GoldKey"]=$WizardSavedSettings["GoldKey"];
                    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LicenseINGP", 0);
                }
            }
        }
    
        echo "Registered for {$LicenseInfos["COMPANY"]}\n";
        build_progress("Check information {$LicenseInfos["COMPANY"]}", 20);
    
        $MergedArray=$WizardSavedSettings;
        $sidentity=new sidentity();
        $MergedArray=$sidentity->RepairSidentity($MergedArray);

        foreach ($MergedArray as $num=>$val) {
            $val=trim($val);
            if ($val==null) {
                continue;
            }
            if (isset($LicenseInfos[$num])) {
                continue;
            }
            $LicenseInfos[$num]=$val;
        }
        $ARRAY=$unix->NETWORK_ALL_INTERFACES();
        if (isset($LicenseInfos["NIC"])) {
            $LicenseInfos["IPADDR"]=$ARRAY[$LicenseInfos["NIC"]]["IPADDR"];
        } else {
            $LicenseInfos["NIC"]="eth0";
            $LicenseInfos["IPADDR"]=$ARRAY["eth0"]["IPADDR"];
        }
    

    
        $hostname=$unix->hostname_g();
        $tt=explode(".", $hostname);
        $netbiosname=$tt[0];
        unset($tt[0]);
        $domain=@implode(".", $tt);
    
        $LicenseInfos["netbiosname"]=$netbiosname;
        $LicenseInfos["domain"]=$domain;
        $LicenseInfos["CPUS_NUMBER"]=$unix->CPU_NUMBER();
        $LicenseInfos["MEMORY"]=$unix->TOTAL_MEMORY_MB();
        $LicenseInfos["LINUX_DISTRI"]=$unix->LINUX_DISTRIBUTION();
    
    
        if ($GLOBALS["VERBOSE"]) {
            echo __FUNCTION__."::".__LINE__."\n";
        }
        $uuid=$unix->GetUniqueID();
    
        build_progress("Check information $uuid", 30);
    
        echo " *************** \n\n UUID : $uuid \n\n ***************\n";
        if ($uuid==null) {
            build_progress("No system ID !", 110);
            return false;
        }

        if (intval($LicenseInfos["REGISTER"])==0) {
            echo "License information: server is not registered\n";
            if (!register(true)) {
                build_progress("License information: server is not registered", 110);
                echo "Please, restart again...";
                exit();
            }
        }
    
    
        $LicenseInfos["UUID"]=$uuid;
        $LicenseInfos["ARTICAVERSION"]=@file_get_contents("/usr/share/artica-postfix/VERSION");
        if (is_file("/etc/artica-postfix/STATS_APPLIANCE")) {
            $LicenseInfos["STATS_APPLIANCE"]=1;
        }
        if (is_file("/etc/artica-postfix/WEBSECURITY_APPLIANCE")) {
            $LicenseInfos["WEBSECURITY_APPLIANCE"]=1;
        }
        echo "License information: Artica v{$LicenseInfos["ARTICAVERSION"]}\n";
    

        //if($GLOBALS["VERBOSE"]){$curl->parms["VERBOSE"]="yes";}
        if ($GLOBALS["VERBOSE"]) {
            echo __FUNCTION__."::".__LINE__."\n";
        }
        if (!isset($LicenseInfos["license_number"])) {
            $LicenseInfos["license_number"]=null;
        }
        if ($LicenseInfos["license_number"]=="--") {
            $LicenseInfos["license_number"]=null;
        }
        if (strpos($LicenseInfos["license_number"], "(")>0) {
            $LicenseInfos["license_number"]=null;
        }
        echo "License number:{$LicenseInfos["license_number"]}\n";
    
        @mkdir($WORKDIR, 640, true);
    
    
        if (isset($LicenseInfos["UNLOCKLIC"])) {
            if (strlen($LicenseInfos["UNLOCKLIC"])>4) {
                if (isset($LicenseInfos["license_number"])) {
                    if (strlen($LicenseInfos["license_number"])>4) {
                        $manulic=aef00vh567($uuid)."-".aef00vh567($LicenseInfos["license_number"]);
                        if ($manulic==$LicenseInfos["UNLOCKLIC"]) {
                            @file_put_contents($WORKPATH, "TRUE");
                            echo "License number: License is Active [OK] by the Unlock License\n";
                            $LicenseInfos["license_status"]="{license_active}";
                            $LicenseInfos["TIME"]=time();
                            $sock->SaveConfigFile(base64_encode(serialize($LicenseInfos)), "LicenseInfos");
                            if ($cmdADD<>null) {
                                shell_exec($cmdADD);
                            }
                            build_progress("{license_active}", 80);
                            CheckLic($LicenseInfos, $WizardSavedSettings);
                            if (function_exists("opcache_reset")) {
                                opcache_reset();
                            }
                            build_progress("{done}", 100);
                            return true;
                        } else {
                            echo "{$LicenseInfos["UNLOCKLIC"]} did not match license!\n";
                        }
                    } else {
                        echo "license_number token not set..\n";
                    }
                }
            }
        } else {
            echo "License number: UNLOCKLIC not set...\n";
        }
        $unix=new unix();
        $URIBASE=$unix->MAIN_URI();
        $URIBASE=str_replace("articatech.net", "artica.fr", $URIBASE);
    

        echo "Checking license on the cloud server\n";
        build_progress("Checking license on the cloud server...", 40);
        echo "Contacting $URIBASE\n";
        $curl=new ccurl("$URIBASE/shalla-orders.php", false, null);
    
        unset($LicenseInfos["administratorpass"]);
        unset($LicenseInfos["SQL1"]);
        unset($LicenseInfos["administrator"]);
        unset($LicenseInfos["ArticaMetaPassword"]);
        unset($LicenseInfos["ArticaMetaUsername"]);
        $LicenseInfos["REAL_MEMBERS"]=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LicensesUsersCount"));
        if ($GLOBALS["EMAIL"]) {
            $LicenseInfos["SENDEMAIL"]="yes";
        }
    
    
    
    
        if ($GLOBALS["REMOTE_OUTPUT"]) {
            echo "DUMP WEBSERVER RESPONSE....\n";
            $curl->parms["VERBOSE"]="yes";
        }
        if ($GLOBALS["VERBOSE"]) {
            $curl->parms["VERBOSE"]="yes";
        }
    
        $curl->parms["REGISTER-LIC"]=base64_encode(serialize($LicenseInfos));
        events("shalla-orders.php", __FUNCTION__, __FILE__, __LINE__);
        echo "Send request... please wait...\n";
        if (!$curl->get()) {
            echo "**********************************\n";
            echo "*\n";
            echo "* Failed to contact cloud server..*\n";
            echo "*\n";
            echo "**********************************\n";
            build_progress("Failed to contact cloud server", 110);
            echo "HTTP Error returned: ".$curl->error."\n";
            echo "**********************************\n";
            echo "*\n";
            echo @implode("\n", $curl->errors);
            echo "*\n";
            echo "**********************************\n";
            $LicenseInfos["TIME"]=time();
            $LicenseInfos["license_status"]="{registration_failed} $curl->error";
            $sock->SaveConfigFile(base64_encode(serialize($LicenseInfos)), "LicenseInfos");
            if (!is_file("/etc/artica-postfix/REGISTRATION_FAILED_TIME")) {
                @file_put_contents("/etc/artica-postfix/REGISTRATION_FAILED_TIME", time());
                $sock->SaveConfigFile(base64_encode(serialize($LicenseInfos)), "LicenseInfos");
                return true;
            }
        
            $LastTime=intval(@file_get_contents("/etc/artica-postfix/REGISTRATION_FAILED_TIME"));
            if ($LastTime==0) {
                @file_put_contents("/etc/artica-postfix/REGISTRATION_FAILED_TIME", time());
                $sock->SaveConfigFile(base64_encode(serialize($LicenseInfos)), "LicenseInfos");
                return true;
            }
            $TimeMin=$unix->time_min($LastTime);
            if ($TimeMin>10080) {
                $TVF_WORKPATH=base64_decode("L2V0Yy9hcnRpY2EtcG9zdGZpeC9zZXR0aW5ncy9EYWVtb25zL0NPUlBfTElDRU5TRQ==");
                if (is_file($WORKPATH)) {
                    echo "Failed expired license ($error1)\n";
                
                    @unlink($WORKPATH);
                    @unlink($TVF_WORKPATH);
                    squid_admin_mysql(0, base64_decode("Q2Fubm90IGNvbnRhY3QgY2xvdWQgc2VydmVyIHNpbmNlIDcgZGF5cywgdHVybiB0byBDb21tdW5pdHkgRWRpdGlvbg=="), $function_ghost, $line_ghost);
                    $LicenseInfos["license_status"]=$error1;
                    $LicenseInfos["license_number"]="";
                    $LicenseInfos["TIME"]=time();
                    $sock->SaveConfigFile(base64_encode(serialize($LicenseInfos)), "LicenseInfos");
                    system("$php /usr/share/artica-postfix/exec.status.php --process1");
                    if (function_exists("opcache_reset")) {
                        opcache_reset();
                    }
                }
            
                if (is_file($TVF_WORKPATH)) {
                    @unlink($TVF_WORKPATH);
                    system("$php /usr/share/artica-postfix/exec.status.php --process1");
                    if (function_exists("opcache_reset")) {
                        opcache_reset();
                    }
                }
            }
        
            return false;
        }
    
    
    
        @file_put_contents("/etc/artica-postfix/REGISTRATION_FAILED_TIME", 0);
        echo "OK the server as been contacted....\n";
        build_progress("{checkiccloud1}", 50);
        if ($GLOBALS["REMOTE_OUTPUT"]) {
            echo "***** $curl->data ****\n";
        }
    
        $finaltime=0;
        if (preg_match("#<FINALTIME>([0-9]+)</FINALTIME>#s", $curl->data, $re)) {
            $finaltime=$re[1];
        }
    
        echo "OK the server as been contacted....[".__LINE__."]\n";
    
        if ($finaltime>0) {
            echo "Final Time: $finaltime against ". time()."....[".__LINE__."]\n";
            if (time()>$finaltime) {
                $LicenseInfos["license_status"]=$licexpir;
                $LicenseInfos["license_number"]=null;
                $LicenseInfos["UNLOCKLIC"]=null;
                $LicenseInfos["TIME"]=time();
                if ($finaltime>0) {
                    $LicenseInfos["FINAL_TIME"]=$finaltime;
                }
                $sock->SaveConfigFile(base64_encode(serialize($LicenseInfos)), "LicenseInfos");
            
                if (is_file($WORKPATH)) {
                    @unlink($WORKPATH);
                    build_progress($licexpir, 110);
                    echo "license_status: $licexpir.... (Expired) [".__LINE__."]\n";
                    squid_admin_mysql(0, $textGhost, null, $function_ghost, $line_ghost);
                    system("$php /usr/share/artica-postfix/exec.status.php --process1");
                    if (is_file($squidbin)) {
                        shell_exec("$php /usr/share/artica-postfix/exec.squid.global.access.php --build");
                        shell_exec("$php /usr/share/artica-postfix/exec.kerbauth.php --disconnect");
                        squid_admin_mysql(2, "Reloading Proxy service (".__FUNCTION__.")", null, __FILE__, __LINE__);
                        shell_exec("$squidbin -f /etc/squid3/squid.conf -k reconfigure");
                        if (function_exists("opcache_reset")) {
                            opcache_reset();
                        }
                    }
                }

                build_progress("$licexpir", 110);
                return false;
            }
            $reste=distanceOfTimeInWords(time(), $finaltime, true);
            echo "license_status: expire in $reste [".__LINE__."]\n";
        }
    
        if (preg_match("#<BADMAIL>(0|1)</BADMAIL>#s", $curl->data, $re)) {
            echo "***** EMAIL *****\n";
            $sock->SET_INFO("RegisterCloudBadEmail", $re[1]);
        }
    
        echo "OK Analyze answer from the cloud server....[".__LINE__."]\n";
    
        if (preg_match("#REGISTRATION_OK:\[(.+?)\]#s", $curl->data, $re)) {
            echo "OK Registration, waiting an active license....[".__LINE__."]\n";
            build_progress("{waiting_approval} {success}", 100);
            $LicenseInfos["license_status"]="{waiting_approval}";
            $LicenseInfos["license_number"]=$re[1];
            $LicenseInfos["TIME"]=time();
            if ($finaltime>0) {
                $LicenseInfos["FINAL_TIME"]=$finaltime;
            }
            $sock->SaveConfigFile(base64_encode(serialize($LicenseInfos)), "LicenseInfos");
            @unlink($WORKPATH);
            if ($cmdADD<>null) {
                shell_exec($cmdADD);
            }
            system("$php /usr/share/artica-postfix/exec.status.php --process1");
            if (function_exists("opcache_reset")) {
                opcache_reset();
            }
            return true;
        }
    
        if (preg_match("#REGISTRATION_WAITING:\[(.+?)\]#s", $curl->data, $re)) {
            echo "OK Registration, waiting an active license....[".__LINE__."]\n";
            build_progress("{waiting_approval} {success}", 100);
            $LicenseInfos["license_status"]="{waiting_approval}";
            $LicenseInfos["license_number"]=$re[1];
            $LicenseInfos["TIME"]=time();
            $sock->SaveConfigFile(base64_encode(serialize($LicenseInfos)), "LicenseInfos");
            @unlink($WORKPATH);
            return true;
        }
    
    
        echo "Data Lenght: ".strlen($curl->data)." bytes\n";
        if (strlen($curl->data)==0) {
            build_progress("{error} O Size byte", 110);
            return false;
        }
    
    
        if (preg_match("#LICENSE_OK:\[(.+?)\]#s", $curl->data, $re)) {
            echo "**********************************************\n";
            echo "*\n";
            echo "*\n";
            echo "*              Congratulations\n";
            echo "*        Your License is  - Active -\n";
            echo "*\n";
            echo "*\n";
            echo "**********************************************\n";
            echo "OK License is Active....[".__LINE__."]\n";
            @file_put_contents($WORKPATH, "TRUE");
            if ($finaltime>0) {
                $LicenseInfos["FINAL_TIME"]=$finaltime;
            }
            $LicenseInfos["license_status"]="{license_active}";
            $LicenseInfos["TIME"]=time();
            $sock->SaveConfigFile(base64_encode(serialize($LicenseInfos)), "LicenseInfos");
            if ($cmdADD<>null) {
                shell_exec($cmdADD);
            }
            build_progress("{license_active} {refresh}", 100);
            system("$php /usr/share/artica-postfix/exec.status.php --process1");
            build_progress("{license_active} {success}", 100);
            if (function_exists("opcache_reset")) {
                opcache_reset();
            }
            return false;
        }
    
    
        if (preg_match("#REGISTRATION_INVALID#s", $curl->data, $re)) {
            @unlink($WORKPATH);
            echo "**********************************************\n";
            echo "*\n";
            echo "*\n";
            echo "*       ****    REGISTRATION_INVALID      ****\n";
            echo "*\n";
            echo "*\n";
            echo "**********************************************\n";
            echo "Invalid License.......[".__LINE__."]\n";
            $LicenseInfos["license_status"]="{community_license}";
            $LicenseInfos["license_number"]=null;
            $LicenseInfos["UNLOCKLIC"]=null;
            $LicenseInfos["TIME"]=time();
            if ($finaltime>0) {
                $LicenseInfos["FINAL_TIME"]=$finaltime;
            }
            build_progress("Community Edition - limited...", 100);
            $sock->SaveConfigFile(base64_encode(serialize($LicenseInfos)), "LicenseInfos");
            if ($cmdADD<>null) {
                shell_exec($cmdADD);
            }
            $unix->Process1(true);
            if (function_exists("opcache_reset")) {
                opcache_reset();
            }
            return false;
        }

        if (preg_match("#REGISTRATION_DELETE_NOW#s", $curl->data, $re)) {
            echo "***** REGISTRATION_DELETE_NOW ****\n";
            @unlink($WORKPATH);
            $LicenseInfos["license_status"]="Community Edition - limited";
            $LicenseInfos["license_number"]=null;
            $LicenseInfos["UNLOCKLIC"]=null;
            $LicenseInfos["TIME"]=time();
            if ($finaltime>0) {
                $LicenseInfos["FINAL_TIME"]=$finaltime;
            }
            $unix->Process1(true);
            $sock->SaveConfigFile(base64_encode(serialize($LicenseInfos)), "LicenseInfos");
            system("$php /usr/share/artica-postfix/exec.status.php --process1");
            build_progress("Community Edition - limited", 110);
            if (function_exists("opcache_reset")) {
                opcache_reset();
            }
            return false;
        }
        
        if ($curl->error<>null) {
            squid_admin_mysql(2, "License registration failed with error $curl->error", "GetLicense", "license", 0, "license");
            echo "License registration failed with error $curl->error\n";
        }
    
        build_progress("Unknown registration?", 110);
        echo "***** Registration_failed ****\n";
        echo $curl->data."\n";
    }

    return true;
}
    






function drop_categorize()
{
    $q=new mysql_squid_builder();
    $q->QUERY_SQL("TRUNCATE TABLE categorize");
}

function pushit()
{
    $unix=new unix();
    $URIBASE=$unix->MAIN_URI();
    $URIBASE=str_replace("articatech.net", "artica.fr", $URIBASE);
    $curl=new ccurl("$URIBASE/shalla-orders.php", false);
    $curl->parms["ORDER_EXPORT"]="yes";
    $curl->get();
    events("shalla-orders.php", __FUNCTION__, __FILE__, __LINE__);
    if (preg_match("#<ANSWER>OK</ANSWER>#is", $curl->data)) {
        events("success", __FUNCTION__, __FILE__, __LINE__);
    } else {
        events("failed\n$curl->data", __FUNCTION__, __FILE__, __LINE__);
    }
}



function ParseGzSqlFile($filepath)
{
    if ($GLOBALS["MYSQLCOMMAND"]==null) {
        $unix=new unix();
        $mysql=$unix->find_program("mysql");
        $q=new mysql();
        if ($q->mysql_password<>null) {
            $password=" --password=$q->mysql_password";
        }
        $nice=EXEC_NICE();
        $cmd="$nice$mysql --batch --user=$q->mysql_admin $password --port=$q->mysql_port";
        $cmd=$cmd." --host=$q->mysql_server --database=artica_backup";
        $cmd=$cmd." --max_allowed_packet=500M";
        $GLOBALS["MYSQLCOMMAND"]=$cmd;
    } else {
        $cmd=$GLOBALS["MYSQLCOMMAND"];
    }
    
    //echo $cmd." <$filepath\n";
    echo "Starting......: ".date("H:i:s")." [ParseGzSqlFile]:: Artica database community running importation (". basename($filepath).")\n";
    exec("$cmd <$filepath 2>&1", $results);
    
    
    
    if (count($results)>0) {
        foreach ($results as $num=>$ligne) {
            if (!preg_match("#Duplicate entry#", $ligne)) {
                echo "Starting......: ".date("H:i:s")." Artica database community $ligne\n";
                if (preg_match("#ERROR\s+[0-9]+#", $ligne)) {
                    echo "Starting......: ".date("H:i:s")." Artica database community error detected\n";
                    $GLOBALS["NEWFILES"][]=$ligne;
                    $unix->send_email_events("Web community mysql error", "Unable to import data file $filepath\n$ligne", "proxy");
                    return false;
                }
            }
        }
    }
    return true;
    @unlink($filepath);
}


function uncompress($srcName, $dstName)
{
    $string = implode("", gzfile($srcName));
    $fp = fopen($dstName, "w");
    fwrite($fp, $string, strlen($string));
    fclose($fp);
}
    



function WriteCategory($category)
{
    $squidguard=new squidguard();
    $q=new mysql_squid_builder();
    echo "Starting......: ".date("H:i:s")." Artica database writing category $category\n";
    echo "Starting......: ".date("H:i:s")." Artica database /etc/dansguardian/lists/blacklist-artica/$category/domains\n";
    echo "Starting......: ".date("H:i:s")." Artica database /var/lib/squidguard/blacklist-artica/$category\n";
    @mkdir("/etc/dansguardian/lists/blacklist-artica/$category", 0755, true);
    @mkdir("/var/lib/squidguard/blacklist-artica/$category", 0755, true);
    
    if (!is_dir("/var/lib/squidguard/$category")) {
        @mkdir("/var/lib/squidguard/$category", 0755, true);
    }
    if (!is_dir("/etc/dansguardian/lists/blacklist/$category/urls")) {
        @mkdir("/etc/dansguardian/lists/blacklist/$category/urls", 755, true);
    }
    if (!is_file("/etc/dansguardian/lists/blacklist/$category/urls")) {
        @file_put_contents("/etc/dansguardian/lists/blacklist/$category/urls", "\n");
    }
    if (!is_file("/var/lib/squidguard/$category/urls")) {
        @file_put_contents("/var/lib/squidguard/$category/urls", "\n");
    }
    $tablesource="category_".$q->category_transform_name($category);
    $sql="SELECT pattern FROM $tablesource WHERE enabled=1";
    
    $results=$q->QUERY_SQL($sql, "artica_backup");
    if (!$q->ok) {
        echo "Starting......: ".date("H:i:s")." Artica database $q->mysql_error\n";
        return;
    }
    $num=mysqli_num_rows($results);
    echo "Starting......: ".date("H:i:s")." Artica database $num domains\n";
    
    $domain_path_1="/etc/dansguardian/lists/blacklist/$category/domains";
    $domain_path_2="/var/lib/squidguard/$category/domains";
    $fh1 = fopen($domain_path_1, 'w+');
    $fh2 = fopen($domain_path_2, 'w+');
    
    while ($ligne=@mysqli_fetch_array($results, MYSQLI_ASSOC)) {
        if ($ligne["pattern"]==null) {
            continue;
        }
        if (!$squidguard->VerifyDomainCompiledPattern($ligne["pattern"])) {
            continue;
        }
        fwrite($fh1, $ligne["pattern"]."\n");
        fwrite($fh2, $ligne["pattern"]."\n");
    }
    
    fclose($fh1);
    fclose($fh2);
    
    echo "Starting......: ".date("H:i:s")." finish\n\n";
}



function GetCategory($www)
{
    $q=new mysql_squid_builder();
    return $q->GET_CATEGORIES($www);
}


function mycnf_get_value($key)
{
    $unix=new unix();
    $cnf=$unix->MYSQL_MYCNF_PATH();
    $f=explode("\n", @file_get_contents($cnf));
    foreach ($f as $index=>$line){
        if (preg_match("#$key(.*?)=(.*)#", $line, $re)) {
            $re[2]=trim($re[2]);
            return $re[2];
        }
    }
}


function mycnf_change_value($key, $value_to_modify)
{
    $unix=new unix();
    $value_to_modify=trim($value_to_modify);
    $cnf=$unix->MYSQL_MYCNF_PATH();
    $f=explode("\n", @file_get_contents($cnf));
    foreach ($f as $index=>$line){
        if (preg_match("#$key(.*?)=(.*)#", $line, $re)) {
            $re[2]=trim($re[2]);
            echo "Starting......: ".date("H:i:s")." Artica database community line $index $key = {$re[2]} change to $value_to_modify\n";
            $f[$index]="$key = $value_to_modify";
            $found=true;
        }
    }
    @file_put_contents($cnf, @implode("\n", $f));
}
    

function events($text, $function, $file, $line)
{
    if (isset($GLOBALS["MYPID"])) {
        $GLOBALS["MYPID"]=getmypid();
    }
    $mem=round(((memory_get_usage()/1024)/1000), 2);
    $logFile="/var/log/artica-postfix/license.log";
    if (!is_dir(dirname($logFile))) {
        mkdir(dirname($logFile));
    }
    if (is_file($logFile)) {
        $size=filesize($logFile);
        if ($size>9000000) {
            unlink($logFile);
        }
    }
    $date=date('m-d H:i:s');
    $f = @fopen($logFile, 'a');
    echo $text."\n";
    @fwrite($f, "$date [{$GLOBALS["MYPID"]}][{$mem}MB]: [$function::$line] $text\n");
    @fclose($f);
}
function ifMustBeExecuted()
{
    $users=new usersMenus();
    $sock=new sockets();
    $update=true;
    $EnableWebProxyStatsAppliance=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableWebProxyStatsAppliance"));
    $CategoriesRepositoryEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("CategoriesRepositoryEnable"));
    if ($EnableWebProxyStatsAppliance==1) {
        return true;
    }
    $CategoriesRepositoryEnable=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("CategoriesRepositoryEnable");
    if ($CategoriesRepositoryEnable==1) {
        return true;
    }
    if (!$users->SQUID_INSTALLED) {
        $update=false;
    }
    return $update;
}
function aef00vh567($string)
{
    $ascii=null;
    $serial=null;
    $secret_num=1;
    $bds[33]=true;
    $bds[34]=true;
    $bds[35]=true;
    $bds[36]=true;
    $bds[37]=true;
    $bds[38]=true;
    $bds[39]=true;
    $bds[40]=true;
    $bds[41]=true;
    $bds[42]=true;
    $bds[43]=true;
    $bds[44]=true;
    $bds[45]=true;
    $bds[46]=true;
    $bds[47]=true;
    $bds[58]=true;
    $bds[59]=true;
    $bds[60]=true;
    $bds[61]=true;
    $bds[62]=true;
    $bds[63]=true;
    $bds[64]=true;
    $bds[91]=true;
    $bds[92]=true;
    $bds[93]=true;
    $bds[94]=true;
    $bds[95]=true;
    $bds[96]=true;




    for ($i = 0; $i < strlen($string); $i++) {
        $ascii .= $secret_num+ ord($string[$i]);
    }
    $ascii=substr($ascii, 0, 20);
    for ($i = 0; $i < strlen($ascii); $i+=2) {
        $string=substr($ascii, $i, 2);



        switch ($string) {
         case $string>122:
                $string-=40;
                break;
            case $string<=48:
                $string+=40;
                break;
        }
        if (isset($bds[$string])) {
            continue;
        }
        if ($string>122) {
            continue;
        }

        $serial .= chr($string);
    }
    return $serial;
}
