#!/usr/bin/php -q
<?php
include_once(dirname(__FILE__)."/ressources/class.squid.sqlite.inc");
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
$GLOBALS["KAV4PROXY_NOSESSION"]=true;
$GLOBALS["STARTIME"]=time();
$GLOBALS["PID"]="000";
$GLOBALS["VERBOSE"]=false;
ini_set('display_errors', 1);	ini_set('html_errors',0);ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);
error_reporting(E_ERROR | E_CORE_ERROR | E_COMPILE_ERROR);
$GLOBALS["DEBUG_LEVEL"]=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HotSpotDebug"));
$GLOBALS["HotSpotRedirectUI"]=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HotSpotRedirectUI"));
$GLOBALS["HotSpotTemplateID"]=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HotSpotTemplateID"));
$GLOBALS["HotSpotAutoLogin"]=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HotSpotAutoLogin"));
$GLOBALS["HotSpotAutoSMTPSrv"]=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HotSpotAutoSMTPSrv"));
$GLOBALS["HotSpotAutoSMTPPort"]=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HotSpotAutoSMTPPort"));
$GLOBALS["HotSpotAutoSMTPFrom"]=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HotSpotAutoSMTPFrom"));
$GLOBALS["HotSpotAutoSMTPUser"]=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HotSpotAutoSMTPUser"));
$GLOBALS["HotSpotAutoSMTPPass"]=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HotSpotAutoSMTPPass"));
$GLOBALS["HotSpotAutoSMTPTLS"]=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HotSpotAutoSMTPTLS"));
$GLOBALS["HotSpotAutoSMTPSSL"]=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HotSpotAutoSMTPSSL"));
$GLOBALS["HotSpotAuthenticateEach"]=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HotSpotAuthenticateEach"));
$GLOBALS["HotSpotDisableAccountTime"]=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HotSpotDisableAccountTime"));
$GLOBALS["HotSpotRemoveAccountTime"]=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HotSpotRemoveAccountTime"));
$GLOBALS["HotSpotBindInterface"]=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HotSpotBindInterface"));

if(!is_dir("/home/squid/hotspot")){@mkdir("/home/squid/hotspot");}
if(function_exists("getmypid")){$GLOBALS["PID"]=getmypid();}
if(!is_file("/home/squid/hotspot/database.db")){CreateDb();}
if($GLOBALS["DEBUG_LEVEL"]==1){WLOG("Daemon start in DEBUG MODE!");}
if($GLOBALS["DEBUG_LEVEL"]==0){WLOG("Daemon start");}
  
while (!feof(STDIN)) {
 	$url = trim(fgets(STDIN));
 	$MAIN_KEY=null;
 	WLOG("<$url>",true);
 	if($url==null){continue;}
 	$CNX_ID=0;
 	$MAIN=explode(" ",$url);
 	$XMAIN=array();
 	$tags=array();
 	foreach ($MAIN as $line){$line=trim($line);if($line=="-"){$line=null;}$XMAIN[]=$line;}
 	$CNX_ID=$XMAIN[0];
 	$USER=$XMAIN[1];
 	$SRC=$XMAIN[2];
 	$MACADDR=$XMAIN[3];
 	$XFORWARDED=$XMAIN[4];
 	if($MACADDR=="00:00:00:00:00:00"){$MACADDR=null;}
 	if($XFORWARDED<>null){$SRC=$XFORWARDED;}
 	
 	
 	$tags["MAC"]="$MACADDR";
 	if($MACADDR<>null){$MAIN_KEY=$MACADDR;}
 	if($MAIN_KEY==null){$MAIN_KEY=$SRC;}
 	$tags["KEY"]="$MAIN_KEY";

 	WLOG("Main key: $MAIN_KEY",true);

 	$ligne=row_user($MAIN_KEY,$MACADDR,$SRC);
 	if($ligne["username"]==null){
 		$tagsz=base64_encode(serialize($tags));
        WLOG("$MAIN_KEY is not authenticated, redirect session");
 		WLOG("Return [{$CNX_ID} ERR message=$tagsz hotspot=yes]",true);
 		fwrite(STDOUT, "{$CNX_ID} ERR message=$tagsz hotspot=yes\n");
 		continue;
 	}
	
	if(!check_user($ligne)){
		$tags["EMAIL"]="{$ligne["username"]}";
		$tagsz=base64_encode(serialize($tags));
		WLOG("Return [{$CNX_ID} ERR message=$tagsz user={$ligne["username"]} hotspot=yes]",true);
		fwrite(STDOUT, "{$CNX_ID} ERR message=$tagsz user={$ligne["username"]} hotspot=yes\n");
		continue;
	}
 	
	
	
	WLOG("Return [{$CNX_ID} OK user={$ligne["username"]} hotspot=yes]",true);
	fwrite(STDOUT, "{$CNX_ID} OK user={$ligne["username"]} hotspot=yes\n");
	
	
}
//----------------------------------------------------------------------------------------------------------------

$distanceInSeconds = round(abs(time() - $GLOBALS["STARTIME"]));
$distanceInMinutes = round($distanceInSeconds / 60);
WLOG("Daemon die after ({$distanceInSeconds}s/about {$distanceInMinutes}mn)");
//----------------------------------------------------------------------------------------------------------------


function row_user($keyname,$mac,$ipaddr){
	$memcached=new lib_memcached();
	
	
	$ligne=$memcached->getKey("MICROHOTSPOT:$keyname");
	if($memcached->MemCachedFound){
		if(is_array($ligne)){
			return PareMemoryLine($ligne);
		}
	}

	if($mac<>null) {
        $ligne = $memcached->getKey("MICROHOTSPOT:$mac");
        if ($memcached->MemCachedFound) {
            if (is_array($ligne)) {
                return PareMemoryLine($ligne);
            }
        }
    }
    $ligne=$memcached->getKey("MICROHOTSPOT:$ipaddr");
    if($memcached->MemCachedFound){
        if(is_array($ligne)){
            return PareMemoryLine($ligne);
        }
    }

    WLOG("[$keyname] Load information from database ($mac/$ipaddr)");
    if($mac<>null) {
        $sql = "SELECT * FROM sessions WHERE sessionkey='$keyname' OR macaddress='$mac'";
    }else{
        $sql = "SELECT * FROM sessions WHERE sessionkey='$keyname' OR ipaddr='$ipaddr'";
    }

	
	$q=new sqlite_squid("/home/squid/hotspot/database.db");

	WLOG("[$keyname] $sql",true);
	$ligne=$q->mysqli_fetch_array($sql);
	if(!$q->ok){
		if(preg_match("#no such table#is", $q->mysql_error)){
			WLOG("[$keyname] Create DB");
			CreateDb();
			$ligne=$q->mysqli_fetch_array($sql);
		}
	}
	if(!$q->ok){WLOG("[$keyname] $q->mysql_error");}
	
	if(count($ligne)==0){
		WLOG("[$keyname] No row in database user={$ligne["username"]}",true);
		return array();
	}

	$reste=0;
    if(intval($ligne["removeaccount"])>0){
        $removeaccount=intval($ligne["removeaccount"]);
        if(time()>$removeaccount){
            WLOG("[$keyname] Account {$ligne["username"]} $ipaddr/$mac must be removed.");
            return array();
        }else{
            $reste=$removeaccount-time();
        }
    }
    if(intval($ligne["disableaccount"])>0){
        $disableaccount=intval($ligne["disableaccount"]);
        if(time()>$disableaccount){
            WLOG("[$keyname] Account {$ligne["username"]} $ipaddr/$mac must be disabled.");
            return array();
        }else{
            $reste=$disableaccount-time();
        }
    }


    $Keyttl=300;
    if($reste>0){
        if($Keyttl>$reste){$Keyttl=$reste;}
    }
	
	if(intval($ligne["autocreate"])<>1){
        WLOG("[$keyname] Account {$ligne["username"]} recreate memory session for $Keyttl seconds.");
		$memcached->saveKey("MICROHOTSPOT:$keyname",$ligne, $Keyttl);
        $memcached->saveKey("MICROHOTSPOT:$ipaddr",$ligne, $Keyttl);
        if($mac<>null) {
            $memcached->saveKey("MICROHOTSPOT:$mac",$ligne, $Keyttl);
        }


	}else{
        WLOG("[$keyname] Account {$ligne["username"]} recreate memory session for 30 seconds.");
		$memcached->saveKey("MICROHOTSPOT:$keyname",$ligne, 30);
	}
	return $ligne;
	
}

function PareMemoryLine($ligne){
    $keyname=$ligne["sessionkey"];
    $mac=$ligne["macaddress"];
    $ipaddr=$ligne["ipaddr"];

    WLOG("[$keyname] PareMemoryLine() Account {$ligne["username"]} removeaccount={$ligne["removeaccount"]}, disableaccount={$ligne["disableaccount"]} ");

    if(intval($ligne["removeaccount"])>0){
        $removeaccount=intval($ligne["removeaccount"]);
        if(time()>$removeaccount){
            WLOG("[$keyname] (in memory) Account {$ligne["username"]} $ipaddr/$mac must be removed.");
            return array();
        }
        return $ligne;
    }
    if(intval($ligne["disableaccount"])>0){
        $disableaccount=intval($ligne["disableaccount"]);
        if(time()>$disableaccount){
            WLOG("[$keyname] (in memory) Account {$ligne["username"]} $ipaddr/$mac must be disabled.");
            return array();
        }
        return $ligne;
    }

    WLOG("[$keyname] (in memory) Account {$ligne["username"]} is an ulimited acount");
    return $ligne;



}

function CreateDb(){
	
	WLOG("Creating database /home/squid/hotspot/database.db");
	$q=new sqlite_squid("/home/squid/hotspot/database.db");
	
	$sql="CREATE TABLE IF NOT EXISTS `sessions` (
		`ID` INTEGER PRIMARY KEY AUTOINCREMENT,
		 sessionkey TEXT UNIQUE,
		 enabled INTEGER,
		 nextauth INTEGER,
		 autocreate INTEGER,
		 disableaccount INTEGER,
		 removeaccount INTEGER,
		 created INTEGER,
		 sourceurl TEXT,
		 macaddress TEXT,
		 ipaddr TEXT,
		 username TEXT,
		 password TEXT)";
	
	$q->QUERY_SQL($sql);
	if(!$q->ok){WLOG($q->mysql_error);}
	$indexes="CREATE OR IGNORE INDEX isessionKey ON `sessions` (sessionkey);";
	$q->QUERY_SQL($indexes);
	$indexes="CREATE OR IGNORE INDEX iUsername ON `sessions` (username);";
	$q->QUERY_SQL($indexes);
}

function check_user($ligne){
	$keyname=$ligne["sessionkey"];
	$autocreate=$ligne["autocreate"];
	$removeaccount=intval($ligne["removeaccount"]);
	$removeaccount_text=date("Y-m-d H:i:s",$removeaccount);
	$enabled=intval($ligne["enabled"]);
	$disableaccount=intval($ligne["disableaccount"]);
	$disableaccount_text=date("Y-m-d H:i:s",$disableaccount);
	$ID=$ligne["ID"];
	$CurrentTime=time();
    $HotSpotAuthenticateEach=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HotSpotAuthenticateEach"));
    $macaddress=$ligne["macaddress"];
    $ipaddr=$ligne["ipaddr"];
    $username=$ligne["username"];


    $created=intval($ligne["created"]);
    $q=new sqlite_squid("/home/squid/hotspot/database.db");

    if($created==0){
        $created=time();
        $q->QUERY_SQL("UPDATE sessions SET created=$created WHERE sessionkey='$keyname'");
    }

    if($HotSpotAuthenticateEach>0) {
        $HotSpotAuthenticateEachSeconds = $HotSpotAuthenticateEach * 60;
        $ToReauthenticate=$created+$HotSpotAuthenticateEachSeconds;
        if(time()>$ToReauthenticate){
            WLOG("[$keyname] $macaddress $ipaddr $username session END TTL",true);
            return false;
        }
    }




    if($enabled==0){
        WLOG("[$keyname] enabled == 0, deny access",true);
        unset($GLOBALS["MEMUSERS"][$keyname]);
        return false;
    }
	
	WLOG("[$keyname] Current Time is $CurrentTime (".date("H:i:s").")",true);
	
	if($autocreate==1){

		
		WLOG("[$keyname] autocreate == Not confirmed, checking the removeaccount value ($removeaccount_text)",true);
		if($CurrentTime>$removeaccount){
			WLOG("[$keyname] autocreate == Not confirmed, time exceed ($removeaccount>$CurrentTime), remove the session N.$ID...");
			$q=new sqlite_squid("/home/squid/hotspot/database.db");
			$q->QUERY_SQL("DELETE FROM `sessions` WHERE ID='$ID'");
			if(!$q->ok){WLOG("[$keyname] FATAL $q->mysql_error");}
			unset($GLOBALS["MEMUSERS"][$keyname]);
			return false;
		}
		$ResteTime=$removeaccount-$CurrentTime;
		WLOG("[$keyname] (session active) autocreate need to confirm in {$ResteTime} seconds",true);
		return true;
	}
	
	if($removeaccount>0){
		if($CurrentTime>$removeaccount){
			WLOG("[$keyname] (remove account) Time exceed time exceed ($removeaccount>$CurrentTime) remove the session N.$ID...");
			$q=new sqlite_squid("/home/squid/hotspot/database.db");
			$q->QUERY_SQL("DELETE FROM `sessions` WHERE ID='$ID'");
			if(!$q->ok){WLOG("[$keyname] FATAL $q->mysql_error");}
			unset($GLOBALS["MEMUSERS"][$keyname]);
			return false;
		}
	}
	if($enabled==1){
		if($disableaccount>0){
			if($CurrentTime>$disableaccount){
				WLOG("[$keyname] (disable account) Time exceed ($CurrentTime>$disableaccount) for Disable Account Time (Max:$disableaccount_text) == Disable the session...");
				$q=new sqlite_squid("/home/squid/hotspot/database.db");
				$q->QUERY_SQL("UPDATE `sessions` SET enabled=0 WHERE ID='$ID'");
				if(!$q->ok){WLOG("[$keyname] FATAL $q->mysql_error");}
				unset($GLOBALS["MEMUSERS"][$keyname]);
				return false;
			}
		}
	}
	



	
	WLOG("[$keyname]: (session active) Pass all tests, return True",true);
	return true;
}


function microtime_float(){
	list($usec, $sec) = explode(" ", microtime());
	return ((float)$usec + (float)$sec);
}
function tool_time_min($timeFrom){
	$data1 = $timeFrom;
	$data2 = time();
	$difference = ($data2 - $data1);
	$results=intval(round($difference/60));
	if($results<0){$results=1;}
	return $results;
}
function ToSyslog($text){
	$LOG_SEV=LOG_INFO;
	if(function_exists("openlog")){openlog("license-plugin", LOG_PID , LOG_SYSLOG);}
	if(function_exists("syslog")){ syslog($LOG_SEV, $text);}
	if(function_exists("closelog")){closelog();}
	WLOG("$text");
}


function WLOG($text=null,$debug=false){
	
	if($debug){if($GLOBALS["DEBUG_LEVEL"]==0){return;}}
	
	$handle= @fopen("/var/log/squid/hotspot.log", 'a');
	$trace=@debug_backtrace();
	if(isset($trace[0])){$LINE=$trace[0]["line"];}
	if(isset($trace[1])){$LINE=$trace[1]["line"];}
	$date=@date("Y-m-d H:i:s");
   	if (is_file("/var/log/squid/hotspot.log")) { 
   		$size=@filesize("/var/log/squid/hotspot.log");
   		if($size>1000000){
   			@fclose($handle);
   			unlink("/var/log/squid/hotspot.log");
   			$handle = @fopen("/var/log/squid/hotspot.log", 'a');
   		}
   		
   		
   	}
	
	
	@fwrite($handle, "$date PROXY:[{$GLOBALS["PID"]}] L.$LINE : $text\n");
	@fclose($handle);
}


function find_program($strProgram) {
	  $key=md5($strProgram);
	  if(isset($GLOBALS["find_program"][$key])){return $GLOBALS["find_program"][$key];}
	  $value=trim(internal_find_program($strProgram));
	  $GLOBALS["find_program"][$key]=$value;
      return $value;
}
function internal_find_program($strProgram){
	  global $addpaths;	
	  $arrPath = array('/bin', '/sbin', '/usr/bin', '/usr/sbin', '/usr/local/bin', 
	  '/usr/local/sbin',
	  '/usr/kerberos/bin',
	  
	  );
	  
	  if (function_exists("is_executable")) {
	    foreach($arrPath as $strPath) {
	      $strProgrammpath = $strPath . "/" . $strProgram;
	      if (is_executable($strProgrammpath)) {
	      	  return $strProgrammpath;
	      }
	    }
	  } else {
	   	return strpos($strProgram, '.exe');
	  }
	}	
?>