<?php
include_once(dirname(__FILE__)."/ressources/class.template-admin.inc");
include_once(dirname(__FILE__).'/ressources/class.postgres.inc');
include_once(dirname(__FILE__).'/ressources/class.modsectools.inc');

if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
$users=new usersMenus();if(!$users->AsFirewallManager){exit();}
if(isset($_GET["verbose"])){$GLOBALS["VERBOSE"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
if(isset($_GET["search"])){search();exit;}

if(isset($_GET["zoom-js"])){zoom_js();exit;}
if(isset($_GET["zoom-popup"])){zoom_popup();exit;}
if(isset($_GET["zoom-download"])){zoom_download();exit;}
page();

function zoom_js(){
    $page=CurrentPageName();
    $tpl=new template_admin();
    $unique_id=$_GET["zoom-js"];
    echo $tpl->js_dialog1($unique_id,"$page?zoom-popup=$unique_id");
}
function zoom_download(){

    $modtools=new modesctools();
    $unique_id=intval($_GET["zoom-download"]);
    $final_content=$modtools->modsecurity_reports($unique_id);
    $final_content=base64_decode($final_content);
    $fsize=strlen($final_content);

    $content_type="text/plain";
    header('Content-type: '.$content_type);
    header('Content-Transfer-Encoding: binary');
    header("Content-Disposition: attachment; filename=\"$unique_id.txt\"");
    header("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
    header("Expires: Sat, 26 Jul 1997 05:00:00 GMT"); // Date dans le passé
    header("Content-Length: ".$fsize);
    ob_clean();
    flush();
    echo $final_content;

}

function zoom_popup(){
    $page=CurrentPageName();
    $tpl=new template_admin();
    $unique_id=intval($_GET["zoom-popup"]);
    $q=new postgres_sql();

    $ligne=$q->mysqli_fetch_array("SELECT * FROM modsecurity_events WHERE unique_id=$unique_id");
    $modtools=new modesctools();

    $severity_icon[0]="<span class='label label'>Info</span>";
    $severity_icon[2]="<span class='label label-danger'>{critic}</span>";
    $severity_icon[3]="<span class='label label-danger'>{error}</span>";
    $severity_icon[4]="<span class='label label-warning'>{warning}</span>";
    $severity_icon[5]="<span class='label label-info'>{notice}</span>";

    $html[]="<H1>".$modtools->modsecurity_titles($ligne["ruleid"])."&nbsp;&nbsp;{$severity_icon[$ligne["severity"]]}</h1>";
    $html[]="<p><h3>".$modtools->modsecurity_explains($ligne["explainid"])."</h3></p>";
    $html[]="<table class=table>";
    $reportsize=strlen($modtools->modsecurity_reports($unique_id));
    if($reportsize>10) {
        $html[] = "<tr>";
        $html[] = "<td colspan='2' align='right'>" . $tpl->button_autnonome("{download2}", "document.location.href='$page?zoom-download=$unique_id'", "fas fa-download", null, 220) . "</td>";
        $html[] = "</tr>";
    }
    $html[]="<tr>";

    $html[]="<tr>";
    $html[]="<td>{date}:</td>";
    $html[]="<td><strong>{$ligne["created"]}</strong></td>";
    $html[]="</tr>";
    $html[]="<tr>";

    $modtools->hostinfo($ligne["hostid"]);
    $hosts=$modtools->hostname." [$modtools->ipaddr]";

    $html[]="<tr>";
    $html[]="<td>{client}:</td>";
    $html[]="<td><strong>{$hosts}</strong></td>";
    $html[]="</tr>";

    $html[]="<tr>";
    $html[]="<td>{rule}:</td>";
    $html[]="<td><strong>{$ligne["ruleid"]}</strong></td>";
    $html[]="</tr>";

    $html[]="<tr>";
    $html[]="<td>{pattern}:</td>";
    $html[]="<td><strong>".$modtools->modsecurity_patterns($ligne["fileid"])."</strong></td>";
    $html[]="</tr>";

    $html[]="<tr>";
    $html[]="<td>{version}:</td>";
    $html[]="<td><strong>".$modtools->modsecurity_vers($ligne["versionid"])."</strong></td>";
    $html[]="</tr>";

    $html[]="<tr>";
    $html[]="<td>{maturity}:</td>";
    $html[]="<td><strong>{$ligne["maturity"]}</strong></td>";
    $html[]="</tr>";

    $html[]="<tr>";
    $html[]="<td>{accuracy}:</td>";
    $html[]="<td><strong>{$ligne["accuracy"]}</strong></td>";
    $html[]="</tr>";

    $html[]="<tr>";
    $html[]="<td>{tags}:</td>";
    $html[]="<td>";

    $tags=$modtools->modsecurity_tags($unique_id);
    if(count($tags)>0){
        $html[]="<ul class=\"tag-list\" style=\"padding: 0\">";
        foreach ($tags as $tag){
            $html[]="<li><a href=\"\"><i class=\"fa fa-tag\"></i> $tag</a></li>";

        }
        $html[]="</ul>";

    }
    $html[]="</td>";
    $html[]="</tr>";




    $html[]="</table>";

    echo $tpl->_ENGINE_parse_body($html);
}

function page(){
    $page=CurrentPageName();
    $tpl=new template_admin();
    $q=new postgres_sql();
    $q->create_modsecurity_tables();
    $t=time();

    $html[]="
	<div class=\"row border-bottom white-bg dashboard-header\">
	    <div class=\"col-sm-12\"><h1 class=ng-binding>Web Application Firewall {DETECTED_THREATS}</H1>
	    </div>
	</div>
	<div class=\"row\" style='margin-top: 10px'> 
		<div class='ibox-content'>
			<div class=\"input-group\">
	      		<input type=\"text\" class=\"form-control\" value=\"\" placeholder=\"{search}\" id='search-this-$t' OnKeyPress=\"Search$t(event);\">
	      		<span class=\"input-group-btn\"><button style=\"text-transform: capitalize;\" class=\"btn btn-default\" type=\"button\" OnClick=\"ss$t();\">Go!</button></span>
	     	</div>
    	</div>
	</div>
	<div class='row'><div id='progress-firehol-restart'></div>
	<div class='ibox-content'>

	<div id='waf-threats-table'></div>

	</div>
	</div>
	<script>
    $.address.state('/');
	$.address.value('/threats-waf');
	$.address.title('Artica: Web Application firewall threats');
		function Search$t(e){";
    $html[]=" 
			if(!checkEnter(e) ){return;}
			ss$t();
		}
		
		function ss$t(){
			var ss=encodeURIComponent(document.getElementById('search-this-$t').value);
			LoadAjax('waf-threats-table','$page?search='+ss);
		}
		
		function Start$t(){
			var ss=document.getElementById('search-this-$t').value;
			ss$t();
		}
		Start$t();
	</script>";

    if(isset($_GET["main-page"])){
        $tpl=new template_admin("Artica: Web Application firewall {DETECTED_THREATS}",$html);
        echo $tpl->build_firewall();
        return;
    }
    echo $tpl->_ENGINE_parse_body($html);

}

function search(){
    $time=null;
    $t=time();
    $page=CurrentPageName();
    $tpl=new template_admin();
    $q=new postgres_sql();

    $sql="SELECT modsecurity_events.unique_id,modsecurity_events.created,modsecurity_events.fileid,modsecurity_events.ruleid,modsecurity_events.explainid,modsecurity_events.severity,modsecurity_events.versionid,modsecurity_events.maturity,modsecurity_events.accuracy,modsecurity_events.hostid,modsecurity_events.uriid FROM modsecurity_events ORDER BY modsecurity_events.created LIMIT 250
  ";

    $results=$q->QUERY_SQL($sql);

    if(!$q->ok){echo $tpl->div_error($q->mysql_error);}

    $html[]="<div class=\"btn-group\" data-toggle=\"buttons\" style='margin-top:10px'>";
    $html[]="<label class=\"btn btn btn-primary\" OnClick=\"$add\"><i class='fa fa-plus'></i> {new_rule} </label>";
    $html[]="</div>";
    $html[]="<table id='table-$t' class=\"footable table table-stripped\" data-page-size=\"100\" data-paging=\"true\">";
	$html[]="<thead>";
	$html[]="<tr>";
    $html[]="<th data-sortable=true class='text-capitalize' >{date}</th>";
    $html[]="<th data-sortable=true class='text-capitalize' >{rule}</th>";
    $html[]="<th data-sortable=true class='text-capitalize' >{severity}</th>";
    $html[]="<th data-sortable=true class='text-capitalize' data-type='text'>{client}</th>";
	$html[]="<th data-sortable=true class='text-capitalize' data-type='text'>{subject}</th>";
    $html[]="<th data-sortable=true class='text-capitalize' data-type='text'>{path}</th>";

	$html[]="</tr>";
	$html[]="</thead>";
	$html[]="<tbody>";

	$severity_icon[0]="<span class='label label'>Info</span>";
    $severity_icon[2]="<span class='label label-danger'>{critic}</span>";
    $severity_icon[3]="<span class='label label-danger'>{error}</span>";
    $severity_icon[4]="<span class='label label-warning'>{warning}</span>";
    $severity_icon[5]="<span class='label label-info'>{notice}</span>";


    $modtools=new modesctools();
    $TRCLASS=null;
    while($ligne=@pg_fetch_assoc($results)){
        $md=md5(serialize($ligne));
        $unique_id=$ligne["unique_id"];
        $created=$ligne["created"];
        $fileid=$ligne["fileid"];
        $ruleid=$ligne["ruleid"];
        $explainid=$ligne["explainid"];
        $severity=$ligne["severity"];
        $versionid=$ligne["versionid"];
        $maturity=$ligne["maturity"];
        $accuracy=$ligne["accuracy"];
        $hostid=$ligne["hostid"];
        $uriid=$ligne["uriid"];
        $msg=$ligne["msg"];
        $ico=$severity_icon[$severity];
        if($TRCLASS=="footable-odd"){$TRCLASS=null;}else{$TRCLASS="footable-odd";}
        $created_time=strtotime($created);
        $zdate=$tpl->time_to_date($created_time,true);
        $modtools->hostinfo($hostid);
        $hosts=$modtools->hostname." [$modtools->ipaddr]";
        $subject=$modtools->modsecurity_titles($ruleid);
        $uri=$modtools->modsecurity_uris($uriid);

        $rule_text=$tpl->td_href($ruleid,null,"Loadjs('$page?zoom-js=$unique_id')");

        $html[]="<tr class='$TRCLASS' id='$md'>";
        $html[]="<td width='1%' nowrap>$zdate</td>";
        $html[]="<td width='1%' nowrap>$rule_text</td>";
        $html[]="<td width='1%' nowrap>$ico</td>";
        $html[]="<td width='1%' nowrap>$hosts</td>";
        $html[]="<td>$subject</td>";
        $html[]="<td>$uri</td>";
        $html[]="</tr>";
    }

    $html[]="</tbody>";
    $html[]="<tfoot>";
    $html[]="<tr>";
    $html[]="<td colspan='6'>";
    $html[]="<ul class='pagination pull-right'></ul>";
    $html[]="</td>";
    $html[]="</tr>";
    $html[]="</tfoot>";
    $html[]="</table>";
    $html[]="
<script> 
NoSpinner();\n".@implode("\n",$tpl->ICON_SCRIPTS)."
$(document).ready(function() { $('#table-$t').footable({\"filtering\": { \"enabled\": true },\"sorting\": { \"enabled\": true },\"paging\": { \"size\": {$GLOBALS["FOOTABLE_PSIZE"]} } } ); });";
$html[]="</script>";
    echo $tpl->_ENGINE_parse_body($html);



}

