<?php
include_once(dirname(__FILE__)."/ressources/class.template-admin.inc");if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__)."/ressources/class.patch.tables.fw.inc");
include_once(dirname(__FILE__)."/ressources/class.openvpn.inc");
if(isset($_GET["verbose"])){$GLOBALS["VERBOSE"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
if(isset($_POST["none"])){die();}
if(isset($_GET["tabs"])){tabs();exit;}
if(isset($_GET["table"])){table();exit;}
if(isset($_GET["status"])){status();exit;}
if(isset($_POST["postgresqlPort"])){Save();exit;}
if(isset($_GET["ufdbconf-popup"])){ufdbconf_popup();exit;}
if(isset($_GET["ufdbdebug-popup"])){ufdbdebug_popup();exit;}
if(isset($_GET["graph1"])){graph1();exit;}
if(isset($_GET["remove-database-ask"])){remove_database_ask();exit;}

status();

function tabs(){
	$page=CurrentPageName();
	$tpl=new template_admin();
	$array["{status}"]="$page?table=yes";
	$array["{tables}"]="fw.postgresql.tables.php";
    $array["{backup}"]="fw.postgresql.backup.php";
    $array["{events}"]="fw.postgresql.events.php";
	
	
	
	echo $tpl->tabs_default($array);

}

function remove_database_ask(){
    $page=CurrentPageName();
    $tpl=new template_admin();


    $ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/postgres.remove.progress";
    $ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/postgres.remove.progress.txt";
    $ARRAY["CMD"]="postgres.php?remove-database=yes";
    $ARRAY["TITLE"]="{REMOVE_DATABASE}";
    $ARRAY["AFTER"]="LoadAjax('table-postgresqlstatus','$page?tabs=yes');";
    $prgress=base64_encode(serialize($ARRAY));
    $jsrestart="Loadjs('fw.progress.php?content=$prgress&mainid=progress-postgresql-restart');";
    $tpl->js_confirm_delete("{REMOVE_DATABASE}<hr>{rebuild_database_warn}","none",$tpl->javascript_parse_text("{database}"),$jsrestart);
}




function status(){
	$page=CurrentPageName();
	$tpl=new template_admin();
	$version=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("ARTICA_POSTGRESQL_VERSION");


	$html="
	<div class=\"row border-bottom white-bg dashboard-header\">
	    <div class=\"col-sm-12\">
	            <h1 class=ng-binding>PostgreSQL $version &raquo;&raquo; {service_status}</h1>
	            <p>{PostgreSQL_explain}</p>
    	</div>
    </div>
		
	<div class='row'>
	        <div id='progress-postgresql-restart'></div>
	        <div class='ibox-content' style='min-height:600px'>
                <div id='table-postgresqlstatus'></div>
	        </div>
	</div>
		
		
		
	<script>
	$.address.state('/');
	$.address.value('/PostgreSQL');
	LoadAjax('table-postgresqlstatus','$page?tabs=yes');
		
	</script>";

	if(isset($_GET["main-page"])){
		$tpl=new template_admin(null,$html);
		echo $tpl->build_firewall();
		return;
	}
	
	$tpl=new template_admin();
	echo $tpl->_ENGINE_parse_body($html);

}

function table(){
	$page=CurrentPageName();
	$tpl=new template_admin();
	$ini=new Bs_IniHandler();
	$sock=new sockets();
	$sock->getFrameWork("postgres.php?service-status=yes");
	$ini->loadFile("/usr/share/artica-postfix/ressources/logs/APP_INFLUXDB.status");
	$InfluxUseRemotePort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("InfluxUseRemotePort"));
	$InfluxUseRemoteArticaPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("InfluxUseRemoteArticaPort"));

	if($InfluxUseRemotePort==0){$InfluxUseRemotePort=5432;}
	if($InfluxUseRemotePort==8086){$InfluxUseRemotePort=5432;}
	if($InfluxUseRemoteArticaPort==0){$InfluxUseRemoteArticaPort=9000;}
	$ArticaInfluxUsername=$sock->GET_INFO("ArticaInfluxUsername");
	if($ArticaInfluxUsername==null){$ArticaInfluxUsername="Manager";}
	$InfluxRestartMem=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("InfluxRestartMem"));

	
	$InfluxListenInterface=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("InfluxListenInterface");
	if($InfluxListenInterface==null){$InfluxListenInterface="lo";}
	
	$PostgreSQLSharedBuffer=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PostgreSQLSharedBuffer"));
	if($PostgreSQLSharedBuffer==0){$PostgreSQLSharedBuffer=32;}
	
	$PostgreSQLEffectiveCacheSize=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PostgreSQLEffectiveCacheSize"));
	if($PostgreSQLEffectiveCacheSize==0){$PostgreSQLEffectiveCacheSize=256;}
	
	$PostgreSQLWorkMem=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PostgreSQLWorkMem"));
	if($PostgreSQLWorkMem==0){$PostgreSQLWorkMem=200;}
	if($PostgreSQLWorkMem<50){$PostgreSQLWorkMem=200;}

	$sock->getFrameWork("postgres.php?PostGresSQLDatabaseDirectory=yes");
	$PostGresSQLDatabaseDirectory=$sock->GET_INFO("PostGresSQLDatabaseDirectory");
	
	
	$ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/postgres.progress";
	$ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/postgres.progress.txt";

	$ARRAY["CMD"]="postgres.php?restart-progress=yes";
	$ARRAY["TITLE"]="{restarting_service}";
	$ARRAY["AFTER"]="LoadAjax('table-postgresqlstatus','$page?tabs=yes');";
	$prgress=base64_encode(serialize($ARRAY));
	$jsrestart="Loadjs('fw.progress.php?content=$prgress&mainid=progress-postgresql-restart');";
	
	//<i class="fas fa-trash"></i>

	
	$html[]="<table style='width:100%'>";
	$html[]="<tr>";
	$html[]="<td style='width:260px' valign='top'>";
	$html[]="<table style='width:100%'>";
	$html[]="<tr><td>
	<div class=\"ibox\">
    	<div class=\"ibox-content\">". $tpl->SERVICE_STATUS($ini, "APP_POSTGRES",$jsrestart)."
    	
    	".$tpl->button_autnonome("{REMOVE_DATABASE}","Loadjs('$page?remove-database-ask=yes')","fas fa-trash","AsSystemAdministrator",335,"btn-danger")."</div>

	</div>
    <div id='influx-db-size'></div>
    <script>Loadjs('$page?graph1=yes');</script>
    </td>
    </tr>";
	


	
	

	
	$ARRAY=array();
	$ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/postgresql.progress";
	$ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/postgresql.progress.log";
	$ARRAY["CMD"]="postgresql.php?restart=yes";
	$ARRAY["TITLE"]="{restart_service}";
	$ARRAY["AFTER"]="dialogInstance1.close();LoadAjax('table-postgresqlstatus','$page?table=yes');";
	$prgress=base64_encode(serialize($ARRAY));
	$jsrestart="Loadjs('fw.progress.php?content=$prgress&mainid=progress-postgresql-restart');";
	
	
	
$html[]="</table></td>";

$html[]="<td style='width:99%;vertical-align:top'>";

$form[]=$tpl->field_interfaces("InfluxListenInterface","{listen_interface}",$InfluxListenInterface);
$form[]=$tpl->field_numeric("InfluxRestartMem","{restart_if_memory_exceed} (MB)",$InfluxRestartMem,"{influx_restart_if_memory_exceed}");
$form[]=$tpl->field_numeric("PostgreSQLSharedBuffer","{shared_buffer}",$PostgreSQLSharedBuffer,"{PostgreSQLSharedBuffer}");
$form[]=$tpl->field_numeric("PostgreSQLEffectiveCacheSize","{effective_cache_size} (MB)",$PostgreSQLEffectiveCacheSize,"{PostgreSQLEffectiveCacheSize}");
$form[]=$tpl->field_numeric("PostgreSQLWorkMem","{work_mem} (MB)",$PostgreSQLWorkMem,"{PostgreSQLWorkMem}");
$form[]=$tpl->field_info("NULL", "{database_storage_path}", $PostGresSQLDatabaseDirectory);

$tpl->form_add_button("{database_storage_path}", "Loadjs('fw.postgres.directory.php')");

$html[]=$tpl->form_outside("{parameters}", @implode("\n", $form),null,"{apply}",$jsrestart,"AsSystemAdministrator");
$html[]="</td>";
$html[]="</tr>";

$html[]="</table>";

	echo $tpl->_ENGINE_parse_body(@implode("\n", $html));
	
}

function Save(){
	$sock=new sockets();
	$tpl=new template_admin();
	$tpl->CLEAN_POST();
	
	$_POST["zipproxy_MaxSize"]=$_POST["zipproxy_MaxSize"]*1024;
	
	foreach ($_POST as $key=>$value){
		$sock->SET_INFO($key, $value);
	}
	
}

function graph1(){

	$cacheFile="/usr/share/artica-postfix/ressources/logs/web/InfluxDB.state";
	$tpl=new templates();
	$ARRAY=unserialize(@file_get_contents($cacheFile));
	$ARRAY["PART"]=$ARRAY["PART"]/1024;

	$PART=intval($ARRAY["PART"])-intval($ARRAY["SIZEKB"]);

	$MAIN["Partition " .FormatBytes($ARRAY["PART"])]=$PART;
	$MAIN["DB ".FormatBytes($ARRAY["SIZEKB"])]=$ARRAY["SIZEKB"];

	$PieData=$MAIN;
	$highcharts=new highcharts();
	$highcharts->container="influx-db-size";
	$highcharts->PieDatas=$PieData;
	$highcharts->ChartType="pie";
	$highcharts->PiePlotTitle="{database_size}";
	$highcharts->Title=$tpl->_ENGINE_parse_body("{database_size} ".FormatBytes($ARRAY["SIZEKB"]));
	echo $highcharts->BuildChart();
}
