<?php
include_once(dirname(__FILE__)."/ressources/class.template-admin.inc");if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__)."/ressources/class.squid.acls.groups.inc");
if(isset($_GET["verbose"])){$GLOBALS["VERBOSE"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}

if(isset($_POST["sslcrtd_program_dbsize"])){Save();exit;}
if(isset($_GET["table"])){table();exit;}
if(isset($_GET["tabs"])){tabs();exit;}


page();


function page(){
	$page=CurrentPageName();
	$tpl=new templates();


	
	
	$html="
<div class=\"row border-bottom white-bg dashboard-header\">
	<div class=\"col-sm-12\"><h1 class=ng-binding id='ssl-title'>{ssl_protocol}&nbsp;&raquo;&nbsp;{status}</h1><p id='par-ssl'>{ssl_protocol_https_explain}</div>
	
</div>
			
                            
			
<div class='row'><div id='progress-ssl-restart'></div>
			<div class='ibox-content'>
       	
			 	<div id='table-acls-ssl-status'></div>
                                    
			</div>
</div>
					
			
			
<script>
	$.address.state('/');
	$.address.value('/proxy-ssl');
	LoadAjax('table-acls-ssl-status','$page?tabs=yes');
</script>";
	

	if(isset($_GET["main-page"])){
		$tpl=new template_admin(null,$html);
		echo $tpl->build_firewall();
		return;
	}
	
	$tpl=new templates();
	echo $tpl->_ENGINE_parse_body($html);
	
}
function tabs(){
	$page=CurrentPageName();
	$tpl=new template_admin();
    $SSLCount=0;
    $sock=new sockets();
    $q=new lib_sqlite("/home/artica/SQLITE/proxy.db");
    $sql="SELECT count(*) as tcount FROM proxy_ports WHERE enabled=1 AND UseSSL=1";
    $ligne=$q->mysqli_fetch_array($sql);
    $SSLCount=intval($ligne["tcount"]);

    $sql="SELECT * FROM transparent_ports WHERE enabled=1";
    $results=$q->QUERY_SQL($sql);
    foreach ($results as $index=>$ligne){
        if($ligne["sslcertificate"]<>null){$SSLCount++;}
    }

    $HaClusterClient                = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterClient"));
    if($HaClusterClient==1){
        $HaClusterGBConfig=unserialize($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterGBConfig"));
        if(intval($HaClusterGBConfig["HaClusterDecryptSSL"])==1){
            $SSLCount++;
        }
    }
    $SquidMikrotikEnabled       = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidMikrotikEnabled"));
    if($SquidMikrotikEnabled==1){
        $SSLCount++;
    }

    if($SSLCount==0){

        echo $tpl->FATAL_ERROR_SHOW_128("{no_sslport_defined}");
        return;
    }



	$array["{status}"]="$page?table=yes";
	$array["{ssl_rules}"]="fw.proxy.ssl.rules.php";
    $array["{certificates}"]="fw.proxy.ssl.certificates.php";
	echo $tpl->tabs_default($array);

}

function table(){
	$addon=null;
	$page=CurrentPageName();
	$tpl=new template_admin();
	$sock=new sockets();
	if($GLOBALS["VERBOSE"]){$addon="&verbose=yes";}
	$sock->getFrameWork("squid2.php?ssl-status=yes$addon");
	
	$SquidSSLUrgency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidSSLUrgency"));
	if($SquidSSLUrgency==1){echo $tpl->FATAL_ERROR_SHOW_128("{proxy_in_ssl_emergency_mode}");}
	
	

	
	$ARRAY=array();
	$ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.ssl.rules.progress";
	$ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/squid.ssl.rules.progress.log";
	$ARRAY["CMD"]="squid2.php?ssl-rules=yes";
	$ARRAY["TITLE"]="{ssl_rules}";
	$prgress=base64_encode(serialize($ARRAY));
	$reconfigure_js="Loadjs('fw.progress.php?content=$prgress&mainid=progress-acls-restart')";
	
	
	$DATA=unserialize(@file_get_contents("/usr/share/artica-postfix/ressources/logs/ssl_status.db"));
	
	$html[]="<table style='width:100%'><tr>";

	
	$html[]="<td style='vertical-align:top;width:33%;padding:10px'>";
	$html[]=$tpl->widget_h("green","fa-heart","{$DATA["DAEMONS_NUMBER"]} {processes}","{memory}: ".FormatBytes($DATA["MEMORY"]));
	$html[]="</td>";
	
	$html[]="<td style='vertical-align:top;width:33%;padding:10px'>";
	$html[]=$tpl->widget_h("green","fa-certificate","{$DATA["CERTSNUMBER"]} {certificates}","{number_of_generated_certificates}");
	$html[]="</td>";
	$html[]="</tr>";
	
	
	
	if($SquidSSLUrgency==1){
		$html[]="<tr><td style='padding-top:10px'>".$tpl->button_autnonome("{disable_emergency_mode}", "Loadjs('fw.proxy.ssl-emergency.remove.php')", "fa-play","AsProxyMonitor",550,"btn-primary")."</td></tr>";
	}
	
	$html[]="</table>";
	
	
	
	
	$html[]="</td>";
	$html[]="</tr></table>";
	
	$sslproxy_versions[1]="{default}";
	$sslproxy_versions[2]="SSLv2 {only}";
	$sslproxy_versions[3]="SSLv3 {only}";
	$sslproxy_versions[4]="TLSv1.0 {only}";
	$sslproxy_versions[5]="TLSv1.1 {only}";
	$sslproxy_versions[6]="TLSv1.2 {only}";
	
	$sslproxy_version=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("sslproxy_version"));
	$sslcrtd_program_dbsize=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("sslcrtd_program_dbsize"));
	
	if($sslproxy_version==0){$sslproxy_version=1;}
	if($sslcrtd_program_dbsize==0){$sslcrtd_program_dbsize=8;}

    $on_unsupported_protocol=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("on_unsupported_protocol"));


	$form[]=$tpl->field_checkbox("on_unsupported_protocol","{on_unsupported_protocol}",
        $on_unsupported_protocol,false,"{on_unsupported_protocol_text}");
	$form[]=$tpl->field_array_hash($sslproxy_versions, "sslproxy_version", "{sslproxy_version}", $sslproxy_version);
	$form[]=$tpl->field_numeric("sslcrtd_program_dbsize","{sslcrtd_program_dbsize} (MB)",$sslcrtd_program_dbsize);

   
	
	$html[]="<div id='progress-acls-restart'></div>";
	$html[]=$tpl->form_outside("{global_parameters}", @implode("\n", $form),null,"{apply}",$reconfigure_js,"AsSquidAdministrator");
	echo $tpl->_ENGINE_parse_body(@implode("\n", $html));
	
	$ssl_protocol=$tpl->_ENGINE_parse_body("{ssl_protocol}&nbsp;&raquo;&nbsp;{status}");
	$PROXY_ACLS=$tpl->_ENGINE_parse_body("{ssl_protocol_https_explain}");
	$PROXY_ACLS=str_replace("\n", "", $PROXY_ACLS);
	$ssl_protocol=str_replace("\n", "", $ssl_protocol);
	$PROXY_ACLS=str_replace("'", "`", $PROXY_ACLS);
	$ssl_protocol=str_replace("'", "`", $ssl_protocol);
	
	echo "<script>
	document.getElementById('ssl-title').innerHTML='$ssl_protocol';
	document.getElementById('par-ssl').innerHTML='$PROXY_ACLS';		
	</script>		
	";
}

function Save(){
	$tpl=new template_admin();
	$tpl->SAVE_POSTs();
}

