<?php
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}

function udevd_daemon_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("udevd");
	if(is_file("/lib/systemd/systemd-udevd")){$bin="/lib/systemd/systemd-udevd";}
	exec("$bin --version 2>&1",$results);
	foreach ($results as $num=>$line){
		if(preg_match("#^([0-9\.]+)#", $line,$re)){$GLOBALS[__FUNCTION__]=$re[1];return $re[1];}
	}

	return null;

}

function OPENDKIM_VERSION(){
	if(isset($GLOBALS["OPENDKIM_VERSION"])){return $GLOBALS["OPENDKIM_VERSION"];}

	$opendkim=$GLOBALS["CLASS_UNIX"]->find_program("opendkim");

	exec("$opendkim -V 2>&1",$results);
	foreach ($results as $index=>$line){
		if(!preg_match("#OpenDKIM Filter v([0-9\.]+)#", $line,$re)){
			if($GLOBALS["VERBOSE"]){echo "VERSION NO MATCH: \"$line\"\n";}
			continue;}
		$GLOBALS["OPENDKIM_VERSION"]=$re[1];
		return $GLOBALS["OPENDKIM_VERSION"];

	}

}

function IPSEC_VERSION(){
	if(isset($GLOBALS["IPSEC_VERSION"])){return $GLOBALS["IPSEC_VERSION"];}
	$ipsec=$GLOBALS["CLASS_UNIX"]->find_program("ipsec");
	exec("$ipsec version 2>&1",$results);
	foreach ($results as $line){
		$line=trim($line);
		if($line==null){continue;}
		if(preg_match("#Linux strongSwan.*?([0-9\.]+)\/#i",$line,$re)){
			$GLOBALS["IPSEC_VERSION"]=$re[1];
			return $GLOBALS["IPSEC_VERSION"];
		}

	}
	return null;
}

function APP_UPDATE_UTILITY_VERSION(){
	if(isset($GLOBALS["APP_UPDATE_UTILITY_VERSION"])){return $GLOBALS["APP_UPDATE_UTILITY_VERSION"];}
	exec("/home/kuu3/UpdateUtility-Console -h 2>&1",$results);
	foreach ($results as $line){
		$line=trim($line);
		if($line==null){continue;}
		if(preg_match("#Update Utility\s+([0-9\.]+)\s+console#i",$line,$re)){
			$GLOBALS["APP_UPDATE_UTILITY_VERSION"]=$re[1];
			return $GLOBALS["APP_UPDATE_UTILITY_VERSION"];
		}

	}

	return null;

}

function APP_KAV4PROXY_VERSION(){

	if(isset($GLOBALS["APP_KAV4PROXY_VERSION"])){return $GLOBALS["APP_KAV4PROXY_VERSION"];}
	exec("/opt/kaspersky/kav4proxy/sbin/kav4proxy-kavicapserver -v 2>&1",$results);

	foreach ($results as $none=>$line){
		if(preg_match("#version\s+([0-9\.]+)\/RELEASE build.*?([0-9]+)#", $line,$re)){
			$GLOBALS["APP_KAV4PROXY_VERSION"]= $re[1]." build {$re[2]}";
			break;
		}
		if(preg_match("#version\s+([0-9\.]+)\/RELEASE#", $line,$re)){
			$GLOBALS["APP_KAV4PROXY_VERSION"]= $re[1];
			break;
		}
		if(preg_match("#version\s+([0-9\.]+)#", $line,$re)){
			$GLOBALS["APP_KAV4PROXY_VERSION"]= $re[1];
			break;
		}
	}

	return $GLOBALS["APP_KAV4PROXY_VERSION"];
}

function APP_KAV4PROXY_PATTERN_DATE(){
	$base=APP_KAV4PROXY_PATTERN_PATH();
	if(!is_file($base)){return;}
	$f=explode("\n",@file_get_contents($base));
	$reg='#UpdateDate="([0-9]+)\s+([0-9]+)"#';

	foreach ($f as $num=>$ligne){
		if(preg_match($reg,$ligne,$re)){
			if(preg_match('#([0-9]{1,2})([0-9]{1,2})([0-9]{1,4});([0-9]{1,2})([0-9]{1,2})#',trim($re[1]).";".trim($re[2]),$regs)){
				return $regs[3]. "/" .$regs[2]. "/" .$regs[1] . " " . $regs[4] . ":" . $regs[5];
			}
		}
	}

}
function APP_KAV4PROXY_PATTERN_PATH(){
	$unix=new unix();
	$Kav4ProxyDatabasePath=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("Kav4ProxyDatabasePath"));
	if($Kav4ProxyDatabasePath==null){$Kav4ProxyDatabasePath="/home/artica/squid/kav4proxy/bases";}



	$XMLS["master.xml"]=true;
	$XMLS["u0607g.xml"]=true;
	$XMLS["upd-0607g.xml"]=true;
	$XMLS["masterv2.xml"]=true;
	$XMLS["av-i386-0607g.xml"]=true;
	$XMLS["kdb-i386-0607g.xml"]=true;
	$XMLS["kdb-i386-1211g.xml"]=true;
	$XMLS["kdb-i386-1211g.xml"]=true;

	foreach ($XMLS as $num=>$ligne){
		if(is_file("$Kav4ProxyDatabasePath/$num")){return "$Kav4ProxyDatabasePath/$num";}
	}

	return "$Kav4ProxyDatabasePath/master.xml";
}

function GEOIPUPDATE_VERSION(){
	if(isset($GLOBALS["GEOIPUPDATE_VERSION"])){return $GLOBALS["GEOIPUPDATE_VERSION"];}

	$geoipupdate=$GLOBALS["CLASS_UNIX"]->find_program("geoipupdate");

	exec("$geoipupdate -V 2>&1",$results);
	foreach ($results as $index=>$line){
		if(!preg_match("#geoipupdate\s+([0-9\.]+)#", $line,$re)){
			if($GLOBALS["VERBOSE"]){echo "VERSION NO MATCH: \"$line\"\n";}
			continue;}
		$GLOBALS["GEOIPUPDATE_VERSION"]=$re[1];
		return $GLOBALS["GEOIPUPDATE_VERSION"];

	}

}

function xIPTABLES_VERSION(){
	if(isset($GLOBALS["IPTABLES_VERSION"])){return $GLOBALS["IPTABLES_VERSION"];}
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("iptables");

	exec("$bin -V 2>&1",$results);
	foreach ($results as $num=>$line){
		$line=trim($line);
		if($line==null){continue;}
		if(!preg_match("#^iptables v([0-9\.]+)#i",$line,$re)){continue;}
		$GLOBALS["IPTABLES_VERSION"]=$re[1];
		return $GLOBALS["IPTABLES_VERSION"];
	}
}

function FIREHOL_VERSION(){
	if(isset($GLOBALS["FIREHOL_VERSION"])){return $GLOBALS["FIREHOL_VERSION"];}

	$link=@readlink("/usr/sbin/firehol");
	$path=dirname($link);
	$path=str_replace("../","/usr/",$path);
	if($GLOBALS["VERBOSE"]){echo "FIREHOL: path: $path\n";}

	if(is_file("$path/install.config")) {
		$results = explode("\n", @file_get_contents("$path/install.config"));
		foreach ($results as $num => $line) {
			$line = trim($line);
			if ($line == null) {
				continue;
			}
			if (!preg_match("#VERSION=.*?([0-9\.]+)#", $line, $re)) {
				if ($GLOBALS["VERBOSE"]) {
					echo "FIREHOL: NO MATCH $line;\n";
				}
				continue;
			}
			$GLOBALS["FIREHOL_VERSION"] = $re[1];
			return $GLOBALS["FIREHOL_VERSION"];
		}
	}
}


function WORDPRESS_SRC_VERSION(){
	if(isset($GLOBALS["WORDPRESS_SRC_VERSION"])){return $GLOBALS["WORDPRESS_SRC_VERSION"];}
	$f=explode("\n",@file_get_contents("/usr/share/wordpress-src/wp-includes/version.php"));
	foreach ($f as $num=>$line){
		$line=trim($line);
		if($line==null){continue;}
		if(!preg_match("#wp_version.*?([0-9\.]+)#i",$line,$re)){continue;}
		$GLOBALS["WORDPRESS_SRC_VERSION"]=$re[1];
		return $GLOBALS["WORDPRESS_SRC_VERSION"];
	}
	return "0.0.0";
}


function APP_DNSCRYPT_PROXY_VERSION(){
	if(isset($GLOBALS["APP_DNSCRYPT_PROXY_VERSION"])){return $GLOBALS["APP_DNSCRYPT_PROXY_VERSION"];}
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("dnscrypt-proxy");
	exec("$bin -version 2>&1",$results);
	foreach ($results as $num=>$line){
		$line=trim($line);
		if($line==null){continue;}
		if(!preg_match("#^([0-9\.]+)#i",$line,$re)){continue;}
		$GLOBALS["APP_DNSCRYPT_PROXY_VERSION"]=$re[1];
		return $GLOBALS["APP_DNSCRYPT_PROXY_VERSION"];
	}

	exec("$bin -V 2>&1",$results);
	foreach ($results as $line){
		if(preg_match("#dnscrypt-proxy\s+([0-9\.]+)#",$line,$re)){
			$GLOBALS["APP_DNSCRYPT_PROXY_VERSION"]=$re[1];
			return $GLOBALS["APP_DNSCRYPT_PROXY_VERSION"];
		}
	}

}
function APP_PADS_VERSION(){
	if(isset($GLOBALS["APP_PADS_VERSION"])){return $GLOBALS["APP_PADS_VERSION"];}
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("pads");
	exec("$bin -V 2>&1",$results);
	foreach ($results as $num=>$line){
		$line=trim($line);
		if($line==null){continue;}
		if(!preg_match("#^v([0-9\.]+)\s+-#i",$line,$re)){continue;}
		$GLOBALS["APP_PADS_VERSION"]=$re[1];
		return $GLOBALS["APP_PADS_VERSION"];
	}
	return null;
}

function APP_FILEBEAT_VERSION(){
	if(isset($GLOBALS["APP_FILEBEAT_VERSION"])){return $GLOBALS["APP_FILEBEAT_VERSION"];}
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("filebeat");
	exec("$bin version 2>&1",$results);
	foreach ($results as $num=>$line){
		$line=trim($line);
		if($line==null){continue;}
		if(!preg_match("#^filebeat version\s+([0-9\.]+)#i",$line,$re)){continue;}
		$GLOBALS["APP_FILEBEAT_VERSION"]=$re[1];
		return $GLOBALS["APP_FILEBEAT_VERSION"];
	}
	return null;
}
function APP_SSHPORTAL_VERSION(){
	if(isset($GLOBALS["APP_SSHPORTAL_VERSION"])){return $GLOBALS["APP_SSHPORTAL_VERSION"];}
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("sshportal");
	exec("$bin -v 2>&1",$results);
	foreach ($results as $num=>$line){
		$line=trim($line);
		if($line==null){continue;}
		if(!preg_match("#^version\s+([0-9\.]+)#i",$line,$re)){continue;}
		$GLOBALS["APP_SSHPORTAL_VERSION"]=$re[1];
		return $GLOBALS["APP_SSHPORTAL_VERSION"];
	}
	return null;
}

function APP_SLAPD_VERSION(){
	if(isset($GLOBALS["APP_SLAPD_VERSION"])){return $GLOBALS["APP_SLAPD_VERSION"];}
	$dpkg=$GLOBALS["CLASS_UNIX"]->find_program("dpkg");
	$grep=$GLOBALS["CLASS_UNIX"]->find_program("grep");
	exec("$dpkg -l|$grep slapd 2>&1",$results);
	foreach ($results as $num=>$line){
		$line=trim($line);
		if($line==null){continue;}
		if(!preg_match("#^([a-z]+)\s+slapd\s+([0-9\.]+).*?amd64#i",$line,$re)){continue;}
		$GLOBALS["APP_SLAPD_VERSION"]=$re[2];
		return $GLOBALS["APP_SLAPD_VERSION"];
	}
	return null;
}
function APP_ZABBIX_AGENT_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("zabbix_agentd");
	exec("$bin -V 2>&1",$results);
	foreach ($results as $num=>$line){
		$line=trim($line);
		if($line==null){continue;}
		if(!preg_match("#^zabbix_agentd.*?([0-9\.]+)#i",$line,$re)){continue;}
		$GLOBALS[__FUNCTION__]=$re[1];
		return $GLOBALS[__FUNCTION__];
	}
	return null;

}

function APP_REDSOCKS_VERSION(){
	if(isset($GLOBALS["APP_REDSOCKS_VERSION"])){return $GLOBALS["APP_REDSOCKS_VERSION"];}
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("redsocks");
	exec("$bin -v 2>&1",$results);
	foreach ($results as $num=>$line){
		$line=trim($line);
		if($line==null){continue;}
		if(!preg_match("#^redsocks/([0-9\.]+)#i",$line,$re)){continue;}
		$GLOBALS["APP_REDSOCKS_VERSION"]=$re[1];
		return $GLOBALS["APP_REDSOCKS_VERSION"];
	}
	return null;
	
}

function WP_CLIENT_VERSION(){
	if(isset($GLOBALS["WP_CLIENT_VERSION"])){return $GLOBALS["WP_CLIENT_VERSION"];}
	$bin="/usr/sbin/wp-cli.phar";
	if($GLOBALS["VERBOSE"]){echo "WP_CLIENT_VERSION:$bin\n";}
	exec("$bin --allow-root --version 2>&1",$results);
	foreach ($results as $num=>$line){
		$line=trim($line);
		if($line==null){continue;}
		if(!preg_match("#^WP-CLI.*?\s+([0-9\.]+)#i",$line,$re)){
			if($GLOBALS["VERBOSE"]){echo "WP_CLIENT_VERSION:$line NO MATCH\n";}
			continue;}
		$GLOBALS["WP_CLIENT_VERSION"]=$re[1];
		return $GLOBALS["WP_CLIENT_VERSION"];
	}
	return null;
	
}

function APP_3PROXY_VERSION(){
	if(isset($GLOBALS["APP_3PROXY_VERSION"])){return $GLOBALS["APP_3PROXY_VERSION"];}
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("3proxy");
	exec("$bin -h 2>&1",$results);
	foreach ($results as $num=>$line){
		$line=trim($line);
		if($line==null){continue;}
		if(!preg_match("#proxy server 3proxy-([0-9\.]+)#i",$line,$re)){continue;}
		$version=$re[1];
		$versionS=explode(".",$version);
		if(count($versionS)<3){$versionS[]=0;}
		$GLOBALS["APP_3PROXY_VERSION"]=@implode(".", $versionS);
		return $GLOBALS["APP_3PROXY_VERSION"];
	}
	return null;
	
}


function APP_MULTIPATH_TCP_VERSION(){
	if(isset($GLOBALS["APP_MULTIPATH_TCP_VERSION"])){return $GLOBALS["APP_MULTIPATH_TCP_VERSION"];}
	$dmesg=$GLOBALS["CLASS_UNIX"]->find_program("dmesg");
	$grep=$GLOBALS["CLASS_UNIX"]->find_program("grep");
	
	$cmdline="$dmesg|$grep MPTCP 2>&1";
	if($GLOBALS["VERBOSE"]){echo "APP_MULTIPATH_TCP_VERSION ---> $cmdline\n";}
	exec($cmdline,$line);
	
	if($GLOBALS["VERBOSE"]){echo "APP_MULTIPATH_TCP_VERSION ---> (".count($line)." lines)\n";}
	foreach ($line as $ll){
		if($GLOBALS["VERBOSE"]){echo "APP_MULTIPATH_TCP_VERSION ---> ** ** $ll ** **\n";}
		if(preg_match("#MPTCP.*?v([0-9\.]+)#", $ll,$re)){
			$GLOBALS["APP_MULTIPATH_TCP_VERSION"]=$re[1];
			return $GLOBALS["APP_MULTIPATH_TCP_VERSION"];
		}
	}
	
	$GLOBALS["APP_MULTIPATH_TCP_VERSION"]="0.94";
	return $GLOBALS["APP_MULTIPATH_TCP_VERSION"];
}
function APP_XTABLES_ADDON_VERSION(){
	if(isset($GLOBALS["APP_XTABLES_ADDON_VERSION"])){return $GLOBALS["APP_XTABLES_ADDON_VERSION"];}
	$f=explode("\n",@file_get_contents("/usr/local/share/man/man8/xtables-addons.8"));
	if($GLOBALS["VERBOSE"]){echo "APP_XTABLES_ADDON_VERSION: ".count($f)." lines\n";}

	foreach ($f as $line){
		if(!preg_match("#\.TH xtables-addons.*?v([0-9\.]+)\s+\(#",$line,$re)){
			if($GLOBALS["VERBOSE"]){echo "APP_XTABLES_ADDON_VERSION: NOMATCH $line\n";}
			continue;}
		if($GLOBALS["VERBOSE"]){echo "APP_XTABLES_ADDON_VERSION: Matches {$re[1]}\n";}
		$GLOBALS["APP_XTABLES_ADDON_VERSION"]=$re[1];
		return $GLOBALS["APP_XTABLES_ADDON_VERSION"];
	}
	return null;
}

function APP_LETSENCRYPT_VERSION(){
	if(isset($GLOBALS["APP_LETSENCRYPT_VERSION"])){return $GLOBALS["APP_LETSENCRYPT_VERSION"];}
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("certbot");
	if($GLOBALS["VERBOSE"]){echo "APP_LETSENCRYPT_VERSION: $bin --version\n";}
	exec("$bin --version 2>&1",$results);
	foreach ($results as $num=>$line){
		$line=trim($line);
		if($line==null){continue;}
		if(!preg_match("#^certbot\s+([0-9\.]+)#",$line,$re)){
			if($GLOBALS["VERBOSE"]){echo "APP_LETSENCRYPT_VERSION: $line == NO MATCH\n";}
			continue;}
		if($GLOBALS["VERBOSE"]){echo "letsencrypt version {$re[1]}\n";}
		$GLOBALS["APP_LETSENCRYPT_VERSION"]=$re[1];
		return $GLOBALS["APP_LETSENCRYPT_VERSION"];
	}
	return null;
}


function APP_MILTER_GREYLIST_VERSION(){
	if(isset($GLOBALS["APP_MILTER_GREYLIST_VERSION"])){return $GLOBALS["APP_MILTER_GREYLIST_VERSION"];}
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("milter-greylist");
	exec("$bin -r 2>&1",$results);
	foreach ($results as $num=>$line){
		$line=trim($line);
		if($line==null){continue;}
		if(!preg_match("#^milter-greylist-([0-9a-z\.]+)#",$line,$re)){continue;}
		$GLOBALS["APP_MILTER_GREYLIST_VERSION"]=$re[1];
		return $GLOBALS["APP_MILTER_GREYLIST_VERSION"];
	}
	return null;
}

function APP_MYSQL_VERSION(){
	return $GLOBALS["CLASS_UNIX"]->MYSQL_VERSION();
}






function APP_GREENSQL_VERSION(){
	if(isset($GLOBALS["APP_GREENSQL_VERSION"])){return $GLOBALS["APP_GREENSQL_VERSION"];}
	$f=explode("\n", @file_get_contents("/usr/share/greensql-console/config.php"));
	foreach ($f as $num=>$ligne){
		if(preg_match("#\$version.+?\"([0-9\.]+)\"#", $ligne,$re)){
			$GLOBALS["APP_GREENSQL_VERSION"]=$re[1];
			return $re[1];
		}else{
			if($GLOBALS["VERBOSE"]){echo "\"$ligne\" ->NO MATCH\n";}
		}
	}
}

function APP_RDPPROXY_VERSION(){
	if(isset($GLOBALS["APP_RDPPROXY_VERSION"])){return $GLOBALS["APP_RDPPROXY_VERSION"];}
	$bin="/usr/local/bin/rdpproxy";
	if(!is_file($bin)){return 0;}

	exec("$bin --version 2>&1",$array);
	foreach ($array as $pid=>$line){
		if(preg_match("#ReDemPtion\s+([0-9\.\-]+)#i", $line,$re)){
			$GLOBALS["APP_RDPPROXY_VERSION"]=$re[1];
			if($GLOBALS['VERBOSE']){echo "APP_RDPPROXY_VERSION(), Success!!! {$GLOBALS["APP_RDPPROXY_VERSION"]}\n";}
			return $GLOBALS["APP_RDPPROXY_VERSION"];}

		if($GLOBALS['VERBOSE']){echo "APP_RDPPROXY_VERSION(), $line, not found \n";}
	}

}

function APP_MEMCACHED_VERSION(){
	if(isset($GLOBALS["APP_MEMCACHED_VERSION"])){return $GLOBALS["APP_MEMCACHED_VERSION"];}
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("memcached");
	if(!is_file($bin)){return 0;}
	
	exec("$bin -V 2>&1",$array);
	foreach ($array as $pid=>$line){
		if(preg_match("#memcached\s+([0-9\.\-]+)#i", $line,$re)){
			$GLOBALS["APP_MEMCACHED_VERSION"]=$re[1];
			if($GLOBALS['VERBOSE']){echo "APP_MEMCACHED_VERSION(), Success!!! {$GLOBALS["APP_MEMCACHED_VERSION"]}\n";}
			return $GLOBALS["APP_MEMCACHED_VERSION"];}
				
			if($GLOBALS['VERBOSE']){echo "APP_MEMCACHED_VERSION(), $line, not found \n";}
	}
}

function APP_NGINX_VERSION(){
	if(isset($GLOBALS["APP_NGINX_VERSION"])){return $GLOBALS["APP_NGINX_VERSION"];}
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("nginx");
	if(!is_file($bin)){return 0;}

	exec("$bin -v 2>&1",$array);
	foreach ($array as $pid=>$line){
		if(preg_match("#\/([0-9\.\-]+)#i", $line,$re)){
			$GLOBALS["APP_NGINX_VERSION"]=$re[1];
			if($GLOBALS['VERBOSE']){echo "APP_NGINX_VERSION(), Success!!! {$GLOBALS["APP_NGINX_VERSION"]}\n";}
			return $GLOBALS["APP_NGINX_VERSION"];}
			
		if($GLOBALS['VERBOSE']){echo "APP_NGINX_VERSION(), $line, not found \n";}
	}

}

function APP_RBLDNSD_VERSION(){
	if(isset($GLOBALS["APP_RBLDNSD_VERSION"])){return $GLOBALS["APP_RBLDNSD_VERSION"];}
	$MasterBin=$GLOBALS["CLASS_UNIX"]->find_program("rbldnsd");
	exec("$MasterBin -h 2>&1",$string);
	foreach ($string as $line){
		if(!preg_match("#version\s+([0-9\.]+)#",$line,$re)){
			if($GLOBALS["VERBOSE"]){echo "APP_RBLDNSD_VERSION: no match \"$line\"\n";}
			continue;
		}
		if($GLOBALS["VERBOSE"]){echo "APP_RBLDNSD_VERSION: FOUND {$re[1]}\n";}
		$GLOBALS["APP_RBLDNSD_VERSION"]=$re[1];
		return $re[1];
	}	
	
}
function APP_UFDBCAT_VERSION(){
	if(isset($GLOBALS["APP_UFDBCAT_VERSION"])){return $GLOBALS["APP_UFDBCAT_VERSION"];}
	$MasterBin="/usr/share/artica-postfix/bin/install/rbldnsd";
	chmod($MasterBin,0755);
	exec("$MasterBin -h 2>&1",$string);
	foreach ($string as $line){
		if(!preg_match("#version\s+([0-9\.]+)#",$line,$re)){
			if($GLOBALS["VERBOSE"]){echo "APP_UFDBCAT_VERSION: no match \"$line\"\n";}
			continue;
		}
		if($GLOBALS["VERBOSE"]){echo "APP_UFDBCAT_VERSION: FOUND {$re[1]}\n";}
		$GLOBALS["APP_UFDBCAT_VERSION"]=$re[1];
		return $re[1];
	}

}

function mimedefang_version(){
	if(isset($GLOBALS["mimedefang_version"])){return $GLOBALS["mimedefang_version"];}
	$MasterBin=$GLOBALS["CLASS_UNIX"]->find_program("rbldnsd");
	$string=exec("$MasterBin -h 2>&1");
	if(preg_match("#version\s+([0-9\.]+)#",$string,$re)){
		$GLOBALS["mimedefang_version"]=$re[1];
		return $re[1];
	}

}

function SNMPD_VERSION(){
	if(isset($GLOBALS["SNMPD_VERSION"])){return $GLOBALS["SNMPD_VERSION"];}
	$snmpd=$GLOBALS["CLASS_UNIX"]->find_program("snmpd");
	exec("$snmpd -v 2>&1",$results);
	foreach ($results as $i=>$line){
		if(preg_match("#NET-SNMP version:\s+([0-9\.]+)#i", $line,$re)){
			$GLOBALS["SNMPD_VERSION"]=$re[1];
			return $re[1];
		}
	}
}

function KLNAGENT_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	
	$f=explode("\n",@file_get_contents("/opt/kaspersky/klnagent64/lib/bin/setup/appdata.pm"));
	foreach ($f as $line){
		if($line==null){continue;}
		if(preg_match("#^VER=([0-9\.]+)#", $line,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			return $GLOBALS[__FUNCTION__];
		}
		
	}
}

function APP_CYRUS_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$binary=$GLOBALS["CLASS_UNIX"]->LOCATE_CYRUS_DELIVER_BIN_PATH();
	exec("$binary 2>&1",$results);
	foreach ($results as $num=>$ligne){
		if(preg_match("#421 4\.3\.0\s+([0-9\.]+)#", $ligne,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Found '{$re[1]}'\n";}
			return $re[1];
		}
	}
	$GLOBALS[__FUNCTION__]=null;
	
}

function dhcpd_version() {
	if(isset($GLOBALS["DHCPD_VERSION"])){return $GLOBALS["DHCPD_VERSION"];}
	$dhcpd_server=$GLOBALS["CLASS_UNIX"]->find_program("dhcpd");
	if(!is_file($dhcpd_server)){return;}
	exec("$dhcpd_server --version 2>&1",$results);
	$sock=new sockets();
	foreach ($results as $num=>$ligne){
		$ligne=trim($ligne);
		if($ligne==null){continue;}
		if(preg_match("#DHCP Server\s+([0-9\.])#", $ligne,$re)){
			$version=$re[1];
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("DHCPDVersion", $version);
			$GLOBALS["DHCPD_VERSION"]=$re[1];
			return $GLOBALS["DHCPD_VERSION"];
		}
		
		if(preg_match("#^isc-dhcpd-(.+)#", $ligne,$re)){
			$version=trim($re[1]);
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("DHCPDVersion", $version);
			$GLOBALS["DHCPD_VERSION"]=$re[1];
			return $GLOBALS["DHCPD_VERSION"];			
		}
	
	}
	
}
function FILEBEAT_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$program=$GLOBALS["CLASS_UNIX"]->find_program("filebeat");
	exec("$program version 2>&1",$results);
	foreach ($results as $index=>$line){
		if(preg_match("#filebeat version\s+([0-9\.]+)#i", $line,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Found '{$re[1]}'\n";}
			return $re[1];
		}
	
	
		if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Not Found '$line'\n";}
	}
	
}
function FRONTAIL_LINUX_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$program=$GLOBALS["CLASS_UNIX"]->find_program("frontail-linux");
	exec("$program --version 2>&1",$results);
	foreach ($results as $index=>$line){
		if(preg_match("#([0-9\.]+)#i", $line,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Found '{$re[1]}'\n";}
			return $re[1];
		}
	
	
		if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Not Found '$line'\n";}
	}
}

function APP_SQUIDANALYZER_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$program=$GLOBALS["CLASS_UNIX"]->find_program("squid-analyzer");
	exec("$program -v 2>&1",$results);
	foreach ($results as $index=>$line){
		if(preg_match("#version\s+([0-9\.]+)#i", $line,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Found '{$re[1]}'\n";}
			return $re[1];
		}


		if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Not Found '$line'\n";}
	}

}



function MSMTP_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$pdns=$GLOBALS["CLASS_UNIX"]->find_program("msmtp");
	exec("$pdns --version 2>&1",$results);
	foreach ($results as $index=>$line){
		if(preg_match("#msmtp version\s+([0-9\.]+)#i", $line,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Found '{$re[1]}'\n";}
			return $re[1];
		}
		if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Not Found '$line'\n";}
	}
}
	
function GLANCES_VERSION(){
		if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
		$pdns=$GLOBALS["CLASS_UNIX"]->find_program("glances");
		exec("$pdns --version 2>&1",$results);
		foreach ($results as $index=>$line){
			if(preg_match("#Glances\s+v([0-9\.]+)#i", $line,$re)){
				$GLOBALS[__FUNCTION__]=$re[1];
				if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Found '{$re[1]}'\n";}
				return $re[1];
			}
			if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Not Found '$line'\n";}
		}
}
function APP_SHELLINABOX_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$pdns=$GLOBALS["CLASS_UNIX"]->find_program("shellinaboxd");
	exec("$pdns --version 2>&1",$results);
	foreach ($results as $index=>$line){
		if(preg_match("#ShellInABox version\s+([0-9\.]+)#i", $line,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Found '{$re[1]}'\n";}
			return $re[1];
		}
		if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Not Found '$line'\n";}
	}
}

function APP_DNSDIST_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$dnsdist=$GLOBALS["CLASS_UNIX"]->find_program("dnsdist");
	exec("$dnsdist --version 2>&1",$results);
	foreach ($results as $index=>$line){
		if(preg_match("#^(dnsdist)\s+([0-9\.]+)#", trim($line),$re)){
			$GLOBALS[__FUNCTION__]=$re[2];
			if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Found '{$re[2]}'\n";}
			return $re[2];
		}
		if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Not Found '$line'\n";}
	}

}

function APP_PDNS_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$pdns=$GLOBALS["CLASS_UNIX"]->find_program("pdns_server");
	exec("$pdns --version 2>&1",$results);
	foreach ($results as $index=>$line){
		if(preg_match("#(Version:|PowerDNS Authoritative Server)\s+([0-9\.]+)#", $line,$re)){
			$GLOBALS[__FUNCTION__]=$re[2];
			if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Found '{$re[2]}'\n";}
			return $re[2];
		}
		if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Not Found '$line'\n";}
	}
}

function APP_PDNS_RECURSOR_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$pdns_recursor=$GLOBALS["CLASS_UNIX"]->find_program("pdns_recursor");
	exec("$pdns_recursor --version 2>&1",$results);
	foreach ($results as $index=>$line){
		if(preg_match("#(version:|PowerDNS Recursor)\s+([0-9\.]+)#i", @implode("", $results),$re)){
			$GLOBALS[__FUNCTION__]=$re[2]; 
			if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Found '{$re[2]}'\n";}
			return $GLOBALS[__FUNCTION__];
		}
		
		if(preg_match("#error while loading shared libraries: libboost_context\.so#", $line)){
			$TimeFile="/etc/artica-postfix/pids/libboost_context.time";
			$TimeExec=$GLOBALS["CLASS_UNIX"]->file_time_min($TimeFile);
			if($TimeExec>20){
				$GLOBALS["CLASS_UNIX"]->DEBIAN_INSTALL_PACKAGE("libboost-context1.62.0");
				@unlink($TimeFile);
				@file_put_contents($TimeFile, time());
			}
		}
		
		if(preg_match("#error while loading shared libraries: liblua5\.3\.so#", $line)){
			$TimeFile="/etc/artica-postfix/pids/liblua53.time";
			$TimeExec=$GLOBALS["CLASS_UNIX"]->file_time_min($TimeFile);
			if($TimeExec>20){
				$GLOBALS["CLASS_UNIX"]->DEBIAN_INSTALL_PACKAGE("liblua5.3-0");
				@unlink($TimeFile);
				@file_put_contents($TimeFile, time());
			}
		}
		if($GLOBALS["VERBOSE"]){echo "[".__FUNCTION__."]: Not Found '$line'\n";}
	}
return null;}

function APP_OPENVPN_VERSION(){
	$unix=new unix();
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$bin_path=$unix->find_program("openvpn");
	exec("$bin_path --version 2>&1",$results);

	foreach ($results as $index=>$line) {
		if (preg_match("#OpenVPN\s+([0-9]+)\.([0-9]+)([a-z0-9\_\-\.]+)\s+#", $line, $re)) {
			$GLOBALS[__FUNCTION__] = $re[1] . ".{$re[2]}{$re[3]}";
			return $GLOBALS[__FUNCTION__];
		}
	}return null;}

function APP_PRIVOXY_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$masterbin=$GLOBALS["CLASS_UNIX"]->find_program("privoxy");
	exec("$masterbin --version 2>&1",$results);
	foreach ($results as $line){
		if(!preg_match("#version\s+([0-9\.]+)#", $line,$re)){continue;}
		$GLOBALS[__FUNCTION__]=$re[1];
	}
	return $GLOBALS[__FUNCTION__];
	return null;}
function APP_SYSLOGD_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$masterbin=$GLOBALS["CLASS_UNIX"]->find_program("rsyslogd");
	exec("$masterbin -v 2>&1",$results);
	foreach ($results as $line){
		if(!preg_match("#rsyslogd\s+([0-9\.]+)#", $line,$re)){continue;}
		$GLOBALS[__FUNCTION__]=$re[1];
	}
	return $GLOBALS[__FUNCTION__];
	return null;}

function MUNIN_NODE_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$filename="/usr/sbin/munin-node";
	$f=explode("\n",@file_get_contents($filename));
	foreach ($f as $ligne){
		$ligne=trim($ligne);
		if($ligne==null){continue;}
		if($GLOBALS["VERBOSE"]){echo "MUNIN_NODE_VERSION(): $ligne\n";}
		if(preg_match("#munin-node v([0-9\.\-]+)#", $ligne,$re)){
			if($GLOBALS["VERBOSE"]){echo "MUNIN_NODE_VERSION(): OK $ligne -> {$re[1]}\n";}
			$GLOBALS[__FUNCTION__]=$re[1];
			return $re[1];
		}
	}
	return null;}
function POSTGRESQL_VERSION(){

	if(isset($GLOBALS["postgres_version"])){return $GLOBALS["postgres_version"];}
	exec("/usr/local/ArticaStats/bin/postgres -V 2>&1",$results);
	foreach ($results as $key=>$value){
		if(preg_match("#([0-9\.]+)#", $value,$re)){
			$GLOBALS["postgres_version"]=$re[1];
			return $GLOBALS["postgres_version"];
		}
	}
	return null;}

function SEAFILE_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$filename="/usr/share/seafile-server/seahub/seahub/settings.py";
	$f=explode("\n",@file_get_contents($filename));
	foreach ($f as $ligne){
		$ligne=trim($ligne);
		if($ligne==null){continue;}
		if(preg_match("#SEAFILE_VERSION.*?([0-9\.\-]+)#", $ligne,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			return $re[1];
		}
	}

	return null;}

function PEAR_PACKAGES(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$masterbin=$GLOBALS["CLASS_UNIX"]->find_program("pear");
	exec("$masterbin list 2>&1",$results);
	foreach ($results as $line){
		if(!preg_match("#(.+?)\s+[0-9\.]+\s+[a-zA-Z]+#", $line,$re)){continue;}
		$MODULES[]=$re[1];
	}
	$GLOBALS[__FUNCTION__]=@implode(";", $MODULES);
	return $GLOBALS[__FUNCTION__];
	return null;}
function IWCONFIG_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$masterbin=$GLOBALS["CLASS_UNIX"]->find_program("iwconfig");
	if(!is_file($masterbin)){return "0.0.0";}
	exec("$masterbin --version 2>&1",$results);
	foreach ($results as $ligne){
		$ligne=trim($ligne);
		if($ligne==null){continue;}
		if(!preg_match("#iwconfig.+?([0-9\.]+)#", $ligne,$re)){if($GLOBALS["VERBOSE"]){echo "IWCONFIG_VERSION():: FAILED {$ligne}\n";}continue;}
		$GLOBALS[__FUNCTION__]=trim($re[1]);
		if($GLOBALS["VERBOSE"]){echo "IWCONFIG_VERSION():: SUCCESS {$re[1]}\n";}
		return $GLOBALS[__FUNCTION__];
	}
	return null;}
function FREERADIUS_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$masterbin=$GLOBALS["CLASS_UNIX"]->find_program("freeradius");
	if(!is_file($masterbin)){return "0.0.0";}
	exec("$masterbin -v 2>&1",$results);
	foreach ($results as $ligne){
		$ligne=trim($ligne);
		if($ligne==null){continue;}
		if(!preg_match("#Version\s+([0-9\.]+)#", $ligne,$re)){if($GLOBALS["VERBOSE"]){echo "FREERADIUS_VERSION():: FAILED {$ligne}\n";}continue;}
		$GLOBALS[__FUNCTION__]=trim($re[1]);
		if($GLOBALS["VERBOSE"]){echo "FREERADIUS_VERSION():: SUCCESS {$re[1]}\n";}
		return $GLOBALS[__FUNCTION__];
	}
	return null;}
function ZIPROXY_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$masterbin=$GLOBALS["CLASS_UNIX"]->find_program("ziproxy");
	if(!is_file($masterbin)){return "0.0.0";}
	exec("$masterbin -h 2>&1",$results);
	foreach ($results as $ligne){
		$ligne=trim($ligne);
		if($ligne==null){continue;}
		if(!preg_match("#Ziproxy\s+([0-9\.]+)#", $ligne,$re)){if($GLOBALS["VERBOSE"]){echo "ZIPROXY_VERSION():: FAILED {$ligne}\n";}continue;}
		$GLOBALS[__FUNCTION__]=trim($re[1]);
		if($GLOBALS["VERBOSE"]){echo "ZIPROXY_VERSION():: SUCCESS {$re[1]}\n";}
		return $GLOBALS[__FUNCTION__];
	}

	return null;}


function TC_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$masterbin=$GLOBALS["CLASS_UNIX"]->find_program("tc");
	if(!is_file($masterbin)){return "0.0.0";}
	exec("$masterbin -V 2>&1",$results);
	foreach ($results as $ligne){
		$ligne=trim($ligne);
		if($ligne==null){continue;}
		if(!preg_match("#iproute2-([a-z0-9\.]+)#", $ligne,$re)){if($GLOBALS["VERBOSE"]){echo "TC_VERSION():: FAILED {$ligne}\n";}continue;}
		$GLOBALS[__FUNCTION__]=trim($re[1]);
		if($GLOBALS["VERBOSE"]){echo "TC_VERSION():: SUCCESS {$re[1]}\n";}
		return $GLOBALS[__FUNCTION__];
	}
	return null;}

function curlftpfs_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$masterbin=$GLOBALS["CLASS_UNIX"]->find_program("curlftpfs");
	if(!is_file($masterbin)){return "0.0.0";}
	exec("$masterbin --version 2>&1",$results);
	foreach ($results as $num=>$val){
		if($GLOBALS["VERBOSE"]){echo "curlftpfs_version(): $val\n";}
		if(preg_match("#curlftpfs\s+([0-9\.\-]+)#", $val,$re)){
			$GLOBALS[__FUNCTION__]=trim($re[1]);
			if($GLOBALS["VERBOSE"]){echo "curlftpfs_version(): ----> '{$GLOBALS[__FUNCTION__]}'\n";}
			return $GLOBALS[__FUNCTION__];
		}
	}
	return null;}

function kibana_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$filename="/usr/share/kibana/package.json";
	$f=explode("\n",@file_get_contents($filename));
	foreach ($f as $ligne){
		$ligne=trim($ligne);
		if($ligne==null){continue;}
		if(preg_match("#version\":.*?([0-9\.\-]+)\"#", $ligne,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			return $re[1];
		}
	}

	return null;}
function vnstat_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$masterbin=$GLOBALS["CLASS_UNIX"]->find_program("vnstatd");
	if(!is_file($masterbin)){return "0.0.0";}
	exec("$masterbin --version 2>&1",$results);
	foreach ($results as $num=>$val){
		if($GLOBALS["VERBOSE"]){echo "vnstat_version(): $val\n";}
		if(preg_match("#daemon\s+([0-9\.\-]+)#", $val,$re)){
			$GLOBALS[__FUNCTION__]=trim($re[1]);
			if($GLOBALS["VERBOSE"]){echo "vnstat_version(): ----> '{$GLOBALS[__FUNCTION__]}'\n";}
			return $GLOBALS[__FUNCTION__];
		}
	
		
	}
	return null;}


function ntopng_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$masterbin=$GLOBALS["CLASS_UNIX"]->find_program("ntopng");
	if(!is_file($masterbin)){return "0.0.0";}
	exec("$masterbin --version 2>&1",$results);
	foreach ($results as $num=>$val){
		if($GLOBALS["VERBOSE"]){echo "ntopng_version(): $val\n";}
		if(preg_match("#ntopng.*?v\.([0-9\.]+)#", $val,$re)){
			$GLOBALS[__FUNCTION__]=trim($re[1]);
			return $GLOBALS[__FUNCTION__];
		}

		if(preg_match("#v\.([0-9\.]+)\s+\[Community#", $val,$re)){
			$GLOBALS[__FUNCTION__]=trim($re[1]);
			if($GLOBALS["VERBOSE"]){echo "ntopng_version():: SUCCESS {$re[1]}\n";}
			return $GLOBALS[__FUNCTION__];
		}
		
		if(preg_match("#v\.([0-9\.]+)\s+\[Enterprise\/Professional#", $val,$re)){
			$GLOBALS[__FUNCTION__]=trim($re[1]);
			if($GLOBALS["VERBOSE"]){echo "ntopng_version():: SUCCESS {$re[1]}\n";}
			return $GLOBALS[__FUNCTION__];
		}
	}
	return null;}

function fping_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$masterbin=$GLOBALS["CLASS_UNIX"]->find_program("fping");
	if(!is_file($masterbin)){return "0.0.0";}
	exec("$masterbin -v 2>&1",$results);
	foreach ($results as $ligne){
		$ligne=trim($ligne);
		if($ligne==null){continue;}
		if(!preg_match("#Version\s+([0-9\.]+)#", $ligne,$re)){if($GLOBALS["VERBOSE"]){echo "fping_version():: FAILED {$ligne}\n";}continue;}
		$GLOBALS[__FUNCTION__]=trim($re[1]);
		if($GLOBALS["VERBOSE"]){echo "fping_version():: SUCCESS {$re[1]}\n";}
		return $GLOBALS[__FUNCTION__];
	}
	return null;}

function proftpd_version($Masterbin){
	exec("$Masterbin -v 2>&1",$results);
	foreach ($results as $num=>$val){
		if(preg_match("#ProFTPD Version\s+([0-9\.]+)#", $val,$re)){
			$GLOBALS["proftpd_version"]=trim($re[1]);
			return $GLOBALS["proftpd_version"];
		}
	}
	return null;}

function elasticsearch_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$filename="/usr/share/elasticsearch/modules/reindex/plugin-descriptor.properties";
	$f=explode("\n",@file_get_contents($filename));
	foreach ($f as $ligne){
		$ligne=trim($ligne);
		if($ligne==null){continue;}
		if(preg_match("#^version=([0-9\.]+)#", $ligne,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			return $re[1];
		}
	}
	return null;}

function logstash_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$f=explode("\n",@file_get_contents("/usr/share/logstash/logstash-core/versions-gem-copy.yml"));
	foreach ($f as $ligne){
		$ligne=trim($ligne);
		if($ligne==null){continue;}
		if(preg_match("#logstash:\s+([0-9\.]+)#", $ligne,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			return $re[1];
		}
	}
	return null;}

function java_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$bin_path=$GLOBALS["CLASS_UNIX"]->find_program("java");
	exec("$bin_path -version 2>&1",$results);
	foreach ($results as $ligne){
		$ligne=trim($ligne);
		if($ligne==null){continue;}
		if(preg_match("#openjdk version.*?([0-9\.\_]+)#", $ligne,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			return $re[1];
		}
	}
	return null;}

function redis_version(){
	if(isset($GLOBALS["redis_version"])){return $GLOBALS["redis_version"];}
	$masterbin=$GLOBALS["CLASS_UNIX"]->find_program("redis-server");
	if(!is_file($masterbin)){return "0.0.0";}
	exec("$masterbin -v 2>&1",$results);
	foreach ($results as $num=>$val){
		if($GLOBALS["VERBOSE"]){echo "redis_version(): $val\n";}
		
		if(preg_match("#Redis server v=([0-9\.]+)#i", $val,$re)){
			$GLOBALS["redis_version"]=trim($re[1]);
			if($GLOBALS["VERBOSE"]){echo "redis_version():: SUCCESS -> {$re[1]}/{$GLOBALS["redis_version"]}\n";}
			return $GLOBALS["redis_version"];
		}
		
		if(!preg_match("#Redis server version\s+([0-9\.]+)#i", $val,$re)){
			if($GLOBALS["VERBOSE"]){echo "redis_version():: $val -> FALSE\n";}
			continue;
		}
		$GLOBALS["redis_version"]=trim($re[1]);
		return $GLOBALS["redis_version"];
	}
	return null;}
function oinkmaster_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$bin_path=$GLOBALS["CLASS_UNIX"]->find_program("oinkmaster");
	exec("$bin_path -V 2>&1",$results);
	foreach ($results as $num=>$ligne){
		if(preg_match("#Oinkmaster\s+v([0-9\.a-z]+),#i", $ligne,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			return $re[1];
		}
	}
	return null;}
function fireqos_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$bin_path=$GLOBALS["CLASS_UNIX"]->find_program("fireqos");
	exec("$bin_path --help 2>&1",$results);
	foreach ($results as $ligne){
		$ligne=trim($ligne);
		if($ligne==null){continue;}
		if(preg_match("#^FireQOS\s+([0-9\.]+)(,|$)#i", $ligne,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			if($GLOBALS["VERBOSE"]){echo "fireqos_version():: SUCCESS -> {$re[1]}\n";}
			return $re[1];
		}
		if($GLOBALS["VERBOSE"]){echo "fireqos_version():: '$ligne' -> FALSE\n";}
	}

	return null;}

function pdns_stats_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	exec("/usr/local/bin/dsc -v 2>&1",$results);
	foreach ($results as $index=>$line){
		if(preg_match("#dsc version ([0-9\.]+)#i", @implode("", $results),$re)){$GLOBALS[__FUNCTION__]=$re[1]; return $GLOBALS[__FUNCTION__];}

	}
	return null;}
function suricata_version(){
	$unix=new unix();
	if(isset($GLOBALS["suricata_version"])){return $GLOBALS["suricata_version"];}
	$squidbin=$unix->find_program("suricata");
	if(!is_file($squidbin)){return "0.0.0";}
	exec("$squidbin -V 2>&1",$results);
	foreach ($results as $num=>$val){
		if(preg_match("#Suricata\s+version\s+([0-9\.]+)#i", $val,$re)){
			$GLOBALS["suricata_version"]=trim($re[1]);
			return $GLOBALS["suricata_version"];
		}
	}
	return null;}
//========================================================================================================================================================
function fail2ban_version(){
	$function=__FUNCTION__;
	if(isset($GLOBALS["fail2ban_version"])){return $GLOBALS["fail2ban_version"];}
	$fail2ban=$GLOBALS["CLASS_UNIX"]->find_program("fail2ban-server");
	if(!is_file($fail2ban)){
		if($GLOBALS["VERBOSE"]){echo "$function: fail2ban-server, no such file...\n";}
		return "0.0.0";}

	exec("$fail2ban -V 2>&1",$results);

	foreach ($results as $md=>$line){
		if(preg_match("#(Fail2Ban v|)([0-9\.]+)#i", $line,$re)){
			$GLOBALS["fail2ban_version"]=$re[2];
			if($GLOBALS["VERBOSE"]){echo "$function: $line FOUND..\n";}
			return $re[2];
		}else{
			if($GLOBALS["VERBOSE"]){echo "$function: $line NOT FOUND..\n";}
		}

	}
	if($GLOBALS["VERBOSE"]){echo "$function: No version found.\n";}
	return "0.0.0";
	return null;}
//========================================================================================================================================================
function rsync_version(){
	$rsync=$GLOBALS["CLASS_UNIX"]->find_program("rsync");
	if(isset($GLOBALS["rsync-VER"])){return $GLOBALS["rsync-VER"];}
	exec("$rsync --version 2>&1",$results);

	foreach ($results as $num=>$val){
		if(!preg_match("#rsync\s+version\s+([0-9\.]+)#",$val,$re)){continue;}
		$GLOBALS["rsync-VER"]=$re[1];
		return $re[1];

	}

	return null;}
//========================================================================================================================================================
function SAMBA_VERSION(){
	if(isset($GLOBALS["SMBD-VER"])){return $GLOBALS["SMBD-VER"];}
	$smbd_bin=$GLOBALS["CLASS_UNIX"]->find_program("smbd");
	if($smbd_bin==null){return;}
	exec("$smbd_bin -V 2>&1",$results);
	foreach ($results as $num=>$val){
		if(preg_match("#Version\s+(.+)#", $val,$re)){
			$GLOBALS["SMBD-VER"]=$re[1];
			return $GLOBALS["SMBD-VER"];
		}
	}

	return null;}

function ufdbcatVersion(){
	if(isset($GLOBALS["ufdbcatVersion"])){return $GLOBALS["ufdbcatVersion"];}
	exec("/opt/ufdbcat/bin/ufdbcatdd -v 2>&1",$results);
	foreach ($results as $num=>$line){
		if(preg_match("#ufdbguardd.*?([0-9\.]+)#", $line,$re)){$GLOBALS["ufdbcatVersion"]= $re[1];return $GLOBALS["ufdbcatVersion"];}
	}
	return null;}
function haproxy_version($binpath=null){

	if(isset($GLOBALS["haproxy_version"])){return $GLOBALS["haproxy_version"];}
	if($GLOBALS["VERBOSE"]){echo "haproxy_version():: Checking $binpath\n";}
	if(!is_file($binpath)){return;}
	exec("$binpath -v 2>&1",$results);
	foreach ($results as $index=>$line){
		if($GLOBALS["VERBOSE"]){echo "haproxy_version():: Checking $line\n";}
		if(preg_match("#HA-Proxy version\s+([0-9\.\-a-z]+)\s+#", $line,$re)){$GLOBALS["haproxy_version"]=$re[1];break;}
	}
	
	if($GLOBALS["VERBOSE"]){echo "haproxy_version():: v{$GLOBALS["haproxy_version"]}\n";}
	return $GLOBALS["haproxy_version"];
	return null;}

function vmtools_version_text(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	if(is_file("/etc/vmware-tools/manifest.txt.shipped")){
		$f=file("/etc/vmware-tools/manifest.txt.shipped");
		foreach ($f as $i=>$line){
			if(preg_match("#guestd\.version.+?([0-9\.]+)#",$line,$re)){
				$GLOBALS[__FUNCTION__]=$re[1];
				return $GLOBALS[__FUNCTION__];
			}
		}
	}
	if(is_file("/usr/bin/vmware-toolbox-cmd")){
		exec("/usr/bin/vmware-toolbox-cmd -v 2>&1",$results);
		$GLOBALS[__FUNCTION__]=trim(@implode("", $results));
		if(preg_match("#(.+?)\s+#", $GLOBALS[__FUNCTION__],$re)){$GLOBALS[__FUNCTION__]=$re[1];}
		return $GLOBALS[__FUNCTION__];
	}

	return null;}


function c_icap_master_version(){
	if(isset($GLOBALS["c_icap_master_version"])){return $GLOBALS["c_icap_master_version"];}
	$cicapbin=$GLOBALS["CLASS_UNIX"]->find_program("c-icap-config");
	$GLOBALS["c_icap_master_version"]=trim(exec("$cicapbin --version"));
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CicapVersion", $GLOBALS["c_icap_master_version"]);
	return $GLOBALS["c_icap_master_version"];
}
function ntpd_version(){
	if(isset($GLOBALS["NTPDVERSION"])){return $GLOBALS["NTPDVERSION"];}
	$bin_path=$GLOBALS["CLASS_UNIX"]->find_program("ntpd");
	exec("$bin_path -v 2>&1",$results);
	foreach ($results as $num=>$ligne){
		if(preg_match("#Ver\.\s+([0-9\.a-z]+)#", $ligne,$re)){
			$GLOBALS["NTPDVERSION"]=$re[1];
			return $re[1];
		}
	}
	return null;}

function dbus_daemon_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("dbus-daemon");
	exec("$bin --version 2>&1",$results);
	foreach ($results as $num=>$line){
		if(preg_match("#Bus Daemon\s+([0-9\.]+)#", $line,$re)){$GLOBALS[__FUNCTION__]=$re[1];return $re[1];}
	}

	return null;}

function omega_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("omindex");
	if($GLOBALS["VERBOSE"]){echo "omega_version():: Binary: $bin\n";}
	exec("$bin -V 2>&1",$results);
	foreach ($results as $num=>$line){
		if($GLOBALS["VERBOSE"]){echo "omega_version():: Checking $line\n";}
		if(preg_match("#\s+([0-9\.]+)#i", $line,$re)){
			if($GLOBALS["VERBOSE"]){echo "omega_version():: Found {$re[1]}\n";}
			$GLOBALS[__FUNCTION__]=$re[1];
			return $re[1];
		}
	}
	return null;}

function monit_daemon_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("monit");
	if($GLOBALS["VERBOSE"]){echo "monit_daemon_version():: Monit binary: $bin\n";}
	exec("$bin -V 2>&1",$results);
	foreach ($results as $num=>$line){
		if($GLOBALS["VERBOSE"]){echo "monit_daemon_version():: Checking $line\n";}
		if(preg_match("#monit version\s+([0-9\.]+)#i", $line,$re)){
			if($GLOBALS["VERBOSE"]){echo "monit_daemon_version():: Found {$re[1]}\n";}
			$GLOBALS[__FUNCTION__]=$re[1];
			return $re[1];
		}
	}
	return null;}
//========================================================================================================================================================




function iscsi_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$iscsiadm=$GLOBALS["CLASS_UNIX"]->find_program("iscsiadm");
	exec("$iscsiadm -V 2>&1",$results);
	foreach ($results as $line){
		if($GLOBALS["VERBOSE"]){echo "iscsi_version: $line\n";}
		if(preg_match("#version\s+([0-9\.\-]+)#i", $line,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			return $GLOBALS[__FUNCTION__];
		}
	}

	return null;}

function WSUSOFFLINE_VERSION(){
	if(isset($GLOBALS["WSUSOFFLINE_VERSION"])){return $GLOBALS["WSUSOFFLINE_VERSION"];}
	$results=explode("\n",@file_get_contents("/usr/share/wsusoffline/sh/versions/installed-version.txt"));
	foreach ($results as $line){
		if(preg_match("#^([0-9\.]+)(.*?)\s+#", $line,$re)){
			$GLOBALS["WSUSOFFLINE_VERSION"]=$re[1].$re[2];
			return $GLOBALS["WSUSOFFLINE_VERSION"];
		}
	}

	return null;}

function APP_SPLUNK_FORWARDER_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$f=explode("\n",@file_get_contents("/opt/splunkforwarder/etc/splunk.version"));
	foreach ($f as $line){
		
		if(preg_match("#VERSION=([0-9\.]+)#", $line,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			return $GLOBALS[__FUNCTION__];
		}
	}
	return null;}

function __debian_version(){
	if(isset($GLOBALS["DEBIAN_VERSION"])){return $GLOBALS["DEBIAN_VERSION"];}
	if(!is_file("/etc/debian_version")){return 0;}
	$ver=trim(@file_get_contents("/etc/debian_version"));
	preg_match("#^([0-9]+)\.#",$ver,$re);
	if(preg_match("#squeeze\/sid#",$ver)){return 6;}
	$Major=$re[1];
	if(!is_numeric($Major)){return 0;}
	$GLOBALS["DEBIAN_VERSION"]=$Major;
	return $Major;

}
function _winbindd_version(){
	if(isset($GLOBALS["_winbindd_version"])){return $GLOBALS["_winbindd_version"];}
	$winbindd=$GLOBALS["CLASS_UNIX"]->find_program("winbindd");
	if(!is_file($winbindd)){return;}
	exec("$winbindd -V 2>&1",$results);
	if(preg_match("#Version\s+([0-9\.]+)#", @implode("", $results),$re)){
		$GLOBALS["_winbindd_version"]=$re[1];
		return $GLOBALS["_winbindd_version"];
	}
	return null;}

function nmap_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$binpath=$GLOBALS["CLASS_UNIX"]->find_program("nmap");
	exec("$binpath -V 2>&1",$results);
	foreach ($results as $ligne){
		if(preg_match("#Nmap version\s+([0-9\.]+)#i", $ligne,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			return $GLOBALS[__FUNCTION__];
		}
	}
	return null;}

function unbound_version(){
	if(isset($GLOBALS["unbound_version"])){return $GLOBALS["unbound_version"];}
	$Masterbin=$GLOBALS["CLASS_UNIX"]->find_program("unbound");
	exec("$Masterbin -h 2>&1",$results);
	foreach ($results as $line){
		if(preg_match("#Version\s+([0-9\.]+)#", $line,$re)){
			$GLOBALS["unbound_version"]=$re[1];
			return $GLOBALS["unbound_version"];
		}
	}
	return null;}
function netdata_version(){
	if(isset($GLOBALS["netdata_version"])){return $GLOBALS["netdata_version"];}
	$Masterbin=$GLOBALS["CLASS_UNIX"]->find_program("netdata");
	if($GLOBALS["VERBOSE"]){echo "Netdata: $Masterbin\n";}
	exec("$Masterbin -v 2>&1",$results);
	foreach ($results as $line){
		if($GLOBALS["VERBOSE"]){echo "Netdata: $line\n";}
		if(preg_match("#netdata([\s|v]+)([0-9\.]+)#", $line,$re)){
			if($GLOBALS["VERBOSE"]){echo "Netdata: Found version `{$re[2]}`\n";}
			$GLOBALS["netdata_version"]=$re[2];
			return $GLOBALS["netdata_version"];
		}else{
			if($GLOBALS["VERBOSE"]){echo "Netdata: not Found version `$line`\n";}
		}
	}
	return null;}


function __MSKTUTIL_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$msktutil=$GLOBALS["CLASS_UNIX"]->find_program("msktutil");
	$t=exec("$msktutil --version 2>&1");
	if($GLOBALS["VERBOSE"]){echo "$msktutil -> $t\n";}
	if(preg_match("#msktutil version\s+([0-9\.]+)#", $t,$re)){
		$GLOBALS[__FUNCTION__]=$re[1];
		return $GLOBALS[__FUNCTION__];
	}
	return null;}
function _ufdbguardd_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$ufdbguardd_path=$GLOBALS["CLASS_UNIX"]->find_program("ufdbguardd");
	exec("$ufdbguardd_path -v 2>&1",$results);
	foreach ($results as $num=>$line){
		if(preg_match("#ufdbguardd.*?([0-9\.]+)#", $line,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			return $re[1];
		}
	}
	return null;}
function dnsfilterd_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$ufdbguardd_path="/opt/dnsfilterd/bin/dnsfilterd";
	exec("$ufdbguardd_path -v 2>&1",$results);
	foreach ($results as $num=>$line){
		if(preg_match("#ufdbguardd.*?([0-9\.]+)#", $line,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			return $re[1];
		}
	}
	return null;}



function _clamd_version(){
	if(isset( $GLOBALS["clamd_version"])){return  $GLOBALS["clamd_version"];}
	$Masterbin=$GLOBALS["CLASS_UNIX"]->find_program("clamd");
	$cp=$GLOBALS["CLASS_UNIX"]->find_program("clamd");
	if(!is_dir("/etc/clamav")){@mkdir("/etc/clamav",0755,true);}
	if(!is_file("/etc/clamav/clamd.conf")){@touch("/etc/clamav/clamd.conf");}

	$files[]="libclamav.so";
	$files[]="libclamav.so.9";
	$files[]="libclamav.so.9.0.1";
	$files[]="libclamav.so.9.0.4";
	$files[]="libclamav.so.9.0.5";
	$files[]="libclamav.so.9.0.6";
	$files[]="libclamav.so.9.0.7";


	foreach ($files as $filename){
		if(is_file("/usr/lib/$filename")){
			if(is_file("/lib/x86_64-linux-gnu/$filename")){
				@unlink("/lib/x86_64-linux-gnu/$filename");
			}

			if(!is_file("/lib/$filename")){
				shell_exec("$cp -fd /usr/lib/$filename /lib/$filename");
			}
		}
	}

	
	exec("$Masterbin -V 2>&1",$results);
	foreach ($results as $line){
		if($GLOBALS["VERBOSE"]){echo "clamd_version(): Checking $line\n";}
		if(preg_match("#ClamAV\s+([0-9\.]+)(\/|-)#i", $line,$re)){
			$GLOBALS["clamd_version"]=$re[1];
			if($GLOBALS["VERBOSE"]){echo "clamd_version():Found  {$re[1]}\n";}
			return $GLOBALS["clamd_version"];
		}

		if(preg_match("#ClamAV\s+devel-clamav-([0-9\.]+)-beta[0-9]+-([0-9]+)-#",$line,$re)){
			$GLOBALS["clamd_version"]=$re[1]."-".$re[2];
			if($GLOBALS["VERBOSE"]){echo "clamd_version():Found  {$re[1]}- {$re[2]}\n";}
			return $GLOBALS["clamd_version"];
		}

	}
	return null;}

function __DSC_VERSION(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$dsc=$GLOBALS["CLASS_UNIX"]->find_program("dsc");
	$t=exec("$dsc -v 2>&1");
	if($GLOBALS["VERBOSE"]){echo "$dsc -> $t\n";}
	if(preg_match("#dsc version\s+([0-9\.]+)#", $t,$re)){
		$GLOBALS[__FUNCTION__]=$re[1];
		return $GLOBALS[__FUNCTION__];
	}

	return null;}
function __ulogd_version(){
	if(isset($GLOBALS["ULOGDVERSION"])){return $GLOBALS["ULOGDVERSION"];}
	exec("/usr/local/sbin/ulogd -V 2>&1",$results);
	foreach ($results as $line){

		if(preg_match("#ulogd Version\s+([0-9\.]+)#", $line,$re)){
			$GLOBALS["ULOGDVERSION"]= $re[1];
			return $GLOBALS["ULOGDVERSION"];
		}
	}

	return null;}

function __ipaudit_version(){
	if(isset($GLOBALS["ipaudit_version"])){return $GLOBALS["ipaudit_version"];}
	$Masterbin="/usr/local/sbin/ipaudit";
	if(!is_file($Masterbin)){return null;}
	@chmod($Masterbin,0755);
	exec("$Masterbin -v 2>&1",$results);
	foreach ($results as $num=>$line){
		$line=trim($line);
		if($line==null){continue;}
		if(!preg_match("#^([0-9\.]+)\s+\(compiled#",$line,$re)){continue;}
		$GLOBALS["ipaudit_version"]=$re[1];
	}

	if(isset($GLOBALS["ipaudit_version"])){return $GLOBALS["ipaudit_version"];}

	return null;}

function __tftpd_version(){
	if(isset($GLOBALS["tftpd_version"])){return $GLOBALS["tftpd_version"];}
	$Masterbin="/usr/sbin/in.tftpd";
	if(!is_file($Masterbin)){return null;}
	@chmod($Masterbin,0755);
	exec("$Masterbin -V 2>&1",$results);
	foreach ($results as $num=>$line){
		$line=trim($line);
		if($line==null){continue;}
		if(!preg_match("#^tftp-hpa\s+([0-9\.]+),#",$line,$re)){continue;}
		$GLOBALS["tftpd_version"]=$re[1];
	}
	
	if(isset($GLOBALS["tftpd_version"])){return $GLOBALS["tftpd_version"];}

	return null;}

 

function __mysqld_version(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	if(!isset($GLOBALS["CLASS_UNIX"])){$GLOBALS["CLASS_UNIX"]=new unix();}
	$mysqld=$GLOBALS["CLASS_UNIX"]->find_program("mysqld");
	exec("$mysqld --version 2>&1",$results);
	foreach ($results as $num=>$ligne){

		if(preg_match("#mysqld.*?([0-9\.\-]+)#", $ligne,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			return $GLOBALS[__FUNCTION__];
		}
	}
	return null;}

function __debian_version_name(){
	if(isset($GLOBALS["PRETTY_NAME"])){return $GLOBALS["PRETTY_NAME"];}
	if(!is_file("/etc/os-release")){return;}
	$f=explode("\n",@file_get_contents("/etc/os-release"));
	foreach ($f as $line){
		
		if(preg_match("#PRETTY_NAME=\"(.+?)[0-9]+\s+(.*?)\"#", $line,$re)){
			$debian_version=trim(@file_get_contents("/etc/debian_version"));
			$GLOBALS["PRETTY_NAME"]=$re[1]." $debian_version {$re[2]}";
			return $GLOBALS["PRETTY_NAME"];
		}
	}

	return null;}
function __ArchStruct(){
	if(isset($GLOBALS["__ArchStruct"])){return $GLOBALS["__ArchStruct"];}
	$uname=$GLOBALS["CLASS_UNIX"]->find_program("uname");
	exec("$uname -m 2>&1",$results);
	foreach ($results as $line){
		if(preg_match("#i[0-9]86#", $line)){
			$GLOBALS["__ArchStruct"]=32;
			return 32;
		}
		if(preg_match("#x86_64#", $line)){
			$GLOBALS["__ArchStruct"]=64;
			return 64;
		}
	}
	return null;}

//##############################################################################

function Build_default_values(){
	
	$XVF_WORKDIR=base64_decode("L3Vzci9sb2NhbC9zaGFyZS9hcnRpY2E=");
	$XVF_WORKFILE=base64_decode('LmxpYw==');
	$XVF_WORKPATH="$XVF_WORKDIR/$XVF_WORKFILE";
	$TVF_WORKPATH=base64_decode("L2V0Yy9hcnRpY2EtcG9zdGZpeC9zZXR0aW5ncy9EYWVtb25zL0NPUlBfTElDRU5TRQ==");
	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- START --- \n";}
	if(!isset($GLOBALS["CLASS_UNIX"])){$GLOBALS["CLASS_UNIX"]=new unix();}

	$TODELETE[]="exec.squid.purge.php";
	$TODELETE[]="exec.frox.php";
	$TODELETE[]="exec.squid.updateuris.malware.php";

	foreach ($TODELETE as $filename){
		if(is_file("/usr/share/artica-postfix/$filename")){@unlink("/usr/share/artica-postfix/$filename");}
	}

	if(!isset($GLOBALS["CLASS_SOCKETS"])){$GLOBALS["CLASS_SOCKETS"]=new sockets();}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableInfluxDB")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableInfluxDB", 1);}
	$EnableInfluxDB=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableInfluxDB"));
	if(!is_numeric($EnableInfluxDB)){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableInfluxDB", 1);}
	if(!is_file("/var/log/lastlog")){@touch("/var/log/lastlog");}

	if(is_file("/etc/monit/conf.d/APP_ARTICA_FRAMEPHP.monitrc")){
		@unlink("/etc/monit/conf.d/APP_ARTICA_FRAMEPHP.monitrc");
		shell_exec("/etc/init.d/monit restart");
	}






	if(is_file("/usr/share/artica-postfix/exec.rest-webfilter.client.php")) {
		if (!is_link("/usr/sbin/webfilter-rest")) {
			@symlink("/usr/share/artica-postfix/exec.rest-webfilter.client.php", "/usr/sbin/webfilter-rest");
			@chmod("/usr/share/artica-postfix/exec.rest-webfilter.client.php", 0755);
		}
	}
	if(is_file("/usr/share/artica-postfix/exec.rest.system.php")) {
		if (!is_link("/usr/sbin/system-rest")) {
			@symlink("/usr/share/artica-postfix/exec.rest.system.php", "/usr/sbin/system-rest");
			@chmod("/usr/share/artica-postfix/exec.rest.system.php", 0755);
		}
	}

	if(!is_file("/var/log/artica-webauth.log")){
		@touch("/var/log/artica-webauth.log");


	}
	@chmod("/var/log/artica-webauth.log",0755);
	@chown("/var/log/artica-webauth.log","www-data");
	@chgrp("/var/log/artica-webauth.log","www-data");

	LIST_SWAPS();

	if(!is_file("/etc/artica-postfix/settings/Daemons/SquidGuardClientMaxMemoryItems")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SquidGuardClientMaxMemoryItems", 100000);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/SquidLogsExceptions")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SquidLogsExceptions", "127.0.0.1");}
	if(!is_file("/etc/artica-postfix/settings/Daemons/SquidCacheLevel")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SquidCacheLevel", 3);}

	if(!is_file("/etc/artica-postfix/settings/Daemons/WebCommunityUpdatePool")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WebCommunityUpdatePool", 360);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/NoTracksSchedule")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NoTracksSchedule", 120);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/URLhausSchedule")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("URLhausSchedule", 120);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/MilterGreyListAutoWhite")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MilterGreyListAutoWhite", 220);}
    if(!is_file("/etc/artica-postfix/settings/Daemons/HardDisksWatchDog")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("HardDisksWatchDog", serialize(array()));}

	$touch[]="/etc/artica-postfix/settings/Mysql/database_admin";
	$touch[]="/etc/artica-postfix/settings/Mysql/database_password";
	foreach ($touch as $path){
		if(!is_file($path)){@touch($path);}
	}

	if(!is_file("/etc/artica-postfix/settings/Daemons/ActiveDirectoryConnections")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ActiveDirectoryConnections",serialize(array()));
	}


	
	if(!is_file("/etc/artica-postfix/settings/Daemons/TempWizard")){@touch("/etc/artica-postfix/settings/Daemons/TempWizard");@chown("/etc/artica-postfix/settings/Daemons/TempWizard","www-data");@chgrp("/etc/artica-postfix/settings/Daemons/TempWizard", "www-data");}
	if(!is_file("/etc/artica-postfix/settings/Daemons/TempWizardback")){@touch("/etc/artica-postfix/settings/Daemons/TempWizardback");@chown("/etc/artica-postfix/settings/Daemons/TempWizardback","www-data");@chgrp("/etc/artica-postfix/settings/Daemons/TempWizardback", "www-data");}
	
	if(is_file("/etc/init.d/.depend.boot")){@unlink("/etc/init.d/.depend.boot");}
	if(is_file("/etc/init.d/.depend.start")){@unlink("/etc/init.d/.depend.start");}  
	if(is_file("/etc/init.d/.depend.stop")){@unlink("/etc/init.d/.depend.stop");}

	$ToDelete[]="exec.mpstat.php";

	foreach ($ToDelete as $filename){
		if(is_file("/usr/share/artica-postfix/$filename")){
			@unlink("/usr/share/artica-postfix/$filename");
		}
	}

	$SET0[]="EnableVirtualDomainsInMailBoxes";
	$SET0[]="EnableClamavSecuriteSchedule";
	$SET0[]="NmapScanEnabled";
	$SET0[]="APACHE_MOD_BW";
	$SET0[]="EnableScanComputersNet";
	$SET0[]="WanProxyEnabled";
	$SET0[]="EnableProxyCompressor";
	$SET0[]="EnableFreeRadius";
	$SET0[]="StoreIDUrgency";
	$SET0[]="LMSensorsEnable";
	$SET0[]="PDNSStatsEnabled";
	$SET0[]="DisableOsSystemUpdate";
	$SET0[]="UseRemoteUfdbguardService";
	$SET0[]="PDNSStatsEnabled";
	$SET0[]="EnableUfdbSimplePage";
	$SET0[]="APACHE_INSTALLED";
	$SET0[]="EnableNginx";
	$SET0[]="DisableMemCacheSettings";
    $SET0[]="EnableIntelCeleron";
	$SET0[]="SquidPerformance";
	$SET0[]="EnableHDParmTests";
	$SET0[]="EnableUfdbGuard2";

	
	foreach ($SET0 as $filename){
		if(!is_file("/etc/artica-postfix/settings/Daemons/$filename")){
			@file_put_contents("/etc/artica-postfix/settings/Daemons/$filename",0);
			@chmod("/etc/artica-postfix/settings/Daemons/$filename",0755);
			@chown("/etc/artica-postfix/settings/Daemons/$filename","www-data");
			@chgrp("/etc/artica-postfix/settings/Daemons/$filename","www-data");
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("$filename", 0);
		}
	}
	
	

	$SET1[]="AllowSquidKaspersky";
	$SET1[]="EnableNoTracks";
	$SET1[]="nonhierarchical_direct";
	$SET1[]="SambaDisableNetbios";
	$SET1[]="SquidBlackListDoNotCheckMD5";
	$SET1[]="ArticaAutoUpateOfficial";
	$SET1[]="AllowSquidWhitelistsSSL";
	$SET1[]="EnableMemcached";
	$SET1[]="SquidGuardClientEnableMemory";
	$SET1[]="AllowWindowsUpdates";
	$SET1[]="HideOfficialsCategory";
	$SET1[]="APP_VLAN_INSTALLED";

	if(!is_file("/etc/artica-postfix/settings/Daemons/ufdbCatPort")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ufdbCatPort",3978);}
	foreach ($SET1 as $filename){ if(!is_file("/etc/artica-postfix/settings/Daemons/$filename")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("$filename", 1);} }
	
	
	
	if(!is_file("/usr/local/sbin/ipaudit")){
	 if(is_file("/usr/share/artica-postfix/bin/install/ipaudit.tar.gz")){
	 	$tar=$GLOBALS["CLASS_UNIX"]->find_program("tar");
	 	shell_exec("$tar xf /usr/share/artica-postfix/bin/install/ipaudit.tar.gz -C /usr/local/sbin/");
	 	if(is_file("/usr/local/sbin/ipaudit")){
	 		squid_admin_mysql(0, "New Feature installed IP traffic summarizer in System/Monitor !", "See https://youtu.be/_jmH7_a3luA",__FILE__,__LINE__);
	 	}
	 }
	}


	$php5=$GLOBALS["CLASS_UNIX"]->LOCATE_PHP5_BIN();

	if(!is_file("/etc/cron.d/frontend-notifications")){
		$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("frontend-notifications",
			"*/5 * * * *","exec.frontend-notifications.php");
	}
	if(!is_file("/usr/share/artica-postfix/ressources/logs/web/frontend_notifications.html")){
		shell_exec("$php5 /usr/share/artica-postfix/exec.frontend-notifications.php");
	}

	
	$GLOBALS["CLASS_UNIX"]->CPU_NUMBER();
	$KERNEL_VERSION=$GLOBALS["CLASS_UNIX"]->KERNEL_VERSION();
	$ipset=$GLOBALS["CLASS_UNIX"]->find_program("ipset");
	$cgrulesengd=$GLOBALS["CLASS_UNIX"]->find_program("cgrulesengd");
	$dialog=$GLOBALS["CLASS_UNIX"]->find_program("dialog");
	$msktutil=$GLOBALS["CLASS_UNIX"]->find_program("msktutil");
	$wpa_supplicant=$GLOBALS["CLASS_UNIX"]->find_program("wpa_supplicant");
	$hostapd=$GLOBALS["CLASS_UNIX"]->find_program("hostapd");
	$losetup=$GLOBALS["CLASS_UNIX"]->find_program("losetup");
	$vconfig=$GLOBALS["CLASS_UNIX"]->find_program("vconfig");
	$iscsiadm=$GLOBALS["CLASS_UNIX"]->find_program("iscsiadm");
	$cgrulesengd=$GLOBALS["CLASS_UNIX"]->find_program("cgrulesengd");
	$arpd=$GLOBALS["CLASS_UNIX"]->find_program("arpd");
	$iscsid=$GLOBALS["CLASS_UNIX"]->find_program("iscsid");
	$ftp_proxy=$GLOBALS["CLASS_UNIX"]->find_program("ftp-proxy");
	$wifidog=$GLOBALS["CLASS_UNIX"]->find_program("wifidog");
	$freshclam=$GLOBALS["CLASS_UNIX"]->find_program("freshclam");
	$suricata=$GLOBALS["CLASS_UNIX"]->find_program("suricata");
	$vde_switch=$GLOBALS["CLASS_UNIX"]->find_program("vde_switch");
	$ucarp=$GLOBALS["CLASS_UNIX"]->find_program("ucarp");
	$ntpdate=$GLOBALS["CLASS_UNIX"]->find_program("ntpdate");
	$freeradius=$GLOBALS["CLASS_UNIX"]->find_program("freeradius");
	$haproxy=$GLOBALS["CLASS_UNIX"]->find_program("haproxy");
	$ebtables=$GLOBALS["CLASS_UNIX"]->find_program("ebtables");
	$squid27=$GLOBALS["CLASS_UNIX"]->find_program("squid27");
	$apache2=$GLOBALS["CLASS_UNIX"]->LOCATE_APACHE_BIN_PATH();
	$offlineimap=$GLOBALS["CLASS_UNIX"]->find_program("offlineimap");
	$postscreen=$GLOBALS["CLASS_UNIX"]->LOCATE_POSTFIX_POSTSCREEN();
	$ipset=$GLOBALS["CLASS_UNIX"]->find_program("ipset");
	$aspell=$GLOBALS["CLASS_UNIX"]->find_program("aspell");
	$muninnode=$GLOBALS["CLASS_UNIX"]->find_program("munin-node");
	$CURL_PATH=$GLOBALS["CLASS_UNIX"]->find_program("curl");
	$miltergreylist=$GLOBALS["CLASS_UNIX"]->find_program("milter-greylist");
	$smbd=$GLOBALS["CLASS_UNIX"]->find_program("smbd");
	$iptables=$GLOBALS["CLASS_UNIX"]->find_program("iptables");
	$php_fpm=$GLOBALS["CLASS_UNIX"]->find_program("php5-fpm");
	$ntopng=$GLOBALS["CLASS_UNIX"]->find_program("ntopng");
	$pureftpd=$GLOBALS["CLASS_UNIX"]->find_program("pure-ftpd");
	$sabnzbdplus=$GLOBALS["CLASS_UNIX"]->find_program("sabnzbdplus");
	$rpc_nfsd=$GLOBALS["CLASS_UNIX"]->find_program("rpc.nfsd");
	$dstat=$GLOBALS["CLASS_UNIX"]->find_program("dstat");
	$gnuplot=$GLOBALS["CLASS_UNIX"]->find_program("gnuplot");
	$VBoxService=$GLOBALS["CLASS_UNIX"]->find_program("VBoxService");
	$kinit=$GLOBALS["CLASS_UNIX"]->find_program("kinit");
	$iostat=$GLOBALS["CLASS_UNIX"]->find_program("iostat");
	$openvpn_bin=$GLOBALS["CLASS_UNIX"]->find_program("openvpn");
	$firehol=$GLOBALS["CLASS_UNIX"]->find_program("firehol");
	$ufdbguardd_path=$GLOBALS["CLASS_UNIX"]->find_program("ufdbguardd");
	if(is_file("/usr/sbin/firehol")){$firehol="/usr/sbin/firehol";}
	$clamd=$GLOBALS["CLASS_UNIX"]->find_program("clamd");
	$uname=$GLOBALS["CLASS_UNIX"]->find_program("uname");
	$unbound=$GLOBALS["CLASS_UNIX"]->find_program("unbound");
	$netdata=$GLOBALS["CLASS_UNIX"]->find_program("netdata");
	$winbindd=$GLOBALS["CLASS_UNIX"]->find_program("winbindd");
	$nmap=$GLOBALS["CLASS_UNIX"]->find_program("nmap");
	$targetcli=$GLOBALS["CLASS_UNIX"]->find_program("targetcli");
	$monitbin=$GLOBALS["CLASS_UNIX"]->find_program("monit");
	$cicapbin=$GLOBALS["CLASS_UNIX"]->find_program("c-icap");
	$omindex=$GLOBALS["CLASS_UNIX"]->find_program("omindex");
	$ntpd=$GLOBALS["CLASS_UNIX"]->find_program("ntpd");
	$vmware_tool=VMWARETOOLS_BIN();
	$rsync=$GLOBALS["CLASS_UNIX"]->find_program("rsync");
	$smbd_bin=$GLOBALS["CLASS_UNIX"]->find_program("smbd");
	$dhcpd=$GLOBALS["CLASS_UNIX"]->find_program("dhcpd");
	$lighttpd=$GLOBALS["CLASS_UNIX"]->find_program("lighttpd");
	$fail2ban=$GLOBALS["CLASS_UNIX"]->find_program("fail2ban-server");
	$oinkmaster=$GLOBALS["CLASS_UNIX"]->find_program("oinkmaster");
	$redis_server=$GLOBALS["CLASS_UNIX"]->find_program("redis-server");
	$fireqos=$GLOBALS["CLASS_UNIX"]->find_program("fireqos");
	$proftpd=$GLOBALS["CLASS_UNIX"]->find_program("proftpd");
	$mountcifs=$GLOBALS["CLASS_UNIX"]->find_program("mount.cifs");
	$java=$GLOBALS["CLASS_UNIX"]->find_program("java");
	$fping=$GLOBALS["CLASS_UNIX"]->find_program("fping");
	$vnstat=$GLOBALS["CLASS_UNIX"]->find_program("vnstatd");
	$curlftpfs=$GLOBALS["CLASS_UNIX"]->find_program("curlftpfs");
	$iptaccount=$GLOBALS["CLASS_UNIX"]->find_program("iptaccount");
	$ipsec=$GLOBALS["CLASS_UNIX"]->find_program("ipsec");
	$pptpd=$GLOBALS["CLASS_UNIX"]->find_program("pptpd");
	$pptp=$GLOBALS["CLASS_UNIX"]->find_program("pptp");
	$slapd=$GLOBALS["CLASS_UNIX"]->find_program("slapd");
	$pear=$GLOBALS["CLASS_UNIX"]->find_program("pear");
	$tc=$GLOBALS["CLASS_UNIX"]->find_program("tc");
	$sensors_detect=$GLOBALS["CLASS_UNIX"]->find_program("sensors-detect");
	$ziproxy=$GLOBALS["CLASS_UNIX"]->find_program("ziproxy");
	$iwconfig=$GLOBALS["CLASS_UNIX"]->find_program("iwconfig");
	$KERNEL_VERSION=$GLOBALS["CLASS_UNIX"]->KERNEL_VERSION();
	$namebench=$GLOBALS["CLASS_UNIX"]->find_program("namebench");
	$nohup=$GLOBALS["CLASS_UNIX"]->find_program("nohup");
	$privoxy=$GLOBALS["CLASS_UNIX"]->find_program("privoxy");
	$pdns_server=$GLOBALS["CLASS_UNIX"]->find_program("pdns_server");
	$msmtp=$GLOBALS["CLASS_UNIX"]->find_program("msmtp");
	$postconf=$GLOBALS["CLASS_UNIX"]->find_program("postconf");
	$glances=$GLOBALS["CLASS_UNIX"]->find_program("glances");
	$filebeat=$GLOBALS["CLASS_UNIX"]->find_program("filebeat");
	$frontail_linux=$GLOBALS["CLASS_UNIX"]->find_program("frontail-linux");
	$cyrus=$GLOBALS["CLASS_UNIX"]->LOCATE_CYRUS_DAEMON();
	$snmpd=$GLOBALS["CLASS_UNIX"]->find_program("snmpd");
	$procmail=$GLOBALS["CLASS_UNIX"]->find_program("procmail");
	$mimedefang=$GLOBALS["CLASS_UNIX"]->find_program("mimedefang");
	$rbldnsd=$GLOBALS["CLASS_UNIX"]->find_program("rbldnsd");
	$nginx=$GLOBALS["CLASS_UNIX"]->find_program("nginx");
	$memcached=$GLOBALS["CLASS_UNIX"]->find_program("memcached");
	$mysqld=$GLOBALS["CLASS_UNIX"]->find_program("mysqld");
	$tar=$GLOBALS["CLASS_UNIX"]->find_program("tar");
	$ln=$GLOBALS["CLASS_UNIX"]->find_program("ln");
	$letsencrypt=$GLOBALS["CLASS_UNIX"]->find_program("certbot");
	$milter_greylist=$GLOBALS["CLASS_UNIX"]->find_program("milter-greylist");
	$openssl=$GLOBALS["CLASS_UNIX"]->find_program("openssl");
	$proxy3=$GLOBALS["CLASS_UNIX"]->find_program("3proxy");
	$redsocks=$GLOBALS["CLASS_UNIX"]->find_program("redsocks");
	$milter_regex=$GLOBALS["CLASS_UNIX"]->find_program("milter-regex");
	$dnscrypt_proxy=$GLOBALS["CLASS_UNIX"]->find_program("dnscrypt-proxy");
    $doh_server=$GLOBALS["CLASS_UNIX"]->find_program("doh-server");
	$linkbalancerbin=$GLOBALS["CLASS_UNIX"]->find_program("link-balancer");
	$squid_analyzer=$GLOBALS["CLASS_UNIX"]->find_program("squid-analyzer");
	$filebeat=$GLOBALS["CLASS_UNIX"]->find_program("filebeat");
	$opendkim=$GLOBALS["CLASS_UNIX"]->find_program("opendkim");
	$prads=$GLOBALS["CLASS_UNIX"]->find_program("prads");
	$php5ExtensionDir=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("php5ExtensionDir");
	$tailon=$GLOBALS["CLASS_UNIX"]->find_program("tailon");
	$php_geoip="$php5ExtensionDir/maxminddb.so";
	$geoipupdate=$GLOBALS["CLASS_UNIX"]->find_program("geoipupdate");
	$qemu_ga=$GLOBALS["CLASS_UNIX"]->find_program("qemu-ga");
	$dnsdist=$GLOBALS["CLASS_UNIX"]->find_program("dnsdist");
	$zabbix_agentd=$GLOBALS["CLASS_UNIX"]->find_program("zabbix_agentd");
	$dhcrelay=$GLOBALS["CLASS_UNIX"]->find_program("dhcrelay");
	$sshportal=$GLOBALS["CLASS_UNIX"]->find_program("sshportal");
	$pdnssec=$GLOBALS["CLASS_UNIX"]->find_program("pdnssec");
	$cgrulesengd=$GLOBALS["CLASS_UNIX"]->find_program("cgrulesengd");
	$greensql=null;
	if(is_file("/usr/sbin/greensql-fw")){$greensql="/usr/sbin/greensql-fw";}
	if(is_file("/usr/share/artica-postfix/bin/ipcalc")){@chmod("/usr/share/artica-postfix/bin/ipcalc",0755);}

	if(is_file("/etc/init.d/ufdbcat")){
		shell_exec("$nohup $php5 /usr/share/artica-postfix/exec.dnscat.php --install >/dev/null 2>&1");
	}
	if(is_file("/etc/cron.d/artica-msftncsi")){
		shell_exec("$nohup $php5 /usr/share/artica-postfix/exec.monit.php --msftncsi >/dev/null 2>&1 &");
	}


	$BugzillaChecked=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("BugzillaChecked"));
	if($BugzillaChecked==0){shell_exec("$nohup $php5 /usr/share/artica-postfix/exec.bugzilla.php --get-user >/dev/null 2>&1");}
	
	$shellinaboxd=$GLOBALS["CLASS_UNIX"]->find_program("shellinaboxd");
	$QEMU_HOST=IS_QEMU_HOST();
	
	if(!is_file($namebench)){$namebench=$GLOBALS["CLASS_UNIX"]->find_program("namebench.py");}
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("LOCATE_PHP5_BIN", $php5);
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("LOCATE_NOHUP", $nohup);

	$TimeFile[]="FROM_ISO";
	$TimeFile[]="artica-as-rebooted";
	$TimeFile[]="artica-iso-first-reboot";
	$TimeFile[]="artica-iso-setup-launched";
	$TimeFile[]="WIZARD_INSTALL_EXECUTED";

	foreach ($TimeFile as $basename){
		if(is_file("/etc/artica-postfix/$basename")){
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("INSTALL_TIME",
				filemtime("/etc/artica-postfix/$basename"));
			break;
		}
	}
	
	
	if($GLOBALS["VERBOSE"]){echo "openvpn		: $openvpn_bin\n";}
	if($GLOBALS["VERBOSE"]){echo "firehol		: $firehol\n";}
	if($GLOBALS["VERBOSE"]){echo "rsync		: $rsync\n";}
	if($GLOBALS["VERBOSE"]){echo "smbd		: $smbd_bin\n";}
	if($GLOBALS["VERBOSE"]){echo "fail2ban	: $fail2ban\n";}
	if($GLOBALS["VERBOSE"]){echo "oinkmaster	: $oinkmaster\n";}
	if($GLOBALS["VERBOSE"]){echo "ntopng		: $ntopng\n";}
	if($GLOBALS["VERBOSE"]){echo "redis-server	: $redis_server\n";}
	if($GLOBALS["VERBOSE"]){echo "FireQOS		: $fireqos\n";}
	if($GLOBALS["VERBOSE"]){echo "ProFTPD		: $proftpd\n";}
	if($GLOBALS["VERBOSE"]){echo "mount.cifs	: $mountcifs\n";}
	if($GLOBALS["VERBOSE"]){echo "java            : $java\n";}
	if($GLOBALS["VERBOSE"]){echo "fping           : $fping\n";}
	if($GLOBALS["VERBOSE"]){echo "vnstat          : $vnstat\n";}
	if($GLOBALS["VERBOSE"]){echo "curlftpfs       : $curlftpfs\n";}
	if($GLOBALS["VERBOSE"]){echo "ziproxy         : $ziproxy\n";}
	if($GLOBALS["VERBOSE"]){echo "php5            : $php5\n";}
	if($GLOBALS["VERBOSE"]){echo "nohup           : $nohup\n";}
	if($GLOBALS["VERBOSE"]){echo "shellinaboxd    : $shellinaboxd\n";}
	if($GLOBALS["VERBOSE"]){echo "msmtp           : $msmtp\n";}
	if($GLOBALS["VERBOSE"]){echo "postconf        : $postconf\n";}
	if($GLOBALS["VERBOSE"]){echo "glances         : $glances\n";}
	if($GLOBALS["VERBOSE"]){echo "filebeat        : $filebeat\n";}
	if($GLOBALS["VERBOSE"]){echo "frontail-linux  : $frontail_linux\n";}
	if($GLOBALS["VERBOSE"]){echo "snmpd           : $snmpd\n";}
	if($GLOBALS["VERBOSE"]){echo "dhcpd           : $dhcpd\n";}
	if($GLOBALS["VERBOSE"]){echo "nginx           : $nginx\n";}
	if($GLOBALS["VERBOSE"]){echo "memcached       : $memcached\n";}
	if($GLOBALS["VERBOSE"]){echo "greensql        : $greensql\n";}
	if($GLOBALS["VERBOSE"]){echo "milter-greylist : $milter_greylist\n";}
	if($GLOBALS["VERBOSE"]){echo "3proxy          : $proxy3\n";}
	if($GLOBALS["VERBOSE"]){echo "redsocks        : $redsocks\n";}
	if($GLOBALS["VERBOSE"]){echo "letsencrypt     : $letsencrypt\n";}
	if($GLOBALS["VERBOSE"]){echo "milter-regex    : $milter_regex\n";}
	if($GLOBALS["VERBOSE"]){echo "dnscrypt-proxy  : $dnscrypt_proxy\n";}
    if($GLOBALS["VERBOSE"]){echo "doh-server      : $doh_server\n";}
	if($GLOBALS["VERBOSE"]){echo "squid-analyzer  : $squid_analyzer\n";}
	if($GLOBALS["VERBOSE"]){echo "Prads           : $prads\n";}
	if($GLOBALS["VERBOSE"]){echo "PHP ExtensionDir: $php5ExtensionDir\n";}
	if($GLOBALS["VERBOSE"]){echo "PHP GeoIP2      : $php_geoip\n";}
	if($GLOBALS["VERBOSE"]){echo "Tailon          : $tailon\n";}
	if($GLOBALS["VERBOSE"]){echo "geoipupdate     : $geoipupdate\n";}
	if($GLOBALS["VERBOSE"]){echo "QEMU_HOST       : $QEMU_HOST\n";}
	if($GLOBALS["VERBOSE"]){echo "qemu-ga         : $qemu_ga\n";}
	if($GLOBALS["VERBOSE"]){echo "dnsdist         : $dnsdist\n";}
	if($GLOBALS["VERBOSE"]){echo "zabbix_agentd   : $zabbix_agentd\n";}
	if($GLOBALS["VERBOSE"]){echo "sshportal       : $sshportal\n";}
	if($GLOBALS["VERBOSE"]){echo "pdnssec         : $pdnssec\n";}
	if($GLOBALS["VERBOSE"]){echo "cgrulesengd     : $cgrulesengd\n";}



	if($QEMU_HOST==1) {
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("QEMU_HOST", 1);
		if(is_file($qemu_ga)){ QEMU_MONIT();}
	}else{

	}

	if(!is_file("/etc/artica-postfix/settings/Daemons/LINUX_INFO_TXT")){

		shell_exec("$php5 /usr/share/artica-postfix/exec.lshw.network.php");
	}

	if(is_file("/etc/init.d/proxy-pac")){
		if(!is_file("/etc/cron.d/proxy-pac-stats")){
			$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("proxy-pac-stats","0,10,20,30,40,50 * * * *","exec.proxy-pac.stats.php");
			shell_exec("/etc/init.d/cron restart");
		}
	}

	
	if(!is_file("/usr/sbin/wp-cli.phar")){
		if(is_file("/usr/share/artica-postfix/bin/install/wp-cli.phar.tar.gz")){
			shell_exec("$tar xf /usr/share/artica-postfix/bin/install/wp-cli.phar.tar.gz -C /usr/sbin/");
			if(is_file("/usr/sbin/wp-cli.phar")){
				@chmod("/usr/sbin/wp-cli.phar", 0755);
				shell_exec("$ln -sf /usr/sbin/wp-cli.phar /usr/sbin/wp");
				squid_admin_mysql(2, "Success installing WordPress client", null,__FILE__,__LINE__);
			}
		}
	}
	
	
	
	
	$zip=$GLOBALS["CLASS_UNIX"]->find_program("zip");
	if(!is_file($zip)){$zip="/usr/bin/zip";}
	
	if(!is_file($php_fpm)){$php_fpm=$GLOBALS["CLASS_UNIX"]->find_program("php-fpm");}
	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- ".__LINE__." --- \n";}
	
	var_lib_php();
	buildCronStatistics();
	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- ".__LINE__." --- \n";}
	
	if(is_file($XVF_WORKPATH)){
		$fjih=strtoupper(trim(@file_get_contents($XVF_WORKPATH)));
		if($fjih=="TRUE"){
			@file_put_contents($TVF_WORKPATH,"VFJVRQ==");
			@chmod($TVF_WORKPATH,0755);
		}else{
			@unlink($TVF_WORKPATH);
		}
	}
	
	
	
	if(!is_file($dialog)){
		$TimeEx=$GLOBALS["CLASS_UNIX"]->file_time_min("/etc/artica-postfix/install.dialog.time");
		if($TimeEx>15){
			$cmd=trim("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.installv2.php --dialog >/dev/null 2>&1");
			shell_exec2($cmd);
		}
	}
	

	PERSONAL_CATEGORIES_CRON();
	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- ".__LINE__." --- \n";}
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("mysqld_version",__mysqld_version());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("DEBIAN_VERSION_NAME",__debian_version_name());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("DEBIAN_VERSION",$GLOBALS["CLASS_UNIX"]->DEBIAN_VERSION());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("VMWARE_HOST",IS_VMWARE_HOST());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("VIRTUALBOX_HOST",IS_VIRTUALBOX_HOST());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("XEN_HOST",$GLOBALS["CLASS_UNIX"]->IS_CITRIXXEN_HOST());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NUTANIX_HOST",$GLOBALS["CLASS_UNIX"]->IS_NUTANIX_HOST());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("HYPERV_HOST",IS_HYPERV_HOST());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ArchStruct",__ArchStruct());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("OPENSSH_VER",openssh_version());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MEM_TOTAL_INSTALLEE",$GLOBALS["CLASS_UNIX"]->MEM_TOTAL_INSTALLEE());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("LinuxDistributionCodeName", $GLOBALS["CLASS_UNIX"]->LINUX_CODE_NAME());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("LinuxDistributionFullName", $GLOBALS["CLASS_UNIX"]->LINUX_DISTRIBUTION());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("TOTAL_MEMORY_MB", $GLOBALS["CLASS_UNIX"]->TOTAL_MEMORY_MB());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ifconfig_all_ips", serialize($GLOBALS["CLASS_UNIX"]->ifconfig_all_ips()));
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SIEVE_PORT",SIEVE_PORT());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("LOCAL_SID",$GLOBALS["CLASS_UNIX"]->GET_LOCAL_SID());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_SYSLOGD_VERSION",APP_SYSLOGD_VERSION());


	$LINUX_INFO_PATH="/etc/artica-postfix/settings/Daemons/LINUX_INFO_TXT";
	if(is_file($LINUX_INFO_PATH)){
		$TimeEx=$GLOBALS["CLASS_UNIX"]->file_time_min($LINUX_INFO_PATH);
		if($TimeEx>420){@unlink($LINUX_INFO_PATH);}
	}
	if(!is_file($LINUX_INFO_PATH)){
		@chmod("/usr/share/artica-postfix/bin/linux-info.sh",0755);
		shell_exec("/usr/share/artica-postfix/bin/linux-info.sh --all >$LINUX_INFO_PATH 2>&1");
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("LINUX_INFO_TXT",@file_get_contents($LINUX_INFO_PATH));
	}

	$DISKS_INODES_TIME=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DISKS_INODES_TIME"));
	if($GLOBALS["CLASS_UNIX"]->time_min($DISKS_INODES_TIME)>30){
		$inodes=$GLOBALS["CLASS_UNIX"]->DISK_INODES();

		foreach ($inodes as $dev=>$array){
			$INODES_PRC  = $array["POURC"];
			if($INODES_PRC>90){
				squid_admin_mysql(0,"Warning inodes on $dev exceed 90%, please check the disk",
						null,__FILE__,__LINE__);
			}
		}

		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("DISKS_INODES",serialize($inodes));
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("DISKS_INODES_TIME",time());
	}




	$EnablePostfix=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnablePostfix"));

	if($EnablePostfix==0){
		if(is_file("/usr/sbin/sendmail")){@chmod("/usr/sbin/sendmail",0600);}
	}else{
		if(is_file("/usr/sbin/sendmail")){@chmod("/usr/sbin/sendmail",0755);}
	}


	$data=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("LINUX_INFO_TXT");
	if($data==null){
		$cmd=trim("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.lshw.network.php >/dev/null 2>&1");
		shell_exec2($cmd);

	}

	if(!is_file("/usr/share/artica-postfix/img/philesight/system.png")){
		$cmd=trim("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.philesight.php --run >/dev/null 2>&1");
		shell_exec2($cmd);
	}
	if(!is_file("/etc/cron.d/squid-notifications")){
		$GLOBALS["CLASS_UNIX"]->events("Popuplate_cron_make -> squid-notifications","/var/log/artica.squid.smtp.log",false,__FUNCTION__,__LINE__,basename(__FILE__));
		Popuplate_cron_make("squid-notifications","* * * * *","exec.squid.smtp.notifications.php");
		system("/etc/init.d/cron reload");
	}

	if(!is_file("/etc/cron.d/ping-cloud")){
		Popuplate_cron_make("ping-cloud","15 0,2,4,6,8,10,12,24,16,28,20 * * *","exec.web-community-filter.php --ping-cloud");
		system("/etc/init.d/cron reload");
	}
	if(!is_file("/etc/cron.d/register-lic")){
		Popuplate_cron_make("register-lic","30 1,3,6,9,12,15,18,21,23 * * *","exec.web-community-filter.php --register-lic --set-stamp");
		system("/etc/init.d/cron reload");
	}



	if(!is_file("/etc/cron.d/philesight")){
		$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("philesight","45 1 * * *","philesight.php --run");
		system("/etc/init.d/cron reload");
	}

	if(!is_file("/etc/cron.d/verif-packages")){
		$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("verif-packages","0 */8 * * *","exec.verif.packages.php");
		system("/etc/init.d/cron reload");
	}
	if(!is_file("/etc/cron.d/artica-syslog-reboot")){
		$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("artica-syslog-reboot","15 * * * *","exec.syslog-init.php --restart");
		system("/etc/init.d/cron reload");
	}

	if(is_file("/etc/init.d/proxy-pac")) {
		if (!is_file("/etc/cron.d/proxy-pac-reboot")) {
			$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("proxy-pac-reboot", "20 * * * *", "exec.proxy-pac.php --restart");
			system("/etc/init.d/cron reload");
		}
	}

	if(!is_file("/etc/cron.d/postgrey-dbsize")){
		$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("postgrey-dbsize","30 * * * *","exec.postgres.backup.php --dbsize");
		system("/etc/init.d/cron reload");
	}



	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- ".__LINE__." --- \n";}
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("LinuxKernelVersion",exec("$uname -v 2>&1"));
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("LOCAL_SID", $GLOBALS["CLASS_UNIX"]->GET_LOCAL_SID());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CURL_PATH", $CURL_PATH);
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EXEC_NICE", $GLOBALS["CLASS_UNIX"]->EXEC_NICE());
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PHP_BIN_PATH", $GLOBALS["PHP5"]);
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SQUID_BIN_PATH", $GLOBALS["CLASS_UNIX"]->LOCATE_SQUID_BIN());
	if(is_file("/etc/cron.d/php5")){@unlink("/etc/cron.d/php5");shell_exec2("/etc/init.d/cron reload");}
	if(is_file("/usr/local/bin/sarg")){@unlink("/usr/local/bin/sarg");}
	
	if($GLOBALS["CLASS_UNIX"]->ISMemoryHiger1G()){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MEM_HIGER_1G",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MEM_HIGER_1G",0);
	}
	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- ".__LINE__." --- \n";}
	if(is_file($apache2)){
		$MODAPACHE["mod_authnz_ldap.so"]="APACHE_MOD_AUTHNZ_LDAP";
		
		$MODAPACHE["mod_security2.so"]="APACHE_MOD_SECURITY";
		$MODAPACHE["mod_evasive20.so"]="APACHE_MOD_EVASIVE";
		$MODAPACHE["mod_cache.so"]="APACHE_MOD_CACHE";
		$MODAPACHE["mod_geoip.so"]="APACHE_MOD_GEOIP";
		$MODAPACHE["mod_pagespeed.so"]="APACHE_MOD_PAGESPEED";
		$MODAPACHE["mod_info.so"]="APACHE_MOD_INFO";
		$MODAPACHE["mod_status.so"]="APACHE_MOD_STATUS";
		$MODAPACHE["mod_suexec.so"]="APACHE_MOD_SUEXEC";
		$MODAPACHE["mod_fcgid.so"]="APACHE_MOD_FCGID";
		$MODAPACHE["mod_log_sql_mysql.so"]="APACHE_MOD_LOGSSQL";
		$MODAPACHE["mod_bw.so"]="APACHE_MOD_BW";
		$MODAPACHE["mod_python.so"]="APACHE_MOD_PYTHON";
		$MODAPACHE["mod_suphp.so"]="APACHE_MOD_SUPHP";
		
		$APACHEPROXY["mod_proxy.so"]=True;
		$APACHEPROXY["mod_proxy_http.so"]=True;
		$APACHEPROXY["mod_proxy_ftp.so"]=True;
		$APACHEPROXY["mod_proxy_connect.so"]=True;
		$APACHEPROXY["mod_headers.so"]=True;
		$APACHEPROXY["mod_deflate.so"]=True;
		$APACHEPROXY["mod_proxy_html.so"]=True;
		
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APACHE_INSTALLED",1);

		if($GLOBALS["CLASS_UNIX"]->APACHE_MODULE_EXISTS("mpm_itk_module")){
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("mpm_itk_module",1);
		}else{
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("mpm_itk_module",0);
		}
		$APACHE_MODULES_PATH=$GLOBALS["CLASS_UNIX"]->APACHE_MODULES_PATH();
		if(is_file("$APACHE_MODULES_PATH/mod_dav.so")){
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("mod_dav",1);
		}else{
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("mod_dav",0);
		}
		foreach ($MODAPACHE as $lib=>$token){
			if(is_file("$APACHE_MODULES_PATH/$lib")){
				$GLOBALS["CLASS_SOCKETS"]->SET_INFO("$token",1);
			}else{
				$GLOBALS["CLASS_SOCKETS"]->SET_INFO("$token",0);
			}
		}
		$APACHE_PROXY_MODE=true;
		foreach ($APACHEPROXY as $lib=>$none){if(!is_file("$APACHE_MODULES_PATH/$lib")){$APACHE_PROXY_MODE=false;break;}}
		if($APACHE_PROXY_MODE){
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APACHE_PROXY_MODE",1);
		}else{
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APACHE_PROXY_MODE",0);
		}		
		
		
	}
	
	if(is_file("/usr/local/ArticaStats/bin/postgres")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ARTICA_POSTGRESQL_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ARTICA_POSTGRESQL_VERSION", POSTGRESQL_VERSION());
		}else{
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ARTICA_POSTGRESQL_INSTALLED", 0);
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ARTICA_POSTGRESQL_VERSION",0);		
		
		
	}
	$ndpi_path="/lib/modules/$KERNEL_VERSION/extra/xt_ndpi.ko";
	if($GLOBALS["VERBOSE"]){echo "[NDPI]: KERNEL VERSION:$KERNEL_VERSION\n";}
	if($GLOBALS["VERBOSE"]){echo "[NDPI]: xt_ndpi.ko....:$ndpi_path\n";}

	if(is_file($ndpi_path)){
		if($GLOBALS["VERBOSE"]){echo "[NDPI]: xt_ndpi.ko....:$ndpi_path SUCCESS\n";}
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_NDPI_INSTALLED", 1);
		if(is_file("/usr/share/nDPI/VERSION")){
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_NDPI_VERSION", trim(@file_get_contents("/usr/share/nDPI/VERSION")));}

	}else{
		if($GLOBALS["VERBOSE"]){echo "[NDPI]: xt_ndpi.ko....:$ndpi_path NO SUCH FILE\n";}
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_NDPI_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_NDPI_VERSION", 0);
	}

	
	if($GLOBALS["CLASS_UNIX"]->SQUID_INSTALLED()){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SQUID_INSTALLED", 1);
	}else{

		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SQUID_INSTALLED", 0);
	}
	if(is_file($dhcrelay)) {
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_DHCP_RELAY_INSTALLED", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_DHCP_RELAY_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableDHCPRelay", 0);
	}

	if(is_file("$sshportal")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_SSHPORTAL_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_SSHPORTAL_VERSION", APP_SSHPORTAL_VERSION());

	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_SSHPORTAL_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableSSHPortal", 0);

	}

	if(is_file("/usr/local/modsecurity/lib/libmodsecurity.so")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MODSECURITY_INSTALLED", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MODSECURITY_INSTALLED", 0);
	}

	if(is_file("/usr/bin/pactester")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_PACTESTER_INSTALLED", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_PACTESTER_INSTALLED", 0);
	}

	if(is_file($cgrulesengd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CGROUPS_INSTALLED", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CGROUPS_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("cgroupsEnabled", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("cgroupsEnabled", 0);
	}



	if(is_file("/usr/sbin/update-ipsets")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("UPDATE_IPSETS_INSTALLED", 1);

	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("UPDATE_IPSETS_INSTALLED", 0);
	}

	if(is_file($opendkim)) {
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("OPENDKIM_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("OPENDKIM_VERSION",OPENDKIM_VERSION());
	}

	if(is_file($prads)) {
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_PRADS_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_PRADS_VERSION", "0.3.3");

	}
	if(is_file($php_geoip)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PHP_GEOIP_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PHP_GEOIP_VERSION",phpversion("maxminddb"));
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PHP_GEOIP_INSTALLED", 0);
	}

	if(is_file("/usr/local/ArticaStats/bin/postgres")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_POSTGRES_INSTALLED", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_POSTGRES_INSTALLED", 0);
	}


	if(is_file($tailon)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("TAILON_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("TAILON_VERSION", "1.1.0");
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("TAILON_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableTailon",0);
	}

	if(!isset($GLOBALS["CLASS_SOCKETS"])){$GLOBALS["CLASS_SOCKETS"]=new sockets();}
	if(is_file('/opt/kaspersky/kav4proxy/sbin/kav4proxy-kavicapserver')){
		$kavicapserverEnabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("kavicapserverEnabled"));
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("Kav4ProxyInstalled", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_KAV4PROXY_VERSION",APP_KAV4PROXY_VERSION());
		if($kavicapserverEnabled==1) {
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_KAV4PROXY_PATTERN_DATE",
				APP_KAV4PROXY_PATTERN_DATE());
		}
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("Kav4ProxyInstalled", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_KAV4PROXY_VERSION","0.0.0");
	}

	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_UFDBCAT_VERSION",APP_UFDBCAT_VERSION());


	if(is_file($geoipupdate)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("GEOIPUPDATE_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("GEOIPUPDATE_VERSION", GEOIPUPDATE_VERSION());

	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("GEOIPUPDATE_INSTALLED", 0);
	}

	
	if(is_file($msmtp)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MSMTP_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MSMTP_VERSION", MSMTP_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MSMTP_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MSMTP_VERSION",0);
	}

	if(is_file($postconf)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("POSTFIX_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("POSTFIX_VERSION", $GLOBALS["CLASS_UNIX"]->POSTCONF_GET("mail_version"));		
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("POSTFIX_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("POSTFIX_VERSION",0);	
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnablePostfix",0);	
	}
	
	if(is_file($filebeat)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FILEBEAT_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FILEBEAT_VERSION", FILEBEAT_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FILEBEAT_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FILEBEAT_VERSION",0);
	}
		
	if(is_file($frontail_linux)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FRONTAIL_LINUX_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FRONTAIL_LINUX_VERSION", FRONTAIL_LINUX_VERSION());
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FRONTAIL_LINUX_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FRONTAIL_LINUX_VERSION",0);		
	}

	if(is_file($squid_analyzer)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_SQUIDANALYZER_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_SQUIDANALYZER_VERSION", APP_SQUIDANALYZER_VERSION());
	}
	
	if(is_file($cyrus)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_CYRUS_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_CYRUS_VERSION", APP_CYRUS_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_CYRUS_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_CYRUS_VERSION", 0);		
	}
	
	if(is_file($glances)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("GLANCES_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("GLANCES_VERSION", GLANCES_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("GLANCES_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("GLANCES_VERSION",0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableGlances",0);
	}	
	
	if(is_file($greensql)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_GREENSQL_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_GREENSQL_VERSION", APP_GREENSQL_VERSION());
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_GREENSQL_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_GREENSQL_VERSION", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableGreenSQL", 0);
	}
	
	if(is_file($mysqld)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MYSQL_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MYSQL_VERSION", APP_MYSQL_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MYSQL_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MYSQL_VERSION", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableMySQL", 0);
		
	}
	if(is_file($milter_regex)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MILTER_REGEX_INSTALLED", 1);
		$md5=md5_file($milter_regex);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MILTER_REGEX_VERSION", "2.0.0");
		if($md5=="b4593de12c36c8429466fdd25bf754b3"){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MILTER_REGEX_VERSION", "2.2.0");}
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MILTER_REGEX_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableMilterRegex", 0);
	}
	
	if(is_file($dnscrypt_proxy)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_DNSCRYPT_PROXY_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_DNSCRYPT_PROXY_VERSION", APP_DNSCRYPT_PROXY_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_DNSCRYPT_PROXY_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableDNSCryptProxy", 0);
	}

	if(is_file("/lib/systemd/systemd-udevd")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_UDEV_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_UDEV_VERSION", udevd_daemon_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_UDEV_INSTALLED", 0);
	}

	
	if( intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("APP_MULTIPATH_TCP_INSTALLED"))==1 ){
		$APP_MULTIPATH_TCP_VERSION=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("APP_MULTIPATH_TCP_VERSION");
		if($APP_MULTIPATH_TCP_VERSION==null){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MULTIPATH_TCP_VERSION", APP_MULTIPATH_TCP_VERSION());}
		if(is_file("/proc/net/mptcp_net/snmp")){
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MULTIPATH_TCP_RUNNING",1);
		}else{
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MULTIPATH_TCP_RUNNING",0);
		}
	}
	
	if(is_file("$milter_greylist")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MILTER_GREYLIST_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MILTER_GREYLIST_VERSION", APP_MILTER_GREYLIST_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MILTER_GREYLIST_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MILTER_GREYLIST_VERSION",0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MilterGreyListEnabled",0);
	}
	
	if(is_file($proxy3)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_3PROXY_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_3PROXY_VERSION", APP_3PROXY_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_3PROXY_INSTALLED", 0);
	}
	
	if(is_file($redsocks)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_REDSOCKS_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_REDSOCKS_VERSION", APP_REDSOCKS_VERSION());
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_REDSOCKS_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_REDSOCKS_VERSION", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableRedSocks", 0);
	}

	if(is_file($zabbix_agentd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_ZABBIX_AGENT_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_ZABBIX_AGENT_VERSION", APP_ZABBIX_AGENT_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_ZABBIX_AGENT_INSTALLED", 0);
	}
	
	
	
	if(is_file($snmpd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SNMPD_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SNMPD_VERSION", SNMPD_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SNMPD_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SNMPD_VERSION",0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableSNMPD",0);
	}
	
	if(is_file($mimedefang)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MimeDefangInstalled", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MimeDefangVersion", mimedefang_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MimeDefangInstalled", 0);

	}
	if(is_file($rbldnsd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_RBLDNSD_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_RBLDNSD_VERSION", APP_RBLDNSD_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_RBLDNSD_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_RBLDNSD_ENABLED", 0);
	}	
	
	
	if(is_file("/usr/libexec/postfix/mailspy")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MILTER_SPY_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MILTER_SPY_INSTALLED",0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableMilterSpyDaemon",0);
	}
	
	if(is_file($procmail)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PROCMAIL_INSTALLED",1);
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PROCMAIL_INSTALLED",0);
	}
	
	if(is_file($tc)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("TC_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("TC_VERSION", TC_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("TC_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("TC_VERSION",0);
	}	
	
	if(is_file("/usr/lib/ldap/syncprov.so")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("LDAP_SYNCPROV", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("LDAP_SYNCPROV", 0);
	}
	
	if(is_file($pear)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PEAR_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PEAR_PACKAGES", PEAR_PACKAGES());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PEAR_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PEAR_PACKAGES", "");		
	}
	
	if(is_file($privoxy)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_PRIVOXY_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_PRIVOXY_VERSION", APP_PRIVOXY_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PEAR_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PEAR_PACKAGES", "");
	}

	if(is_file($dnsdist)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_DNSDIST_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_DNSDIST_VERSION", APP_DNSDIST_VERSION());

	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_DNSDIST_INSTALLED", 0);
	}
	
	if(is_file($pdns_server)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PDNSInstalled", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PDNSVersion", APP_PDNS_VERSION());
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PDNSRecursorVersion", APP_PDNS_RECURSOR_VERSION());	
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PDNSInstalled", 0);
	}	
	
	if(is_file($shellinaboxd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_SHELLINABOX_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_SHELLINABOX_VERSION", APP_SHELLINABOX_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_SHELLINABOX_INSTALLED", 0);
	}	


	if(is_file($filebeat)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_FILEBEAT_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_FILEBEAT_VERSION", APP_FILEBEAT_VERSION());
	}
	
	
	if(is_file($nginx)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_NGINX_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_NGINX_VERSION", APP_NGINX_VERSION());
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NGINX_COMPILE_PARAMS", base64_encode(serialize( $GLOBALS["CLASS_UNIX"]->NGINX_COMPILE_PARAMS() ) ));
		$EnableNginx=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableNginx"));
		if($EnableNginx==1){
			shell_exec("$php5 /usr/share/artica-postfix/exec.nginx.php --dump-modules >/dev/null 2>&1 &");
		}

		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_NGINX_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableNginx", 0);
	}	

	if(is_file($slapd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("openldap_installed", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("openldap_version",APP_SLAPD_VERSION());

	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("openldap_installed", 0);
	}	
	if(is_file($pptpd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PPTPD_INSTALLED", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PPTPD_INSTALLED", 0);
	}	
	if(is_file($pptp)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PPTP_INSTALLED", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PPTP_INSTALLED", 0);
	}	
	if(is_file($ipsec)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IPSEC_VERSION", IPSEC_VERSION());
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IPSEC_INSTALLED", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IPSEC_INSTALLED", 0);
	}
		
	if(is_file($iptaccount)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IPTABLES_ACCOUNTING_EXISTS", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IPTABLES_ACCOUNTING_EXISTS", 0);
	}
	if(is_file($sensors_detect)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SENSORS_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SensorsInstalled", 1);
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SENSORS_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SensorsInstalled", 0);
	}
	if(is_file($ziproxy)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ZIPROXY_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ZIPROXY_VERSION", ZIPROXY_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ZIPROXY_INSTALLED", 0);
	}
	
	if(is_file($namebench)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NAMEBENCH_INSTALLED", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NAMEBENCH_INSTALLED", 0);
	}
	

	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IWLWIFI_INSTALLED", 1);


	if(is_file($pdnssec)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PowerDNSSecInstalled", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PowerDNSSecInstalled", 0);
	}





	if(is_file($iwconfig)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IWCONFIG_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IWCONFIG_VERSION", IWCONFIG_VERSION());
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IWCONFIG_INSTALLED", 0);
	}
	
	if(is_file("/usr/share/appdata/artica/VERSION")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_FIRMWARES_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_FIRMWARES_VERSION",trim(@file_get_contents("/usr/share/appdata/artica/VERSION")));
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_FIRMWARES_INSTALLED", 0);
	}

	if(is_file("/usr/local/bin/rdpproxy")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_RDPPROXY_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_RDPPROXY_VERSION", APP_RDPPROXY_VERSION());

	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_RDPPROXY_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_RDPPROXY_VERSION", 0);
	}
	
	
	if(!is_file("/usr/sbin/ss5")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SS5Installed", 0);
	}else{
		if(!is_file("/var/lib/ss5/ss5/mod_socks4.so")){
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SS5Installed", 0);
		}else{
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SS5Installed", 1);
		}
	}
	
	if(IS_INSIDE_VPS()){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("AS_VPS_CLIENT", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("AS_VPS_CLIENT", 0);
	}
	
	if(is_file($ntpd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NTPDInstalled", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NTPDVersion", ntpd_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NTPDInstalled", 0);
	}
	
	if(is_file($fail2ban)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FAIL2BAN_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FAIL2BAN_VERSION", fail2ban_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FAIL2BAN_INSTALLED", 0);
		
	}
	
	if(is_file($vnstat)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_VNSTAT_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_VNSTAT_VERSION", vnstat_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_VNSTAT_INSTALLED", 0);
	
	}	
	
	if(is_file($mountcifs)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CIFS_INSTALLED", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CIFS_INSTALLED", 0);
	}
	
	if(is_file($proftpd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ProFTPDInstalled", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ProFTPDVersion", proftpd_version($proftpd));
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ProFTPDInstalled", 0);
	}
	if(is_file($memcached)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MEMCACHED_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MEMCACHED_VERSION", APP_MEMCACHED_VERSION());
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MEMCACHED_INSTALLED", 0);
	}
	
	if(is_file($letsencrypt)){
		if($GLOBALS["VERBOSE"]){echo "APP_LETSENCRYPT_VERSION --> Installed\n";}
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_LETSENCRYPT_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_LETSENCRYPT_VERSION", APP_LETSENCRYPT_VERSION());
	}else{
		if($GLOBALS["VERBOSE"]){echo "APP_LETSENCRYPT_VERSION --> UNKNOWN\n";}
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_LETSENCRYPT_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_LETSENCRYPT_VERSION", 0);
	}
	
	
	
	
	if(is_file($rsync)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("RSYNC_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("RSYNC_VERSION", rsync_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("RSYNC_INSTALLED", 0);
	}
	
	if(is_file($dhcpd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("DHCPD_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("DHCPDInstalled", 1);
		dhcpd_version();
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("DHCPD_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("DHCPDInstalled", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableDHCPServer", 0);
	}
	
	if(is_file("/usr/share/seafile-server/seahub/seahub/settings.py")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SEAFILE_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SEAFILE_VERSION", SEAFILE_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SEAFILE_INSTALLED", 0);
	}
	
	
	if(is_file($lighttpd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("LIGHTTPD_INSTALLED", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("LIGHTTPD_INSTALLED", 0);
	}
	
	if(is_file("/usr/sbin/wp")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WP_CLIENT_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WP_CLIENT_VERSION",WP_CLIENT_VERSION());
	}

	if(is_file("/usr/sbin/wp-cli.phar")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WP_CLIENT_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WP_CLIENT_VERSION",WP_CLIENT_VERSION());
	}


	
	if(is_file($fireqos)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FIREQOS_INSTALLED", 1);
		$fireqos_version=fireqos_version();
		if($GLOBALS["VERBOSE"]){echo "fireqos_version(): FINAL -- > $fireqos_version\n";}
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FIREQOS_VERSION", $fireqos_version);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FIREQOS_INSTALLED", 0);
	}

	
	if(is_file($java)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("JAVA_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("JAVA_VERSION", java_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("JAVA_INSTALLED", 0);
	}
	
	if(is_file("/usr/share/logstash/logstash-core/versions-gem-copy.yml")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("LOGSTASH_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("LOGSTASH_VERSION", logstash_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("LOGSTASH_INSTALLED", 0);
	}
	
	if(is_file("/usr/share/elasticsearch/modules/reindex/plugin-descriptor.properties")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ELASTICSEARCH_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ELASTICSEARCH_VERSION", elasticsearch_version());
	}
	
	if(is_file($fping)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FPING_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FPING_VERSION", fping_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FPING_INSTALLED", 0);
	}
	
	if(is_file($curlftpfs)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CURLFTPFS_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CURLFTPFS_VERSION", curlftpfs_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CURLFTPFS_INSTALLED", 0);
	}

	
	if(is_file($cicapbin)){
		file_put_contents("/etc/artica-postfix/settings/Daemons/C_ICAP_INSTALLED",1);
		c_icap_master_version();
		if(is_file("/usr/lib/c_icap/dnsbl_tables.so")){
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("C_ICAP_DNSBL", 1);
		}else{
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("C_ICAP_DNSBL", 0);
		}
	}else{
		file_put_contents("/etc/artica-postfix/settings/Daemons/C_ICAP_INSTALLED",0);
	}
	
	$XAPIAN_INSTALLED=false;
	if(is_file("/usr/lib/php/extensions/no-debug-non-zts-20160303/xapian.so")){
		file_put_contents("/etc/artica-postfix/settings/Daemons/XAPIAN_PHP_INSTALLED",1);
		file_put_contents("/etc/artica-postfix/settings/Daemons/XAPIAN_OMINDEX_VERSION",omega_version());
		$XAPIAN_INSTALLED=true;
	}
	if(is_file("/usr/lib/php/20151012/xapian.so")){
		file_put_contents("/etc/artica-postfix/settings/Daemons/XAPIAN_PHP_INSTALLED",1);
		file_put_contents("/etc/artica-postfix/settings/Daemons/XAPIAN_OMINDEX_VERSION",omega_version());
		$XAPIAN_INSTALLED=true;		
	}
	if(!$XAPIAN_INSTALLED){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("XAPIAN_PHP_INSTALLED",0);}

	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FireholInstalled",1);
	if(is_file($firehol)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FireholVersion",FIREHOL_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FireholVersion",0);
	}

	if(is_file($linkbalancerbin)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_LINK_BALANCER_INSTALLED",1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_LINK_BALANCER_VERSION",FIREHOL_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_LINK_BALANCER_INSTALLED",0);
	}

	
	if(is_file($clamd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ClamAVDaemonInstalled", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ClamAVDaemonVersion",_clamd_version());
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ClamAVDaemonInstalled", 0);
	}
	
	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- ".__LINE__." --- \n";}
	if(is_file($netdata)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NetDataInstalled", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_NETDATA_VERSION",netdata_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NetDataInstalled", 0);
		
	}
	
	if(is_file($oinkmaster)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_OINKMASTER_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_OINKMASTER_VERSION",oinkmaster_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_OINKMASTER_INSTALLED", 0);
	}
	
	if(is_file($winbindd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WINBINDD_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_WINBINDD_VERSION",_winbindd_version());		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WINBINDD_INSTALLED", 0);
	}
	
	if(is_file("/usr/share/wsusoffline/sh/versions/installed-version.txt")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WSUSOFFLINE_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WSUSOFFLINE_VERSION", WSUSOFFLINE_VERSION());
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WSUSOFFLINE_INSTALLED", 0);
	}
	
	if(is_file($smbd_bin)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SAMBA_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_SAMBA_VERSION", SAMBA_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SAMBA_INSTALLED", 0);
	}
	
	if(is_file($redis_server)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_REDIS_SERVER_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_REDIS_SERVER_VERSION", redis_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_REDIS_SERVER_INSTALLED", 0);
	}
	

	if(is_file("/opt/dnsfilterd/bin/dnsfilterd")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_DNSFILTERD_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_DNSFILTERD_VERSION",dnsfilterd_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_DNSFILTERD_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableDNSFilterd", 0);
	}
	
	
	if(!is_file($nmap)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NMAPInstalled", 0);
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NMAPInstalled", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NMAPPath", $nmap);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NMAPVersion", nmap_version());
	
	}
	
	if(!is_file("/opt/splunkforwarder/bin/splunk")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_SPLUNK_FORWARDER_INSTALLED", 0);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_SPLUNK_FORWARDER_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_SPLUNK_FORWARDER_VERSION", APP_SPLUNK_FORWARDER_VERSION());
	}
	
	
	if(!is_file("/usr/local/bin/dsc")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PDNSStatsInstalled", 0);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("DSCVersion", __DSC_VERSION());
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("DSC_VERSION", __DSC_VERSION());
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PDNSStatsInstalled", 1);
	}
	if(is_file( "/etc/artica-postfix/KASPERSKY_WEB_APPLIANCE" )){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("KASPERSKY_WEB_APPLIANCE",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("KASPERSKY_WEB_APPLIANCE",0);
	}
	
	if(is_file("/etc/artica-postfix/WEBSECURIZE")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WEBSECURIZE",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WEBSECURIZE",0);
	}
	
	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- ".__LINE__." --- \n";}
	if(!is_file($unbound)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("UnboundInstalled", 0);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("UnboundVersion", unbound_version());
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("UnboundInstalled", 1);
	}
	
	if(is_file("/usr/local/sbin/ulogd")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_ULOGD_INSTALLED",1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("UlogdVersion", __ulogd_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_ULOGD_INSTALLED",0);
	}
	
	if(is_file("/usr/local/ArticaWebConsole/sbin/artica-webconsole")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_NGINX_CONSOLE",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_NGINX_CONSOLE",0);
	}
	
	if(is_file($zip)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_ZIP_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_ZIP_INSTALLED",0);
	}

	if(is_file("/usr/lib/x86_64-linux-gnu/xtables/libxt_ratelimit.so")){
		if($GLOBALS["VERBOSE"]){echo "APP_XTABLES_INSTALLED: TRUE\n";}
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_XTABLES_INSTALLED",1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_XTABLES_VERSION",APP_XTABLES_ADDON_VERSION());
	}else{
		if($GLOBALS["VERBOSE"]){echo "APP_XTABLES_INSTALLED: FALSE\n";}
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_XTABLES_INSTALLED",0);
	}

	
	if(is_file("/usr/local/lib/openvpn-python.so")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_OPENVPN_PYTHON",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_OPENVPN_PYTHON",0);
	}
	
	if(is_file("/usr/local/bin/davserver")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_DAVSERVER",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_DAVSERVER",0);
	}

	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- L.".__LINE__." --- \n";}
	if($GLOBALS["VERBOSE"]){echo "VMWare Tool: $vmware_tool L.".__LINE__." --- \n";}
	if(is_file( $vmware_tool)){
		if($GLOBALS["VERBOSE"]){echo "VMWARE_TOOLS_INSTALLED : YES L.".__LINE__." --- \n";}
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("VMWARE_TOOL_BIN_PATH", $vmware_tool);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("VMWARE_TOOLS_INSTALLED",1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("VMWARE_TOOLS_VERSION",vmtools_version_text());

		if(is_file("/etc/init.d/open-vm-tools")){
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableVMWareTools",1);
		}

		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("VMWARE_TOOLS_INSTALLED",0);
	}
	
	
	if(is_file( $VBoxService )){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_VBOXADDINTION_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_VBOXADDINTION_INSTALLED",0);
	}	
	
	
	if(is_file('/usr/local/bin/wanproxy')){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WANPROXY_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WANPROXY_VERSION", @file_get_contents("/usr/local/bin/wanproxy.version"));
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WANPROXY_INSTALLED", 0);
	}
	if(is_file($kinit)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("KINIT_INSTALLED", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("KINIT_INSTALLED", 0);
	}
	if(is_file($iostat)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IOSTAT_INSTALLED", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IOSTAT_INSTALLED", 0);
	}	
	
	if(is_file("/usr/local/sbin/ipaudit")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IPAUDIT_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IpAuditVersion", __ipaudit_version());
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IPAUDIT_INSTALLED", 0);
	}
	
	
	if(is_file("/usr/sbin/in.tftpd")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("TFTPD_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("TFTPD_VERSION", __tftpd_version());
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("TFTPD_INSTALLED", 0);
	}
	
	if(is_file("/opt/kaspersky/klnagent64/sbin/klnagent")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("KLNAGENT_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("KLNAGENT_VERSION", KLNAGENT_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("KLNAGENT_INSTALLED", 0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("KLNAGENT_VERSION", "");
	}
	

	
	if(is_file("/usr/local/bin/dsc")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PDNSStatsInstalled", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("DSCVersion", pdns_stats_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PDNSStatsInstalled", 0);
	}
	
	
	if(is_file("/opt/ufdbcat/bin/ufdbcatdd")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("UFDBCAT_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("UFDBCAT_VERSION", ufdbcatVersion());
		
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("UFDBCAT_INSTALLED", 0);
	}
	if(is_file("/home/kuu3/UpdateUtility-Console")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("KASPERSKY_UPDATE_UTILITY_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("KASPERSKY_UPDATE_UTILITY_VERSION", APP_UPDATE_UTILITY_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("KASPERSKY_UPDATE_UTILITY_INSTALLED", 0);
	}
	if(is_file("/usr/local/ArticaStats/bin/postgres")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("POSTGRESSQL_INSTALLED", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("POSTGRESSQL_INSTALLED", 0);
	}
	if(is_file($pureftpd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PUREFTP_INSTALLED", 1);
		if(is_file("/etc/pure-ftpd/pureftpd.pdb")){
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PUREFTP_USERS", 1);
		}else{
			$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PUREFTP_USERS", 0);
		}
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PUREFTP_INSTALLED", 0);
	}	
	
	if(is_file($rpc_nfsd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NFS_SERVER_INTSALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NFS_SERVER_INTSALLED",0);
	}
	if(is_file($dstat)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("DSTAT_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("DSTAT_INSTALLED",0);
	}	
	if(is_file($gnuplot)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("GNUPLOT_PNG",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("GNUPLOT_PNG",0);
	}	
	
	
	if(is_file($ntopng)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NtopNGInstalled", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NTOPNG_VERSION",ntopng_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NtopNGInstalled", 0);
	}		
	
	if(is_file($sabnzbdplus)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_SABNZBDPLUS_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_SABNZBDPLUS_INSTALLED",0);
	}	
	
	if(is_file($muninnode)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MUNIN_CLIENT_INSTALLED",1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MUNIN_CLIENT_VERSION",MUNIN_NODE_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MUNIN_CLIENT_INSTALLED",0);
	}	
	if(is_file($php_fpm)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PHPFPM_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("PHPFPM_INSTALLED",0);
	}
	if(is_file($offlineimap)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("offlineimap_installed",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("offlineimap_installed",0);
	}
	if(is_file($postscreen)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("POSTSCREEN_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("POSTSCREEN_INSTALLED",0);
	}	
	if(is_file($ipset)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IPSET_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IPSET_INSTALLED",0);
	}	
	if(is_file($aspell)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ASPELL_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ASPELL_INSTALLED",0);
	}	
	if(is_file($curlftpfs)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CURLFTPFS_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CURLFTPFS_INSTALLED",0);
	}
	if(is_file($smbd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SAMBA_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SAMBA_INSTALLED",0);
	}	
	if(is_file($iptables)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IPTABLES_INSTALLED",1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IPTABLES_VERSION",xIPTABLES_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IPTABLES_INSTALLED",0);
	}
	if(is_file($squid27)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_SQUID27_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_SQUID27_INSTALLED",0);
	}	
	if(is_file($ebtables)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_EBTABLES_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_EBTABLES_INSTALLED",0);
	}
	if(is_file($haproxy)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("HAPROXY_INSTALLED",1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("HAPROXY_VERSION",haproxy_version($haproxy));
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("HAPROXY_INSTALLED",0);
	}	
	if(is_file($freeradius)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FREERADIUS_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FREERADIUS_INSTALLED",0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FREERADIUS_VERSION",FREERADIUS_VERSION());
	}
	if(is_file($ntpdate)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NTPDATE_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NTPDATE_INSTALLED",0);
	}	
	if(is_file($ucarp)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("UCARP_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("UCARP_INSTALLED",0);
	}
	if(is_file($vde_switch)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("VDESWITCH_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("VDESWITCH_INSTALLED",0);
	}	
	if(is_file($suricata)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SURICATA_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SURICATA_INSTALLED",0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SURICATA_VERSION",suricata_version());
		
	}	
	if(is_file($memcached)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MEMCACHED_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MEMCACHED_INSTALLED",0);
	}
	if(is_file($freshclam)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FRESHCLAM_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FRESHCLAM_INSTALLED",0);
	}
	if(is_file($wifidog)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WIFIDOG_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WIFIDOG_INSTALLED",0);
	}
	if(is_file($ftp_proxy)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_FTP_PROXY",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_FTP_PROXY",0);
	}	
	if(is_file("/usr/share/filez/index.php")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_FILEZ_WEB",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_FILEZ_WEB",0);
	}
	
	if(is_file("/etc/artica-postfix/OPENVPN_APPLIANCE")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("OPENVPN_APPLIANCE",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("OPENVPN_APPLIANCE",0);
	}

	if(is_file("$openvpn_bin")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("OPENVPN_INSTALLED",1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_OPENVPN_VERSION",APP_OPENVPN_VERSION());
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("OpenVPNVersion",APP_OPENVPN_VERSION());
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("OPENVPN_INSTALLED",0);
	}
	
	
	if(is_file("/etc/artica-postfix/WORDPRESS_APPLIANCE")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WORDPRESS_APPLIANCE",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WORDPRESS_APPLIANCE",0);
	}	
	if(is_file("/usr/share/wordpress-src/wp-includes/version.php")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WORDPRESS_INSTALLED",1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WORDPRESS_SRC_VERSION",WORDPRESS_SRC_VERSION());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WORDPRESS_INSTALLED",0);
	}	
	
	
	if(is_file($miltergreylist)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MILTERGREYLIST_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MILTERGREYLIST_INSTALLED",0);
	}
	if(is_file($iscsid)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ISCSID_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ISCSID_INSTALLED",0);
	}

	if(is_file($arpd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ARPD_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ARPD_INSTALLED",0);
	}
	if(is_file($cgrulesengd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CGROUPS_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CGROUPS_INSTALLED",0);
	}	
	if(is_file($hostapd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("HOSTAPD_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("HOSTAPD_INSTALLED",0);
	}	
	if(is_file($hostapd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("HOSTAPD_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("HOSTAPD_INSTALLED",0);
	}	
	
	if(is_file($losetup)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("LOSETUP_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("LOSETUP_INSTALLED",0);
	}
	if(is_file($vconfig)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("VLAN_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("VLAN_INSTALLED",0);
	}
	if(is_file($iscsiadm)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ISCSI_CLIENT_INSTALLED",1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ISCSI_INSTALLED",1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ISCSI_VERSION",iscsi_version());
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ISCSI_CLIENT_INSTALLED",0);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ISCSI_INSTALLED",0);
	}

	if(is_file($targetcli)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ISCSI_TARGETCLI_INSTALLED",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ISCSI_TARGETCLI_INSTALLED",0);
	}
	
	
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("dbus_daemon_version",dbus_daemon_version());
	
	if(is_file($monitbin)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MONIT_INSTALLED", 1);
		$vv=monit_daemon_version();
		if($GLOBALS["VERBOSE"]){echo "SAVING APP_MONIT_VERSION -> $vv\n";}
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_MONIT_VERSION",$vv);
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MONIT_INSTALLED", 0);
	}

	if(is_file("$doh_server")){
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_DOH_SERVER_INSTALLED",1);
	}else{
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_DOH_SERVER_INSTALLED",0);
	}
	
	
	
	
	if(is_file("/usr/share/RichFilemanager/package.json")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("RICHFILEMANAGER_INSTALLED",1);
		$class=json_decode(@file_get_contents("/usr/share/RichFilemanager/package.json"));
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("RICHFILEMANAGER_VERSION",$class->version);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("RICHFILEMANAGER_INSTALLED",0);
	}
		
	
	
	if(is_file($ufdbguardd_path)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_UFDBGUARD_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("UFDBDaemonVersion", _ufdbguardd_version());
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_UFDBGUARD_INSTALLED", 0);
	}
	
	
	if(is_file("/usr/share/kibana/package.json")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_KIBANA_INSTALLED", 1);
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("APP_KIBANA_VERSION",kibana_version());
		
	}
	
	
	if(is_file($ipset)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IPSetInstalled",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("IPSetInstalled",0);
	}

//************************************************************************************************************
	if(is_file($msktutil)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MSKTUTIL_INSTALLED",1);
		if($GLOBALS["VERBOSE"]){echo "MSKTUTIL_VERSION -> ...\n";}
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MSKTUTIL_VERSION",__MSKTUTIL_VERSION());
	}else{
		if($GLOBALS["VERBOSE"]){echo "MSKTUTIL_VERSION -> NOT INSTALLED...\n";}
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MSKTUTIL_INSTALLED",0);
	}

//************************************************************************************************************
	if(is_file("/lib/modules/$KERNEL_VERSION/extra/xt_ndpi.ko")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("iptablesNDPI",1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("iptablesNDPI",0);
	}
//************************************************************************************************************
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableMsftncsi")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableMsftncsi",1);
		$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("artica-msftncsi",
				"* * * * *","exec.msftncsi.php");
		shell_exec2("/etc/init.d/cron reload");
	}else{
		$EnableMsftncsi=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableMsftncsi"));
		if($EnableMsftncsi==0){
			if(is_file("/etc/cron.d/artica-msftncsi")){
				@unlink("/etc/cron.d/artica-msftncsi");
				shell_exec2("/etc/init.d/cron reload");
			}
		}else{
			if(!is_file("/etc/cron.d/artica-msftncsi")){
				$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("artica-msftncsi",
					"* * * * *","exec.msftncsi.php");
				shell_exec2("/etc/init.d/cron reload");
			}
		}
	}
//************************************************************************************************************
	if(!is_file("/etc/cron.d/artica-check-repositories")){
		$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("artica-check-repositories",
			"*/30 * * * *","exec.check.repositories.php");
		shell_exec2("/etc/init.d/cron reload");

	}
//************************************************************************************************************
	if(!is_file("/etc/cron.d/artica-clean-postgresql")){
		$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("artica-clean-postgresql",
			"30 3 * * *","exec.clean.postgres.php");
		shell_exec2("/etc/init.d/cron reload");

	}
//************************************************************************************************************

	
	
	
	
	if(!is_file($cgrulesengd)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CGROUPS_INSTALLED", 0);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("CGROUPS_INSTALLED", 1);
	}
	
	if(!is_file("/usr/lib/apache2/modules/mod_cband.so")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ApacheModCbandInstalled", 0);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("ApacheModCbandInstalled", 1);
	}
	
	if(is_file("/usr/local/ArticaStats/bin/postgres")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("StatsPostGres", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("StatsPostGres", 0);
	}

	if(is_file("/etc/monit/conf.d/APP_SLAPD.monitrc")){
		@unlink("/etc/monit/conf.d/APP_SLAPD.monitrc");
		shell_exec("/etc/init.d/monit reload");
	}
	
	
	if(is_file("/etc/cron.d/access-failed-parser")){@unlink("/etc/cron.d/access-failed-parser");}
	if(is_file("/etc/cron.d/access-logs-parser")){@unlink("/etc/cron.d/access-logs-parser");}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableWebFTPFilter")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableWebFTPFilter", 0);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableDNSPerfs")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableDNSPerfs", 1);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableSquidQuotasBandwidth")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableSquidQuotasBandwidth", 0);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/SquidQuotaBandwidthRefresh")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SquidQuotaBandwidthRefresh", 30);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableMacAddressFilter")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableMacAddressFilter", 1);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/InfluxSyslogRemote")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("InfluxSyslogRemote", 0);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableSuricata")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableSuricata", 0);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/cgroupsEnabled")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("cgroupsEnabled", 0);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/cgroupsEnabled")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("cgroupsEnabled", 0);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableClamavUnofficial")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableClamavUnofficial", 0);}
	
	$EnableClamavUnofficial=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableClamavUnofficial"));
	
	if(!is_file("/etc/nginx/certificates/dhparam.pem")){
		if(!is_dir("/etc/nginx/certificates")){@mkdir("/etc/nginx/certificates",0755,true);}
		if(!$GLOBALS["CLASS_UNIX"]->process_exists($GLOBALS["CLASS_UNIX"]->PIDOF($openssl))){
			system("$nohup $openssl dhparam -outform PEM -out /etc/nginx/certificates/dhparam.pem 2048 >/dev/null 2>&1");
		}
	
	}
	
	
	
	if($EnableClamavUnofficial==1){
		if(!is_file("/etc/cron.d/clamav-unofficial-sigs-cron")){
			$CRON[]="MAILTO=\"\"";
			$CRON[]="45 * * * * root /usr/share/artica-postfix/bin/clamav-unofficial-sigs.sh -c /etc/clamav-unofficial-sigs.conf >/dev/null 2>&1";
			$CRON[]="";
			file_put_contents("/etc/cron.d/clamav-unofficial-sigs-cron",@implode("\n", $CRON));
			$CRON=array();
			chmod("/etc/cron.d/clamav-unofficial-sigs-cron",0640);
			chown("/etc/cron.d/clamav-unofficial-sigs-cron","root");
			shell_exec2("/etc/init.d/cron reload");
		}
	}
	
	if($EnableClamavUnofficial==0){
		if(is_file("/etc/cron.d/clamav-unofficial-sigs-cron")){
			@unlink("/etc/cron.d/clamav-unofficial-sigs-cron");
			shell_exec2("/etc/init.d/cron reload");
		}
	}
	
	if(!is_file("/usr/local/bin/load_balance.pl")){
		$DEBIAN_VERSION=$GLOBALS["CLASS_UNIX"]->DEBIAN_VERSION();
		$tgz="/usr/share/artica-postfix/bin/install/netbalance-debian{$DEBIAN_VERSION}.tar.gz";
		if(is_file($tgz)){
			system("$tar -xhf $tgz -C /");
			squid_admin_mysql(1, "Installed Net Balance package for Debian $DEBIAN_VERSION", null,__FILE__,__LINE__);
		}
	}
	
	if(is_file("/usr/local/bin/load_balance.pl")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NETBALANCE_INSTALLED", 1);
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NETBALANCE_INSTALLED", 0);
	}	
	
	if(!is_file("/etc/artica-postfix/settings/Daemons/HdparmInfos")){
		@mkdir("/etc/artica-postfix/settings/Daemons",0755,true);
		shell_exec("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.hdparm.php --force >/dev/null 2>&1 &");
	}
	
	if($GLOBALS["VERBOSE"]){echo "PROCESS 1 --- DONE --- \n";}

}

function var_lib_php(){
	$unix=new unix();
	$df=$unix->find_program("df");
	exec("$df /var/lib/php5 2>&1",$results);
	$percent=0;
	foreach ($results as $cidr=>$none){
		if(preg_match("#.*?\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)%\s+#", $none,$re)){
			$percent=$re[4];
			break;
		}
	}
	
	if($percent<92){return;}
	squid_admin_mysql(1, "/var/lib/php5 partition size execeed 92% ({$percent}%) [action=clean]", @implode("\n", $results),__FILE__,__LINE__);
	$files=$unix->DirFiles("/var/lib/php5");

	@unlink("/usr/share/artica-postfix/ressources/logs/php.log");
	@touch("/usr/share/artica-postfix/ressources/logs/php.log");
	
	foreach ($files as $filename=>$none){
		$fullpath="/var/lib/php5/$filename";
		$time=$unix->file_time_min($fullpath);
		if($time>15){@unlink($fullpath);continue;}
	
	}
	
}

function buildCronStatistics(){
	$ENABLED=true;
	$SquidPerformance=0;
	$SquidStatsMonthQueue=0;
	$AsStatsAppliance=0;
	
	// if > 1 then no stats $SquidPerformance
	$InfluxSyslogRemote=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("InfluxSyslogRemote"));
	$InfluxUseRemote=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("InfluxUseRemote"));

	if($InfluxUseRemote==0){$InfluxSyslogRemote=0;}
	
	if(is_file("/etc/artica-postfix/STATS_APPLIANCE")){
		$InfluxUseRemote=0;
		$SquidPerformance=0;
		$AsStatsAppliance=1;
	}
	
	if($AsStatsAppliance==1){
		$time_file=$GLOBALS["CLASS_UNIX"]->file_time_min("/usr/share/artica-postfix/ressources/interface-cache/suricata.dashboard");
		if($time_file>15){
			$cmd=trim("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.suricata.php --dashboard >/dev/null 2>&1 &");
			shell_exec2($cmd);
		}
	}
	
	
	
	
	
	if($InfluxUseRemote==1){$ENABLED=false;}
	if($SquidPerformance>1){$ENABLED=false;}
	
	if($ENABLED){
		if(!is_file("/etc/cron.d/statistics-monthly")){
			$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("statistics-monthly","15 1 * * *","exec.squid.stats.compress.php");
			shell_exec2("/etc/init.d/cron reload");
		}
		if(!is_file("/etc/cron.d/statistics-yearly")){
			$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("statistics-yearly","30 3 1 * *","exec.squid.stats.compress.php --compress-year");
			shell_exec2("/etc/init.d/cron reload");
		}		
		
		
		buildCronStatistics_run();
		buildCronStatistics_year_run();
	}
	
	if(!$ENABLED){
		if(is_file("/etc/cron.d/statistics-monthly")){
			@unlink("/etc/cron.d/statistics-monthly");
			shell_exec2("/etc/init.d/cron reload");
		}
		if(is_file("/etc/cron.d/statistics-yearly")){
			@unlink("/etc/cron.d/statistics-yearly");
			shell_exec2("/etc/init.d/cron reload");
		}
		
	}
	
}
function buildCronStatistics_run(){
	if(!is_file("/etc/artica-postfix/settings/Daemons/SquidStatsMonthQueue")){return;}
	$SquidStatsMonthQueue=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidStatsMonthQueue"));
	if($SquidStatsMonthQueue==0){return;}
	if(system_is_overloaded()){return;}
	$pidfile="/etc/artica-postfix/pids/SquidStatsMonthQueue.pid";
	$pidTime="/etc/artica-postfix/pids/SquidStatsMonthQueue.time";
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file($pidfile);
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return;}
	$timeExec=$GLOBALS["CLASS_UNIX"]->file_time_min($pidTime);
	if($timeExec<15){return;}
	$cmd="{$GLOBALS["NICE"]}{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.squid.stats.compress.php >/dev/null 2>&1 &";
	shell_exec2(trim($cmd));
}
function buildCronStatistics_year_run(){
	
	$cmd="{$GLOBALS["NICE"]}{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.squid.stats.compress.php --compress-year >/dev/null 2>&1 &";
	if(!is_file("/etc/artica-postfix/settings/Daemons/SquidStatsYearQueue")){return;}
	$SquidStatsYearQueue=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidStatsYearQueue"));
	if($SquidStatsYearQueue==0){return;}
	if(system_is_overloaded()){return;}
	$pidfile="/etc/artica-postfix/pids/SquidStatsYearQueue.pid";
	$pidTime="/etc/artica-postfix/pids/SquidStatsYearQueue.time";
	$pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file($pidfile);
	if($GLOBALS["CLASS_UNIX"]->process_exists($pid)){return;}
	$timeExec=$GLOBALS["CLASS_UNIX"]->file_time_min($pidTime);
	if($timeExec<15){return;}
	shell_exec2(trim($cmd));
}

function VMWARETOOLS_BIN(){
   
   if(is_file("/usr/sbin/vmware-guestd")){return "/usr/sbin/vmware-guestd";}
   if(is_file("/usr/bin/vmware-toolbox-cmd")){return "/usr/bin/vmware-toolbox-cmd";}
   if(is_file("/usr/lib/vmware-tools/bin32/vmware-user-loader")){return "/usr/lib/vmware-tools/bin32/vmware-user-loader";}
   if(is_file("/usr/bin/vmtoolsd")){return "/usr/bin/vmtoolsd";}
   if(is_file("/usr/sbin/vmtoolsd")){return "/usr/sbin/vmtoolsd";} 

}

function NTOPNG_INTERFACES(){
	$CacheFile="/etc/artica-postfix/settings/Daemons/NTOPNG_INTERFACES";
	$TimeExec=$GLOBALS["CLASS_UNIX"]->file_time_min($CacheFile);
	if($TimeExec<120){return;}
	
	$masterbin=$GLOBALS["CLASS_UNIX"]->find_program("ntopng");
	exec("$masterbin -h 2>&1",$results);
	foreach ($results as $index=>$ligne){
		if(preg_match("#\s+([0-9])\.\s+(.+)#", $ligne,$re)){
			$arrayINT[trim($re[2])]=$re[1];
		}
	}
	
	@unlink($CacheFile);
	@file_put_contents($CacheFile, serialize($arrayINT));
	
}
function IS_QEMU_HOST(){
	if(is_file("/etc/artica-postfix/QEMU_HOST")){
		$xtime=$GLOBALS["CLASS_UNIX"]->file_time_get("/etc/artica-postfix/QEMU_HOST");
		if($xtime>120){@unlink("/etc/artica-postfix/QEMU_HOST");}
	}
	if(is_file("/etc/artica-postfix/QEMU_HOST")){
		return intval(@file_get_contents("/etc/artica-postfix/QEMU_HOST"));
	}
		
	if(is_file("/etc/artica-postfix/dmidecode-type-1.cache")){
		$xtime=$GLOBALS["CLASS_UNIX"]->file_time_get("/etc/artica-postfix/dmidecode-type-1.cache");
		if($xtime>480){@unlink("/etc/artica-postfix/dmidecode-type-1.cache");}
	}
	if(is_file("/etc/artica-postfix/dmidecode-type-1.cache")){
		$results=unserialize(@file_get_contents("/etc/artica-postfix/dmidecode-type-1.cache"));
		 
	}else{
		$dmidecode=$GLOBALS["CLASS_UNIX"]->find_program('dmidecode');
		if (!is_file("$dmidecode")){return 0;}
		exec("$dmidecode --type 1 2>&1",$results);
		@file_put_contents("/etc/artica-postfix/dmidecode-type-1.cache", serialize($results));
	}	
	
	foreach($results as $line){
		if(preg_match("#Manufacturer: QEMU#i",$line)){
			@file_put_contents("/etc/artica-postfix/QEMU_HOST",1);
			return 1;
		}
	}
	
	@file_put_contents("/etc/artica-postfix/QEMU_HOST",0);
	return 0;
	
	
}

function IS_VMWARE_HOST(){
	if(is_file("/etc/artica-postfix/VMWARE_NOHOST")){
		@unlink("/etc/artica-postfix/VMWARE_HOST");
		@unlink("/etc/artica-postfix/VMWARE_NOHOST");
	}
	
   	if(is_file("/etc/artica-postfix/VMWARE_HOST")){
   		$xtime=$GLOBALS["CLASS_UNIX"]->file_time_get("/etc/artica-postfix/VMWARE_HOST");
   		if($xtime>120){@unlink("/etc/artica-postfix/VMWARE_HOST");}
   	}
   	if(is_file("/etc/artica-postfix/VMWARE_HOST")){
   		$data=trim(@file_get_contents("/etc/artica-postfix/VMWARE_HOST"));
   		if(is_numeric($data)){return intval($data);}
   	}
   	
   	if(is_file("/etc/artica-postfix/dmidecode-type-1.cache")){
   		$xtime=$GLOBALS["CLASS_UNIX"]->file_time_get("/etc/artica-postfix/dmidecode-type-1.cache");
   		if($xtime>480){@unlink("/etc/artica-postfix/dmidecode-type-1.cache");}
   	}
   	if(is_file("/etc/artica-postfix/dmidecode-type-1.cache")){
   		$results=unserialize(@file_get_contents("/etc/artica-postfix/dmidecode-type-1.cache"));
   		
   	}else{
   		$dmidecode=$GLOBALS["CLASS_UNIX"]->find_program('dmidecode');
   		if (!is_file("$dmidecode")){return 0;}
   		exec("$dmidecode --type 1 2>&1",$results);
   		@file_put_contents("/etc/artica-postfix/dmidecode-type-1.cache", serialize($results));
   	}
   
   foreach($results as $line){
		if(preg_match("#VMware Virtual Platform#i",$line)){
			@file_put_contents("/etc/artica-postfix/VMWARE_HOST",1);
			return 1;
		}
   }
	@file_put_contents("/etc/artica-postfix/VMWARE_HOST",0);
	return 0;
}
//############################################################################## 
function IS_VIRTUALBOX_HOST(){
	if(is_file("/etc/artica-postfix/VIRTUALBOX_NOHOST")){
		@unlink("/etc/artica-postfix/VIRTUALBOX_HOST");
		@unlink("/etc/artica-postfix/VIRTUALBOX_NOHOST");
	}

	if(is_file("/etc/artica-postfix/VIRTUALBOX_HOST")){
		$xtime=$GLOBALS["CLASS_UNIX"]->file_time_get("/etc/artica-postfix/VIRTUALBOX_HOST");
		if($xtime>120){@unlink("/etc/artica-postfix/VIRTUALBOX_HOST");}
	}
	if(is_file("/etc/artica-postfix/VIRTUALBOX_HOST")){
		$data=trim(@file_get_contents("/etc/artica-postfix/VIRTUALBOX_HOST"));
		if($GLOBALS["VERBOSE"]){echo "L.".__LINE__." VIRTUALBOX_HOST='$data'\n";}
		if(is_numeric($data)){return intval($data);}
	}

	if(is_file("/etc/artica-postfix/dmidecode-type-1.cache")){
		$xtime=$GLOBALS["CLASS_UNIX"]->file_time_get("/etc/artica-postfix/dmidecode-type-1.cache");
		if($xtime>480){@unlink("/etc/artica-postfix/dmidecode-type-1.cache");}
	}
	if(is_file("/etc/artica-postfix/dmidecode-type-1.cache")){
		$results=unserialize(@file_get_contents("/etc/artica-postfix/dmidecode-type-1.cache"));
		 
	}else{
		$dmidecode=$GLOBALS["CLASS_UNIX"]->find_program('dmidecode');
		if (!is_file("$dmidecode")){return 0;}
		exec("$dmidecode --type 1 2>&1",$results);
		@file_put_contents("/etc/artica-postfix/dmidecode-type-1.cache", serialize($results));
	}
	 
	foreach($results as $line){
		if(preg_match("#VirtualBox#",$line)){
			@file_put_contents("/etc/artica-postfix/VIRTUALBOX_HOST",1);
			return 1;
		}
	}
	@file_put_contents("/etc/artica-postfix/VIRTUALBOX_HOST",0);
	return 0;
}

function IS_HYPERV_HOST(){
	if(is_file("/etc/artica-postfix/HYPERV_NOHOST")){
		@unlink("/etc/artica-postfix/HYPERV_HOST");
		@unlink("/etc/artica-postfix/HYPERV_NOHOST");
	}

	if(is_file("/etc/artica-postfix/HYPERV_HOST")){
		$xtime=$GLOBALS["CLASS_UNIX"]->file_time_get("/etc/artica-postfix/HYPERV_HOST");
		if($xtime>120){@unlink("/etc/artica-postfix/HYPERV_HOST");}
	}
	if(is_file("/etc/artica-postfix/HYPERV_HOST")){
		$data=trim(@file_get_contents("/etc/artica-postfix/HYPERV_HOST"));
		if(is_numeric($data)){return intval($data);}
	}

	if(is_file("/etc/artica-postfix/dmidecode-type-1.cache")){
		$xtime=$GLOBALS["CLASS_UNIX"]->file_time_get("/etc/artica-postfix/dmidecode-type-1.cache");
		if($xtime>480){@unlink("/etc/artica-postfix/dmidecode-type-1.cache");}
	}
	if(is_file("/etc/artica-postfix/dmidecode-type-1.cache")){
		$results=unserialize(@file_get_contents("/etc/artica-postfix/dmidecode-type-1.cache"));
			
	}else{
		$dmidecode=$GLOBALS["CLASS_UNIX"]->find_program('dmidecode');
		if (!is_file("$dmidecode")){return 0;}
		exec("$dmidecode --type 1 2>&1",$results);
		@file_put_contents("/etc/artica-postfix/dmidecode-type-1.cache", serialize($results));
	}

	foreach($results as $line){
		if(preg_match("#Microsoft Corporation#",$line)){
			@file_put_contents("/etc/artica-postfix/HYPERV_HOST",1);
			return 1;
		}
	}
	@file_put_contents("/etc/artica-postfix/HYPERV_HOST",0);
	return 0;
}

function LOGROTATE(){

}

function QEMU_MONIT(){
	//
	if(!is_file("/etc/init.d/qemu-guest-agent")){
		if(is_file("/etc/monit/conf.d/APP_QEMU_CLIENT.monitrc")){
			@unlink("/etc/monit/conf.d/APP_QEMU_CLIENT.monitrc");
			system("/etc/init.d/monit restart");
		}
		return;
	}
	if(is_file("/etc/monit/conf.d/APP_QEMU_CLIENT.monitrc")){return;}
	
	$f[]="check process APP_QEMU_CLIENT with pidfile /var/run/qemu-ga.pid";
	$f[]="\tstart program = \"/etc/init.d/qemu-guest-agent start\"";
	$f[]="\tstop program = \"/etc/init.d/qemu-guest-agent stop\"";
	$f[]="\tif 5 restarts within 5 cycles then timeout";
	$f[]="";
	@file_put_contents("/etc/monit/conf.d/APP_QEMU_CLIENT.monitrc", @implode("\n", $f));
	system("/etc/init.d/monit restart");
	
	
}


function PERSONAL_CATEGORIES_CRON(){

	if(!is_file("/etc/cron.d/letsencrypt-renew")){
		$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("letsencrypt-renew","45 2 * * *","exec.letsencrypt.renew.php");
		system("/etc/init.d/cron reload");
	}

	if(!is_file("/etc/cron.d/clean-databases")){
		$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("clean-databases","0 0,4,8,12,16 * * *","exec.mysql.clean.php");
		system("/etc/init.d/cron reload");
	}

	$DNSAmplificationProtection=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DNSAmplificationProtection"));
	$EnablePersonalCategories=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnablePersonalCategories"));


	if($DNSAmplificationProtection==1){
		if(!is_file("/etc/cron.d/DNSAmplificationProtection")){
			$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("categories-maintenance","5 * * * *","exec.dns-amplification.php --blacklists");
			system("/etc/init.d/cron reload");
		}
	}else{
		if(is_file("/etc/cron.d/DNSAmplificationProtection")){
			@unlink("/etc/cron.d/DNSAmplificationProtection");
			system("/etc/init.d/cron reload");
		}

	}



	if($EnablePersonalCategories==1){
		if(!is_file("/etc/cron.d/categories-maintenance")){
			$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("categories-maintenance","30 */2 * * *","exec.categories.maintenance.php");
			system("/etc/init.d/cron reload");
		}
	}else{
		if(is_file("/etc/cron.d/categories-maintenance")){
			@unlink("/etc/cron.d/categories-maintenance");
			system("/etc/init.d/cron reload");
		}
	}

}

function IS_INSIDE_VPS(){
	if(is_file('/proc/vz/veinfo')){return true;}
	if(is_file('/proc/vz/version')){return true;}
	if(is_dir('/proc/xen')){return true;}
	if(is_file('/proc/1/cgroup')){
		exec('/bin/cat /proc/1/cgroup 2>&1',$results);
		if(preg_match("#cpuset:/(.*)$#", @implode(" ", $results))){ return true;}
		}
}	
function SIEVE_PORT(){
	if(isset($GLOBALS[__FUNCTION__])){return $GLOBALS[__FUNCTION__];}
	$f=explode("\n","/etc/services");
	foreach ($f as $line){
		if(preg_match("#^sieve\s+([0-9]+)#", $line,$re)){
			$GLOBALS[__FUNCTION__]=$re[1];
			return $re[1];
		}
		
	}
	$GLOBALS[__FUNCTION__]=null;
	
}

function LIST_SWAPS()
{

	$ARRAY = array();
	$f = explode("\n", @file_get_contents("/proc/swaps"));
	foreach ($f as $line) {
		if (!preg_match("#(.*?)\s+(.+?)\s+([0-9]+)\s+([0-9]+)\s+(.+?)$#", $line, $re)) {
			continue;
		}

		$ARRAY[$re[1]]["TYPE"] = $re[2];
		$ARRAY[$re[1]]["SIZE"] = $re[3];
		$ARRAY[$re[1]]["USED"] = $re[4];
		$ARRAY[$re[1]]["PRIO"] = $re[5];


	}

	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("SWAP_PARTITIONS", serialize($ARRAY));


	$unix = new unix();
	if (!is_file("/etc/cron.d/postgres-size")) {
		$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("postgres-size", "0,10,20,30,40,50 * * * *", "exec.PostgreSQL-failed.php --pg-size");
	}

	if(!is_file("/etc/cron.d/squid-rotate")) {
		$LogRotateH = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LogRotateH"));
		$LogRotateM = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LogRotateM"));
		$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("squid-rotate", "$LogRotateM $LogRotateH * * *", "exec.squid.php --rotate --byschedule");
	}

}



?>

