<?php
function memcached(){
    include_once(dirname(__FILE__)."/class.status.daemons.inc");
    udev();
    dbus();

	if(!is_file("/etc/init.d/memcached")){return;}
	
	$EnableMemcached=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableMemcached"));
	$master_pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/memcached.pid");
	

	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		$memcached=$GLOBALS["CLASS_UNIX"]->find_program("memcached");
		$master_pid=$GLOBALS["CLASS_UNIX"]->PIDOF($memcached,true);
	}


	$l[]="";
	$l[]="";
	$l[]="[APP_MEMCACHED]";
	$l[]="service_name=APP_MEMCACHED";
	$l[]="master_version=".trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("APP_MEMCACHED_VERSION"));
	$l[]="service_disabled=$EnableMemcached";
	$l[]="watchdog_features=1";
	$l[]="family=system";
	$l[]="service_cmd=/etc/init.d/memcached";
	
	if(!is_file("/etc/monit/conf.d/APP_MEMCACHED.monitrc")){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			squid_admin_mysql(1, "Memcached not correctly installed,  [action=install]", null,__FILE__,__LINE__);
			shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.memcached.php --install");
		}
	}
	

	if($EnableMemcached==0){
		$l[]="";
		return implode("\n",$l);
		
	}

	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			squid_admin_mysql(0, "Memcached daemon not running [action=start]", null,__FILE__,__LINE__);
			shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} /etc/init.d/memcached start");
		}
		$l[]="running=0";
		return implode("\n",$l);
	}


	if(!$GLOBALS["CLASS_UNIX"]->is_socket("/var/run/memcached.sock")){
		if(!$GLOBALS["DISABLE_WATCHDOG"]){
			shell_exec2("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} /etc/init.d/memcached restart");
		}
	}else{
		@chmod("/var/run/memcached.sock",0777);
	}

	$l[]="running=1";
	$l[]=GetMemoriesOf($master_pid);
	$l[]="";
	return implode("\n",$l);
}