<?php


function Drovorub_checks(){

    if(!is_file("/root/drovorubtest")){
        $touch=$GLOBALS["CLASS_UNIX"]->find_program("touch");
        shell_exec("$touch /root/drovorubtest");
    }
    $echo=$GLOBALS["CLASS_UNIX"]->find_program("echo");
    shell_exec("$echo \"ASDFZXCV:hf:drovorubtest\" >/dev/zero");
    sleep(1);
    if(!is_file("/root/drovorubtest")){
        squid_admin_mysql(0,"ALERT: Suspicious Malware Drovorub found in Artica system");
    }
}

//========================================================================================
function monit(){
    Drovorub_checks();
	if(!is_file("/etc/artica-postfix/settings/Daemons/EnableMonit")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableMonit", 1);}
	$bin=$GLOBALS["CLASS_UNIX"]->find_program("monit");
	if(!is_file($bin)){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MONIT_INSTALLED", 0);
		$l[]="[APP_MONIT]";
		$l[]="service_name=APP_MONIT";
		$l[]="installed=0";
		$l[]="service_disabled=0";
		return implode("\n",$l);
		
		
	}else{
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("MONIT_INSTALLED", 1);
	}

	@chmod("/var/run/artica-phpfpm.sock",0777);
	$EnableDaemon=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableMonit"));
	$master_pid=$GLOBALS["CLASS_UNIX"]->get_pid_from_file("/var/run/monit/monit.pid");


	if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		$master_pid=$GLOBALS["CLASS_UNIX"]->PIDOF($bin,true);
	}
	if($EnableDaemon==0){if($GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
		shell_exec2("/etc/init.d/monit stop");}}

		$l[]="[APP_MONIT]";
		$l[]="service_name=APP_MONIT";
		$l[]="master_version=".$GLOBALS["CLASS_SOCKETS"]->GET_INFO("APP_MONIT_VERSION");
		$l[]="service_disabled=$EnableDaemon";
		$l[]="watchdog_features=1";
		$l[]="service_cmd=/etc/init.d/monit";
		$l[]="family=system";
		$l[]="installed=1";

		if($EnableDaemon==0){$l[]="";return implode("\n",$l);return;}

		if(!$GLOBALS["CLASS_UNIX"]->process_exists($master_pid)){
			if($GLOBALS["VERBOSE"]){echo " **** NO RUNNING ****\n";}
			if(!$GLOBALS["DISABLE_WATCHDOG"]){
				shell_exec2("/etc/init.d/monit start");
			}
			$l[]="running=0";
			$l[]="";
			return implode("\n",$l);
		}

		$AS_CGROUP=false;
		if($GLOBALS["CLASS_SOCKETS"]->EnableIntelCeleron==1){$AS_CGROUP=true;}
		if($AS_CGROUP){
			events("mysqld cgroup must be enabled ....",__FUNCTION__,__LINE__);
			$cgroups=new status_cgroups();
			$limit=$cgroups->GetLimit($master_pid);
			if($cgroups->GetLimit($master_pid)=="unlimited"){
				$cgroups->set_limit("php", $master_pid);
			}

		}
		
		$EnableMunin=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableMunin"));
		if($EnableMunin==1){
			if(!is_file("/etc/munin/plugins/monit_parser")){
				if(is_file("/usr/share/artica-postfix/bin/install/munin/monit_parser")){
					squid_admin_mysql(0, "Munin for Monit not configured [action=reconfigure]", null,__FILE__,__LINE__);
					shell_exec("{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.munin.php --reconfigure");
				}
			}
		}
		
		
		
		
		
		if(!is_file("/etc/cron.d/monit-watchdog")){
			$GLOBALS["CLASS_UNIX"]->Popuplate_cron_make("monit-watchdog", "2,4,6,8,10,12,14,16,18,20,22,24,26,28,30,32,34,36,38,40,42,44,46,48,50,52,54,56,58 * * * *", "exec.monit.php --status");
			shell_exec("/etc/init.d/cron reload");
		}


		$l[]=GetMemoriesOf($master_pid);
		$l[]="running=1";
		$monit=new monit_unix();
		$monit->WAKEUP();
		
		$SQUIDEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable"));
		if($SQUIDEnable==0){
			if(is_file("/etc/monit/conf.d/APP_SQUID.monitrc")){
				@unlink("/etc/monit/conf.d/APP_SQUID.monitrc");
				shell_exec("monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid -s /var/run/monit/monit.state reload");
			}
		}
		$EnableNginx=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableNginx"));
		if($EnableNginx==0){
			if(is_file("/etc/monit/conf.d/APP_NGINX.monitrc")){
				@unlink("/etc/monit/conf.d/APP_NGINX.monitrc");
				shell_exec("monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid -s /var/run/monit/monit.state reload");
			}
		}
		
		
		return implode("\n",$l);
}
//========================================================================================================================================================
