<?php


function etc_hosts(){
    $DisableNetworking=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DisableNetworking"));
    if($DisableNetworking==1){return;}
    $prfix="{$GLOBALS["NICE"]}{$GLOBALS["PHP5"]} /usr/share/artica-postfix";
    $EnableipV6=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableipV6"));
    $myhostname=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("myhostname"));
    $myhostnameRegex=str_replace(".","\.",$myhostname);


    $f=explode("\n",@file_get_contents("/etc/hosts"));
    $IPv6Found=false;
    $myhostnameFound=false;
    $localhostFound=false;
    foreach ($f as $line){
        $line=trim($line);
        if($line==null){continue;}
        if(preg_match("#::1\s+#",$line)){
            $IPv6Found=true;
            continue;
        }
        if(preg_match("#^[a-z0-9]+::[0-9]++\s+#",$line)){
            $IPv6Found=true;
            continue;
        }
        if(preg_match("#$myhostnameRegex#i",$line)){
            $myhostnameFound=true;
            continue;
        }

        if(preg_match("#\s+localhost#i",$line)){
            $localhostFound=true;
            continue;
        }
    }

    if($EnableipV6==0){
        if($IPv6Found){
            squid_admin_mysql(0,"Patching hosts file (Ipv6 is disabled)",@implode("\n",$f),
                    __FILE__,__LINE__);
            shell_exec("$prfix/exec.virtuals-ip.php --hosts >/dev/null 2>&1 &");
        }
    }
    if($EnableipV6==1){
        if(!$IPv6Found){
            squid_admin_mysql(0,"Patching hosts file (Ipv6 is enabled)",@implode("\n",$f),
                    __FILE__,__LINE__);
            shell_exec("$prfix/exec.virtuals-ip.php --hosts >/dev/null 2>&1 &");
        }
    }

    if(!$myhostnameFound){
        squid_admin_mysql(0,"Patching hosts file $myhostname record not found",@implode("\n",$f),
            __FILE__,__LINE__);
        shell_exec("$prfix/exec.virtuals-ip.php --hosts >/dev/null 2>&1 &");
    }

    if(!$localhostFound){
        squid_admin_mysql(0,"Patching hosts file localhost record not found",@implode("\n",$f),
            __FILE__,__LINE__);
        shell_exec("$prfix/exec.virtuals-ip.php --hosts >/dev/null 2>&1 &");
    }


}

function nDPI(){

    etc_hosts();
    $EnablenDPI=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnablenDPI"));
    $EnablenDPIFistInstall=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnablenDPIFistInstall"));
    $KERNEL_VERSION=$GLOBALS["CLASS_UNIX"]->KERNEL_VERSION();
    $ndpi_path="/lib/modules/$KERNEL_VERSION/extra/xt_ndpi.ko";


    if($EnablenDPIFistInstall==0){
        if(!is_file($ndpi_path)){return;}
        if(!is_file("/etc/init.d/nDPI")){
            squid_admin_mysql(0, "Install nDPI by default... [action=install]", null,__FILE__,__LINE__);
            $cmd=trim("{$GLOBALS["NICE"]}{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.firehol.php --enable-ndpi");
            shell_exec2($cmd);
            return;
        }
    }




    if($EnablenDPI==0){
        if(is_file("/etc/init.d/nDPI")){
            squid_admin_mysql(0, "nDPI is disabled but service is installed [action=uninstall]", null,__FILE__,__LINE__);
            $cmd=trim("{$GLOBALS["NICE"]}{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.firehol.php --disable-ndpi");
            shell_exec2($cmd);
            return;
        }
        return;
    }

    if(!is_file("/etc/init.d/nDPI")){
        squid_admin_mysql(0, "nDPI is enabled but service is uninstalled [action=install]", null,__FILE__,__LINE__);
        $cmd=trim("{$GLOBALS["NICE"]}{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.firehol.php --enable-ndpi");
        shell_exec2($cmd);
        return;
    }

    if(!is_file($ndpi_path)){
        squid_admin_mysql(0, "nDPI is enabled but module for $KERNEL_VERSION doesn`t exists [action=uninstall]",
            "$ndpi_path no such file!",__FILE__,__LINE__);
        $cmd=trim("{$GLOBALS["NICE"]}{$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.firehol.php --disable-ndpi");
        shell_exec2($cmd);

    }


}

