<?php
if(!isset($GLOBALS["AS_ROOT"])){if(posix_getuid()==0){$GLOBALS["AS_ROOT"]=true;}else{$GLOBALS["AS_ROOT"]=false;}}
include_once(dirname(__FILE__)."/class.resolv.conf.inc");

class networking{
	public $array_conf;
	public $array_TCP;
	public $array_local_aliases;
	public $ldap_error;
	public $arrayNameServers;
	public $hostname;
	
	public $tcp_addr="0.0.0.0";
	public $wireless=false;
	public $netmask="0.0.0.0";
	public $gateway="0.0.0.0";
	public $linkup=false;
	public $mac_addr=null;
	
	function __construct(){
        if( !isset($GLOBALS["CLASS_SOCKETS"]) ){
            if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");    }
            $GLOBALS["CLASS_SOCKETS"]=new sockets();
        }

			include_once(dirname(__FILE__) . '/class.tcpip.inc');
			if(isset($GLOBALS["__CLASS-networking"])){
			foreach (get_object_vars($GLOBALS["__CLASS-networking"]) as $key => $value){$this->$key = $value;}
			if($GLOBALS["DEBUG_MEM"]){
				if(function_exists("events")){events("Memory: class.system.network.inc -> networking class() -> ".round(((memory_get_usage()/1024)/1000),2) ." line:".__LINE__);}
				}
			return null;
			}		
		
		
		$this->LoadNameServers();
		$this->LoadIPs();
		$GLOBALS["__CLASS-networking"]=$this;

	}
	
	
  public function NETWORK_ALL_INTERFACES(){
  	if(!$GLOBALS["AS_ROOT"]){
  		$sock=new sockets();
  		$INTERFACES=unserialize(base64_decode($sock->getFrameWork("cmd.php?TCP_NICS_STATUS_ARRAY=yes")));
  		 
  	}else{
  		$unix=new unix();
  		$INTERFACES=$unix->NETWORK_ALL_INTERFACES();
  	}
  	return $INTERFACES;
  	
  }
	
  public function Local_interfaces($filter=false) {
  	if(isset($_GET["verbose"])){$GLOBALS["VERBOSE"]=true;}
      VERBOSE("->Local_interfaces()",__LINE__);
    $results = array();
    $bufr=null;
   
    if(!$GLOBALS["AS_ROOT"]){
    	$sock=new sockets();
        VERBOSE("cmd.php?TCP_NICS_STATUS_ARRAY=yes",__LINE__);
    	$INTERFACES=unserialize(base64_decode($sock->getFrameWork("cmd.php?TCP_NICS_STATUS_ARRAY=yes")));
    	
    }else{
    	$unix=new unix();
        VERBOSE("->NETWORK_ALL_INTERFACES()",__LINE__);
    	$INTERFACES=$unix->NETWORK_ALL_INTERFACES();
    }
    $EnableIwConfig=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableIwConfig"));
    foreach ($INTERFACES as $dev_name=>$ligneAR){
        $IPADDD=null;
        if(isset($ligneAR["IPADDR"])){$IPADDD=$ligneAR["IPADDR"];}
    	if($GLOBALS["VERBOSE"]){VERBOSE("Receive interface name:$dev_name / {$IPADDD}",__LINE__);}
    	if($dev_name=="lo"){continue;}
    	
    	
    	$INTERFACEZ[$dev_name]=true;
  		
         if($filter){
          	if(preg_match("#^veth#",trim($dev_name))){continue;}
          	if(preg_match("#^sit#",trim($dev_name))){continue;}
          	if(preg_match("#^lxc#",trim($dev_name))){continue;}
          	if(preg_match("#^lo#",trim($dev_name))){continue;}
          	if(preg_match("#^br[0-9]+#",trim($dev_name))){continue;}
          	if(preg_match("#^ham[0-9]+#",trim($dev_name))){continue;}
         	if($EnableIwConfig==0){ if(preg_match("#^wlan[0-9]+#", $dev_name)){continue;} }
          	
          }
          $results[trim($dev_name)] = trim($dev_name);
        
      }
    
    
    return $results;
  }	
  
	 private function rfts($strFileName, &$strRet, $intLines = 0, $intBytes = 4096, $booErrorRep = true) {
	  $error = "";
	  $strFile = "";
	  $intCurLine = 1;
	  if (is_file($strFileName)) {
	    if ($fd = fopen($strFileName, 'r')) {
	      while (!feof($fd)) {
	        $strFile.= fgets($fd, $intBytes);
	        if ($intLines <= $intCurLine && $intLines != 0) {
	          break;
	        } else {
	          $intCurLine++;
	        }
	      }
	      fclose($fd);
	      $strRet = $strFile;
	    } else {
	      if ($booErrorRep) {
	        writelogs('fopen(' . $strFileName . ') file can not read',__CLASS__.'/'.__FUNCTION__,__FILE__,__LINE__);
	      }
	      return false;
	    }
	  } else {
	    if ($booErrorRep) {
	      writelogs('file_exists(' . $strFileName . ') the file does not exist on your machine',__CLASS__.'/'.__FUNCTION__,__FILE__,__LINE__);
	    }
	    return false;
	  }
	  return true;
	}  
	

	function ALL_IPS_GET_ARRAY(){
        if(isset($GLOBALS["ALL_IPS_GET_ARRAY"])){
            if(count($GLOBALS["ALL_IPS_GET_ARRAY"])>0){
                return $GLOBALS["ALL_IPS_GET_ARRAY"];
            }
        }
        $f=explode("\n",@file_get_contents("/proc/net/fib_trie"));
        $array=array();
        $IPADDR=null;
        foreach ($f as $line){
            if(preg_match("#\/[0-9]+\s+host LOCAL#",$line,$re)){
                if($IPADDR==null){continue;}
                $array[$IPADDR]=true;
            }
            if(!preg_match("#\|--\s+([0-9\.]+)#",$line,$re)){continue;}
            $IPADDR=$re[1];
            if($IPADDR=="127.0.0.0"){$IPADDR=null;continue;}
            if($IPADDR=="0.0.0.0"){$IPADDR=null;continue;}
        }
        $GLOBALS["ALL_IPS_GET_ARRAY"]=array();
        foreach ($array as $ipaddr=>$none){
            $GLOBALS["ALL_IPS_GET_ARRAY"][$ipaddr]=$ipaddr;
            $this->array_TCP[$ipaddr]=$ipaddr;
        }
        return $GLOBALS["ALL_IPS_GET_ARRAY"];

	}
	
	function LoadIPs(){
		include_once(dirname(__FILE__) . '/class.sockets.inc');
		if(!class_exists("usersMenus")){include_once(dirname(__FILE__) . '/class.users.menus.inc');}
		if(isset($GLOBALS["CLASS_SOCKETS"])){$sock=$GLOBALS["CLASS_SOCKETS"];}else{$GLOBALS["CLASS_SOCKETS"]=new sockets();$sock=$GLOBALS["CLASS_SOCKETS"];}
		$users=new usersMenus();
		
		
		if($GLOBALS["AS_ROOT"]){
			if(class_exists('unix')){
				$unix=new unix();
				$this->hostname=$unix->FULL_HOSTNAME();
			}
		}else{
			$this->hostname=php_uname("n");
		}
		
		
		$this->ALL_IPS_GET_ARRAY();
		
	}
	
	public function SaveResolvconf($targetFile){
	
		
	}
	
	public function checkIP($ip){
		$cIP = ip2long($ip);
		$fIP = long2ip($cIP);
		if($fIP=="0.0.0.0"){return false;}
		return true;
		}	
		
		private function DNS_LIST(){
		
			$f=explode("\n",@file_get_contents("/etc/resolv.conf"));
		
			foreach ( $f as $index=>$line ){
				$line=trim($line);
				if($line==null){continue;}
				if(preg_match("#nameserver\s+(.+)#", $line,$re)){
					if(trim($re[1])=="127.0.0.1"){continue;}
					$DNS[]=$re[1];
				}
		
			}
		
			return $DNS;
		
		}
	
	
		
	
	function LoadNameServers(){
		include_once(dirname(__FILE__) . '/class.sockets.inc');
		if(isset($GLOBALS["CLASS_SOCKETS"])){$sock=$GLOBALS["CLASS_SOCKETS"];}else{$GLOBALS["CLASS_SOCKETS"]=new sockets();$sock=$GLOBALS["CLASS_SOCKETS"];}
		$dnslist=$this->DNS_LIST();
		$ip=new IP();
		if(is_array($dnslist)){
			foreach ($dnslist as $val){
				$val=trim(strtolower($val));
				if($val<>null){
					if($GLOBALS["VERBOSE"]){if(function_exists("VERBOSE")){VERBOSE("LoadNameServers: $val", __LINE__);}}
					if($ip->isValid($val)){
						$arr[$val]=trim($val);
					}
					
				}}
			}
			
			if(!isset($arr)){return;}			
		    if(is_array($arr)){
		        foreach ($arr as $val){
					if($ip->isValid($val)){
						$this->arrayNameServers[]=$val;
					}
				}
		   	}
		}
	
	
	function ifconfig($nic){
		include_once(dirname(__FILE__) . '/class.sockets.inc');
		if(isset($GLOBALS["CLASS_SOCKETS"])){
			$sock=$GLOBALS["CLASS_SOCKETS"];}
		else{
			$GLOBALS["CLASS_SOCKETS"]=new sockets();
			$sock=$GLOBALS["CLASS_SOCKETS"];
		}
		if(!$GLOBALS["AS_ROOT"]){
			if($GLOBALS["VERBOSE"]){echo "<strong style='color:blue'>cmd.php?nicstatus=$nic</strong><br>\n";}
			$nicinfos=$sock->getFrameWork("cmd.php?nicstatus=$nic");
		}else{
			$nicinfos=$this->GetNicStatusAsRoot($nic);
			
		}
		
		$tbl=explode(";",$nicinfos);
		$this->tcp_addr=$tbl[0];
		$this->mac_addr=$tbl[1];
		$this->netmask=$tbl[2];
		$this->gateway=$tbl[4];
		
		$ipBin="/bin/ip";
		if(!is_file($ipBin)){
			$ipBin="/sbin/ip";
		}
		
		exec("$ipBin link show $nic 2>&1",$results);
		foreach ($results as $index=>$line){
			if(preg_match("#LOWER_UP#", $line)){
				$this->linkup=true;
			}
		}
		
		if($this->netmask=="0.0.0.0"){
			$results=array();
			exec("$ipBin addr show $nic 2>&1",$results);
			foreach ($results as $index=>$line){
				if(preg_match("#inet\s+([0-9\.]+)\/([0-9]+)\s+#", $line,$re)){
					$net=$re[1]."/".$re[2];
					$results2=array();
					exec("/usr/share/artica-postfix/bin/ipcalc $net 2>&1");
					foreach ($results2 as $line){
						if(preg_match("#Netmask:\s+([0-9\.]+)#", $line,$re)){$this->netmask=$re[1];break;}
						
					}
					break;
				}
			}
		}
		
		
		if(trim($tbl[5])=='yes'){$this->wireless=true;}else{$this->wireless=false;}
			
		
		}
		
		function BuildResolvConf(){
			$resolv=new resolv_conf();
			if($GLOBALS["AS_ROOT"]){
                $GLOBALS["CLASS_SOCKETS"]->SET_INFO("MyDNSServers","");
				@file_put_contents("/etc/resolv.conf", $resolv->build());
			}	
		}
		
	function nameserver_add($name){
		$this->BuildResolvConf();
		}
		
	function nameserver_delete($name){
		$this->BuildResolvConf();
	}
		
		private function GetNicInfosAsRoot($nic){
			if(isset($GLOBALS["GetNicInfosAsRoot$nic"])){
				if($GLOBALS["VERBOSE"]){echo "*** GetNicInfosAsRoot($nic) *** \n{$GLOBALS["GetNicInfosAsRoot$nic"]}\n";}
				return $GLOBALS["GetNicInfosAsRoot$nic"];
			}
			if(!class_exists("unix")){include_once("/usr/share/artica-postfix/framework/class.unix.inc");}
			$unix=new unix();
			
			$MAIN=$unix->NETWORK_ALL_INTERFACES();
			$f[]="BOOTPROTO=";
			$f[]="METHOD=debian";
			$f[]="DEVICE=$nic";
			$f[]="MAC={$MAIN[$nic]["MAC"]}";
			$datas=trim(@implode("\n",$f));	
			if($GLOBALS["VERBOSE"]){echo "*** GetNicInfosAsRoot($nic) *** \n$datas\n";}
			$GLOBALS["GetNicInfosAsRoot$nic"]=$datas;
			return $datas;
		}
		
		private function GetNicStatusAsRoot($nic){
			if(isset($GLOBALS["GetNicStatusAsRoot$nic"])){return $GLOBALS["GetNicStatusAsRoot$nic"];}
			if(!class_exists("unix")){include_once("/usr/share/artica-postfix/framework/class.unix.inc");}
			$unix=new unix();
			$ALLARRAY=$unix->NETWORK_ALL_INTERFACES();
			$outputz[]=$ALLARRAY[$_GET["nicstatus"]]["IPADDR"];
			$outputz[]=$ALLARRAY[$_GET["nicstatus"]]["MAC"];
			$outputz[]=$ALLARRAY[$_GET["nicstatus"]]["NETMASK"];
			$outputz[]=$ALLARRAY[$_GET["nicstatus"]]["SCOPE"];
			$outputz[]=$ALLARRAY[$_GET["nicstatus"]]["GATEWAY"];
			$outputz[]="no";
			if(isset($ALLARRAY[$_GET["nicstatus"]]["STATE"])){
				$outputz[]=$ALLARRAY[$_GET["nicstatus"]]["STATE"];
			}
			$sortie=@implode(";",$outputz);
			$GLOBALS["GetNicStatusAsRoot$nic"]=$sortie;
			return $sortie;
		}		
		
	
	function GetNicInfos($nic){
			if($GLOBALS["VERBOSE"]){echo "*** GetNicInfos($nic) *** \n";}
			if($nic==null){return false;}
			include_once(dirname(__FILE__) . '/class.sockets.inc');
			if(isset($GLOBALS["CLASS_SOCKETS"])){
				$sock=$GLOBALS["CLASS_SOCKETS"];}else{$GLOBALS["CLASS_SOCKETS"]=new sockets();$sock=$GLOBALS["CLASS_SOCKETS"];}
			
			if(!isset($GLOBALS["NIC_INFOS_$nic"])){
				if($GLOBALS["AS_ROOT"]){$GLOBALS["NIC_INFOS_$nic"]=$this->GetNicInfosAsRoot($nic);}else{$GLOBALS["NIC_INFOS_$nic"]=$sock->getFrameWork("cmd.php?nic-infos=$nic");}
			}
			$datas=$GLOBALS["NIC_INFOS_$nic"];
			if($GLOBALS["VERBOSE"]){echo "*** GetNicInfos($nic) *** \n$datas\n";}
			
			$tbl=explode("\n",$datas);
			if(!is_array($tbl)){return array();}
			$array=array();
			foreach ($tbl as $ligne){
				$ligne=str_replace("'","",$ligne);
			    if(preg_match("#route add -net\s+([0-9\.]+)\s+netmask\s+([0-9\.]+)\s+gw\s+([0-9\.]+)#",$ligne,$re)){$array["ROUTES"][$re[1]]=array("NETMASK"=>$re[2],"GATEWAY"=>$re[3]);continue;}
			    if(preg_match("#route add -net\s+([0-9\.]+)\s+netmask\s+([0-9\.]+)\s+dev\s+(.+)#",$ligne,$re)){$array["ROUTES"][$re[1]]=array("NETMASK"=>$re[2],"DEV"=>$re[3]);continue;}
			    if(preg_match("#route add default gw ([0-9\.]+)#",$ligne,$re)){$array["ROUTES"]["default"]=array("GATEWAY"=>$re[1]);continue;}
			    if(preg_match('#([a-zA-Z0-9\-\_]+)=(.+)#',$ligne,$reg)){$array[$reg[1]]=$reg[2];}
				
			}
			
		return $this->GetInfosReturnDefault($array,$nic);
		}
		
	function default_network(){
		if($this->array_TCP){
		while (list ($nic, $ip) = each ($this->array_TCP) ){
			if(preg_match("#^vmnet#",$nic)){continue;}
			if($ip==null){continue;}
			if($ip=="0.0.0.0"){continue;}
			return $ip;
		}}
		return null;
	}
	
	function GetInfosReturnDefault($array,$nic=null){
		$default_addr=null;
		$default_netmask=null;
		$default_gateway=null;
		$bradcast_default=null;
		if(count($this->arrayNameServers)==0){$this->LoadNameServers();}
		if($nic<>null){
			include_once(dirname(__FILE__) . '/class.sockets.inc');
			if(isset($GLOBALS["CLASS_SOCKETS"])){$sock=$GLOBALS["CLASS_SOCKETS"];}else{$GLOBALS["CLASS_SOCKETS"]=new sockets();$sock=$GLOBALS["CLASS_SOCKETS"];}
			if(!isset($GLOBALS["NIC_STATUS_$nic"])){if($GLOBALS["AS_ROOT"]){$GLOBALS["NIC_STATUS_$nic"]=$this->GetNicStatusAsRoot($nic);}else{$GLOBALS["NIC_STATUS_$nic"]=$sock->getFrameWork("cmd.php?nicstatus=$nic");}}
			$nicinfos=$GLOBALS["NIC_STATUS_$nic"];
			$tbl=explode(";",$nicinfos);
			$default_addr=$tbl[0];
			if(isset($tbl[2])){$default_netmask=$tbl[2];}
			if(isset($tbl[4])){$default_gateway=$tbl[4];}
			if(isset($tbl[3])){$bradcast_default=$tbl[3];}
		}
				
		if(trim($default_addr)==null){$default_addr="0.0.0.0";}
		if(trim($default_netmask)==null){$default_netmask="0.0.0.0";}
		if(trim($default_gateway)==null){$default_gateway="0.0.0.0";}
		
		if($bradcast_default==null){
			if(preg_match("#([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)#",$default_addr,$re)){
				$bradcast_default="{$re[1]}.{$re[2]}.{$re[3]}.255";
			}
		}
		
		if(!isset($array["ONBOOT"])){$array["ONBOOT"]=null;}
		if(!isset($array["METRIC"])){$array["METRIC"]=null;}
		if(!isset($array["NEEDHOSTNAME"])){$array["NEEDHOSTNAME"]=null;}
		if(!isset($array["DHCP_CLIENT"])){$array["DHCP_CLIENT"]=null;}
		if(!isset($array["PEERDNS"])){$array["PEERDNS"]=null;}
		if(!isset($array["PEERYP"])){$array["PEERYP"]=null;}
		if(!isset($array["PEERNTPD"])){$array["PEERNTPD"]=null;}
		if(!isset($array["GATEWAY"])){$array["GATEWAY"]=null;}
		if(!isset($array["BROADCAST"])){$array["BROADCAST"]=null;}
		if(!isset($array["IPADDR"])){$array["IPADDR"]=null;}
		if(!isset($array["NETMASK"])){$array["NETMASK"]=null;}
		if(!isset($array["BOOTPROTO"])){$array["BOOTPROTO"]=null;}
		if(!isset($array["ipv6"])){$array["ipv6"]=null;}
		
		
		
		
		if($array["ONBOOT"]==null){$array["ONBOOT"]="yes";}
		if($array["METRIC"]==null){$array["METRIC"]="10";}
		if($array["NEEDHOSTNAME"]==null){$array["NEEDHOSTNAME"]="yes";}	
		if($array["DHCP_CLIENT"]==null){$array["DHCP_CLIENT"]="dhclient";}	
		if($array["PEERDNS"]==null){$array["PEERDNS"]="yes";}	
		if($array["PEERYP"]==null){$array["PEERYP"]="no";}	
		if($array["PEERNTPD"]==null){$array["PEERNTPD"]="no";}		
		if($array["GATEWAY"]==null){$array["GATEWAY"]=$default_gateway;}
		if($array["IPADDR"]==null){$array["IPADDR"]=$default_addr;}
		if($array["NETMASK"]==null){$array["NETMASK"]=$default_netmask;}
		if($array["BOOTPROTO"]==null){$array["BOOTPROTO"]="static";}
		if($array["BROADCAST"]==null){$array["BROADCAST"]=$bradcast_default;}
		
		if(preg_match("#(.+?)\/([0-9]+)#",$array["IPADDR"],$re)){
			$array["IPADDR"]=$re[1];
			if($re[2]==24){$array["NETMASK"]="255.255.255.0";}
		}
		if(isset($array["dns-nameservers"])){
			if($array["dns-nameservers"]<>null){
				$t=explode(" ",$array["dns-nameservers"]);
				$array["NAMESERVERS"]=$t;
			}else{
				$array["NAMESERVERS"]=$this->arrayNameServers;;
			}
		}
		return $array;		
		
	}
	
	
    function route_shouldbe($ip_start,$mask=null){
        $newmask=null;
        $ip=$ip_start;
        $calc_ip=null;
        $calc_ip_end=null;
        if(preg_match("#([0-9]+)$#",$ip,$re)){
            $calc_ip=$re[1].".0.0.0";
            $calc_ip_end=$re[1].".255.255.255";
        }

        if(preg_match("#([0-9]+)\.([0-9]+)$#",$ip,$re)){
            $calc_ip=$re[1].".{$re[2]}.0.0";
            $calc_ip_end=$re[1].".{$re[2]}.255.255";
        }

        if(preg_match("#([0-9]+)\.([0-9]+)\.$#",$ip,$re)){
            $calc_ip=$re[1].".{$re[2]}.0.0";
            $calc_ip_end=$re[1].".{$re[2]}.255.255";
        }

        if(preg_match("#([0-9]+)\.([0-9]+)\.([0-9]+)$#",$ip,$re)){
            $calc_ip=$re[1].".{$re[2]}.{$re[3]}.0";
            $calc_ip_end=$re[1].".{$re[2]}.{$re[3]}.255";
        }

        if(preg_match("#([0-9]+)\.([0-9]+)\.([0-9]+)\.$#",$ip,$re)){
            $calc_ip=$re[1].".{$re[2]}.{$re[3]}.0";
            $calc_ip_end=$re[1].".{$re[2]}.{$re[3]}.255";
        }

        if(preg_match("#([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)$#",$ip,$re)){
            $calc_ip=$re[1].".{$re[2]}.{$re[3]}.0";
            $calc_ip_end=$re[1].".{$re[2]}.{$re[3]}.255";
        }



        if($mask<>null){
            if(preg_match("#([0-9]+)$#",$mask,$re)){
                $newmask=$re[1].".0.0.0";
            }

        if(preg_match("#([0-9]+)\.([0-9]+)$#",$mask,$re)){
            $newmask=$re[1].".{$re[2]}.0.0";
        }

            if(preg_match("#([0-9]+)\.([0-9]+)\.$#",$mask,$re)){
            $newmask=$re[1].".{$re[2]}.0.0";
        }

        if(preg_match("#([0-9]+)\.([0-9]+)\.([0-9]+)$#",$mask,$re)){
            $newmask=$re[1].".{$re[2]}.{$re[3]}.0";
        }

        if(preg_match("#([0-9]+)\.([0-9]+)\.([0-9]+)\.$#",$mask,$re)){
            $newmask=$re[1].".{$re[2]}.{$re[3]}.0";
        }


        if(preg_match("#([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)$#",$mask,$re)){
            $newmask=$re[1].".{$re[2]}.{$re[3]}.{$re[4]}";
        }

        }

        $ip=new IP();

        if($newmask<>null){
            return $ip->maskTocdir($calc_ip, $newmask);
        }



        $cdir=$ip->ip2cidr($calc_ip,$calc_ip_end);
        $arr=$ip->parseCIDR($cdir);
        $netbit=$arr[1];
        $ipv=new ipv4($calc_ip,$netbit);
        return "<strong>$cdir {$ipv->address()} - {$ipv->netmask()}</strong>";

    }

	

	
	
	
	
	
}


function VirtualNicInfosIPaddr($ID){
	if(!is_numeric($ID)){return false;}
	$sql="SELECT * FROM nics_virtuals WHERE ID=$ID";
	$q=new lib_sqlite("/home/artica/SQLITE/interfaces.db"); 
	$ligne=$q->mysqli_fetch_array($sql);
	$eth="{$ligne["nic"]}:{$ligne["ID"]}";
	return array("IPADDR"=>$ligne["ipaddr"],"ETH"=>$eth);
	
}

class MACAddress {
    private $_macPrefix = '00-';
    private $_macORGPrefix = '00-50-56-';
    private $_macAddress;
    private $_macChars;
    public $separator="-";
    public $MAC1;
    public $MAC2;
    public $MAC3;
    public $MAC4;
    public $MAC5;
    public $MAC6;

     public function _generateMAC(){
     	$this->MAC1=str_replace("-",$this->_macPrefix,$this->_macPrefix);
        $this->_macChars = md5(uniqid(mt_rand(), TRUE));
        $this->MAC2=substr($this->_macChars, 0,2);
        $this->MAC3=substr($this->_macChars, 8,2);
        $this->MAC4=substr($this->_macChars, 12,2);
        $this->MAC5=substr($this->_macChars, 16,2);
        $this->MAC6=substr($this->_macChars, 20,2);
            
        
        $this->_macAddress = substr($this->_macChars, 0,2) . '-';
        $this->_macAddress .= substr($this->_macChars, 8,2) . '-';
        $this->_macAddress .= substr($this->_macChars, 12,2) . '-';
        $this->_macAddress .= substr($this->_macChars, 16,2) . '-';
        $this->_macAddress .= substr($this->_macChars, 20,2);
        return "$this->MAC1$this->MAC2$this->separator$this->MAC3$this->separator$this->MAC4$this->separator$this->MAC5$this->separator$this->MAC6";
     }

     public function _generateMAC2(){
     	$this->_macORGPrefix=str_replace("-",$this->separator,$this->_macORGPrefix);
        $this->_macChars = md5(uniqid(mt_rand(), TRUE));
        $this->MAC4=substr($this->_macChars, 0,2);
        $this->MAC5=substr($this->_macChars, 8,2);
        $this->MAC6=substr($this->_macChars, 12,2);
        $this->_macAddress = "$this->_macORGPrefix$this->MAC4$this->separator$this->MAC5$this->separator$this->MAC6";
        return $this->_macAddress;
     }
} 

class networkscanner{
	var $networklist=array();
	var $DefaultNetworkList=array();
	var $Networks_disabled=array();
	
	
	function __construct(){
        $q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");

        if(!$q->FIELD_EXISTS("networks_infos","enabled")){
            $q->QUERY_SQL("ALTER TABLE networks_infos ADD enabled INTEGER DEFAULT 1");
        }

        $ligne=$q->mysqli_fetch_array("SELECT count(*) as tcount FROM networks_infos");
        if($ligne["tcount"]>0){
            $results=$q->QUERY_SQL("SELECT * FROM networks_infos");
            foreach ($results as $index=>$ligne){
                $this->networklist[]=$ligne["ipaddr"];
            }
            $results=$q->QUERY_SQL("SELECT * FROM networks_infos WHERE enabled=0");
            foreach ($results as $index=>$ligne){
                $this->Networks_disabled[$ligne["ipaddr"]]=true;
            }
            return;
        }


		$tbl=explode("\n",$GLOBALS["CLASS_SOCKETS"]->GET_INFO("NetworkScannerMasks"));
		$disabled=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NetworkScannerMasksDisabled"));
		
        foreach ($tbl as $maks){
			$maks=trim($maks);
			if(strlen($maks)<6){continue;}
			$netinfos=base64_encode("Network $maks");
            $this->networklist[]=$maks;
			$q->QUERY_SQL("INSERT INTO networks_infos (ipaddr,netinfos) VALUES ('$maks','$netinfos')");
		}
		

	$tbl=explode("\n",$disabled);	
	if(is_array($tbl)){
        foreach ($tbl as $maks){
			if(trim($maks)==null){continue;}
            $netinfos=base64_encode("Network $maks");
            $q->QUERY_SQL("INSERT INTO networks_infos (ipaddr,netinfos,enabled) VALUES ('$maks','$netinfos',0)");
			$this->Networks_disabled[$maks]=true;
		}
	}
		
		if(count($this->networklist)==0){$this->builddefault();}
		
	}
	
	function disable_net($net){
		$disabled=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NetworkScannerMasksDisabled"));
		$disabled=$disabled."\n".$net;
        $GLOBALS["CLASS_SOCKETS"]->SaveConfigFile($disabled,"NetworkScannerMasksDisabled");
	}
	

	
	
	function save(){
		if(is_array($this->networklist)){
			reset($this->networklist);
			foreach ($this->networklist as $maks){
				$maks=trim($maks);
				if(strlen($maks)<6){continue;}
				$arr[trim($maks)]=trim($maks);
				}
			}
		
		$xt=array();
		if(is_array($arr)){
		    foreach ($arr as $net){
				$xt[]=$net;
			}
		}
		
		$sock=new sockets();
		$sock->SaveConfigFile( @implode("\n", $xt),"NetworkScannerMasks");
		$sock->DeleteCache();
		
	}
	
	function builddefault(){
        $q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");
		$net=new networking();
		$cip=new IP();
		foreach ($net->array_TCP as $ip){
			if(preg_match('#([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)#',$ip,$re)){
				$ip_start="{$re[1]}.{$re[2]}.{$re[3]}.0";
				$ip_end="{$re[1]}.{$re[2]}.{$re[3]}.255";
				$cdir=$cip->ip2cidr($ip_start,$ip_end);
				if(trim($cdir)<>null){
                    $netinfos=base64_encode("Network $cdir");
                    $q->QUERY_SQL("INSERT INTO networks_infos (ipaddr,netinfos) VALUES ('$cdir','$netinfos')");
					$this->DefaultNetworkList[trim($cdir)]=true;
					$this->networklist[]=$cdir;
				}
			}
			
		}
		
		$this->save();
		
	}
	
	
		
	
}


?>