#!/usr/bin/php
<?php
$GLOBALS["VERBOSE_COUNT"]=false;
$BLOCKED_TYPES[1]="{webfiltering}";
$BLOCKED_TYPES[2]="NoTracks";
$BLOCKED_TYPES[403]="Permission denied";
$BLOCKED_TYPES[503]="Domain Does not exists";

set_time_limit(0);
ob_implicit_flush();
declare(ticks = 1);
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;$GLOBALS["VERBOSE"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.settings.inc');
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');

$GLOBALS["CLASS_UNIX"]=new unix();
$unix=new unix();
$GLOBALS["VERBOSE"]=false;
$pid=$unix->get_pid_from_file("/var/run/artica-communicator.pid");
if($unix->process_exists($pid,__FILE__)){
    $unix->ToSyslog("Stopped, already pid $pid exists....","stats-communicator");
    die();
}

use React\EventLoop\Factory;
use React\Socket\Server;
use React\Socket\ConnectionInterface;

// https://github.com/reactphp/socket
include_once(dirname(__FILE__).'/ressources/externals/vendor/autoload.php');

    @unlink("/var/run/artica-communicator.sock");

    $GLOBALS["DATA_PROCESSED"]=0;


    $loop = Factory::create();
    $server = new React\Socket\Server("127.0.0.1:1899", $loop, array());



    $server->on('connection', function (ConnectionInterface $connection) use ($data){

    $connection->on('data', function ($chunk) {
        $GLOBALS["DATA_PROCESSED"]++;
        dataprocessing($chunk);
    });

    $connection->on('error', function (Exception $e) {
        $error=$e->getMessage();
        $GLOBALS["CLASS_UNIX"]->ToSyslog($error,"stats-communicator");
    });


});



$server->on('error', function (Exception $e) {
    $error='Error' . $e->getMessage();
    $GLOBALS["CLASS_UNIX"]->ToSyslog("stats-communicator",$error);
    echo date("Y-m-d H:i:s").": stats-communicator $error\n";
    die();
});

$pid = pcntl_fork();

if ($pid == -1) {
    die("Starting......: ".date("H:i:s")." artica-status fork() call asploded!\n");
} else if ($pid) {
    if($pid>0) {
        $GLOBALS["CLASS_UNIX"]->ToSyslog("fork()ed successfully with pid $pid", "stats-communicator");
        @file_put_contents("/var/run/artica-communicator.pid", $pid);
        exit();
    }
}

$loop->addSignal(SIGTERM, function () use ($data, $loop) {
    $GLOBALS["CLASS_UNIX"]->ToSyslog(sprintf('%s finished running, Processed %d requests',
        posix_getpid(), $GLOBALS["DATA_PROCESSED"]),"stats-communicator");

   $loop->stop();
    try {
    $GLOBALS["REDIS"]->close();
    } catch (Exception $e) {
        $GLOBALS["CLASS_UNIX"]->ToSyslog($e->getMessage(),"stats-communicator");
    }
    die();
});


$loop->run();

function redisConnection() {
    try {
        $redis = new Redis();
        $redis->pconnect("127.0.0.1", 4322, 2);
        $redis->ping();
        return $redis;
    } catch (Exception $e) {
        $GLOBALS["CLASS_UNIX"]->ToSyslog($e->getMessage(),"stats-communicator");
    }
}


function dataprocessing($chunk){
    if(!isset($GLOBALS["CLASS_UNIX"])){$GLOBALS["CLASS_UNIX"]=new unix();}

    if(!isset($GLOBALS["REDIS"])){
        $GLOBALS["REDIS"]=redisConnection();
    }

    if(!$GLOBALS["REDIS"]){
        $GLOBALS["REDIS"]=redisConnection();
    }

    if(!method_exists($GLOBALS["REDIS"],'ping')){
        $GLOBALS["REDIS"]=redisConnection();
    }
    if(!method_exists($GLOBALS["REDIS"],'ping')){
        if(!isset($GLOBALS["REDIS_REBOOTED"])) {
            $GLOBALS["CLASS_UNIX"]->ToSyslog("Alert Redis server for Stats Communicator is away!", "stats-communicator");
            squid_admin_mysql(0, "Alert Redis server for Stats Communicator is away!", null, __FILE__, __LINE__);
            shell_exec("/etc/init.d/statsredis restart >/dev/null 2>&1 &");
            $GLOBALS["REDIS_REBOOTED"] = true;
            return false;
        }else{
            return false;
        }
    }

    $redis=$GLOBALS["REDIS"];


    try {
        if(!$redis->ping()){
            $GLOBALS["REDIS"]=redisConnection();
            $redis=$GLOBALS["REDIS"];
        }

    } catch (Exception $e) {
        $GLOBALS["CLASS_UNIX"]->ToSyslog($e->getMessage(),"stats-communicator");
        $GLOBALS["REDIS"]=redisConnection();
        $redis=$GLOBALS["REDIS"];
    }

    if(isset($GLOBALS["REDIS_REBOOTED"])){unset($GLOBALS["REDIS_REBOOTED"]);}


    $table=explode(":::",$chunk);
    $proxyName=$table[1];
    $time=$table[2];
    $MAC=$table[3];
    if($MAC=="-"){$MAC="00:00:00:00:00:00";}
    $ipaddr=$table[4];
    $username=$table[5];
    $proto=$table[6]; // GET / NONE
    $StatusCode=$table[7];
    $Size=intval($table[8]);
    if($Size==0){return false;}
    $BLOCKED=false;
    $Hierarchy=$table[9];
    $ForwardedFor=$table[10];
    $sitename=trim(strtolower($table[11]));
    if($sitename=="-"){$sitename=null;}
    if($sitename==null){return false;}
    $ClientFQDN=strtolower($table[12]);
    $ResponseTime=$table[13];
    $MimeContent=$table[14];
    $webfiltering="pass";
    $notracks=0;
    $BLOCKED_TEXT="[PASS]";
    $SNI=trim($table[15]);
    if($SNI=="-"){$SNI=null;}
    $BLOCKED_INT=0;
    $NOTE=str_replace("%20"," ",$table[16]);
    $uniqueid=trim($table[17]);

    if(!preg_match("#^[0-9a-z]+-[0-9a-z]+-[0-9a-z]+-[0-9a-z]+-[0-9a-z]+$#",$uniqueid)){
        write_error("[".__LINE__."] FATAL Wrong [$uniqueid] in chunck:\"$chunk\"");
    }
    //$LineError="proxy:$proxyName($uniqueid); Time:$time; ipAddr:$ipaddr; Site:$sitename({$table[11]})";



    $HOST_REQUESTED=trim($table[18]);
    if($HOST_REQUESTED=="-"){$HOST_REQUESTED=null;}

    $UserAgent=trim($table[19]);
    if($UserAgent=="-"){$UserAgent=null;}
    $NOTE=str_replace("%0D%0A",":::",$NOTE);

    /*if($GLOBALS["VERBOSE"]){
        foreach ($table as $index=>$value){
            $GLOBALS["CLASS_UNIX"]->ToSyslog("\$table[$index]=\"$value\"","stats-communicator");
        }
    }*/

    $username=trim(strtolower(str_replace("%20", " ", $username)));
    $username=str_replace("%25", "-", $username);
    if($username=="-"){$username=null;}
    $znote=explode(":::",$NOTE);
    foreach ($znote as $line){ $tt=explode(":",$line); $sNOTES[trim($tt[0])]=trim($tt[1]); }
    if($ForwardedFor=="-"){$ForwardedFor=null;}

    $category=intval($sNOTES["category"]);
    $date = new DateTime(date("Y-m-d H:i:s",$time));
    $date = roundToNearestMinuteInterval($date);
    $timestamp=$date->getTimestamp();
    $KEYUSER=null;
    if($username<>null){$KEYUSER=$username;}
    if($KEYUSER==null){if($MAC<>null){$KEYUSER=$MAC;}}
    if($KEYUSER==null){if($ipaddr<>null){$KEYUSER=$ipaddr;}}
    if($SNI<>null){$sitename=$SNI;}
    if($sitename=="-"){$sitename=null;}
    if($sitename==null){ if($HOST_REQUESTED<>null){ $sitename=$HOST_REQUESTED; } }


    if(preg_match("#^www\.(.+)#",$sitename,$re)){$sitename=$re[1];}

    if(isset($sNOTES["webfiltering"])){
        $webfiltering=$sNOTES["webfiltering"];
        if(preg_match("#block#",$webfiltering)){$BLOCKED_INT=1;}
    }

    if(isset($sNOTES["notracks"])){
        if(intval($sNOTES["notracks"])==1){
            $BLOCKED_TEXT="NoTracks";
            $BLOCKED_INT=2;

        }
    }

    if($BLOCKED_INT==0){
        if($StatusCode==503){
            $BLOCKED_INT=503;
        }
        if($StatusCode==403){
            $BLOCKED_INT=403;
        }
        if($StatusCode==407){
            if($GLOBALS["VERBOSE_COUNT"]) {
                $GLOBALS["CLASS_UNIX"]->ToSyslog("$sitename: 407 status code, aborting...", "stats-communicator");
            }
            return false;
        }
    }

    if($BLOCKED_INT>0){
        $BLOCKED_TEXT="BLOCK";
    }

    $sitename=trim($sitename);
    if($sitename==null){
        if($GLOBALS["VERBOSE_COUNT"]) {
            write_error("No sitename from \"$chunk\"");
        }
        return false;
    }

    if(strpos($sitename,"(")>0){
        if($GLOBALS["VERBOSE_COUNT"]) {
            write_error("Wrong pattern \"$sitename\" from \"$chunk\"");
        }
        return false;
    }
    if(strpos("  $sitename","::")>0){
        if($GLOBALS["VERBOSE_COUNT"]) {
            write_error("Wrong pattern \"$sitename\" from \"$chunk\"");
        }
        return false;
    }

    if($GLOBALS["VERBOSE"]){
        foreach ($sNOTES as $a=>$b){$bb[]="$a=$b";}
        $GLOBALS["CLASS_UNIX"]->ToSyslog("{$BLOCKED_TEXT}:$sitename: $proto $StatusCode ".@implode(" ",$bb),"stats-communicator");
    }

    if($BLOCKED_INT>0) {
        $BLOCKED_SQL = "$ipaddr|$MAC|$username|$sitename|$category|$BLOCKED_INT";
        $key="BLOCKED.$timestamp.$BLOCKED_SQL";


        $int=intval($redis->get($key));
        $GLOBALS["CLASS_UNIX"]->ToSyslog("$key = $int","stats-communicator");
        $int++;

        try {
            $redis->set($key,$int,28800);

        } catch (Exception $e) {
            $Message=$e->getMessage();
            $GLOBALS["CLASS_UNIX"]->ToSyslog($Message,"stats-communicator");
            squid_admin_mysql(1,"Redis server for Stats Communicator: $Message",null,__FILE__,__LINE__);
            if(preg_match("#OOM command not allowed when used memory#",$Message)){
                shell_exec("/etc/init.d/statsredis restart >/dev/null 2>&1 &");
            }
        }



        return false;
    }




    $USERSQL="$ipaddr|$MAC|$username";
    $key="USERS.$timestamp.$USERSQL";
    $data=$redis->hgetall($key);
    if(!$data){ $data["SIZE"]=0; $data["RQS"]=0; }
    $data["SIZE"]=$data["SIZE"]+$Size;
    $data["RQS"]=$data["RQS"]+1;

    try {
        $redis->HMSET($key,$data);

    } catch (Exception $e) {
        $GLOBALS["CLASS_UNIX"]->ToSyslog($e->getMessage()." line:".__LINE__,"stats-communicator");
        return false;
    }

    $SITESQL="$sitename|$category|$proxyName|$uniqueid";
    $key="SITES.$timestamp.$SITESQL";
    $data=$redis->hgetall($key);
    if(!$data){ $data["SIZE"]=0; $data["RQS"]=0; }
    $data["SIZE"]=$data["SIZE"]+$Size;
    $data["RQS"]=$data["RQS"]+1;
    $redis->HMSET($key,$data);

    $key="USERAGENT.".md5($UserAgent);
    $redis->set($key,$UserAgent,28800);

    $PROXY_SQL="$uniqueid";
    $key="PROXY.$timestamp.$PROXY_SQL";
    $data=$redis->hgetall($key);
    if(!$data){ $data["SIZE"]=0; $data["RQS"]=0; }
    $data["SIZE"]=$data["SIZE"]+$Size;
    $data["RQS"]=$data["RQS"]+1;
    $redis->HMSET($key,$data);



    $key="ACCESS.$timestamp.$USERSQL|$SITESQL";
    $data=$redis->hgetall($key);
    if(!$data){ $data["SIZE"]=0; $data["RQS"]=0; }
    $data["SIZE"]=$data["SIZE"]+$Size;
    $data["RQS"]=$data["RQS"]+1;
    $redis->HMSET($key,$data);


    return true;

}



function roundToNearestMinuteInterval(\DateTime $dateTime, $minuteInterval = 10)
{
    return $dateTime->setTime(
        $dateTime->format('H'),
        round($dateTime->format('i') / $minuteInterval) * $minuteInterval,
        0
    );
}
function write_error($lineToSave){

    $f = @fopen("/var/log/statscom-error.log", 'a');
    @fwrite($f, "$lineToSave\n");
    @fclose($f);
}
