<?php
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
$GLOBALS["FORCE"]=false;
$GLOBALS["RECONFIGURE"]=false;
$GLOBALS["SWAPSTATE"]=false;
$GLOBALS["NOSQUIDOUTPUT"]=true;
$GLOBALS["TITLENAME"]="Clam AntiVirus userspace daemon";
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;$GLOBALS["OUTPUT"]=true;$GLOBALS["debug"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
if(preg_match("#--output#",implode(" ",$argv))){$GLOBALS["OUTPUT"]=true;}
if(preg_match("#schedule-id=([0-9]+)#",implode(" ",$argv),$re)){$GLOBALS["SCHEDULE_ID"]=$re[1];}
if(preg_match("#--force#",implode(" ",$argv),$re)){$GLOBALS["FORCE"]=true;}
if(preg_match("#--reconfigure#",implode(" ",$argv),$re)){$GLOBALS["RECONFIGURE"]=true;}
$GLOBALS["AS_ROOT"]=true;
include_once(dirname(__FILE__).'/ressources/class.ldap.inc');
include_once(dirname(__FILE__).'/ressources/class.squid.inc');
include_once(dirname(__FILE__).'/ressources/class.mysql.inc');

include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.settings.inc');
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.clamav.bad-patterns.inc');

// Usage: /etc/init.d/clamav-daemon {start|stop|restart|force-reload|reload-log|reload-database|status}

$GLOBALS["ARGVS"]=implode(" ",$argv);
if($argv[1]=="--stop"){$GLOBALS["OUTPUT"]=true;stop();exit();}
if($argv[1]=="--start"){$GLOBALS["OUTPUT"]=true;start();exit();}
if($argv[1]=="--restart"){$GLOBALS["OUTPUT"]=true;restart();exit();}
if($argv[1]=="--reload-database"){$GLOBALS["OUTPUT"]=true;reload_database();exit();}
if($argv[1]=="--reload-log"){$GLOBALS["OUTPUT"]=true;reload();exit();}
if($argv[1]=="--force-reload"){$GLOBALS["OUTPUT"]=true;reload();exit();}
if($argv[1]=="--install"){$GLOBALS["OUTPUT"]=true;install();exit();}
if($argv[1]=="--uninstall"){$GLOBALS["OUTPUT"]=true;uninstall();exit();}
if($argv[1]=="--install-fresh"){$GLOBALS["OUTPUT"]=true;install_clamav_freshclam();exit();}
if($argv[1]=="--reconfigure"){$GLOBALS["OUTPUT"]=true;reconfigure();exit();}
if($argv[1]=="--permissions"){$GLOBALS["OUTPUT"]=true;permissions();exit();}
if($argv[1]=="--fix"){$GLOBALS["OUTPUT"]=true;fixClamLibs();exit();}




function fixClamLibs(){
    $unix=new unix();
    $cp=$unix->find_program("cp");
    $files[]="libclamav.so";
    $files[]="libclamav.so.9";
    $files[]="libclamav.so.9.0.1";
    $files[]="libclamav.so.9.0.4";
    $files[]="libclamav.so.9.0.5";
    $files[]="libclamav.so.9.0.6";
    $files[]="libclamav.so.9.0.7";
    $files[]="libclamav.so.9.0.8";


    foreach ($files as $filename){
        if(!is_file("/usr/lib/$filename")){
            echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} /usr/lib/$filename (no such file)\n";
            continue;
        }


        if(is_file("/usr/lib/$filename")){
            if(is_file("/lib/x86_64-linux-gnu/$filename")){
                echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} removing /lib/x86_64-linux-gnu/$filename\n";
                @unlink("/lib/x86_64-linux-gnu/$filename");
            }

            if(!is_file("/lib/$filename")){
                shell_exec("$cp -fd /usr/lib/$filename /lib/$filename");
            }
        }
    }
}

function restart() {
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pid=$unix->get_pid_from_file($pidfile);
	if($unix->process_exists($pid,basename(__FILE__))){
		$time=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Already Artica task running PID $pid since {$time}mn\n";}
		return;
	}
	@file_put_contents($pidfile, getmypid());
	build_progress_restart(30,"{stopping_service}");
	stop(true);
	build_progress_restart(50,"{reconfiguring}");
	build();
	build_progress_restart(70,"{starting_service}");
	sleep(1);
	if(!start(true)){
		build_progress_restart(110,"{starting_service} {failed}");
		return;
	}
	build_progress_restart(90,"{starting_service} {success}");
	$cicap=$unix->find_program("c-icap");
	if(is_file($cicap)){
		$CicapEnabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("CicapEnabled"));
		if($CicapEnabled==1){
			build_progress_restart(95,"{restarting_service} {APP_C_ICAP}");
			system("/etc/init.d/c-icap reload");}
	}
	build_progress_restart(100,"{restarting_service} {done}");

}
function build_progress_restart($pourc,$text){
	$echotext=$text;
	echo "Starting......: ".date("H:i:s")." {$pourc}% $echotext\n";
	$cachefile="/usr/share/artica-postfix/ressources/logs/web/clamd.restart";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($cachefile, serialize($array));
	@chmod($cachefile,0755);
}

function build_progress($pourc,$text){
	$echotext=$text;
	echo "Starting......: ".date("H:i:s")." {$pourc}% $echotext\n";
	$cachefile="/usr/share/artica-postfix/ressources/logs/web/clamd.progress";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($cachefile, serialize($array));
	@chmod($cachefile,0755);
}

function uninstall(){
	$sock=new sockets();
	build_progress(10,"{uninstalling}");
	$sock->SET_INFO("EnableClamavDaemon", 0);
	$sock->SET_INFO("EnableFreshClam", 0);
	build_progress(20,"{uninstalling}");
	remove_service("/etc/init.d/clamav-daemon");
	build_progress(30,"{uninstalling}");
	remove_service("/etc/init.d/clamav-freshclam");
	build_progress(40,"{uninstalling}");
	@unlink("/etc/monit/conf.d/APP_CLAMAV.monitrc");
	build_progress(50,"{uninstalling}");
	@unlink("/etc/cron.d/clamd-cron");
	shell_exec("/etc/init.d/cron reload");
	build_progress(70,"{uninstalling}");
	shell_exec("/etc/init.d/monit restart");
	build_progress(80,"{uninstalling}");
	$dirs[]="/var/run/clamav";
	$dirs[]="/var/lib/clamav";
	$dirs[]="/var/log/clamav";
	$unix=new  unix();
	$rm=$unix->find_program("rm");
	build_progress(90,"{uninstalling}");
	foreach ($dirs as $directory){if(is_dir($directory)){shell_exec("$rm -rf $directory");}}
	build_progress(100,"{uninstalling} {done}");
}

function install(){
	$unix=new unix();
	
	$unix->Popuplate_cron_make("clamd-cron","0 */2 * * *","exec.freshclam.php --sigtool");
	
	$sock=new sockets();
	$sock->SET_INFO("EnableClamavDaemon", 1);
	$sock->SET_INFO("EnableFreshClam", 1);
	build_progress(10,"{installing}");
	install_clamav_daemon();
	install_clamav_freshclam();
	install_monit();
	reconfigure();
	build_progress(95,"{starting_service}...");
	start(true);
	system("/etc/init.d/clamav-freshclam start");
	build_progress(100,"{installing} {success}");
}
function remove_service($INITD_PATH){
	if(!is_file($INITD_PATH)){return;}
	system("$INITD_PATH stop");
	if(is_file('/usr/sbin/update-rc.d')){shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");}
	if(is_file('/sbin/chkconfig')){shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");}
	if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}
function install_monit(){
	$f=array();
	$f[]="check process APP_CLAMAV";
	$f[]="with pidfile /var/run/clamav/clamd.pid";
	$f[]="start program = \"/etc/init.d/clamav-daemon start --monit\"";
	$f[]="stop program =  \"/etc/init.d/clamav-daemon stop --monit\"";
	$f[]="if 5 restarts within 5 cycles then timeout";
	$f[]="";
	$f[]="check process APP_FRESHCLAM";
	$f[]="with pidfile /var/run/clamav/freshclam.pid";
	$f[]="start program = \"/etc/init.d/clamav-freshclam start --monit\"";
	$f[]="stop program =  \"/etc/init.d/clamav-freshclam stop --monit\"";
	$f[]="if 5 restarts within 5 cycles then timeout";
	$f[]="";
	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} monitoring Clamd service...\n";}
	@file_put_contents("/etc/monit/conf.d/APP_CLAMAV.monitrc", @implode("\n", $f));
	shell_exec("/etc/init.d/monit restart");
}


function reconfigure(){
	
	build_progress(20, "{reconfiguring}");
	build();
	build_progress(95, "{reloading}");
	reload_database();
	build_progress(100, "{success}");
}

function install_clamav_daemon(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	$INITD_PATH="/etc/init.d/clamav-daemon";
	$php5script="exec.clamd.php";
	$daemonbinLog="Clam AntiVirus userspace daemon";



	$f[]="#!/bin/sh";
	$f[]="### BEGIN INIT INFO";
	$f[]="# Provides:        clamav-daemon";
	$f[]="# Required-Start:    \$local_fs \$syslog";
	$f[]="# Required-Stop:     \$local_fs \$syslog";
	$f[]="# Should-Start:";
	$f[]="# Should-Stop:";
	$f[]="# Default-Start:     3 4 5";
	$f[]="# Default-Stop:      0 1 6";
	$f[]="# Short-Description: $daemonbinLog";
	$f[]="# chkconfig: - 80 75";
	$f[]="# description: $daemonbinLog";
	$f[]="### END INIT INFO";

	$f[]="case \"\$1\" in";
	$f[]=" start)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  stop)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" restart)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" reconfigure)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --build \$2 \$3";
	$f[]="    ;;";
	$f[]=" build)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --build \$2 \$3";
	$f[]="    ;;";
	$f[]=" force-reload)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --force-reload \$2 \$3";
	$f[]="    ;;";
	$f[]=" reload-database)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --reload-database \$2 \$3";
	$f[]="    ;;";
	$f[]=" reload-log)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --reload-log \$2 \$3";
	$f[]="    ;;";

	$f[]="";
	$f[]="  *)";
	$f[]="    echo \"Usage: $INITD_PATH {start|stop|restart|force-reload|reload-log|reload-database|status} (+ '--verbose' for more infos)\"";
	$f[]="    exit 1";
	$f[]="    ;;";
	$f[]="esac";
	$f[]="exit 0\n";


	echo "$daemonbinLog: [INFO] Writing $INITD_PATH with new config\n";
	@unlink($INITD_PATH);
	@file_put_contents($INITD_PATH, @implode("\n", $f));
	@chmod($INITD_PATH,0755);

	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
	}

	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
		shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
	}
	install_clamav_freshclam();
}

function install_clamav_freshclam(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	$INITD_PATH="/etc/init.d/clamav-freshclam";
	$php5script="exec.freshclam.php";
	$daemonbinLog="Clam AntiVirus userspace daemon";
	$Provides="clamav-freshclam";
	$daemonbinLog="Clam AntiVirus virus database updater";



	$f[]="#!/bin/sh";
	$f[]="### BEGIN INIT INFO";
	$f[]="# Provides:        $Provides";
	$f[]="# Required-Start:    \$local_fs \$syslog";
	$f[]="# Required-Stop:     \$local_fs \$syslog";
	$f[]="# Should-Start:";
	$f[]="# Should-Stop:";
	$f[]="# Default-Start:     3 4 5";
	$f[]="# Default-Stop:      0 1 6";
	$f[]="# Short-Description: $daemonbinLog";
	$f[]="# chkconfig: - 80 75";
	$f[]="# description: $daemonbinLog";
	$f[]="### END INIT INFO";

	$f[]="case \"\$1\" in";
	$f[]=" start)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  stop)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
	$f[]="    ;;";
	$f[]="  skip)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
	$f[]="    ;;";
	$f[]="  status)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" restart)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" reconfigure)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --build \$2 \$3";
	$f[]="    ;;";
	$f[]=" build)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --build \$2 \$3";
	$f[]="    ;;";
	$f[]=" force-reload)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --force-reload \$2 \$3";
	$f[]="    ;;";
	$f[]=" reload-database)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --reload-database \$2 \$3";
	$f[]="    ;;";
	$f[]=" reload-log)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --reload-log \$2 \$3";
	$f[]="    ;;";

	$f[]="";
	$f[]="  *)";
	$f[]="    echo \"Usage: $INITD_PATH {no-daemon|start|stop|restart|force-reload|reload-log|skip|status} (+ '--verbose' for more infos)\"";
	$f[]="    exit 1";
	$f[]="    ;;";
	$f[]="esac";
	$f[]="exit 0\n";


	echo "$daemonbinLog: [INFO] Writing $INITD_PATH with new config\n";
	@unlink($INITD_PATH);
	@file_put_contents($INITD_PATH, @implode("\n", $f));
	@chmod($INITD_PATH,0755);

	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
	}

	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
		shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
	}


}
function reload_database($aspid=false){
    $unix=new unix();
	$Masterbin=$unix->find_program("clamd");

	if(!is_file($Masterbin)){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]}, clamd not installed\n";}
		return;
	}

	if(!$aspid){
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=$unix->get_pid_from_file($pidfile);
		if($unix->process_exists($pid,basename(__FILE__))){
			$time=$unix->PROCCESS_TIME_MIN($pid);
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Already Artica task running PID $pid since {$time}mn\n";}
			return;
		}
		@file_put_contents($pidfile, getmypid());
	}
	$pid=PID_NUM();
	$kill=$unix->find_program("kill");
	if($unix->process_exists($pid)){
        $timepid=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service reloading PID $pid running since {$timepid}Mn...\n";}
		shell_exec("$kill -USR2 $pid");
		return;
	}	
	
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} not running\n";}
	
}
function reload($aspid=false){
	$unix=new unix();
	$sock=new sockets();
	$Masterbin=$unix->find_program("clamd");

	if(!is_file($Masterbin)){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]}, clamd not installed\n";}
		return;
	}
	
	$EnableClamavDaemon=$sock->EnableClamavDaemon();
	if($EnableClamavDaemon==0){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service disabled (see sock->EnableClamavDaemon)\n";}
		return;
	}

	if(!$aspid){
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=$unix->get_pid_from_file($pidfile);
		if($unix->process_exists($pid,basename(__FILE__))){
			$time=$unix->PROCCESS_TIME_MIN($pid);
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Already Artica task running PID $pid since {$time}mn\n";}
			return;
		}
		@file_put_contents($pidfile, getmypid());
	}
	$pid=PID_NUM();
	$kill=$unix->find_program("kill");
	if($unix->process_exists($pid)){
        $timepid=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service reloading PID $pid running since {$timepid}Mn...\n";}
		unix_system_HUP($pid);
		return;
	}

	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} not running\n";}

}



function start($aspid=false){
	$unix=new unix();
	$sock=new sockets();
	$Masterbin=$unix->find_program("clamd");

	if(!is_file($Masterbin)){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]}, clamd not installed\n";}
		return;
	}

	if(!$aspid){
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=$unix->get_pid_from_file($pidfile);
		if($unix->process_exists($pid,basename(__FILE__))){
			$time=$unix->PROCCESS_TIME_MIN($pid);
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Already Artica task running PID $pid since {$time}mn\n";}
			return;
		}
		@file_put_contents($pidfile, getmypid());
	}

	$pid=PID_NUM();

	if($unix->process_exists($pid)){
		$timepid=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Service already started $pid since {$timepid}Mn...\n";}
		@file_put_contents("/var/run/clamav/clamd.pid", $pid);
		return true;
	}
	
	$EnableClamavDaemon=$sock->EnableClamavDaemon();
	
	

	if($EnableClamavDaemon==0){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service disabled (see sock->EnableClamavDaemon)\n";}
		return;
	}


	$nohup=$unix->find_program("nohup");
	$aa_complain=$unix->find_program('aa-complain');
	if(is_file($aa_complain)){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} add clamd Profile to AppArmor..\n";}
		shell_exec("$aa_complain $Masterbin >/dev/null 2>&1");
	}

    fixClamLibs();
    $ClamUser=$unix->ClamUser();

	$Dirs[]="/var/clamav";
    $Dirs[]="/var/run/clamav";
    $Dirs[]="/var/lib/clamav";
    $Dirs[]="/var/log/clamav";
	
	foreach ($Dirs as $directory){
	    if(!is_dir($directory)){@mkdir($directory,0755,true);}
        $unix->chown_func("$ClamUser", "$ClamUser",$directory);
        @chmod($directory,0755);
    }
	
	RemoveBadPatterns();
	

	
	$YaraIncompatible=unserialize(@file_get_contents("/etc/artica-postfix/YaraIncompatible.db"));
	foreach ($YaraIncompatible as $path=>$line){
		if(is_file($path)){@unlink($path);}
	}
	

	
	$clamd_version=clamd_version();
	$file_temp=$unix->FILE_TEMP();
	build();
	$cmd="$nohup $Masterbin --config-file=/etc/clamav/clamd.conf >$file_temp 2>&1 &";
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service version $clamd_version\n";}
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service $cmd\n";}
	shell_exec($cmd);



	for($i=1;$i<21;$i++){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} waiting $i/20\n";}
		sleep(1);
		$pid=PID_NUM();
		if($unix->process_exists($pid)){break;}
	}
	
	$RESTART=false;
	$f=explode("\n",@file_get_contents($file_temp));
	foreach ($f as $line){

        if(preg_match("#ERROR: This tool requires libclamav with functionality level#i",$line,$re)){
            echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} functionality level issue\n";
            fixClamLibs();
            squid_admin_mysql(0,"ClamAV compatibility issue (see content), try to fix it",$line,__FILE__,__LINE__);
            return false;
        }

		if(preg_match("#Error: cli_loadyara: failed to parse rules file (.*?),#i", $line,$re)){
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Removing incompatible Yara rule {$re[1]}\n";}
			$YaraIncompatible[$re[1]]=true;
			$RESTART=true;
			continue;
		}



		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} $line\n";}
	}
	@unlink($file_temp);
	@file_put_contents("/etc/artica-postfix/YaraIncompatible.db", serialize($YaraIncompatible));
	if($RESTART){return start(true);}
	
	
	$pid=PID_NUM();
	if($unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Success PID $pid\n";}
		sleep(1);
		for($i=1;$i<21;$i++){
			
			if($unix->is_socket("/var/run/clamav/clamav.sock")){
				if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Apply permissions on clamav.sock\n";}
				@chmod("/var/run/clamav/clamav.sock", 0777);
				break;
			}else{
				if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} waiting for socket... $i/20 /var/run/clamav/clamav.sock\n";}
				sleep(1);
			}
		}
		
		if($unix->is_socket("/var/run/clamav/clamav.sock")){
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Apply permissions on clamav.sock\n";}
			@chmod("/var/run/clamav/clamav.sock", 0777);
			if(is_file("/usr/bin/c-icap")){
				shell_exec("$nohup /etc/init.d/c-icap reload >/dev/null 2>&1 &");
			}
		}else{
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} socket failed\n";}
		}

	}else{
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Failed\n";}
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} $cmd\n";}
	}
	
	$pid=PID_NUM();
	if(!$unix->process_exists($pid)){if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Failed..\n";}return false;}
	if(!$unix->is_socket("/var/run/clamav/clamav.sock")){if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} socket Failed..\n";}return false;}
	return true;

}

function clamd_version(){
	if(isset( $GLOBALS["clamd_version"])){return  $GLOBALS["clamd_version"];}
	$unix=new unix();
	$Masterbin=$unix->find_program("clamd");
	exec("$Masterbin -V 2>&1",$results);
	foreach ($results as $line){
		if(preg_match("#ClamAV\s+([0-9\.]+)\/#i", $line,$re)){
			$GLOBALS["clamd_version"]=$re[1];
			return $GLOBALS["clamd_version"];
		}
	}
}

function PID_NUM(){
	$unix=new unix();
	$pid=$unix->get_pid_from_file("/var/run/clamav/clamd.pid");
	if($unix->process_exists($pid)){return $pid;}
	$Masterbin=$unix->find_program("clamd");
	return $unix->PIDOF($Masterbin);

}




function stop($aspid=false){
	$unix=new unix();
	if(!$aspid){
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=$unix->get_pid_from_file($pidfile);
		if($unix->process_exists($pid,basename(__FILE__))){
			$time=$unix->PROCCESS_TIME_MIN($pid);
			if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service Already Artica task running PID $pid since {$time}mn\n";}
			return;
		}
		@file_put_contents($pidfile, getmypid());
	}

	$pid=PID_NUM();


	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service already stopped...\n";}
		return;
	}
	$pid=PID_NUM();
	$nohup=$unix->find_program("nohup");
	$php5=$unix->LOCATE_PHP5_BIN();
	$kill=$unix->find_program("kill");
	$chmod=$unix->find_program("chmod");



	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service Shutdown pid $pid...\n";}
	unix_system_kill($pid);
	for($i=0;$i<5;$i++){
		$pid=PID_NUM();
		if(!$unix->process_exists($pid)){break;}
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service waiting pid:$pid $i/5...\n";}
		sleep(1);
	}

	$pid=PID_NUM();
	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service success...\n";}
		return;
	}

	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service shutdown - force - pid $pid...\n";}
	unix_system_kill_force($pid);
	for($i=0;$i<5;$i++){
		$pid=PID_NUM();
		if(!$unix->process_exists($pid)){break;}
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service waiting pid:$pid $i/5...\n";}
		sleep(1);
	}

	if($unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service failed...\n";}
		return;
	}

}

function permissions(){
    $unix=new unix();
    $ClamUser=$unix->ClamUser();
    $chown=$unix->find_program("chown");
    $ClamavTemporaryDirectory="/home/clamav";
    $dirs[]="/var/clamav";
    $dirs[]="/var/run/clamav";
    $dirs[]="/var/lib/clamav";
    $dirs[]="/var/log/clamav";
    $dirs[]=$ClamavTemporaryDirectory;
    foreach ($dirs as $directory){
        if(!is_dir($directory)){@mkdir($directory,0755,true);}
        if(is_dir($directory)) {
            @chmod($directory, 0755);
            @chown($directory, $ClamUser);
            @chgrp($directory, $ClamUser);
            if ($GLOBALS["OUTPUT"]) {
                echo "Starting......: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} Permissions on $directory\n";
            }
            system("$chown -R $ClamUser:$ClamUser $directory");
        }

    }
    $ClamavTemporaryDirectory2=dirname($ClamavTemporaryDirectory);
    @chmod($ClamavTemporaryDirectory2,0755);

}

function build(){
	
	$unix=new unix();
	$sock=new sockets();
	$ClamavStreamMaxLength=$sock->GET_INFO("ClamavStreamMaxLength");
	$ClamavMaxRecursion=$sock->GET_INFO("ClamavMaxRecursion");
	$ClamavMaxFiles=$sock->GET_INFO("ClamavMaxFiles");

	$ClamavMaxScanSize=$sock->GET_INFO("ClamavMaxScanSize");
	$ClamavMaxFileSize=$sock->GET_INFO("ClamavMaxFileSize");
	$ClamavTemporaryDirectory="/home/clamav";
	if(!is_numeric($ClamavStreamMaxLength)){$ClamavStreamMaxLength=12;}
	if(!is_numeric($ClamavMaxRecursion)){$ClamavMaxRecursion=5;}
	if(!is_numeric($ClamavMaxFiles)){$ClamavMaxFiles=10000;}
	if(!is_numeric($ClamavMaxScanSize)){$ClamavMaxScanSize=15;}
	if(!is_numeric($ClamavMaxFileSize)){$ClamavMaxFileSize=20;}
	
	
	$PhishingScanURLs=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PhishingScanURLs"));
	$ClamaVDetectPUA=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ClamaVDetectPUA"));
	
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} MaxFileSize: {$ClamavMaxFileSize}M\n";}
	
	$ClamUser=$unix->ClamUser();
    permissions();

	
	
	$q=new lib_sqlite("/home/artica/SQLITE/antivirus.db");
	$results=$q->QUERY_SQL("SELECT VirusName FROM `whitelist` WHERE enabled=1 ORDER BY VirusName");
	$VIR=array();
	foreach ($results as $index=>$ligne){
		$ligne["VirusName"]=trim($ligne["VirusName"]);
		if($ligne["VirusName"]==null){continue;}
		if(preg_match("#^(.+?)\.UNOFFICIAL$#i", $ligne["VirusName"],$re)){$ligne["VirusName"]=$re[1];}
		if(preg_match("#^\{HEX\}(.+)#", $ligne["VirusName"],$re)){$VIR[]=strToHex($re[1]);continue;}
		
		
		
		$ligne["VirusName"]=str_replace("{HEX}","",$ligne["VirusName"]);
		$VIR[]=$ligne["VirusName"];
		
	}
	if(count($VIR)==0){
	    if(is_file("/var/lib/clamav/whitelist.ign2")) {
            @unlink("/var/lib/clamav/whitelist.ign2");
        }
	}else{
		build_progress(35, "{signature_exclusions} {done}");
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} ".count($VIR)." whitelisted viruse(s)\n";}
		@file_put_contents("/var/lib/clamav/whitelist.ign2", @implode("\n", $VIR));
	}
	
	
	

	$unix->SystemCreateUser("clamav","clamav");
	$f[]="LocalSocket /var/run/clamav/clamav.sock";
	$f[]="FixStaleSocket true";
	$f[]="User $ClamUser";
	
	$f[]="ScanMail true";
	$f[]="ScanArchive true";
	$f[]="#ArchiveLimitMemoryUsage false (depreciated)";
	$f[]="ArchiveBlockEncrypted false";
	$f[]="MaxDirectoryRecursion 15";
	$f[]="FollowDirectorySymlinks false";
	$f[]="FollowFileSymlinks false";
	$f[]="ReadTimeout 180";
	$f[]="MaxThreads 50";
	$f[]="MaxConnectionQueueLength 15";
	$f[]="StreamMaxLength {$ClamavStreamMaxLength}M";
	$f[]="MaxFileSize {$ClamavMaxFileSize}M";
	$f[]="MaxScanSize {$ClamavMaxFileSize}M";
	$f[]="MaxFiles 10000";
	$f[]="MaxRecursion {$ClamavMaxRecursion}";
	$f[]="LogSyslog yes";
	$f[]="LogRotate yes";
	$f[]="LogFacility LOG_LOCAL6";
	$f[]="LogClean false";
	$f[]="LogVerbose false";
	$f[]="PidFile /var/run/clamav/clamd.pid";
	$f[]="LogFile /var/log/clamav/clamd.log";
	$f[]="LogRotate yes";
	$f[]="LogFileMaxSize 50M";
	$f[]="TemporaryDirectory $ClamavTemporaryDirectory";
	$f[]="DatabaseDirectory /var/lib/clamav";
	$f[]="LocalSocketMode 777";
	$f[]="ExitOnOOM yes";
	$f[]="SelfCheck 3600";
	$f[]="Foreground false";
	$f[]="Debug false";
	$f[]="ScanPE true";
	$f[]="ScanOLE2 true";
	$f[]="ScanHTML true";
	$f[]="ScanPDF true";
	$f[]="ScanELF true";
	if($ClamaVDetectPUA==1){
		$f[]="DetectPUA true";
	}else{
		$f[]="DetectPUA false";
	}
	
	$f[]="PhishingSignatures true";
	if($PhishingScanURLs==1){
		$f[]="PhishingScanURLs true";
	}else{
		$f[]="PhishingScanURLs false";
	}

	
	$f[]="#DetectBrokenExecutables false (depreciated)";
	$f[]="#MailFollowURLs false (depreciated)";
	$f[]="LeaveTemporaryFiles false";
	$f[]="AlgorithmicDetection true";
	$f[]="IdleTimeout 30";
	$f[]="Bytecode yes";
	
	$f[]="PhishingAlwaysBlockSSLMismatch false";
	$f[]="PhishingAlwaysBlockCloak false";
	$f[]="ScanPartialMessages false";
	$f[]="HeuristicScanPrecedence false";
	$f[]="StructuredDataDetection false";
	$f[]="LogFile /var/log/clamav/clamd.log";
	$f[]="LogTime true";
	$f[]="LogFileUnlock false";
	$f[]="LogFileMaxSize 0";
	
	
	@file_put_contents("/etc/clamav/clamd.conf", @implode("\n", $f));
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} /etc/clamav/clamd.conf done\n";}
	
	
}
function strToHex($string){
	$hexstr = unpack('H*', $string);
	return array_shift($hexstr);
}

function hex_to_str($string) {
	return hex2bin("$string");
}