<?php

if (!isset($GLOBALS["CLASS_SOCKETS"])) {
    if (!class_exists("sockets")) {
        include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");
    }
    $GLOBALS["CLASS_SOCKETS"] = new sockets();
}
if (function_exists("posix_getuid")) {
    if (posix_getuid() <> 0) {
        die("Cannot be used in web server mode\n\n");
    }
}
include_once(dirname(__FILE__) . '/framework/class.unix.inc');
if (!isset($GLOBALS["CLASS_SOCKETS"])) {
    if (!class_exists("sockets")) {
        include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");
    }
    $GLOBALS["CLASS_SOCKETS"] = new sockets();
}
include_once(dirname(__FILE__) . "/framework/frame.class.inc");
include_once(dirname(__FILE__) . '/ressources/class.os.system.inc');
include_once(dirname(__FILE__) . '/ressources/class.system.network.inc');
include_once(dirname(__FILE__) . '/ressources/class.samba.kerb.inc');
include_once(dirname(__FILE__) . '/ressources/class.tcpip.inc');
include_once(dirname(__FILE__) . '/ressources/class.users.menus.inc');
include_once(dirname(__FILE__) . '/ressources/class.ActiveDirectory.inc');
include_once(dirname(__FILE__) . "/framework/class.settings.inc");

if($argv[1]=="--run"){execKerb();exit;}
if($argv[1]=="--off"){disconnect();exit;}
if($argv[1]=="--kerberos"){kerberos();exit;}
if($argv[1]=="--emergency"){emergency();exit;}
if($argv[1]=="--emergency-remove"){emergency_remove();exit;}



function build_progress($text,$pourc,$other=null){
    $echotext=$text;

    echo "Starting......: ".date("H:i:s")." {$pourc}% $echotext\n";
    if($other<>null){echo "Starting......: ".date("H:i:s")." {$pourc}% $other\n";}
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
   @file_put_contents("/usr/share/artica-postfix/ressources/logs/web/msktutils.progress", serialize($array));
   @chmod("/usr/share/artica-postfix/ressources/logs/web/msktutils.progress",0755);


}
function progress_logs($pourc,$text,$other=null){
    build_progress($text,$pourc,$other);
}

function emergency(){
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    build_progress("{enable_emergency_mode}",20);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("ActiveDirectoryEmergency",1);
    build_progress("{enable_emergency_mode}",50);
    system("$php /usr/share/artica-postfix/exec.squid.global.access.php --auth --percent-pr=50");
    squid_admin_mysql(0,"Active Directory: switch to Emergency - Success",null,__FILE__,__LINE__);
    build_progress("{enable_emergency_mode} {success}",100);
}
function emergency_remove(){
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    build_progress("{disable_emergency_mode}",20);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("ActiveDirectoryEmergency",0);
    build_progress("{disable_emergency_mode}",50);
    system("$php /usr/share/artica-postfix/exec.squid.global.access.php --auth --percent-pr=50");
    squid_admin_mysql(0,"Active Directory: exit to Emergency - Success",null,__FILE__,__LINE__);
    build_progress("{disable_emergency_mode} {success}",100);
}


function disconnect(){
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LockActiveDirectoryToKerberos",0);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("WindowsActiveDirectoryKerberos",0);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("ActiveDirectoryEmergency",0);
    @unlink("/etc/squid3/PROXY.keytab");
    @unlink("/etc/cron.daily/msktutil");
    @file_put_contents("/etc/krb.conf", @implode("\n", array()));
    @file_put_contents("/etc/krb5.conf", @implode("\n", array()));

    @unlink("/etc/cron.d/squid-negotiateauthenticator-5mn");
    system("/etc/init.d/cron reload");

    build_progress("{uninstall}",20);
    $unix=new unix();
    $kdestroy=$unix->find_program("kdestroy");
    $php=$unix->LOCATE_PHP5_BIN();
    shell_exec("$kdestroy");
    build_progress("{reconfigure}",50);
    system("$php /usr/share/artica-postfix/exec.squid.global.access.php --auth --percent-pr=51");
    squid_admin_mysql(0,"Active Directory: Disconnecting from Active Directory Success",null,__FILE__,__LINE__);
    build_progress("{uninstall} {success}",100);

}

function execKerb(){
    echo "Synchronize time...\n";
    sync_time();
    echo "kerberos configuration..\n";
    if(!kerberos()){return false;}
    echo "kinit...\n";

    $unix=new unix();
    $kdestroy=$unix->find_program("kdestroy");
    $php=$unix->LOCATE_PHP5_BIN();

    if(!RunKinit(30)){
        build_progress("kinit {failed}",110);
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LockActiveDirectoryToKerberos",0);
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("WindowsActiveDirectoryKerberos",0);
        return;
    }

    if(!run_msktutils($GLOBALS["PRC_PROGRESS"])){
        build_progress("msktutil {failed}",110);
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LockActiveDirectoryToKerberos",0);
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO("WindowsActiveDirectoryKerberos",0);
        shell_exec("$kdestroy");
        return;
    }
    $progress=$GLOBALS["PRC_PROGRESS"];

    if(is_file("/etc/init.d/winbind")){
        build_progress("{uninstall} {APP_SAMBA_WINBIND}",$progress++);
        remove_service("/etc/init.d/winbind");
        build_progress("{uninstall} {APP_SAMBA_WINBIND}",$progress++);
        if(is_file("/etc/monit/conf.d/winbind.monitrc")) {@unlink("/etc/monit/conf.d/winbind.monitrc");}
        if(is_file("/etc/monit/conf.d/APP_WINBINDD.monitrc")) {@unlink("/etc/monit/conf.d/APP_WINBINDD.monitrc");}
        system("/etc/init.d/monit restart");
    }

    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("LockActiveDirectoryToKerberos",1);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("WindowsActiveDirectoryKerberos",1);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableKerbAuth",1);
    shell_exec("$kdestroy");



    build_progress("{reconfiguring} {APP_SQUID}",$progress++);

    system("$php /usr/share/artica-postfix/exec.squid.global.access.php --auth --percent-pr=$progress");

    build_progress("msktutil {success}",100);
}

function run_msktutils($progress=1){
    $function=__FUNCTION__;
    $unix=new unix();
    $fullhostname=$unix->hostname_g();
    $msktutil = $unix->find_program("msktutil");
    if (!is_file($msktutil)) {
        progress_logs($progress++, "{join_activedirectory_domain}", "msktutil not installed, you should use it..");
        return;
    }
    $array=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("KerbAuthInfos")));
    if($array["COMPUTER_BRANCH"]==null){$array["COMPUTER_BRANCH"]="CN=Computers";}

    $fullhostnameK=explode(".",$fullhostname);
    $NetbiosName=strtoupper($fullhostnameK[0]);

    $cmd[]="$msktutil -c -b \"{$array["COMPUTER_BRANCH"]}\"";
    $cmd[]="-s HTTP/{$fullhostname} -k /etc/squid3/PROXY.keytab";
    $cmd[]="--computer-name \"$NetbiosName\" --upn HTTP/$fullhostname";
    $cmd[]="--server {$array["fullhosname"]} --no-reverse-lookups --verbose --enctypes 28";

    $cmdline=@implode(" ", $cmd);
    progress_logs($progress++,"{join_activedirectory_domain}","$function,`$cmdline`");
    exec("$cmdline 2>&1",$results);
    foreach ($results as $a){
        if(trim($a)==null){continue;}



        progress_logs(20,"{join_activedirectory_domain}","$function, $a Line:".__LINE__."");

        if(preg_match("#continue with wrong UPN#i", $a)){
            echo "$cmdline\n###################################################################\n";
            echo "######################### MSKTUTILS FAILED #########################\n";
            progress_logs(20,"{join_activedirectory_domain} kerberos failed (wrong UPN)","$function,`$cmdline`");
            return false;
        }



        if(preg_match("#Is your kerberos ticket expired#i", $a)){
            progress_logs(20,"{join_activedirectory_domain} kerberos failed (ticket expired)","$function,`$cmdline`");
            echo "$cmdline\n###################################################################\n";
            echo "######################### MSKTUTILS FAILED #########################\n";
            squid_admin_mysql(0,"Active Directory: {join_activedirectory_domain} failed",@implode("\n",$results),__FILE__,__LINE__);
            return false;

        }

    }


    if(!is_file("/etc/squid3/PROXY.keytab")){
            echo "/etc/squid3/PROXY.keytab - No Such file!!\n$cmdline\n";
            echo "###################################################################\n";
            echo "######################### MSKTUTILS FAILED #########################\n";
            echo "###################################################################\n";
        squid_admin_mysql(0,"Active Directory: PROXY.keytab missing {join_activedirectory_domain} failed",@implode("\n",$results),__FILE__,__LINE__);
            return false;
    }




    echo "SUCCESS\n";
    echo "###################################################################\n";

        @chmod("/etc/squid3/PROXY.keytab", 0755);
        @chown("/etc/squid3/PROXY.keytab","squid");
        @chgrp("/etc/squid3/PROXY.keytab","squid");



    echo "buildong cron for updates...\n";
    $cmdline="$msktutil --auto-update --verbose --computer-name $NetbiosName --no-reverse-lookups --server {$array["fullhosname"]} >/dev/null";
    $CRON[]="#!/bin/sh";
    $CRON[]="exec $cmdline";
    $CRON[]="";

    $php=$unix->LOCATE_PHP5_BIN();
    @file_put_contents("/etc/cron.daily/msktutil", @implode("\n", $CRON));
    chmod("/etc/cron.daily/msktutil",0755);
    chown("/etc/cron.daily/msktutil","root");
    system("$php /usr/share/artica-postfix/exec.squid.disable.php --squid-service");

    system("/etc/init.d/squid reload");
    squid_admin_mysql(2,"Active Directory: KINIT {join_activedirectory_domain} {success}",@implode("\n",$results),__FILE__,__LINE__);


    $unix->Popuplate_cron_make("squid-negotiateauthenticator-5mn","*/5 * * * *","exec.negotiateauthenticator.php");
    system("/etc/init.d/cron reload");

    return true;

}

function RunKinit($progress=1){
    $unix=new unix();
    $kinit=$unix->find_program("kinit");
    $klist=$unix->find_program("klist");
    $echo=$unix->find_program("echo");
    $function=__FUNCTION__;
    if(!is_file($kinit)){echo "Unable to stat kinit\n";return;}
    sync_time();
    exec("$klist 2>&1",$res);
    $line=@implode("",$res);


    $array=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("KerbAuthInfos")));

    $kinitpassword= $array["WINDOWS_SERVER_PASS"];
    $password     = $unix->shellEscapeChars($kinitpassword);
    $username     = $array["WINDOWS_SERVER_ADMIN"];

    if(strpos($username,"@")){
        $usernameR=explode("@",$username);
        $username=$usernameR[0];
    }


    if(strpos($line,"No credentials cache found")>0){
        unset($res);
        echo $line." -> initialize..\n";
        $cmd="$echo $password|$kinit {$username} 2>&1";
        progress_logs($progress++,"{kerberaus_authentication}","$cmd");
        progress_logs($progress++,"{kerberaus_authentication}","$function, kinit `$username`");
        exec("$echo $password|$kinit {$username} 2>&1",$res);
        foreach ($res as $a){
            progress_logs($progress++,"{kerberaus_authentication}","$a");

            if(preg_match("#Clock skew too great while#", $a)){
                echo "           * * * * * * * * * * * * * * * * * * *\n";
                echo "           * *                               * *\n";
                echo "           * * Please check the system clock ! *\n";
                echo "           * *   Time differ with the AD     * *\n";
                echo "           * *                               * *\n";
                echo "           * * * * * * * * * * * * * * * * * * *\n";
                progress_logs($progress++,"{kerberaus_authentication}",$a." -> Failed..");
                $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableKerbAuth",0);
                return;
            }

        }

    }

    progress_logs($progress++,"{kerberaus_authentication}",$klist);
    exec("$klist 2>&1",$res);


    foreach ($res as $a){
        progress_logs($progress++,"{kerberaus_authentication}","$a");
        if(preg_match("#Default principal:(.+)#",$a,$re)){
            progress_logs($progress++,"{kerberaus_authentication}","$a SUCCESS");
            break;
        }
    }

    $GLOBALS["PRC_PROGRESS"]=$progress;

    return true;
}


function sync_time(){
    if(isset($GLOBALS[__FUNCTION__])){return;}
    $unix=new unix();
    $NtpdateAD=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NtpdateAD"));
    if($NtpdateAD==0){return;}
    $function=__FUNCTION__;
    $array=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("KerbAuthInfos")));
    $hostname=strtolower(trim($array["WINDOWS_SERVER_NETBIOSNAME"])).".".strtolower(trim($array["WINDOWS_DNS_SUFFIX"]));
    $ipaddr=trim($array["ADNETIPADDR"]);
    $ntpdate=$unix->find_program("ntpdate");
    $hwclock=$unix->find_program("hwclock");


    if(!is_file($ntpdate)){progress_logs(20,"{sync_time_ad}","$function, ntpdate no such binary Line:".__LINE__."");return;}
    progress_logs(20,"{sync_time_ad}","$function, sync the time with the Active Directory $hostname [$ipaddr]...");
    if($ipaddr<>null){$cmd="$ntpdate -u $ipaddr";}else{$cmd="$ntpdate -u $hostname";}
    if($GLOBALS["VERBOSE"]){progress_logs(20,"{sync_time_ad}","$cmd line:".__LINE__."");}
    exec($cmd." 2>&1",$results);
    while (list ($num, $a) = each ($results) ){
        $unix->ToSyslog($a,false,"ntpd");
        progress_logs(20,"{sync_time_ad}","$function, $a Line:".__LINE__."");
    }

    if(is_file($hwclock)){
        progress_logs(20,"{sync_time_ad}","$function, sync the Hardware time with $hwclock");
        shell_exec("$hwclock --systohc");
    }

    $GLOBALS[__FUNCTION__]=true;
}

function kerberos(){
    $array=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("KerbAuthInfos")));
    $IPClass=new IP();

    if(!isset($array["fullhosname"])){
        build_progress("/etc/krb5.conf fullhosname not defined!",110);
        return false;

    }

    $hostname=strtolower(trim($array["fullhosname"]));
    if(!isset($array["ADNETIPADDR"])){$array["ADNETIPADDR"]=null;}

    if($array["ADNETIPADDR"]==null){
        $ipaddr=gethostbyname($hostname);
        if(!$IPClass->isValid($ipaddr)){
            echo "* * * * Cannot resolve IP of $hostname * * * *\n";
            return false;
        }
        $array["ADNETIPADDR"]=$ipaddr;
    }


    $hostnameTR=explode(".",$hostname);
    unset($hostnameTR[0]);
    $domain=@implode(".",$hostnameTR);

    $domainUp=strtoupper($domain);
    $domaindow=strtolower($domain);
    $ipaddr=trim($array["ADNETIPADDR"]);

    if(!ActiveDirectory::test_server_resolution($domaindow)){
        build_progress("/etc/krb5.conf $domaindow kdc resolve false",110);
        return false;
    }


    echo "hostname............: $hostname $domaindow/$domainUp\n";
    echo "ipaddr..............: $ipaddr\n";

    $fp=@fsockopen($array["ADNETIPADDR"], 88, $errno, $errstr, 2);
    if(!$fp){
        build_progress("/etc/krb5.conf port 88 {failed}",110);
        echo "* * * * {$array["ADNETIPADDR"]} on port 88 Error: $errno ($errstr) !!! * * * *\n";
        return false;
    }

    echo "{$array["ADNETIPADDR"]} on port 88 OK\n";

    fclose($fp);

    $fp=@fsockopen($array["ADNETIPADDR"], 464, $errno, $errstr, 2);
    if(!$fp){
        build_progress("/etc/krb5.conf port 464 {failed}",110);
        echo "* * * * {$array["ADNETIPADDR"]} on port 464 Error: $errno ($errstr) !!! * * * *\n";
        return false;
    }
    fclose($fp);
    echo "{$array["ADNETIPADDR"]} on port 464 OK\n";




    if($array["WINDOWS_SERVER_TYPE"]=="WIN_2003"){
        $t[]="# For Windows 2003:";
        $t[]=" default_tgs_enctypes = rc4-hmac des-cbc-crc des-cbc-md5";
        $t[]=" default_tkt_enctypes = rc4-hmac des-cbc-crc des-cbc-md5";
        $t[]=" permitted_enctypes = rc4-hmac des-cbc-crc des-cbc-md5";
        $t[]="";

    }

    if($array["WINDOWS_SERVER_TYPE"]=="WIN_2008AES" OR $array["WINDOWS_SERVER_TYPE"]=="WIN_2016"){
        $t[]="; for Windows 2008 with AES";
        $t[]=" default_tgs_enctypes = aes256-cts-hmac-sha1-96 aes128-cts-hmac-sha1-96 rc4-hmac des-cbc-crc des-cbc-md5";
        $t[]=" default_tkt_enctypes = aes256-cts-hmac-sha1-96 aes128-cts-hmac-sha1-96 rc4-hmac des-cbc-crc des-cbc-md5";
        $t[]=" permitted_enctypes   = aes256-cts-hmac-sha1-96 aes128-cts-hmac-sha1-96 rc4-hmac des-cbc-crc des-cbc-md5";
        $t[]="";


    }


    $dns_lookup_realm="yes";
    $dns_lookup_kdc="yes";
    $default_realm=$domainUp;
    $realms=$domainUp;



    $f[]="[logging]";
    $f[]="\tdefault = FILE:/var/log/krb5libs.log";
    $f[]="\tkdc = FILE:/var/log/krb5kdc.log";
    $f[]="\tadmin_server = FILE:/var/log/kadmind.log";
    $f[]="";
    $f[]="[libdefaults]";
    $f[]="\tdefault_keytab_name = /etc/squid3/PROXY.keytab";
    $f[]="\tdefault_realm = $default_realm";
    $f[]="\tdns_lookup_realm = $dns_lookup_realm";
    $f[]="\tdns_lookup_kdc = $dns_lookup_kdc";
    $f[]="\tallow_weak_crypto = true";
    $f[]="\tticket_lifetime = 24h";
    $f[]="\tforwardable = true";
    $f[]="\tproxiable = true";
    $f[]="\tfcc-mit-ticketflags = true";
    $f[]="\tccache_type = true";
    $f[]="\tdefault_ccache_name = FILE:/etc/kerberos/tickets/krb5cc_%{euid}";




    $f[]="[realms]";
    $f[]="\t$realms = {";
    $f[]="\t\tkdc = $hostname:88";
    $f[]="\t\tmaster_kdc = $hostname:88";
    $f[]="\t\tkpasswd_server = $hostname:464";


    if(count($array["Controllers"])>0){
        foreach ($array["Controllers"] as $md5=>$array2){
            $kdc_hostname=$array2["hostname"];
            $kdc_ipaddr=$array2["ipaddr"];
            $UseIPaddr=$array2["UseIPaddr"];
            if($UseIPaddr==1){
                $f[]="\t\tkdc = $kdc_ipaddr";
            }else{
                $f[]="\t\tkdc = $kdc_hostname";
            }
        }
    }

    $f[]="\t\tadmin_server = $hostname";
    $f[]="\t\tdefault_domain = $domaindow";
    $f[]="\t}";
    $f[]="";
    $f[]="[domain_realm]";
    $f[]="\t.$domaindow = $domainUp";
    $f[]="\t$domaindow = $domainUp";

    $f[]="";
    $f[]="[appdefaults]";
    $f[]="\tpam = {";
    $f[]="\t\tdebug = false";
    $f[]="\t\tticket_lifetime = 36000";
    $f[]="\t\trenew_lifetime = 36000";
    $f[]="\t\tforwardable = true";
    $f[]="\t\tkrb4_convert = false";
    $f[]="\t}";
    $f[]="";




    $conf[]="";
    @mkdir("/etc/kerberos/tickets",0755,true);
    @file_put_contents("/etc/krb.conf", @implode("\n", $f));
    @file_put_contents("/etc/krb5.conf", @implode("\n", $f));
    build_progress("/etc/krb5.conf {success}",30);
    return true;

}



function TestsKerbauth(){
    $unix=new unix();
    if(!RunKinit(0)){
        echo "Failed\n";
    }

    $fullhostname=$unix->hostname_g();
    $array=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("KerbAuthInfos")));
    $awk=$unix->find_program("awk");
    $print=$unix->find_program("print");
    $fullhostnameK=explode(".",$fullhostname);
    $NetbiosName=strtoupper($fullhostnameK[0]);


    $cmd[]="/lib/squid3/negotiate_kerberos_auth_test serversquid.mondomaine.local |";
    $cmd[]="$awk '{sub(/Token:/,\"YR\"); $print $0}END{print \"QQ\"}' |";
    $cmd[]="/usr/lib/squid3/negotiate_kerberos_auth -r -s HTTP/serversquid.mondomaine.local@MONDOMAINE.LOCAL";

}
function remove_service($INITD_PATH){
    if(!is_file($INITD_PATH)){return;}
    system("$INITD_PATH stop");

    if(is_file('/usr/sbin/update-rc.d')){
        shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");
    }

    if(is_file('/sbin/chkconfig')){
        shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");

    }

    if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}