<?php
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
$GLOBALS["FORCE"]=false;
$GLOBALS["RECONFIGURE"]=false;
$GLOBALS["SWAPSTATE"]=false;
$GLOBALS["NOSQUIDOUTPUT"]=true;
$GLOBALS["VERBOSE"]=false;
$GLOBALS["RELOAD"]=false;
$GLOBALS["pidStampReload"]="/etc/artica-postfix/pids/".basename(__FILE__).".Stamp.reload.time";
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;$GLOBALS["OUTPUT"]=true;
$GLOBALS["debug"]=true;
ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
if(preg_match("#--output#",implode(" ",$argv))){$GLOBALS["OUTPUT"]=true;}
if(preg_match("#schedule-id=([0-9]+)#",implode(" ",$argv),$re)){$GLOBALS["SCHEDULE_ID"]=$re[1];}
if(preg_match("#--force#",implode(" ",$argv),$re)){$GLOBALS["FORCE"]=true;}
if(preg_match("#--reconfigure#",implode(" ",$argv),$re)){$GLOBALS["RECONFIGURE"]=true;}



$GLOBALS["AS_ROOT"]=true;
include_once(dirname(__FILE__).'/ressources/class.ldap.inc');
include_once(dirname(__FILE__).'/ressources/class.nginx.inc');
include_once(dirname(__FILE__).'/ressources/class.freeweb.inc');
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__).'/ressources/class.squid.reverse.inc');
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.settings.inc');
include_once(dirname(__FILE__).'/ressources/class.resolv.conf.inc');

if($argv[1]=="--verif"){verif();exit;}
if($argv[1]=="--disable"){uninstall();exit;}
if($argv[1]=="--monit"){build_monit();exit;}




startx();

function build_progress($text,$pourc){
	$GLOBALS["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/nginx-enable.progress";
	echo "[{$pourc}%] $text\n";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($GLOBALS["PROGRESS_FILE"], serialize($array));
	@chmod($GLOBALS["PROGRESS_FILE"],0755);
	sleep(1);

}

function verif(){
	$unix=new unix();
	$sock=new sockets();
	$sock=new sockets();
	$t=time();
	$EnableNginx=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableNginx"));
	$EnableFreeWeb=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableFreeWeb"));
	$EnableNginxMail=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableNginxMail"));
	$SQUIDEnable=trim($sock->GET_INFO("SQUIDEnable"));
	$php=$unix->LOCATE_PHP5_BIN();

	$unix->CreateUnixUser("www-data","www-data","Web services");
	
	build_progress("Restart Artica status",5);
	system('/etc/init.d/artica-status restart --force');
	
	if($EnableNginx==1){
		build_progress("Reverse Proxy is enabled",10);
		build_progress("{configuring}....",15);
		system("$php /usr/share/artica-postfix/exec.nginx.php --build");
		build_progress("{starting} reverse Proxy service",15);
		
		system("/etc/init.d/nginx start");
	}else{
		build_progress("Reverse Proxy is disabled",10);
		build_progress("{stopping} reverse Proxy service",15);
		system("/etc/init.d/nginx stop");		
		
	}
	

	
	if($SQUIDEnable==1){
		build_progress("Proxy service is enabled",50);
		build_progress("{starting} Proxy service",60);
		system("/etc/init.d/squid start");
	}else{
		build_progress("Proxy service is disabled",50);
		build_progress("{stopping} Proxy service",60);
		system("/etc/init.d/squid stop");
	}	
	
	build_progress("{done}",100);
	
}

function required_libraries(){

   $libs["liblua5.3-0"]="/usr/lib/x86_64-linux-gnu/liblua5.3.so.0";
   $f=array();
   $c=0;
   foreach ($libs as $package=>$path){
        if(!is_file($path)){
            $c++;
            $f[]=$package;}

   }

   if($c==0){return array();}
   return $f;
}


function startx(){
	$unix                           = new unix();
	$php                            = $unix->LOCATE_PHP5_BIN();
    $ElasticsearchBehindReverse     = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ElasticsearchBehindReverse"));



    $required_libraries=required_libraries();
    if(count($required_libraries)>0){
        foreach ($required_libraries as $pckg){
            build_progress("Install $pckg...",10);
            $unix->DEBIAN_INSTALL_PACKAGE($pckg);
        }
    }
    $required_libraries=required_libraries();
    if(count($required_libraries)>0){
        build_progress("missing ".@implode(",",$required_libraries),110);
        return;
    }


	build_progress("Set true for service...",10);
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableNginx", 1);
	build_progress("{install_services}",15);



    if(is_file("/usr/local/modsecurity/lib/libmodsecurity.so")){
        if(!is_file("/etc/ld.so.conf.d/modsecurity.conf")){
            @file_put_contents("/etc/ld.so.conf.d/modsecurity.conf","/usr/local/modsecurity/lib\n");
            $ldconfig=$unix->find_program("ldconfig");
            shell_exec($ldconfig);
        }
    }


	nginx_service();
	
	build_progress("Restart Artica status",20);
	system('/etc/init.d/artica-status restart');
	
	if(is_file("/etc/init.d/apache2")){
		build_progress("Remove Web server apache2",30);
		remove_service("/etc/init.d/apache2");
	}
	
	if(is_file("/etc/init.d/munin-node")){
		shell_exec("$php /usr/share/artica-postfix/exec.munin.php --server");
		system("/etc/init.d/munin-node restart");
	}
    $binary=$unix->find_program("frontail-linux");
	if(is_file($binary)){
        shell_exec("$php /usr/share/artica-postfix/exec.frontail-nginx.php --install");
    }
	build_progress("Restart {APP_NGINX} service",50);
	system("/etc/init.d/nginx restart");
	build_progress("{APP_MONIT}",90);
	build_monit();

	if($ElasticsearchBehindReverse==1){
        shell_exec("$php /usr/share/artica-postfix/exec.nginx.single.php --elastic");
    }

	build_progress("{done}",100);
	
}

function build_monit(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	@unlink("/etc/monit/conf.d/APP_NGINX.monitrc");
	$f=array();
	$f[]="check process APP_NGINX with pidfile /var/run/nginx.pid";
	$f[]="\tstart program = \"/etc/init.d/nginx start --monit\"";
	$f[]="\tstop program = \"/etc/init.d/nginx stop --monit\"";
    $f[]="\tif failed host 127.0.0.1 port 1842 protocol http for 2 cycles then restart";
	$f[]="\tif 5 restarts within 5 cycles then timeout";
	$f[]="";
    @file_put_contents("/etc/monit/conf.d/APP_NGINX.monitrc", @implode("\n", $f));


    $sh[]="#!/bin/sh";
    $sh[]="$php /usr/share/artica-postfix/exec.lighttpd.php --nginx-build || true";
    $sh[]="$php /usr/share/artica-postfix/exec.lighttpd.php --fpm-start || true\n";
    @file_put_contents("/bin/fpm_start.sh",@implode("\n",$sh));
    @chmod("/bin/fpm_start.sh",0755);

    $sh=array();
    $sh[]="#!/bin/sh";
    $sh[]="$php /usr/share/artica-postfix/exec.lighttpd.php --fpm-stop || true\n";
    @file_put_contents("/bin/fpm_stop.sh",@implode("\n",$sh));
    @chmod("/bin/fpm_stop.sh",0755);


	$f=array();
    $f[]="check process APP_NGINX_PHP with pidfile /var/run/artica-phpfpm.pid";
    $f[]="\tstart program = \"/bin/fpm_start.sh\"";
    $f[]="\tstop program = \"/bin/fpm_stop.sh\"";
    $f[]="\tif failed unixsocket /var/run/nginx-phpfpm.sock then restart";
    $f[]="\tif 5 restarts within 5 cycles then timeout";
    $f[]="";
    @file_put_contents("/etc/monit/conf.d/APP_NGINX_PHP.monitrc", @implode("\n", $f));

    $monit=$unix->find_program("monit");
    system("$monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid -s /var/run/monit/monit.state reload");
	

	
}

function uninstall(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
    $monit=$unix->find_program("monit");
	build_progress("Set False for service...",10);
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableNginx", 0);
	build_progress("{uninstall_service} {APP_MONIT}",20);
	
	if(is_file("/etc/monit/conf.d/APP_NGINX.monitrc")){
		@unlink("/etc/monit/conf.d/APP_NGINX.monitrc");
        system("$monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid -s /var/run/monit/monit.state reload");
	}


    if(is_file("/etc/monit/conf.d/APP_NGINX_PHP.monitrc")){
		@unlink("/etc/monit/conf.d/APP_NGINX.monitrc");
        system("$monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid -s /var/run/monit/monit.state reload");
	}
	
	if(is_file("/etc/init.d/munin-node")){
		shell_exec("$php /usr/share/artica-postfix/exec.munin.php --server");
        system("$monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid -s /var/run/monit/monit.state reload");
	}

    shell_exec("$php /usr/share/artica-postfix/exec.frontail-nginx.php --uninstall");
    if(is_file("/etc/ld.so.conf.d/modsecurity.conf")){
        @unlink("/etc/ld.so.conf.d/modsecurity.conf");
    }

    shell_exec("$php /usr/share/artica-postfix/exec.ModSecurity.install.php --uninstall");

	
	remove_service("/etc/init.d/nginx");
	build_progress("{uninstall_service}",30);
	remove_service("/etc/init.d/nginx-auth-ldap");
	build_progress("{uninstall_service}",40);
	remove_service("/etc/init.d/nginx-auth-form");
	build_progress("{uninstall_service} {success}",100);
	
}

function remove_service($INITD_PATH){
	if(!is_file($INITD_PATH)){return;}
	system("$INITD_PATH stop");

	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");
	}

	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");

	}

	if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}

function nginx_service(){
	if(is_file("/etc/artica-postfix/WEBSECURITY_APPLIANCE")){return;}
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	$INITD_PATH="/etc/init.d/nginx";
	$php5script="exec.nginx.php";
	$daemonbinLog="nginx For Artica";
	$daemon_path=$unix->find_program("nginx");
	$restart=false;
	if(!is_file("/etc/artica-postfix/ngnix.first.restart")){$restart=true;}

	$f[]="#!/bin/sh";
	$f[]="### BEGIN INIT INFO";
	$f[]="# Provides:         artica-nginx";
	$f[]="# Required-Start:    \$local_fs \$syslog";
	$f[]="# Required-Stop:     \$local_fs \$syslog";
	$f[]="# Should-Start:";
	$f[]="# Should-Stop:";
	$f[]="# Default-Start:     3 4 5";
	$f[]="# Default-Stop:      0 1 6";
	$f[]="# Short-Description: $daemonbinLog";
	$f[]="# chkconfig: - 80 75";
	$f[]="# description: $daemonbinLog";
	$f[]="### END INIT INFO";

	$f[]="case \"\$1\" in";
	$f[]=" start)";
	$f[]="    ulimit -n 65536";
	$f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
	$f[]="    $php /usr/share/artica-postfix/exec.mounts.bind.php \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  stop)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" restart)";
	$f[]="    ulimit -n 65536";
	$f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
	$f[]="    $php /usr/share/artica-postfix/exec.mounts.bind.php \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" reconfigure)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --build \$2 \$3";
	$f[]="    ;;";
	$f[]=" reload)";
	$f[]="    ulimit -n 65536";
	$f[]="    $php /usr/share/artica-postfix/$php5script --reload \$2 \$3";
	$f[]="    ;;";
	$f[]="";

	$f[]=" purge)";
	$f[]="    ulimit -n 65536";
	$f[]="    $php /usr/share/artica-postfix/$php5script --purge-all-caches \$2 \$3";
	$f[]="    ;;";
	$f[]="";



	$f[]=" reconfigure)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --build \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  *)";
	$f[]="    echo \"Usage: \$0 {start|stop|restart|reconfigure|reload} (+ '--verbose' for more infos)\"";
	$f[]="    exit 1";
	$f[]="    ;;";
	$f[]="esac";
	$f[]="exit 0\n";


	echo "$daemonbinLog: [INFO] Writing $INITD_PATH with new config\n";
	@unlink($INITD_PATH);
	@file_put_contents($INITD_PATH, @implode("\n", $f));
	@chmod($INITD_PATH,0755);

	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
	}

	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
		shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
	}

	if($restart){
		@file_put_contents("/etc/artica-postfix/ngnix.first.restart", time());
		echo "Restarting Apache Web server...\n";
		remove_service("/etc/init.d/apache2");
		echo "Restarting Nginx service...\n";
		system("$INITD_PATH restart");
	}
	nginx_auth_ldap();

}

function nginx_auth_ldap(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	$INITD_PATH="/etc/init.d/nginx-auth-ldap";
	$php5script="exec.nginx.auth.ldap.php";
	$daemonbinLog="Nginx LDAP background Auth";

	$f[]="#!/bin/sh";
	$f[]="### BEGIN INIT INFO";
	$f[]="# Provides:         ".basename($INITD_PATH);
	$f[]="# Required-Start:    \$local_fs \$syslog";
	$f[]="# Required-Stop:     \$local_fs \$syslog";
	$f[]="# Should-Start:";
	$f[]="# Should-Stop:";
	$f[]="# Default-Start:     3 4 5";
	$f[]="# Default-Stop:      0 1 6";
	$f[]="# Short-Description: $daemonbinLog";
	$f[]="# chkconfig: - 80 75";
	$f[]="# description: $daemonbinLog";
	$f[]="### END INIT INFO";

	$f[]="case \"\$1\" in";
	$f[]=" start)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  stop)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" restart)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" reconfigure)";
	$f[]="     $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  *)";
	$f[]="    echo \"Usage: \$0 {start|stop|restart|reconfigure} (+ '--verbose' for more infos)\"";
	$f[]="    exit 1";
	$f[]="    ;;";
	$f[]="esac";
	$f[]="exit 0\n";


	echo "$daemonbinLog: [INFO] Writing $INITD_PATH with new config\n";
	@unlink($INITD_PATH);
	@file_put_contents($INITD_PATH, @implode("\n", $f));
	@chmod($INITD_PATH,0755);

	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
	}

	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
		shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
	}

	nginx_auth_form();
}
function nginx_auth_form(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	$INITD_PATH="/etc/init.d/nginx-auth-form";
	$php5script="exec.nginx.auth.form.php";
	$daemonbinLog="Nginx Form background Auth";

	$f[]="#!/bin/sh";
	$f[]="### BEGIN INIT INFO";
	$f[]="# Provides:         ".basename($INITD_PATH);
	$f[]="# Required-Start:    \$local_fs \$syslog";
	$f[]="# Required-Stop:     \$local_fs \$syslog";
	$f[]="# Should-Start:";
	$f[]="# Should-Stop:";
	$f[]="# Default-Start:     3 4 5";
	$f[]="# Default-Stop:      0 1 6";
	$f[]="# Short-Description: $daemonbinLog";
	$f[]="# chkconfig: - 80 75";
	$f[]="# description: $daemonbinLog";
	$f[]="### END INIT INFO";

	$f[]="case \"\$1\" in";
	$f[]=" start)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  stop)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" restart)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" reconfigure)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  *)";
	$f[]="    echo \"Usage: \$0 {start|stop|restart|reconfigure} (+ '--verbose' for more infos)\"";
	$f[]="    exit 1";
	$f[]="    ;;";
	$f[]="esac";
	$f[]="exit 0\n";


	echo "$daemonbinLog: [INFO] Writing $INITD_PATH with new config\n";
	@unlink($INITD_PATH);
	@file_put_contents($INITD_PATH, @implode("\n", $f));
	@chmod($INITD_PATH,0755);

	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
	}

	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
		shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
	}


}