#!/usr/bin/php -q
<?php
$GLOBALS["YESCGROUP"]=true;
$GLOBALS["BASEDIR"]="/usr/share/artica-postfix/ressources/interface-cache";
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
$GLOBALS["FORCE"]=false;
$GLOBALS["RECONFIGURE"]=false;
$GLOBALS["SWAPSTATE"]=false;
$GLOBALS["NOSQUIDOUTPUT"]=true;
$GLOBALS["TITLENAME"]="InfluxDB Daemon";
$GLOBALS["PROGRESS"]=false;
$GLOBALS["MIGRATION"]=false;
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;
$GLOBALS["OUTPUT"]=true;$GLOBALS["debug"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
if(preg_match("#--output#",implode(" ",$argv))){$GLOBALS["OUTPUT"]=true;}
if(preg_match("#schedule-id=([0-9]+)#",implode(" ",$argv),$re)){$GLOBALS["SCHEDULE_ID"]=$re[1];}
if(preg_match("#--force#",implode(" ",$argv),$re)){$GLOBALS["FORCE"]=true;}
if(preg_match("#--reconfigure#",implode(" ",$argv),$re)){$GLOBALS["RECONFIGURE"]=true;}
if(preg_match("#--migration#",implode(" ",$argv),$re)){$GLOBALS["MIGRATION"]=true;}

$GLOBALS["AS_ROOT"]=true;
include_once(dirname(__FILE__).'/ressources/class.ldap.inc');
include_once(dirname(__FILE__).'/ressources/class.squid.inc');
include_once(dirname(__FILE__).'/ressources/class.mysql.inc');
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.settings.inc');
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.system.nics.inc');
include_once(dirname(__FILE__).'/ressources/class.influx.inc');

$GLOBALS["ARGVS"]=implode(" ",$argv);
if($argv[1]=="--dbsize"){InfluxDbSize();exit;}
if($argv[1]=="--delete-backup"){DeleteBackup($argv[2]);}
if($argv[1]=="--restore"){RestoreBackup($argv[2]);}
backup();
exec_verif_packages_php();

function DebianVersion(){
	$ver=trim(@file_get_contents("/etc/debian_version"));
	preg_match("#^([0-9]+)\.#",$ver,$re);
	if(preg_match("#squeeze\/sid#",$ver)){return 6;}
	return $re[1];
}

function DeleteBackup($ID){
    $q=new lib_sqlite("/home/artica/SQLITE_TEMP/pg_tables.db");
    $ligne=$q->mysqli_fetch_array("SELECT * FROM backup WHERE ID=$ID");
    $filename=$ligne["filename"];
    if(is_file($filename)){@unlink($filename);}
    $q->QUERY_SQL("DELETE FROM backup WHERE ID=$ID");
}
function RestoreBackup($sourcepath){
    $InFluxBackupDatabaseDir=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("InFluxBackupDatabaseDir");
    if($InFluxBackupDatabaseDir==null){$InFluxBackupDatabaseDir="/home/artica/influx/backup";}

    if(!is_file($sourcepath)){
        build_progress_idb("{failed} $sourcepath no such file",110);
        return;
    }

    if(!is_dir($InFluxBackupDatabaseDir)){@mkdir($InFluxBackupDatabaseDir,0755,true);}
    $DestPath="$InFluxBackupDatabaseDir/snapshot.imported.".date("Y-m-d-H-i").".gz";
    if(is_file($DestPath)){@unlink($DestPath);}
    build_progress_idb("{copy} $sourcepath",30);

    if(!@copy($sourcepath,$DestPath)){
        build_progress_idb("{copy} $sourcepath {failed}",110);
        @unlink($sourcepath);
        @unlink($DestPath);
        return;
    }
    build_progress_idb("{remove} $sourcepath",50);
    @unlink($sourcepath);
    build_progress_idb("{scanning} $InFluxBackupDatabaseDir",80);
    ScanBackup();
    build_progress_idb("{done}",100);
}

function backup(){
	build_progress_idb("{backup_database}",20);
	$unix=new unix();
	$targetFilename="/home/ArticaStatsBackup/backup.db";
	$su=$unix->find_program("su");
	@mkdir("/home/ArticaStatsBackup",0777,true);
	@chmod("/home/ArticaStatsBackup",0777);
	if(is_file($targetFilename)){@unlink($targetFilename);}
	$BackupSquidLogsUseNas=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("BackupSquidLogsUseNas"));
	$InFluxBackupDatabaseDir=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("InFluxBackupDatabaseDir");
	if($InFluxBackupDatabaseDir==null){$InFluxBackupDatabaseDir="/home/artica/influx/backup";}
	$CompressFileName="$InFluxBackupDatabaseDir/snapshot.".date("Y-m-d-H-i").".gz";
	$ContainersToDelete=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PostGresBackupMaxContainers"));
	if($ContainersToDelete==0){$ContainersToDelete=3;}
	
	@mkdir($InFluxBackupDatabaseDir,0755,true);
	
	
	if(is_file($CompressFileName)){
		build_progress_idb("{backup_database} already exists",110);
	}
	
	$cmdline="$su -c \"/usr/local/ArticaStats/bin/pg_dumpall -c --if-exists -S ArticaStats -f $targetFilename -h /var/run/ArticaStats\" ArticaStats";
	echo $cmdline."\n";
	$results[]=$cmdline;
	exec($cmdline,$results);
	build_progress_idb("{backup_database}",30);

	if(!is_file($targetFilename)){
		echo "$targetFilename No such file\n";
		foreach ($results as $num=>$val){
			echo "$val\n";
			
		}
		squid_admin_mysql(0, "Snaphost BigData database {failed} ( processing )", @implode("\n", $results),__FILE__,__LINE__);
		build_progress_idb("{backup_database} {failed}",110);
		return;
	}
	
	
	
	
	build_progress_idb("{compressing}",50);
	echo "Compress $targetFilename\n";
	echo "Destination $CompressFileName\n";
	if(!$unix->compress($targetFilename, $CompressFileName)){
		build_progress_idb("{compressing} {failed}",110);
		squid_admin_mysql(0, "Snaphost BigData database {failed} ( compress )", null,__FILE__,__LINE__);
		@unlink($targetFilename);
		@unlink($CompressFileName);
		return;
		
	}
	@unlink($targetFilename);
	$sizeBytes=@filesize($CompressFileName);
	$size=FormatBytes($sizeBytes/1024);
	squid_admin_mysql(2, "Backup [".basename($CompressFileName)."] BigData database ($size) done", null,__FILE__,__LINE__);


    $q=new lib_sqlite("/home/artica/SQLITE_TEMP/pg_tables.db");

    $sql="CREATE TABLE IF NOT EXISTS `backup` (
		`ID` INTEGER PRIMARY KEY AUTOINCREMENT,
		`filename` TEXT,
		`filesize` integer,
		`zdate` INTEGER
    )";

    $q->QUERY_SQL($sql);
    $t=time();
    $sql="INSERT INTO backup (filename,filesize,zdate) VALUES ('$CompressFileName','$sizeBytes','$t')";
    $q->QUERY_SQL($sql);




	build_progress_idb("{scanning}",80);
	$unix=new unix();
	$ls=$unix->find_program("ls");
	$head=$unix->find_program("head");
	$xargs=$unix->find_program("xargs");
	
	
	// ************************ REMOVE OLD FILES ************************
	$tmpfile=$unix->FILE_TEMP().".sh";
	$sh=array();
	$sh[]="#! /bin/sh";
	$sh[]="$ls -d -1tr \"/home/artica/influx/backup/\"* | $head -n -$ContainersToDelete|$xargs -d '\n' rm -f";
	$sh[]="";
	@file_put_contents($tmpfile, @implode("\n", $sh));
	@chmod($tmpfile,0755);
	system($tmpfile);
	@unlink($tmpfile);
	// ************************ ************************ *****************
	
	if($BackupSquidLogsUseNas==1){
		$php=$unix->LOCATE_PHP5_BIN();
		$nohup=$unix->find_program("nohup");
		system("$nohup $php /usr/share/artica-postfix/exec.squid.rotate.php --backup-postgres");
	}
		
	
	
	ScanBackup();
	InfluxDbSize();
	build_progress_idb("{backup_database} {success}",100);
}

function ScanBackup(){
	

	$InFluxBackupDatabaseDir=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("InFluxBackupDatabaseDir");
	if($InFluxBackupDatabaseDir==null){$InFluxBackupDatabaseDir="/home/artica/influx/backup";}
	$PostGresBackupMaxContainers=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("PostGresBackupMaxContainers");

    $q=new lib_sqlite("/home/artica/SQLITE_TEMP/pg_tables.db");

    $sql="CREATE TABLE IF NOT EXISTS `backup` (
		`ID` INTEGER PRIMARY KEY AUTOINCREMENT,
		`filename` TEXT,
		`filesize` integer,
		`zdate` INTEGER
    )";

    $q->QUERY_SQL($sql);


	$unix=new unix();


	$results=$q->QUERY_SQL("SELECT * FROM backup");
	foreach ($results as $index=>$ligne){
	    $filename=$ligne["filename"];
	    $ID=$ligne["ID"];
	    $INDB[$filename]=$ligne["ID"];
        if(!is_file($filename)){
            $q->QUERY_SQL("DELETE FROM backup WHERE ID=$ID");
            continue;
        }

    }

    $patnz=$unix->DirFiles($InFluxBackupDatabaseDir,"\.gz$");
	foreach ($patnz as $filepath=>$none){
		$filepath="$InFluxBackupDatabaseDir/$filepath";
		if(isset($INDB[$filepath])){continue;}
		$filesize=@filesize($filepath);
		$filetime=filemtime($filepath);
		$ARRAY[$filepath]=$filesize;
        $sql="INSERT INTO backup (filename,filesize,zdate) VALUES ('$filepath','$filesize','$filetime')";
        $q->QUERY_SQL($sql);
	}
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("InfluxDBRestoreArray", serialize($ARRAY));

	
}

function exec_verif_packages_php(){
    $unix=new unix();
    if(!is_file("/etc/artica-postfix/VERIF_PKG_TIME")){
        $php=$unix->LOCATE_PHP5_BIN();
        $nohup=$unix->find_program("nohup");
        shell_exec("$nohup $php /usr/share/artica-postfix/exec.verif.packages.php >/dev/null 2>&1 &");

    }else{
        $time=$unix->file_time_min("/etc/artica-postfix/VERIF_PKG_TIME");
        if($time>10080){
            $php=$unix->LOCATE_PHP5_BIN();
            $nohup=$unix->find_program("nohup");
            shell_exec("$nohup $php /usr/share/artica-postfix/exec.verif.packages.php >/dev/null 2>&1 &");
        }
    }
}


function InfluxDbSize(){
    $unix=new unix();

    exec_verif_packages_php();


    if(system_is_overloaded()){
        die();
    }

	$dir="/home/ArticaStatsDB";

	$size=$unix->DIRSIZE_KO($dir);
	$partition=$unix->DIRPART_INFO($dir);


	echo "Directory: $dir ($size KB)\n";
	
	$TOT=$partition["TOT"];
	$percent=($size/$TOT)*100;
	$percent=round($percent,3);
	
	
	echo "$dir: $size Partition $TOT\n";

	$ARRAY["PERCENTAGE"]=$percent;
	$ARRAY["SIZEKB"]=$size;
	$ARRAY["PART"]=$TOT;

    echo "Percent: {$percent}%\n";
	
	if($GLOBALS["VERBOSE"]){print_r($ARRAY);};
	@unlink("/usr/share/artica-postfix/ressources/logs/web/InfluxDB.state");
	@file_put_contents("/usr/share/artica-postfix/ressources/logs/web/InfluxDB.state", serialize($ARRAY));
	
}
function build_progress_idb($text,$pourc){
	$GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/postgres.backup.progress";
	echo "{$pourc}% $text\n";
	$cachefile=$GLOBALS["CACHEFILE"];
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($cachefile, serialize($array));
	@chmod($cachefile,0755);

}	
?>