<?php
if(is_file("/etc/artica-postfix/FROM_ISO")){if(is_file("/etc/init.d/artica-cd")){print "Starting......: ".date("H:i:s")." artica-". basename(__FILE__)." Waiting Artica-CD to finish\n";exit();}}
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
$GLOBALS["FORCE"]=false;
$GLOBALS["RECONFIGURE"]=false;
$GLOBALS["SWAPSTATE"]=false;
$GLOBALS["SERVICE_NAME"]="Persistent key-value db";
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;$GLOBALS["OUTPUT"]=true;$GLOBALS["debug"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
if(preg_match("#--output#",implode(" ",$argv))){$GLOBALS["OUTPUT"]=true;}
if(preg_match("#schedule-id=([0-9]+)#",implode(" ",$argv),$re)){$GLOBALS["SCHEDULE_ID"]=$re[1];}
if(preg_match("#--force#",implode(" ",$argv),$re)){$GLOBALS["FORCE"]=true;}
if(preg_match("#--reconfigure#",implode(" ",$argv),$re)){$GLOBALS["RECONFIGURE"]=true;}
$GLOBALS["AS_ROOT"]=true;
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.settings.inc');
include_once(dirname(__FILE__).'/ressources/class.squid.inc');


$GLOBALS["ARGVS"]=implode(" ",$argv);
if($argv[1]=="--stop"){$GLOBALS["OUTPUT"]=true;stop();exit();}
if($argv[1]=="--start"){$GLOBALS["OUTPUT"]=true;start();exit();}
if($argv[1]=="--restart"){$GLOBALS["OUTPUT"]=true;restart();exit();}
if($argv[1]=="--reload"){$GLOBALS["OUTPUT"]=true;reload();exit();}
if($argv[1]=="--build"){$GLOBALS["OUTPUT"]=true;build();exit();}
if($argv[1]=="--install"){$GLOBALS["OUTPUT"]=true;install();exit();}
if($argv[1]=="--uninstall"){$GLOBALS["OUTPUT"]=true;remove();exit();}
if($argv[1]=="--version"){$GLOBALS["OUTPUT"]=true;echo redis_version();exit();}



function restart($nopid=false){
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	if(!$nopid){
		$pid=$unix->get_pid_from_file($pidfile);
		if($unix->process_exists($pid,basename(__FILE__))){
			$time=$unix->PROCCESS_TIME_MIN($pid);
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Already Artica task running PID $pid since {$time}mn\n";}
			return;
		}
	}
	@file_put_contents($pidfile, getmypid());
	stop(true);
	build();
	start(true);
}

function build_progress($text,$pourc){
    $GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/web/redis.progress";
    echo "{$pourc}% $text\n";
    $cachefile=$GLOBALS["CACHEFILE"];
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($cachefile, serialize($array));
    @chmod($cachefile,0755);

}

function reload($nopid=false){
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	if(!$nopid){
		$pid=$unix->get_pid_from_file($pidfile);
		if($unix->process_exists($pid,basename(__FILE__))){
			$time=$unix->PROCCESS_TIME_MIN($pid);
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: Already Artica task running PID $pid since {$time}mn\n";}
			return;
		}
	}
	@file_put_contents($pidfile, getmypid());

	$sock=new sockets();

	
	build();
	$masterbin=$unix->find_program("redis-server");
	if(!is_file($masterbin)){
		$unix->DEBIAN_INSTALL_PACKAGE("redis-server");
		$masterbin=$unix->find_program("redis-server");
	}
	
	
	if(!is_file($masterbin)){
		if($GLOBALS["OUTPUT"]){echo "Reload........: [INIT]: {$GLOBALS["SERVICE_NAME"]} not installed\n";}
		return;
	}
	$pid=redis_pid();
	$kill=$unix->find_program("kill");
	if($unix->process_exists($pid)){
		$time=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Reload........: [INIT]: {$GLOBALS["SERVICE_NAME"]} Service running since {$time}Mn...\n";}
		unix_system_HUP($pid);
		return;
	}
	start(true);
}

function NETWORK_ALL_INTERFACES(){
	if(isset($GLOBALS["NETWORK_ALL_INTERFACES"])){return $GLOBALS["NETWORK_ALL_INTERFACES"];}
	$unix=new unix();
	$GLOBALS["NETWORK_ALL_INTERFACES"]=$unix->NETWORK_ALL_INTERFACES(true);
	unset($GLOBALS["NETWORK_ALL_INTERFACES"]["127.0.0.1"]);
}


function build(){
	$sock=new sockets();
	$unix=new unix();
    $RedisBindIP=null;
	$sysctl=$unix->find_program("sysctl");
	shell_exec("$sysctl \"vm.overcommit_memory=1\" 2>&1");


	$RedisBindInterface=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("RedisBindInterface");
	if($RedisBindInterface==null){$RedisBindInterface="lo";}

	if($RedisBindInterface=="lo"){$RedisBindIP="127.0.0.1";}else{
        $RedisBindIP=$unix->InterfaceToIPv4($RedisBindInterface);
    }

	if($RedisBindIP==null){$RedisBindIP="127.0.0.1";}
    redis_server_install();

	$f[]="daemonize yes";
	$f[]="pidfile /var/run/redis/redis-server.pid";
	$f[]="port 6379";
	$f[]="bind $RedisBindIP";
	$f[]="unixsocket /var/run/redis/redis.sock";
	$f[]="unixsocketperm 777";
	$f[]="timeout 0";
	$f[]="loglevel notice";
	$f[]="logfile /var/log/redis/redis-server.log";
	$f[]="syslog-enabled no";
	$f[]="syslog-ident redis-server";
	$f[]="syslog-facility local5";
	$f[]="databases 16";
	$f[]="save 900 1";
	$f[]="save 300 10";
	$f[]="save 60 10000";
	$f[]="rdbcompression yes";
	$f[]="dbfilename dump.rdb";
	$f[]="dir /home/redis";
	$f[]="slave-serve-stale-data yes";
	$f[]="# maxclients 128";
	$f[]="# maxmemory <bytes>";
	$f[]="# maxmemory-policy allkeys-lru";
	$f[]="# maxmemory-samples 3";
	$f[]="appendonly no";
	$f[]="appendfsync everysec";
	$f[]="no-appendfsync-on-rewrite no";
	$f[]="auto-aof-rewrite-percentage 100";
	$f[]="auto-aof-rewrite-min-size 64mb";
	$f[]="slowlog-log-slower-than 10000";
	$f[]="slowlog-max-len 128";
	$f[]="list-max-ziplist-entries 512";
	$f[]="list-max-ziplist-value 64";
	$f[]="set-max-intset-entries 512";
	$f[]="zset-max-ziplist-entries 128";
	$f[]="zset-max-ziplist-value 64";
	$f[]="activerehashing yes";
	CheckFilesAndSecurity();
	
	@file_put_contents("/etc/redis/redis.conf", @implode("\n", $f));
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} /etc/redis/redis.conf done\n";}


}

function start($nopid=false){

	
	$sock=new sockets();
	
	$unix=new unix();
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	if(!$nopid){
		$pid=$unix->get_pid_from_file($pidfile);
		if($unix->process_exists($pid,basename(__FILE__))){
			$time=$unix->PROCCESS_TIME_MIN($pid);
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Already Artica task running PID $pid since {$time}mn\n";}
			return false;
		}
	}
	
	
	
	$pid=redis_pid();
	if($unix->process_exists($pid)){
		$time=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Already running since {$time}Mn...\n";}
		return true;
	}
	
	$EnableRedisServer=intval($sock->GET_INFO("EnableRedisServer"));

	
	
	if($EnableRedisServer==0){
        outstart("Disabled ( see Enablentopng )...");
		return false;
	}

	

	$masterbin=$unix->find_program("redis-server");
	if(!is_file($masterbin)){
        outstart("installing redis-server");
		$unix->DEBIAN_INSTALL_PACKAGE("redis-server");
		$masterbin=$unix->find_program("redis-server");
	}
	
	if(!is_file($masterbin)){
        outstart("Not installed...");
		return false;
	}
	
	CheckFilesAndSecurity();

    $pids=$unix->PIDOF_BY_PORT(6379);
    outstart(count($pids)." processes running 6379");
    foreach ($pids as $pid=>$none){
        eoutstart("killing $pid listen 6379");
        unix_system_kill_force($pid);
    }



	$version=redis_version();
    outstart("Starting service v$version");
	$cmd="$masterbin /etc/redis/redis.conf";
	if(is_file("/var/log/redis/redis-server.log")){@unlink("/var/log/redis/redis-server.log");}


	shell_exec($cmd);
	
	$c=1;
	for($i=0;$i<10;$i++){
		sleep(1);
        outstart("Starting service waiting $c");
		$pid=redis_pid();
		if($unix->process_exists($pid)){
            outstart("Success PID $pid");
			break;
		}
		$c++;
	}
	
	$pid=redis_pid();
	if(!$unix->process_exists($pid)){

	    $f=explode("\n",@file_get_contents("/var/log/redis/redis-server.log"));
	    foreach ($f as $line){
            $line=trim($line);
            if(!isset($GLOBALS["ALLFIX"])) {
                if (preg_match("#Fatal error loading the DB#", $line, $re)) {
                    outstart("Fixing Error ($line)");
                    @unlink("/home/redis/dump.rdb");
                    $GLOBALS["ALLFIX"] = true;
                    return start(true);
                }
            }
            echo outstart($line);

        }


        outstart("Failed");
        outstart("$cmd");
		return false;
	}

	return true;
	
}
function outstart($text){
    echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} $text\n";
}

function CheckFilesAndSecurity(){
	$unix=new unix();
	$unix->CreateUnixUser("redis","redis");
	$f[]="/var/run/redis";
	$f[]="/var/log/redis";
	$f[]="/home/redis";
	$f[]="/etc/redis";

	
	while (list ($num, $val) = each ($f)){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} checking \"$val\"\n";}
		if(!is_dir($val)){@mkdir($val,0755,true);}
		$unix->chown_func("redis","redis","$val/*");
	}
	
}

function stop(){

	$unix=new unix();
	$sock=new sockets();
	$masterbin=$unix->find_program("redis-server");
	
	
	$pid=redis_pid();
	if(!is_file($masterbin)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Not installed\n";}
		return;
		
	}

	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Already stopped...\n";}
		return;
	}

	$nohup=$unix->find_program("nohup");
	$php5=$unix->LOCATE_PHP5_BIN();
	$kill=$unix->find_program("kill");
	


	

	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} Shutdown pid $pid...\n";}
	unix_system_kill($pid);
	for($i=0;$i<5;$i++){
		$pid=redis_pid();
		if(!$unix->process_exists($pid)){break;}
		unix_system_kill($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} waiting pid:$pid $i/5...\n";}
		sleep(1);
	}

	$pid=redis_pid();
	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} success...\n";}
		return;
	}

	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} shutdown - force - pid $pid...\n";}
	
	unix_system_kill_force($pid);
	for($i=0;$i<5;$i++){
		$pid=redis_pid();
		if(!$unix->process_exists($pid)){break;}
		echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} waiting pid:$pid $i/5...\n";
		unix_system_kill_force($pid);
		sleep(1);
	}

	$pids=$unix->PIDOF_BY_PORT(6379);
	foreach ($pids as $pid=>$none){
        echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} killing $pid listen 6379\n";
        unix_system_kill_force($pid);
    }

	$pid=redis_pid();
	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} success stopped...\n";}
		return;
	}else{
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["SERVICE_NAME"]} failed...\n";}
	}
}

function redis_version(){
	$unix=new unix();
	if(isset($GLOBALS["redis_version"])){return $GLOBALS["redis_version"];}
	$masterbin=$unix->find_program("redis-server");
	if(!is_file($masterbin)){return "0.0.0";}
	exec("$masterbin --version 2>&1",$results);
	foreach ($results as $val){
	    if($GLOBALS["VERBOSE"]){echo "Checks $val\n";}
		if(preg_match("#Redis server version\s+(.+)#", $val,$re)){
			$GLOBALS["redis_version"]=trim($re[1]);
			return $GLOBALS["redis_version"];
		}

		if(preg_match("#Redis server v=([0-9\.]+)\s+#",$val,$re)){
            $GLOBALS["redis_version"]=trim($re[1]);
            return $GLOBALS["redis_version"];
        }
	}
}

function redis_pid(){
	$unix=new unix();
	$zmasterbin=$unix->find_program("redis-server");
	$pid=$unix->get_pid_from_file('/var/run/redis/redis-server.pid');
	if($unix->process_exists($pid)){return $pid;}
	return $unix->PIDOF_PATTERN($zmasterbin." -f /etc/redis/redis.conf");
}


function install(){
    $unix=new unix();
    $sock=new sockets();
    $sock->SET_INFO("EnableRedisServer",1);
    build_progress("{installing}",20);
    redis_server_install();

    build_progress("{starting_service}",50);
    if(!start(true)){
        build_progress("{installing} {failed}",110);
        $sock->SET_INFO("EnableRedisServer",0);
        remove_service("/etc/init.d/redis-server");
        return;
    }
    $php=$unix->LOCATE_PHP5_BIN();
    build_progress("{installing}",60);
    redis_server_monit();
    build_progress("{installing}",70);
    system("$php /usr/share/artica-postfix/exec.php.ini.php");
    build_progress("{installing}",80);
    system("$php /usr/share/artica-postfix/exec.lighttpd.php --fpm-reload");
    build_progress("{restarting}",90);
    system("/etc/init.d/redis-server stop");
    system("/etc/init.d/redis-server start");
    build_progress("{success}",100);

}
function remove(){
    $unix=new unix();
    build_progress("{removing}",50);
    @unlink("/etc/monit/conf.d/APP_REDIS_SERVER.monitrc");
    shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload >/dev/null 2>&1");

    $sock=new sockets();
    $sock->SET_INFO("EnableRedisServer",0);
    remove_service("/etc/init.d/redis-server");
    $php=$unix->LOCATE_PHP5_BIN();
    if(is_file("/etc/init.d/ntopng")){
        build_progress("{removing} {APP_NTOPNG}",60);
        system("$php /usr/share/artica-postfix/exec.ntopng.disable.php");
    }
    $rm=$unix->find_program("rm");
    system("$rm -rf /home/redis/*");
    build_progress("{removing} {done}",100);
}



function remove_service($INITD_PATH){
    if(!is_file($INITD_PATH)){return;}
    system("$INITD_PATH stop");
    if(is_file('/usr/sbin/update-rc.d')){shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");}
    if(is_file('/sbin/chkconfig')){shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");}
    if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}


function redis_server_monit(){
    $f[]="check process APP_REDIS_SERVER with pidfile /var/run/redis/redis-server.pid";
    $f[]="\tstart program = \"/etc/init.d/redis-server start\"";
    $f[]="\tstop program = \"/etc/init.d/redis-server stop\"";
    $f[]="\tif 5 restarts within 5 cycles then timeout";
    $f[]="";
    @file_put_contents("/etc/monit/conf.d/APP_REDIS_SERVER.monitrc", @implode("\n", $f));
    if(!is_file("/etc/monit/conf.d/APP_REDIS_SERVER.monitrc")){
        echo "/etc/monit/conf.d/APP_REDIS_SERVER.monitrc failed !!!\n";
    }
    shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload >/dev/null 2>&1");

}

function redis_server_install(){
    $f[]="#! /bin/sh";
    $f[]="### BEGIN INIT INFO";
    $f[]="# Provides:		redis-server";
    $f[]="# Required-Start:	\$syslog \$remote_fs";
    $f[]="# Required-Stop:	\$syslog \$remote_fs";
    $f[]="# Should-Start:		\$local_fs";
    $f[]="# Should-Stop:		\$local_fs";
    $f[]="# Default-Start:	2 3 4 5";
    $f[]="# Default-Stop:		0 1 6";
    $f[]="# Short-Description:	redis-server - Persistent key-value db";
    $f[]="# Description:		redis-server - Persistent key-value db";
    $f[]="### END INIT INFO";
    $f[]="";
    $f[]="";
    $f[]="PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin";
    $f[]="DAEMON=/usr/bin/redis-server";
    $f[]="DAEMON_ARGS=/etc/redis/redis.conf";
    $f[]="NAME=redis-server";
    $f[]="DESC=redis-server";
    $f[]="";
    $f[]="RUNDIR=/var/run/redis";
    $f[]="PIDFILE=\$RUNDIR/redis-server.pid";
    $f[]="";
    $f[]="test -x \$DAEMON || exit 0";
    $f[]="";
    $f[]="if [ -r /etc/default/\$NAME ]";
    $f[]="then";
    $f[]="	. /etc/default/\$NAME";
    $f[]="fi";
    $f[]="";
    $f[]=". /lib/lsb/init-functions";
    $f[]="";
    $f[]="set -e";
    $f[]="";
    $f[]="if [ \"\$(id -u)\" != \"0\" ]";
    $f[]="then";
    $f[]="	log_failure_msg \"Must be run as root.\"";
    $f[]="	exit 1";
    $f[]="fi";
    $f[]="";
    $f[]="Run_parts () {";
    $f[]="	if [ -d /etc/redis/\${NAME}.\${1}.d ]";
    $f[]="	then";
    $f[]="		su redis -s /bin/sh -c \"run-parts --exit-on-error /etc/redis/\${NAME}.\${1}.d\"";
    $f[]="	fi";
    $f[]="}";
    $f[]="";
    $f[]="case \"\$1\" in";
    $f[]="  start)";
    $f[]="	echo never > /sys/kernel/mm/transparent_hugepage/enabled || true";
    $f[]="	echo -n \"Starting \$DESC: \"";
    $f[]="	mkdir -p \$RUNDIR";
    $f[]="	touch \$PIDFILE";
    $f[]="	chown redis:redis \$RUNDIR \$PIDFILE";
    $f[]="	chown -R redis:redis /var/log/redis";
    $f[]="	chmod 755 \$RUNDIR";
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    $f[]="  $php ".__FILE__." --build || true";
    $f[]="";
    $f[]="	if [ -n \"\$ULIMIT\" ]";
    $f[]="	then";
    $f[]="		ulimit -n \$ULIMIT";
    $f[]="	fi";
    $f[]="";
    $f[]="  $php ".__FILE__." --start || true";
    $f[]="	;;";
    $f[]="  stop)";
    $f[]="  $php ".__FILE__." --stop || true";
    $f[]="	sleep 1";
    $f[]="	;;";
    $f[]="";
    $f[]="  restart|force-reload)";
    $f[]="	\${0} stop";
    $f[]="	\${0} start";
    $f[]="	;;";
    $f[]="";
    $f[]="  status)";
    $f[]="	status_of_proc -p \${PIDFILE} \${DAEMON} \${NAME}";
    $f[]="	;;";
    $f[]="";
    $f[]="  *)";
    $f[]="	echo \"Usage: /etc/init.d/\$NAME {start|stop|restart|force-reload|status}\" >&2";
    $f[]="	exit 1";
    $f[]="	;;";
    $f[]="esac";
    $f[]="";
    $f[]="exit 0\n";

    $INITD_PATH="/etc/init.d/redis-server";
    @unlink($INITD_PATH);
    @file_put_contents($INITD_PATH, @implode("\n", $f));
    @chmod($INITD_PATH,0755);

    if(is_file('/usr/sbin/update-rc.d')){
        shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
    }

    if(is_file('/sbin/chkconfig')){
        shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
        shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
    }

}