<?php
ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);
ini_set('error_prepend_string',null);ini_set('error_append_string',null);
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
$GLOBALS["FORCE"]=false;
$GLOBALS["RECONFIGURE"]=false;
$GLOBALS["SWAPSTATE"]=false;
$GLOBALS["NOSQUIDOUTPUT"]=true;
$GLOBALS["VERBOSE"]=false;
$GLOBALS["RELOAD"]=false;
$GLOBALS["REPLIC_CONF"]=false;
$GLOBALS["NO_RELOAD"]=false;
$GLOBALS["NO_BUILD_MAIN"]=false;
$GLOBALS["pidStampReload"]="/etc/artica-postfix/pids/".basename(__FILE__).".Stamp.reload.time";
$GLOBALS["debug"]=true;

if(preg_match("#--output#",implode(" ",$argv))){$GLOBALS["OUTPUT"]=true;}
if(preg_match("#schedule-id=([0-9]+)#",implode(" ",$argv),$re)){$GLOBALS["SCHEDULE_ID"]=$re[1];}
if(preg_match("#--force#",implode(" ",$argv),$re)){$GLOBALS["FORCE"]=true;}
if(preg_match("#--reconfigure#",implode(" ",$argv),$re)){$GLOBALS["RECONFIGURE"]=true;}
if(preg_match("#--replic-conf#",implode(" ",$argv),$re)){$GLOBALS["REPLIC_CONF"]=true;}
if(preg_match("#--no-reload#",implode(" ",$argv),$re)){$GLOBALS["NO_RELOAD"]=true;}
if(preg_match("#--no-buildmain#",implode(" ",$argv),$re)){$GLOBALS["NO_BUILD_MAIN"]=true;}




$GLOBALS["AS_ROOT"]=true;
include_once(dirname(__FILE__).'/ressources/class.ldap.inc');
include_once(dirname(__FILE__).'/ressources/class.nginx.inc');
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__).'/ressources/class.squid.reverse.inc');
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.settings.inc');
include_once(dirname(__FILE__).'/ressources/class.resolv.conf.inc');
include_once(dirname(__FILE__).'/ressources/class.system.nics.inc');

if($argv[1]=="--uninstall"){uninstall();exit;}
if($argv[1]=="--install-service"){install_service();exit;}
if($argv[1]=="--re-install"){reinstall_service($argv[2]);exit;}
if($argv[1]=="--exec"){execute_autconfig();exit;}


execute_autconfig();

function build_progress($text,$pourc){
	$filename=basename(__FILE__);
	$GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/web/squid-autoconf.progress";
	echo "[{$pourc}%] $filename: $text\n";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($GLOBALS["CACHEFILE"], serialize($array));
	@chmod($GLOBALS["CACHEFILE"],0755);
	if($GLOBALS["OUTPUT"]){usleep(5000);}


}

function reinstall_service($hostname){
    $unix=new unix();

	build_progress("{removing_service}",50);
	uninstall(true);
	build_progress("{installing_service}",60);
	install_service();
	build_progress("{installing_service}",70);

    @mkdir("/var/log/proxy-pac",0755,true);
    @mkdir("/home/squid/proxy_pac_rules",0755,true);
    $unix->Popuplate_cron_make("proxy-pac-stats","0,10,20,30,40,50 * * * *","exec.proxy-pac.stats.php");
    $unix->Popuplate_cron_make("proxy-pac-reboot","20 * * * *","exec.proxy-pac.php --restart");
    shell_exec("/etc/init.d/cron restart");


	execute_autconfig(null,$hostname);
	build_progress("{installing_service}",80);
	build_monit();
	build_progress("{success}",100);
}

function build_monit(){
	
	$f[]="check process APP_PROXY_PAC with pidfile /var/run/proxy-pac/http-server.pid";
	$f[]="\tstart program = \"/etc/init.d/proxy-pac start\"";
	$f[]="\tstop program = \"/etc/init.d/proxy-pac stop\"";
	$f[]="\tif 5 restarts within 5 cycles then timeout";
	$f[]="\tif failed host 127.0.0.1 port 9505 protocol http then restart";
	$f[]="";
	@file_put_contents("/etc/monit/conf.d/APP_PROXY_PAC.monitrc", @implode("\n", $f));
	if(!is_file("/etc/monit/conf.d/APP_PROXY_PAC.monitrc")){
		echo "/etc/monit/conf.d/APP_PROXY_PAC.monitrc failed !!!\n";
	}
	echo "Proxy PAC: [INFO] Writing /etc/monit/conf.d/APP_PROXY_PAC.monitrc\n";
	system('/etc/init.d/monit restart');
}


function uninstall($not100=false) {
    $unix=new unix();
    $REBOOTCRON=false;
	build_progress("{removing_service}",50);
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableProxyPac", 0);
	remove_service("/etc/init.d/proxy-pac");
	build_progress("{removing_service}",60);
	if(is_file("/etc/monit/conf.d/APP_PROXY_PAC.monitrc")){
		@unlink("/etc/monit/conf.d/APP_PROXY_PAC.monitrc");
		system('/etc/init.d/monit restart');
	}

    if(is_file("/etc/cron.d/proxy-pac-reboot")){
        @unlink("/etc/cron.d/proxy-pac-reboot");
        $REBOOTCRON=true;
    }
    if(is_file("/etc/cron.d/proxy-pac-stats")){
        @unlink("/etc/cron.d/proxy-pac-stats");
        $REBOOTCRON=true;
    }
    if($REBOOTCRON){
        system("/etc/init.d/cron reload");
    }

    $rm=$unix->find_program("rm");
    shell_exec("$rm -rf /var/log/proxy-pac");
    shell_exec("$rm -rf /home/squid/proxy_pac_rules");

	if(!$not100){build_progress("{removing_service} {done}",100);}
	
}

function execute_autconfig($not100=false,$hostname=null){
	$sock=new sockets();
	$unix=new unix();
	build_progress("Execute....",5);
	
	build_progress("Loading settings....",5);
	
	
	$hostname=$unix->hostname_g();
	$dd=explode(".",$hostname);
	unset($dd[0]);
	$DOMAIN=@implode(".", $dd);
    $fnets[]="192.168.0.0/16";
    $fnets[]="10.0.0.0/8";
    $fnets[]="127.0.0.0/8";
    $fnets[]="172.16.0.0/12";


	$LOCALNET=@implode(",",$fnets);
	
	
	
	$port=0;
	$q=new lib_sqlite("/home/artica/SQLITE/proxy.db");
	$sql="SELECT nic,port  FROM `proxy_ports` WHERE enabled=1 AND transparent=0 AND TProxy=0 AND is_nat=0 AND WCCP=0";
	$results = $q->QUERY_SQL($sql);
	foreach ($results as $index=>$ligne){
		$nic=$ligne["nic"];
		$port=intval($ligne["port"]);
		if($nic<>null){$nics=new system_nic($nic);$NETS=$nics->IPADDR;}
		
		
	}
	
	if($port==0){$port=3128;}
	$PROXY=$NETS;
	$PORT=$port;
	$php=$unix->LOCATE_PHP5_BIN();
	if($PROXY==null){$PROXY=$unix->hostname_g();}
	if($hostname<>null){$PROXY=$hostname;}
	
	echo "DOMAIN.........: $DOMAIN\n";
	echo "LOCALNET.......: $LOCALNET\n";
	echo "PROXY..........: $PROXY:$PORT\n";
	
	if($DOMAIN==null){
		build_progress("Missing domain....",110);
		return;
	}
	if($LOCALNET==null){
		build_progress("Missing LOCALNET....",110);
		return;
	}	
	if($PROXY==null){
		build_progress("Missing PROXY....",110);
		return;
	}	
	if(!is_numeric($PORT)){build_progress("Missing PROXY PORT....",110);
		return;
	}

	build_progress("{removing_apache_service}",5);
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableProxyPac", 1);
	
	
	
	build_progress("{install_service}",10);	
	install_service();
	
	$webserver="wpad.$DOMAIN";
	

	$rulnename="Wizard - all to $PROXY:$PORT";
    $q=new lib_sqlite("/home/artica/SQLITE/acls.db");

    echo "Check if rule $rulnename Already exists...\n";
	$ligne=$q->mysqli_fetch_array("SELECT ID FROM wpad_rules WHERE rulename='$rulnename'");
    $MAIN_RULE_ID=intval($ligne["ID"]);

	if($MAIN_RULE_ID==0) {
        $sql = "INSERT INTO `wpad_rules` (`rulename`,`enabled`,`zorder`,`dntlhstname`) VALUES ('$rulnename',1,0,1)";
        $q->QUERY_SQL($sql);
        if (!$q->ok) {
            echo $q->mysql_error . "\n";
            build_progress("Building first rule...MySQL error", 110);
            return;
        }

        $MAIN_RULE_ID = intval($q->last_id);
    }
	    if($MAIN_RULE_ID==0){
		    build_progress("Building first rule...MAIN_RULE_ID = 0!",110);
		    return;
	    }
	
	$zmd5=md5("$MAIN_RULE_ID$PROXY$PORT");
	build_progress("Add destination $PROXY:$PORT",20);

    $ligne=$q->mysqli_fetch_array("SELECT zmd5 FROM wpad_destination WHERE proxyserver='$PROXY' AND proxyport='$PORT'");
    if(strlen(trim($ligne["zmd5"]))==0) {
        $q->QUERY_SQL("INSERT OR IGNORE INTO wpad_destination (zmd5,aclid,proxyserver,proxyport,zorder)
			VALUES ('$zmd5','$MAIN_RULE_ID','$PROXY','$PORT',0)");
        if (!$q->ok) {
            echo $q->mysql_error . "\n";
            build_progress("Add destination $PROXY:$PORT MySQL error", 110);
            return;
        }
    }
	
	build_progress("Creating Proxy object `Everyone`",25);
	
	
	$ligne=$q->mysqli_fetch_array("SELECT ID FROM webfilters_sqgroups WHERE `GroupType`='all'");
	$SourceGroupID=intval($ligne["ID"]);
	if($SourceGroupID==0){
		$sql="INSERT OR IGNORE INTO webfilters_sqgroups (GroupName,GroupType,enabled,`acltpl`,`params`,`tplreset`) VALUES ('Everyone','all','1','','',0);";
		$q->QUERY_SQL($sql);
		if(!$q->ok){
			echo $q->mysql_error."\n";
			build_progress("Creating Proxy object `Everyone` MySQL error",110);
			return;
		}
		$SourceGroupID=intval($q->last_id);
	}
	
	if($SourceGroupID==0){
		build_progress("Creating Proxy object `Everyone` SourceGroupID = 0!",110);
		return;
	}
	
	build_progress("Creating Proxy object `WPAD - Local networks`",25);
	$ligne=$q->mysqli_fetch_array("SELECT ID FROM webfilters_sqgroups WHERE `GroupName`='WPAD - Local networks'");
	$NetWorkGroupID=intval($ligne["ID"]);

    if($NetWorkGroupID==0){
        $ligne=$q->mysqli_fetch_array("SELECT ID FROM webfilters_sqgroups WHERE `params`='WizardWPADLocalNet'");
        $NetWorkGroupID=intval($ligne["ID"]);
    }
	
	if($NetWorkGroupID==0){
	    echo "Creating WPAD - Local networks\n";
        $q=new lib_sqlite("/home/artica/SQLITE/acls.db");
		$sql="INSERT OR IGNORE INTO webfilters_sqgroups (GroupName,GroupType,enabled,`acltpl`,`params`,`tplreset`) 
				VALUES ('WPAD - Local networks','dst','1','','WizardWPADLocalNet',0);";
		$q->QUERY_SQL($sql);
		if(!$q->ok){
			echo $q->mysql_error."\n";
			build_progress("Creating Proxy object `WPAD - Local networks` MySQL error",110);
			return;
		}
		$NetWorkGroupID=intval($q->last_id);
        echo "Creating WPAD - Local networks new ID is = $NetWorkGroupID\n";

		if( ($NetWorkGroupID==$SourceGroupID) OR ($NetWorkGroupID==0)){
            echo "Creating WPAD - Local networks wrong ID $NetWorkGroupID try to find it\n";
            $q=new lib_sqlite("/home/artica/SQLITE/acls.db");
            $ligne=$q->mysqli_fetch_array("SELECT ID FROM webfilters_sqgroups WHERE `params`='WizardWPADLocalNet'");
            $NetWorkGroupID=intval($ligne["ID"]);
            echo "Creating WPAD - Local networks WizardWPADLocalNet -> ID $NetWorkGroupID\n";

        }
		
		
	}
	
	if($NetWorkGroupID==0){
		build_progress("Creating Proxy object `WPAD - Local networks` NetWorkGroupID = 0!",110);
		return;
	}
	
	$IP=new IP();
	$LOCALNET_ARRAY=array();
	if(strpos($LOCALNET, ",")>0){
		$LOCALNET_ARRAY_TEMP=explode(",",$LOCALNET);
		foreach ($LOCALNET_ARRAY_TEMP as $line){
			$line=trim($line);
			if(!$IP->isIPAddressOrRange($line)){continue;}
			$LOCALNET_ARRAY[]="('$line','$NetWorkGroupID','1','')";
		}
	}else{
		if($IP->isIPAddressOrRange(trim($LOCALNET))){
			$LOCALNET_ARRAY[]="('$LOCALNET','$NetWorkGroupID','1','')";
		}
	}
	
	build_progress("Filling Proxy object `WPAD - Local networks`",30);
	echo "WPAD - Local networks: $NetWorkGroupID, removing items...\n";
	
	
	$q->QUERY_SQL("DELETE FROM webfilters_sqitems WHERE gpid=$NetWorkGroupID");
	if(!$q->ok){
	    echo "DELETE FROM webfilters_sqitems WHERE gpid=$NetWorkGroupID\n";
		echo $q->mysql_error."\n";
		build_progress("Filling Proxy object `WPAD - Local networks` MySQL error",110);
		return;
	}

	if(!$q->FIELD_EXISTS("webfilters_sqitems","other")){
        $q->QUERY_SQL("ALTER TABLE webfilters_sqitems ADD `other` TEXT");
    }


    echo "WPAD - Local networks: $NetWorkGroupID, insert items...\n";
	$sql="INSERT INTO webfilters_sqitems (pattern,gpid,enabled,other) VALUES ".@implode(",", $LOCALNET_ARRAY);
	if($GLOBALS["VERBOSE"]){echo $sql."\n";}
	$q->QUERY_SQL($sql);
	if(!$q->ok){
		echo $q->mysql_error."\n";
		build_progress("Filling Proxy object `WPAD - Local networks` MySQL error",110);
		return;
	}
	
	
	build_progress("Linking Everyone - $SourceGroupID - to rule $MAIN_RULE_ID",30);
	$zmd5=md5("$MAIN_RULE_ID$SourceGroupID");
	$q->QUERY_SQL("INSERT INTO wpad_sources_link (zmd5,aclid,negation,gpid,zorder) VALUES ('$zmd5','$MAIN_RULE_ID','0','$SourceGroupID',1)");
	if(!$q->ok){
		echo $q->mysql_error."\n";
		build_progress("MySQL error",110);
		return;
	}
	
	$zmd5=md5("$MAIN_RULE_ID$NetWorkGroupID");
	build_progress("Linking WPAD - Local networks - $NetWorkGroupID - to rule $MAIN_RULE_ID",50);
	$q->QUERY_SQL("INSERT INTO wpad_white_link (zmd5,aclid,negation,gpid,zorder) VALUES ('$zmd5','$MAIN_RULE_ID','0','$NetWorkGroupID',1)");
	if(!$q->ok){
		echo $q->mysql_error."\n";
		build_progress("MySQL error",110);
		return;
	}
	
	system("$php /usr/share/artica-postfix/exec.proxy.pac.builder.php");
	if(!$not100){
	build_progress("{success}",100);}
		
}
function remove_service($INITD_PATH){
	if(!is_file($INITD_PATH)){return;}
	system("$INITD_PATH stop");

	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");
	}

	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");

	}

	if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}
function install_service(){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	$INITD_PATH="/etc/init.d/proxy-pac";
	$php5script="exec.proxy-pac.php";
	$daemonbinLog="Proxy.pac Web engine";
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableProxyPac", 1);


	$f[]="#!/bin/sh";
	$f[]="### BEGIN INIT INFO";
	$f[]="# Provides:         proxy-pac";
	$f[]="# Required-Start:    \$local_fs \$syslog";
	$f[]="# Required-Stop:     \$local_fs \$syslog";
	$f[]="# Should-Start:";
	$f[]="# Should-Stop:";
	$f[]="# Default-Start:     3 4 5";
	$f[]="# Default-Stop:      0 1 6";
	$f[]="# Short-Description: $daemonbinLog";
	$f[]="# chkconfig: - 80 75";
	$f[]="# description: $daemonbinLog";
	$f[]="### END INIT INFO";

	$f[]="case \"\$1\" in";
	$f[]=" start)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  stop)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" restart)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" reconfigure)";
	$f[]="    $php /usr/share/artica-postfix/$php5script --build \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]="  *)";
	$f[]="    echo \"Usage: \$0 {start|stop|restart|reconfigure} (+ '--verbose' for more infos)\"";
	$f[]="    exit 1";
	$f[]="    ;;";
	$f[]="esac";
	$f[]="exit 0\n";


	echo "$daemonbinLog: [INFO] Writing $INITD_PATH with new config\n";
	@unlink($INITD_PATH);
	@file_put_contents($INITD_PATH, @implode("\n", $f));
	@chmod($INITD_PATH,0755);

	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
	}

	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
		shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
	}




}

?>