<?php
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.system.network.inc');
include_once(dirname(__FILE__).'/ressources/class.hosts.inc');
$GLOBALS["TITLENAME"]="Passive asset detection system";
	if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
	if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;$GLOBALS["OUTPUT"]=true;}
	if(preg_match("#--force#",implode(" ",$argv))){$GLOBALS["FORCE"]=true;}

if(isset($argv[1])) {
    $GLOBALS["ARGVS"] = implode(" ", $argv);
    if ($argv[1] == "--stop") {
        $GLOBALS["OUTPUT"] = true;
        stop();
        exit();
    }
    if ($argv[1] == "--start") {
        $GLOBALS["OUTPUT"] = true;
        start();
        die(1);
    }
    if ($argv[1] == "--restart") {
        $GLOBALS["OUTPUT"] = true;
        restart();
        exit();
    }
    if ($argv[1] == "--install") {
        $GLOBALS["OUTPUT"] = true;
        install();
        exit();
    }
    if ($argv[1] == "--install-redis") {
        $GLOBALS["OUTPUT"] = true;
        install_redis_service();
        build_monit();
        exit();
    }
    if ($argv[1] == "--uninstall") {
        $GLOBALS["OUTPUT"] = true;
        uninstall();
        exit();
    }
}


function restart() {
	$unix=new unix();
	$nohup=$unix->find_program("nohup");
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$pid=$unix->get_pid_from_file($pidfile);
	if($unix->process_exists($pid,basename(__FILE__))){
		$time=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Already Artica task running PID $pid since {$time}mn\n";}
		return;
	}

	@file_put_contents($pidfile, getmypid());
    build_progress_restart(50,"{stopping}");
    sleep(1);
	system("/etc/init.d/statscom stop");
    sleep(1);
    build_progress_restart(55,"{stopping}");
    system("/etc/init.d/statsredis stop");
	sleep(1);
    build_progress_restart(80,"{starting}");
    system("$nohup /etc/init.d/statscom start >>/usr/share/artica-postfix/ressources/logs/statscom.txt 2>&1 &");
    sleep(1);
    build_progress_restart(90,"{starting}");
    system("/etc/init.d/statsredis start");
    sleep(2);
    build_progress_restart(100,"{done}...");
    die();
}

function build_progress_restart($pourc,$text){
    $date=date("Y-m-d H:i:s");
    $GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/statscom.progress";
    echo "$date: [{$pourc}%] $text\n";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($GLOBALS["CACHEFILE"], serialize($array));
    @chmod($GLOBALS["CACHEFILE"],0755);
}
function build_progress($pourc,$text){
	$date=date("Y-m-d H:i:s");
	$GLOBALS["CACHEFILE"]="/usr/share/artica-postfix/ressources/logs/web/stats-com.progress";
	echo "$date: [{$pourc}%] $text\n";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($GLOBALS["CACHEFILE"], serialize($array));
	@chmod($GLOBALS["CACHEFILE"],0755);
}
function install(){
    $unix=new unix();
    $nohup=$unix->find_program("nohup");
    $SQUIDEnable = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SQUIDEnable"));
    $php=$unix->LOCATE_PHP5_BIN();
	build_progress(15,"{installing}");
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableStatsCommunicator", 1);
	install_service();
	install_redis_service();
	build_progress(20,"{installing}");
	shell_exec("/etc/init.d/statsredis start");
    build_progress(30,"{installing}");
    shell_exec("$nohup /etc/init.d/statscom start >/dev/null 2>&1");
    if($SQUIDEnable==1) {
        build_progress(50, "{installing}");
        shell_exec("$php /usr/share/artica-postfix/exec.squid.global.access.php --logs");
    }
    
	build_progress(90,"{installing}");
    build_monit();
    $unix->Popuplate_cron_make("statscom-statistics","*/12 * * * *","exec.statscom-stats.php");
    $unix->Popuplate_cron_make("statscom-days","30 1 * * *","exec.statscom-stats.php --days");
    $unix->Popuplate_cron_make("statscom-categorize","30 23 * * *","exec.statscom-stats.php --catz");
    shell_exec("/etc/init.d/cron reload");
	build_progress(100,"{done}");

}

function uninstall(){
    build_progress(15,"{uninstalling}");
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("EnableStatsCommunicator", 0);
	remove_service("/etc/init.d/statscom");
    remove_service("/etc/init.d/statsredis");
	build_progress(30,"{uninstalling}");
	@unlink("/etc/monit/conf.d/APP_STATS_COMMUNICATOR.monitrc");
	@unlink("/etc/monit/conf.d/APP_STATS_REDIS.monitrc");
    shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload >/dev/null 2>&1");

    build_progress(40,"{remove_database}");
    $q=new postgres_sql();
    $q->QUERY_SQL("DROP TABLE statscom");
    $q->QUERY_SQL("DROP TABLE statscom_months");
    $q->QUERY_SQL("DROP TABLE statscom_entity");
    $q->QUERY_SQL("DROP TABLE statscom_websites");

    $f[]="statscom-statistics";
    $f[]="statscom-days";
    $f[]="statscom-categorize";

    foreach ($f as $file){
        if(is_file("/etc/cron.d/$file")){@unlink("/etc/cron.d/$file");}
    }
    shell_exec("/etc/init.d/cron reload");

	build_progress(100,"{uninstalling} {done}");
	
}
function remove_service($INITD_PATH){
	if(!is_file($INITD_PATH)){return;}
	system("$INITD_PATH stop");
	if(is_file('/usr/sbin/update-rc.d')){shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");}
	if(is_file('/sbin/chkconfig')){shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");}
	if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}
function build_monit(){

	$f[]="check process APP_STATS_COMMUNICATOR with pidfile /var/run/artica-communicator.pid";
	$f[]="\tstart program = \"/etc/init.d/statscom start\"";
	$f[]="\tstop program = \"/etc/init.d/statscom stop\"";
	$f[]="\tif 5 restarts within 5 cycles then timeout";
	$f[]="";
	@file_put_contents("/etc/monit/conf.d/APP_STATS_COMMUNICATOR.monitrc", @implode("\n", $f));
	if(!is_file("/etc/monit/conf.d/APP_STATS_COMMUNICATOR.monitrc")){
		echo "/etc/monit/conf.d/APP_STATS_COMMUNICATOR.monitrc failed !!!\n";
	}

	$f=array();
    $f[]="check process APP_STATS_REDIS with pidfile \"/var/run/statsredis.pid\"";
    $f[]="\tstart program = \"/etc/init.d/statsredis start\"";
    $f[]="\tstop program = \"/etc/init.d/statsredis stop\"";
    $f[]="\tif failed host 127.0.0.1 port 4322 protocol redis then restart";
    $f[]="\tif 5 restarts within 5 cycles then timeout\n";

    @file_put_contents("/etc/monit/conf.d/APP_STATS_REDIS.monitrc", @implode("\n", $f));
    if(!is_file("/etc/monit/conf.d/APP_STATS_REDIS.monitrc")){
        echo "/etc/monit/conf.d/APP_STATS_REDIS.monitrc failed !!!\n";
    }

	shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload >/dev/null 2>&1");
	
}
function install_redis_service(){
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    $php5script="exec.statsredis.php";
    $f[]="#!/bin/sh";
    $f[]="";
    $f[]="### BEGIN INIT INFO";
    $f[]="# Provides:          statsredis";
    $f[]="# Required-Start:    \$network \$local_fs";
    $f[]="# Required-Stop:     \$network \$local_fs";
    $f[]="# Default-Start:     S 2 3 4 5";
    $f[]="# Default-Stop:      0 1 6";
    $f[]="# Short-Description: Artica Statistics Realtime database";
    $f[]="# Description:       Designed to store events from statscom";
    $f[]="#                    in order to save data in PostGreSQL database";
    $f[]="### END INIT INFO";
    $f[]="";
    $f[]="#";
    $f[]="# Author:       David Touzeau <david@articatech.com>";
    $f[]="case \"\$1\" in";
    $f[]=" start)";

    $f[]="    $php /usr/share/artica-postfix/$php5script --start \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]="  stop)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --stop \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" restart)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --restart \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" reconfigure)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --reload \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]=" reload)";
    $f[]="    $php /usr/share/artica-postfix/$php5script --reload \$2 \$3";
    $f[]="    ;;";
    $f[]="";
    $f[]="  *)";
    $f[]="    echo \"Usage: \$0 {start|stop|restart|reconfigure|reload} (+ '--verbose' for more infos)\"";
    $f[]="    exit 1";
    $f[]="    ;;";
    $f[]="esac";
    $f[]="exit 0\n";

    $INITD_PATH="/etc/init.d/statsredis";
    echo "statsredis: [INFO] Writing $INITD_PATH with new config\n";
    @unlink($INITD_PATH);
    @file_put_contents($INITD_PATH, @implode("\n", $f));
    @chmod($INITD_PATH,0755);

    if(is_file('/usr/sbin/update-rc.d')){
        shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
    }

    if(is_file('/sbin/chkconfig')){
        shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
        shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
    }

    $rm =$unix->find_program("rm");
    if(is_dir("/home/artica/statscom_blocked")){
        shell_exec("$rm -rf /home/artica/statscom_blocked");
    }
    if(is_dir("/home/artica/statscom")){
        shell_exec("$rm -rf /home/artica/statscom");
    }

}

function install_service(){
	    $unix=new unix();
	    $php=$unix->LOCATE_PHP5_BIN();
    $f[]="#!/bin/sh";
    $f[]="";
    $f[]="### BEGIN INIT INFO";
    $f[]="# Provides:          statscom";
    $f[]="# Required-Start:    \$network \$local_fs \$remote_fs";
    $f[]="# Required-Stop:     \$network \$local_fs \$remote_fs";
    $f[]="# Default-Start:     S 2 3 4 5";
    $f[]="# Default-Stop:      0 1 6";
    $f[]="# Short-Description: Artica Statistics Realtime Communicator";
    $f[]="# Description:       Designed to receive events from syslog";
    $f[]="#                    in order to save data in PostGreSQL database";
    $f[]="### END INIT INFO";
    $f[]="";
    $f[]="#";
    $f[]="# Author:       David Touzeau <david@articatech.com>";
    $f[]="#";
    $f[]="";
    $f[]="DESC=\"Artica Statistics Realtime Communicator\"";
    $f[]="NAME=\"statscom\"";
    $f[]="DAEMON=\"/usr/share/artica-postfix/exec.StatsCommunicator.php\"";
    $f[]="";
    $f[]="test -f \$DAEMON || exit 0";
    $f[]="";
    $f[]="# Read LSB init functions";
    $f[]=". /lib/lsb/init-functions";
    $f[]="";
    $f[]="";
    $f[]="PIDFILE=\"/var/run/artica-communicator.pid\"";
    $f[]="DAEMON_OPTS=\"\"";
    $f[]="";
    $f[]="start_service() {";
    $f[]="    log_begin_msg \"Starting \$DESC...\"";
    $f[]="    [ ! -d \$CHROOT ] && create_chroot";
    $f[]="    chmod 0755 \$DAEMON";
    $f[]="    start-stop-daemon --start --quiet --pidfile \$PIDFILE --umask \"007\" --exec \$DAEMON --  \$DAEMON_OPTS";
    $f[]="    log_end_msg \$?";
    $f[]="}";
    $f[]="";
    $f[]="stop_service() {";
    $f[]="    log_begin_msg \"Stopping \$DESC...\"";
    $f[]="    start-stop-daemon --stop --quiet --oknodo --retry 60 --pidfile \$PIDFILE";
    $f[]="    log_end_msg \$?";
    $f[]="}";
    $f[]="";
    $f[]="status_service() {";
    $f[]="    status_of_proc \$DAEMON \$NAME";
    $f[]="}";
    $f[]="";
    $f[]="restart_service() {";
    $f[]="    stop_service";
    $f[]="    start_service";
    $f[]="}";
    $f[]="";
    $f[]="fail() {";
    $f[]="    echo \"usage: \$0 <start|stop|restart|status>\"";
    $f[]="    exit 1";
    $f[]="}";
    $f[]="";
    $f[]="case \"\$1\" in";
    $f[]="    start)   start_service;;";
    $f[]="    stop)    stop_service;;";
    $f[]="    status)  status_service;;";
    $f[]="    restart) restart_service;;";
    $f[]="    force-reload) restart_service;;";
    $f[]="    *) fail;;";
    $f[]="esac";
    $f[]="";

	$INITD_PATH="/etc/init.d/statscom";
	echo "PADS: [INFO] Writing $INITD_PATH with new config\n";
	@unlink($INITD_PATH);
	@file_put_contents($INITD_PATH, @implode("\n", $f));
	@chmod($INITD_PATH,0755);

	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
	}

	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
		shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
	}



}


function start($aspid=false){
	$unix=new unix();
	$sock=new sockets();
	$Masterbin=$unix->find_program("vnstatd");

	if(!is_file($Masterbin)){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]}, vnstatd not installed\n";}
		return;
	}

	if(!$aspid){
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=$unix->get_pid_from_file($pidfile);
		if($unix->process_exists($pid,basename(__FILE__))){
			$time=$unix->PROCCESS_TIME_MIN($pid);
			if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Already Artica task running PID $pid since {$time}mn\n";}
			
			return;
		}
		@file_put_contents($pidfile, getmypid());
	}

	$pid=PID_NUM();

	if($unix->process_exists($pid)){
		$timepid=$unix->PROCCESS_TIME_MIN($pid);
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Service already started $pid since {$timepid}Mn...\n";}
		@file_put_contents("/var/run/vnstat.pid", $pid);
		return;
	}
	$EnableVnStat=$sock->GET_INFO("EnableVnStat");
	if(!is_numeric($EnableVnStat)){$EnableVnStat=0;}

	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Enabled: $EnableVnStat\n";}
	if($EnableVnStat==0){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service disabled (see EnableVnStat)\n";}
		stop(true);
		return;
	}

	$php5=$unix->LOCATE_PHP5_BIN();
	$echo=$unix->find_program("echo");
	$nohup=$unix->find_program("nohup");

	$CMDS[]="--daemon";
	$CMDS[]="--pidfile /var/run/vnstat.pid";
	
	$cmd="$Masterbin ".@implode(" ", $CMDS)." >/dev/null 2>&1 &";
	if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service\n";}

	shell_exec($cmd);




	for($i=1;$i<5;$i++){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} waiting $i/5\n";}
		sleep(1);
		$pid=PID_NUM();
		if($unix->process_exists($pid)){break;}
	}

	$pid=PID_NUM();
	if($unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Success PID $pid\n";}

	}else{
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Failed\n";}
		if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} $cmd\n";}
	}


}

function stop($aspid=false){
	$unix=new unix();
	if(!$aspid){
		$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
		$pid=$unix->get_pid_from_file($pidfile);
		if($unix->process_exists($pid,basename(__FILE__))){
			$time=$unix->PROCCESS_TIME_MIN($pid);
			if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service Already Artica task running PID $pid since {$time}mn\n";}
			return;
		}
		@file_put_contents($pidfile, getmypid());
	}

	$pid=PID_NUM();


	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service already stopped...\n";}
		return;
	}
	$pid=PID_NUM();
	$nohup=$unix->find_program("nohup");
	$php5=$unix->LOCATE_PHP5_BIN();
	$kill=$unix->find_program("kill");




	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service Shutdown pid $pid...\n";}
	unix_system_kill($pid);
	for($i=0;$i<5;$i++){
		$pid=PID_NUM();
		if(!$unix->process_exists($pid)){break;}
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service waiting pid:$pid $i/5...\n";}
		sleep(1);
	}

	$pid=PID_NUM();
	if(!$unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service success...\n";}
		return;
	}

	if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service shutdown - force - pid $pid...\n";}
	unix_system_kill_force($pid);
	for($i=0;$i<5;$i++){
		$pid=PID_NUM();
		if(!$unix->process_exists($pid)){break;}
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service waiting pid:$pid $i/5...\n";}
		sleep(1);
	}

	if($unix->process_exists($pid)){
		if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service failed...\n";}
		return;
	}

}

function PID_NUM(){
	$unix=new unix();
	$pid=$unix->get_pid_from_file("/var/run/vnstat.pid");
	if($unix->process_exists($pid)){return $pid;}
	$Masterbin=$unix->find_program("vnstatd");
	return $unix->PIDOF($Masterbin);
}

function build_stats(){
    $unix = new unix();
    $preports = $unix->find_program("prads-asset-report");
    $targetfile =$unix->FILE_TEMP();
    $echo=$unix->find_program("echo");
    $cmd="$preports -n -r /var/log/prads-asset.log -w $targetfile";
    echo "$cmd\n";
    shell_exec($cmd);
    shell_exec("$echo \"\"> /var/log/prads-asset.log");


    $f = explode("\n", @file_get_contents($targetfile));
    @unlink($targetfile);

    foreach ($f as $line) {
        $line = trim($line);
        if ($line == null) {continue;}

        if (preg_match("#^IP:\s+([0-9\.]+)#", $line, $re)) {
            $ipaddr=$re[1];
            $MAIN[$re[1]]["hostname"] = gethostbyaddr($re[1]);
            continue;
        }
        if (preg_match("#^MAC.*?:\s+([0-9A-Z:]+)#i", $line, $re)) {
            $MAIN[$ipaddr]["mac"] = $re[1];
            if (preg_match("#,\((.+?)\)#", $line, $re)) {
                $MAIN[$ipaddr]["type"] = $re[1];
            }
            continue;
        }

        if (preg_match("#^OS:\s+(.+?)\s+(.+)\s+#", $line, $re)) {
            if ($re[1] == "unknown") {
                continue;
            }
            $MAIN[$ipaddr]["os"] = "{$re[1]} {$re[2]}";
            continue;
        }

        if (preg_match("#^([0-9]+)\s+(CLIENT|SERVER)\s+(.+)#", $line, $re)) {
            $MAIN[$ipaddr]["ports"][] = $re[1] . " {$re[2]} {$re[3]}";
            continue;
        }
     }



    foreach ($MAIN as $ipaddr=>$array){

        if(!isset($array["mac"])){
           continue;
        }

        $cp = new hosts($array["mac"]);

        if($cp->fullhostname==null){
            $cp->fullhostname=$array["hostname"];
        }

        $cp->ipaddr=$ipaddr;
        $cp->mac=strtolower($array["mac"]);
        if(!isset($array["type"])) {
            $cp->vendor= $array["type"];
        }
        if(!isset($array["os"])){
            $cp->ComputerOS=$array["os"];
        }

        $cp->scanreport=@implode("\n",$array["ports"]);

        $cp->Save();

    }


    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("PradsReport",serialize($MAIN));


}
?>