#!/usr/bin/php -q
<?php
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
$GLOBALS["FORCE"]=false;
$GLOBALS["RECONFIGURE"]=false;
$GLOBALS["SWAPSTATE"]=false;
$GLOBALS["NOSQUIDOUTPUT"]=true;
$GLOBALS["TITLENAME"]="StatsCom Database Daemon";
$GLOBALS["PROGRESS"]=false;
$GLOBALS["MIGRATION"]=false;
$GLOBALS["OUTPUT"]=true;
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;
$GLOBALS["debug"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
if(preg_match("#--output#",implode(" ",$argv))){$GLOBALS["OUTPUT"]=true;}
if(preg_match("#schedule-id=([0-9]+)#",implode(" ",$argv),$re)){$GLOBALS["SCHEDULE_ID"]=$re[1];}
if(preg_match("#--force#",implode(" ",$argv),$re)){$GLOBALS["FORCE"]=true;}
if(preg_match("#--reconfigure#",implode(" ",$argv),$re)){$GLOBALS["RECONFIGURE"]=true;}
if(preg_match("#--migration#",implode(" ",$argv),$re)){$GLOBALS["MIGRATION"]=true;}

$GLOBALS["AS_ROOT"]=true;
include_once(dirname(__FILE__).'/ressources/class.ldap.inc');
include_once(dirname(__FILE__).'/ressources/class.squid.inc');
include_once(dirname(__FILE__).'/ressources/class.mysql.inc');

include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__).'/framework/frame.class.inc');
include_once(dirname(__FILE__).'/framework/class.settings.inc');
include_once(dirname(__FILE__).'/ressources/class.os.system.inc');
include_once(dirname(__FILE__).'/ressources/class.system.nics.inc');


$GLOBALS["ARGVS"]=implode(" ",$argv);
if($argv[1]=="--build"){build_rules();exit;}
if($argv[1]=="--start"){start();exit;}
if($argv[1]=="--stop"){stop();exit;}
if($argv[1]=="--restart"){restart();exit;}


function build_syslog(){
    $RELOAD=false;
    if(!is_file("/etc/rsyslog.d/ITCharter.conf")){$RELOAD=true;}

    $f[]="if  (\$programname =='ItCharter') then {";
    $f[]="\t-/var/log/ITCharter.log";
    $f[]="\t& stop";
    $f[]="}\n";

    @file_put_contents("/etc/rsyslog.d/ITCharter.conf",@implode("\n",$f));
    if($RELOAD){
        shell_exec("/etc/init.d/rsyslog restart");
    }

}



function build_config(){
    if(!is_dir("/home/artica/statscom_db")){@mkdir("/home/artica/statscom_db",0755,true);}
    $f[]="# it in the usual form of 1k 5GB 4M and so forth:";
    $f[]="#";
    $f[]="# 1k => 1000 bytes";
    $f[]="# 1kb => 1024 bytes";
    $f[]="# 1m => 1000000 bytes";
    $f[]="# 1mb => 1024*1024 bytes";
    $f[]="# 1g => 1000000000 bytes";
    $f[]="# 1gb => 1024*1024*1024 bytes";
    $f[]="#";
    $f[]="# units are case insensitive so 1GB 1Gb 1gB are all the same.";
    $f[]="";
    $f[] = "bind 127.0.0.1";

    $f[]="protected-mode yes";
    $f[]="port 4322";
    $f[]="tcp-backlog 511";
    $f[]="unixsocket /var/run/statsredis.sock";
    $f[]="unixsocketperm 777";
    $f[]="timeout 5";
    $f[]="tcp-keepalive 300";
    $f[]="daemonize yes";
    $f[]="supervised no";
    $f[]="pidfile /var/run/statsredis.pid";
    $f[]="loglevel notice";
    $f[]="logfile '/var/log/statsredis.log'";
    $f[]="syslog-enabled no";
    $f[]="# Specify the syslog identity.";
    $f[]="syslog-ident statscom";
    $f[]="syslog-facility local0";
    $f[]="databases 16";
    $f[]="save 900 1";
    $f[]="save 300 10";
    $f[]="save 60 10000";
    $f[]="stop-writes-on-bgsave-error yes";
    $f[]="rdbcompression yes";
    $f[]="rdbchecksum yes";
    $f[]="dbfilename dump.statscom";


    $f[]="dir /home/artica/statscom_db";
    $f[]="# masterauth <master-password>";
    $f[]="# replica-serve-stale-data yes";
    $f[]="repl-diskless-sync no";
    $f[]="repl-diskless-sync-delay 5";
    $f[]="# repl-ping-replica-period 10";
    $f[]="repl-disable-tcp-nodelay no";
    $f[]="# repl-backlog-size 1mb";
    $f[]="# repl-backlog-ttl 3600";
    $f[]="#replica-priority 100";
    $f[]="# min-replicas-to-write 3";
    $f[]="# min-replicas-max-lag 10";
    $f[]="# min-replicas-max-lag is set to 10.";
    $f[]="# replica-announce-ip 5.5.5.5";
    $f[]="# replica-announce-port 1234";
    $f[]="# requirepass foobared";
    $f[]="maxclients 500";
    $f[]="maxmemory 512mb";
    $f[]="maxmemory-policy allkeys-lru";
    $f[]="maxmemory-samples 5";
    $f[]="# replica-ignore-maxmemory yes";
    $f[]="# lazyfree-lazy-eviction no";
    $f[]="# lazyfree-lazy-expire no";
    $f[]="# lazyfree-lazy-server-del no";
    $f[]="# replica-lazy-flush no";
    $f[]="appendonly no";
    $f[]="appendfilename \"appendonly.aof\"";
    $f[]="appendfsync everysec";
    $f[]="# appendfsync no";
    $f[]="no-appendfsync-on-rewrite no";
    $f[]="auto-aof-rewrite-percentage 100";
    $f[]="auto-aof-rewrite-min-size 64mb";
    $f[]="aof-load-truncated yes";
    $f[]="# aof-use-rdb-preamble yes";
    $f[]="lua-time-limit 5000";
    $f[]="";
    $f[]="# cluster-enabled yes";
    $f[]="# cluster-config-file nodes-6379.conf";
    $f[]="# cluster-node-timeout 15000";
    $f[]="# cluster-replica-validity-factor 10";
    $f[]="# cluster-migration-barrier 1";
    $f[]="# cluster-require-full-coverage yes";
    $f[]="# cluster-replica-no-failover no";
    $f[]="";
    $f[]="# In order to setup your cluster make sure to read the documentation";
    $f[]="# available at http://redis.io web site.";
    $f[]="# * cluster-announce-ip";
    $f[]="# * cluster-announce-port";
    $f[]="# * cluster-announce-bus-port";
    $f[]="# cluster-announce-ip 10.1.1.5";
    $f[]="# cluster-announce-port 6379";
    $f[]="# cluster-announce-bus-port 6380";
    $f[]="slowlog-log-slower-than 10000";
    $f[]="slowlog-max-len 128";
    $f[]="latency-monitor-threshold 0";
    $f[]="notify-keyspace-events \"\"";
    $f[]="list-max-ziplist-size -2";
    $f[]="list-compress-depth 0";
    $f[]="set-max-intset-entries 512";
    $f[]="zset-max-ziplist-entries 128";
    $f[]="zset-max-ziplist-value 64";
    $f[]="hll-sparse-max-bytes 3000";
    $f[]="# stream-node-max-bytes 4096";
    $f[]="# stream-node-max-entries 100";
    $f[]="activerehashing yes";
    $f[]="client-output-buffer-limit normal 0 0 0";
    $f[]="# client-output-buffer-limit replica 256mb 64mb 60";
    $f[]="client-output-buffer-limit pubsub 32mb 8mb 60";
    $f[]="# client-query-buffer-limit 1gb";
    $f[]="# proto-max-bulk-len 512mb";
    $f[]="hz 10";
    $f[]="# dynamic-hz yes";
    $f[]="aof-rewrite-incremental-fsync yes";
    $f[]="# rdb-save-incremental-fsync yes";
    $f[]="#   redis-benchmark -n 1000000 incr foo";
    $f[]="#   redis-cli object freq foo";
    $f[]="# lfu-log-factor 10";
    $f[]="# lfu-decay-time 1";
    $f[]="# activedefrag yes";
    $f[]="# active-defrag-ignore-bytes 100mb";
    $f[]="# active-defrag-threshold-lower 10";
    $f[]="# active-defrag-threshold-upper 100";
    $f[]="# active-defrag-cycle-min 5";
    $f[]="# active-defrag-cycle-max 75";
    $f[]="# active-defrag-max-scan-fields 1000";
    $f[]="";
    $f[]="";

    @file_put_contents("/etc/statsredis.conf",@implode("\n",$f));

}

function restart(){

    build_progress_restart("{stopping}",10);
    if(!stop(true)){
        build_progress_restart("{stopping} {failed}",110);
        return;
    }
    build_progress_restart("{starting}",50);
    sleep(1);
    if(!start(true)){
        build_progress_restart("{starting} {failed}",110);
        return;
    }

    build_progress_restart("{starting} {success}",100);



}

function start($aspid=false){
    if(!is_dir("/home/artica/statscom_db")){@mkdir("/home/artica/statscom_db",0755,true);}
    $unix=new unix();
    $Masterbin=$unix->find_program("redis-server");

    if(!is_file($Masterbin)) {
        if (is_file("/usr/sbin/statsredis")) {
            @copy("/usr/sbin/statsredis", "/usr/sbin/redis-server");
            $Masterbin = "/usr/sbin/redis-server";
        }
    }

    if(!is_file($Masterbin)){
        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]}, redis-server not installed\n";}
        return false;
    }

    if(!$aspid){
       $pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
        $pid=$unix->get_pid_from_file($pidfile);
        if($unix->process_exists($pid,basename(__FILE__))){
            $time=$unix->PROCCESS_TIME_MIN($pid);
            if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Already Artica task running PID $pid since {$time}mn\n";}
            return false;
        }
        @file_put_contents($pidfile, getmypid());
    }

    $pid=PID_NUM();

    if($unix->process_exists($pid)){
        $timepid=$unix->PROCCESS_TIME_MIN($pid);
        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Service already started $pid since {$timepid}Mn...\n";}
        return true;
    }

    if(is_file("/usr/sbin/statsredis")){
        $md51=md5_file("/usr/sbin/statsredis");
        $md52=md5_file($Masterbin);
        if($md51<>$md52){@unlink("/usr/sbin/statsredis");}
    }
    if(!is_file("/usr/sbin/statsredis")){@copy($Masterbin,"/usr/sbin/statsredis");}
    @chmod("/usr/sbin/statsredis",0755);
    build_config();


    $echo=$unix->find_program("echo");
    $sysctl=$unix->find_program("sysctl");
    shell_exec("$echo never > /sys/kernel/mm/transparent_hugepage/enabled >/dev/null 2>&1");
    shell_exec("$sysctl vm.overcommit_memory=1 >/dev/null 2>&1");

    if(is_file("/var/log/statsredis.log")){@unlink("/var/log/statsredis.log");}
    $cmdline="/usr/sbin/statsredis /etc/statsredis.conf";
    if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service\n";}
    shell_exec($cmdline);

    for($i=1;$i<5;$i++){
        if($GLOBALS["OUTPUT"]){echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} waiting $i/5\n";}
        sleep(1);
        $pid=PID_NUM();
        if($unix->process_exists($pid)){break;}
    }

    $pid=PID_NUM();
    if($unix->process_exists($pid)) {
        if ($GLOBALS["OUTPUT"]) {
            echo "Starting......: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} Success PID $pid\n";
        }
        return true;
    }

    echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} Failed\n";
    echo "Starting......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} $cmdline\n";


    $f=explode("\n",@file_get_contents("/var/log/statsredis.log"));
    foreach ($f as $line){
        $line=trim($line);
        if($line==null){continue;}
        echo "Starting......: $line\n";
        if(preg_match("#Fatal error loading the DB: Invalid argument\. Exiting#",$line)){
            if(is_file("/home/artica/statscom_db/dump.statscom")) {
                echo "Starting......: " . date("H:i:s") . " [INIT]: {$GLOBALS["TITLENAME"]} remove database\n";
                @unlink("/home/artica/statscom_db/dump.statscom");
                return start();
            }
        }

    }

    //


    return false;

}





function PID_NUM(){

    $unix=new unix();
    $pid=$unix->get_pid_from_file("/var/run/statsredis.pid");
    if($unix->process_exists($pid)){return $pid;}
    return $unix->PIDOF("/usr/sbin/statsredis");

}

function build_progress_restart($text,$pourc){
    if(is_numeric($text)){$int=$text;$text=$pourc;$pourc=$int;}
    $cachefile="/usr/share/artica-postfix/ressources/logs/web/statsredis.restart.progress";
    echo "{$pourc}% $text\n";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($cachefile, serialize($array));
    @chmod($cachefile,0755);
}
function build_progress($text,$pourc){
	if(is_numeric($text)){$int=$text;$text=$pourc;$pourc=$int;}
	$cachefile="/usr/share/artica-postfix/ressources/logs/statsredis.progress";
	echo "{$pourc}% $text\n";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($cachefile, serialize($array));
	@chmod($cachefile,0755);
}
function stop($aspid=false){
    $unix=new unix();
    if(!$aspid){
        $pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
        $pid=$unix->get_pid_from_file($pidfile);
        if($unix->process_exists($pid,basename(__FILE__))){
            $time=$unix->PROCCESS_TIME_MIN($pid);
            echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service Already Artica task running PID $pid since {$time}mn\n";
            return false;
        }
        @file_put_contents($pidfile, getmypid());
    }

    $pid=PID_NUM();


    if(!$unix->process_exists($pid)){
        if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service already stopped...\n";}
        return true;
    }
    $pid=PID_NUM();

    if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service Shutdown pid $pid...\n";}
    unix_system_kill($pid);
    for($i=0;$i<5;$i++){
        $pid=PID_NUM();
        if(!$unix->process_exists($pid)){break;}
        if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service waiting pid:$pid $i/5...\n";}
        sleep(1);
    }

    $pid=PID_NUM();
    if(!$unix->process_exists($pid)){
        if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service success...\n";}
        return true;
    }

    if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service shutdown - force - pid $pid...\n";}
    unix_system_kill_force($pid);
    for($i=0;$i<5;$i++){
        $pid=PID_NUM();
        if(!$unix->process_exists($pid)){break;}
        if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service waiting pid:$pid $i/5...\n";}
        sleep(1);
    }

    if($unix->process_exists($pid)){
        if($GLOBALS["OUTPUT"]){echo "Stopping......: ".date("H:i:s")." [INIT]: {$GLOBALS["TITLENAME"]} service failed...\n";}
        return false;
    }

    return true;

}
?>