<?php
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
include_once(dirname(__FILE__).'/ressources/class.templates.inc'); 
include_once(dirname(__FILE__).'/ressources/class.ldap.inc');
include_once(dirname(__FILE__).'/ressources/class.computers.inc');
include_once(dirname(__FILE__).'/ressources/class.system.network.inc');
include_once(dirname(__FILE__).'/framework/class.unix.inc');if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__)."/framework/frame.class.inc");


ExecuteVerification();

function ExecuteVerification(){
    $unix=new unix();

    $apttime="/etc/artica-postfix/VERIF_PKG_TIME";
    $time=$unix->file_time_min($apttime);

    if($time<600){die();}
    @unlink("/etc/artica-postfix/VERIF_PKG_TIME");
    @file_put_contents("/etc/artica-postfix/VERIF_PKG_TIME", time());
    $PKG=CheckPackages();

    $Count_source=count($PKG);
    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("VerifPackages",base64_decode(serialize($PKG)));

    $apttime="/etc/artica-postfix/VERIF_PKG_TIME";
    $time=$unix->file_time_min($apttime);

    if($time<600){die();}
    @unlink("/etc/artica-postfix/VERIF_PKG_TIME");
    @file_put_contents("/etc/artica-postfix/VERIF_PKG_TIME", time());


    if($Count_source>0) {
        foreach ($PKG as $package) {
            echo "Installing $package...\n";
            squid_admin_mysql(1, "[SYSTEM]: Missing package $package [action=install]", null, __FILE__, __LINE__);
            $unix->DEBIAN_INSTALL_PACKAGE($package);
        }

    }

    $PKG=CheckPackages();
    $Count_final=count($PKG);

    $reste=$Count_source-$Count_final;

    $GLOBALS["CLASS_SOCKETS"]->SET_INFO("VerifPackages",base64_decode(serialize($PKG)));

    if($reste<$Count_source) {
        $php = $unix->LOCATE_PHP5_BIN();
        shell_exec("$php /usr/share/artica-postfix/exec.apt-get.php --deb-collection");
        system("$php /usr/share/artica-postfix/exec.pip.php --collection");
        shell_exec("$php /usr/share/artica-postfix/exec.php.ini.php");
        shell_exec("/etc/init.d/artica-phpfpm restart");
        shell_exec("/etc/init.d/artica-status restart");
    }

}




function CheckPackages()
{

    $unix = new unix();
    $PKG = array();


    $DEBIAN_VERSION = $unix->DEBIAN_VERSION();

    if(is_dir("/usr/lib/x86_64-linux-gnu/perl5/5.28")){
        if(!is_file("/usr/lib/x86_64-linux-gnu/perl5/5.28/Text/CSV_XS.pm")) {
            $PKG[] = "libtext-csv-xs-perl";
        }
    }

    if (!extension_loaded("pdo_sqlite")) {
        $PKG[] = "php7.0-sqlite3";
    }
    if (!class_exists('Memcached')) {
        $PKG[] = "php-memcached";
    }
    if (!is_file("/usr/bin/memcached")) {
        $PKG[] = "memcached";
    }
    if (!is_file("/usr/bin/pip")) {
        $PKG[] = "python-pip";
    }
    if (!is_file("/usr/lib/python3/dist-packages/bottle.py")) {
        $PKG[] = "python3-bottle";
    }
    if (!is_file("/usr/lib/python2.7/dist-packages/memcache.py")) {
        $PKG[] = "python-memcache";
    }
    if (!is_file("/usr/share/perl5/Cache/Cache.pm")) {
        $PKG[] = "libcache-cache-perl";
    }
    if (!is_file("/usr/lib/x86_64-linux-gnu/libprotobuf-c.so.1.0.0")) {
        $PKG[] = "libprotobuf-c1";
    }
    if (!is_file("/usr/lib/x86_64-linux-gnu/libfstrm.so.0")) {
        $PKG[] = "libfstrm0";
    }
    if (!is_file("/usr/share/perl5/Cache/Memcached.pm")) {
        $PKG[] = "libcache-memcached-perl";
    }

    if(!is_file("/usr/bin/dhcpd-pools")){
        $PKG[] = "dhcpd-pools";
    }

    if(!is_file("/usr/bin/zip")){
        $PKG[] = "zip";
    }



    if ($DEBIAN_VERSION < 10) {
        if (!is_file("/usr/lib/x86_64-linux-gnu/perl5/5.24/DBD/SQLite.pm")) {
            $PKG[] = "libdbd-sqlite3-perl";
        }
        if (!is_file("/usr/lib/x86_64-linux-gnu/libavcodec.so.57")) {
            $PKG[] = "libavcodec57";
        }
        if (!is_file("/usr/lib/x86_64-linux-gnu/libavformat.so.57")) {
            $PKG[] = "libavformat57";
        }
        if (!is_file("/usr/lib/x86_64-linux-gnu/libswscale.so.4")) {
            $PKG[] = "libswscale4";
        }
        if (!is_file("/usr/lib/libhs.so.4")) {
            $PKG[] = "libhyperscan4";
        }
        if (!is_file("/usr/lib/x86_64-linux-gnu/perl5/5.24/Encode/Detect.pm")) {
            $PKG[] = "libencode-detect-perl";
        }
        if (!is_file("/usr/lib/x86_64-linux-gnu/perl5/5.24/Net/Patricia.pm")) {
            $PKG[] = "libnet-patricia-perl";
        }
        if (!is_file("/usr/lib/x86_64-linux-gnu/liblua5.3.so.0")) {
            $PKG[] = "liblua5.3-0";
        }

        if (!is_file("/usr/lib/x86_64-linux-gnu/libmaxminddb.so.0")) {
            $PKG[] = "libmaxminddb0";
        }
        if (!is_file("/usr/bin/certbot")) {
            echo "Adding letsencrypt\n";
            $PKG[] = "letsencrypt";
        }
        if (!is_file("/usr/lib/x86_64-linux-gnu/libmaxminddb.so.0")) {
            echo "Adding libmaxminddb0\n";
            $PKG[] = "libmaxminddb0";
        }
        if (!is_file("/usr/bin/mmdblookup")) {
            $PKG[] = "mmdb-bin";
        }
        if (!is_file("/usr/lib/php/20151012/mcrypt.so")) {
            $PKG[] = "php7.0-mcrypt";
        }


    }

    $QEMU_HOST = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("QEMU_HOST"));
    $VMWARE_HOST = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("VMWARE_HOST"));
    $VMWARE_TOOLS_INSTALLED = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("VMWARE_TOOLS_INSTALLED"));

    if ($QEMU_HOST == 1) {
        $qemu_ga = $unix->find_program("qemu-ga");
        if (!is_file($qemu_ga)) {
            $PKG[] = "qemu-guest-agent";
        }
    }

    if ($VMWARE_HOST == 1) {
        if ($VMWARE_TOOLS_INSTALLED == 0) {
            $PKG[] = "open-vm-tools";
        }
    }

    echo "DEBIAN_VERSION=$DEBIAN_VERSION\n";

    if ($DEBIAN_VERSION == 10) {

        if (!is_file("/usr/lib/x86_64-linux-gnu/libluajit-5.1.so.2")) {
            $PKG[] = "libluajit-5.1-2";
        }

        if (!is_file("/usr/lib/locale/fr_FR.utf8/LC_ADDRESS")) {
            $PKG[] = "locales-all";
        }

        if (!is_file("/usr/bin/certbot")) {
            $PKG[] = "letsencrypt";
        }
        if (!is_file("/usr/lib/php/20151012/mcrypt.so")) {
            $PKG[] = "php7-mcrypt";
        }
        if (!is_file("/usr/bin/mmdblookup")) {
            $PKG[] = "mmdb-bin";
        }

        if (!is_file("/usr/lib/x86_64-linux-gnu/libmaxminddb.so.0")) {
            $PKG[] = "libmaxminddb0";
        }
        if (!is_file("/usr/lib/python2.7/dist-packages/cherrypy/__init__.py")) {
            $PKG[] = "python-cherrypy3";
        }
        if (!is_file("/usr/lib/x86_64-linux-gnu/libh2o-evloop.so")) {
            $PKG[] = "libh2o-evloop-dev";
        }
        if (!is_file("/usr/lib/x86_64-linux-gnu/libhs.so.5")) {
            $PKG[] = "libhyperscan5";
        }

        if(!is_file("/usr/bin/pactester")){
            $PKG[] = "libpacparser1";
        }



    }

    if (!is_file("/usr/lib/x86_64-linux-gnu/samba/ldb/acl.so")) {
        $PKG[] = "samba-dsdb-modules";
    }
    if (!is_file("/usr/share/doc/intel-microcode/license")) {
        $PKG[] = "firmware-realtek";
    }
    if (!is_file("/usr/sbin/iucode-tool")) {
        $PKG[] = "intel-microcode";
    }
    if (!is_file("/lib/firmware/e100/d101m_ucode.bin")) {
        $PKG[] = "firmware-misc-nonfree";
    };
    if (!is_file("/lib/firmware/iwlwifi-100-5.ucode")) {
        $PKG[] = "firmware-iwlwifi";
    };
    if (!is_file("/usr/lib/x86_64-linux-gnu/libmilter.so.1.0.1")) {
        $PKG[] = "libmilter1.0.1";
    }
    if (!is_file("/usr/lib/x86_64-linux-gnu/libuuid.so")) {
        $PKG[] = "uuid-dev";
    }
    if (!is_file("/usr/lib/x86_64-linux-gnu/libmnl.so")) {
        $PKG[] = "libmnl-dev";
    }
    if (!is_file("/usr/lib/python2.7/dist-packages/pymongo/__init__.py")) {
        $PKG[] = "python-pymongo";
    }
    if (!is_file("/usr/lib/x86_64-linux-gnu/libz.so")) {
        $PKG[] = "zlib1g-dev";
    }
    if (!is_file("/usr/bin/nodejs")) {
        $PKG[] = "nodejs";
    }
    if (!is_file("/usr/sbin/dnscrypt-proxy")) {
        $PKG[] = "dnscrypt-proxy";
    }

    if (!is_file("/usr/share/perl5/Net/CIDR/Lite.pm")) {
        $PKG[] = "libnet-cidr-lite-perl";
    }
    if (!is_file("/usr/share/perl5/Razor2/Client/Agent.pm")) {
        $PKG[] = "razor";
    }

    if (!is_file("/usr/lib/apt/methods/https")) {
        $PKG[] = "apt-transport-https";
    }
    if (!is_file("/usr/lib/python2.7/dist-packages/pcapy.so")) {
        $PKG[] = "python-pcapy";
    }
    if (!is_file("/usr/bin/schedtool")) {
        $PKG[] = "schedtool";
    }
    if (!is_file("/usr/lib/x86_64-linux-gnu/rsyslog/lmnsd_gtls.so")) {
        $PKG[] = "rsyslog-gnutls";
    }
    if (!is_file("/usr/bin/getdns_query")) {
        $PKG[] = "getdns-utils";
    }
    if (!is_file("/usr/bin/msmtp")) {
        $PKG[] = "msmtp";
    }
    if (!is_file("/usr/lib/x86_64-linux-gnu/libJudy.so.1")) {
        $PKG[] = "libjudydebian1";
    }
    if (!is_file("/usr/bin/ziproxy")) {
        $PKG[] = "ziproxy";
    }
    if (!is_file("/usr/bin/zip")) {
        $PKG[] = "zip";
    }
    if (!is_file("/usr/bin/prads")) {
        $PKG[] = "prads";
    }
    if (!is_file("/usr/sbin/argus")) {
        $PKG[] = "argus-client";
        $PKG[] = "argus-server";
    }

    $sacompile = $unix->find_program("sa-compile");
    if (!is_file($sacompile)) {
        $PKG[] = "sa-compile";
    }


    if (count($PKG) == 0) {
        return array();
    }


    return $PKG;

}

?>