#!/usr/bin/php
<?php
$GLOBALS["WIZARD"]=false;
if(preg_match("#--verbose#",implode(" ",$argv))){$GLOBALS["VERBOSE"]=true;$GLOBALS["VERBOSE"]=true;$GLOBALS["debug"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
include_once(dirname(__FILE__) . '/ressources/class.ldap.inc');
include_once(dirname(__FILE__) . '/ressources/class.templates.inc');
include_once(dirname(__FILE__) . '/framework/class.unix.inc'); 
include_once(dirname(__FILE__) . '/framework/frame.class.inc');
include_once(dirname(__FILE__) . '/framework/class.tcpip-parser.inc');
include_once(dirname(__FILE__) . '/framework/class.settings.inc');
include_once(dirname(__FILE__) . '/ressources/class.system.network.inc');
include_once(dirname(__FILE__) . '/ressources/class.system.nics.inc');
include_once(dirname(__FILE__) . '/ressources/class.os.system.inc');

$GLOBALS["FIRST_TIME"]=false;
$GLOBALS["NO_GLOBAL_RELOAD"]=false;
$GLOBALS["AFTER_REBUILD"]=false;
$GLOBALS["AS_ROOT"]=true;
$GLOBALS["SLEEP"]=false;
$GLOBALS["RESTART"]=false;
$GLOBALS["RESTART_DNS"]=false;
if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}

if(function_exists("posix_getuid")){if(posix_getuid()<>0){die("Cannot be used in web server mode\n\n");}}
if(preg_match("#--wizard#",implode(" ",$argv))){$GLOBALS["WIZARD"]=true;}
if(preg_match("#--sleep#",implode(" ",$argv))){$GLOBALS["SLEEP"]=true;}
if(preg_match("#--restart#",implode(" ",$argv))){$GLOBALS["RESTART"]=true;}
if(preg_match("#--afterrebuild#",implode(" ",$argv))){$GLOBALS["AFTER_REBUILD"]=true;}
if(preg_match("#--first-time#",implode(" ",$argv))){$GLOBALS["FIRST_TIME"]=true;$GLOBALS["VERBOSE"]=true;$GLOBALS["VERBOSE"]=true;$GLOBALS["debug"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}


$DisableNetworking=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DisableNetworking"));
if($DisableNetworking==1){
    die("Disable Networking is defined, aborting...");
}



if(isset($argv[1])){
	if($argv[1]=="--resolvconf"){resolvconf();exit;}
	if($argv[1]=="--interfaces"){interfaces_show();exit();}
	if($argv[1]=="--loopback"){loopback();exit();}
	if($argv[1]=="--just-add"){routes();exit();}
	if($argv[1]=="--articalogon"){articalogon();exit();}
	if($argv[1]=="--ifconfig"){ifconfig_tests();exit;}
	if($argv[1]=="--bridges"){bridges_build();exit;}
	if($argv[1]=="--parse-tests"){ifconfig_parse($argv[2]);exit;}
	if($argv[1]=="--routes"){routes();exit;}
	if($argv[1]=="--routes-del"){routes_del($argv[2]);exit;}
	if($argv[1]=="--vlans"){build();exit;}
	if($argv[1]=="--build"){build();exit;}
	if($argv[1]=="--postfix-instances"){postfix_multiples_instances();exit;}
	if($argv[1]=="--ping"){ping($argv[2]);exit;}
	if($argv[1]=="--ipv6"){Checkipv6();exit;}
	if($argv[1]=="--ifupifdown"){ifupifdown($argv[2]);exit;}
	if($argv[1]=="--reconstruct-interface"){reconstruct_interface($argv[2]);exit;}
	if($argv[1]=="--ucarp"){ucarp_build();exit;}
	if($argv[1]=="--ucarp-start"){ucarp_start();exit;}
	if($argv[1]=="--ucarp-stop"){ucarp_stop();exit;}
	if($argv[1]=="--net-rules"){persistent_net_rules();exit;}
	if($argv[1]=="--main-routes"){routes_main_build();exit;}
	if($argv[1]=="--routes"){routes();exit;}
	if($argv[1]=="--vlans-build"){vlan_build();exit;}
	if($argv[1]=="--vlans-delete"){vlan_delete($argv[2]);exit;}
	if($argv[1]=="--virtip-build"){virtip_build($argv[2]);exit;}
	if($argv[1]=="--virtip-delete"){virtip_delete($argv[2]);exit;}
	if($argv[1]=="--bridge-delete"){bridge_delete($argv[2]);exit;}
	if($argv[1]=="--bridge-rm"){bridge_deletemanu($argv[2]);exit;}
	if($argv[1]=="--hosts"){$GLOBALS["RESTART_DNS"]=true;etc_hosts_exec();exit;}
	if($argv[1]=="--hosts-defaults"){etc_hosts_defaults();exit;}
	if($argv[1]=="--iptables-bridge-delete"){bridges_delete();exit;}
	if($argv[1]=="--ucarp-notify"){ucarp_notify($argv[2],$argv[3],$argv[4],$argv[5],$argv[6]);exit;}
	if($argv[1]=="--ucarp-notify-down"){ucarp_notify_down($argv[2],$argv[3],$argv[4],$argv[5],$argv[6]);exit;}
	if($argv[1]=="--wccp-build"){nics_wccp_build(true);exit;}
	if($argv[1]=="--ucarp-active"){print_r(ucarp_interface_active(true));exit;}
	if($argv[1]=="--start-dhclient"){start_dhclient($argv[2]);exit;}
	if($argv[1]=="--stop-dhclient"){stop_dhclient($argv[2]);exit;}
	if($argv[1]=="--iproute2"){CheckRoutesRules($argv[2]);exit;}
	if($argv[1]=="--iprouteChecks"){CheckAllRoutesRules();exit;}
	if($argv[1]=="--iproute-progress"){apply_routes();exit;}
	if($argv[1]=="--wifi"){Check_wifi_cards();exit;}
    if($argv[1]=="--watchdog"){monit_interfaces();exit;}
    if($argv[1]=="--verif-interface"){verif_interface($argv[2]);exit;}
    if($argv[1]=="--monit-interface"){watchdog_interface($argv[2]);}
}



if($GLOBALS["SLEEP"]){sleep(2);}
DHCP_SCRIPTS();
dev_shm();
build();

if(!$GLOBALS["RESTART"]){build_progress(100, "{success}");}



system("/etc/init.d/artica-ifup start");
build_progress(100, "{checking} {done}");

if(is_file("/etc/init.d/ssh")){
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	shell_exec("$php /usr/share/artica-postfix/exec.sshd.php --progress");
}

//
//vconfig set_flag eth1.3 1 1
//vconfig set_flag eth1.4 1 1

//http://www.cyberciti.biz/tips/howto-configure-linux-virtual-local-area-network-vlan.html
//http://www.stg.net/vlanbridge


function ping($host){
	ini_set_verbosed();
	$unix=new unix();
	if($unix->PingHost($host)){
		echo "$host:TRUE\n";
	}else{
		echo "$host:FALSE\n";
	}
	
}

function interfaces_show(){
	$nic=new system_nic();
	$datas=$nic->root_build_debian_config();
	echo $datas;
}


function DHCP_SCRIPTS(){
    $f[]="#!/bin/sh";
    $f[]="# Filename:     /etc/dhcp/dhclient-exit-hooks.d/hostname";
    $f[]="# Purpose:      Used by dhclient-script to set the hostname of the system";
    $f[]="#               to match the DNS information for the host as provided by";
    $f[]="#               DHCP.";
    $f[]="#";
    $f[]="";
    $f[]="";
    $f[]="# Do not update hostname for virtual machine IP assignments";
    $f[]="if [ \"\$interface\" != \"eth0\" ] && [ \"\$interface\" != \"eth1\" ]";
    $f[]="then";
    $f[]="    return";
    $f[]="fi";
    $f[]="";
    $f[]="";
    $f[]="if [ \"\$reason\" != BOUND ] && [ \"\$reason\" != RENEW ] \\";
    $f[]="   && [ \"\$reason\" != REBIND ] && [ \"\$reason\" != REBOOT ]";
    $f[]="then";
    $f[]="        return";
    $f[]="fi";
    $f[]="";
    $f[]="echo dhclient-exit-hooks.d/hostname: Dynamic IP address = \$new_ip_address";
    $f[]="hostname=\$(host \$new_ip_address | cut -d ' ' -f 5 | sed -r 's/((.*)[^\.])\.?/\1/g' )";
    $f[]="echo \$hostname > /etc/hostname";
    $f[]="hostname \$hostname";
    $f[]="echo dhclient-exit-hooks.d/hostname: Dynamic Hostname = \$hostname\n";
    @file_put_contents("/etc/dhcp/dhclient-exit-hooks.d/hostname",@implode("\n",$f));
    system("chmod a+r /etc/dhcp/dhclient-exit-hooks.d/hostname");
}

function loopback(){
	$unix=new unix();
	$ifconfig=$unix->find_program("ifconfig");
	shell_exec("$ifconfig lo down");
	shell_exec("$ifconfig lo 127.0.0.1 netmask 255.255.255.0 up >/dev/null 2>&1");
	VirtualsIPSyslog("Restarting loopback...");
}

function VirtualsIPSyslog($text){
	if(!function_exists("syslog")){return;}
	$LOG_SEV=LOG_ERR;
	openlog("artica-ifup", LOG_PID , LOG_SYSLOG);
	syslog($LOG_SEV, $text);
	closelog();
}
function wizard_progress($perc,$text){
	if(!$GLOBALS["WIZARD"]){return;}
	$PROGRESS_FILE="/usr/share/artica-postfix/ressources/logs/web/wizard.progress";
	$array["POURC"]=60;
	$array["TEXT"]="$perc) $text";
if(!is_dir('/usr/share/artica-postfix/ressources/logs/web')){@mkdir('/usr/share/artica-postfix/ressources/logs/web',0755,true);}
	@file_put_contents($PROGRESS_FILE, serialize($array));
	@chmod($PROGRESS_FILE,0755);
	$unix=new unix();

	if(function_exists("debug_backtrace")){
		$trace=debug_backtrace();
		if(isset($trace[1])){
			$sourcefile=basename($trace[1]["file"]);
			$sourcefunction=$trace[1]["function"];
			$sourceline=$trace[1]["line"];
		}
			
	}


	$unix->events("$perc} $text","/var/log/artica-wizard.log",$sourcefunction,$sourceline,$sourcefile);

}
function build_progress_resolvconf($text,$pourc){
    wizard_progress($pourc, $text);
    $echotext=$text;
    echo "Starting......: ".date("H:i:s")." {$pourc}% $echotext\n";
    $cachefile="/usr/share/artica-postfix/ressources/logs/dnsparams.progress";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($cachefile, serialize($array));
    @chmod($cachefile,0755);
}



function resolvconf(){

    build_progress_resolvconf("{reconfiguring}",50);

	$resolv=new resolv_conf();
	$resolvDatas=$resolv->build();
    echo "/etc/resolv.conf DONE\n";
	@file_put_contents("/etc/resolv.conf", $resolvDatas);

    build_progress_resolvconf("{reconfiguring} {$resolv->MainArray["DNS1"]} - {$resolv->MainArray["DNS2"]}",60);

	if(is_dir("/var/spool/postfix/etc")){
	        echo "/var/spool/postfix/etc/resolv.conf DONE\n";
	        @file_put_contents("/var/spool/postfix/etc/resolv.conf", $resolvDatas);
	}

	if(is_dir("/etc/resolvconf")){
		@mkdir("/etc/resolvconf/resolv.conf.d",0755,true);
		$f=array();
		if($resolv->MainArray["DNS1"]<>null){$f[]="nameserver {$resolv->MainArray["DNS1"]}";}
		if($resolv->MainArray["DNS2"]<>null){$f[]="nameserver {$resolv->MainArray["DNS2"]}";}
		if($resolv->MainArray["DNS3"]<>null){$f[]="nameserver {$resolv->MainArray["DNS3"]}";}
		if(count($f)>0){
            echo "/etc/resolvconf/resolv.conf.d/base DONE\n";
			@file_put_contents("/etc/resolvconf/resolv.conf.d/base", @implode("\n", $f));
		}
	}

    build_progress_resolvconf("{success}",100);
	

}

function verif_interface($Interface){

    $cachefile="/etc/artica-postfix/pids/verif.interface.$Interface.cache";
    $pidfile="/etc/artica-postfix/pids/verif.interface.$Interface.pid";
    $unix=new unix();
    $pid=$unix->get_pid_from_file($pidfile);
    if($unix->process_exists($pid)){
        die("Already process $pid exists");
    }
    if(is_file($pidfile)){
        @unlink($pidfile);
    }
    @file_put_contents($pidfile,getmypid());

    $ip=$unix->find_program("ip");
    $q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");
    $ligne=$q->mysqli_fetch_array("SELECT * FROM `nics` WHERE `Interface`='$Interface'");

    $enabled=intval($ligne["enabled"]);
    $watchdog=intval($ligne["watchdog"]);
    $GATEWAY=trim($ligne["GATEWAY"]);
    $ID=intval($ligne["ID"]);
    if($enabled==0){echo "$Interface: enabled == 0\n";return false;}
    if($watchdog==0){echo "$Interface: watchdog == 0\n";return false;}
    if($GATEWAY==null){echo "$Interface: GATEWAY == NULL\n";return false;}
    if($GATEWAY=="0.0.0.0"){echo "$Interface: GATEWAY == 0.0.0.0\n";return false;}

    $Cgateway=verif_interface_default_gateway($Interface);
    echo "$Interface ($ID) Current gateway '$Cgateway', need ($GATEWAY)\n";

    if($Cgateway==null){
        exec("$ip route add default via $GATEWAY dev $Interface 2>&1",$addg);
        $Cgateway=verif_interface_default_gateway($Interface);
        if($Cgateway==null){
            $cacheTime=$unix->file_time_min($cachefile);
            if($cacheTime>10) {
                squid_admin_mysql(0, "[NET]: Unable to create gateway $GATEWAY for interface $Interface", @implode("\n", $addg), __FILE__, __LINE__);
                @unlink($cachefile);
                @file_put_contents($cachefile, time());
            }
            return;
        }else{
            $cacheTime=$unix->file_time_min($cachefile);
            if($cacheTime>10) {
                squid_admin_mysql(2, "[NET]: Success to create gateway $GATEWAY for interface $Interface", @implode("\n", $addg), __FILE__, __LINE__);
                @unlink($cachefile);
                @file_put_contents($cachefile, time());
            }


        }
        return true;
    }

    if($Cgateway<>$GATEWAY){
        exec("$ip route del default via $Cgateway dev $Interface");
        exec("$ip route add default via $GATEWAY dev $Interface 2>&1",$addg);
        $Dgateway=verif_interface_default_gateway($Interface);
        if($Dgateway<>$GATEWAY){
            $cacheTime=$unix->file_time_min($cachefile);
            if($cacheTime>10) {
                squid_admin_mysql(0, "[NET]: Unable to change default gateway from $Cgateway to $GATEWAY for interface $Interface",
                    @implode("\n", $addg), __FILE__, __LINE__);
                @unlink($cachefile);
                @file_put_contents($cachefile, time());
            }
            return true;
        }else{
            $cacheTime=$unix->file_time_min($cachefile);
            if($cacheTime>10) {
                squid_admin_mysql(2, "[NET]: Success to change gateway $Cgateway to $GATEWAY for interface $Interface", @implode("\n", $addg),
                    __FILE__, __LINE__);
                @unlink($cachefile);
                @file_put_contents($cachefile, time());
            }
        }

        return true;
    }




}

function verif_interface_default_gateway($eth){
    $unix=new unix();
    $ip=$unix->find_program("ip");
    exec("$ip route show dev $eth 2>&1",$results);

    foreach ($results as $line){
        if($line==null){continue;}
        if(!preg_match("#default via\s+([0-9\.]+)#",$line,$re)){continue;}
        return $re[1];
    }

    return null;

}

function watchdog_interface($Interface){


    $cacheFile="/etc/artica-postfix/pids/watchdog.interface.$Interface.time";
    $pidfile="/etc/artica-postfix/pids/watchdog.interface.$Interface.pid";
    $unix=new unix();
    $pid=$unix->get_pid_from_file($pidfile);
    if($unix->process_exists($pid)){
        die("Already process $pid exists");
    }
    @unlink($pidfile);
    @file_put_contents($pidfile,getmypid());

    $filetime=$unix->file_time_min($cacheFile);
    if($filetime<3){die();}

    @unlink($filetime);
    @file_put_contents($filetime,time());

    $grep=$unix->find_program("grep");
    $cmdline="$grep -E \"kernel.*?($Interface|net)\" /var/log/syslog 2>&1";
    exec($cmdline,$results);
    $unix->ToSyslog("Warning Interface $Interface bad status [action=reset network]",true,"Net-$Interface");
    squid_admin_mysql(0,"[NET]: Warning $Interface bad status [action=reset network]",
        @implode("\n",results),__FILE__,__LINE__);
    system("/etc/init.d/artica-ifup start");

}

function monit_interfaces(){
    $prc=10;
    $i=0;
    $unix=new unix();
    $php=$unix->LOCATE_PHP5_BIN();
    $files=$unix->DirFiles("/etc/monit/conf.d","^INTERFACE_");
    foreach ($files as $filename=>$none){
        @unlink("/etc/monit/conf.d/$filename");
        build_progress_watchdog("Removing $filename",$prc++);
        $i++;
    }

    $RELOAD_CRON=false;
    $files=$unix->DirFiles("/etc/cron.d","^INTERFACE_");
    foreach ($files as $filename=>$none){
        if(is_file("/etc/cron.d/$filename")) {
            @unlink("/etc/cron.d/$filename");
            $RELOAD_CRON=true;
            build_progress_watchdog("Removing $filename", $prc++);
        }
        $i++;
    }



    $q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");
    $sql="SELECT * FROM `nics` WHERE `enabled`=1 AND `watchdog`=1";
    $results=$q->QUERY_SQL($sql);
    if(!$q->ok){echo $q->mysql_error."\n";}
    echo "Watchdog ".count($results)." items\n";
    build_progress_watchdog("Watchdog ".count($results)." items",$prc++);

    foreach ($results as $index=>$ligne) {
        $Interface = $ligne["Interface"];
        echo "Watchdog on $Interface\n";
        build_progress_watchdog("Watchdog on $Interface",$prc++);
        $RELOAD_CRON=true;
        $unix->Popuplate_cron_make("INTERFACE_$Interface","* * * * *","exec.virtuals-ip.php --verif-interface $Interface");
        system("/etc/init.d/cron reload");

        $H[] = "check network $Interface with interface $Interface";
        $H[] = "\tif failed link then exec \"/bin/bash -c '$php " . __FILE__ . " --monit-interface $Interface'\"";
        $H[] = "";
        @file_put_contents("/etc/monit/conf.d/INTERFACE_$Interface.monitrc",@implode("\n",$H));
        $i++;
    }

    if($RELOAD_CRON){
        system("/etc/init.d/cron reload");
    }

    build_progress_watchdog("Reloading watchdog service",90);
    shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload");
    build_progress_watchdog("{done}",100);
}

function ucarp_notify($nic=null,$SQUIDIP=null,$trois=null,$quatre=null,$cinq=null){
	if($nic==null){
		VirtualsIPSyslog("[Failover] No nic, no IP...");
		return;
	}
	
	
	$unix=new unix();
	$LOCATE_SQUID_BIN=$unix->LOCATE_SQUID_BIN();
	if(!is_file($LOCATE_SQUID_BIN)){return;}
	$nohup=$unix->find_program("nohup");
	
	
	include_once(dirname(__FILE__)."/ressources/class.squid.inc");
	$sock=new sockets();
	$hasProxyTransparent=$sock->GET_INFO("hasProxyTransparent");
	if(!is_numeric($hasProxyTransparent)){$hasProxyTransparent=0;}
	VirtualsIPSyslog("[Failover] state UP detected $nic:$SQUIDIP Proxy Transparent mode: $hasProxyTransparent");
	
	if(is_file("/usr/share/ucarp/Master")){
		VirtualsIPSyslog("[Failover] UP mode Master... nothing to do...");
		return;
	}
	
	$MAIN=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HASettings")));
	if($MAIN["SLAVE"]<>null){
		VirtualsIPSyslog("[Failover] UP mode Master... nothing to do...");
		return;
	}
	
	
	if($hasProxyTransparent==0){return;}
	$squid=new squidbee();
	$ssl_port=$squid->get_ssl_port();
	if(!is_numeric($squid->listen_port)){$squid->listen_port=3128;}
	$listen_ssl_port=$squid->listen_port+1;
	$SSL_BUMP=$squid->SSL_BUMP;
	$iptables=$unix->find_program("iptables");
	$MARKLOG="-m comment --comment \"SquidFailOverTransparent\"";
	$SQUIDPORT=$squid->listen_port;
	
	VirtualsIPSyslog("[Failover] UP Redirect connections from $SQUIDIP:80/443 to port $SQUIDPORT/$ssl_port - if ssl enabled -");
	ucarp_notify_removeiptables();
	shell_exec("$iptables -t nat -A PREROUTING -s $SQUIDIP -p tcp --dport 80 -j ACCEPT $MARKLOG");
	
	if($SSL_BUMP==1){
		shell_exec("$iptables -t nat -A PREROUTING -s $SQUIDIP -p tcp --dport 443 -j ACCEPT $MARKLOG");
	}	
	
	shell_exec("$iptables -t nat -A PREROUTING -p tcp --dport 80 -j REDIRECT --to-port $SQUIDPORT $MARKLOG");
	if($SSL_BUMP==1){shell_exec("$iptables -t nat -A PREROUTING -p tcp --dport 443 -j REDIRECT --to-port $ssl_port $MARKLOG");}
	shell_exec("$iptables -t nat -A POSTROUTING -j MASQUERADE $MARKLOG");
	shell_exec("$iptables -t mangle -A PREROUTING -p tcp --dport $SQUIDPORT -j DROP $MARKLOG");
	if($SSL_BUMP==1){
		shell_exec("$iptables -t mangle -A PREROUTING -p tcp --dport $ssl_port -j DROP $MARKLOG");
	}
	
	$cmd="/etc/init.d/squid reload --script=".basename(__FILE__);
	squid_admin_mysql(2, "Reloading Proxy service (".__FUNCTION__.")", null,__FILE__,__LINE__);
	shell_exec("$cmd >/dev/null 2>&1");
	shell_exec("$nohup /etc/init.d/snmpd restart >/dev/null 2>&1 &");
	
	
}

function ucarp_notify_removeiptables(){
	$unix=new unix();
	VirtualsIPSyslog("[Failover] Remove transparent rules...");
	$iptables_save=$unix->find_program("iptables-save");
	$iptables_restore=$unix->find_program("iptables-restore");
	system("$iptables_save > /etc/artica-postfix/iptables.conf");
	$data=file_get_contents("/etc/artica-postfix/iptables.conf");
	$datas=explode("\n",$data);
	$pattern="#.+?SquidFailOverTransparent#";
	$d=0;
	$conf=null;
	foreach ($datas as $num=>$ligne){
		if($ligne==null){continue;}
		if(preg_match($pattern,$ligne)){$d++;continue;}
		$conf=$conf . $ligne."\n";
	}
	file_put_contents("/etc/artica-postfix/iptables.new.conf",$conf);
	system("$iptables_restore < /etc/artica-postfix/iptables.new.conf");
	VirtualsIPSyslog("[Failover] Removed $d temporary transparent rules...");	
}

function ucarp_notify_down($nic=null,$ipaddr=null,$trois=null,$quatre=null,$cinq=null){
	
	if(is_file("/usr/share/ucarp/Master")){
		VirtualsIPSyslog("[Failover] DOWN mode Master... nothing to do...");
		return;
	}
	
	$unix=new unix();
	$LOCATE_SQUID_BIN=$unix->LOCATE_SQUID_BIN();
	if(!is_file($LOCATE_SQUID_BIN)){return;}
	$nohup=$unix->find_program("nohup");
	ucarp_notify_removeiptables();
	$cmd="/etc/init.d/squid reload --script=".basename(__FILE__);
	squid_admin_mysql(2, "Reloading Proxy service (".__FUNCTION__.")", null,__FILE__,__LINE__);
	shell_exec("$nohup $cmd >/dev/null 2>&1 &");
	shell_exec("$nohup /etc/init.d/snmpd restart >/dev/null 2>&1 &");
}


function ucarp_stop(){
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$unix=new unix();
	
	$pid=$unix->get_pid_from_file($pidfile);
	if($unix->process_exists($pid,basename(__FILE__))){
		echo "Starting......: ".date("H:i:s")." UCARP Start task already running PID: $pid\n";
		return;
	}
	@file_put_contents($pidfile, getmypid());
	
	$ucarp_bin=$unix->find_program("ucarp");
	if(!is_file($ucarp_bin)){echo "Starting......: ".date("H:i:s")." UCARP Not installed...\n";return;}	
	$pids=ucarp_all_pid();
	$kill=$unix->find_program("kill");
	
	echo "Starting......: ".date("H:i:s")." UCARP Found (".count($pids).") processe(s)\n";
	
	while (list ($pid, $line) = each ($pids) ){
		echo "Starting......: ".date("H:i:s")." UCARP checks PID:$pid processe(s)\n";
		ucarp_stop_single($pid);
	}
	
	
}

function ScriptInfo($line){
	$line=str_replace("\n", "", $line);
	$line=str_replace("\r", "", $line);
	$line=str_replace("\r\n", "", $line);
	return $line;
	
}
function build_progress_watchdog($text,$pourc){
    wizard_progress($pourc, $text);
    $echotext=$text;
    echo "Starting......: ".date("H:i:s")." {$pourc}% $echotext\n";
    $cachefile="/usr/share/artica-postfix/ressources/logs/web/exec.interfaces-watchdog.progress";
    $array["POURC"]=$pourc;
    $array["TEXT"]=$text;
    @file_put_contents($cachefile, serialize($array));
    @chmod($cachefile,0755);
}

function build_progress($pourc,$text){
	wizard_progress($pourc, $text);
	$echotext=$text;
	echo "Starting......: ".date("H:i:s")." {$pourc}% $echotext\n";
	$cachefile="/usr/share/artica-postfix/ressources/logs/web/exec.virtuals-ip.php.progress";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($cachefile, serialize($array));
	@chmod($cachefile,0755);
}
function build_progress_etc_host($pourc,$text){
	wizard_progress($pourc, $text);
	$echotext=$text;
	echo "Starting......: ".date("H:i:s")." {$pourc}% $echotext\n";
	$cachefile="/usr/share/artica-postfix/ressources/logs/web/etchosts.progress";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($cachefile, serialize($array));
	@chmod($cachefile,0755);
}
function dev_shm(){
	
	build_progress(10, "{checking} SHM...");
	
	
	if(!is_dir("/etc/network")){return;}
	if(!is_dir("/dev/shm/network")){@mkdir("/dev/shm/network",0755,true);}
	
	if(!is_link("/etc/network/run")){
		$unix=new unix();
		$ln=$unix->find_program("ln");
		shell_exec("$ln -s /dev/shm/network /etc/network/run");
	}
	if($GLOBALS["VERBOSE"]){echo "Line:".__LINE__." dev_shm ->done\n";}
	
}

function vlan_build(){
	BuildNetWorksDebian();
}
function virtip_build(){
	$nic=new system_nic();
	$nic->BuildVirtIps();
	if(count($GLOBALS["SCRIPTS"])>0){
		while (list ($index, $line) = each ($GLOBALS["SCRIPTS"]) ){
			$line=trim($line);
			if($line==null){continue;}
			$md=md5($line);
			if(substr($line, 0,1)=="#"){$sh[]=ScriptInfo($line);continue;}
			if(isset($AL[$md])){continue;}
			$AL[$md]=true;
				
			echo "Starting......: ".date("H:i:s")." `$line`\n";
			$sh[]="echo \"Starting......: ".date("H:i:s")." $line\"";
			events("$line",__FUNCTION__,__LINE__);
			system($line);
		}
		usleep(500);
	}
	BuildNetWorksDebian();
}

function etc_hosts_exec(){
	
	build_progress_etc_host(25,"{etc_hosts}");
	if(!etc_hosts()){
		build_progress_etc_host(110,"{failed}");
		return;}
	if(count($GLOBALS["SCRIPTS"])>0){
	    foreach ($GLOBALS["SCRIPTS"] as $index=>$line){
			$line=trim($line);
			if($line==null){continue;}
			$md=md5($line);
			if(substr($line, 0,1)=="#"){continue;}
			if(isset($AL[$md])){continue;}
			$AL[$md]=true;
			echo "Starting......: ".date("H:i:s")." `$line`\n";
			events("$line",__FUNCTION__,__LINE__);
			system($line);
		}

	}
    build_progress_etc_host(50,"{etc_hosts}");
	if($GLOBALS["RESTART_DNS"]) {
        if (is_file("/etc/init.d/unbound")) {
            build_progress_etc_host(55,"{etc_hosts}");
            shell_exec("/etc/init.d/unbound restart");
        }
    }


	build_progress_etc_host(100,"{etc_hosts} {success}");
	
	
}

function hostclean($hostname){

    $hostname=str_replace([':','|','+','²','^','°', '\\', '/', '*',' ','(',')','{','}','[',']','%','$',';',',','?','=','#','&','`','"'], '', $hostname);
    return trim(strtolower($hostname));
}

function etc_hosts(){
	$unix                       = new unix();
	$echo                       = $unix->find_program("echo");
	$hostname                   = trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("myhostname"));
    $EnableipV6                 = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableipV6"));
    $q                          = new lib_sqlite("/home/artica/SQLITE/etc_hosts.db");
	$DisableEtcHosts            = intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DisableEtcHosts"));
    $AclsDynamicsWebServerName  = trim(strtolower($GLOBALS["CLASS_SOCKETS"]->GET_INFO("AclsDynamicsWebServerName")));
    $FirewallWebServerName      = trim(strtolower($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FirewallWebServerName")));
    $ProxyWebServerName         = trim(strtolower($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ProxyWebServerName")));

	if(!is_numeric($DisableEtcHosts)){$DisableEtcHosts=0;}
	if($DisableEtcHosts==1){
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] ****      HOSTS FILE       ****";
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] Disabled by DisableEtcHosts";
		return true;
	}

    if($hostname==null){
        $hostname=$GLOBALS["CLASS_SOCKETS"]->getFrameWork("system.php?hostname-g=yes");
        $GLOBALS["CLASS_SOCKETS"]->SET_INFO(hostclean($hostname),"myhostname");
    }

    $hostname=hostclean($hostname);

	if(strpos($hostname, ".")>0){
		$rre=explode(".",$hostname);
		$netbiosname=$rre[0];
	}


    $local_hostnames[]=$netbiosname;
	$local_hostnames[]=$hostname;



    if($AclsDynamicsWebServerName<>null) {
        $local_hostnames[] = "$AclsDynamicsWebServerName";
    }
    if($FirewallWebServerName<>null){
        $local_hostnames[] = "$FirewallWebServerName";
    }

    if($ProxyWebServerName<>null){
        $local_hostnames[] = "$ProxyWebServerName";
    }

    $local_alias[]="localhost";
    $local_alias[]="localhost.localdomain";

    $f[]="127.0.0.1 ".@implode("\t",$local_alias);
    $f[]="127.0.0.1 ".@implode("\t",$local_hostnames);

    if($EnableipV6 == 1 ) {
        echo "IPv6 is Enabled\n";
        $f[] = "::1     ip6-localhost\tip6-loopback";
        $f[] = "::1     ".@implode("\t",$local_alias);
        $f[] = "::1     ".@implode("\t",$local_hostnames);
        $f[] = "fe00::0 ip6-localnet";
        $f[] = "ff00::0 ip6-mcastprefix";
        $f[] = "ff02::1 ip6-allnodes";
        $f[] = "ff02::2 ip6-allrouters";
        $f[] = "ff02::3 ip6-allhosts";
        $f[] = "ff02::3 ip6-allhosts";
    }else{
        echo "IPv6 is disabled\n";
    }
	


	$GLOBALS["SCRIPTS"][]="# [".__LINE__."]";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."] ****      HOSTS FILE       ****";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."]";
	$GLOBALS["SCRIPTS"][]="# this first line flush the host file";
    $GLOBALS["SCRIPTS"][]="$echo \"\" >/etc/hosts";

    if(!$q->TABLE_EXISTS("dummy")){
        $sql="CREATE TABLE IF NOT EXISTS dummy  (
		`ID` INTEGER PRIMARY KEY AUTOINCREMENT,
		`nothing` TEXT)";
        $q->QUERY_SQL($sql);
    }
	
	
	$UnboundEnabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundEnabled"));
	
	if($UnboundEnabled==1){
		$sql="DELETE FROM net_hosts WHERE hostname LIKE '%google.%'";
		$q->QUERY_SQL($sql);
	}
    $sql="SELECT * FROM net_hosts ORDER BY hostname";
    $results=$q->QUERY_SQL($sql);
    if($q->ok) {
        $ip = new IP();
        foreach ($results as $index => $ligne) {

            foreach ($ligne as $a => $b) {
                $ligne[$a] = str_replace("\r\n", " ", $ligne[$a]);
                $ligne[$a] = str_replace("\n", " ", $ligne[$a]);
                $ligne[$a] = str_replace("\r", " ", $ligne[$a]);
                $ligne[$a] = trim($ligne[$a]);
            }

            if (!$ip->isValid($ligne["ipaddr"])) {
                $GLOBALS["SCRIPTS"][] = "# [" . __LINE__ . "]: {$ligne["ipaddr"]} not valid for {$ligne["hostname"]}";
                continue;
            }

            if (trim($ligne["hostname"]) == null) {
                continue;
            }
            $ligne["alias"]=hostclean($ligne["alias"]);
            $ligne["hostname"]=hostclean( $ligne["hostname"]);

            if (preg_match("#^google\.#", $ligne["hostname"])) {
                if ($UnboundEnabled == 1) {
                    continue;
                }
                $ligne["alias"] = hostclean("www.{$ligne["hostname"]}");
            }

            if (trim($ligne["alias"]) <> null) {
                $ligne["alias"] = "\t{$ligne["alias"]}";
            }
            echo "Parsing {$ligne["ipaddr"]}\n";
            if($EnableipV6==0){
                if($ligne["ipaddr"]=="::1"){continue;}
                if(preg_match("#[a-z0-9]+::[0-9]+#i",$ligne["ipaddr"])){continue;}
            }

            $lineExe = trim("{$ligne["ipaddr"]}\t{$ligne["hostname"]}{$ligne["alias"]}");

            if($EnableipV6==0){
                if(preg_match("#(ip6-localhost|ip6-loopback|ip6-allnodes|ip6-allrouters)#",$lineExe)){continue;}
                if(preg_match("#^ff.*?::[0-9]+#",$lineExe)){continue;}
            }

            $GLOBALS["SCRIPTS"][] = "$echo \"$lineExe\" >> /etc/hosts";


        }
    }

	foreach ( $f as $index=>$line ){
		$GLOBALS["SCRIPTS"][]="$echo \"$line\" >> /etc/hosts";
	}

	$INTERFACES=$unix->NETWORK_ALL_INTERFACES(true);

	for($i=0;$i<10;$i++){
	    $eth="eth$i";
        if(!isset($INTERFACES[$eth])){continue;}
        if($INTERFACES[$eth]["IPADDR"]=="0.0.0.0"){continue;}
        if($INTERFACES[$eth]["IPADDR"]==null){continue;}
        $GLOBALS["SCRIPTS"][]="$echo \"{$INTERFACES[$eth]["IPADDR"]}\t".@implode("\t",$local_hostnames)."\" >> /etc/hosts";
    }
    $GLOBALS["SCRIPTS"][]="";
	$GLOBALS["SCRIPTS"][]="#";
	return true;
	
}

function vlan_delete($ID){
	$sql="SELECT * FROM nics_vlan WHERE ID='$ID'";
	$q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");
	if(!is_numeric($ID)){return;}
	if($ID<1){return;}	
	$unix=new unix();
	if(!isset($GLOBALS["moprobebin"])){$GLOBALS["moprobebin"]=$unix->find_program("modprobe");}
	if(!isset($GLOBALS["vconfigbin"])){$GLOBALS["vconfigbin"]=$unix->find_program("vconfig");}
	if(!isset($GLOBALS["ifconfig"])){$GLOBALS["ifconfig"]=$unix->find_program("ifconfig");}
	if(!isset($GLOBALS["ethtoolbin"])){$GLOBALS["ethtoolbin"]=$unix->find_program("ethtool");}
	if(!isset($GLOBALS["ipbin"])){$GLOBALS["ipbin"]=$unix->find_program("ip");}	
	$ligne=$q->mysqli_fetch_array($sql);
	$eth="{$ligne["nic"]}";
	$vlanid=$ligne["vlanid"];
	if($vlanid==0){return;}
	if($vlanid>0){$vlanid_text=".$vlanid";}	
	shell_exec("{$GLOBALS["ifconfig"]} $eth$vlanid_text down");
	shell_exec("{$GLOBALS["vconfigbin"]} rem eth$vlanid_text");
	$q->QUERY_SQL("DELETE FROM nics_vlan WHERE ID='$ID'","artica_backup");
	BuildNetWorksDebian();
}
function virtip_delete($ID){
	if(!is_numeric($ID)){return;}
	if($ID<1){return;}
	$sql="SELECT * FROM nics_virtuals WHERE ID='$ID'";
	$q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");
	
	$unix=new unix();
	if(!isset($GLOBALS["moprobebin"])){$GLOBALS["moprobebin"]=$unix->find_program("modprobe");}
	if(!isset($GLOBALS["vconfigbin"])){$GLOBALS["vconfigbin"]=$unix->find_program("vconfig");}
	if(!isset($GLOBALS["ifconfig"])){$GLOBALS["ifconfig"]=$unix->find_program("ifconfig");}
	if(!isset($GLOBALS["ethtoolbin"])){$GLOBALS["ethtoolbin"]=$unix->find_program("ethtool");}
	if(!isset($GLOBALS["ipbin"])){$GLOBALS["ipbin"]=$unix->find_program("ip");}
	$ligne=$q->mysqli_fetch_array($sql);
	$eth="{$ligne["nic"]}:{$ligne["ID"]}";
	shell_exec("{$GLOBALS["ifconfig"]} $eth down");
	$q->QUERY_SQL("DELETE FROM nics_virtuals WHERE ID='$ID'","artica_backup");
	BuildNetWorksDebian();	
	
}

/*
 * iptables -A INPUT -p udp -m physdev --physdev-in eth1 -j LOG
iptables -A INPUT -p tcp -m physdev --physdev-in eth1 -j LOG
iptables -A INPUT -p icmp -m physdev --physdev-in eth1 -j LOG

# allow ssh, smtp and http on the router _itself_ (INPUT!)
iptables -A INPUT -p tcp --dport 22 -m physdev --physdev-in eth1 -j ACCEPT
iptables -A INPUT -p tcp --dport 25 -m physdev --physdev-in eth1 -j ACCEPT
iptables -A INPUT -p tcp --dport 80 -m physdev --physdev-in eth1 -j ACCEPT

# reject all other connections to the router
iptables -A INPUT -p tcp --syn -m physdev --physdev-in eth1 -J REJECT

# allow the some on the FORWARD chain
iptables -A FORWARD -p tcp --dport 22 -m physdev --physdev-in eth1 --physdev-out eth0 -j ACCEPT
iptables -A FORWARD -p tcp --dport 25 -m physdev --physdev-in eth1 --physdev-out eth0 -j ACCEPT
iptables -A FORWARD -p tcp --dport 80 -m physdev --physdev-in eth1 --physdev-out eth0 -j ACCEPT

# reject irc to anywhere
iptables -A FORWARD -p tcp --dport 6667 -m physdev --physdev-in eth1 -j REJECT

# reject all other connections to the internal lan
iptables -A FORWARD -p tcp --syn -m physdev --physdev-in eth1 --physdev-out eth0 -j REJECT

*/



function ucarp_stop_single($pid){
	$unix=new unix();
	$ucarp_bin=$unix->find_program("ucarp");
	if(!is_file($ucarp_bin)){echo "Starting......: ".date("H:i:s")." UCARP Not installed...\n";return;}
	$kill=$unix->find_program("kill");
	$ifconfig=$unix->find_program("ifconfig");
	if(!$unix->process_exists($pid)){
		echo "Starting......: ".date("H:i:s")." UCARP [$pid]: Not running...\n";
		return;
	}
	
	$cmdline=var_export(@file_get_contents("/proc/$pid/cmdline"),true);
	if(preg_match("#'--interface=(.+?)'#", $cmdline,$re)){
		echo "Starting......: ".date("H:i:s")." UCARP: [$pid]: Shutting down interface ucarp:{$re[1]}...\n";
		shell_exec("$ifconfig {$re[1]}:ucarp down");
	}
		
	echo "Starting......: ".date("H:i:s")." UCARP: [$pid]: Shutting down $pid...\n";
	for($i=0;$i<10;$i++){
		unix_system_kill($pid);
		sleep(1);
		if(!$unix->process_exists($pid)){break;}
	}
	
	if(!$unix->process_exists($pid)){
		echo "Starting......: ".date("H:i:s")." UCARP: [$pid]: Shutting down success...\n";
	}
}

function ucarp_build($nopid=false){
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$unix=new unix();
	$sock=new sockets();

	
	if(!$nopid){
		$pid=$unix->get_pid_from_file($pidfile);
		if($unix->process_exists($pid,basename(__FILE__))){
			echo "Starting......: ".date("H:i:s")." UCARP Start task already running PID: $pid\n";
			return;
		}
		@file_put_contents($pidfile, getmypid());
	}
	
	@unlink("/usr/share/ucarp/ETH_LIST");
	@unlink("/usr/share/ucarp/Master");
	$rm=$unix->find_program("rm");
	shell_exec("$rm /usr/share/ucarp/vip-*.sh >/dev/null 2>&1");
	
	
	
	
	$users=new settings_inc();
	if(!$GLOBALS["CLASS_SOCKETS"]->CORP_LICENSE()){
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *** FAILOVER License error  ***";
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
		echo "Starting......: ".date("H:i:s")." UCARP No license set, aborting...\n";
		return;
	}
	$ucarp_bin=$unix->find_program("ucarp");
	
	if(!is_file($ucarp_bin)){echo "Starting......: ".date("H:i:s")." UCARP Not installed...\n";return;}
	
	$sql="SELECT * FROM `nics` WHERE enabled=1 AND `ucarp-enable`=1 ORDER BY Interface";
	$q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");
	$results=$q->QUERY_SQL($sql);
	if(!$q->ok){
		echo "Starting......: ".date("H:i:s")." UCARP: MySQL Error: $q->mysql_error\n";
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] **** FAILOVER Mysql ERROR! ****";
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
		return;
	}
	
	$count=count($results);
	@unlink("/etc/network/if-up.d/ucarp");
	if($count==0){
		echo "Starting......: ".date("H:i:s")." UCARP: Network Unconfigured\n";
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] **** FAILOVER Unconfigured ****";
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
		return;
	}
	
	$FINAL[]="#!/bin/sh";
	
	$pid=ucarp_pid();
	$kill=$unix->find_program("kill");
	$ifconfig=$unix->find_program("ifconfig");
	
	$EnableChilli=$sock->GET_INFO("EnableChilli");
	$chilli=$unix->find_program("chilli");
	$nohup=$unix->find_program("nohup");
	$ETHS=array();
	
	if(!is_numeric($EnableChilli)){$EnableChilli=0;}	
	if(is_file($chilli)){
		if($EnableChilli==1){
			$ChilliConf=unserialize(base64_decode($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ChilliConf")));
			$SKIP_INTERFACE=strtolower(trim($ChilliConf["HS_LANIF"]));
			$GLOBALS["SCRIPTS"][]="# [".__LINE__."] **** Skip $SKIP_INTERFACE with chilli ****";
		}
		
	}
	

	
	$php5=$unix->LOCATE_PHP5_BIN();
	if(is_file("/etc/init.d/ssh")){$sshcmd="$nohup /etc/init.d/ssh restart >/dev/null 2>&1 &";}
	
	foreach ($results as $index=>$ligne){
		$eth=trim(strtolower($ligne["Interface"]));
		if($SKIP_INTERFACE==$eth){
			echo "Starting......: ".date("H:i:s")." UCARP: Skipping interface: $SKIP_INTERFACE\n";
			continue;
		}
		$downfile="/usr/share/ucarp/vip-$eth-down.sh";
		$upfile="/usr/share/ucarp/vip-$eth-up.sh";
		
		system_failover_events("Configure:<br>Building configuration for $eth",__FUNCTION__,basename(__FILE__),__LINE__);
		
		$ucarpcmd=array();
		$ucarpcmd[]=$ucarp_bin;
		$ucarpcmd[]="--interface=$eth";
		$ucarpcmd[]="--srcip={$ligne["IPADDR"]}";
		$ucarpcmd[]="--vhid={$ligne["ucarp-vid"]}";
		$ucarpcmd[]="--passfile=/etc/artica-postfix/ucarppass";
		$ucarpcmd[]="--addr={$ligne["ucarp-vip"]}";
		
		if($ligne["ucarp-master"]==0){
			$advAdd=$ligne["ucarp-advskew"]+5;
			if($advAdd>255){$advAdd=255;}
			$ucarpcmd[]="--advskew=$advAdd";
		}else{
			@file_put_contents("/usr/share/ucarp/Master", $eth);
			$ucarpcmd[]="--preempt";
			$ucarpcmd[]="--advskew=1";
			$ucarpcmd[]="--advbase=1";
			
		}
		$ucarpcmd[]="--neutral";
		$ucarpcmd[]="--ignoreifstate";
		$ucarpcmd[]="--upscript=$upfile";
		$ucarpcmd[]="--downscript=$downfile";
		$ucarpcmd[]="--daemonize";
		@file_put_contents("/etc/artica-postfix/ucarppass", "secret");
		@chmod("/etc/artica-postfix/ucarppass",0700);
		$ucarpcmdLINE=@implode(" ", $ucarpcmd);
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] ****    FAILOVER $eth     ****";
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
		$GLOBALS["SCRIPTS"][]=$ucarpcmdLINE;
		$GLOBALS["SCRIPTS"][]="/usr/share/ucarp/vip-$eth-up.sh";
		
		$FINAL[]=@implode(" ", $ucarpcmd);
		

		$down=array();
		$down[]="#!/bin/sh";
		$down[]="$ifconfig $eth:ucarp down";
		$down[]="$php5 ".__FILE__." --ucarp-notify-down $1 $2 $3 $4 $5 >/dev/null 2>&1";
		$down[]="$sshcmd";
		$down[]="exit 0\n";
		@file_put_contents($downfile, @implode("\n", $down));
		@chmod($downfile, 0755);
		
		$up=array();
		$up[]="#!/bin/sh";
		$up[]="$ifconfig $eth:ucarp {$ligne["ucarp-vip"]} netmask {$ligne["NETMASK"]} up";
		$up[]="$php5 ".__FILE__." --ucarp-notify $1 $2 $3 $4 $5 >/dev/null 2>&1";
		$up[]=$sshcmd;
		$up[]="exit 0\n";
		@file_put_contents($upfile, @implode("\n", $up));
		@chmod($upfile, 0755);	
		$ETHS[$eth]=$ucarpcmdLINE;
		
	}	
	
	$FINAL[]="";
	echo "Starting......: ".date("H:i:s")." UCARP: /etc/network/if-up.d/ucarp done..\n";
	shell_exec("$php5 ".__FILE__." --ucarp-start --afterrebuild");
	@file_put_contents("/etc/network/if-up.d/ucarp", @implode("\n", $FINAL));
	@file_put_contents("/usr/share/ucarp/ETH_LIST", serialize($ETHS));
	@chmod("/etc/network/if-up.d/ucarp", 0755);
}


function ucarp_interface_active(){
	
	$unix=new unix();
	$ifconfig=$unix->find_program("ifconfig");
	exec("$ifconfig -a 2>&1",$results);
	$interface=null;
	$ipaddr=null;
	foreach ($results as $num=>$ligne){
		if(preg_match("#(.+?):ucarp.*?HWaddr\s+(.+)#",$ligne,$re)){
			$interface=$re[1];
			$MAC=$re[2];
			continue;
		}
		if($interface<>null){
			if(preg_match("#inet\s+addr:([0-9\.]+)\s+Bcast:#",$ligne,$re)){
				$ipaddr=$re[1];
				break;
			}
			
		}
		
	}
	
	return array("NIC"=>$interface,"MAC"=>$MAC,"IP"=>$ipaddr);
	
}




function ucarp_start(){
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".".__FUNCTION__.".pid";
	$unix=new unix();
	$sock=new sockets();
	$pid=$unix->get_pid_from_file($pidfile);
	if($unix->process_exists($pid,basename(__FILE__))){
		echo "Starting......: ".date("H:i:s")." UCARP Start task already running PID: $pid\n";
		return;
	}
	@file_put_contents($pidfile, getmypid());

	$users=new settings_inc();
	if(!$GLOBALS["CLASS_SOCKETS"]->CORP_LICENSE()){echo "Starting......: ".date("H:i:s")." UCARP No license set, aborting...\n";return;}
	$ucarp_bin=$unix->find_program("ucarp");
	if(!is_file($ucarp_bin)){echo "Starting......: ".date("H:i:s")." UCARP Not installed...\n";return;}
	
	
	if(is_file("/etc/network/if-up.d/ucarp")){
		if(!is_file("/usr/share/ucarp/ETH_LIST")){
			if(!$GLOBALS["AFTER_REBUILD"]){ucarp_build(true);}
			return;
		}
	}
	if(!is_file("/usr/share/ucarp/ETH_LIST")){echo "Starting......: ".date("H:i:s")." UCARP Not configured, Apply network parameters first (1)...\n";return;}
	$ETHS=unserialize(@file_get_contents("/usr/share/ucarp/ETH_LIST"));
	if(!is_array($ETHS)){
		echo "Starting......: ".date("H:i:s")." UCARP Not configured (2 not an array), Apply network parameters first...\n";
		return;
	}
	if(count($ETHS)==0){echo "Starting......: ".date("H:i:s")." UCARP Not configured (3)...\n";return;}
	
	while (list ($eth, $ucarpcmdLINE) = each ($ETHS) ){
		$pid=ucarp_pid($eth);
		if($unix->process_exists($pid)){
			echo "Starting......: ".date("H:i:s")." UCARP `$eth` already running pid $pid\n";
			if(ucarp_eth_ucarped($eth)){echo "Starting......: ".date("H:i:s")." UCARP `$eth` alreaded linked\n";continue;}
			shell_exec("/usr/share/ucarp/vip-$eth-up.sh");
			continue;
		}
		
		shell_exec($ucarpcmdLINE);
		sleep(1);
		$pid=ucarp_pid($eth);
		echo "Starting......: ".date("H:i:s")." UCARP `$eth` PID:$pid\n";
		if(!$unix->process_exists($pid)){
			system_failover_events("Fatal:<br>Unable to start daemon for $eth",__FUNCTION__,basename(__FILE__),__LINE__);
			echo "Starting......: ".date("H:i:s")." UCARP `$eth` failed `$ucarpcmdLINE`\n";continue;}
		if(!ucarp_eth_ucarped($eth)){
			system_failover_events("Daemon:<br>`$eth` linking to network",__FUNCTION__,basename(__FILE__),__LINE__);
			echo "Starting......: ".date("H:i:s")." UCARP `$eth` linking to network...\n";
			shell_exec("/usr/share/ucarp/vip-$eth-up.sh");
			echo "Starting......: ".date("H:i:s")." UCARP `$eth` linking to network success...\n";
		}
	}
	
}

function IPTABLES_NETWORK_BRIDGES(){
	$unix=new unix();
	
	$iptables=$unix->find_program("iptables");
	$echo=$unix->find_program("echo");
	$php=$unix->LOCATE_PHP5_BIN();
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."] ****    BRIDGES     ****";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."] Removing old rules";
	$GLOBALS["SCRIPTS"][]="$php /usr/share/artica-postfix/exec.remove.iptablesbridges.php";
	
	
	
	$q=new lib_sqlite("/home/artica/SQLITE/firewall.db");
	if(!$q->TABLE_EXISTS("pnic_bridges")){
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] Table pnic_bridges no such table";
		$GLOBALS["SCRIPTS"][]="# Enable TimeStamps";
		$GLOBALS["SCRIPTS"][]="$echo 1 > /proc/sys/net/ipv4/tcp_timestamps";		
		return;
	}
	
	
	
	$sql="SELECT * FROM `pnic_bridges` WHERE `enabled`=1";
	$results = $q->QUERY_SQL($sql);
	
	if(!$q->ok){
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] MySQL Error $sql $q->mysql_error";
		$GLOBALS["SCRIPTS"][]="# Enable TimeStamps";
		$GLOBALS["SCRIPTS"][]="$echo 1 > /proc/sys/net/ipv4/tcp_timestamps";
		return;		
		
	}
	
	if(count($results)==0){
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] No rule set in `pnic_bridges` table";
		$GLOBALS["SCRIPTS"][]="# Enable TimeStamps";
		$GLOBALS["SCRIPTS"][]="$echo 1 > /proc/sys/net/ipv4/tcp_timestamps";
		
		return;
	}
	

	$NetBuilder=new system_nic();
	$comment=" -m comment --comment \"ArticaNetworkBridges\"";
	
	$GLOBALS["SCRIPTS"][]="# Disabling TimeStamps and enable forward packets";
	$GLOBALS["SCRIPTS"][]="$echo 1 > /etc/artica-postfix/IPTABLES_BRIDGE";
	

	
}


function ucarp_eth_ucarped($eth){
	if(!isset($GLOBALS["ucarp_eth_ucarped"])){
		$unix=new unix();
		$ip=$unix->find_program("ip");
		exec("$ip addr 2>&1",$GLOBALS["ucarp_eth_ucarped"]);
	}
	reset($GLOBALS["ucarp_eth_ucarped"]);
	while (list ($index, $line) = each ($GLOBALS["ucarp_eth_ucarped"]) ){
		if(preg_match("#inet\s+([0-9\.]+).*?secondary $eth:ucarp#",$line)){
			return true;
		}
		
	}
	return false;
	
}



function ucarp_pid($eth=null){
	$unix=new unix();
	$ucarp_bin=$unix->find_program("ucarp");
	if($eth<>null){$eth=".*?--interface=$eth";}
	return $unix->PIDOF_PATTERN("$ucarp_bin$eth");
	
}
function ucarp_all_pid($eth=null){
	$unix=new unix();
	$ucarp_bin=$unix->find_program("ucarp");
	if($eth<>null){$eth=".*?--interface=$eth";}
	return $unix->PIDOF_PATTERN_ALL("$ucarp_bin$eth");

}

function reconstruct_interface($eth){
	$GLOBALS["NO_GLOBAL_RELOAD"]=true;
	if($GLOBALS["SLEEP"]){sleep(10);}
	build();
	ifupifdown($eth);
}

function events($text,$function=null,$line=null){
	$unix=new unix();
	
	if(function_exists("debug_backtrace")){
		$trace=debug_backtrace();
		if(isset($trace[1])){
			$sourcefile=basename($trace[1]["file"]);
			if($function==null){$function=$trace[1]["function"];}
			if($line==null){$line=$trace[1]["line"];}
		}
			
	}
	
	
	$unix->events($text,"/var/log/artica-network.log",false,$function,$line);
	
	
}
function event($text,$function=null,$line=null){events($text,$function,$line);}


function LoadProcNetDev(){
	$unix=new unix();
	$eth0Found=false;

	
	
	$dhclient=$unix->find_program("dhclient");
	$datas=explode("\n",@file_get_contents("/proc/net/dev"));
	foreach ( $datas as $num=>$line ){
		if(preg_match("#^(.+?):#",$line,$re)){
			$re[1]=trim($re[1]);
			if(preg_match("#^(sit|dummy|wccp|tunl|tun|ifb|gretap|gre|ip6tnl|teql|bond|eno)[0-9]+#",$re[1])){continue;}
			
			
			$GLOBALS["SCRIPTS_TOP"][]="# [LoadProcNetDev/".__LINE__."] Found Network Interface <{$re[1]}>";
			if($GLOBALS["FIRST_TIME"]){
				if($re[1]=="eth0"){$eth0Found=true;}
				
				if($re[1]<>"lo"){
					$GLOBALS["SCRIPTS_TOP"][]="$dhclient -4 {$re[1]}";
				}
			}
			$GLOBALS["PROC_NET_DEV"][$re[1]]=true;
		}
	}

	if($GLOBALS["FIRST_TIME"]){
		if(!$eth0Found){
			$GLOBALS["SCRIPTS_TOP"][]="$dhclient -4 eth0";
		}
	}
}


function build(){
	$unix=new unix();
	$q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");
	$hostname_bin=$unix->find_program("hostname");
	$php5=$unix->LOCATE_PHP5_BIN();
	$sock=new sockets();
	$Myhostname=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("myhostname"));
	$oom_kill_allocating_task=$sock->GET_INFO("oom_kill_allocating_task");
	if(!is_numeric($oom_kill_allocating_task)){$oom_kill_allocating_task=1;}
	$pidfile="/etc/artica-postfix/pids/".basename(__FILE__).".pid";
	$pid=@file_get_contents($pidfile);
	$sysctl=$unix->find_program("sysctl");
	$ifconfig=$unix->find_program("ifconfig");
	$GLOBALS["ipbin"]=$unix->find_program("ip");
	$GLOBALS["SCRIPTS_DOWN"]=array();
	$rm=$unix->find_program("rm");
    DHCP_SCRIPTS();
	
	if($GLOBALS["FIRST_TIME"]){
		if(is_file("/etc/artica-postfix/settings/Daemons/NetworksConfiguredFirstTime")){$GLOBALS["FIRST_TIME"]=false;}
	}
	
	
	if($unix->process_exists($pid,basename(__FILE__))){
		
		echo "Starting......: ".date("H:i:s")." Building networks already executed PID: $pid\n";
		echo "*******************************************************************************\n";
		echo @file_get_contents("/proc/$pid/cmdline")."\n";
		echo "*******************************************************************************\n";
		
	}	
	$fqdn=@file_get_contents("/etc/artica-postfix/FULL_HOSTNAME");
	
	if(is_file("/etc/init.d/hostname.sh")){
		if(is_file("/usr/sbin/update-rc.d")){
			shell_exec("/usr/sbin/update-rc.d -f hostname remove >/dev/null 2>&1");
			@unlink("/etc/init.d/hostname.sh");
		}
		
	}
	
	if(is_dir("/etc/artica-postfix/nics-watchdog")){
		shell_exec("$rm -rf /etc/artica-postfix/nics-watchdog");
	}
	
	
	$zA=array();
	$sql="SELECT Interface,watchdog FROM nics WHERE enabled=1";
	$results2=$q->QUERY_SQL($sql);
	echo "Starting......: ".date("H:i:s")." ".count($results2)." Interface(s)\n";
	
	if(!$GLOBALS["FIRST_TIME"]){
		if(!$q->ok){
			echo "***************************************************************************\n";
			echo $q->mysql_error."\n";
			build_progress(110, "{checking} MySQL error!");
			echo "***************************************************************************\n";
			exit();
		}
	}

	$rm=$unix->find_program("rm");
	foreach ($results2 as $index=>$ligne){
		$Interface=$ligne["Interface"];
		echo "Starting......: ".date("H:i:s")." CheckRoutesRules For $Interface\n";
		CheckRoutesRules($Interface);
		$watchdog=intval($ligne["watchdog"]);
		build_progress(20, "{checking} $Interface Watchdog  = $watchdog");
		if($watchdog==0){
			if(is_dir("/etc/artica-postfix/nics-watchdog/$Interface")){shell_exec("$rm -rf /etc/artica-postfix/nics-watchdog/$Interface");}
			continue;
		}
		@mkdir("/etc/artica-postfix/nics-watchdog/$Interface",0755,true);
		$zA[]=$Interface;
		$sql="SELECT * FROM nics WHERE Interface='$Interface'";
		$ligne2=$q->mysqli_fetch_array($sql);

		while (list ($a, $b) = each ($ligne2) ){
			if(is_numeric($a)){continue;}
			@file_put_contents("/etc/artica-postfix/nics-watchdog/$Interface/$a", $b);
		}
	}
	
	
	
	if(count($zA)>0){
		@file_put_contents("/etc/artica-postfix/nics-watchdog/Interfaces.array", @implode("\n", $zA)."\n");
	}
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("WatchdogInterfacesCount", 0);
	
	if($oom_kill_allocating_task==1){
		echo "Starting......: ".date("H:i:s")." Kernel oom_kill_allocating_task is enabled\n";
		shell_exec("$sysctl -w \"vm.oom_dump_tasks=1\" >/dev/null 2>&1");
		shell_exec("$sysctl -w \"vm.oom_kill_allocating_task=1\" >/dev/null 2>&1");
		
	}else{
		echo "Starting......: ".date("H:i:s")." Kernel oom_kill_allocating_task is disabled\n";
		shell_exec("$sysctl -w \"vm.oom_dump_tasks=0\" >/dev/null 2>&1");
		shell_exec("$sysctl -w \"vm.oom_kill_allocating_task=0\" >/dev/null 2>&1");		
	}
	
	if($GLOBALS["VERBOSE"]){echo "Line:".__LINE__." persistent_net_rules()\n";}
	
	persistent_net_rules();
	if($GLOBALS["VERBOSE"]){echo "Line:".__LINE__." dev_shm()\n";}
	dev_shm();
	$ip=$unix->find_program("ip");
	$echobin=$unix->find_program("echo");
	$logger=$unix->find_program("logger");
	$IPROUTEFOUND=false;
	$results=array();
	exec("$ip route",$results);
	events("IP route -> ".count($results)." lines",__FUNCTION__,__LINE__);
	
	foreach ($results as $index=>$line){
		events("IP route -> $line",__FUNCTION__,__LINE__);
	
		if(preg_match("#default via#", $line)){
			events("IP route found default via -> $line",__FUNCTION__,__LINE__);
			$IPROUTEFOUND=true;
		}
		
	}
	
	if(!$IPROUTEFOUND){@unlink("/etc/artica-postfix/MEM_INTERFACES");}
	
	if(is_file("/etc/artica-postfix/MEM_INTERFACES")){
		$MEM_INTERFACES=unserialize(@file_get_contents("/etc/artica-postfix/MEM_INTERFACES"));
	}
	
	if($GLOBALS["VERBOSE"]){echo "Line:".__LINE__." MEM_INTERFACES()\n";}
	$EXECUTE_CMDS=true;
	
	
	if(is_array($MEM_INTERFACES)){
		$EXECUTE_CMDS=false;
		if($GLOBALS["VERBOSE"]){echo "Line:".__LINE__." NETWORK_ALL_INTERFACES()\n";}
		$array=$unix->NETWORK_ALL_INTERFACES();
		while (list ($Interface, $ipaddr) = each ($MEM_INTERFACES) ){
			if($ipaddr==null){continue;}
			build_progress(30, "{checking} $Interface ($ipaddr)");
			if($GLOBALS["VERBOSE"]){echo "Line:".__LINE__." $Interface Must be $ipaddr -> {$array[$Interface]["IPADDR"]}\n";}
			events("$Interface Must be $ipaddr -> {$array[$Interface]["IPADDR"]}",__FUNCTION__,__LINE__);
			if($ipaddr<>$array[$Interface]["IPADDR"]){
				events("Must rebuilded....",__FUNCTION__,__LINE__);
				$EXECUTE_CMDS=true;
				break;
			}
		}
	}
	
		
	if(!$q->TABLE_EXISTS("nics")){
		echo "Starting......: ".date("H:i:s")." Building networks MySQL table is not yet builded..\n";
		build_progress(110, "{checking} MySQL ({failed})");
		exit();
	}
	

	$GLOBALS["SAVED_INTERFACES"]=array();
	Checkipv6();
	@file_put_contents($pidfile,getmypid());

	
	build_progress(40, "{checking} bridges");
	echo "Starting......: ".date("H:i:s")." Building networks checking bridge\n";
	bridges_build();
	echo "Starting......: ".date("H:i:s")." Building networks checking IPV6\n";
	build_progress(50, "{checking} IPV6");
	Checkipv6();
	build_progress(50, "{checking} Construct Interfaces");
	$nic=new system_nic();
	$nic->root_build_debian_config(true);
	build_progress(50, "{checking} Reloading ". count($GLOBALS["SAVED_INTERFACES"])." interface(s)");
	echo "Starting......: ".date("H:i:s")." Building networks Reloading ". count($GLOBALS["SAVED_INTERFACES"])." interface(s)\n";
	
	
	
	if(count($GLOBALS["SAVED_INTERFACES"])==0){
		echo "Starting......: ".date("H:i:s")." Building networks Building Ipv6 virtuals IP...\n";
		Checkipv6Virts();
	}
	
	$EXECUTE_CMDS=false;
	
	
	
	if(is_file("/etc/init.d/hostname.sh")){
		if(is_file("/usr/sbin/update-rc.d")){
			shell_exec("/usr/sbin/update-rc.d -f hostname remove >/dev/null 2>&1");
			@unlink("/etc/init.d/hostname.sh");
		}
	
	}
	
	LoadProcNetDev();
	$GLOBALS["SCRIPTS_TOP"][]="# [".__LINE__."]";
	$GLOBALS["SCRIPTS_TOP"][]="# [".__LINE__."] *******************************";
	$GLOBALS["SCRIPTS_TOP"][]="# [".__LINE__."] **** SETTINGS for LOOP BACK ***";
	$GLOBALS["SCRIPTS_TOP"][]="# [".__LINE__."] *******************************";
	$GLOBALS["SCRIPTS_TOP"][]="# [".__LINE__."]";	
	
	$ModeProbeAlx=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ModeProbeAlx"));
	$GLOBALS["SCRIPTS_TOP"][]="# [".__LINE__."] ALX driver: $ModeProbeAlx";
	if($ModeProbeAlx==1){
		$modprobe=$unix->find_program("modprobe");
		$GLOBALS["SCRIPTS_TOP"][]="$modprobe alx";
		
	}
	
	$GLOBALS["SCRIPTS_TOP"][]="$ifconfig lo 127.0.0.1 up";
	if($Myhostname<>null){$GLOBALS["SCRIPTS_TOP"][]="$hostname_bin \"$Myhostname\"";}
	$GLOBALS["SCRIPTS_TOP"][]="# [".__LINE__."]";
	$datas=$nic->networks_disabled();
	

	$nohup=$unix->find_program("nohup");
	
	$sh=array();
	$sh[]="#!/bin/sh -e";
	$sh[]="### BEGIN INIT INFO";
	$sh[]="# Builded on ". date("Y-m-d H:i:s");
	$sh[]="# Provides:          artica-ifup";
	$sh[]="# Required-Start:    mountkernfs \$local_fs urandom";
	$sh[]="# Required-Stop:     \$local_fs";
	$sh[]="# Should-Start:		";
	$sh[]="# Should-Stop:		";
	$sh[]="# Default-Start:     2 3 4 5";
	$sh[]="# Default-Stop:      0 6";
	$sh[]="# Short-Description: start and stop the network";
	$sh[]="# Description:       Artica ifup service Raise network interfaces";
	$sh[]="### END INIT INFO";
	$sh[]="case \"\$1\" in";
	$sh[]="start)";
	$sh[]="$logger \"kernel: [  Artica-Net] Artica network Script executed (start)\" || true";
	$mkdir=$unix->find_program("mkdir");
	$sh[]="mkdir -p /run/network >/dev/null 2>&1";
	$sh[]="$php5 /usr/share/artica-postfix/exec.virtuals-ip-notify.php --start $2 $3 || true";
	
	
	build_progress(55, "{checking} /etc/hosts");
	etc_hosts();
	build_progress(60, "{checking} {routes}");
	routes_main();
	build_progress(65, "{checking} UCARP");
	ucarp_build(true);
	build_progress(70, "{checking} Bridges");
	bridges_build();
	build_progress(75, "{checking} Network Bridges");
	IPTABLES_NETWORK_BRIDGES();
	build_progress(76, "{checking} DHCP Clients");
	dhcp_client();
    build_progress(76, "{checking} WIFI...");
    Check_wifi_cards();
    monit_interfaces();
	
	
	$sh[]="$echobin \"\" > /var/log/net-start.log";
	$sh[]="$echobin \"  **** Apply Network configuration, please wait... ****\"";
	
	while (list ($index, $line) = each ($GLOBALS["SCRIPTS_TOP"]) ){
		$line=trim($line);
		if($line==null){continue;}
		if(substr($line, 0,1)=="#"){$sh[]=ScriptInfo($line);continue;}
		$md=md5($line);
		if(isset($AL[$md])){
			echo "Starting......: ".date("H:i:s")." SKIPING `$line`\n";
			continue;
		}
		$AL[$md]=true;
		echo "Starting......: ".date("H:i:s")." `$line`\n";
		
		if(strpos($line, "/etc/hosts")>0){
			$sh[]="$line";
			continue;
		}
		
		if(preg_match("#ifconfig\s+(.+?)\s+(.+?)netmask(.+?)\s+#", $line,$re)){
			$sh[]="$echobin \"adding {$re[2]}/{$re[3]} in {$re[1]} interface\"";
				
		}
		
		$sh[]="$echobin \"$line\" >>/var/log/net-start.log 2>&1";
		$sh[]="$line >>/var/log/net-start.log 2>&1 || true";	
		
	}

    foreach ($GLOBALS["SCRIPTS"] as $line){
			$line=trim($line);
			if($line==null){continue;}
			if(substr($line, 0,1)=="#"){$sh[]=ScriptInfo($line);continue;}
			
			if(preg_match("#^OUTPUT\s+(.+)#",$line,$re)){
                $re[1]=str_replace('"' ,"'", $re[1]);
				$sh[]="$echobin \"{$re[1]}\"";
				continue;
			}
				
			
			
			$md=md5($line);
			if(isset($AL[$md])){
				echo "Starting......: ".date("H:i:s")." SKIPING `$line`\n";
				continue;
			}
			$AL[$md]=true;		
			echo "Starting......: ".date("H:i:s")." `$line`\n";
			
			if(strpos($line, "/etc/hosts")>0){
				$sh[]="$line";
				continue;
			}			
		
		
		if(preg_match("#ifconfig\s+(.+?)\s+(.+?)netmask(.+?)\s+#", $line,$re)){
			$sh[]="$echobin \"adding {$re[2]}/{$re[3]} in {$re[1]} interface\"";
			
		}	
			
		if(strpos('echo "', $line)==0){
			$sh[]="$echobin \"$line\" >>/var/log/net-start.log 2>&1";
		}
		$sh[]="$line >>/var/log/net-start.log 2>&1 || true"; 
	}
	
	
	$cmdlines=unserialize($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EthtoolsCommands"));
	if(is_array($cmdlines)){
		if(count($cmdlines)>0){
			$sh[]="";
			$sh[]="# [".__LINE__."]";
			$sh[]="# [".__LINE__."] *******************************";
			$sh[]="# [".__LINE__."] ****     ETH TOOLS    ****";
			$sh[]="# [".__LINE__."] *******************************";
			$sh[]="# [".__LINE__."] See /etc/artica-postfix/settings/Daemons/EthtoolsCommands";
			$sh[]="# [".__LINE__."]";
			foreach ($cmdlines as $line){
				$sh[]="$index >>/var/log/net-start.log 2>&1 || true";
			}
		}
	}

    $NetworkAdvancedRouting=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("NetworkAdvancedRouting"));
	if($NetworkAdvancedRouting==0){ BUILD_SIMPLE_ROUTES();}
	
	if(count($GLOBALS["SCRIPTS_ROUTES"])>0){
		$GLOBALS["START_ROUTES"][]="$echobin \"Apply network routes, please wait...\"";
		$sh[]="";
		$sh[]="# [".__LINE__."]";
		$sh[]="# [".__LINE__."] *******************************";
		$sh[]="# [".__LINE__."] ****     NETWORK ROUTES    ****";
		$sh[]="# [".__LINE__."] *******************************";
		$sh[]="# [".__LINE__."]";


        foreach ($GLOBALS["SCRIPTS_ROUTES"] as $line){
			$line=trim($line);
			if($line==null){continue;}
			if(substr($line, 0,1)=="#"){
				$ScriptInfo=ScriptInfo($line);
				$sh[]=$ScriptInfo;
				$GLOBALS["START_ROUTES"][]=$ScriptInfo;
				continue;
			}
			$md=md5($line);
			
			
			if(isset($AL[$md])){
				if(!preg_match("#^force#", $line)){
					echo "Starting......: ".date("H:i:s")." SKIPING `$line`\n";
					continue;
				}
			}
			
			if(preg_match("#^force:(.+)#", $line,$re)){$line=$re[1];$md=md5($line);}
			
			$AL[$md]=true;
			
			
			if(preg_match("#ip route add (.+?)\s+.*?src\s+(.+)#",$line,$re)){
				$GLOBALS["START_ROUTES"][]="$echobin \"Create route for network {$re[1]} for local address {$re[2]}\"";
				$sh[]="$echobin \"Create route for network {$re[1]} for local address {$re[2]}\"";
			}
			
			if(preg_match("#ip route add (.+?)\s+via(.+?)\s+src\s+([0-9\.]+)#",$line,$re)){
				$GLOBALS["START_ROUTES"][]="$echobin \"Create route for network {$re[1]} using gateway {$re[2]} for local address {$re[3]}\"";
				$sh[]="$echobin \"Create route for network {$re[1]} using gateway {$re[2]} for local address {$re[3]}\"";
			}
	
			$GLOBALS["START_ROUTES"][]="$echobin \"$line\" >>/var/log/net-start.log 2>&1";
			$sh[]="$echobin \"$line\" >>/var/log/net-start.log 2>&1";
			if(preg_match("#\/echo\s+#", $line)){$sh[]=$line;continue;}
			$sh[]="$line >>/var/log/net-start.log 2>&1 || true";
			$GLOBALS["START_ROUTES"][]="$line >>/var/log/net-start.log 2>&1 || true";
			
		}	
	
	}


    $sh[]="if [ -x /etc/init.d/artica-ifup-content.sh ] ; then";
    $sh[]="	/etc/init.d/artica-ifup-content.sh || true";
    $sh[]="fi";
	$sh[]="";
		
	$sh[]="if [ -x /usr/local/sbin/vlan-start.sh ] ; then";
	$sh[]="	/usr/local/sbin/vlan-start.sh || true";
	$sh[]="fi";
	$sh[]="";
    $sh[]="chmod 0755 /usr/share/artica-postfix/logon.sh || true";
    $sh[]="";
	
	$sh[]=nics_vde_build();
	$EnablePDNS=intval($sock->GET_INFO("EnablePDNS"));

	$EnableLinkBalancer=intval($sock->GET_INFO("EnableLinkBalancer"));

	$unix=new unix();

	$ip=$unix->find_program("ip");
	$echo=$unix->find_program("echo");
	$nohup=$unix->find_program("nohup");
	$monit=$unix->find_program("monit");
	$ifconfig=$unix->find_program("ifconfig");
	$php=$unix->LOCATE_PHP5_BIN();

	if(is_file("/etc/init.d/firehol")) {
        system("$php /usr/share/artica-postfix/exec.firehol.php --build");
    }

	if($EnableLinkBalancer==1){
	    if(!is_dir("/etc/firehol")){@mkdir("/etc/firehol",0755,true);}
        system("$php /usr/share/artica-postfix/exec.firehol.php --configure-lb");
        $linkbalancerbin=$unix->find_program("link-balancer");
        $sh[]="# [".__LINE__."] Running Link-balancer";
        $sh[]="if [ -x /etc/firehol/link-balancer.conf ] ; then";
        $sh[]="\t$linkbalancerbin ||true";
        $sh[]="fi";
    }

	$sh[]="if [ -x /etc/init.d/squid ] ; then";
	$sh[]="# [".__LINE__."] Reloading squid";
	$sh[]="\t$echo \"Reloading Proxy service\"";
	$sh[]="\t$nohup $php /usr/share/artica-postfix/exec.squid.php --kreconfigure 2>&1 >>/var/log/net-start.log 2>&1 &";
	$sh[]="fi";

    $sh[]="if [ -x /etc/init.d/dnscatz ] ; then";
    $sh[]="# [".__LINE__."] Reloading Categories service";
    $sh[]="\t$echo \"Reloading Categories service\"";
    $sh[]="\t$nohup $php /usr/share/artica-postfix/exec.dnscat.php --restart 2>&1 >>/var/log/net-start.log 2>&1 &";
    $sh[]="fi";

    $sh[]="if [ -x /etc/init.d/ssh ] ; then";
    $sh[]="# [".__LINE__."] Reloading SSH service";
    $sh[]="\t$echo \"Reloading SSH service\"";
    $sh[]="\t$nohup /etc/init.d/ssh restart 2>&1 >>/var/log/net-start.log 2>&1 &";
    $sh[]="fi";





    $sh[]="";
    $sh[]="";
	$sh[]="# [".__LINE__."] Flushing ARP cache";
	$sh[]="$echo \"Flushing ARP cache...\"";
	$sh[]="ip -s -s neigh flush all >>/var/log/net-start.log 2>&1 || true";
	
	$sh[]="# [".__LINE__."] Tune the kernel";
	$sh[]="$echo \"Tuning the kernel...\"";
	$sh[]="$php5 /usr/share/artica-postfix/exec.sysctl.php --build >>/var/log/net-start.log 2>&1 || true";
	$sh[]="if [ -x /bin/artica-firewall.sh ] ; then";
	$sh[]="	/bin/artica-firewall.sh || true";
	$sh[]="fi";
    $sh[]="";
    $sh[]="";

    $sh[]="if [ -x /etc/init.d/firehol ] ; then";
    $sh[]="# [".__LINE__."] Starting firehol";
    $sh[]="$echo \"Starting Firehol\"";
    $sh[]="/etc/init.d/firehol start 2>&1 || true";
    $sh[]="fi";
    $sh[]="";
	
	$sh[]="if [ -x /etc/init.d/ssh ] ; then";
	$sh[]="# [".__LINE__."] Starting sshd";
	$sh[]="$echo \"Restarting sshd\"";
	$sh[]="/etc/init.d/ssh restart 2>&1 || true";
    $sh[]="fi";
    $sh[]="";

	$sh[]="# [".__LINE__."] Starting FrameWork";
	$sh[]="$echo \"Starting FrameWork\"";
	$UseUnitd=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UseUnitd"));
	if($UseUnitd==0){$sh[]="$nohup $php5 /usr/share/artica-postfix/exec.framework.php --start >/dev/null 2>&1 &";}
	if($UseUnitd==1){$sh[]="$nohup $php5 /usr/share/artica-postfix/exec.unitd.php --start >/dev/null 2>&1 &";}
	
	$sh[]="# [".__LINE__."] Starting Meta Server Client";
	$sh[]="$echo \"Starting FrameWork\"";
	$sh[]="$nohup $php5 /usr/share/artica-postfix/exec.artica-meta-client.php --ping --force >/dev/null 2>&1 &";
	
	
	if($EnablePDNS==1){
		$sh[]="# [".__LINE__."] Reloading PowerDNS...";
		$sh[]="$echo \"Reloading PowerDNS\"";
		$sh[]="$php5 /usr/share/artica-postfix/exec.pdns.php --reload 2>&1 || true";
	}
	
	if(is_file($monit)){
		$sh[]="# [".__LINE__."] Starting Monit in background";
		$sh[]="$echo \"Starting Monit in background\"";
		$sh[]="$nohup $monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid -s /var/run/monit/monit.state >/dev/null 2>&1 &";		
		
	}
	$mount=$unix->find_program("mount");
	if(is_file($mount)){
		$sh[]="# [".__LINE__."] Mount all system after network set";
		$sh[]="$echo \"Starting mount in background\"";
		$sh[]="$nohup $mount -a >/dev/null 2>&1 &";
	}
	
	$sh[]="if [ -x /bin/iptables-iproute2.sh ] ; then";
	$sh[]="	/bin/iptables-iproute2.sh || true";
	$sh[]="fi";
	
	
	
	
	
	
	$sh[]="# [".__LINE__."] Reloading DHCPD (if exists)";
	$sh[]="$echo \"Reloading DHCP server ( if exists )\"";
	$sh[]="$php5 /usr/share/artica-postfix/exec.dhcpd.compile.php --reload-if-run 2>&1 || true";
	$sh[]="$php5 /usr/share/artica-postfix/exec.firehol.routing.php >> /var/log/net-start.log 2>&1";
	$sh[]="$echo \"  ****      Apply Network configuration, done      ****\"";
	$sh[]=";;";
	$sh[]="  stop)";
	$sh[]="$logger \"* * * * * * * * * * * * * * SUSPECTED STOPPED SERVER !!! * * * * * * * * * * * * * *\" || true";
	$sh[]="$logger \"kernel: [  Artica-Net] Artica network Script executed (stop)\" || true";
	if(is_array($GLOBALS["SCRIPTS_DOWN"])){
		while (list ($index, $line) = each ($GLOBALS["SCRIPTS_DOWN"]) ){	
			if(substr($line, 0,1)=="#"){$sh[]=ScriptInfo($line);continue;}
			$sh[]="$line >>/var/log/net-stop.log 2>&1 || true";
			
		}
	}

	
	$php=$unix->LOCATE_PHP5_BIN();
	$sh[]=";;";	
	$sh[]="reconfigure)";
	$sh[]="$logger \"kernel: [  Artica-Net] Artica network Script Executed (reconfigure)\" || true";
	$sh[]="$php ".__FILE__." --build --force $2 $3";
	$sh[]="/etc/init.d/artica-ifup start";
	$sh[]=";;";
	$sh[]="routes)";
	$sh[]="$logger \"kernel: [  Artica-Net] Artica network Script Executed (routes)\" || true";
	$sh[]="# Array of ".count($GLOBALS["START_ROUTES"]);
	$sh[]="$echobin \"Flushing routes tables...\"";
	$sh[]="{$GLOBALS["ipbin"]} route flush table all";
	$sh[]="$echobin \"$ifconfig lo 127.0.0.1 down\"";
	$sh[]="$ifconfig lo 127.0.0.1 down || true";
	$sh[]="$echobin \"$ifconfig lo 127.0.0.1 up\"";
	$sh[]="$ifconfig lo 127.0.0.1 up || true";
	$sh[]="$echobin \"Apply routes to the system\"";
	$sh[]="$echobin \"Running routes\" > /var/log/net-start.log 2>&1";
	$sh[]=@implode("\n", $GLOBALS["START_ROUTES"]);
	$sh[]="$echobin \"Routes applied to the system\"";
	$sh[]="$php /usr/share/artica-postfix/exec.firehol.routing.php >> /var/log/net-start.log 2>&1";
    $sh[]="$php /usr/share/artica-postfix/exec.squid.wccp.php --configure >> /var/log/net-start.log 2>&1";
	
	
	$sh[]=";;";
	
	
	
	$sh[]="*)";
	$sh[]="$logger \"kernel: [  Artica-Net] Artica network Script executed (unknown)\" || true";
	$sh[]=" echo \"Usage: $0 {start or reconfigure only}\"";
	$sh[]="exit 1";
	$sh[]=";;";
	$sh[]="esac";
	$sh[]="exit 0\n";
	
	if(!is_file("/etc/artica-postfix/settings/Daemons/NetworksConfiguredFirstTime")){
		$GLOBALS["CLASS_SOCKETS"]->SET_INFO("NetworksConfiguredFirstTime", time());
	}
	@file_put_contents("/etc/init.d/artica-ifup", @implode("\n", $sh));
	@chmod("/etc/init.d/artica-ifup",0755);
	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f artica-ifup defaults >/dev/null 2>&1");
		
		if(is_file('/etc/init.d/networking')){
			shell_exec("/usr/sbin/update-rc.d -f networking disable  >/dev/null 2>&1"); 
			@copy("/etc/init.d/networking","/etc/init.d/networking.back");
			@unlink("/etc/init.d/networking");
		}
	}
	
	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --add artica-ifup >/dev/null 2>&1");
		shell_exec("/sbin/chkconfig --level 1234 artica-ifup on >/dev/null 2>&1");
	}
	
	if(is_file("/bin/iptables-iproute2.sh")){@unlink("/bin/iptables-iproute2.sh");}
	
	if(isset($GLOBALS["SCRIPTS_IPTABLES"])){
		$sh_iptables[]="#!/bin/sh -e";
		$sh_iptables[]=@implode("\n", $GLOBALS["SCRIPTS_IPTABLES"]);
		$sh_iptables[]="";
		@file_put_contents("/bin/iptables-iproute2.sh", @implode("\n", $sh_iptables));
		@chmod("/bin/iptables-iproute2.sh",0755);
	}

	
	$inter[]="# This file describes the network interfaces available on your system";
	$inter[]="## and how to activate them. For more information, see interfaces(5).";
	$inter[]="";
	$inter[]="## The loopback network interface";
	$inter[]="auto lo";
	$inter[]="iface lo inet loopback";
	$inter[]="";
	$inter[]="";
	if(is_file("/etc/network/interfaces")){ @file_put_contents("/etc/network/interfaces", @implode("\n", $inter)); }
	
	squid_admin_mysql(2, "Network script was successfully rebuilded", null,__FILE__,__LINE__);
	
	echo "Starting......: ".date("H:i:s")." Building FireWall rules.\n";
	
	
	

	$FireHolEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("FireHolEnable"));

	if($FireHolEnable==1){
		build_progress(80, "{checking} {firewall}");
		system("$php5 /usr/share/artica-postfix/exec.firehol.php --build");
	}
	echo "Starting......: ".date("H:i:s")." done...\n";
	
	
}

function BuildNetWorksDebian(){
	if(!is_file("/etc/network/interfaces")){return;}
	
	
	
	
	echo "Starting......: ".date("H:i:s")." Building networks mode Debian\n";
	$nic=new system_nic();
	
	$datas=$nic->root_build_debian_config();
	if($datas==null){
		events("Not yet configured");
		echo "Starting......: ".date("H:i:s")." Not yet configured\n";
		return;
	}
	
	echo "Starting......: ".date("H:i:s")." ". strlen($datas)." bytes length\n";
	bridges_build();
	$unix=new unix();
	$unix->THREAD_COMMAND_SET($unix->LOCATE_PHP5_BIN()." /usr/share/artica-postfix/exec.ip-rotator.php --build");
	
	}

function BuildNetWorksRedhat(){
	
	echo "Starting......: ".date("H:i:s")." Building networks mode RedHat\n";
	$nic=new system_nic();
	$datas=$nic->root_build_redhat_config();
	bridges_build();
	$unix=new unix();
	$unix->THREAD_COMMAND_SET($unix->LOCATE_PHP5_BIN()." /usr/share/artica-postfix/exec.ip-rotator.php --build");
	if(!$GLOBALS["NO_GLOBAL_RELOAD"]){$unix->NETWORK_REDHAT_RESTART();}
	}


function ifconfig_tests(){
	$unix=new unix();
	$cmd=$unix->find_program("ifconfig")." -s";
	exec($cmd,$results);
	foreach ($results as $index=>$line){
		if(preg_match("#^(.+?)\s+[0-9]+#",$line,$re)){
			$array[trim($re[1])]=trim($re[1]);
		}
	}
	print_r($array);
	
}

function nics_vde_build(){
	$unix=new unix();
	$virtualports=$unix->DirFiles("/etc/init.d","virtualport-[0-9]+");
	
	$sh[]="# [".__LINE__."]";
	$sh[]="# [".__LINE__."]";
	$sh[]="# [".__LINE__."] ************************************************";
	$sh[]="# [".__LINE__."] Virtual Network interfaces via virtual SWITCH";
	$sh[]="# [".__LINE__."] ************************************************";
	$sh[]="";

	$c=0;
	foreach ($virtualports as $numFile=>$xfile){
        $c++;
	    $sh[]="/etc/init.d/$numFile restart || true";
	}
	$sh[]="";
	$sh[]="";

	if($c==0){return null;}
	return @implode("\n", $sh);
}


	


function bridges_build(){
	if(isset($GLOBALS["bridges_build_executed"])){return;}
	$GLOBALS["bridges_build_executed"]=true;
	$unix=new unix();
	$iptables=$unix->find_program("iptables");
	
	$php5=$unix->LOCATE_PHP5_BIN();
	$iptables_rules=array();
	$sql="SELECT * FROM iptables_bridge ORDER BY ID DESC";
	$q=new lib_sqlite("/home/artica/SQLITE/firewall.db");
	$results=$q->QUERY_SQL($sql);	
	if(!$q->ok){return null;}
	
	$GLOBALS["SCRIPTS"][]="";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."]";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."] ****   Iptables Bridges    ****";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."]";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."]:". mysqli_num_rows($results). " rule(s)";
	$GLOBALS["SCRIPTS"][]="$php5 ". __FILE__." --iptables-bridge-delete";
	if(count($results)==0){return;}
	$sysctl=$unix->find_program("sysctl");
	$GLOBALS["SCRIPTS"][]="$sysctl -w net.ipv4.ip_forward=1";
	
	$NetBuilder=new system_nic();
	$NetBuilder->LoadTools();
	
	foreach ($results as $index=>$ligne){
		if($ligne["nics_virtuals_id"]>0){
			$array_virtual_infos=VirtualNicInfosIPaddr($ligne["nics_virtuals_id"]);
			$nicvirtual=$array_virtual_infos["IPADDR"];
			if($nicvirtual==null){continue;}
			
		}
		
		if($ligne["nic_inbound"]<>null){
			$nicvirtual=$ligne["nic_inbound"];
			$nicvirtual=$NetBuilder->NicToOther($nicvirtual);
		}
		
		$nic_linked=trim($ligne["nic_linked"]);
		if(trim($nic_linked)==null){continue;}
		if(trim($nicvirtual)==null){continue;}
		
		if(preg_match("#(.+?):([0-9]+)#",$nic_linked,$re)){
			$array_virtual_infos=VirtualNicInfosIPaddr($re[2]);
			$nic_linked=$array_virtual_infos["IPADDR"];
		}
		
		$id=$ligne["ID"];
		$nic_linked=$NetBuilder->NicToOther($nic_linked);
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."]: [$id] Virtuals bridge $nicvirtual to $nic_linked";
		$GLOBALS["SCRIPTS"][]="$iptables -A FORWARD -i $nicvirtual -o $nic_linked -m state --state ESTABLISHED,RELATED -j ACCEPT -m comment --comment \"ArticaBridgesVirtual:$id\" 2>&1";
		$GLOBALS["SCRIPTS"][]="$iptables -A FORWARD -i $nicvirtual -o $nic_linked -j ACCEPT -m comment --comment \"ArticaBridgesVirtual:$id\" 2>&1";
		$GLOBALS["SCRIPTS"][]="$iptables -t nat -A POSTROUTING -o $nic_linked -j MASQUERADE	-m comment --comment \"ArticaBridgesVirtual:$id\" 2>&1";	
		
	}

}

function bridges_delete(){
	$unix=new unix();
	echo "Starting......: ".date("H:i:s")." Virtuals bridge Deleting old rules\n";
	$iptables_save=$unix->find_program("iptables-save");
	$iptables_restore=$unix->find_program("iptables-restore");
	$conf=null;
	$cmd="$iptables_save > /etc/artica-postfix/iptables.conf";
	if($GLOBALS["VERBOSE"]){echo "Starting......: ".date("H:i:s")." $cmd\n";}		
	shell_exec($cmd);

	
	$data=file_get_contents("/etc/artica-postfix/iptables.conf");
	$datas=explode("\n",$data);
	$pattern="#.+?ArticaBridgesVirtual#";	
	$count=0;
foreach ($datas as $num=>$ligne){
		if($ligne==null){continue;}
		if(preg_match($pattern,$ligne)){
			if($GLOBALS["VERBOSE"]){echo "Starting......: ".date("H:i:s")." Delete $ligne\n";}		
			$count++;continue;}
			$conf=$conf . $ligne."\n";
		}

file_put_contents("/etc/artica-postfix/iptables.new.conf",$conf);
$cmd="$iptables_restore < /etc/artica-postfix/iptables.new.conf";
if($GLOBALS["VERBOSE"]){echo "Starting......: ".date("H:i:s")." $cmd\n";}
shell_exec("$cmd");
echo "Starting......: ".date("H:i:s")." Virtuals bridge cleaning iptables $count rules\n";	
}


function ifconfig_parse($path=null){
	$unix=new unix();
	print_r($unix->NETWORK_DEBIAN_PARSE_ARRAY($path));
	
}

function iproute_progress($pourc,$text){
	wizard_progress($pourc, $text);
	$echotext=$text;
	echo "Starting......: ".date("H:i:s")." {$pourc}% $echotext\n";
	$cachefile="/usr/share/artica-postfix/ressources/logs/routes.check.progress";
	$array["POURC"]=$pourc;
	$array["TEXT"]=$text;
	@file_put_contents($cachefile, serialize($array));
	@chmod($cachefile,0755);
}


function CheckAllRoutesRules(){
	$q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");
	
	$sql="CREATE TABLE IF NOT EXISTS `routing_rules` (
				  `ID` INTEGER PRIMARY KEY AUTOINCREMENT,
				  `RouteName` varchar(90),
				  `enabled` smallint(1),
				  `nic` varchar(20) )";
	$q->QUERY_SQL($sql);
	
	
	$sql="SELECT Interface,watchdog FROM nics WHERE enabled=1";
	$results2=$q->QUERY_SQL($sql);
	echo "Starting......: ".date("H:i:s")." ".count($results2)." Interface(s)\n";
	$i=30;
	foreach ($results2 as $index=>$ligne){
		iproute_progress($i++,"{verify_routes} {$ligne["Interface"]}");
		$i=CheckRoutesRules($ligne["Interface"],$i);
	}
	iproute_progress(100,"{verify_routes} {done}");
}

function CheckRoutesRules($interface,$i=0){
	if($interface==null){return;}
	$q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");
	
	

	
	$ligne=$q->mysqli_fetch_array("SELECT ID FROM routing_rules WHERE nic='$interface'");
	if(!$q->ok){
		iproute_progress($i++,"MySQL Failed on /home/artica/SQLITE/interfaces.db");
		return;
	}
	
	echo "Starting......: ".date("H:i:s")." $interface routing_rules nic='$interface':{$ligne["ID"]}\n";
	
	if(intval($ligne["ID"])==0){
		
		$RouteName="RouteFor$interface";
		iproute_progress($i++,"{create} $RouteName");
		echo "Starting......: ".date("H:i:s")." $interface Create a new routing rule..$RouteName \n";
		$sql="INSERT INTO routing_rules (`RouteName`,`nic`,`enabled`) VALUES('{$RouteName}','{$interface}',1);";
		$q->QUERY_SQL($sql);
		if(!$q->ok){
			iproute_progress($i++,"MySQL Failed on /home/artica/SQLITE/interfaces.db");
			echo $q->mysql_error."\n";
			return;
		}
		
		$ligne=$q->mysqli_fetch_array("SELECT ID FROM routing_rules WHERE nic='$interface'");
		$ruleid=intval($ligne["ID"]);
		
		if($ruleid>0){
			$nicClass=new system_nic($interface);
			$metric=$ruleid+1;
			echo "Starting......: ".date("H:i:s")." $interface Create a new routing rule..$RouteName/$nicClass->IPADDR ID: $ruleid\n";
			$tr=explode(".",$nicClass->IPADDR);
			unset($tr[3]);
			$ipf=@implode(".", $tr).".0";
			$sql="INSERT INTO routing_rules_dest (`type`,`gateway`,`pattern`,`ruleid`,`nic`,`metric`,`zOrder`) VALUES('1','','$ipf/$nicClass->NETMASK','$ruleid','$interface','$metric','1');";
			$q->QUERY_SQL($sql);
		}
		
		return;
	}
	
	iproute_progress($i++,"{checking} ".__LINE__);
	
	echo "Starting......: ".date("H:i:s")." $interface Checking routing rule {$ligne["ID"]}\n";
	$ruleid=$ligne["ID"];
	$nicClass=new system_nic($interface);
	$tr=explode(".",$nicClass->IPADDR);
	unset($tr[3]);
	$ipf=@implode(".", $tr).".0";
	$ligne=$q->mysqli_fetch_array("SELECT ID FROM routing_rules_dest WHERE nic='$interface' AND `type`=1 AND `pattern`='$ipf/$nicClass->NETMASK'");
	echo "Starting......: ".date("H:i:s")." $interface DESTINATION $ipf/$nicClass->NETMASK --> '{$ligne["ID"]}'\n";
	iproute_progress($i++,"{checking} ".__LINE__);
	
	if(intval($ligne["ID"])==0){
		$metric=$ruleid+1;
		iproute_progress($i++,"{checking} ".__LINE__);
		echo "Starting......: ".date("H:i:s")." $interface - $ipf/$nicClass->NETMASK Create routing rule For $ruleid\n";
		$sql="INSERT INTO routing_rules_dest (`type`,`gateway`,`pattern`,`ruleid`,`nic`,`metric`,`zOrder`,`status`) VALUES('1','','$ipf/$nicClass->NETMASK','$ruleid','$interface','$metric','1',0);";
		$q->QUERY_SQL($sql);
		if(!$q->ok){echo $q->mysql_error."\n";}
	}else{
		iproute_progress($i++,"{checking} ".__LINE__);
		echo "Starting......: ".date("H:i:s")." $interface - $ipf/$nicClass->NETMASK UPDATE routing rule $ruleid/{$ligne["ID"]}\n";
		$subruleid=$ligne["ID"];
		$sql="UPDATE routing_rules_dest SET `pattern`='$ipf/$nicClass->NETMASK',`type`=1 WHERE ID='$subruleid'";
		$q->QUERY_SQL($sql);
		if(!$q->ok){echo $q->mysql_error."\n";}
	}
	iproute_progress($i++,"{checking} ".__LINE__);
	
}

function routes_fromfile(){
	
	if(!is_file("/etc/artica-postfix/ROUTES.CACHES.TABLES")){
		echo "Starting......: ".date("H:i:s")." Building routes, no cache file\n";
		return;
	}
	
	$unix=new unix();
	$route=$unix->find_program("route");
	$ip=$unix->find_program("ip");

	$f=explode("\n",@file_get_contents("/etc/iproute2/rt_tables"));
	while (list ($eth, $ligne) = each ($f) ){
		if(preg_match("#^([0-9]+)\s+(.+)#", $ligne,$re)){
			$tableID=$re[1];
			if($tableID==255){continue;}
			if($tableID==254){continue;}
			if($tableID==253){continue;}
			$array[$tableID]=$re[2];
		}
	
	}
	
	while (list ($id, $ligne) = each ($array) ){
		shell_exec("$ip route flush table $ligne");
	
	}	
	
	
	$array=unserialize("/etc/artica-postfix/ROUTES.CACHES.TABLES");
	$TABLES=$array["TABLES"];
	$NEXT=$array["NEXT"];
	$CMDS=$array["CMDS"];
	
	while (list ($id, $cmdline) = each ($CMDS) ){
		shell_exec($cmdline);
	}
	
	
	$f[]="255\tlocal";
	$f[]="254\tmain";
	$f[]="253\tdefault";
	$f[]="0\tunspec";
	$c=1;
	if(count($TABLES)>0){
		while (list ($id, $ligne) = each ($TABLES) ){
			$f[]="$c\t$ligne";
				
		}
	
	file_put_contents("/etc/iproute2/rt_tables", @implode("\n", $f));
			while (list ($id, $cmdline) = each ($NEXT) ){
				echo "$cmdline\n";
				shell_exec($cmdline);
			}
		}
		reset($TABLES);
		reset($NEXT);
		
	
}


function PARSECDR($pattern){
	if($pattern==null){return;}
	if(strpos($pattern, "/")==0){return $pattern;}
	
	$re=explode("/",$pattern);
	if(strpos($re[1], ".")>0){
		$tcp=new Unixipv4($re[0], $re[1]);
		return $tcp->NetMaskToCdir();
	}
	
	return $pattern;
	
	
}

function routes_main_build(){
	routes();
	routes_main();

	if(count($GLOBALS["SCRIPTS"])==0){echo "No route to build\n";return;}

	foreach ($GLOBALS["SCRIPTS"] as $line){
		$line=trim($line);
		if($line==null){continue;}
		$md=md5($line);
		if(isset($AL[$md])){continue;}
		$AL[$md]=true;
		echo "Starting......: ".date("H:i:s")." `$line`\n";
		system($line);
	}
	
	
	
		
}

function alphaToNum($name){
$array["a"]="11";
$array["b"]="12";	
$array["c"]="13";
$array["d"]="14";
$array["e"]="15";
$array["f"]="16";
$array["g"]="17";
$array["h"]="18";
$array["i"]="19";
$array["j"]=10;
$array["k"]=11;
$array["l"]=12;
$array["m"]=13;
$array["n"]=14;
$array["o"]=15;
$array["p"]=16;
$array["q"]=17;
$array["r"]=18;
$array["s"]=19;
$array["t"]=20;
$array["u"]=21;
$array["v"]=22;
$array["w"]=23;
$array["x"]=24;
$array["y"]=25;
$array["z"]=26;

$lengt=strlen($name);
for ($i = 0; $i < $lengt+1; $i++) {
	if(!isset($name[$i])){continue;}
	$Letter=$name[$i];
	if(is_numeric($Letter)){$tt[]=$Letter;continue;}
	$tt[]=$array[$Letter];
}

	return @implode("", $tt);
}

function isGatewayGood($ipaddr){
	if(trim($ipaddr)==null){return false;}
	if(trim($ipaddr)=="0.0.0.0"){return false;}
	return true;
}


function routing_rules_specifics($ruleid,$nic,$LASTID){
	$GLOBALS["SCRIPTS_ROUTES"][]="#";
	$GLOBALS["SCRIPTS_ROUTES"][]="# routing_rules_specifics $ruleid $nic ($LASTID)";
	$ipclass=new IP();
	$q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");
	if(!isset($GLOBALS["SCRIPTS_ROUTES_RULES"])){$GLOBALS["SCRIPTS_ROUTES_RULES"]=array();}
	$MAINGATEWAY=array();
	$NetBuilder=new system_nic();
	$sql="SELECT * FROM routing_rules_src WHERE ruleid='$ruleid' ORDER BY zOrder";
	$results=$q->QUERY_SQL($sql);
	if(!$q->ok){$GLOBALS["SCRIPTS_ROUTES"][]="# ".$q->mysql_error."!!!";}
	$GLOBALS["SCRIPTS_ROUTES"][]="# routing_rules_src $ruleid -> ". mysqli_num_rows($results)." elements";
	
	foreach ($results as $index=>$ligne){
		$type=intval($ligne["type"]);
		$gateway=trim($ligne["gateway"]);
		$priority=$ligne["metric"];
		$priority_cmd=null;
		if($priority>0){$priority_cmd=" priority $priority";}
		
		
		if($gateway==null){continue;}
        if($gateway=="0.0.0.0"){
            $GLOBALS["SCRIPTS_ROUTES"][]="# routing_rules_src $ruleid `$gateway` Invalid [".__LINE__."]";
            continue;}
		if(!$ipclass->isValid($gateway)){
			$GLOBALS["SCRIPTS_ROUTES"][]="# routing_rules_src $ruleid `$gateway` Invalid [".__LINE__."]";
			continue;
		}
		if($type>2){continue;}
		$MAINGATEWAY[$gateway][$ligne["ID"]]=$ligne["pattern"].$priority_cmd;
		$GLOBALS["routing_rules_src"][$ligne["ID"]]=true;
		
	}
	$EnableIwConfig=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableIwConfig"));
	if(count($MAINGATEWAY)==0){return $LASTID;}

	foreach ($MAINGATEWAY as $gateway=>$array){
		$LASTID++;
		$RouteName="Sub".str_replace(".", "", $gateway)."$nic";
		
		if($EnableIwConfig==0){
			if(preg_match("#^wlan[0-9]+#", $nic)){
				$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."]: $nic Skipped (EnableIwConfig = 0 )";
				continue;
			}
		}
		
		
		if(!isset($GLOBALS["ROUTESNAMES"][$RouteName])){
			$GLOBALS["ROUTESNAMES"][$RouteName]=$LASTID;
			$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["echobin"]} \"$LASTID $RouteName\" >> /etc/iproute2/rt_tables";
			$GLOBALS["SCRIPTS_ROUTES_RULES"][]="{$GLOBALS["ipbin"]} route add default via $gateway dev $nic table $RouteName prio 0 || true";
		}
		
		
		foreach ($array as $ID=>$pattern){
			$GLOBALS["SCRIPTS_ROUTES_RULES"][]="{$GLOBALS["ipbin"]} rule add from $pattern iif $nic lookup $RouteName";
		}
	}
	
	$MAINGATEWAY=array();
    $sql="SELECT * FROM routing_rules_dest WHERE ruleid='$ruleid' ORDER BY zOrder";
	$results=$q->QUERY_SQL($sql);
	foreach ($results as $index=>$ligne){
		$type=intval($ligne["type"]);
		$gateway=trim($ligne["gateway"]);
		$priority=$ligne["metric"];
		$priority_cmd=null;
		if($priority>0){$priority_cmd=" priority $priority";}
		if($gateway==null){continue;}
        if($gateway=="0.0.0.0"){continue;}
		if(!$ipclass->isValid($gateway)){continue;}
		if($type>2){continue;}
		$MAINGATEWAY[$gateway][$ligne["ID"]]=$ligne["pattern"].$priority_cmd;
		$GLOBALS["routing_rules_dest"][$ligne["ID"]]=true;
	
	}
	
	if(count($MAINGATEWAY)==0){return $LASTID;}
	
	foreach ($MAINGATEWAY as $gateway=>$array){
		$LASTID++;
		$RouteName="Sub".str_replace(".", "", $gateway)."$nic";
		
		if($EnableIwConfig==0){
			if(preg_match("#^wlan[0-9]+#", $nic)){
				$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."]: $nic Skipped (EnableIwConfig = 0 )";
				continue;
			}
		}
	
		if(!isset($GLOBALS["ROUTESNAMES"][$RouteName])){
			$GLOBALS["ROUTESNAMES"][$RouteName]=$LASTID;
			$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["echobin"]} \"$LASTID $RouteName\" >> /etc/iproute2/rt_tables";
			$GLOBALS["SCRIPTS_ROUTES_RULES"][]="{$GLOBALS["ipbin"]} route add default via $gateway dev $nic table $RouteName prio 0 || true";
		}
	
		
	    foreach ($array as $ID=>$pattern){
			$GLOBALS["SCRIPTS_ROUTES_RULES"][]="{$GLOBALS["ipbin"]} rule add to $pattern lookup $RouteName ";
		}
	}	
	
	
	return $LASTID;
	
}

function Check_wifi_cards(){
    $EnableIwConfig=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableIwConfig"));
    $unix=new unix();
    $Files=$unix->DirFiles("/etc/init.d","wifi-wlan[0-9]+");
    $ip=$unix->find_program("ip");
    $ifconfig=$unix->find_program("ifconfig");
    $iw=$unix->find_program("iw");

    foreach ($Files as $net=>$nothing){
        echo "Scannning $net\n";
        if(!preg_match("#wifi-(.+)#",$net,$re)){
            echo "Scannning $net - SKIP\n";
            continue;}
        $Interface=$re[1];
        echo "Interface: $Interface\n";
        $nic=new system_nic($Interface);

        if($EnableIwConfig==0){
            echo "EnableIwConfig $Interface ---> 0 !\n";
            $nic->enabled=0;
        }

        if($nic->enabled==1){
            echo "Scannning $Interface - Enabled OK\n";
            continue;
        }

        squid_admin_mysql(1,"Uninstalling Wifi interface $Interface");
        remove_service("/etc/init.d/$net");
        if(is_file("/etc/wpa_supplicant/$Interface.conf")){
             @unlink("/etc/wpa_supplicant/$Interface.conf");
        }

        if(is_file("/etc/monit/conf.d/APP_WPA_SUPPLIANT_$Interface.monitrc")){
            @unlink("/etc/monit/conf.d/APP_WPA_SUPPLIANT_$Interface.monitrc");
            system("/etc/init.d/monit reload");
        }

        shell_exec("$ip link set $Interface down");
        if(is_file($ifconfig)){shell_exec("$ifconfig $Interface down");}
        if(is_file($iw)){shell_exec("$iw dev $Interface del");}

    }


}


function apply_routes(){
	
	iproute_progress(30, "{configuring}");
	routes_main(30);
	echo "Building Scripts....\n";
	
	$sh=array();
	$sh[]="#!/bin/sh -e";
	$sh[]="";
	
	foreach ($GLOBALS["SCRIPTS_ROUTES"] as $line){
		if(preg_match("#^\##", $line)){$sh[]=$line;continue;}
		if(strpos($line, "||")>0){$sh[]=$line;continue;}
		$sh[]=$line." || true";
	}
	
	
	$sh[]="";
	@file_put_contents("/tmp/routes-progress.sh", @implode("\n", $sh));
	iproute_progress(100, "{configuring} {done}");
}

function routes_main($i=0){
	$MetricCount=0;
	$unix=new unix();
	LoadProcNetDev();
	$RULES_TABLES=array();
	$GLOBALS["ifconfig"]=$unix->find_program("ifconfig");
	$GLOBALS["routebin"]=$unix->find_program("route");
	$GLOBALS["echobin"]=$unix->find_program("echo");
	$GLOBALS["ipbin"]=$unix->find_program("ip");
	$GLOBALS["vconfigbin"]=$unix->find_program("vconfig");
	$GLOBALS["moprobebin"]=$unix->find_program("modprobe");	
	$GLOBALS["ethtoolbin"]=$unix->find_program("ethtool");
	$RULES_TABLES=array();
	
	iproute_progress($i++, "{configuring} ".__LINE__);
	$sock=new sockets();
	$OVHNetConfig=$sock->GET_INFO("OVHNetConfig");
	if(!is_numeric($OVHNetConfig)){$OVHNetConfig=0;}
	$NetWorkBroadCastAsIpAddr=$sock->GET_INFO("NetWorkBroadCastAsIpAddr");
		
	
	$route=$unix->find_program("route");
	$ip=$unix->find_program("ip");
	$types[1]="{network_nic}";
	$types[2]="{host}";
	
	$endcmdsline=array();
	$q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");
	iproute_progress($i++, "{configuring} ".__LINE__);
	
	$NetBuilder=new system_nic();
	$NetBuilder->LoadTools();
	$php=$unix->LOCATE_PHP5_BIN();
	
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."]";
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] *******************************";
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] ****     MAIN ROUTES       ****";
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] *******************************";
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."]";
	
	$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route add 127.0.0.1 dev lo";

	
	$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["echobin"]} \"\" > /etc/iproute2/rt_tables";
	$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["echobin"]} \"100	tproxy\" >> /etc/iproute2/rt_tables";
	$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["echobin"]} \"255	local\" >> /etc/iproute2/rt_tables";
	$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["echobin"]} \"254	main\" >> /etc/iproute2/rt_tables";
	$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["echobin"]} \"253	default\" >> /etc/iproute2/rt_tables";
	$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["echobin"]} \"0	unspec\" >> /etc/iproute2/rt_tables";
	
	
	$GLOBALS["SCRIPTS_ROUTES"][]="$php /usr/share/artica-postfix/exec.network.ip-rules.flush.php";
	iproute_progress($i++, "{configuring} ".__LINE__);
	
	
	
	
	iproute_progress($i++, "{configuring} ".__LINE__);
	$EnableIwConfig=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableIwConfig"));
	if($q->TABLE_EXISTS("routing_rules")){
		$routing_rules=$q->QUERY_SQL("SELECT * FROM routing_rules WHERE enabled=1");
		if(!$q->ok){echo "Starting......: ".date("H:i:s")." Mysql error : $q->mysql_error\n";return;}
		$LASTID=260;
		foreach ($routing_rules as $index=>$routing_ligne){
			$LASTID++;
			
			$RouteName=$routing_ligne["RouteName"];
			$nic=$routing_ligne["nic"];
			$ID=$routing_ligne["ID"];
			if($ID>$LASTID){$LASTID=$ID;}
			$RULES_TABLES[$nic]=$ID;
			iproute_progress($i++, "{configuring} $RouteName iproute id $LASTID id $ID".__LINE__);
			$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] Advanced route for $nic table ID $LASTID";
			$GLOBALS["SCRIPTS_ROUTES"][]="while ip rule delete from 0/0 to 0/0 table $RouteName 2>/dev/null; do true; done";
			$GLOBALS["SCRIPTS_ROUTES"][]="while ip rule delete dev $nic 2>/dev/null; do true; done";
			$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["echobin"]} \"$LASTID $RouteName\" >> /etc/iproute2/rt_tables";
			
		}
		
		iproute_progress($i++, "{configuring} ".__LINE__);
		foreach ($RULES_TABLES as $nic=>$ID){
			iproute_progress($i++, "{configuring} ".__LINE__);
			if($EnableIwConfig==0){
				if(preg_match("#^wlan[0-9]+#", $nic)){
					$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."]: $nic Skipped (EnableIwConfig = 0 )";
					continue;
				}
			}
			
			iproute_progress($i++, "{configuring} ".__LINE__);
			$LASTID=routing_rules_specifics($ID,$nic,$LASTID);
		}
		iproute_progress($i++, "{configuring} ".__LINE__);
		reset($RULES_TABLES);
		
		
	}
	iproute_progress($i++, "{configuring} ".__LINE__);
	routes_table($i);
}


function routes_table($i=0){
	$unix=new unix();
	$q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");

	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."]";
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."]";
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] ************************************************";
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] ADVANCED ROUTING";
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] ************************************************";
	iproute_progress($i++, "{configuring} ".__LINE__);
	if(!$q->TABLE_EXISTS("routing_rules", "artica_backup")){
		$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] routing_rules table does not exists";
		return;
	}
	
	$sql="SELECT nic FROM routing_rules WHERE enabled=1 GROUP BY nic";
	$results=$q->QUERY_SQL($sql,"artica_backup");
	iproute_progress($i++, "{configuring} ".__LINE__);
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] routing_rules ".count($results)." items";
	if(count($results)==0){return;}
	
//	$GLOBALS["SCRIPTS_IPTABLES"][]="$php /usr/share/artica-postfix/exec.iptables-deleteroutes.php || true";
	
	iproute_progress($i++, "{configuring} ".__LINE__);
	$EnableArticaAsGateway=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableArticaAsGateway"));
	$GLOBALS["SCRIPTS_ROUTES"][]="#";
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."]: EnableArticaAsGateway = $EnableArticaAsGateway";
	
	iproute_progress($i++, "{configuring} ".__LINE__);
	if($EnableArticaAsGateway==1){
		$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] Enable IP Forwarding and disable Reverse Path filter";
		$sysctl=$unix->find_program("sysctl");
		$GLOBALS["SCRIPTS_ROUTES"][]="$sysctl -w net.ipv4.ip_forward=1";
		$GLOBALS["SCRIPTS_ROUTES"][]="$sysctl -w net.ipv4.conf.default.rp_filter=0 >/dev/null 2>&1";
		$GLOBALS["SCRIPTS_ROUTES"][]="$sysctl -w net.ipv4.conf.all.rp_filter=0 >/dev/null 2>&1";
		$GLOBALS["SCRIPTS_ROUTES"][]="for f in /proc/sys/net/ipv4/conf/*/rp_filter; do echo 0 >| \$f ; done";
		$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."]";
		$GLOBALS["SCRIPTS_ROUTES"][]="#";
	}
	

	iproute_progress($i++, "{configuring} ".__LINE__);
	$EnableIwConfig=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableIwConfig"));
	foreach ($results as $index=>$ligne){
		$nic=$ligne["nic"];
		
		if($EnableIwConfig==0){
			if(preg_match("#^wlan[0-9]+#", $nic)){
				$GLOBALS["SCRIPTS_ROUTES"][]="#              ****************                     ";
				$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."]: $nic Skipped (EnableIwConfig = 0 )";
				$GLOBALS["SCRIPTS_ROUTES"][]="#              ****************                     ";
				continue;
			}
		}
		iproute_progress($i++, "{configuring} ".__LINE__);
		$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] routing_rules flush table and rules from $nic";
		$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route flush dev $nic || true";
		$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} rule del dev $nic || true";
	}
	
		iproute_progress($i++, "{configuring} ".__LINE__);
		$sql="SELECT * FROM routing_rules WHERE enabled=1";
		$results=$q->QUERY_SQL($sql,"artica_backup");
		if(!$q->ok){echo "Starting......: ".date("H:i:s")." Mysql error : $q->mysql_error\n";return;}
	
		
		$GLOBALS["SCRIPTS_ROUTES"][]=@implode("\n",$GLOBALS["SCRIPTS_ROUTES_RULES"]);
		
		foreach ($results as $index=>$ligne){
			$RouteName=$ligne["RouteName"];
			iproute_progress($i++, "{configuring} $RouteName".__LINE__);
			$ID=$ligne["ID"];
			$nic=$ligne["nic"];
			
			if($EnableIwConfig==0){
				if(preg_match("#^wlan[0-9]+#", $nic)){
					$GLOBALS["SCRIPTS_ROUTES"][]="#              ****************                     ";
					$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."]: $nic Skipped (EnableIwConfig = 0 )";
					$GLOBALS["SCRIPTS_ROUTES"][]="#              ****************                     ";
					continue;
				}
			}
			
			$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] routing_rules table $RouteName";
			iproute_progress($i++, "{configuring} $RouteName".__LINE__);
			routes_table_sources($ID,$nic,$RouteName);
		}
		
		iproute_progress($i++, "{configuring} {done}".__FUNCTION__." == ".__LINE__);
}

function MULTIPATH_GATEWAY($eth,$RouteName=null){
	$q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");
	$sql="CREATE TABLE IF NOT EXISTS `multipath` (`ID` INTEGER PRIMARY KEY AUTOINCREMENT,`nic` TEXT NOT NULL,`weight` INTEGER NOT NULL DEFAULT 1, `gateway` TEXT NOT NULL)";
	$q->QUERY_SQL($sql);
	$sql="SELECT * FROM `multipath` WHERE `nic`='$eth' ORDER BY `weight`";
	$results=$q->QUERY_SQL($sql);
	if(count($results)==0){return false;}
	$ipclass=new IP();
    $ROUTENAMET=null;
	if($RouteName<>null){$ROUTENAMET=" table $RouteName";}
	
	$GATEWAYS=array();
	
	foreach ($results as $index=>$ligne){
		$ligne["gateway"]=trim($ligne["gateway"]);
		if($ligne["gateway"]=="0.0.0.0"){continue;}
		$weight=intval($ligne["weight"]);
		if($weight==0){$weight=1;}
		if(!$ipclass->isIPAddress($ligne["gateway"])){continue;}
        $GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] Add Multipath gateway {$ligne["gateway"]} for $eth [".__LINE__."]";
		$GATEWAYS[$ligne["gateway"]]=$weight;
	}
	
	if(count($GATEWAYS)==0){return false;}
	
	$nic=new system_nic($eth);
	$GATEWAYS[$nic->GATEWAY]=$nic->metric;
	
	$prefix="{$GLOBALS["ipbin"]} route add default scope global{$ROUTENAMET} ";
	
	foreach ($GATEWAYS as $gateway=>$weight){
		$GLOBALS["SCRIPTS_ROUTES"][]="# gateway: $gateway weight $weight";
		$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route add $gateway{$ROUTENAMET} dev $eth";
		$f[]="nexthop via $gateway dev $eth  weight $weight";
		
	}
	$GLOBALS["SCRIPTS_ROUTES"][]=$prefix." ".@implode(" ", $f);
	return true;
	
}

function routes_table_sources($ruleid,$eth,$RouteName){
	$unix=new unix();
	$q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");
	$EnableIwConfig=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableIwConfig"));
	if($EnableIwConfig==0){
		if(preg_match("#^wlan[0-9]+#", $eth)){
			$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."]: $eth Skipped (EnableIwConfig = 0 )";
			return;
		}
	}
	
	
	$route=$unix->find_program("route");
	$nicClass=new system_nic($eth);
	
	$GLOBALS["SCRIPTS_ROUTES"][]="#";
	$GLOBALS["SCRIPTS_ROUTES"][]="#";
	$GLOBALS["SCRIPTS_ROUTES"][]="#";
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] --------------------------------------------------------------------";
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] Routing rule $ruleid for Interface $eth Route $RouteName";
	
	
	if($nicClass->enabled==0){
		$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] $eth is disabled";
		return;
	}
	if($nicClass->UseSPAN==1){
		$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] $eth is on SPAN MODE";
		return;
	}
	
	
	$TBRZ=explode(".",$nicClass->IPADDR);
	$MAINNET="{$TBRZ[0]}.{$TBRZ[1]}.{$TBRZ[2]}.0";
	
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] $eth --> IP Address: $nicClass->IPADDR Net:$MAINNET/$nicClass->NETMASK";
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] $eth --> Default route \"$nicClass->GATEWAY\" Add in maintable=$nicClass->defaultroute";
	$GLOBALS["SCRIPTS_ROUTES"][]="#";
	$GLOBALS["SCRIPTS_ROUTES"][]="#";
	
	$GLOBALS["SCRIPTS_ROUTES"][]="while ip rule delete from $nicClass->IPADDR 2>/dev/null; do true; done";
	
	if($nicClass->GATEWAY<>null){
		if($nicClass->GATEWAY<>"0.0.0.0"){
			
			
			if($nicClass->defaultroute==1){
				if(!isset($GLOBALS["DEFAULT_METRIC"])){$GLOBALS["DEFAULT_METRIC"]=0;}
				if($nicClass->metric>$GLOBALS["DEFAULT_METRIC"]){$GLOBALS["DEFAULT_METRIC"]=$nicClass->metric;}
				if(intval($nicClass->metric<$GLOBALS["DEFAULT_METRIC"])){$GLOBALS["DEFAULT_METRIC"]++;$nicClass->metric=$GLOBALS["DEFAULT_METRIC"];}
				$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] Add the default route defined for $eth metric ".$nicClass->metric;
				$GLOBALS["SCRIPTS_ROUTES"][]="$route add -host $nicClass->GATEWAY dev $eth";
				$GLOBALS["SCRIPTS_ROUTES"][]="$route add default gw $nicClass->GATEWAY dev $eth metric $nicClass->metric";
			}
			$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] Add the default route in table table $RouteName and defined for $eth metric ".$nicClass->metric;
			
			
			if(!MULTIPATH_GATEWAY($eth,$RouteName)){
				$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route add $nicClass->GATEWAY table $RouteName dev $eth";
				$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route add default scope global table $RouteName nexthop via $nicClass->GATEWAY dev $eth  weight $nicClass->metric";
			}
			$GLOBALS["SCRIPTS_ROUTES"][]="#";
		}
	}
	
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] All packets from $nicClass->IPADDR goes to $RouteName";
	$GLOBALS["SCRIPTS_ROUTES"][]="#";
	
	$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} rule add from $nicClass->IPADDR iif $eth lookup $RouteName prio $nicClass->metric";
	$GLOBALS["SCRIPTS_ROUTES"][]="#";
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] Network Interface can answering itself from $MAINNET/$nicClass->NETMASK";
	$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route add $MAINNET/$nicClass->NETMASK dev $eth  proto kernel scope link src $nicClass->IPADDR table $RouteName"; 
	$GLOBALS["SCRIPTS_ROUTES"][]="#";
	
	
	
	if(!isset($GLOBALS["TABLE_MAIN"]["$MAINNET/$nicClass->NETMASK"])){
		$GLOBALS["SCRIPTS_ROUTES"][]="#";
		$GLOBALS["SCRIPTS_ROUTES"][]="# 				-------------- TABLE MAIN --------------";
		$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route add $MAINNET/$nicClass->NETMASK dev $eth  proto kernel scope link src $nicClass->IPADDR table main";
		$GLOBALS["SCRIPTS_ROUTES"][]="#";
		$GLOBALS["SCRIPTS_ROUTES"][]="#";	
		$GLOBALS["TABLE_MAIN"]["$MAINNET/$nicClass->NETMASK"]=true;
	}
	
	
	$results=$q->QUERY_SQL("SELECT * FROM routing_rules_dest WHERE ruleid='$ruleid' AND type=3 ORDER BY zOrder,metric","artica_backup");
	
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] routing_rules_dest ruleid='$ruleid' ".count($results)." elements";
	
	if(count($results)>0){
		foreach ($results as $index=>$ligne){
			$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] Gateway {$ligne["gateway"]}";
			if($ligne["gateway"]==$nicClass->GATEWAY){continue;}
			$GLOBALS["SCRIPTS_ROUTES"][]="#";
			$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] default $eth -> {$ligne["gateway"]}";
			$GLOBALS["SCRIPTS_ROUTES"][]="$route add -host {$ligne["gateway"]} dev $eth";
			$GLOBALS["SCRIPTS_ROUTES"][]="$route add default gw {$ligne["gateway"]} dev $eth";
			$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route add default via {$ligne["gateway"]} dev $eth table $RouteName prio {$ligne["metric"]} || true";
		}
	}else{
		if($nicClass->defaultroute==0){
			$GLOBALS["SCRIPTS_ROUTES"][]="#";
			$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] * * * * * * * * * * * * * * * * * * * * * *";
			$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] WARNING: TRY TO FIX IT --------------------";
			$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] Gateway $nicClass->GATEWAY is not a default route and no routes are defined";
			if($nicClass->GATEWAY<>null){
				if($nicClass->GATEWAY<>"0.0.0.0"){
					$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] Default gateway for $eth -> $nicClass->GATEWAY";
					$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route add $nicClass->GATEWAY dev $eth table main";
					$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route add default via $nicClass->GATEWAY dev $eth table main prio {$nicClass->metric} || true";
					$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route add {$nicClass->GATEWAY} dev $eth table $RouteName";
					$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route add default via {$nicClass->GATEWAY} dev $eth table $RouteName prio {$nicClass->metric} || true";
				}
				
			}
			$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] * * * * * * * * * * * * * * * * * * * * * *";
			$GLOBALS["SCRIPTS_ROUTES"][]="#";
		}
		
		
	}
	
	
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] routing_rules_src... Rule number $ruleid";
	$results=$q->QUERY_SQL("SELECT * FROM routing_rules_src WHERE ruleid='$ruleid' ORDER BY zOrder","artica_backup");
	$CuntOfSources=0;
	foreach ($results as $index=>$ligne){
		$CuntOfSources++;
		$pattern=$ligne["pattern"];
		$gateway=$ligne["gateway"];
		$priority=$ligne["metric"];
		$priority_cmd=null;
		
		if(isset($GLOBALS["routing_rules_src"][$ligne["ID"]])){
			$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] routing_rules_src gateway:$gateway from: $pattern {$ligne["ID"]} Skipped, already added";
			continue;
		}
		
		if($priority>0){$priority_cmd=" priority $priority";}
		$type=$ligne["type"];
		
		if($type==3){
			$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} rule add nat $gateway from $pattern iif $eth table $RouteName{$priority_cmd} || true";
			continue;
		}
		if($type==4){
			$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} rule add type blackhole from $pattern iif $eth table $RouteName{$priority_cmd} || true";
			continue;
		}
		
		if($type==5){
			$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} rule add type prohibit from $pattern iif $eth table $RouteName{$priority_cmd} || true";
			continue;
		}		
		
		if($gateway==null){
			$GLOBALS["SCRIPTS_ROUTES"][]="#";
			$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] routing_rules_src All packets from $pattern go to $eth table $RouteName";
			$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} rule add from $pattern iif $eth lookup $RouteName{$priority_cmd} || true";
		}
		
		
	}
	
	
	$results=$q->QUERY_SQL("SELECT * FROM routing_rules_dest WHERE ruleid='$ruleid' ORDER BY zOrder,metric","artica_backup");
	
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] routing_rules_dest rule Number $ruleid...";
	foreach ($results as $index=>$ligne){
		$pattern=trim($ligne["pattern"]);
		$priority=$ligne["metric"];
		$priority_cmd=null;
		$type=$ligne["type"];
		$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] pattern=$pattern, priority=$priority, type=$type";
		if($pattern=="0.0.0.0/0.0.0.0"){$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] $pattern refused here, use default gateway instead.";continue;}
		if(isset($GLOBALS["routing_rules_dest"][$ligne["ID"]])){
			$GLOBALS["SCRIPTS_ROUTES"][]="# {$ligne["ID"]} already defined in memory";
			continue;
		}
		
		if($priority>0){$priority_cmd=" priority $priority";}
		
		if($type<3){
			if($ligne["gateway"]<>null){
				$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] $pattern via {$ligne["gateway"]}";
				
				
				if(!isset($GLOBALS["ALREADYADDED"][$pattern])){$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route add $pattern dev $eth proto kernel scope link src $nicClass->IPADDR";$GLOBALS["ALREADYADDED"][$pattern]=true;}
				$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route add $pattern via {$ligne["gateway"]} dev $eth table $RouteName src $nicClass->IPADDR {$priority_cmd}";
				$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} rule add to $pattern iif $eth lookup $RouteName{$priority_cmd}";
				continue;
			}
			$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] $pattern via $eth";
			if(!isset($GLOBALS["ALREADYADDED"][$pattern])){$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route add $pattern dev $eth proto kernel scope link src $nicClass->IPADDR"; $GLOBALS["ALREADYADDED"][$pattern]=true; }
			$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} rule add to $pattern iif $eth lookup $RouteName{$priority_cmd}";
			continue;
		}
		if(!isset($GLOBALS["ALREADYADDED"][$pattern])){$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route add $pattern dev $eth proto kernel scope link src $nicClass->IPADDR {$priority_cmd}"; $GLOBALS["ALREADYADDED"][$pattern]=true;}
		$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} rule add to $pattern iif $eth lookup $RouteName{$priority_cmd}";
		
	}
	
	$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route flush cache || true";
	
}



function routes_default_add($eth,$ipsrc,$gateway,$network,$metric_text,$calledByLine){
	$unix=new unix();
	
	$EnableIwConfig=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableIwConfig"));
	if($EnableIwConfig==0){
		if(preg_match("#^wlan[0-9]+#", $eth)){
			$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."]: $eth Skipped (EnableIwConfig = 0 )";
			return;
		}
	}
	
	
	if(!isset($GLOBALS["moprobebin"])){$GLOBALS["moprobebin"]=$unix->find_program("modprobe");}
	if(!isset($GLOBALS["vconfigbin"])){$GLOBALS["vconfigbin"]=$unix->find_program("vconfig");}
	if(!isset($GLOBALS["ifconfig"])){$GLOBALS["ifconfig"]=$unix->find_program("ifconfig");}
	if(!isset($GLOBALS["ipbin"])){$GLOBALS["ipbin"]=$unix->find_program("ip");}
	if(!isset($GLOBALS["echobin"])){$GLOBALS["echobin"]=$unix->find_program("echo");}
	if(!isset($GLOBALS["sysctl"])){$GLOBALS["sysctl"]=$unix->find_program("sysctl");}
	if(!isset($GLOBALS["routebin"])){$GLOBALS["routebin"]=$unix->find_program("route");}


	if($gateway=="0.0.0.0"){$gateway=null;}
	
	$GLOBALS["SCRIPTS_ROUTES"][]="#[$eth/".__FUNCTION__."/".__LINE__." Gateway: $gateway Standard routing - called by $calledByLine";
	
	if($network<>null){
		$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["routebin"]} add -net $network gw $gateway dev $eth $metric_text";
	}
	
	if($gateway==null){return;}
	if(isGatewayGood($gateway)){
		$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["routebin"]} add -host $gateway dev $eth $metric_text";
		$GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["routebin"]} add -net 0.0.0.0 gw $gateway dev $eth $metric_text";
	}
	
	
	
	

}

function routes_source_add($eth,$ipsrc,$gateway,$network,$calledByLine){
	$unix=new unix();
	
	$EnableIwConfig=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableIwConfig"));
	if($EnableIwConfig==0){
		if(preg_match("#^wlan[0-9]+#", $eth)){
			$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."]: $eth Skipped (EnableIwConfig = 0 )";
			return;
		}
	}
	
		if(!isset($GLOBALS["moprobebin"])){$GLOBALS["moprobebin"]=$unix->find_program("modprobe");}
		if(!isset($GLOBALS["vconfigbin"])){$GLOBALS["vconfigbin"]=$unix->find_program("vconfig");}
		if(!isset($GLOBALS["ifconfig"])){$GLOBALS["ifconfig"]=$unix->find_program("ifconfig");}
		if(!isset($GLOBALS["ipbin"])){$GLOBALS["ipbin"]=$unix->find_program("ip");}
		if(!isset($GLOBALS["echobin"])){$GLOBALS["echobin"]=$unix->find_program("echo");}
		if(!isset($GLOBALS["sysctl"])){$GLOBALS["sysctl"]=$unix->find_program("sysctl");}

	
	if($gateway=="0.0.0.0"){$gateway=null;}
    $rpfilter=1;
    $EnableVLANs=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableVLANs");
    if($EnableVLANs==1){$rpfilter=0;}
	
	$ip=$GLOBALS["ipbin"];
	$echo =$GLOBALS["echobin"];
	$table=alphaToNum($eth);
	$sysctl=$GLOBALS["sysctl"];
	if(!isset($GLOBALS["net.ipv4.conf.all.arp_filter"])){
		$GLOBALS["SCRIPTS_ROUTES"][]="$sysctl -w net.ipv4.conf.all.arp_filter=1";
		$GLOBALS["net.ipv4.conf.all.arp_filter"]=true;
	}
	
	
	
	$GLOBALS["SCRIPTS_ROUTES"][]="$echo \"*** TABLE $table $eth/$ipsrc/$network go to $gateway ****\"";
	$GLOBALS["SCRIPTS_ROUTES"][]="# Called by line $calledByLine routes_source_add() line ".__LINE__;
	$GLOBALS["SCRIPTS_ROUTES"][]="$ip route flush table $table";
	$GLOBALS["SCRIPTS_ROUTES"][]="$ip rule del dev $eth";
	$GLOBALS["SCRIPTS_ROUTES"][]="$ip rule del from $ipsrc";
	$GLOBALS["SCRIPTS_ROUTES"][]="$ip rule add from $ipsrc table $table";
	if($network<>null){
		$GLOBALS["SCRIPTS_ROUTES"][]="$ip route add $network dev $eth src $ipsrc table $table";
	}
	
	if($gateway<>null){
		$GLOBALS["SCRIPTS_ROUTES"][]="$ip route add default via $gateway table $table";
	}
	
	if($network<>null){
		$GLOBALS["SCRIPTS_ROUTES"][]="$ip route add $network dev $eth src $ipsrc";
	}
	
}


function routes_main_network($ligne){
	$NetBuilder=new system_nic();
	$NetBuilder->LoadTools();
	$ipClass=new IP();
	$pattern=$ligne["pattern"];
	$gateway=$ligne["gateway"];
	if($gateway=="0.0.0.0"){$gateway=null;}
	
	if(!isset($GLOBALS["PROC_NET_DEV"][$ligne["nic"]])){
		$GLOBALS["SCRIPTS_ROUTES"][]="# [{$ligne["nic"]}/".__LINE__."] INTERFACE MATERIAL ERROR";
		return;
	}
	$eth=$NetBuilder->NicToOther($ligne["nic"]);
	$metric=$ligne["metric"];	
	
	if(!$ipClass->isValidBlock($pattern)){
		$GLOBALS["SCRIPTS_ROUTES"][]="# [$eth/".__LINE__."] \"$pattern\" is not a valid block";
		return;
	}
	
	if($ligne["SourceBasedRouting"]==1){
		$table=alphaToNum($ligne["nic"]);
		$f[]="{$GLOBALS["ipbin"]} add $pattern";
		if($gateway<>null){ $f[]="via $gateway"; }
		$f[]="table $table";
		if($metric>0){ $f[]="metric $metric"; }
		return @implode(" ", $f);
	}	
	
	
	if($gateway==null){
		$GLOBALS["SCRIPTS_ROUTES"][]="# [{$ligne["nic"]}/".__LINE__."] No gateway set, add just the net $pattern on interface $eth";
		$f[]="{$GLOBALS["ipbin"]} route add $pattern dev $eth";
		if($metric>0){ $f[]="metric $metric"; }
		return @implode(" ", $f);
	}
	
	$GLOBALS["SCRIPTS_ROUTES"][]="# [{$ligne["nic"]}/".__LINE__."] $pattern via $gateway on interface $eth";
	$f[]="{$GLOBALS["routebin"]} add -net $pattern";
	$f[]="gw $gateway"; 
	$f[]="dev $eth";
	if($metric>0){ $f[]="metric $metric"; }
	
	return @implode(" ", $f);
	
}


function routes_main_host($ligne){
	$ipClass=new IP();
	$NetBuilder=new system_nic();
	$NetBuilder->LoadTools();
	$pattern=$ligne["pattern"];
	$gateway=$ligne["gateway"];
	$SourceBasedRouting=$ligne["SourceBasedRouting"];
	if($gateway=="0.0.0.0"){$gateway=null;}
	
	if(!isset($GLOBALS["PROC_NET_DEV"][$ligne["nic"]])){
		$GLOBALS["SCRIPTS_ROUTES"][]="# [{$ligne["nic"]}/".__LINE__."] INTERFACE MATERIAL ERROR";
		return;
	}
	
	
	if(preg_match("#(.+?)\/([0-9]+)#", $pattern,$re)){
		$pattern=$re[1];
	}
	
	
	if(!$ipClass->isValid($pattern)){
		$pattern=gethostbyname($pattern);
	
	}
	
	if(!$ipClass->isValid($pattern)){
		$GLOBALS["SCRIPTS_ROUTES"][]="# [{$ligne["nic"]}/".__LINE__."] `$pattern` ERROR - could not resolv";
		return;
	}
	
	$eth=$NetBuilder->NicToOther($ligne["nic"]);
	$metric=$ligne["metric"];
	
	
	if($ligne["SourceBasedRouting"]==1){
		$table=alphaToNum($ligne["nic"]);
		$f[]="{$GLOBALS["ipbin"]} add $pattern";
		if($gateway<>null){ $f[]="via $gateway"; }
		$f[]="table $table";
		if($metric>0){ $f[]="metric $metric"; }
		return @implode(" ", $f);
	}
	
	
	$f[]="{$GLOBALS["routebin"]} add -host $pattern";
	if($gateway<>null){ $f[]="gw $gateway"; }
	$f[]="dev $eth";
	if($metric>0){ $f[]="metric $metric"; }
	return @implode(" ", $f);

	
}


function routes(){
	$unix=new unix();
	$NetBuilder=new system_nic();
	$route=$unix->find_program("route");
	$ip=$unix->find_program("ip");
	$types[1]="{network_nic}";
	$types[2]="{host}";	
	$array=array();
	
	
	$q=new mysql();	
	
	$f=explode("\n",@file_get_contents("/etc/iproute2/rt_tables"));
	foreach ($f as $ligne){
		if(preg_match("#^([0-9]+)\s+(.+)#", $ligne,$re)){
			$tableID=$re[1];
			if($tableID==255){continue;}
			if($tableID==254){continue;}
			if($tableID==253){continue;}
			if($tableID==0){continue;}
			echo "Starting......: ".date("H:i:s")." $tableID is for route {$re[2]}\n";
			$array[$tableID]=$re[2];
		}
		
	}
	
	if(count($array)>0){
		while (list ($id, $ligne) = each ($array) ){
			echo "Starting......: ".date("H:i:s")." Building routes, flush table `$ligne`\n";
			shell_exec("$ip route flush table $ligne");
			
		}
	}
	
	$sql="SELECT * FROM iproute_table WHERE enable=1 ORDER BY routename";
	$results=$q->QUERY_SQL($sql,"artica_backup");
	if(!$q->ok){
		echo "Starting......: ".date("H:i:s")." Building routes, $q->mysql_error\n";
		routes_fromfile();
		return;
	}
	
	
	$rtid=0;
	$countOfRoutes=mysqli_num_rows($results);
	if($GLOBALS["VERBOSE"]){echo "Line:".__LINE__." $countOfRoutes routes\n";}
	if($countOfRoutes==0){return;}
	
	while ($ligne = mysqli_fetch_assoc($results)) {
		$rtname=$ligne["routename"];
		$rtid++;		
		$eth=$ligne["interface"];
		$gw=$ligne["gateway"];
		$eth=$NetBuilder->NicToOther($eth);
		
		
		if($gw<>null){
			$NEXT[]="$ip route add $gw dev $eth";
			
		}
	
		$TABLES[]=$rtname;
	}
	
	$f=array();
	$f[]="255\tlocal";
	$f[]="254\tmain";
	$f[]="253\tdefault";
	$f[]="299\tproxy";
	$f[]="0\tunspec";
	$c=1;
	if(count($TABLES)>0){
	    foreach ($TABLES as $ligne){
			$f[]="$c\t$ligne";
			shell_exec("$ip route flush table $ligne");
			
		}
		@file_put_contents("/etc/iproute2/rt_tables", @implode("\n", $f));
		while (list ($id, $cmdline) = each ($NEXT) ){
			shell_exec("$cmdline >/dev/null 2>&1");
		}
	}
	reset($TABLES);
	reset($NEXT);
	$FINAL["TABLES"]=$TABLES;
	$FINAL["NEXT"]=$NEXT;

	
	
	@file_put_contents("/etc/artica-postfix/ROUTES.CACHES.TABLES", serialize($FINAL));
	
}
function route_desc($src,$destination,$priority,$eth,$rtname,$gw){
	if($src<>null){return;}
	if($destination==null){return;}
	if($gw==null){return;}
	$prioritytext=null;
	if($priority>0){
		$prioritytext=" priority $priority ";
	}
	
	return "route add$prioritytext to $destination via $gw dev $eth table $rtname";	
	
}

function route_from($src,$destination,$priority,$eth,$rtname){
	if($src==null){return;}
	if($destination<>null){return;}
	$prioritytext=null;
	if($priority>0){
		$prioritytext=" priority $priority ";
	}
	
	return "rule add$prioritytext from $src dev $eth table $rtname";	
	
}

function route_between_subnet($src,$destination,$priority,$eth,$rtname){
	if($src==null){return;}
	if($destination==null){return;}
	$prioritytext=null;
	if($priority>0){
		$prioritytext=" priority $priority ";
	}
	
	return "rule add$prioritytext from $src to $destination dev $eth table $rtname";
}

function routes_del($md5){
	$unix=new unix();
	$route=$unix->find_program("route");	
	$q=new mysql();
	$sql="SELECT * FROM nic_routes WHERE `zmd5`='$md5'";
	$ligne=mysqli_fetch_array($q->QUERY_SQL($sql,"artica_backup"));
	$type=$ligne["type"];
	$ttype="-net";
	if($type==1){$ttype="-net";}
	if($type==2){$ttype="-host";}
	
	$NetBuilder=new system_nic();
	if($NetBuilder->IsBridged($ligne["nic"])){
		$ligne["nic"]=$ligne["BridgedTo"];
	}
	
	if($ligne["nic"]<>null){$dev=" dev {$ligne["nic"]}";}
	
	
	
	$cmd="$route del $ttype {$ligne["pattern"]} gw {$ligne["gateway"]}$dev";
	if($GLOBALS["VERBOSE"]){echo $cmd."\n";}	
	shell_exec("$cmd >/dev/null 2>&1");
	$sql="DELETE FROM nic_routes WHERE `zmd5`='$md5'";
	$q->QUERY_SQL($sql,"artica_backup");
	if(!$q->ok){echo $q->mysql_error;return;}	
	
	
}


function postfix_multiples_instances(){
	build();
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	
	$sql="SELECT ou, ip_address, `key` , `value` FROM postfix_multi WHERE `key` = 'myhostname'";
	$q=new mysql();
	$results=$q->QUERY_SQL($sql,"artica_backup");	
	while($ligne=@mysqli_fetch_array($results,MYSQLI_ASSOC)){	
		$hostname=$ligne["value"];
		echo "Starting......: ".date("H:i:s")." reconfigure postfix instance $hostname\n";
		shell_exec("$php /usr/share/artica-postfix/exec.postfix-multi.php --instance-reconfigure \"$hostname\"");
	}
}

function Checkipv6Virts(){
	$unix=new unix();
	$sock=new sockets();
	$EnableipV6=$sock->GET_INFO("EnableipV6");
	$NetBuilder=new system_nic();
	
	if(!is_numeric($EnableipV6)){$EnableipV6=0;}	
	if($EnableipV6==0){return;}
	$q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");
	$sql="SELECT nic FROM nics_virtuals WHERE ipv6=1";
	$results=$q->QUERY_SQL($sql,"artica_backup");
	$eths=array();
	foreach ($results as $index=>$ligne){
		$eths[$ligne["nic"]]=$ligne["nic"];
		
	}
	
	if(count($eths)==0){
		echo "Starting......: ".date("H:i:s")." Building Ipv6 virtuals IP -> 0 interface...\n";
		return;
	}
	
	
	$echo=$unix->find_program("echo");
	$ipbin=$unix->find_program("ip");
	$ip=new IP();
	$sh=array();
	while (list ($eth, $ligne) = each ($eths) ){
		echo "Starting......: ".date("H:i:s")." Building Ipv6 virtuals IP for `$eth` interface...\n";
		$sh[]="$echo 0 > /proc/sys/net/ipv6/conf/$eth/disable_ipv6";		
		$sh[]="$echo 0 > /proc/sys/net/ipv6/conf/$eth/autoconf";
		$sh[]="$echo 0 > /proc/sys/net/ipv6/conf/$eth/accept_ra";
		$sh[]="$echo 0 > /proc/sys/net/ipv6/conf/$eth/accept_ra_defrtr";
		$sh[]="$echo 0 > /proc/sys/net/ipv6/conf/$eth/accept_ra_pinfo";
		$sh[]="$echo 0 > /proc/sys/net/ipv6/conf/$eth/accept_ra_rtr_pref";	
		$sql="SELECT * FROM nics_virtuals WHERE ipv6=1 AND nic='$eth' ORDER BY ID DESC";
		$results=$q->QUERY_SQL($sql,"artica_backup");
		foreach ($results as $index=>$ligne){
			$ipv6addr=$ligne["ipaddr"];
			$netmask=$ligne["netmask"];
			if(!is_numeric($netmask)){$netmask=0;}
			if($netmask==0){continue;}
			
			
			if(!$ip->isIPv6($ipv6addr)){continue;}
			echo "Starting......: ".date("H:i:s")." Building Ipv6 virtuals IP for `$eth` [$ipv6addr/$netmask]...\n";
  		    $sh[]="$ipbin addr add dev $eth $ipv6addr/$netmask";
		}
		
	}
	
	if(count($sh)==0){return;}
	while (list ($num, $cmdline) = each ($sh) ){
		if($GLOBALS["VERBOSE"]){echo "Starting......: ".date("H:i:s")." Building Ipv6 virtuals $cmdline\n";}
		shell_exec($cmdline);
	}
	

}


function Checkipv6(){
	$unix=new unix();
	$EnableipV6=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableipV6"));
	$sysctl=$unix->find_program("sysctl");
	$GLOBALS["SCRIPTS"][]="#";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."] ****         IPV6          ****";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."] *******************************";
	$GLOBALS["SCRIPTS"][]="#";
	
	if($EnableipV6==0){
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] ipV6 disabled";
		echo "Starting......: ".date("H:i:s")." Building networks IPv6 is disabled\n";
		$GLOBALS["SCRIPTS"][]="$sysctl -w net.ipv6.conf.all.disable_ipv6=1"; 
		$GLOBALS["SCRIPTS"][]="$sysctl -w net.ipv6.conf.default.disable_ipv6=1";
		$GLOBALS["SCRIPTS"][]="$sysctl -w net.ipv6.conf.lo.disable_ipv6=1";
		$unix->sysctl("net.ipv6.conf.all.disable_ipv6",1);
		$unix->sysctl("net.ipv6.conf.default.disable_ipv6",1);
		$unix->sysctl("net.ipv6.conf.lo.disable_ipv6",1);
		@file_put_contents("/proc/sys/net/ipv6/conf/lo/disable_ipv6",1);
		@file_put_contents("/proc/sys/net/ipv6/conf/lo/disable_ipv6",1);
		@file_put_contents("/proc/sys/net/ipv6/conf/all/disable_ipv6",1);
		@file_put_contents("/proc/sys/net/ipv6/conf/default/disable_ipv6",1);
	}else{
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] ipV6 Enabled";
		echo "Starting......: ".date("H:i:s")." Building networks IPv6 is enabled\n";
		$unix->sysctl("net.ipv6.conf.all.disable_ipv6",0);
		$unix->sysctl("net.ipv6.conf.default.disable_ipv6",0);
		$unix->sysctl("net.ipv6.conf.lo.disable_ipv6",0);
		$GLOBALS["SCRIPTS"][]="$sysctl -w net.ipv6.conf.all.disable_ipv6=0";
		$GLOBALS["SCRIPTS"][]="$sysctl -w net.ipv6.conf.default.disable_ipv6=0";
		$GLOBALS["SCRIPTS"][]="$sysctl -w net.ipv6.conf.lo.disable_ipv6=0";
		@file_put_contents("/proc/sys/net/ipv6/conf/lo/disable_ipv6",0);
		@file_put_contents("/proc/sys/net/ipv6/conf/lo/disable_ipv6",0);
		@file_put_contents("/proc/sys/net/ipv6/conf/all/disable_ipv6",0);
		@file_put_contents("/proc/sys/net/ipv6/conf/default/disable_ipv6",0);
	}
	echo "Starting......: ".date("H:i:s")." Building networks IPv6 done...\n";
}

function ifupifdown($eth){
return;
}

function articalogon(){
	if(!is_file("/etc/artica-postfix/network.first.settings")){return;}
	$f=explode(";", @file_get_contents("/etc/artica-postfix/network.first.settings"));
	//l.Add(IP+';'+Gayteway+';'+netmask+';'+DNS); 
	$IPADDR=$f[0];
	$GATEWAY=$f[1];
	$NETMASK=$f[2];
	$DNS1=$f[3];
	$eth=$f[4];
	
	$nics=new system_nic($eth);
	$nics->eth=$eth;
	$nics->IPADDR=$IPADDR;
	$nics->NETMASK=$NETMASK;
	$nics->GATEWAY=$GATEWAY;
	$nics->DNS1=$DNS1;
	$nics->dhcp=0;
	$nics->enabled=1;
	$nics->NoReboot=true;
	$nics->SaveNic();
	dev_shm();
	build();
	echo "Settings $eth ($IPADDR) done...\n";
	
}
function persistent_net_rules(){
	if(!is_dir("/etc/udev/rules.d")){return;}
	$filename="/etc/udev/rules.d/70-persistent-net.rules";
	if(is_file($filename)){return;}
	
	
	$unix=new unix();
	$fz=$unix->dirdir("/sys/class/net");
	
	$final=array();
	while (list ($net, $line) = each ($fz) ){
		$line=basename($line);
		if(!preg_match("#eth[0-9]+#", $line)){continue;}
		$array=udevadm_eth($line);
		if(!$array){echo "Starting......: ".date("H:i:s")." Building persistent rule `FAILED` for `$line`\n";continue;}
		echo "Starting......: ".date("H:i:s")." Building persistent rule for `$line` {$array["MAC"]}\n";
		$final[]="SUBSYSTEM==\"net\", ACTION==\"add\", DRIVERS==\"?*\", ATTR{address}==\"{$array["MAC"]}\", ATTR{dev_id}==\"{$array["dev_id"]}\", ATTR{type}==\"{$array["TYPE"]}\", KERNEL==\"eth*\", NAME=\"$line\"";
		
	}
	
	if(count($final)>0){
		echo "Starting......: ".date("H:i:s")." Building $filename done\n";
		@file_put_contents($filename, @implode("\n", $final)."\n");
		
	}
	
	
}

function udevadm_eth($eth){
	$unix=new unix();
	$udevadm=$unix->find_program("udevadm");
	if(!is_file($udevadm)){return false;}
	$MAC=null;
	$dev_id=null;
	$type=null;
	exec("udevadm info -a -p /sys/class/net/$eth",$results);
	foreach ($results as $index=>$line){
		if(preg_match('#ATTR.*?address.*?=="(.+?)"#', $line,$re)){$MAC=$re[1];continue;}
		if(preg_match('#ATTR.*?dev_id.*?=="(.+?)"#', $line,$re)){$dev_id=$re[1];continue;}
		if(preg_match('#ATTR.*?type.*?=="(.+?)"#', $line,$re)){$type=$re[1];continue;}
		
	}
	if($MAC==null){return false;}
	if($dev_id==null){return false;}
	if($type==null){return false;}
	return array("MAC"=>$MAC,"DEV"=>$dev_id,"TYPE"=>$type); 
}

function bridge_delete($ID){
	
	$q=new mysql();
	$nicbr="br{$ID}";
	$NetBuilder=new system_nic();
	$NetBuilder->LoadTools();
	$NICS=$NetBuilder->BuildBridges_getlinked();
	while (list ($a, $b) = each ($NICS) ){
		$q->QUERY_SQL("UPDATE `nics` SET Bridged=0, BridgedTo='' WHERE Interface='$b'","artica_backup");
		$GLOBALS["SCRIPTS_DEL"][]="{$GLOBALS["brctlbin"]} delif $nicbr $b";
		$GLOBALS["SCRIPTS_DEL"][]="{$GLOBALS["ifconfig"]} $b down";
		
	}
	
	$GLOBALS["SCRIPTS_DEL"][]="{$GLOBALS["ifconfig"]} $nicbr down";
	$GLOBALS["SCRIPTS_DEL"][]="{$GLOBALS["brctlbin"]} delbr $nicbr";
	$q->QUERY_SQL("DELETE FROM `nics_bridge` WHERE ID='$ID'","artica_backup");
	
	
	
	while (list ($id, $ligne) = each ($GLOBALS["SCRIPTS_DEL"]) ){
		echo "Starting......: ".date("H:i:s")." `$ligne`\n";
		shell_exec("$ligne");
	
	}
	
	bridge_deletemanu($nicbr);
	BuildNetWorksDebian();
	shell_exec("/etc/init.d/artica-ifup start");
	
}

function bridge_deletemanu($eth){
	$NetBuilder=new system_nic();
	$NetBuilder->LoadTools();	
	if(!$NetBuilder->IfBridgeExists($eth)){return;}
	
	exec("{$GLOBALS["brctlbin"]} show $eth 2>&1",$result);
	while (list ($id, $ligne) = each ($result) ){
		if(preg_match("#.*\s+.*?\s+.*?\s+([a-z\.0-9]+)$#", $ligne,$re)){
			if(strtolower(trim($re[1])=="interfaces")){continue;}
			echo "Removing {$re[1]}\n";
			$GLOBALS["SCRIPTS_DEL"][]="{$GLOBALS["brctlbin"]} delif $eth {$re[1]}";
			$GLOBALS["SCRIPTS_DEL"][]="{$GLOBALS["ifconfig"]} {$re[1]} down";
			continue;
		}
		
		if(preg_match("#\s+\s+([a-z\.0-9]+)$#", $ligne,$re)){
			if(strtolower(trim($re[1])=="interfaces")){continue;}
			echo "Removing {$re[1]}\n";
			$GLOBALS["SCRIPTS_DEL"][]="{$GLOBALS["brctlbin"]} delif $eth {$re[1]}";
			$GLOBALS["SCRIPTS_DEL"][]="{$GLOBALS["ifconfig"]} {$re[1]} down";
			continue;			
		}
		
		
	}
	
	$GLOBALS["SCRIPTS_DEL"][]="{$GLOBALS["ifconfig"]} $eth down";
	$GLOBALS["SCRIPTS_DEL"][]="{$GLOBALS["brctlbin"]} delbr $eth";	
	

	while (list ($id, $ligne) = each ($GLOBALS["SCRIPTS_DEL"]) ){
		echo "Starting......: ".date("H:i:s")." `$ligne`\n";
		shell_exec("$ligne");
	
	}	
	
}
function etc_hosts_defaults(){

	$ip=new IP();
	$datas=explode("\n",@file_get_contents("/etc/hosts"));
	foreach ($datas as $num=>$ligne){
		if(substr($ligne, 0,1)=="#"){continue;}
		if(preg_match("#^([0-9\.\:]+)\s+(.+?)\s+(.+?)$#",$ligne,$re)){
			$array[]=array("name"=>$re[2],"alias"=>$re[3],"ip"=>$re[1],"md"=>md5($ligne));
			continue;
		}
	
		if(preg_match("#^([0-9\.\:]+)\s+(.+?)$#",$ligne,$re)){
			$array[]=array("name"=>$re[2],"ip"=>$re[1],"md"=>md5($ligne));
			continue;
		}
	
	}
	
	foreach ($array as $num=>$ligne){
		if($ligne["name"]==null){if($ligne["alias"]<>null){$ligne["name"]=$ligne["alias"];$ligne["alias"]=null;}}
		$md5=md5("{$ligne["ip"]}{$ligne["name"]}");
		if(!$ip->isValid($ligne["ip"])){continue;}
		$f[]="('$md5','{$ligne["ip"]}','{$ligne["name"]}','{$ligne["alias"]}')";
	}  
	
	$q=new lib_sqlite("/home/artica/SQLITE/etc_hosts.db");
	$q->QUERY_SQL("INSERT INTO net_hosts (`zmd5`,`ipaddr`,`hostname`,`alias`) VALUES ".@implode(",", $f));
	
	
}

function dhcp_client(){
	$unix=new unix();
	$php5=$unix->LOCATE_PHP5_BIN();
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."]";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."]";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."] ************************************************";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."] Network interfaces Card in DHCP";
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."] ************************************************";
	$GLOBALS["SCRIPTS"][]="";

	$sql="SELECT Interface FROM `nics` WHERE `dhcp`=1 AND enabled=1";
	$q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");
	$results=$q->QUERY_SQL($sql,"artica_backup");
	if(!$q->ok){$GLOBALS["SCRIPTS"][]="# $q->mysql_error";}
	$Interfaces=array();
	
	foreach ($results as $index=>$ligne){
		$Interfaces[]=$ligne["Interface"];
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] {$ligne["Interface"]} is on DHCP client";

	}

	if(count($Interfaces)==0){
		$GLOBALS["SCRIPTS"][]="# [".__LINE__."] No interface is set";
		$GLOBALS["SCRIPTS"][]="$php5 /usr/share/artica-postfix/exec.kill.dhclient.php || true";
		remove_service("/etc/init.d/dhcp-client");
		if(is_file("/etc/monit/conf.d/APP_DHCP_CLIENT.monitrc")){
			@unlink("/etc/monit/conf.d/APP_DHCP_CLIENT.monitrc");
			system("/etc/init.d/monit restart");
		}
		return;
	}
	$GLOBALS["SCRIPTS"][]="# [".__LINE__."] install /etc/init.d/dhcp-client";
	$RSTMONIT=false;
	if(!is_file("/etc/monit/conf.d/APP_DHCP_CLIENT.monitrc")){$RSTMONIT=true;}
	$RST=false;
	if(is_file("/etc/init.d/dhcp-client")){$RST=true;}
	install_dhcpclient($Interfaces);
	if($RSTMONIT){system("/etc/init.d/monit restart");}
	if($RST){system("/etc/init.d/dhcp-client restart");}


}

function dhclient_pid(){
	$unix=new unix();
	$pid=$unix->get_pid_from_file("/var/run/dhcp-client.pid");
	if($unix->process_exists($pid)){return $pid;}
	return $unix->PIDOF($unix->find_program("dhclient"));
}

function start_dhclient($interfaces){
	$unix=new unix();
	$interfaces=trim(str_replace(",", " ", $interfaces));
	$dhclient_pid=dhclient_pid();
	if($unix->process_exists($dhclient_pid)){
		@file_put_contents("/var/run/dhcp-client.pid", $dhclient_pid);
		echo "dhclient: Already running $dhclient_pid\n";
		return;
	}

	if($interfaces==null){
		echo "dhclient: No interface defined\n";
		return;
	}
	$dhclient=$unix->find_program("dhclient");
	$nohup=$unix->find_program("nohup");
	echo "dhclient: Starting for $interfaces\n";
	$cmd="$nohup $dhclient -4 -lf /etc/dhclient.leases -pf /var/run/dhcp-client.pid $interfaces >/dev/null 2>&1 &";
	shell_exec($cmd);
	for($i=0;$i<6;$i++){
		$dhclient_pid=dhclient_pid();
		sleep(1);
		if($unix->process_exists($dhclient_pid)){
			echo "dhclient: Starting success pid $dhclient_pid\n";
			return;
		}
		sleep(1);
	}

}

function stop_dhclient(){
	$unix=new unix();
	$dhclient_pid=dhclient_pid();
	if(!$unix->process_exists($dhclient_pid)){
		@file_put_contents("/var/run/dhcp-client.pid", $dhclient_pid);
		echo "dhclient: Already stopped\n";
		return;
	}
	echo "dhclient: Stopping PID: $dhclient_pid\n";
	$unix->KILL_PROCESS($dhclient_pid);
	for($i=0;$i<6;$i++){
		$dhclient_pid=dhclient_pid();
		if(!$unix->process_exists($dhclient_pid)){echo "dhclient: Stopping success\n";return;}
		sleep(1);
		$unix->KILL_PROCESS($dhclient_pid);
	}
	$dhclient_pid=dhclient_pid();
	if(!$unix->process_exists($dhclient_pid)){echo "dhclient: Stopping success\n";return;}

	$unix->KILL_PROCESS($dhclient_pid,9);
	for($i=0;$i<6;$i++){
		$dhclient_pid=dhclient_pid();
		if(!$unix->process_exists($dhclient_pid)){echo "dhclient: Stopping success\n";return;}
		sleep(1);
		$unix->KILL_PROCESS($dhclient_pid,9);
	}
	if(!$unix->process_exists($dhclient_pid)){echo "dhclient: Stopping success\n";return;}
	echo "dhclient: Stopping failed\n";
}


function install_dhcpclient($interfaces){

	$interfaces_text=@implode(",", $interfaces);
	$unix=new unix();
	$php=$unix->LOCATE_PHP5_BIN();
	$filename=__FILE__;
	$dhclient=$unix->find_program("dhclient");
	$f[]="#!/bin/sh";
	$f[]="### BEGIN INIT INFO";
	$f[]="# Provides:          darkstat";
	$f[]="# Required-Start:    \$local_fs \$syslog \$network \$time";
	$f[]="# Required-Stop:     \$local_fs";
	$f[]="# Should-Start:";
	$f[]="# Should-Stop:";
	$f[]="# Default-Start:     3 4 5";
	$f[]="# Default-Stop:      0 1 6";
	$f[]="# Short-Description: dhcp client Daemon";
	$f[]="# chkconfig: 2345 11 89";
	$f[]="# description: Extensible, configurable dhcp client daemon";
	$f[]="### END INIT INFO";
	$f[]="case \"\$1\" in";
	$f[]=" start)";
	$f[]="   $php $filename --start-dhclient \"$interfaces_text\" \$2 \$3";
	$f[]="	 exit 0";
	$f[]="    ;;";
	$f[]="";
	$f[]="  stop)";
	$f[]="   $dhclient -pf /var/run/dhcp-client.pid -r";
	$f[]="   $php $filename --stop-dhclient \$2 \$3";
	$f[]="    ;;";
	$f[]="";
	$f[]=" restart)";
	$f[]="   $php $filename --stop-dhclient \$2 \$3";
	$f[]="   $php $filename --start-dhclient \"$interfaces_text\" \$2 \$3";
	$f[]="	 exit 0";
	$f[]="    ;;";
	$f[]="";
	$f[]=" reload)";
	$f[]="   $dhclient -pf /var/run/dhcp-client.pid -r";
	$f[]="   $php $filename --stop-dhclient \$2 \$3";
	$f[]="   $php $filename --start-dhclient \"$interfaces_text\" \$2 \$3";
	$f[]="	 exit 0";
	$f[]="    ;;";
	$f[]="";
	$f[]="  *)";
	$f[]="    echo \"Usage: \$0 {start|stop|restart} (+ '--verbose' for more infos)\"";
	$f[]="    exit 1";
	$f[]="    ;;";
	$f[]="esac";
	$f[]="exit 0\n";

	$INITD_PATH="/etc/init.d/dhcp-client";
	@unlink($INITD_PATH);
	@file_put_contents($INITD_PATH, @implode("\n", $f));
	@chmod($INITD_PATH,0755);

	if(is_file('/usr/sbin/update-rc.d')){
		shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." defaults >/dev/null 2>&1");
	}

	if(is_file('/sbin/chkconfig')){
		shell_exec("/sbin/chkconfig --add " .basename($INITD_PATH)." >/dev/null 2>&1");
		shell_exec("/sbin/chkconfig --level 345 " .basename($INITD_PATH)." on >/dev/null 2>&1");
	}

	monit_install();
	return true;

}
function monit_install(){
	$f=array();
	$f[]="check process APP_DHCP_CLIENT";
	$f[]="with pidfile /var/run/dhcp-client.pid";
	$f[]="start program = \"/etc/init.d/dhcp-client start --monit\"";
	$f[]="stop program =  \"/etc/init.d/dhcp-client stop --monit\"";
	$f[]="if 5 restarts within 5 cycles then timeout";
	$f[]="";
	@file_put_contents("/etc/monit/conf.d/APP_DHCP_CLIENT.monitrc", @implode("\n", $f));
	$f=array();
	//********************************************************************************************************************
	shell_exec("/usr/bin/monit -c /etc/monit/monitrc -p /var/run/monit/monit.pid reload");

}


function remove_service($INITD_PATH){
	if(!is_file($INITD_PATH)){return;}
	system("$INITD_PATH stop");
	if(is_file('/usr/sbin/update-rc.d')){shell_exec("/usr/sbin/update-rc.d -f " .basename($INITD_PATH)." remove >/dev/null 2>&1");}
	if(is_file('/sbin/chkconfig')){shell_exec("/sbin/chkconfig --del " .basename($INITD_PATH)." >/dev/null 2>&1");}
	if(is_file($INITD_PATH)){@unlink($INITD_PATH);}
}


function BUILD_SIMPLE_ROUTES(){
    $GLOBALS["SCRIPTS_ROUTES"]=array();
    $unix=new unix();
    $ip=$unix->find_program("ip");
    $php=$unix->LOCATE_PHP5_BIN();
    $q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");


    $EnableArticaAsGateway=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableArticaAsGateway"));
	$GLOBALS["SCRIPTS_ROUTES"][]="#";
	$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."]: EnableArticaAsGateway = $EnableArticaAsGateway";


	if($EnableArticaAsGateway==1){
		$GLOBALS["SCRIPTS_ROUTES"][]="# [".__LINE__."] Enable IP Forwarding and disable Reverse Path filter";
		$sysctl=$unix->find_program("sysctl");
		$GLOBALS["SCRIPTS_ROUTES"][]="$sysctl -w net.ipv4.ip_forward=1";
		$GLOBALS["SCRIPTS_ROUTES"][]="$sysctl -w net.ipv4.conf.default.rp_filter=0 >/dev/null 2>&1";
		$GLOBALS["SCRIPTS_ROUTES"][]="$sysctl -w net.ipv4.conf.all.rp_filter=0 >/dev/null 2>&1";
		$GLOBALS["SCRIPTS_ROUTES"][]="for f in /proc/sys/net/ipv4/conf/*/rp_filter; do echo 0 >| \$f ; done";
	}

    $GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route add 127.0.0.1 dev lo";


    $GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["echobin"]} \"\" > /etc/iproute2/rt_tables";
    $GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["echobin"]} \"100	tproxy\" >> /etc/iproute2/rt_tables";
    $GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["echobin"]} \"255	local\" >> /etc/iproute2/rt_tables";
    $GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["echobin"]} \"254	main\" >> /etc/iproute2/rt_tables";
    $GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["echobin"]} \"253	default\" >> /etc/iproute2/rt_tables";
    $GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["echobin"]} \"0	unspec\" >> /etc/iproute2/rt_tables";
    $GLOBALS["SCRIPTS_ROUTES"][]="$php /usr/share/artica-postfix/exec.network.ip-rules.flush.php";

    $sql="SELECT * FROM `nics` WHERE `enabled`='1' ORDER BY metric";
    $results=$q->QUERY_SQL($sql);
    $GLOBALS["SCRIPTS_ROUTES"][]="# ---- DEFAULT ROUTES ------------- [".__LINE__."]";
    foreach ($results as $index=>$ligne){
        $GATEWAY=$ligne["GATEWAY"];
        $metric=intval($ligne["metric"]);
        $INTERFACE=$ligne["Interface"];
        $GLOBALS["SCRIPTS_ROUTES"][]="# Main Route for Interface {$ligne["Interface"]} Gateway: $GATEWAY [".__LINE__."]";
        if($GATEWAY==null){continue;}
        if($GATEWAY=="0.0.0.0"){continue;}

        if(!MULTIPATH_GATEWAY($INTERFACE,null)){
            $GLOBALS["SCRIPTS_ROUTES"][]="# Default gateway for $INTERFACE [".__LINE__."]";
            $GLOBALS["SCRIPTS_ROUTES"][]="$ip route add $GATEWAY dev $INTERFACE";
            $GLOBALS["SCRIPTS_ROUTES"][]="$ip route add default via $GATEWAY dev $INTERFACE metric $metric";
        }
    }


    $routing_rules=$q->QUERY_SQL("SELECT * FROM routing_rules WHERE enabled=1");
	if(!$q->ok){echo "Starting......: ".date("H:i:s")." Mysql error : $q->mysql_error\n";return;}
	foreach ($routing_rules as $index=>$routing_ligne){
	        $nic=$routing_ligne["nic"];
	        $ID=$routing_ligne["ID"];
			routing_rules_simple($ID,$nic);
    }

    $GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} route flush cache || true";

}





function routing_rules_simple($ruleid,$nic){
	$GLOBALS["SCRIPTS_ROUTES"][]="#";
	$GLOBALS["SCRIPTS_ROUTES"][]="# routing_rules_specifics $ruleid $nic [".__LINE__."]";
	$ipclass=new IP();
	$q=new lib_sqlite("/home/artica/SQLITE/interfaces.db");
	if(!isset($GLOBALS["SCRIPTS_ROUTES_RULES"])){$GLOBALS["SCRIPTS_ROUTES_RULES"]=array();}




    $results=$q->QUERY_SQL("SELECT * FROM routing_rules_src WHERE ruleid='$ruleid' ORDER BY zOrder");
    if(!$q->ok){$GLOBALS["SCRIPTS_ROUTES"][]="# ".$q->mysql_error."!!! [".__LINE__."]";}
    $CuntOfSources=0;
    foreach ($results as $index=>$ligne){
        $CuntOfSources++;
        $pattern=$ligne["pattern"];
        $gateway=$ligne["gateway"];
        $priority=$ligne["metric"];
        $priority_cmd=null;
        $GLOBALS["SCRIPTS_ROUTES"][]="# $pattern -> $gateway prio $priority [".__LINE__."]";
        if($gateway=="0.0.0.0"){
            $GLOBALS["SCRIPTS_ROUTES"][]="# Gateway is 0.0.0.0, skip [".__LINE__."]";
            continue;
        }

        if($priority>0){$priority_cmd=" priority $priority";}
        $type=$ligne["type"];

        if($type==3){
            $GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} rule add nat $gateway from $pattern iif $nic {$priority_cmd} || true";
            continue;
        }
        if($type==4){
            $GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} rule add type blackhole from $pattern iif $nic {$priority_cmd} || true";
            continue;
        }

        if($type==5){
            $GLOBALS["SCRIPTS_ROUTES"][]="{$GLOBALS["ipbin"]} rule add type prohibit from $pattern iif $nic {$priority_cmd} || true";
            continue;
        }

    }

    $results=$q->QUERY_SQL("SELECT * FROM routing_rules_dest WHERE ruleid='$ruleid' ORDER BY zOrder,metric");


    foreach ($results as $index=>$ligne) {
        $pattern = trim($ligne["pattern"]);
        $priority = $ligne["metric"];
        $priority_cmd = null;
        $type = $ligne["type"];
        $GLOBALS["SCRIPTS_ROUTES"][] = "# [" . __LINE__ . "] pattern=$pattern, priority=$priority, type=$type";

        if ($priority > 0) {
            $priority_cmd = " priority $priority";
        }

        if ($type < 3) {
            if ($ligne["gateway"] <> null) {
                if($ligne["gateway"]=="0.0.0.0"){
                    $GLOBALS["SCRIPTS_ROUTES"][]="# Gateway is 0.0.0.0, skip [".__LINE__."]";
                    continue;
                }
                $GLOBALS["SCRIPTS_ROUTES"][] = "# [" . __LINE__ . "] $pattern via {$ligne["gateway"]}";
                if($pattern=="0.0.0.0/0.0.0.0"){$pattern="default";}

                if (!isset($GLOBALS["ALREADYADDED"][$pattern])) {
                    if($pattern<>"default") {
                        $GLOBALS["SCRIPTS_ROUTES"][] = "{$GLOBALS["ipbin"]} route add $pattern dev $nic";
                    }
                    $GLOBALS["ALREADYADDED"][$pattern] = true;
                }
                $GLOBALS["SCRIPTS_ROUTES"][] = "{$GLOBALS["ipbin"]} route add $pattern via {$ligne["gateway"]} dev $nic {$priority_cmd}";
                continue;
            }
        }
    }
}

//

?>

