<?php
include_once(dirname(__FILE__)."/frame.class.inc");
include_once(dirname(__FILE__)."/class.unix.inc");

if(isset($_GET["install"])){install();exit;}
if(isset($_GET["uninstall"])){uninstall();exit;}
if(isset($_GET["ipset"])){ipset();exit;}
if(isset($_GET["status"])){status();exit;}
if(isset($_GET["stop"])){stop();exit;}
if(isset($_GET["start"])){start();exit;}


foreach ($_GET as $num=>$line){$f[]="$num=$line";}
writelogs_framework("unable to understand query !!!!!!!!!!!..." .@implode(",",$f),"main()",__FILE__,__LINE__);
die("DIE " .__FILE__." Line: ".__LINE__);

function ipset(){

    $unix=new unix();
    $php5=$unix->LOCATE_PHP5_BIN();
    $nohup=$unix->find_program("nohup");
    $PROGRESS_FILE="/usr/share/artica-postfix/ressources/logs/web/nginxfw.ipset.progress";
    $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/nginxfw.ipset.log";

    @unlink($PROGRESS_FILE);
    @unlink($config["LOG_FILE"]);
    @touch($PROGRESS_FILE);
    @touch($config["LOG_FILE"]);
    @chmod($PROGRESS_FILE, 0755);
    @chmod($config["LOG_FILE"], 0755);
    $cmd="$nohup $php5 /usr/share/artica-postfix/exec.nginx.fw.php --ipset >{$config["LOG_FILE"]} 2>&1 &";
    writelogs_framework("$cmd",__FUNCTION__,__FILE__,__LINE__);
    shell_exec($cmd);
}
function stop(){

    $unix=new unix();
    $php5=$unix->LOCATE_PHP5_BIN();
    $nohup=$unix->find_program("nohup");
    $PROGRESS_FILE="/usr/share/artica-postfix/ressources/logs/web/nginxfw.stop.progress";
    $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/nginxfw.stop.txt";

    @unlink($PROGRESS_FILE);
    @unlink($config["LOG_FILE"]);
    @touch($PROGRESS_FILE);
    @touch($config["LOG_FILE"]);
    @chmod($PROGRESS_FILE, 0755);
    @chmod($config["LOG_FILE"], 0755);
    $cmd="$nohup $php5 /usr/share/artica-postfix/exec.nginx.fw.php --stop >{$config["LOG_FILE"]} 2>&1 &";
    writelogs_framework("$cmd",__FUNCTION__,__FILE__,__LINE__);
    shell_exec($cmd);
}
function start(){

    $unix=new unix();
    $php5=$unix->LOCATE_PHP5_BIN();
    $nohup=$unix->find_program("nohup");
    $PROGRESS_FILE="/usr/share/artica-postfix/ressources/logs/web/nginxfw.start.progress";
    $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/nginxfw.start.txt";

    @unlink($PROGRESS_FILE);
    @unlink($config["LOG_FILE"]);
    @touch($PROGRESS_FILE);
    @touch($config["LOG_FILE"]);
    @chmod($PROGRESS_FILE, 0755);
    @chmod($config["LOG_FILE"], 0755);
    $cmd="$nohup $php5 /usr/share/artica-postfix/exec.nginx.fw.php --start >{$config["LOG_FILE"]} 2>&1 &";
    writelogs_framework("$cmd",__FUNCTION__,__FILE__,__LINE__);
    shell_exec($cmd);
}


function install(){

    $unix=new unix();
    $php5=$unix->LOCATE_PHP5_BIN();
    $nohup=$unix->find_program("nohup");
    $PROGRESS_FILE="/usr/share/artica-postfix/ressources/logs/web/nginxfw.progress";
    $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/nginxfw.log";

    @unlink($PROGRESS_FILE);
    @unlink($config["LOG_FILE"]);
    @touch($PROGRESS_FILE);
    @touch($config["LOG_FILE"]);
    @chmod($PROGRESS_FILE, 0755);
    @chmod($config["LOG_FILE"], 0755);
    $cmd="$nohup $php5 /usr/share/artica-postfix/exec.nginx.fw.php --install >{$config["LOG_FILE"]} 2>&1 &";
    writelogs_framework("$cmd",__FUNCTION__,__FILE__,__LINE__);
    shell_exec($cmd);
}
function uninstall(){

    $unix=new unix();
    $php5=$unix->LOCATE_PHP5_BIN();
    $nohup=$unix->find_program("nohup");
    $PROGRESS_FILE="/usr/share/artica-postfix/ressources/logs/web/nginxfw.progress";
    $config["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/nginxfw.log";

    @unlink($PROGRESS_FILE);
    @unlink($config["LOG_FILE"]);
    @touch($PROGRESS_FILE);
    @touch($config["LOG_FILE"]);
    @chmod($PROGRESS_FILE, 0755);
    @chmod($config["LOG_FILE"], 0755);
    $cmd="$nohup $php5 /usr/share/artica-postfix/exec.nginx.fw.php --uninstall >{$config["LOG_FILE"]} 2>&1 &";
    writelogs_framework("$cmd",__FUNCTION__,__FILE__,__LINE__);
    shell_exec($cmd);
}

function status(){
    $unix=new unix();
    $ipset=$unix->find_program("ipset");
    $iptables_save=$unix->find_program("iptables-save");

    exec("$iptables_save 2>&1",$results);
    $OUT_STATUS=false;
    foreach ($results as $line){
        if(preg_match("#-A OUTPUT -p tcp -m owner --uid-owner.*?-m tcp.*?-j NGNIX_FW_DROP#",
            $line)){
            $OUT_STATUS=true;
            break;
            }

    }

    exec("$ipset -t -L nginxfww 2>&1",$sipset);

    foreach ($sipset as $line){
        if(preg_match("#(.*?):(.+)#",$line,$re)){
            $OUTWHITE[trim(strtoupper($re[1]))]=trim($re[2]);

        }

    }

    $OUTWHITE["STATUS"]=$OUT_STATUS;
    @file_put_contents("/usr/share/artica-postfix/ressources/logs/nginxfw.out.status",serialize($OUTWHITE));







}


