<?php
include_once(dirname(__FILE__)."/ressources/class.template-admin.inc");if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__)."/ressources/class.system.network.inc");
if(isset($_GET["verbose"])){$GLOBALS["VERBOSE"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}
if(isset($_GET["table"])){table();exit;}
if(isset($_POST["EnableDNSRootInts"])){save();exit;}
if(isset($_GET["unbound-status"])){unbound_status();exit;}
if(isset($_GET["tabs"])){tabs();exit;}
if(isset($_GET["config-file-js"])){config_file_js();exit;}
if(isset($_GET["config-file-popup"])){config_file_popup();exit;}
page();
function page(){
	$page=CurrentPageName();
	$tpl=new template_admin();
	$UnboundVersion=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundVersion");
	$Title="{APP_UNBOUND} v{$UnboundVersion}";
    $EnableDNSDist=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableDNSDist"));
    $explain="{didyouknow_unbound}";
    $raccourci="dns-cache";

    if($EnableDNSDist==1){
        $APP_DNSDIST_VERSION=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("APP_DNSDIST_VERSION");
        $Title="{APP_DNSDIST} v{$APP_DNSDIST_VERSION}";
        $explain="{APP_DNSDIST_EXPLAIN}";
        $raccourci="dns-load-balancing";
    }

	$html="
	<div class=\"row border-bottom white-bg dashboard-header\">
	<div class=\"col-sm-12\"><h1 class=ng-binding>$Title</h1>
	<p>$explain</p>
	</div>

	</div>



	<div class='row'><div id='progress-unbound-restart'></div>
	<div class='ibox-content'>

	<div id='table-loader-dns-servers'></div>

	</div>
	</div>



	<script>
	$.address.state('/');
	$.address.value('/$raccourci');
	LoadAjax('table-loader-dns-servers','$page?tabs=yes');

	</script>";
	
	if(isset($_GET["main-page"])){
		$tpl=new template_admin(null,$html);
		echo $tpl->build_firewall();
		return;
	}

	$tpl=new templates();
	echo $tpl->_ENGINE_parse_body($html);

}
function config_file_js(){
	$page=CurrentPageName();
	$tpl=new template_admin();
	$users=new usersMenus();
	if(!$users->AsSystemAdministrator){$tpl->js_no_privileges();return;}
	$tpl->js_dialog1("{APP_UNBOUND} >> {config_file}", "$page?config-file-popup=yes");

}
function config_file_popup(){
	$page=CurrentPageName();
	$tpl=new template_admin();
	$sock=new sockets();
	$sock->getFrameWork("sshd.php?config-file=yes");
	$data=@file_get_contents("/etc/unbound/unbound.conf");
	$form[]=$tpl->field_textareacode("configfile", null, $data);

	$ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/sshd.progress";
	$ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/sshd.log";
	$ARRAY["CMD"]="sshd.php?reconfigure=yes";
	$ARRAY["TITLE"]="{apply_parameters}";
	$prgress=base64_encode(serialize($ARRAY));
	$jsafter="Loadjs('fw.progress.php?content=$prgress&mainid=progress-sshd-restart')";

	echo $tpl->form_outside("{config_file}", @implode("", $form),"{display_generated_configuration_file}",null,$jsafter,"AsSystemAdministrator");

}


function tabs(){
	$page=CurrentPageName();
	$tpl=new template_admin();
	$sock=new sockets();
	$MUNIN=false;
    $UnboundEnabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundEnabled"));
	$MUNIN_CLIENT_INSTALLED=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("MUNIN_CLIENT_INSTALLED"));
	$EnableMunin=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableMunin"));
	if($MUNIN_CLIENT_INSTALLED==1){if($EnableMunin==1){$MUNIN=true;}}

	$array["{status}"]="$page?table=yes";
    $array["{networks_restrictions}"]="fw.pdns.restrictions.php";
    if($UnboundEnabled==1) {$array["{cache}"]="fw.dns.unbound.cache.php";}
	
	$EnableDNSCryptProxy=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableDNSCryptProxy"));

    if($EnableDNSCryptProxy==1){
		$array["{APP_DNSCRYPT_PROXY}"]="fw.dnscrypt-proxy.php";
	}
    $UnboundRedisEnabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundRedisEnabled"));

	if($UnboundRedisEnabled==1){
        $array["{UBOUND_REDIS}"] = "fw.dns.unbound.redis.php";

    }


	
	
	if($UnboundEnabled==1) {
        if ($MUNIN) {
            $array["{statistics}"] = "fw.unbound.statistics.php";
        }
    }
	echo $tpl->tabs_default($array);

}

function unbound_status(){
    $page=CurrentPageName();
    $EnableDNSDist=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableDNSDist"));
    $UnboundRedisEnabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundRedisEnabled"));
    if($EnableDNSDist==1){
        $tpl=new template_admin();
        $GLOBALS["CLASS_SOCKETS"]->getFrameWork("dnsdist.php?status=yes");
        $bsini=new Bs_IniHandler("/usr/share/artica-postfix/ressources/logs/web/dnsdist.status");

        $ARRAY["PROGRESS_FILE"] = "/usr/share/artica-postfix/ressources/logs/web/dnsdist.restart";
        $ARRAY["LOG_FILE"] = "/usr/share/artica-postfix/ressources/logs/web/dnsdist.restart.log";
        $ARRAY["CMD"] = "dnsdist.php?restart=yes";
        $ARRAY["TITLE"] = "{APP_DNSDIST} {restarting_service}";
        $ARRAY["AFTER"]="LoadAjaxSilent('unbound-status','$page?unbound-status=yes');";
        $prgress=base64_encode(serialize($ARRAY));
        $jsRestart="Loadjs('fw.progress.php?content=$prgress&mainid=progress-unbound-restart')";
        $final[]=$tpl->SERVICE_STATUS($bsini, "APP_DNSDIST",$jsRestart);
        echo $tpl->_ENGINE_parse_body($final);
        return;
    }

	$sock=new sockets();
	$sock->getFrameWork("unbound.php?status=yes");
	$bsini=new Bs_IniHandler("/usr/share/artica-postfix/ressources/logs/web/unbound.status");
	$tpl=new template_admin();

	$EnableDNSCryptProxy=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableDNSCryptProxy"));
	$PDNSStatsEnabled=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PDNSStatsEnabled"));
	
	$ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php";
	$ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php.log";
	$ARRAY["CMD"]="unbound.php?restart=yes";
	$ARRAY["TITLE"]="{APP_UNBOUND} {restarting_service}";
	$ARRAY["AFTER"]="LoadAjaxSilent('unbound-status','$page?unbound-status=yes');";
	$prgress=base64_encode(serialize($ARRAY));
	$jsRestart="Loadjs('fw.progress.php?content=$prgress&mainid=progress-unbound-restart')";
	
	$ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/pdns.dsc.progress";
	$ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/pdns.dsc.progress.txt";
	$ARRAY["CMD"]="pdns.php?restart-dsc=yes";
	$ARRAY["TITLE"]="{APP_DSC} {restarting_service}";
	$ARRAY["AFTER"]="LoadAjaxSilent('unbound-status','$page?unbound-status=yes');";
	$prgress=base64_encode(serialize($ARRAY));
	$jsRestartDSC="Loadjs('fw.progress.php?content=$prgress&mainid=progress-unbound-restart')";
	
	
	$ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/DNSCryptProxy.restart.progress";
	$ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/DNSCryptProxy.restart.progress.log";
	$ARRAY["CMD"]="dnscrypt-proxy.php?restart=yes";
	$ARRAY["TITLE"]="{APP_DNSCRYPT_PROXY} {restarting_service}";
	$ARRAY["AFTER"]="LoadAjaxSilent('unbound-status','$page?unbound-status=yes');";
	$prgress=base64_encode(serialize($ARRAY));
	$jsRestartDNSCrypt="Loadjs('fw.progress.php?content=$prgress&mainid=progress-unbound-restart')";

    $ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/DNSCryptProxy.restart.progress";
    $ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/DNSCryptProxy.restart.progress.log";
    $ARRAY["CMD"]="dnscrypt-proxy.php?restart=yes";
    $ARRAY["TITLE"]="{APP_DNSCRYPT_PROXY} {restarting_service}";
    $ARRAY["AFTER"]="LoadAjaxSilent('unbound-status','$page?unbound-status=yes');";
    $prgress=base64_encode(serialize($ARRAY));
    $jsRestartDNSCrypt="Loadjs('fw.progress.php?content=$prgress&mainid=progress-unbound-restart')";


    $ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php";
    $ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/unbound.install.php.log";
    $ARRAY["CMD"]="unbound.php?restart-redis=yes";
    $ARRAY["TITLE"]="{UBOUND_REDIS} {restarting_service}";
    $ARRAY["AFTER"]="LoadAjaxSilent('unbound-status','$page?unbound-status=yes');";
    $jsRedisRestart=base64_encode(serialize($ARRAY));


	
	
	
	
	$btn_config=$tpl->button_autnonome("{config_file}", "Loadjs('$page?config-file-js=yes')", "fas fa-file-code","AsSystemAdministrator",335);
	
	$final[]=$tpl->SERVICE_STATUS($bsini, "APP_UNBOUND",$jsRestart);

	if($UnboundRedisEnabled==1){
        $final[]=$tpl->SERVICE_STATUS($bsini, "UBOUND_REDIS",$jsRedisRestart);
    }


	if($PDNSStatsEnabled==1) {
        $final[] = $tpl->SERVICE_STATUS($bsini, "APP_DSC", $jsRestartDSC);
    }


    if($EnableDNSCryptProxy==1) {
        $final[] = $tpl->SERVICE_STATUS($bsini, "APP_DNSCRYPT_PROXY", $jsRestartDNSCrypt);
    }


    $final[]="$btn_config";
    VERBOSE(count($final)." row",__LINE__);
    echo $tpl->_ENGINE_parse_body($final);
	
}

function table(){

	$tpl=new template_admin();
	$page=CurrentPageName();
	$sock=new sockets();
	$resolv=new resolv_conf();
	$users=new usersMenus();

	$EnableDNSRootInts=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableDNSRootInts"));
	$UnboundDisplayVersion=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundDisplayVersion"));
	$DNSDistSetServerPolicy=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DNSDistSetServerPolicy"));
    $EnableUnBoundSNMPD=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableUnBoundSNMPD"));
	if($DNSDistSetServerPolicy==null){$DNSDistSetServerPolicy="leastOutstanding";}
	
	if(!is_file("/etc/artica-postfix/settings/Daemons/UnBoundCacheMinTTL")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("UnBoundCacheMinTTL", 3600);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/UnBoundCacheMAXTTL")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("UnBoundCacheMAXTTL", 172800);}
	if(!is_file("/etc/artica-postfix/settings/Daemons/UnBoundCacheNEGTTL")){$GLOBALS["CLASS_SOCKETS"]->SET_INFO("UnBoundCacheNEGTTL", 3600);}



    $ipclass=new IP();
	$UnBoundCacheSize=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnBoundCacheSize"));
	$UnBoundCacheMinTTL=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnBoundCacheMinTTL"));
	$UnBoundCacheMAXTTL=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnBoundCacheMAXTTL"));
	$UnBoundCacheNEGTTL=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnBoundCacheNEGTTL"));
	$UnboundOutGoingInterface=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundOutGoingInterface"));
	$EnableUnboundBlackLists=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableUnboundBlackLists"));
	$ListenOnlyLoopBack=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ListenOnlyLoopBack"));
	$EnableUnboundLogQueries=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableUnboundLogQueries"));
    $EnableUnboundLogSyslog=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableUnboundLogSyslog"));
    $UnboundLogSyslogServer=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundLogSyslogServer"));
    $UnboundLogSyslogServerPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundLogSyslogServerPort"));
    $UnboundLogSyslogServerTCP=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundLogSyslogServerTCP"));
    $UnboundLogSyslogUseSSL=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundLogSyslogUseSSL"));
    $UnboundLogSyslogCertificate=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundLogSyslogCertificate"));
    if($UnboundLogSyslogServerPort==0){$UnboundLogSyslogServerPort=514;}
    $UnboundLogSyslogDoNotStorelogsLocally=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundLogSyslogDoNotStorelogsLocally"));

	$forcesafesearch=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("GoogleSafeSearchAddress"));
	if(!$ipclass->isValid($forcesafesearch)){$forcesafesearch=null;}
	if($forcesafesearch==null){$forcesafesearch=gethostbyname("forcesafesearch.google.com");}
	if(!$ipclass->isValid($forcesafesearch)){$forcesafesearch=null;}

   $UnboundTLSEnable=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundTLSEnable"));
    $UnboundTLSCertificate=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundTLSCertificate"));
    $UnboundTLSPort=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("UnboundTLSPort"));
    if($UnboundTLSPort==0){$UnboundTLSPort=853;}

    if($UnBoundCacheMinTTL==0){$UnBoundCacheMinTTL=3600;}
    if($UnBoundCacheMAXTTL==0){$UnBoundCacheMAXTTL=172800;}
    if($UnBoundCacheNEGTTL==0){$UnBoundCacheNEGTTL=3600;}


    $TIMES[-1]="{not_used}";
	$TIMES[10]="10 {seconds}";
	$TIMES[20]="20 {seconds}";
	$TIMES[30]="30 {seconds}";
	$TIMES[60]="1 {minute}";
	$TIMES[300]="5 {minutes}";
	$TIMES[900]="15 {minutes}";
	$TIMES[1800]="30 {minutes}";
	$TIMES[3600]="1 {hour}";
	$TIMES[7200]="2 {hours}";
	$TIMES[10800]="3 {hours}";
	$TIMES[14400]="4 {hours}";
	$TIMES[28800]="8 {hours}";
	$TIMES[57600]="16 {hours}";
	$TIMES[86400]="1 {day}";
	$TIMES[172800]="2 {days}";
	$TIMES[604800]="7 {days}";

    $algo["chashed"]="{strict-hashed-ip}";
    $algo["roundrobin"]="{round-robin}";
    $algo["leastOutstanding"]="{leastconn}";
    $algo["firstAvailable"]="{firstAvailable}";
	
	if($UnBoundCacheSize==0){$UnBoundCacheSize=100;}
	
	$PowerDNSListenAddr=explode("\n",trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("PowerDNSListenAddr")));
	$EnableSNMPD=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableSNMPD"));
	
	$InComingInterfaces=@implode(",", $PowerDNSListenAddr);

    $EnableDNSDist=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableDNSDist"));
	if($EnableDNSDist==0) {
        $form[] = $tpl->field_checkbox("UnboundDisplayVersion", "{display_servername_version}", $UnboundDisplayVersion, false, null);
        $form[] = $tpl->field_checkbox("EnableDNSRootInts", "{EnableDNSRootInts}", $EnableDNSRootInts, false, "{EnableDNSRootInts_explain}");
    }else{
        $tpl->field_hidden("UnboundDisplayVersion",$UnboundDisplayVersion);
        $tpl->field_hidden("EnableDNSRootInts",$EnableDNSRootInts);
        $form[]=$tpl->field_array_hash($algo,"DNSDistSetServerPolicy","{method}",$DNSDistSetServerPolicy);
    }
	
	
	$form[]=$tpl->field_interfaces_choose("InComingInterfaces", "{listen_interfaces}", $InComingInterfaces);
	$form[]=$tpl->field_checkbox("ListenOnlyLoopBack","{listen_only_loopback}",$ListenOnlyLoopBack);
	$form[]=$tpl->field_interfaces("UnboundOutGoingInterface", "{outgoing_interface}", $UnboundOutGoingInterface);

	if($EnableSNMPD==1){
        $form[] = $tpl->field_checkbox("EnableUnBoundSNMPD", "{enable_snmp}", $EnableUnBoundSNMPD, false);

    }

	//



    if($EnableDNSDist==0) {
        $form[] = $tpl->field_section("{DNSOTLS}", "{DNSOTLS_EXPLAIN}");
        $form[] = $tpl->field_checkbox("UnboundTLSEnable", "{DNSOTLS_ENABLE}", $UnboundTLSEnable, "UnboundTLSCertificate", "UnboundTLSPort");
        $form[] = $tpl->field_numeric("UnboundTLSPort", "{listen_port}", $UnboundTLSPort);
        $form[] = $tpl->field_certificate("UnboundTLSCertificate", "{certificate}", $UnboundTLSCertificate);
    }else{
        $tpl->field_hidden("UnboundTLSEnable",$UnboundTLSEnable);
        $tpl->field_hidden("UnboundTLSPort",$UnboundTLSPort);
        $tpl->field_hidden("UnboundTLSCertificate",$UnboundTLSCertificate);

    }


    $form[] = $tpl->field_section("{events}","");
    $form[]=$tpl->field_checkbox("EnableUnboundLogQueries","{log_queries}",$EnableUnboundLogQueries);
    if($EnableDNSDist==0) {
        if ($GLOBALS["CLASS_SOCKETS"]->CORP_LICENSE()) {

            if (!is_file("/usr/lib/x86_64-linux-gnu/rsyslog/lmnsd_gtls.so")) {
                $form[] = "<div class='alert alert-danger'>{missing} rsyslog-gnutls (lmnsd_gtls.so)</div>";
            }


            $form[] = $tpl->field_checkbox("EnableUnboundLogSyslog", "{send_syslog_logs}", $EnableUnboundLogSyslog, "UnboundLogSyslogServer");
            $form[] = $tpl->field_checkbox("UnboundLogSyslogDoNotStorelogsLocally", "{not_store_log_locally}", $UnboundLogSyslogDoNotStorelogsLocally);
            $form[] = $tpl->field_ipv4("UnboundLogSyslogServer", "{remote_syslog_server}", $UnboundLogSyslogServer);
            $form[] = $tpl->field_numeric("UnboundLogSyslogServerPort", "{listen_port}", $UnboundLogSyslogServerPort);
            $form[] = $tpl->field_checkbox("UnboundLogSyslogServerTCP", "{enable_tcpsockets}", $UnboundLogSyslogServerTCP);
            $form[] = $tpl->field_checkbox("UnboundLogSyslogUseSSL", "{useSSL}", $UnboundLogSyslogUseSSL);
            $form[] = $tpl->field_certificate("UnboundLogSyslogCertificate", "{certificate}", $UnboundLogSyslogCertificate);


        }
    }else{
        $tpl->field_hidden("EnableUnboundLogSyslog",$EnableUnboundLogSyslog);
        $tpl->field_hidden("UnboundLogSyslogDoNotStorelogsLocally",$UnboundLogSyslogDoNotStorelogsLocally);
        $tpl->field_hidden("UnboundTLSPort",$UnboundTLSPort);
        $tpl->field_hidden("UnboundLogSyslogServer",$UnboundLogSyslogServer);
        $tpl->field_hidden("UnboundLogSyslogServerPort",$UnboundLogSyslogServerPort);
        $tpl->field_hidden("UnboundLogSyslogServerTCP",$UnboundLogSyslogServerTCP);
        $tpl->field_hidden("UnboundLogSyslogUseSSL",$UnboundLogSyslogUseSSL);
        $tpl->field_hidden("UnboundLogSyslogCertificate",$UnboundLogSyslogCertificate);
    }

    $form[] = $tpl->field_section("{cache}");
	$form[]=$tpl->field_numeric("UnBoundCacheSize", "{cache_size} (MB)", $UnBoundCacheSize);
	$form[]=$tpl->field_array_hash($TIMES, "UnBoundCacheMinTTL", "{cache-ttl} (Min)", $UnBoundCacheMinTTL);
	$form[]=$tpl->field_array_hash($TIMES, "UnBoundCacheMAXTTL", "{cache-ttl} (Max)", $UnBoundCacheMAXTTL);
	$form[]=$tpl->field_array_hash($TIMES, "UnBoundCacheNEGTTL", "{negquery-cache-ttl}", $UnBoundCacheNEGTTL);
    if($EnableDNSDist==0) {
        $form[] = $tpl->field_checkbox("EnableUnboundBlackLists", "{activate_dns_blacklists}", $EnableUnboundBlackLists, false, "{activate_dns_blacklists_explain}");
    }else{
        $tpl->field_hidden("EnableUnboundBlackLists",$EnableUnboundBlackLists);
    }

	$title="{local_dns_service}";
    if($EnableDNSDist==1) {$title="{APP_DNSDIST}";}

	$myform=$tpl->form_outside($title, @implode("\n", $form),null,"{apply}","Loadjs('fw.dns.unbound.restart.php');","AsDnsAdministrator");
	
	$html="<table style='width:100%'>
	<tr>
		<td style='vertical-align:top;width:240px'><div id='unbound-status' style='margin-top:15px'></div></td>
		<td	style='vertical-align:top;width:90%'>$myform</td>
	</tr>
	</table>
	<script>LoadAjaxSilent('unbound-status','$page?unbound-status=yes');</script>	
	";
	
	
	echo $tpl->_ENGINE_parse_body($html);
}


function save(){
	$sock=new sockets();
	$tpl=new template_admin();
	$tpl->CLEAN_POST();
	
	if($_POST["UnboundEnabled"]==0){$_POST["EnableUnboundBlackLists"]=0;}
	$EnableUnboundBlackLists=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableUnboundBlackLists"));
    $EnableUnBoundSNMPD=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableUnBoundSNMPD"));
	
	if(isset($_POST["InComingInterfaces"])){
		$array=explode(",",$_POST["InComingInterfaces"]);
		$sock->SaveConfigFile(@implode("\n", $array), "PowerDNSListenAddr");
		unset($_POST["InComingInterfaces"]);
	}
	
	
    $tpl->SAVE_POSTs();
	
	if($_POST["EnableUnboundBlackLists"]<>$EnableUnboundBlackLists){$sock->getFrameWork("unbound.php?blacklists-enable=yes");}
	if($_POST["EnableUnBoundSNMPD"]<>$EnableUnBoundSNMPD){$sock->getFrameWork("snmpd.php?restart=yes");}
	
		
	
	
	
}




