<?php
include_once(dirname(__FILE__)."/ressources/class.template-admin.inc");if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__)."/ressources/class.system.network.inc");
if(isset($_GET["verbose"])){$GLOBALS["VERBOSE"]=true;ini_set('display_errors', 1);ini_set('error_reporting', E_ALL);ini_set('error_prepend_string',null);ini_set('error_append_string',null);}

page();

function page(){

    $tpl=new template_admin();

    try {
        $redis = new Redis();
        $redis->connect("127.0.0.1", 21647, 2);
    } catch (Exception $e) {
        echo $tpl->div_error($e->getMessage());
        die();
    }


    try {
        $ALL_KEYS = $redis->keys("*");
    } catch (Exception $e) {
        echo $tpl->div_error($e->getMessage());
        die();
    }

    $CountOfKeys=count($ALL_KEYS);

    $infos=$redis->info();

    $maxmemory_human=$infos["maxmemory_human"];
    $total_connections_received=$tpl->FormatNumber($infos["total_connections_received"]);
    $mem=FormatBytes(($infos["used_memory"]+$infos["used_memory_rss"])/1024);

    $html[]="<h1 style='margin-top:10px'>{UBOUND_REDIS} v{$infos["redis_version"]}</h1>";
    $html[]="<H2>{memory}: $mem / $maxmemory_human</H2>";



    $html[]="<table style='width:100%'>";
    $html[]="<tr>";
    $html[]="<td style='padding-left: 10px' width='1%' nowrap>";
    $html[]= $tpl->widget_vert("{connections}",$total_connections_received);
    $html[]="</td>";

    $html[]="<td style='padding-left: 10px' width='1%' nowrap>";
    if($CountOfKeys==0){
        $html[]= $tpl->widget_rouge("{records}","0 !");
    }else{
        $html[]= $tpl->widget_vert("{records}",$tpl->FormatNumber($CountOfKeys));
    }
    $html[]="</td>";
    $html[]="<td style='padding-left: 10px' width='1%' nowrap>";
    try{
        if($redis->set("TESTKEY","TESTVALUE",2)) {
            if(method_exists($redis,"unlink")){
                $redis->unlink("TESTKEY");
            }else{
                $redis->delete("TESTKEY");
            }

            $html[]=$tpl->widget_vert("{write}","OK");
        }else{
            $html[]=$tpl->widget_vert("{write}","{failed}");
        }


    } catch (Exception $e) {
        $html[]=$tpl->widget_rouge("{write}",$e->getMessage());
    }
    $html[]="</td>";
    $html[]="<td style='padding-left: 10px' width='99%' nowrap>&nbsp;</td>";

    $html[]="</tr>";
    $html[]="</table>";

    echo $tpl->_ENGINE_parse_body($html);


}