<?php
include_once(dirname(__FILE__)."/ressources/class.template-admin.inc");if(!isset($GLOBALS["CLASS_SOCKETS"])){if(!class_exists("sockets")){include_once("/usr/share/artica-postfix/ressources/class.sockets.inc");}$GLOBALS["CLASS_SOCKETS"]=new sockets();}
include_once(dirname(__FILE__)."/ressources/class.system.network.inc");
include_once(dirname(__FILE__)."/ressources/class.nginx.params.inc");

if(isset($_POST["ModSecurityAction"])){Save();exit;}
if(isset($_GET["table"])){table();exit;}
if(isset($_GET["tabs"])){tabs();exit;}
if(isset($_GET["parameters-start"])){parameters_start();exit;}
if(isset($_GET["parameters"])){parameters();exit;}



page();

function page(){
	$page=CurrentPageName();
	$tpl=new template_admin();
$ModSecurityPatternCount=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ModSecurityPatternCount"));
$ModSecurityPatternVersion=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ModSecurityPatternVersion"));
	$title=$tpl->_ENGINE_parse_body("Web Application Firewall");
	$js="LoadAjax('table-waf','$page?tabs=yes');";
	
	

	$html="
	<div class=\"row border-bottom white-bg dashboard-header\">
	    <div class=\"col-sm-12\"><h1 class=ng-binding>$title <H3>$ModSecurityPatternCount {rules} v$ModSecurityPatternVersion</h3></H1>
	        <p>{ModSecurityExplain}</p>
	    </div>
	</div>
    <div class='row'><div id='progress-waf'></div>
	<div class='ibox-content' style='min-height:600px'>
    	<div id='table-waf'></div>
    </div>
	<script>
	$.address.state('/');
	$.address.value('/waf');
	$.address.title('Artica: Web Application firewall');
	$js
	</script>";
	
	if(isset($_GET["main-page"])){
		$tpl=new template_admin("Artica: Web Application firewall {status}",$html);
		echo $tpl->build_firewall();
		return;
	}

	$tpl=new templates();
	echo $tpl->_ENGINE_parse_body($html);

}

function tabs(){
	$page=CurrentPageName();
	$tpl=new template_admin();
	
	
	$array["{parameters}"]="$page?parameters-start=yes";
    $array["{rules}"]="fw.modsecurity.rules.php";
    $array["{service_events}"]="fw.modsecurity.events.php";
	//$array["{parameters}"]="$page?parameters=yes";
	//$array["{statistics} {messages}"]="$page?stats-mailstats=yes";
	//$array["{statistics} {volumes}"]="$page?stats-mailvolume=yes";
	echo $tpl->tabs_default($array);
}
function parameters_start(){
    $page=CurrentPageName();
    echo "<div id='modsec-params' style='margin-top:10px'></div><script>LoadAjax('modsec-params','$page?parameters=yes');</script>";
}

function parameters(){
	$page=CurrentPageName();
	$tpl=new template_admin();

    $ModSecurityHTTPBL=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ModSecurityHTTPBL"));
    $ModSecurityDoS=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ModSecurityDoS"));
    $ModSecurityDoSRqs=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ModSecurityDoSRqs"));
    $ModSecurityDoSTT=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ModSecurityDoSTT"));
    $ModSecurityDoSBK=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ModSecurityDoSBK"));
    $enforce_bodyproc_urlencoded=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("enforce_bodyproc_urlencoded"));
    $crs_validate_utf8_encoding=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("crs_validate_utf8_encoding"));
    if($ModSecurityDoSRqs==0){$ModSecurityDoSRqs=100;}
    if($ModSecurityDoSTT==0){$ModSecurityDoSTT=60;}
    if($ModSecurityDoSBK==0){$ModSecurityDoSBK=600;}

    $SecHttpBlKey=trim($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SecHttpBlKey"));
    $SecHttpBlSE=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SecHttpBlSE"));
    $SecHttpBlSus=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SecHttpBlSus"));
    $SecHttpBlHar=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SecHttpBlHar"));
    $SecHttpBlSpam=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SecHttpBlSpam"));

    $do_reput_block=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("do_reput_block"));
    $reput_block_duration=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("reput_block_duration"));
    if($reput_block_duration==0){$reput_block_duration=300;}

	$ModSecurityAction=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("ModSecurityAction");
	$ModSecurityParanoiaLevel=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ModSecurityParanoiaLevel"));
    $ModSecurityMaxArgs=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ModSecurityMaxArgs"));
    $ModSecurityMaxArgName=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ModSecurityMaxArgName"));
    $ModSecurityMaxArgValue=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ModSecurityMaxArgValue"));
    $ModSecurityDebug=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ModSecurityDebug"));

	if($ModSecurityAction==null){$ModSecurityAction="auditlog,pass";}
	if($ModSecurityParanoiaLevel==0){$ModSecurityParanoiaLevel=2;}


	$sModSecurityAction["auditlog,pass"]="{alert_and_pass}";
    $sModSecurityAction["auditlog,deny,status:405"]="{alert_and_block}";

    $sModSecurityParanoiaLevel[1]="{level} 1";
    $sModSecurityParanoiaLevel[2]="{level} 2";
    $sModSecurityParanoiaLevel[3]="{level} 3";
    $sModSecurityParanoiaLevel[4]="{level} 4";

    $ModSecurityDebugS[0]="{none}";
    $ModSecurityDebugS[1]="{errors}";
    $ModSecurityDebugS[2]="{warning}";
    $ModSecurityDebugS[3]="{notices}";
    $ModSecurityDebugS[4]="{informational}";
    $ModSecurityDebugS[5]="{detailed}";
    $ModSecurityDebugS[6]="{everything}";


    $form[]=$tpl->field_array_hash($sModSecurityAction,"ModSecurityAction","nonull:{default_action}",$ModSecurityAction);
    $form[]=$tpl->field_array_hash($sModSecurityParanoiaLevel,"ModSecurityParanoiaLevel","nonull:{OPT_SPAM_RATE_LIMIT}",$ModSecurityParanoiaLevel);
    $form[]=$tpl->field_array_hash($ModSecurityDebugS,"ModSecurityDebug","nonull:{debug_mode}",$ModSecurityDebug);
    $form[]=$tpl->field_numeric("ModSecurityMaxArgs","{maximum_number_of_arguments}",$ModSecurityMaxArgs);
    $form[]=$tpl->field_numeric("ModSecurityMaxArgName","{maximum_number_of_argument_name}",$ModSecurityMaxArgName);
    $form[]=$tpl->field_numeric("ModSecurityMaxArgValue","{maximum_number_of_argument_value}",$ModSecurityMaxArgValue);

    $form[]=$tpl->field_checkbox("enforce_bodyproc_urlencoded","{enforce_bodyproc_urlencoded}",$enforce_bodyproc_urlencoded);
    $form[]=$tpl->field_checkbox("crs_validate_utf8_encoding","{crs_validate_utf8_encoding}",$crs_validate_utf8_encoding);





    $form[]=$tpl->field_section("Honey Pot HTTP Blacklist");
    $form[]=$tpl->field_checkbox("ModSecurityHTTPBL","{enable_feature}",$ModSecurityHTTPBL,"SecHttpBlKey,SecHttpBlSE,SecHttpBlSus,SecHttpBlHar,SecHttpBlSpam");
    $form[]=$tpl->field_text("SecHttpBlKey","{API_KEY}",$SecHttpBlKey);

    $form[]=$tpl->field_checkbox("SecHttpBlSE","{xapian_packages}",$SecHttpBlSE);
    $form[]=$tpl->field_checkbox("SecHttpBlSus","{Suspicious}",$SecHttpBlSus);
    $form[]=$tpl->field_checkbox("SecHttpBlHar","{harvester}",$SecHttpBlHar);
    $form[]=$tpl->field_checkbox("SecHttpBlSpam","{comment_spammer}",$SecHttpBlSpam);

    $form[]=$tpl->field_section("{dos_protection}");
    $form[]=$tpl->field_checkbox("ModSecurityDoS","{enable_feature}",$ModSecurityDoS,"ModSecurityDoSRqs,ModSecurityDoSTT,ModSecurityDoSBK");
    $form[]=$tpl->field_numeric("ModSecurityDoSRqs","{MX_REQUESTS}",$ModSecurityDoSRqs);
    $form[]=$tpl->field_numeric("ModSecurityDoSTT","{during} ({seconds})",$ModSecurityDoSTT);
    $form[]=$tpl->field_numeric("ModSecurityDoSBK","{deny} {during} ({seconds})",$ModSecurityDoSBK);

    $form[]=$tpl->field_section("{do_reput_block}");
    $form[]=$tpl->field_checkbox("do_reput_block","{enable_feature}",$do_reput_block,"reput_block_duration");
    $form[]=$tpl->field_numeric("reput_block_duration","{during} ({seconds})",$reput_block_duration);



	$ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/web/modsecurity.progress";
	$ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/web/modsecurity.progress.log";
	$ARRAY["CMD"]="nginx.php?reconfigure-modsecurity=yes";
	$ARRAY["TITLE"]="{reconfigure}";
	$ARRAY["AFTER"]="LoadAjax('modsec-params','$page?parameters=yes');";
	$prgress=base64_encode(serialize($ARRAY));
	$service_restart="Loadjs('fw.progress.php?content=$prgress&mainid=progress-waf');";
	
	$t=time();

	$html[]=$tpl->form_outside(null, $form,null,"{apply}",$service_restart,"AsWebMaster",true);
	echo $tpl->_ENGINE_parse_body($html);
	
}

function Save(){
	$tpl=new template_admin();
	$tpl->SAVE_POSTs();

}


function table(){
	$page=CurrentPageName();
	$tpl=new template_admin();
	$sock=new sockets();
	$ini=new Bs_IniHandler();
	$users=new usersMenus();

	include_once(dirname(__FILE__)."/ressources/class.ccurl.inc");
	$sock->getFrameWork("nginx.php?status=yes");
	$ini->loadFile("/usr/share/artica-postfix/ressources/logs/web/nginx.status");
	
	$ARRAY["PROGRESS_FILE"]="/usr/share/artica-postfix/ressources/logs/nginx.restart.progress";
	$ARRAY["LOG_FILE"]="/usr/share/artica-postfix/ressources/logs/nginx.restart.progress.txt";
	$ARRAY["CMD"]="nginx.php?restart-progress=yes";
	$ARRAY["TITLE"]="{restarting_service}";
	$ARRAY["AFTER"]="LoadAjax('table-nginx','$page?table=yes');";
	$prgress=base64_encode(serialize($ARRAY));
	$service_restart="Loadjs('fw.progress.php?content=$prgress&mainid=progress-nginx-restart');";
	
	$html[]="<table style='width:100%'>";
	$html[]="<tr>";
	$html[]="<td style='width:260px'>";
	$html[]="<table style='width:100%'>";
	$html[]="<tr><td>
	<div class=\"ibox\" style='border-top:0px'>
    	<div class=\"ibox-content\" style='border-top:0px'>". 
    	$tpl->SERVICE_STATUS($ini, "APP_NGINX",$service_restart).
	"</div>
    </div></td></tr>";
	
	$html[]="</table></td>";

	$curl=new ccurl("http://127.0.0.1:1842/nginx_status/",true,"127.0.0.1");
	$curl->NoLocalProxy();
	$curl->interface_force("127.0.0.1");
	$curl->NoHTTP_POST=true;
	$curl->get();

	$tbl=explode("\n",$curl->data);
	$ActiveConnections=0;
	$requests=0;
	foreach ($tbl as $index=>$ligne){
        $ligne=trim($ligne);
        if($ligne==null){continue;}
	    if(preg_match("#Active connections:\s+([0-9]+)#i",$ligne,$re)){
            $ActiveConnections=$re[1];
            continue;
        }
	    if(preg_match("#^([0-9]+)\s+([0-9]+)\s+([0-9]+)#",$ligne,$re)){
            $requests=$re[3];

        }
    }

	

	
	$html[]="<td style='width:99%;vertical-align:top'>";
	$html[]="<table style='width:100%'>";
	$html[]="<tr>";
	$html[]="<td style='padding-left:10px;padding-top:20px'>";
	$html[]="<div class=\"col-lg-3\">";
	
	$html[]="<!-- -------------------------------------------------------------------------------------------------- -->
	<div class=\"widget style1 lazur-bg\">
	<div class=\"row\">
	<div class=\"col-xs-4\">
	<i class=\"fas fa-ethernet fa-5x\"></i>
	</div>
	<div class=\"col-xs-8 text-right\">
	<span> {connections}</span>
	<h2 class=\"font-bold\">".FormatNumber($ActiveConnections)."</h2>
	</div>
	</div>
	</div>";
	
	
	$html[]="<!-- -------------------------------------------------------------------------------------------------- -->
	<div class=\"widget style1 lazur-bg\">
	<div class=\"row\">
	<div class=\"col-xs-4\">
	<i class=\"fas fa-tachometer fa-5x\"></i>
	</div>
	<div class=\"col-xs-8 text-right\">
	<span> {requests}</span>
	<h2 class=\"font-bold\">".FormatNumber($requests)."</h2>
	</div>
	</div>
	</div>";	
			
			
			
	$html[]="</div>";
	$html[]="</td>";
	$html[]="</tr>";
	$html[]="</table>";
	$html[]="</td>";
	$html[]="</tr>";
	
	$html[]="</table>";
	echo $tpl->_ENGINE_parse_body(@implode("\n", $html));
	
}

function FormatNumber($number, $decimals = 0, $thousand_separator = '&nbsp;', $decimal_point = '.'){$tmp1 = round((float) $number, $decimals); while (($tmp2 = preg_replace('/(\d+)(\d\d\d)/', '\1 \2', $tmp1)) != $tmp1)$tmp1 = $tmp2; return strtr($tmp1, array(' ' => $thousand_separator, '.' => $decimal_point));}