<?php
include_once(dirname(__FILE__)."/class.squid.acls.quotas.inc");
include_once(dirname(__FILE__)."/class.ldap-extern.inc");
include_once(dirname(__FILE__)."/class.squid.templates-simple.inc");
class squid_acls_groups{
	var $GroupTypesTxt=array();
	
	var $RequestedGroupeType=null;
	var $UseDynamicGroupsAcls=1;
	var $smartphones_port=0;
	var $EnableKerbAuth=0;
	var $AUTH=0;	
	var $GroupTypes=array();
	var $ASROOT=false;
	var $error=null;
	public $AsMeta=false;
	public $ErrorsArray=array();
	public $DEBUG=array();
	public $buildacls_bytype_logs=array();
	private $hasProxyTransparent=0;
	private $EnableTransparent27=0;
	private $SquidBubbleMode=0;
	private $ArticaSquidParameters=null;
	private $LockActiveDirectoryToKerberos=0;
	public $HLOGS=array();
	
	public $ARRAY_NO_ITEM=array();
	function __construct(){
		if(posix_getuid()==0){$this->ASROOT=true;}

		$qProxy=new mysql_squid_builder(true);
		$this->GroupTypes=$qProxy->acl_GroupType;
		$sock=new sockets();

	
		$this->UseDynamicGroupsAcls=1;
		$this->ArticaSquidParameters=$GLOBALS["CLASS_SOCKETS"]->GET_INFO("ArticaSquidParameters");
		$this->xload();
		$this->EnableKerbAuth=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableKerbAuth"));
        $this->LockActiveDirectoryToKerberos=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("LockActiveDirectoryToKerberos"));
        if($this->LockActiveDirectoryToKerberos==1){$this->EnableKerbAuth=1;}
		$this->hasProxyTransparent=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("hasProxyTransparent"));
		$this->EnableTransparent27=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableTransparent27"));
		$this->SquidBubbleMode=$sock->GET_INFO("SquidBubbleMode");
		$this->smartphones_port=$sock->GET_INFO("smartphones_port");
		$this->LDAP_AUTH=$sock->GET_INFO("SquidStandardLDAPAuth");
		$ini=new Bs_IniHandler();
		$ini->loadString($this->ArticaSquidParameters);
		if(isset($ini->_params["NETWORK"]["LDAP_AUTH"])){
			if(intval($ini->_params["NETWORK"]["LDAP_AUTH"])==1){$this->LDAP_AUTH=1;$this->AUTH=1;}
		}
		
		
		$EnableOpenLDAP=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableOpenLDAP"));
		if($EnableOpenLDAP==0){$this->LDAP_AUTH=0;}
		
		
		if(!is_numeric($this->smartphones_port)){$this->smartphones_port=0;}
		if(!is_numeric($this->EnableKerbAuth)){$this->EnableKerbAuth=0;}
		if(!is_numeric($this->SquidBubbleMode)){$this->SquidBubbleMode=0;}
		if($this->EnableKerbAuth==1){$this->AUTH=1;$this->UseDynamicGroupsAcls=1;}
		if($this->LDAP_AUTH==1){$this->AUTH=1;}
		$this->ARRAY_NO_ITEM=$qProxy->acl_ARRAY_NO_ITEM;

		
	}
	
	private function xload(){
		$ini=new Bs_IniHandler();
		$this->LDAP_EXTERNAL_AUTH=intval(@file_get_contents('/etc/artica-postfix/settings/Daemons/SquidExternLDAPAUTH'));
		if(!isset($GLOBALS["SQUID_MEMORYCONF"]["INI_ARRAY"])){
			$ini->loadString($this->ArticaSquidParameters);
			if(isset($ini->_params)){
				$GLOBALS["SQUID_MEMORYCONF"]["INI_ARRAY"]=$ini->_params;
			}
		}else{
			$ini->_params=$GLOBALS["SQUID_MEMORYCONF"]["INI_ARRAY"];
		}

	}
	
	private function debugOutput($text,$function=null,$line=null){
		$this->DEBUG[]="# -- ACLS:$function::$text [$line]";
		if(!$GLOBALS["AS_ROOT"]){return;}

		if(!is_numeric($line)){
			if(function_exists("debug_backtrace")){
				$trace=@debug_backtrace();
				if(isset($trace[1])){
					$function=$trace[1]["function"];
					$line=$trace[1]["line"];
					
				}
			}
		}
        $this->HLOGS[]="# DEBUG ACLS:$function::$text [$line]";
        if(!$GLOBALS["VERBOSE"]){return;}
		echo "DEBUG ACLS:$function::$text [$line]\n";
	}
	
	function buildacls_order($aclport=0,$aclgpid=0){
        $HaClusterClient=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterClient"));
		$mysql_for_port=null;
		$MASTER_PORT=0;
		$function=__FUNCTION__;
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");



		if(!isset($GLOBALS["webfilters_sqacls_tested"])){
			if(!$q->FIELD_EXISTS("webfilters_sqacls", "PortDirection")){
			        $q->QUERY_SQL("ALTER TABLE `webfilters_sqacls` 
                    ADD `PortDirection` smallint(1) NOT NULL DEFAULT '0',ADD INDEX(`PortDirection`)");
			}
            if(!$q->FIELD_EXISTS("webfilters_sqacls","zTemplate")){
                $q->QUERY_SQL("ALTER TABLE webfilters_sqacls ADD zTemplate TEXT");
            }

			$GLOBALS["webfilters_sqacls_tested"]=true;
		}
		
		if(!is_numeric($aclport)){$aclport=0;}
		if(!is_numeric($aclgpid)){$aclgpid=0;}
		
		if($aclport>0){
			if($this->SquidBubbleMode==0){return;}
			$mysql_for_port=" AND webfilters_sqacls.aclport=$aclport";
		}

		if($aclgpid>0){
		    $ligneMaster=$q->mysqli_fetch_array("SELECT aclport FROM webfilters_sqacls WHERE ID=$aclgpid");
            $MASTER_PORT=$ligneMaster["aclport"];
        }
		
		
		$sql="SELECT 
		webfilters_sqacls.ID,
		webfilters_sqacls.aclname,
		webfilters_sqacls.zTemplate,
		webfilters_sqacls.PortDirection,
		webfilters_sqacls.xORDER,
		webfilters_sqacls.aclport,
		webfilters_sqacls.aclgroup
		FROM webfilters_sqacls 
		WHERE webfilters_sqacls.enabled=1$mysql_for_port
		AND webfilters_sqacls.aclgpid=$aclgpid
		ORDER BY webfilters_sqacls.xORDER";
        $conf[]="# buildacls_order mysql_for_port=$mysql_for_port [".__LINE__."] [".basename(__FILE__)."]";
		$this->debugOutput("$sql", __FUNCTION__, __LINE__);

		$results = $q->QUERY_SQL($sql);
		if($this->ASROOT){echo "Starting......: ".date("H:i:s")." [ACLS]: buildacls_order(`$aclport`,`$aclgpid`) ". count($results). "... (Line ".__LINE__.")\n";}
		if(!$q->ok){if(preg_match("#Error Table.*?doesn't exist#",$q->mysql_error)){$q->CheckTables();$results = $q->QUERY_SQL($sql);}}
		$this->debugOutput("Find `by order` -> ". count($results)." items", __FUNCTION__, __LINE__);
		if(!$q->ok){
			$conf[]="# webfilters_sqacls MySQL ERROR !";
			$this->debugOutput("$q->mysql_error", __FUNCTION__, __LINE__);
		}
		$conf=array();
		
		$PrefixAcls=null;
		if($aclport==0){
			if($this->SquidBubbleMode==1){
				$PrefixAcls=" MyStandPort ";
			}
		}
		if($aclport>0){
		    $PrefixAcls=" MyPort$aclport ";
		}

        if($HaClusterClient==1){
            //$PrefixAcls=" HaClusterT ";
            $PortDirectionS[500]=" HaClusterT ";
        }
		$PortDirectionS[1]=" NormalPorts ";
		$PortDirectionS[2]=" MyTransparentPort ";
		$PortDirectionS[3]=" MyMobilesPort ";

		$ql=new lib_sqlite("/home/artica/SQLITE/proxy.db");
		$resultsPorts = $ql->QUERY_SQL("SELECT ID FROM proxy_ports WHERE enabled=1");
		foreach ($resultsPorts as $index=>$lignePorts){
			$ID=$lignePorts["ID"];
			$PortDirectionS[$ID]=" MyPort$ID ";
		}
		
		
		$conf[]="# webfilters_sqacls HaClusterClient=$HaClusterClient ". count($results)." rules [".__LINE__."] [".basename(__FILE__)."]";
		
		
		foreach ($results as $index=>$ligne) {
			$PrefixAclsStandard=null;
			$PortDirection=$ligne["aclport"];
			if($MASTER_PORT>0){$PortDirection=$MASTER_PORT;}
			$aclid=$ligne["ID"];
            if(isset($PortDirectionS[$PortDirection])){$PrefixAcls=$PortDirectionS[$PortDirection];}

            $conf[]="# webfilters_sqacls #$aclid : aclport=$PortDirection ( $PrefixAcls ) [".__LINE__."] [".basename(__FILE__)."]";
			if($PrefixAcls==null){
				if($PortDirection>0){
					if($PortDirection==2){if($this->isTransParent()==0){continue;}}
					if($PortDirection==3){if($this->smartphones_port==0){continue;}}
                    if(!isset($PortDirectionS[$PortDirection])){$conf[]="# webfilters_sqacls #$aclid : $PortDirection no matches PortDirections  [".__LINE__."] [".basename(__FILE__)."]"; }
					if(isset($PortDirectionS[$PortDirection])){ $PrefixAclsStandard=$PortDirectionS[$PortDirection]; }
				}
			}
			
			
			$this->debugOutput("******* {$ligne["aclname"]} ******* ", __FUNCTION__, __LINE__);
			
			$this->debugOutput("buildacls_order($aclport,$aclid): SELECT httpaccess,httpaccess_value,httpaccess_data FROM webfilters_sqaclaccess WHERE aclid='$aclid'");
			$ligneWhat=$q->mysqli_fetch_array("SELECT httpaccess,httpaccess_value,httpaccess_data 
					FROM webfilters_sqaclaccess WHERE aclid='$aclid'");
			if(!$q->ok){echo "*** FATAL **** $q->mysql_error in line: ".__LINE__."\n";}
			
			$httpaccess_data=$ligneWhat["httpaccess_data"];
			$httpaccess=$ligneWhat["httpaccess"];
			
			$aclgroup=intval($ligne["aclgroup"]);
			$this->debugOutput("buildacls_order($aclport,$aclid) $httpaccess http_access_data: ($httpaccess_data) [$aclid] $httpaccess/is an acl group ? `$aclgroup`",__FUNCTION__,__FILE__,__LINE__);
			if($aclgroup==1){
				$conf[]="#";
				$conf[]="#-------- ACL Group `{$ligne["aclname"]}`";
                $aclport=0;
				$conf[]=$this->buildacls_order($aclport,$aclid);
				$conf[]="#----------------------------------------";
				$conf[]="#";
				continue;
			}
			
			$firstToken=null;
			if($httpaccess==null){
				$conf[]="# $aclid httpaccess is null, aborting";
				$this->debugOutput("buildacls_order($aclport,$aclid) httpaccess is null, aborting!!");
				continue;
			}
			if($httpaccess=="tcp_outgoing_tos"){continue;}
			if($httpaccess=="reply_body_max_size"){continue;}
			
			if($httpaccess=="url_rewrite_access_deny"){continue;}
			if($httpaccess=="url_rewrite_access_allow"){continue;}
			if($httpaccess=="adaptation_access_deny"){continue;}
			if($httpaccess=="delay_access"){continue;}
			if($httpaccess=="tcp_outgoing_address"){continue;}
			if($httpaccess=="cache_parent"){continue;}
			if($httpaccess=="snmp_access_allow"){continue;}
			if($httpaccess=="log_access"){continue;}
			if($httpaccess=="request_header_add"){continue;}
			if($httpaccess=="deny_log"){continue;}
			if($httpaccess=="always_direct"){continue;}
			
			$reverse=false;
			
			$conf[]="# [L.".__LINE__."]: rule id: $aclid $httpaccess Port Direction=$PortDirection ($PrefixAclsStandard)";
			
			if($httpaccess=="deny_access_except"){$reverse=true;$firstToken="http_access deny$PrefixAclsStandard$PrefixAcls";}
			if($httpaccess=="access_allow"){$firstToken="http_access allow$PrefixAclsStandard$PrefixAcls";}
			if($httpaccess=="access_deny"){
			    $firstToken="http_access deny$PrefixAclsStandard$PrefixAcls";

			}
			if($httpaccess=="cache_deny"){$firstToken="cache deny$PrefixAclsStandard$PrefixAcls";}
			if($httpaccess=="http_reply_access_deny"){$firstToken="http_reply_access deny$PrefixAclsStandard$PrefixAcls";}
			if($httpaccess=="http_reply_access_allow"){$firstToken="http_reply_access allow$PrefixAclsStandard$PrefixAcls";}
			
			
			
			if($httpaccess=="deny_quota_rule"){
				$this->debugOutput("  **************  deny_quota_rule ******************");
				$this->debugOutput("buildacls_order($aclport,$aclid)  -> deny_quota_rule");
				$deny_quota_rule_id=$httpaccess_data;
				if($deny_quota_rule_id==0){
					$this->debugOutput("deny_quota_rule: deny_quota_rule_id = $deny_quota_rule_id SKIP !");
					continue;
				}
				$aclquota=new squid_acls_quotas_time($deny_quota_rule_id);
				if(!$aclquota->IsValid($deny_quota_rule_id)){
					$this->debugOutput("deny_quota_rule: RULE:$deny_quota_rule_id is not valid !");
					continue;
				}
				$firstToken="http_access deny {$PrefixAclsStandard}{$PrefixAcls}!time_quota$deny_quota_rule_id";
			}
			
			
			
			
			
			$this->debugOutput("[$httpaccess] ->buildacls_bytype_items($aclid,$reverse)", __FUNCTION__, __LINE__);
            $conf[]="# [L.".__LINE__."]: ".basename(__FILE__)." buildacls_bytype_items($aclid,..)";
			$groups=$this->buildacls_bytype_items($aclid,$reverse);
			$this->debugOutput("Checks: ACL $aclid Access type:`$httpaccess` ($firstToken) groups:". count($groups),__FUNCTION__,__LINE__);
			if(count($groups)==0){
				if($this->ASROOT){echo "Starting......: ".date("H:i:s")." [ACLS]: buildacls_order() SKIP! NO GROUP FOR THIS RULE !! type:`$httpaccess` ($firstToken) groups:". count($groups)." (Line ".__LINE__.")\n";}
				continue;
			}
			
			$this->debugOutput("buildacls_order($aclport,$aclid): *** $firstToken ".@implode(" ", $groups)." ***");
			$FINAL="$firstToken ".@implode(" ", $groups);
			$FINAL=str_replace("!!", "!", $FINAL);

			if(strlen($ligne["zTemplate"])>2) {
                $zTemplate = unserialize(base64_decode($ligne["zTemplate"]));
                if($zTemplate["ENABLE"]==1){
                    $conf[]="# Template Enabled for this ACL.";
                    $conf[]=$this->Templatev2($aclid,$groups,$zTemplate);
                }
            }
            $conf[]=$FINAL;

			
			
		}	
		if($this->ASROOT){echo "Starting......: ".date("H:i:s")." [ACLS]: buildacls_order() FINAL:". count($conf)." rules (Line ".__LINE__.")\n";}
		return @implode("\n", $conf);
		
	}


	private function Templatev2($aclid,$groups,$zTemplate){
        $TemplateDir="/usr/share/squid-langpack/templates";
	    $TEMPLATE_ID=$zTemplate["TEMPLATE_ID"];
	    $BODY=$zTemplate["BODY"];
	    $TITLE=$zTemplate["TITLE"];
	    $tpl=new template_simple($TEMPLATE_ID);
	    $TEMPLATE_FINAL=$tpl->buildTemplate($TEMPLATE_ID,$TITLE,$BODY);
        @file_put_contents("$TemplateDir/TEMPLATE_$aclid",$TEMPLATE_FINAL);
        $FINAL_GRP=null;
        foreach ($groups as $grp){
            $grp=trim($grp);
            if($grp==null){continue;}
            $FINAL_GRP=$grp;
        }

        $conf[]="# Final acl is $FINAL_GRP, Template ID=$TEMPLATE_ID";
        $conf[]="deny_info TEMPLATE_{$aclid} $FINAL_GRP";
        return @implode("\n",$conf);

    }
	

	public function external_acl_helper_quota_builder(){
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
		$sql="SELECT * FROM webfilters_quotas WHERE enabled=1";
		$results = $q->QUERY_SQL($sql);
		if(!$q->ok){return;}
		foreach ($results as $index=>$ligne) {
			$array[$ligne["xtype"]]["MAX"]=$ligne["maxquota"];
			$array[$ligne["xtype"]]["DUR"]=$ligne["duration"];
			$array[$ligne["xtype"]]["PATTERN"]=$ligne["value"];
			$DESTINATIONS=$this->external_acl_helper_quota_builder_dest($ligne["ID"]);
			if($this->ASROOT){echo "Starting......: ".date("H:i:s")." [QUOTA]: {$ligne["ID"]} = ". count($DESTINATIONS)." rules\n";}
			$array[$ligne["xtype"]]["DESTINATIONS"]=$DESTINATIONS;
			
		}
		
		
		@file_put_contents("/etc/squid3/quotas_artica.db", serialize($array));
		@chmod("/etc/squid3/quotas_artica.db",0755);
		@chown("/etc/squid3/quotas_artica.db","squid");
		
	}
	
	private function external_acl_helper_quota_builder_dest($RULEID){
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
		
		$sql="SELECT webfilters_quotas_grp.gpid,
		webfilters_quotas_grp.zmd5, webfilters_quotas_grp.ID as LINKID,
		webfilters_sqgroups.* FROM webfilters_quotas_grp, webfilters_sqgroups
		WHERE webfilters_quotas_grp.gpid=webfilters_sqgroups.ID 
		AND webfilters_sqgroups.enabled =1
		AND webfilters_quotas_grp.ruleid=$RULEID";
		
		
		$results = $q->QUERY_SQL($sql);
		if($this->ASROOT){echo "Starting......: ".date("H:i:s")." [QUOTA]: $RULEID = ". count($results)." groups\n";}
		foreach ($results as $index=>$ligne) {
			
			$items=$this->ItemsInArray($ligne["gpid"]);
			if($this->ASROOT){echo "Starting......: ".date("H:i:s")." [QUOTA]: $RULEID = {$ligne["gpid"]}/{$ligne["GroupType"]} = ".count($items)." items\n";}
			$array[$ligne["GroupType"]]=$this->ItemsInArray($ligne["gpid"]);
			
		}
		
		return $array;
		
	}
	
	private function ItemsInArray($gpid){
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
		$sql="SELECT pattern FROM webfilters_sqitems WHERE gpid=$gpid AND enabled=1";
		$results = $q->QUERY_SQL($sql);
		foreach ($results as $index=>$ligne) {
			$array[$ligne["pattern"]]=$ligne["pattern"];
			
		}
		return $array;
	}


	function DUPLICATE_ACLS_OBJECTS($TableLink=null,$ID_SRC=0,$ID_DEST=0){
        if($TableLink==null){$TableLink="webfilters_sqacllinks";}
        $q=new lib_sqlite("/home/artica/SQLITE/acls.db");
        $sql="SELECT {$TableLink}.gpid,{$TableLink}.negation,
        {$TableLink}.zOrder,{$TableLink}.zmd5 as mkey,
        webfilters_sqgroups.* FROM {$TableLink},webfilters_sqgroups
        WHERE {$TableLink}.gpid=webfilters_sqgroups.ID
        AND {$TableLink}.aclid=$ID_SRC
        ORDER BY {$TableLink}.zOrder";

        $results=$q->QUERY_SQL($sql);

        foreach ($results as $index=>$ligne){
            $gpid=$ligne["gpid"];
            $negation=$ligne["negation"];
            $zOrder=$ligne["zOrder"];
            $md5=md5($ID_DEST.$gpid);
            $sql="INSERT OR IGNORE INTO {$TableLink} (zmd5,negation,aclid,gpid,zOrder) VALUES('$md5','$negation','$ID_DEST','$gpid',$zOrder)";
            $q->QUERY_SQL($sql);
        }



    }

	
	function buildacls_bytype($ruletype,$aclport=0){
		$this->buildacls_bytype=array();
		$this->error=null;
		if($aclport>0){
			if($this->SquidBubbleMode==0){
				$this->error="SquidBubbleMode is not enabled";
				return;
			}
		}
		$LOCALSIPS=array();
		if($ruletype=="tcp_outgoing_address"){
			if($this->ASROOT){
				if(class_exists("unix")){
					$unix=new unix();
					$LOCALSIPS=$unix->NETWORK_ALL_INTERFACES(true);
					
				}
			}
		}
		
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
		$PortDirectionS[1]=" NormalPorts";
		$PortDirectionS[2]=" MyTransparentPort ";
		$PortDirectionS[3]=" MyMobilesPort ";
		$ql=new lib_sqlite("/home/artica/SQLITE/proxy.db");
		$resultsPorts = $ql->QUERY_SQL("SELECT ID FROM proxy_ports WHERE enabled=1");
		foreach ($resultsPorts as $index=>$lignePorts){
			$ID=$lignePorts["ID"];
			$PortDirectionS[$ID]=" MyPort$ID ";
		}

        $PortDirectionS[500]=" HaClusterT";
		
		
		if(isset($GLOBALS["buildacls_bytype$ruletype$aclport"])){return $GLOBALS["buildacls_bytype$ruletype$aclport"];}
		
		if($GLOBALS["VERBOSE"]){echo "######### $ruletype:$aclport #########\n";}
		
		if($GLOBALS["VERBOSE"]){echo "DEBUG: ACLS: Find `$ruletype`\n";}
		$rulesAcls=array();
		$sql="SELECT webfilters_sqacls.ID,
		webfilters_sqacls.aclport, 
		webfilters_sqacls.xORDER,
		webfilters_sqacls.PortDirection,
		webfilters_sqaclaccess.httpaccess_data
		FROM webfilters_sqacls, webfilters_sqaclaccess 
		WHERE webfilters_sqacls.ID=webfilters_sqaclaccess.aclid
		AND webfilters_sqacls.enabled=1
		AND webfilters_sqacls.aclport=$aclport
		AND webfilters_sqaclaccess.httpaccess='$ruletype' 
		ORDER BY webfilters_sqacls.xORDER";
		
		
		$reverse=false;
		
		if($ruletype=="deny_access_except"){$reverse=true;}
		$this->debugOutput("$ruletype:$aclport MySQL AND webfilters_sqacls.aclport=$aclport",__FUNCTION__,__LINE__);
		
		
		$results = $q->QUERY_SQL($sql);
		if(!$q->ok){if(preg_match("#Error Table.*?doesn't exist#",$q->mysql_error)){$q->CheckTables();$results = $q->QUERY_SQL($sql);}}
		if(!$q->ok){$this->error=str_replace("\n"," ",$q->mysql_error);}
		
		if(count($results)==0){
			$this->buildacls_bytype_logs[]="# $ruletype:$aclport no item";
			$this->debugOutput("$ruletype:$aclport MySQL > ABORTING ! NO items",__FUNCTION__,__LINE__);
			$this->error="MySQL:No item";
		}
		
		$mysql_num_rows=count($results);
		$this->debugOutput("$ruletype:$aclport MySQL > $mysql_num_rows items",__FUNCTION__,__LINE__);
		
		$this->buildacls_bytype_logs[]="# $ruletype/$aclport $mysql_num_rows items";
		
		foreach ($results as $index=>$ligne) {
			$MainRuleID=$ligne["ID"];
			
			$AddPort=true;
			$PrefixAclsPort=null;
			if($this->SquidBubbleMode==0){
				$PortDirection=$ligne["PortDirection"];
				if($PortDirection>0){
					if($PortDirection==2){if($this->isTransParent()==0){continue;}}
					if(isset($PortDirectionS[$PortDirection])){
						$PrefixAclsPort=$PortDirectionS[$PortDirection];
					}
				}	
			}
			
			$aclid=$ligne["ID"];
			
			
			
			$this->debugOutput("$ruletype:$aclport RuleID=$MainRuleID buildacls_bytype_items($aclid,$reverse)",__FUNCTION__,__LINE__);
			$groups=$this->buildacls_bytype_items($aclid,$reverse,"webfilters_sqacllinks",$ruletype);
			if(count($groups)==0){
				$this->buildacls_bytype_logs[]="# $ruletype:$aclport RuleID=$MainRuleID groups=0 (aborting)";
				$this->debugOutput("$ruletype:$aclport No groups..");
				$this->error=$this->error." $aclid=0;";
				continue;
			}
			$valueToAdd=null;
			
			
			if($ruletype=="tcp_outgoing_tos"){
				$valueToAdd=$ligne["httpaccess_data"];
				if($valueToAdd==null){continue;}
				if(strpos($valueToAdd, "x")==0){
					$ayDscp = array(0 => '0x00',8 => '0x20',10 => '0x28',12 => '0x30',14 => '0x38',16 => '0x40',18 => '0x48',20 => '0x50',22 => '0x58',24 => '0x60',26 => '0x68',28 => '0x70',30 => '0x78',32 => '0x80',34 => '0x88',36 => '0x90',38 => '0x98',40 => '0xA0',46 => '0xB8',48 => '0xC0',56 => '0xE0');
					$valueToAdd=$ayDscp[$valueToAdd];
				}
				
				$valueToAdd=$valueToAdd." ";
			}

			
			
			
			if($ruletype=="reply_body_max_size"){
				$valueToAdd=intval($ligne["httpaccess_data"]);
				if($valueToAdd==0){continue;}
				$valueToAdd=$valueToAdd." MB ";
			}
			
			

			
			
			
			if($ruletype=="tcp_outgoing_address"){
				
				$valueToAdd=$ligne["httpaccess_data"];
				if($GLOBALS["VERBOSE"]){echo "tcp_outgoing_address \"$valueToAdd\" PORT:{$aclport}\n";}
				if($valueToAdd==null){continue;}
				if(count($LOCALSIPS)>0){
					if(preg_match("#[0-9\.]+#", $valueToAdd)){
						$valueToAdd=trim($valueToAdd);
						if(!isset($LOCALSIPS[$valueToAdd])){
							$GLOBALS["tcp_outgoing_address_errors"][]="Error tcp_outgoing_address $valueToAdd NO SUCH ADDRESS";
							if($GLOBALS["VERBOSE"]){echo "tcp_outgoing_address \"$valueToAdd\" PORT:{$aclport} NO SUCH ADDRESS !!!\n";}
							continue;
						}
					}
				}else{
					$GLOBALS["tcp_outgoing_address_errors"][]="LOCALSIPS Array = 0";
				}
				
				
				$valueToAdd=$valueToAdd." ";
			}
			

			
			if($ruletype=="request_header_add"){
				$httpaccess_data=unserialize(base64_decode($ligne["httpaccess_data"]));
				$request_header_add_name=$httpaccess_data["header_name"];
				$request_header_add_value=$httpaccess_data["header_value"];
				if(trim($request_header_add_name)==null){continue;}
				if(trim($request_header_add_value)==null){continue;}				
				$valueToAdd="$request_header_add_name \"$request_header_add_value\" ";
				
			}
			
			if($ruletype=="log_access"){
				$valueToAdd="stdio:/var/log/squid/access_acl_$aclid.csv csv_acls ";
			}	
				
			$FINAL=@implode(" ", $groups);
			$FINAL=str_replace("!!", "!", $FINAL);
			$rulesAcls[]=$valueToAdd.$PrefixAclsPort." ".$FINAL;
			
			
		}
		
		$GLOBALS["buildacls_bytype$ruletype"]=$rulesAcls;
		return $rulesAcls;
	}
	
	public function buildacls_bytype_items($aclid=null,$reverse=false,$tablelink="webfilters_sqacllinks",$RuleType=null){
		$ActiveDirectoryEmergency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("ActiveDirectoryEmergency"));
		$SquidUrgency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidUrgency"));
		$CATEGORY_UNSET=false;
		if($SquidUrgency==1){$ActiveDirectoryEmergency=1;}
		$NoAuthPorts=$this->NoAuthPorts();
		$this->DEBUG=array();
		$prefix=null;
		$zOrder="zOrder";
		if($reverse){$prefix="!";}
		$acls_name=array();
		
		$this->debugOutput("$aclid: $tablelink", __FUNCTION__, __LINE__);
		
		if(!is_numeric($aclid)){
			
			if(function_exists("debug_backtrace")){
				$trace=@debug_backtrace();
				if(isset($trace[1])){
					$function=$trace[1]["function"];
					$line=$trace[1]["line"];
						
				}
			}
			
			$this->debugOutput("$aclid: no aclid as been sent function:$function() in $line", __FUNCTION__, __LINE__);
		}
		
		
		if($this->AsMeta){
			$tablelink="meta_webfilters_sqacllinks";
			$zOrder="zorder";
		}
		
		$sql="SELECT 
		$tablelink.gpid,
		$tablelink.negation,
		$tablelink.zOrder,
		webfilters_sqgroups.GroupType,
		webfilters_sqgroups.GroupName,
		webfilters_sqgroups.params,
		webfilters_sqgroups.ID 
		FROM $tablelink,webfilters_sqgroups 
		WHERE $tablelink.gpid=webfilters_sqgroups.ID 
		AND $tablelink.aclid=$aclid
		ORDER BY $tablelink.$zOrder";
		
		$this->debugOutput("$aclid: $tablelink", __FUNCTION__, __LINE__);
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
		$qlProxy=new mysql_squid_builder();
		
		if($this->AsMeta){$q=new mysql();}
		
		$results = $q->QUERY_SQL($sql,"metaclient");
		
		if(!$q->ok){
			if(function_exists("debug_backtrace")){
				$trace=@debug_backtrace();
				if(isset($trace[1])){
					$function=$trace[1]["function"];
					$line=$trace[1]["line"];
				}
			}
			$this->debugOutput("$aclid: MySQL Error",__FUNCTION__,__LINE__);
			echo "Sent by function:$function() in $line -> FATAL !!! $q->mysql_error ".__FUNCTION__."() in line: ".__LINE__."\n";
			echo "$sql\n";
		}
		
		$this->debugOutput("$aclid: ". count($results)." items", __FUNCTION__, __LINE__);
		
		$ARRAY_AUTH["radius_auth"]=true;
		$ARRAY_AUTH["ad_auth"]=true;
		$ARRAY_AUTH["ldap_auth"]=true;
		$ARRAY_AUTH["dynamic_acls"]=true;
		$ISAUTH=false;
		$GroupSuffix="Group";
		if($this->AsMeta){$GroupSuffix="MetGroup";}
		$squid_acls=new squid_acls();
		foreach ($results as $index=>$ligne) {
			$GroupType=$ligne["GroupType"];
			$GroupName=$ligne["GroupName"];
			$this->debugOutput("$aclid: GroupName: `$GroupType` ID:{$ligne['ID']}",__FUNCTION__,__LINE__);
			$this->buildacls_bytype_logs[]="# GroupName: `$GroupType` ID:{$ligne['ID']}";
			if($squid_acls->NotUsedGroup($ligne['ID'])){
                $this->buildacls_bytype_logs[]="# GroupName: `$GroupType` Not used";
				$this->debugOutput("$aclid: GroupName: `$GroupType` ID:{$ligne['ID']} -> NotUsedGroup aborting",__FUNCTION__,__LINE__);
				continue;}
			$neg=null;
			
			$SuperPrefix=$prefix;
			$this->debugOutput("$aclid $GroupName: `$GroupType` ID:{$ligne['ID']}", __FUNCTION__, __LINE__);
			if(preg_match("#time_session:([A-Z]+):([0-9]+)#", $GroupType,$re)){
				$this->debugOutput("$aclid: $GroupName / $GroupType NO ITEM", __FUNCTION__, __LINE__);
				$qlProxy->acl_ARRAY_NO_ITEM[$GroupType]=true;
			}
			
			
			if($GroupType=="dynamic_acls"){
				if(!$GLOBALS["CLASS_SOCKETS"]->CORP_LICENSE()){continue;}
			}
			
			
			if($GroupType=="ad_auth"){
				if($this->EnableKerbAuth==0){continue;}
				if($ActiveDirectoryEmergency==1){continue;}
			}

			if($RuleType=="always_direct"){
				if($GroupType=="proxy_auth"){
					$this->debugOutput("$aclid: $GroupName / $GroupType / $RuleType --> Incompatible !", __FUNCTION__, __LINE__);
					continue;
				}
			}
	
			if($GroupType=="proxy_auth_adou"){
                if($ActiveDirectoryEmergency==1){continue;}
                if($this->EnableKerbAuth==0){continue;}
                $ISAUTH=true;
                if($ligne["negation"]==1){$neg="!";$SuperPrefix=null;}
                $acls_name[]="{$neg}{$prefix}Group{$ligne["ID"]}";
                continue;

            }
			
			if($GroupType=="proxy_auth_statad"){
                if($ActiveDirectoryEmergency==1){continue;}
                if($this->EnableKerbAuth==0){continue;}
                if($this->UseDynamicGroupsAcls==0){continue;}
				$ISAUTH=true;
				if($ligne["negation"]==1){$neg="!";$SuperPrefix=null;}
				$acls_name[]="{$neg}{$prefix}Group{$ligne["ID"]}";
				continue;
			}

			if($GroupType=="ldap_group"){
                $SquidStandardLDAPAuth=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("SquidStandardLDAPAuth"));
                if($SquidStandardLDAPAuth==0){continue;}
                $ISAUTH=true;
                if($ligne["negation"]==1){$neg="!";$SuperPrefix=null;}
                $acls_name[]="{$neg}{$prefix}Group{$ligne["ID"]}";
                continue;
            }
			
			if($GroupType=="proxy_auth_tagad"){
				if($ActiveDirectoryEmergency==1){continue;}
				if($this->EnableKerbAuth==0){continue;}
				if($this->UseDynamicGroupsAcls==0){continue;}
				$ISAUTH=true;
				if($ligne["negation"]==1){$neg="!";$SuperPrefix=null;}
				$acls_name[]="{$neg}{$prefix}{$GroupSuffix}{$ligne["ID"]}";
				continue;
				
			}
			
            if($GroupType=="proxy_auth_ads"){
                if($ActiveDirectoryEmergency==1){continue;}
                if($this->EnableKerbAuth==0){continue;}
                if($this->UseDynamicGroupsAcls==0){continue;}
				$ISAUTH=true;
				if($ligne["negation"]==1){$neg="!";$SuperPrefix=null;}
				$acls_name[]="{$neg}{$prefix}{$GroupSuffix}{$ligne["ID"]}";
				continue;
			}

            if($GroupType=="proxy_auth_authenticated"){
                if($ActiveDirectoryEmergency==1){continue;}
                if($this->EnableKerbAuth==0){continue;}
                $ISAUTH=true;
                if($ligne["negation"]==1){$neg="!";$SuperPrefix=null;}
                $acls_name[]="{$neg}AUTHENTICATED";
                continue;
            }
			
			if($GroupType=="proxy_auth_extad"){
				$ISAUTH=true;
				if($ligne["negation"]==1){$neg="!";$SuperPrefix=null;}
				$acls_name[]="{$neg}{$prefix}{$GroupSuffix}{$ligne["ID"]}";
				continue;
				
			}
			
			
			
			if($GroupType=="categories"){
				if($CATEGORY_UNSET){ $this->debugOutput("$aclid: Categories is not enabled !!!!"); continue; }
				if($ligne["negation"]==1){$neg="!";$SuperPrefix=null;}
				$this->debugOutput("$aclid: categories -> {$neg}{$prefix}Group{$ligne["ID"]}", __FUNCTION__, __LINE__);
				$acls_name[]="{$neg}{$prefix}{$GroupSuffix}{$ligne["ID"]}";
				continue;
			}
			


			if(isset($ARRAY_AUTH[$GroupType])){
				$ISAUTH=true;
				if($ligne["negation"]==1){$neg="!";$SuperPrefix=null;}
				$this->debugOutput("$aclid: Is an Auth [$GroupType] -> {$neg}{$prefix}Group{$ligne["ID"]}", __FUNCTION__, __LINE__);
				$acls_name[]="{$neg}{$prefix}{$GroupSuffix}{$ligne["ID"]}";
				continue;
			}
			
			

			if($GroupType=="all"){
				if($ligne["negation"]==1){$neg="!";$SuperPrefix=null;}
				$this->debugOutput("$aclid: all -> {$neg}{$prefix}all", __FUNCTION__, __LINE__);
				$acls_name[]="{$neg}{$prefix}all";
				continue;
			}	

			if(isset($qlProxy->acl_ARRAY_NO_ITEM[$GroupType])){
				if($ligne["negation"]==1){$neg="!";$SuperPrefix=null;}
				$this->debugOutput("$aclid: acl ARRAY_NO_ITEM -> {$neg}{$prefix}Group{$ligne["ID"]} OK", __FUNCTION__, __LINE__);
				$acls_name[]="{$neg}{$prefix}{$GroupSuffix}{$ligne["ID"]}";
				continue;
				
			}
			
			
			
			if($GroupType=="NudityScan"){continue;}
			
			
			if($GroupType=="proxy_auth"){
				if($this->AUTH==0){
					$this->buildacls_bytype_logs[]="#Group{$ligne['ID']} $GroupType BUT AUTH = 0";
					continue;
				}
				$acls=new squid_acls();
				$fCountArray=$acls->GetItems($ligne['ID'],null,$this->AsMeta);
				$items=count($fCountArray);
				if($items==0){
					$this->buildacls_bytype_logs[]="#Group{$ligne['ID']} $GroupType NO ITEM! Aborting";
					continue;
				}
				$this->buildacls_bytype_logs[]="#Group{$ligne['ID']} $GroupType $items item(s)";
				if($ligne["negation"]==1){$neg="!";$SuperPrefix=null;}
				$acls_name[]="{$neg}{$prefix}{$GroupSuffix}{$ligne["ID"]}";
				$ISAUTH=true;
				continue;
			}
			
			
			if($GroupType=="ssl_sni"){
				if($ligne["negation"]==1){$neg="!";$SuperPrefix=null;}
                $this->buildacls_bytype_logs[]="#$aclid: SNIGroup -> ";
				$acls_name[]="{$neg}{$prefix}SNIGroup{$ligne["ID"]}";
				continue;
			}

			
			$sql="SELECT COUNT(ID) as tcount FROM webfilters_sqitems 
                WHERE gpid='{$ligne['ID']}' AND enabled=1";



			$acls=new squid_acls();
			$fCountArray=$acls->GetItems($ligne['ID'],null,$this->AsMeta);
			foreach ($acls->buildacls_bytype_logs as $line){
                $this->buildacls_bytype_logs[]=$line;
            }
			$items=count($fCountArray);
            $this->buildacls_bytype_logs[]="# {$ligne['ID']} GetItems: $items L.". __LINE__;
			
			$this->debugOutput("$aclid `$GroupType` ID:GetItems({$ligne['ID']}) $items items", __FUNCTION__, __LINE__);
			
			
			
			if($items==0){
				$this->debugOutput("$aclid:GroupID {$ligne['ID']} 0 items, STOP", __FUNCTION__, __LINE__);
				continue;
			}
			
			if($ligne["negation"]==1){$neg="!";$SuperPrefix=null;}
			$acls_name[]="{$neg}{$prefix}{$GroupSuffix}{$ligne["ID"]}";	
			
		}	
		
		
		if($NoAuthPorts<>null){
			if($ISAUTH){
				array_unshift($acls_name, $NoAuthPorts);
			}
		}
		$this->buildacls_bytype_logs[]="# $aclid:". count($acls_name)." final items";
		$this->debugOutput("$aclid:". count($acls_name)." final items", __FUNCTION__, __LINE__);
		return $acls_name;
	}
	
	private function NoAuthPorts(){
		if(isset($GLOBALS["NoAuthPorts"])){return $GLOBALS["NoAuthPorts"];}
        $HaClusterTransParentMode=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterTransParentMode"));
        $HaClusterClient=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("HaClusterClient"));
		$q=new lib_sqlite("/home/artica/SQLITE/proxy.db");

        if($HaClusterClient==1) {
            if ($HaClusterTransParentMode == 1) {
                $GLOBALS["NoAuthPorts"] = "!NoAuthPort";
                return $GLOBALS["NoAuthPorts"];
            }
        }


		$sql="SELECT COUNT(*) as TCOUNT FROM proxy_ports WHERE enabled=1 and NoAuth=1";
		$ligne=$q->mysqli_fetch_array($sql);
		if(intval($ligne["TCOUNT"])==0){
			$GLOBALS["NoAuthPorts"]=null;
			return null;
		}
		$GLOBALS["NoAuthPorts"]= "!NoAuthPort";
		return $GLOBALS["NoAuthPorts"];
	}
	
	private function acl_tpl($aclid){
		
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
		if(!$q->FIELD_EXISTS("webfilters_sqgroups", "tplreset")){$q->QUERY_SQL("ALTER TABLE `webfilters_sqgroups` ADD `tplreset` smallint(1) ,ADD INDEX ( `tplreset` ) ");}
		$sql="SELECT acltpl,tplreset FROM webfilters_sqgroups WHERE ID='$aclid'";
		$ligne=mysqli_fetch_array($q->QUERY_SQL($sql));
		
		if(intval($ligne["tplreset"])==1){return "TCP_RESET";}
		if($ligne["acltpl"]==null){return;}
		if($ligne["acltpl"]=="ARTICA_SLASH_SCREEN"){return;}
		$acltpl=$ligne["acltpl"];
		$q=new lib_sqlite("/home/artica/SQLITE/proxy.db");
		$sql="SELECT template_name,lang FROM squidtpls WHERE `zmd5`='$acltpl'";
		if(is_numeric($ligne["lang"])){$ligne["lang"]="en";}
		$ligne=$q->mysqli_fetch_array($sql);
		if(!preg_match("#ERR_.+#", $ligne["template_name"])){$ligne["template_name"]="ERR_".$ligne["template_name"];}
		$template_path="/usr/share/squid-langpack/templates/{$ligne["lang"]}/{$ligne["template_name"]}";
		if(!is_file($template_path)){return;}
		
	}
	
	
	function GroupTypeToText($GroupType){
		return $this->GroupTypes[$GroupType];
		
	}
	
	
	function aclrule_edittype($aclid,$type,$value,$NexValue=null){
		$md5=md5("$aclid$type");
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
        $q->QUERY_SQL("DELETE FROM webfilters_sqaclaccess WHERE aclid='$aclid'");
        $q->QUERY_SQL("DELETE FROM webfilters_sqaclaccess WHERE zmd5='$md5'");

		//$q->QUERY_SQL("DELETE FROM webfilters_sqaclaccess WHERE aclid='$aclid'");
		$sql="INSERT OR IGNORE INTO webfilters_sqaclaccess 
		(zmd5,aclid,httpaccess,httpaccess_value,httpaccess_data) VALUES('$md5','$aclid','$type',1,'$NexValue')";
		//$sql="UPDATE webfilters_sqaclaccess SET httpaccess='$type',httpaccess_value=1,httpaccess_data='$NexValue' WHERE aclid='$aclid'";
		$q->QUERY_SQL($sql);
		if(!$q->ok){echo $q->mysql_error;return false;}
		
		if($NexValue<>null){
			$sql="UPDATE webfilters_sqaclaccess SET httpaccess_data='$NexValue' WHERE  aclid='$aclid'";
			$q->QUERY_SQL($sql);
			if(!$q->ok){echo $q->mysql_error;return false;}
		}
		
		
		return true;
		
	}
	private function isTransParent(){
		if(isset($GLOBALS[__CLASS__."/".__FUNCTION__])){return $GLOBALS[__CLASS__."/".__FUNCTION__];}
        $q=new lib_sqlite("/home/artica/SQLITE/proxy.db");
        $ligne=$q->mysqli_fetch_array("SELECT COUNT(*) as tcount FROM transparent_ports WHERE enabled=1");
		$tcount=intval($ligne["tcount"]);
		if($tcount>0) {
            $GLOBALS[__CLASS__ . "/" . __FUNCTION__] = 1;
            return 1;
        }

        $GLOBALS[__CLASS__."/".__FUNCTION__]=0;
		return 0;


	}
	private function isBubble(){
		if(isset($GLOBALS[__CLASS__."/".__FUNCTION__])){return $GLOBALS[__CLASS__."/".__FUNCTION__];}		
		$sock=new sockets();
		$GLOBALS[__CLASS__."/".__FUNCTION__]=$sock->GET_INFO("SquidBubbleMode");
		if($GLOBALS[__CLASS__."/".__FUNCTION__]==null){$GLOBALS[__CLASS__."/".__FUNCTION__]=0;}
		return $GLOBALS[__CLASS__."/".__FUNCTION__];
	}
	
	
	private function _ports_list(){
	
	if(isset($GLOBALS["ACL_PORTS_LIST"])){return $GLOBALS["ACL_PORTS_LIST"];}
	
	$qPorts=new mysql_squid_builder();
	if(!$qPorts->FIELD_EXISTS("webfilters_sqgroups", "PortDirection")){$qPorts->QUERY_SQL("ALTER TABLE `webfilters_sqgroups` ADD `PortDirection` smallint(1) NOT NULL DEFAULT '0',ADD INDEX(`PortDirection`)");}
	
	$ql=new lib_sqlite("/home/artica/SQLITE/proxy.db");
	$sql="SELECT * FROM proxy_ports WHERE enabled=1";
	$resultsPorts = $ql->QUERY_SQL($sql);
	
	$ip=new networking();
	$interfaces=$ip->Local_interfaces();
	unset($interfaces["lo"]);
	
	$arrayNICZ[null]="0.0.0.0";
	
	foreach ($interfaces as $eth){
		if(preg_match("#^gre#", $eth)){continue;}
		$nic=new system_nic($eth);
		$arrayNICZ[$eth]="$eth $nic->IPADDR - $nic->NICNAME";
	}
	$PortDirectionS[0]="{all}";
	foreach ($resultsPorts as $index=>$lignePorts){
		$eth=$lignePorts["nic"];
		$ipaddr=$arrayNICZ[$eth];
		$port=$lignePorts["port"];
		$IDPort=$lignePorts["ID"];
		$PortDirectionS[$IDPort]="{port} $port [$ipaddr]";
	}
	
	$GLOBALS["ACL_PORTS_LIST"]=$PortDirectionS;
	return $GLOBALS["ACL_PORTS_LIST"];
}
	
	public function PORTS_DIRECTIONS(){
	    if(isset($GLOBALS["PORTSDIRECTIONS"])){return $GLOBALS["PORTSDIRECTIONS"];}
        $tpl=new template_admin();
        $GLOBALS["PORTSDIRECTIONS"]=$tpl->ProxyPortsDirections();
        return $GLOBALS["PORTSDIRECTIONS"];
	}
	
	
	
	function ACL_MULTIPLE_EXPLAIN($aclid,$ACCESSEnabled,$aclgroup=0,$TableLink=null){
		$error=null;
		if(!isset($_GET["t"])){$_GET["t"]=time();}
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
		$cache_parent_info=null;
		$prefix=null;
		$explain=array();
		$CheckPortDirection=true;
		$PortDirection=0;
		$isBubble=0;
		$Mainjs="Loadjs('squid.acls-rules.php?Addacl-js=yes&ID=$aclid&t={$_GET["t"]}',true)";
		$CheckHTTP_Access=true;
		$cache_deny=0;
		$access_deny=0;
		$http_reply_access_deny=0;
		$http_reply_access_allow=0;
		$access_allow=0;
		$snmp_access_allow =0;
		$log_access =0;
		$deny_access_except=0;
		$request_header_add=0;
		$deny_log=0;
		$always_direct=0;
		$deny_quota_rule=0;
		$delay_access=0;
		$url_rewrite_access_deny=0;
		$url_rewrite_access_allow =0;
		$adaptation_access_deny=0;
		$tcp_outgoing_tos=0;
		$tcp_outgoing_address=0;
		$reply_body_max_size=0;
		$remove_dst=0;
        $GLOBALS["PORTSDIRECTIONS"]=$this->PORTS_DIRECTIONS();
		
		if($TableLink=="sslrules_sqacllinks"){
			$CheckPortDirection=false;
			$CheckHTTP_Access=false;
			
		}

		if($TableLink=="dnsdist_sqacllinks"){
            $remove_dst=1;

        }

        if(!$q->FIELD_EXISTS("webfilters_sqacls","zTemplate")){
            $q->QUERY_SQL("ALTER TABLE webfilters_sqacls ADD zTemplate TEXT");
        }


		if($aclgroup==1){
		    $tpl    = new template_admin();
			$explains=array();

            $ligne=$q->mysqli_fetch_array("SELECT aclport,description FROM webfilters_sqacls WHERE ID=$aclid");
            $description=base64_decode($ligne["description"]);
            $PortDirection=$ligne["aclport"];
            if($description<>null){$explains[]="<div style='font-weight:bold;color:#5b5b5b;border-bottom:1px solid #CCCCCC;maring-bottom:3px;margin-right: 5px;'>$description</div>";}
            $explains[]="<div>{when_connecting_to_method} &laquo;{$GLOBALS["PORTSDIRECTIONS"][$PortDirection]}&raquo;</div>";
            $explains[]="<div>{then} {apply_the_following_rules}:</div>";

			$sql="SELECT aclname,ID,enabled FROM webfilters_sqacls WHERE aclgpid=$aclid ORDER BY xORDER";
			$results = $q->QUERY_SQL($sql);
            $explains[]="<div style='padding-left: 20px;margin-top:10px'><table style='width:100%'>";
			foreach ($results as $index=>$ligne) {
                $js="Loadjs('fw.proxy.acls.php?rule-id-js={$ligne["ID"]}')";
                $explains[]="<tr>";
                $explains[]="<td width='1%' style='vertical-align:top' nowrap=''><i class=\"fas fa-check\"></i>&nbsp;</td>";
                $explains[]="<td width='99%' style='vertical-align:top;padding-left:3px'>";

                $explains[]="<strong ".$tpl->ClickMouse($js).">{$ligne["aclname"]}</strong> <small>(".
                    $this->ACL_MULTIPLE_EXPLAIN($ligne["ID"], $ligne["enabled"],0)."</small>";
                $explains[]="</td>";
                $explains[]="</tr>";
			}
            $explains[]="</table>";
            $explains[]="</div>";
			
				return @implode("", $explains);
		}

        $ligneTpl=$q->mysqli_fetch_array("SELECT zTemplate FROM webfilters_sqacls WHERE ID=$aclid");
        $zTemplate=unserialize(base64_decode($ligneTpl["zTemplate"]));
		
		$errorTransparentModeIsDisabled=" <i>{the_transarent_mode_is_disabled_acl}</i>";
		$isTransParent=$this->isTransParent();
		if($CheckPortDirection){
			$isBubble=$this->isBubble();
			$ligne=$q->mysqli_fetch_array("SELECT aclport,aclgpid FROM webfilters_sqacls WHERE ID='$aclid'");
			if(function_exists("VERBOSE")){VERBOSE("[$aclid]: PortDirection --> [{$ligne["aclport"]}]");}
			$PortDirection  = intval($ligne["aclport"]);
            $aclgpid        = intval($ligne["aclgpid"]);
		}
		$methodConnect=null;
        if($isBubble==0){$methodConnect="{when_connecting_to_method} &laquo;{$GLOBALS["PORTSDIRECTIONS"][$PortDirection]}&raquo;,";}
		if($aclgpid>0){$methodConnect=null;}
		
		$linkcolor="black";
		$WarnColor="#EA0C0C";
		if($ACCESSEnabled==0){
		    if($GLOBALS["VERBOSE"]){echo "<span style='color:red'>ACCESSEnabled === $ACCESSEnabled</span><br>";}
			$linkcolor="text-danger";$WarnColor="text-danger";
		}
		
		$errorNoObjects="<br><img src='img/status_warning.png' align='left' style='margin-right:4px'><span style='font-size:11px;font-weight:bold;color:$WarnColor;margin-top:1px'>{error_acl_no_object}</span>";
		
		if($CheckHTTP_Access){
		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value FROM webfilters_sqaclaccess WHERE aclid='$aclid' AND httpaccess='url_rewrite_access_deny'");
		$url_rewrite_access_deny=$ligne["httpaccess_value"];
		if(!is_numeric($url_rewrite_access_deny)){$url_rewrite_access_deny=0;}
		
		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value FROM webfilters_sqaclaccess WHERE aclid='$aclid' AND httpaccess='url_rewrite_access_allow'");
		$url_rewrite_access_allow=$ligne["httpaccess_value"];
		if(!is_numeric($url_rewrite_access_allow)){$url_rewrite_access_allow=0;}
	
		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value FROM webfilters_sqaclaccess WHERE aclid='$aclid' AND httpaccess='access_deny'");
		$access_deny=$ligne["httpaccess_value"];
		if(!is_numeric($access_deny)){$access_deny=0;}	
	
		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value FROM webfilters_sqaclaccess WHERE aclid='$aclid' AND httpaccess='adaptation_access_deny'");
		$adaptation_access_deny=$ligne["httpaccess_value"];
		if(!is_numeric($adaptation_access_deny)){$adaptation_access_deny=0;}
		
		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value FROM webfilters_sqaclaccess WHERE aclid='$aclid' AND httpaccess='cache_deny'");
		$cache_deny=$ligne["httpaccess_value"];
		
		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value FROM webfilters_sqaclaccess WHERE aclid='$aclid' AND httpaccess='access_allow'");
		$access_allow=$ligne["httpaccess_value"];
		if(!is_numeric($access_allow)){$access_allow=0;}	

		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value FROM webfilters_sqaclaccess WHERE aclid='$aclid' AND httpaccess='snmp_access_allow'");
		$snmp_access_allow=$ligne["httpaccess_value"];
		if(!is_numeric($snmp_access_allow)){$snmp_access_allow=0;}	

		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value FROM webfilters_sqaclaccess WHERE aclid='$aclid' AND httpaccess='log_access'");
		$log_access=$ligne["httpaccess_value"];
		if(!is_numeric($log_access)){$log_access=0;}		
		
		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value,httpaccess_data FROM webfilters_sqaclaccess WHERE aclid='$aclid' AND httpaccess='deny_log'");
		$deny_log=$ligne["httpaccess_value"];
		if(!is_numeric($deny_log)){$deny_log=0;}

		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value,httpaccess_data FROM webfilters_sqaclaccess WHERE aclid='$aclid' AND httpaccess='always_direct'");
		$always_direct=intval($ligne["httpaccess_value"]);
		
		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value FROM webfilters_sqaclaccess WHERE aclid='$aclid' AND httpaccess='deny_access_except'");
		$deny_access_except=$ligne["httpaccess_value"];
		if(!is_numeric($deny_access_except)){$deny_access_except=0;}	
		
		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value,httpaccess_data FROM webfilters_sqaclaccess WHERE aclid='$aclid' AND httpaccess='tcp_outgoing_tos'");
		$tcp_outgoing_tos=$ligne["httpaccess_value"];
		$tcp_outgoing_tos_value=$ligne["httpaccess_data"];
		if(!is_numeric($tcp_outgoing_tos)){$tcp_outgoing_tos=0;}	
		if($tcp_outgoing_tos_value==null){$tcp_outgoing_tos_value="0x20";}

		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value,httpaccess_data FROM webfilters_sqaclaccess WHERE aclid='$aclid' AND httpaccess='tcp_outgoing_address'");
		$tcp_outgoing_address=$ligne["httpaccess_value"];
		$tcp_outgoing_address_value=$ligne["httpaccess_data"];
		if(!is_numeric($tcp_outgoing_address)){$tcp_outgoing_address=0;}	
		if($tcp_outgoing_tos_value==null){$tcp_outgoing_address=0;}		

		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value,httpaccess_data FROM webfilters_sqaclaccess WHERE aclid='$aclid' AND httpaccess='reply_body_max_size'");
		$reply_body_max_size=$ligne["httpaccess_value"];
		$reply_body_max_size_value=intval($ligne["httpaccess_data"]);
	
		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value,httpaccess_data FROM webfilters_sqaclaccess WHERE aclid='$aclid' AND httpaccess='delay_access'");
		$delay_access=$ligne["httpaccess_value"];
		$delay_access_id=$ligne["httpaccess_data"];
		if(!is_numeric($delay_access)){$delay_access=0;}	
		if(!is_numeric($delay_access_id)){$delay_access_id=0;}
		
		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value FROM webfilters_sqaclaccess WHERE aclid='$aclid' 
		AND httpaccess='http_reply_access_deny'");
		$http_reply_access_deny=$ligne["httpaccess_value"];
		if(!is_numeric($http_reply_access_deny)){$http_reply_access_deny=0;}
		
		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value FROM webfilters_sqaclaccess WHERE aclid='$aclid' 
		AND httpaccess='http_reply_access_allow'");
		$http_reply_access_allow=$ligne["httpaccess_value"];
		if(!is_numeric($http_reply_access_allow)){$http_reply_access_allow=0;}		

		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value,httpaccess_data FROM webfilters_sqaclaccess WHERE aclid='$aclid' AND httpaccess='request_header_add'");
		$request_header_add=$ligne["httpaccess_value"];
		$request_header_add_value=unserialize(base64_decode($ligne["httpaccess_data"]));
		if(!is_numeric($request_header_add)){$request_header_add=0;}else{
			$request_header_add_name=$request_header_add_value["header_name"];
			$request_header_add_value=$request_header_add_value["header_value"];
		}
		$ligne=$q->mysqli_fetch_array("SELECT httpaccess_value,httpaccess_data FROM webfilters_sqaclaccess WHERE aclid='$aclid' AND httpaccess='deny_quota_rule'");
		$deny_quota_rule=$ligne["httpaccess_value"];
		$deny_quota_rule_id=$ligne["httpaccess_data"];
		if(!is_numeric($deny_quota_rule)){$deny_quota_rule=0;}
		if($deny_quota_rule_id>0){
			$q3=new mysql();
			$ligne3=mysqli_fetch_array($q3->QUERY_SQL("SELECT QuotaName FROM ext_time_quota_acl WHERE ID=$deny_quota_rule_id","artica_backup"));
			$deny_quota_rule_value=$ligne3["QuotaName"];
			$js_quota="<a href=\"javascript:blur();\"
			OnClick=\"Loadjs('squid.ext_time_quota_acl.php?session-rule-js=yes&ID=$deny_quota_rule_id&t={$_GET["t"]}&tOrg={$_GET["t"]}');\"
			class='$linkcolor'>";
		}		
		
		}
		
		$explain_deny_color="text-danger";
		$explain_allow_color="text-info";

		$reverse_text=false;
		if(!is_numeric($cache_deny)){$cache_deny=0;}		
		if($access_deny==1){$url_rewrite_access_deny=0;$url_rewrite_access_allow=0;$adaptation_access_deny=0;$cache_deny=0;$access_allow=0;}
		if($access_deny==1){$explain[]="<strong class='$explain_deny_color'>$prefix{deny_access}</a></strong>";}
		if($http_reply_access_deny==1){$explain[]="<strong class='$explain_deny_color'>$prefix{deny_reply_access}</a></strong>";}

				
		if($http_reply_access_allow==1){$explain[]="<strong class='$explain_allow_color'>$prefix{allow_reply_access}</a></strong>";}
		if($access_allow==1){$explain[]="<strong class=\"$explain_allow_color\">$prefix{allow}</a></strong>";}
		if($snmp_access_allow==1){$explain[]="<strong class=\"$explain_allow_color\">{allow_snmp_access}</a></strong>";}
		if($log_access==1){$explain[]="<strong class=\"$explain_allow_color\">$prefix{log_to_csv}</a> <a href=\"squid.acls-rules.php?csv=$aclid\" style='text-decoration:underline;color:$explain_allow_color'>&laquo;download&raquo;</a></strong>";}
		if($deny_access_except==1){$explain[]="{deny_access_except}";$reverse_text=true;}
		if($request_header_add==1){$explain[]="<strong class=\"$explain_allow_color\">$prefix{add_http_header}</a>:</strong> &laquo;<strong>$request_header_add_name</strong>: $request_header_add_value&raquo;";}
		if($deny_log==1){$explain[]="<strong class=\"$explain_allow_color\">$prefix{deny_logging}</a></strong>";}
		if($always_direct==1){$explain[]="<strong class=\"$explain_allow_color\">$prefix{do_not_use_parent_proxy}</a></strong>";}
		
		
		if($deny_quota_rule==1){
			$objects=$this->getobjectsNameFromAclrule($aclid,$linkcolor,null);
			if(count($objects)==0){
				$error=$error.$errorNoObjects;
			}
			$explain[]="<strong class=\"$explain_deny_color\">$prefix{affect_quota_rule}</a> &laquo;$js_quota$deny_quota_rule_value</a>&raquo;</strong>";}
		
		
			if($isTransParent==0){
				if($PortDirection==2){
					$error=$error.$errorTransparentModeIsDisabled;
				}
			}		
			
		
		if($delay_access==1){
			$sql="SELECT rulename FROM squid_pools WHERE ID='$delay_access_id'";
			$ligne=$q->mysqli_fetch_array($sql);	
			$delay_access_id_text=utf8_encode($ligne["rulename"]);
			$delay_access_id_textjs="Loadjs('squid.bandwith.php?bandwith-rule-js=yes&ID=$delay_access_id&t={$_GET["t"]}&by-acls=yes')";
			$url_rewrite_access_allow=0;$url_rewrite_access_deny=0;$adaptation_access_deny=0;$cache_deny=0;$access_allow=0;$access_deny=0;
			$explain[]="<strong class=\"$explain_deny_color\">$prefix{limit_bandwidth}</a>&nbsp;&laquo;<a href=\"javascript:blur();\" OnClick=\"$delay_access_id_textjs\" style='text-decoration:underline'>$delay_access_id_text</a>&raquo;</strong>";
		}
		
		if($url_rewrite_access_deny==1){$explain[]="$prefix{pass_trough_thewebfilter_engine}</a>";}
		if($url_rewrite_access_allow==1){$explain[]="$prefix{force_using_thewebfilter_engine}</a>";}
		if($adaptation_access_deny==1){$explain[]="$prefix{pass_trough_icap_engines}</a>";}
		if($tcp_outgoing_tos==1){$explain[]="$prefix{set_specific_dcsp}</a> $tcp_outgoing_tos_value";}
		if($tcp_outgoing_address==1){$explain[]="$prefix{acl_tcp_outgoing_address}</a> $tcp_outgoing_address_value";}
		if($reply_body_max_size==1){$explain[]="$prefix{acl_reply_body_max_size}</a> {$reply_body_max_size_value}MB";}
		

		
		if($cache_deny==1){$explain[]="$prefix{do_not_cache}</a>";}

		if($zTemplate["ENABLE"]==1){
		    $error=$error." <small>({error_page} &laquo;{$zTemplate["TITLE"]}&raquo;)</small>";
        }
		
		
		if($CheckHTTP_Access){
			if(count($explain)==0){
				$final_explain="$prefix<strong class=\"$explain_deny_color\">{disable_this_rule_no_access_set}</strong></a>";
			}else{
				$final_explain=@implode(" {and} ", $explain);
			}
		}else{
			$final_explain=@implode(" {and} ", $explain);
		}
		$objects=$this->getobjectsNameFromAclrule($aclid,$linkcolor);
		
		
		if(count($objects)>0){
			if(!$reverse_text){
				if($final_explain<>null){$final_explain=" {then} $final_explain";}
				return "$methodConnect{for_objects} ". @implode(", {and} ", $objects)."$final_explain$error";
			}else{
				return $methodConnect.$final_explain."&nbsp;{for_objects} ". @implode(" {and} ", $objects).$error;
			}
		}else{
			return $methodConnect.$final_explain.$error;
		}
		
	}
	
	private function template_name($groupid,$linkcolor="black"){
		
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
		if(!$q->FIELD_EXISTS("webfilters_sqgroups", "tplreset")){
			$q->QUERY_SQL("ALTER TABLE `webfilters_sqgroups` ADD `tplreset` smallint(1) ,ADD INDEX ( `tplreset` ) ");
		}
		
		
		$sql="SELECT acltpl,tplreset FROM webfilters_sqgroups WHERE ID='$groupid'";
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
		$ligne=mysqli_fetch_array($q->QUERY_SQL($sql));
		
		if(intval($ligne["tplreset"])==1){
			return "{reset_connection}";
		}
		
		if($ligne["acltpl"]==null){return;}
		$zmd5=$ligne["acltpl"];
		
		if($ligne["acltpl"]=="ARTICA_SLASH_SCREEN"){
			$js="Loadjs('squid.webauth.php');";
			return "<a href=\"javascript:blur();\" OnClick=\"javascript:$js\" style=\"text-decoration:underline;\">HotSpot</a>";
		}
		
		$acltpl=$ligne["acltpl"];
		$q=new lib_sqlite("/home/artica/SQLITE/proxy.db");
		$sql="SELECT template_name,zmd5,lang,emptytpl FROM squidtpls WHERE `zmd5`='$acltpl'";
		$ligne=$q->mysqli_fetch_array($sql);
		$subject=base64_encode(addslashes($ligne["template_name"]));
		$js="Loadjs('squid.templates.php?Zoom-js=$zmd5&subject=$subject');";
		if($ligne["emptytpl"]==1){
			$js="Loadjs('squid.templates.php?template-settings-js=yes&zmd5={$ligne["zmd5"]}');";
		}
		
		if(trim($ligne["template_name"])==null){return;}
		return "<a href=\"javascript:blur();\" OnClick=\"$js\" style=\"text-decoration:underline;\">{$ligne["template_name"]}</a>";
		}
	
	
	public function getobjectsNameFromAclrule($aclid,$linkcolor="black",$webfilters_sqacllinks="webfilters_sqacllinks"){
		if(isset($GLOBALS["getobjectsNameFromAclrule$aclid"])){return $GLOBALS["getobjectsNameFromAclrule$aclid"];}

		$remove_dst=0;
		
		VERBOSE("getobjectsNameFromAclrule($aclid...)",__LINE__);

		if($webfilters_sqacllinks=="dnsdist_sqacllinks"){
            $remove_dst=1;

        }
		
		$f                      = array();
		$tableorg               = null;
		$users                  = new usersMenus();
		$sock                   = new sockets();
		$text_license           = null;
        $markExcl               = null;
		$webfilters_sqacllinks  = trim($webfilters_sqacllinks);
		if($webfilters_sqacllinks==null){$webfilters_sqacllinks="webfilters_sqacllinks";}
		$EnableSplashScreen=$sock->GET_INFO("EnableSplashScreen");
		$EnableSplashScreenAsObject=$sock->GET_INFO("EnableSplashScreenAsObject");
		if(!is_numeric($EnableSplashScreen)){$EnableSplashScreen=0;}
		if(!is_numeric($EnableSplashScreenAsObject)){$EnableSplashScreenAsObject=0;}
		$SplashScreenURI=$sock->GET_INFO("SplashScreenURI");
		if(trim($SplashScreenURI)==null){$EnableSplashScreen=0;}
		$URLAR=parse_url($SplashScreenURI);
		if(isset($URLAR["host"])){$SplashScreenURI="http://$SplashScreenURI";}	
		$CATEGORY_UNSET=false;
        $jsafter=null;
		if(!$GLOBALS["CLASS_SOCKETS"]->CORP_LICENSE()){ $text_license="<span class='text-danger'>&laquo;&laquo;{acl_no_license_explain}$markExcl&raquo;&raquo;</span>"; }
		$markExcl="<span style='font-size:30px;font-weight:bold'>&nbsp;!</span>";
		
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
		$qlProxy=new mysql_squid_builder(true);
		
		$ARRAY_AUTH["radius_auth"]=true;
		$ARRAY_AUTH["ad_auth"]=true;
		$ARRAY_AUTH["ldap_auth"]=true;
		$ARRAY_AUTH["hotspot_auth"]=true;

		if(isset($GLOBALS["ACL_OBJECTS_JS_AFTER"])){
            $jsafter="&js-after={$GLOBALS["ACL_OBJECTS_JS_AFTER"]}";
        }
		
		

		$sql="SELECT $webfilters_sqacllinks.gpid,$webfilters_sqacllinks.negation,$webfilters_sqacllinks.zOrder,webfilters_sqgroups.* 
		FROM $webfilters_sqacllinks,webfilters_sqgroups 
		WHERE $webfilters_sqacllinks.gpid=webfilters_sqgroups.ID 
		AND $webfilters_sqacllinks.aclid=$aclid
		ORDER BY $webfilters_sqacllinks.zOrder
		";
		
		$results = $q->QUERY_SQL($sql);
		if(!$q->ok){$f[]="<div class=text-error>$aclid: $q->mysql_error</div>";}
		
		VERBOSE($sql,__LINE__);
		VERBOSE(count($results)." Group(s)",__LINE__);
		foreach ($results as $index=>$ligne) {
			$error_object=null;
			$items_text=null;
			$ports_text=null;
			$PREFIX_TEXT=null;
			VERBOSE("ACL[$aclid]: Checking Group[{$ligne['ID']}] type:{$ligne["GroupType"]} enabled:{$ligne["enabled"]}",__LINE__);
			if($ligne["enabled"]==0){
				VERBOSE("ACL[$aclid]: Checking Group[{$ligne['ID']}] Not enabled, aborting", __LINE__);
				continue;
			}
			
			$butnot=null;

			if($remove_dst==1){
                if($ligne["GroupType"]=="dst"){
                    continue;
                }

            }
			
			
			if($ligne["GroupType"]=="proxy_auth_ldap"){
				preg_match("#ExtLDAP:(.+?):#",$ligne["GroupName"],$re);
				$ligne["GroupName"]=$re[1];
			}
			if(preg_match("#time_session:([A-Z]+):([0-9]+)#", $ligne["GroupType"],$re)){$qlProxy->acl_ARRAY_NO_ITEM[$ligne["GroupType"]]=true;}
			
			
			$GroupName=utf8_encode($ligne["GroupName"]);
			VERBOSE("--> webfilters_sqitems",__LINE__);
			$ligne2=$q->mysqli_fetch_array("SELECT COUNT(ID) as tcount FROM webfilters_sqitems WHERE gpid='{$ligne['ID']}'");
			if(!$q->ok){VERBOSE("$q->mysql_error",__LINE__);}
			
			$items=$ligne2["tcount"];
			VERBOSE("$GroupName [{$ligne['ID']}] = $items item(s)",__LINE__);
			
			$items_text="$items {items}";
			if(!isset($qlProxy->acl_ARRAY_NO_ITEM[$ligne["GroupType"]])){
				if($items==0){
					VERBOSE("ACL[$aclid]: Checking Group[{$ligne['ID']}] No item, aborting",__LINE__);
					continue;
				}
			}

			if($ligne["GroupType"]=="proxy_auth_adou"){$items_text=null;}
            if($ligne["GroupType"]=="proxy_auth_ads"){$items_text=null;}
            if($ligne["GroupType"]=="proxy_auth_authenticated"){$items_text=null;}
			if($ligne["GroupType"]=="proxy_auth_tagad"){$items_text=null;}
			if($ligne["GroupType"]=="proxy_auth_statad"){$items_text=null;}
			if($ligne["GroupType"]=="proxy_auth_ldap"){$items_text=null;}
			if($ligne["GroupType"]=="NudityScan"){$items_text=null;}
			if($ligne["GroupType"]=="categories"){ 
				$PREFIX_TEXT=$text_license; 
				if($PREFIX_TEXT==null){
					if($CATEGORY_UNSET){
						$PREFIX_TEXT="<span class='text-danger'>&laquo;&laquo;{categories_service}:{disabled}$markExcl&raquo;&raquo;</span>";
					}
				}				
			
			}
			if($ligne["GroupType"]=="quota_time"){ $PREFIX_TEXT=$text_license; }
			if($ligne["GroupType"]=="quota_size"){ $PREFIX_TEXT=$text_license; }

			

			if(intval($ligne["PortDirection"])>0){
				
				$portslist=$this->_ports_list();
				$ports_text="&nbsp;{on_port}: ".$portslist[$ligne["PortDirection"]];
			}
			
			
			if($ligne["GroupType"]=="dynamic_acls"){
			
				$DynamicACLUrgency=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("DynamicACLUrgency"));
				if($GLOBALS["VERBOSE"]){echo "<span style='color:blue'>DynamicACLUrgency = $DynamicACLUrgency</span><br>\n";}
				$ligne3=$q->mysqli_fetch_array("SELECT COUNT(ID) as tcount FROM webfilter_aclsdynamic WHERE gpid='{$ligne['ID']}'");
				if($GLOBALS["VERBOSE"]){if($DynamicACLUrgency==1){echo "<span style='color:blue'>DynamicACLUrgency is on !</span><br>\n";}}
				if($DynamicACLUrgency==1){
					$error_object="<span style='color:#A71A05'> ({proxy_in_dynamic_emergency_mode})</span><br>";}
				
				if(!$GLOBALS["CLASS_SOCKETS"]->CORP_LICENSE()){$error_object=$text_license;}
					
				
				$items_text="&nbsp;<a href=\"javascript:blur();\" 
				OnClick=\"Loadjs('squid.acls.dynamics.php?ByJs=yes&gpid={$ligne['ID']}');\"
				style=\"font-weight:normal;text-decoration:underline;\">{$ligne3["tcount"]} {rules}</a>&nbsp;";
				
			}
			
			if($ligne["GroupType"]=="all"){$items_text="{all}";}
			
			
			if(isset($qlProxy->acl_ARRAY_NO_ITEM[$ligne["GroupType"]])){
				if($GLOBALS["VERBOSE"]){echo "<span style='color:blue'>[".__LINE__."]: $GroupName -> acl_ARRAY_NO_ITEM = True, remove text</span><br>\n";}
				$items_text=null;
			}
			
			$template=null;

			if(isset($_GET["toexplainorg"])){$tableorg="&table-org={$_GET["toexplainorg"]}";}
			
			if(isset($ARRAY_AUTH[$ligne["GroupType"]])){
				$butnot="{authenticated_trough}&nbsp;";
			}
			
			if($ligne["negation"]==1){
				$butnot="{notfor}&nbsp;";
				if(isset($ARRAY_AUTH[$ligne["GroupType"]])){
					$butnot="{not_authenticated_trough}&nbsp;";
				}
				$template=null;
			}
			
			if(isset($ARRAY_AUTH[$ligne["GroupType"]])){
				$items_text="<a href=\"javascript:blur();\" 
				OnClick=\"Loadjs('squid.auth-objects-events.php?ID={$ligne['ID']}',true);\"
				style=\"text-decoration:underline;\">{events}</a>
				";
			}
			
			if($ligne["GroupType"]=="hotspot_auth"){
				$warn="<img src='img/status_warning.png' align='left' style='margin-right:4px'>";
				$items_text="<a href=\"javascript:blur();\" 
				OnClick=\"Loadjs('squid.webauth.php');\"
				style=\"text-decoration:underline;\">{parameters}</a>
				";
				
				if($EnableSplashScreen==0){
					$items_text=$warn.$items_text;
				}
				
				if($EnableSplashScreenAsObject==0){
					$items_text=$warn.$items_text;
				}				
				
			}
			
			if($ligne["GroupType"]=="quota_time"){
				$items_text="&nbsp;&laquo;&nbsp;<a href=\"javascript:blur();\"
				OnClick=\"Loadjs('squid.acls.quota.time.array.php');\"
				style=\"text-decoration:underline;;font-weight:bold\">{status}</a>&nbsp;&raquo;&nbsp;
				";
				
			}
			

			if(preg_match("#time_quota:([0-9]+)#", $ligne["GroupType"],$re)){
				$ligne3=$q->mysqli_fetch_array("SELECT * FROM quota_objects WHERE ID='{$re[1]}'");
				$GroupName="$GroupName&nbsp;&raquo;&nbsp;{time_quota} {$ligne3["objectname"]}";
			}
			
			if($GLOBALS["VERBOSE"]){echo "Group Type: {$ligne["GroupType"]} ".__LINE__."<br>\n";}
			
			if(preg_match("#time_session:([A-Z]+):([0-9]+)#", $ligne["GroupType"],$re)){
				$ligne3=$q->mysqli_fetch_array("SELECT * FROM sessions_objects WHERE ID='{$re[2]}'");
				$GroupName="$GroupName&nbsp;&raquo;&nbsp;{session_tracking} - {$re[1]} - {$ligne3["objectname"]}";
			}			
			
			$finalItemText="$items_text$template";
			if($finalItemText<>null){$finalItemText="($finalItemText)";}

			
			$href="<a href=\"javascript:blur();\" 
			OnClick=\"Loadjs('fw.rules.items.php?groupid={$ligne['ID']}$tableorg$jsafter',true);\" 
			style=\"text-decoration:underline;\">";		

			
			
			$f[]="$PREFIX_TEXT$butnot&laquo;$href$GroupName</a>&raquo;$error_object $ports_text <span><small>$finalItemText</small>";
		}
		
		
		$GLOBALS["getobjectsNameFromAclrule$aclid"]=$f;
		return $f;
		
	}
	
	public function FlexArray($gpid,$enable=1,$jsafetr=null){
		$q=new lib_sqlite("/home/artica/SQLITE/acls.db");
		$qlProxy=new mysql_squid_builder();

		if($jsafetr==null){
		    if(isset($GLOBALS["ACL_OBJECTS_JS_AFTER"])){
                $jsafetr = $GLOBALS["ACL_OBJECTS_JS_AFTER"];
            }
        }

		$jsafetr=urlencode(base64_encode($jsafetr));
		$items=0;
		$t=$_GET["t"];
		$color="black";
		if($enable==0){$color="#8a8a8a";}
		$tpl=new templates();
		$rules=$tpl->_ENGINE_parse_body("{rules}");
		
		
		$ligne=$q->mysqli_fetch_array("SELECT GroupName,GroupType,enabled FROM webfilters_sqgroups WHERE ID='$gpid'");
		$GroupName=null;
		$GroupType=$ligne["GroupType"];
		$GroupEnabled=intval($ligne["enabled"]);
		
		
		if($GroupType=="proxy_auth_ldap"){
			$p=new ldap_extern();
			preg_match("#^ExtLDAP:(.+?):(.+)#", $ligne['GroupName'],$re);
			$GroupName=$re[1];
			$DN=base64_decode($re[2]);
			$items=$p->CountDeUsersByGroupDN($DN);
		}
		
		$GroupTypeName=$tpl->_ENGINE_parse_body($q->acl_GroupType[$GroupType]);
		if($GroupName==null){$GroupName=utf8_encode($ligne["GroupName"]);}
		if($GroupType=="ndpi"){$GroupTypeName="Deep packet inspection";}
		

		if($items==0){
			$ligne2=$q->mysqli_fetch_array("SELECT COUNT(ID) as tcount FROM webfilters_sqitems WHERE gpid='$gpid'");
			$items=$ligne2["tcount"];
		}
				

		
		
		
		
		if($GroupType=="dynamic_acls"){
			$ligne2=$q->mysqli_fetch_array("SELECT COUNT(ID) as tcount FROM webfilter_aclsdynamic WHERE gpid='$gpid'");
			$items="<a href=\"javascript:blur();\" 
			
			OnClick=\"Loadjs('squid.acls.dynamics.php?ByJs=yes&gpid=$gpid');\"
			style='font-weight:bold;text-decoration:underline;color:$color'>{$ligne2["tcount"]}</a>";
			$additional_text="&nbsp;&nbsp;<a href=\"javascript:blur();\" 
			OnClick=\"Loadjs('squid.acls.dynamics.php?ByJs=yes&gpid=$gpid');\"
			style='font-weight:bold;text-decoration:underline;color:$color'>[$rules]</a>";
		}
		
		
		
		

		if(preg_match("#time_quota:([0-9]+)#", $GroupType,$re)){
			$ligne2=$q->mysqli_fetch_array("SELECT * FROM quota_objects WHERE ID='{$re[1]}'");
			$GroupTypeName=$tpl->_ENGINE_parse_body("{time_quota} {$ligne2["objectname"]}");
		}
		if(preg_match("#time_session:([A-Z]+):([0-9]+)#", $GroupType,$re)){
			$qlProxy->acl_ARRAY_NO_ITEM[$GroupType]=true;
			$ligne2=$q->mysqli_fetch_array("SELECT * FROM sessions_objects WHERE ID='{$re[2]}'");
			$GroupTypeName=$tpl->_ENGINE_parse_body("{session_tracking} - {$re[1]} - {$ligne2["objectname"]}");
		}		
	
		
		
		$tpl=new template_admin();
		$hrefT=$tpl->td_href($GroupName. " ($GroupTypeName)","{click_to_edit}","Loadjs('fw.rules.items.php?groupid=$gpid&js-after=$jsafetr')");

		
		if(isset($qlProxy->acl_ARRAY_NO_ITEM[$GroupType])){unset($hrefAdd);}
		if($items==0){
			if(isset($qlProxy->acl_ARRAY_NO_ITEM[$GroupType])){$items='-';}
		}
		if($GroupType=="all"){$items="*";}
		

		
		return array("ROW"=>"$hrefT&nbsp;&nbsp;$ports_text$additional_text",
				"ITEMS"=>$items,"ENABLED"=>$GroupEnabled
				
				);
		
		
	}
	
	
}