<?php


function firewall_nginx(){
    $startcmd="{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix";
    $EnableNginxFW=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableNginxFW"));

    if($EnableNginxFW==0){
        if(is_file("/etc/init.d/nginx-fw")){
            squid_admin_mysql(0, "Removing Firewall For Reverse-Proxy (not enabled)",
                null,__FILE__,__LINE__);
            shell_exec("$startcmd/exec.nginx.fw.php --uninstall >/dev/null 2>&1 &");
        }

        return null;
    }

    if(!is_file("/etc/init.d/nginx-fw")){
        squid_admin_mysql(0, "Installing Firewall For Reverse-Proxy (enabled)",
            null,__FILE__,__LINE__);
        shell_exec("$startcmd/exec.nginx.fw.php --install >/dev/null 2>&1 &");
        return null;
    }


}

function firehol_watch_status(){
	
	$EnableFireQOS=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableFireQOS"));
	if($EnableFireQOS==0){
		if(is_file("/etc/init.d/fireqos")){
			$cmd=trim("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.fireqos.php --uninstall >/dev/null 2>&1 &");
			squid_admin_mysql(0, "Removing Q.O.S service (not enabled)", null,__FILE__,__LINE__);
			shell_exec($cmd);
		}
	}
	
	if(!$GLOBALS["CLASS_UNIX"]->IS_FIREHOLE_ACTIVE()){return;}
	$iptables_save=$GLOBALS["CLASS_UNIX"]->find_program("iptables-save");
	if(!is_file($iptables_save)){return null;}
	
	exec("$iptables_save 2>&1",$results);
	
	$GLOBALS["CLASS_SOCKETS"]->SET_INFO("FireHoleDumpRules",@implode("\n", $results));
	
	
	foreach ($results as $index=>$line){
		if(preg_match("#FIREHOL:#", $line)){
			_firehol_countriesdeny();
			return true;
		}
	}
	$ServerRunSince=$GLOBALS["CLASS_UNIX"]->ServerRunSince();
	if($ServerRunSince>3){
		squid_admin_mysql(0, "Firewall not active! [action=restart]", "Firewall service will be restarted",__FILE__,__LINE__);
		if(is_file("/usr/sbin/squid")){squid_admin_mysql(0, "Firewall not active! [action=restart]","Firewall service will be restarted",__FILE__,__LINE__);}
	}
	if($ServerRunSince>3){
		shell_exec2("/etc/init.d/firehol restart >/etc/artica-postfix/settings/Daemons/FireHoleRestartDump 2>&1");
		return;
	}
	shell_exec2("/etc/init.d/firehol start >/etc/artica-postfix/settings/Daemons/FireHoleRestartDump 2>&1");
	
}


function _firehol_countriesdeny(){
	
	$EnableIpBlocks=intval($GLOBALS["CLASS_SOCKETS"]->GET_INFO("EnableIpBlocks"));
	if($EnableIpBlocks==0){return;}
	$filetime=$GLOBALS["CLASS_UNIX"]->file_time_min("/etc/artica-postfix/pids/exec.ipblock.php.update.time");
	if($filetime<720){return;}
	
	$cmd=trim("{$GLOBALS["nohup"]} {$GLOBALS["NICE"]} {$GLOBALS["PHP5"]} /usr/share/artica-postfix/exec.ipblock.php >/dev/null 2>&1");
	shell_exec2($cmd);
	
}

