#!/usr/bin/env python
import sys
import dns.name
import dns.message
import dns.query
import dns.flags
from Crypto.Cipher import AES
import base64
import re

def mb_substr(s,start,length=None,encoding="8bit;") :
    u_s = s.decode(encoding)
    return (u_s[start:(start+length)] if length else u_s[start:]).encode(encoding)

def my_decrypt(data, passphrase):
    ivsize=16;
    key = passphrase
    data=base64.b64decode(data)
    print(data)
    iv=mb_substr(data,0,ivsize)
    encrypted_data=mb_substr(data,ivsize)
    cipher = AES.new(key, AES.MODE_CBC, iv)
    decrypted = cipher.decrypt(encrypted_data)
    clean = unpad(decrypted).decode('ascii').rstrip()
    print(clean)


domain = 'mashionalkov.info.filter.artica.center'
name_server = None
dnsport = None
ADDITIONAL_RDCLASS = 65535

domain = dns.name.from_text(domain)
if not domain.is_absolute():
    domain = domain.concatenate(dns.name.root)

request = dns.message.make_query(domain, dns.rdatatype.TXT)
request.flags |= dns.flags.AD
request.find_rrset(request.additional, dns.name.root, ADDITIONAL_RDCLASS,
                   dns.rdatatype.OPT, create=True, force_unique=True)

response=dns.query.udp(request, "8.8.8.8",port=53)


for rdata in response.answer:
    txt_string=rdata.to_text()
    matches = re.search('IN TXT "(.+?)"', txt_string)
    if matches:
        print("Found "+matches.group(1))
        ss=my_decrypt(matches.group(1),"24maY6s7JJbCr5vwkQrX2TJEoE9gkno8")




